*DECK CREXSI
      SUBROUTINE CREXSI(IPMAP,NENTRY,HENTRY,KENTRY,NMIX,NGRP,NL,ILEAK,
     1 IMPX,TOTAL,ZNUG,SNUGF,CHI,OVERV,DIFFX,DIFFY,DIFFZ,H,IJJ,NJJ,
     2 SCAT,IPOS)
*
*-----------------------------------------------------------------------
*
*Purpose:
* recover and/or interpolate l_compo data.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal.
*
*Author(s): A. Hebert, D. Sekki
*
*Parameters: input/output
* IPMAP   pointer to the fuel-map information (=0 if no l_fmap).
* NENTRY  number of lcm or xsm objects used by the module.
* HENTRY  character*12 name of each lcm or xsm objects.
* KENTRY  pointers to the lcm or xsm objects.
* NMIX    maximum number of material mixtures.
* NGRP    number of energy groups.
* NL      number of legendre orders (=1 for isotropic scattering).
* ILEAK   diffusion coefficient flag (=1: isotropic; =2: anisotropic).
* IMPX    printing index (=0 for no print).
*
*Parameters: scratch
* TOTAL
* ZNUG
* SNUGF
* CHI
* OVERV
* DIFFX
* DIFFY
* DIFFZ
* H
* IJJ
* NJJ
* SCAT
* IPOS
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPMAP,NENTRY,KENTRY(NENTRY),NMIX,NGRP,NL,ILEAK,IMPX,
     1        IJJ(NMIX,NL,NGRP),NJJ(NMIX,NL,NGRP),IPOS(NMIX)
      REAL TOTAL(NMIX,NGRP),ZNUG(NMIX,NGRP),SNUGF(NMIX,NGRP),
     1     CHI(NMIX,NGRP),OVERV(NMIX,NGRP),DIFFX(NMIX,NGRP),
     2     DIFFY(NMIX,NGRP),DIFFZ(NMIX,NGRP),H(NMIX,NGRP),
     3     SCAT(NMIX,NL,NGRP,NGRP)
      CHARACTER HENTRY(NENTRY)*12
*----
*  LOCAL VARIABLES
*----
      PARAMETER(NSTATE=40,IOUT=6)
      CHARACTER TEXT*12,NAMDIR*12,HCOMPO*12,HSMG*131
      INTEGER IPAR(NSTATE),IDATA(NSTATE),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
      LOGICAL DERIV,UPS,LTAB
      DOUBLE PRECISION DFLOT
*
      IVARTY=0
      UPS=.FALSE.
      LTAB=.FALSE.
      DERIV=.FALSE.
      MAXEN=NENTRY
      IF(IPMAP.NE.0)THEN
        CALL LCMGET(IPMAP,'STATE-VECTOR',IDATA)
        IF(IDATA(4).NE.NGRP)CALL XABORT('@CREXSI: DIFFERENT NUM'
     1   //'BER OF ENERGY GROUPS IN COMPO AND FUEL MAP.')
        NB=IDATA(1)
        NCH=IDATA(2)
        NFUEL=IDATA(7)
        MAXEN=MAXEN-1
        LTAB=.TRUE.
      ENDIF
*----
*  READ INTERPOLATION OPTION
*----
      CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      DO 200 IEN=2,MAXEN
*     KEYWORD COMPO OR TABLE
      IF(TEXT.EQ.'COMPO')THEN
        IF(IPMAP.NE.0)CALL XABORT('@CREXSI: ONLY USE OF EITHER CO'
     1   //'MPO OR TABLE OPTION. BOTH OPTIONS ARE NOT ALLOWED.')
      ELSEIF(TEXT.EQ.'TABLE')THEN
        IF(IPMAP.EQ.0)CALL XABORT('@CREXSI: MISSING FUEL MAP.')
      ELSE
        CALL XABORT('@CREXSI: KEYWORD COMPO OR TABLE EXPECTED.')
      ENDIF
*     COMPO NAME
      CALL REDGET(ITYP,NITMA,FLOT,HCOMPO,DFLOT)
      IF(ITYP.NE.3)CALL XABORT('@CREXSI: COMPO NAME EXPECTED.')
      DO JEN=2,MAXEN
        IF(HCOMPO.EQ.HENTRY(JEN))THEN
          IPCPO=KENTRY(JEN)
          IF(IMPX.GT.1)CALL LCMLIB(IPCPO)
          GOTO 10
        ENDIF
      ENDDO
      WRITE(HSMG,'(44HCREXSI: UNABLE TO FIND THE COMPO WITH NAME '',
     1      A12,2H''.)') TEXT
      CALL XABORT(HSMG)
*----
*  READ MIX INFO
*----
   10 CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(TEXT.NE.'MIX')CALL XABORT('@CREXSI: KEYWORD MIX EXPECTED.')
      CALL LCMGET(IPCPO,'STATE-VECTOR',IPAR)
      NGRP1=IPAR(2)
      NL1=IPAR(4)
      NISO=IPAR(3)
      IF(NGRP1.NE.NGRP)THEN
        WRITE(HSMG,'(43HCREXSI: INCONSISTENT NB OF GROUPS. IN MACRO,
     1        5HLIB =,I5,11H IN COMPO =,I5)') NGRP,NGRP1
        CALL XABORT(HSMG)
      ENDIF
      IF(NL1.LT.NL)THEN
        WRITE(HSMG,'(43HCREXSI: INCONSISTENT NB OF LEGENDRE ORDERS.,
     1        14H IN MACROLIB =,I5,11H IN COMPO =,I5)') NL,NL1
        CALL XABORT(HSMG)
      ENDIF
   20 CALL SETARA(IBASE,3*NISO,IHISO)
      CALL SETARA(IBASE,NISO,IITY)
      CALL SETARA(BASE,NISO,ICONC)
      CALL CREXSR(IPCPO,LTAB,HCOMPO,NMIX,NGRP,NL,IMPX,NISO,IBM,
     1            DERIV,UPS,NAMDIR,NISO1,IBASE(IHISO),IBASE(IITY),
     2            BASE(ICONC),NBURN,KBURN,IVARTY,IBTYP,BURN0,BURN1)
      JPCPO=LCMGID(IPCPO,NAMDIR)
*----
*  TABLE-OPTION INTERPOLATION
*----
      IF(LTAB)THEN
*       CHECK FUEL MIXTURE
        JPMAP=LCMGID(IPMAP,'FUEL')
        DO 30 IFUEL=1,NFUEL
        KPMAP=LCMGIL(JPMAP,IFUEL)
        CALL LCMGET(KPMAP,'MIX',IMIX)
        IF(IMIX.EQ.IBM)GOTO 40
        CALL LCMLEN(KPMAP,'MIX-VOID',LENGT,ITYP)
        IF(LENGT.EQ.0)GOTO 30
        CALL LCMGET(KPMAP,'MIX-VOID',IMIX)
        IF(IMIX.EQ.IBM)GOTO 40
   30   CONTINUE
        WRITE(IOUT,*)'@CREXSI: UNABLE TO FIND FUEL MIXTURE ',IBM
        CALL XABORT('@CREXSI: WRONG MIXTURE NUMBER.')
*
   40   CALL SETARA(BASE,NBURN,IBURNU)
        CALL SETARA(BASE,NISO1,IDENSI)
        CALL SETARA(BASE,NBURN,ITERP)
        CALL SETARA(BASE,NCH*NB,IBRN0)
        CALL SETARA(BASE,NCH*NB,IBRN1)
        CALL SETARA(IBASE,NCH*NB,IFMIX)
        CALL SETARA(BASE,NCH*NB,IZONED)
        CALL SETARA(BASE,NBURN,ITERPW)
        CALL CRERGR(JPCPO,IPMAP,NISO1,NGRP,NMIX,NL,IBM,IMPX,IBTYP,
     1  DERIV,UPS,NBURN,BASE(IBURNU),BASE(IDENSI),ILEAK,TOTAL,ZNUG,
     2  SNUGF,CHI,OVERV,DIFFX,DIFFY,DIFFZ,H,SCAT,IJJ,NJJ,IBASE(IHISO),
     3  IBASE(IITY),BASE(ICONC),IBASE(IFMIX),BASE(IBRN0),BASE(IBRN1),
     4  NCH,NB,IVARTY,BASE(ITERP),BASE(IZONED),BASE(ITERPW))
        CALL RLSARA(BASE(ITERPW))
        CALL RLSARA(BASE(IZONED))
        CALL RLSARA(IBASE(IFMIX))
        CALL RLSARA(BASE(IBRN1))
        CALL RLSARA(BASE(IBRN0))
        CALL RLSARA(BASE(ITERP))
        CALL RLSARA(BASE(IDENSI))
        CALL RLSARA(BASE(IBURNU))
        CALL RLSARA(BASE(ICONC))
        CALL RLSARA(IBASE(IITY))
        CALL RLSARA(IBASE(IHISO))
*----
*  COMPO-OPTION INTERPOLATION
*----
      ELSE
        CALL SETARA(BASE,NGRP,ITOTAL)
        CALL SETARA(BASE,NGRP,IZNUG)
        CALL SETARA(BASE,NGRP,INUGF)
        CALL SETARA(BASE,NGRP,ICHI)
        CALL SETARA(BASE,NGRP,IOVERV)
        CALL SETARA(BASE,NGRP,IDIFFX)
        CALL SETARA(BASE,NGRP,IDIFFY)
        CALL SETARA(BASE,NGRP,IDIFFZ)
        CALL SETARA(BASE,NGRP,IH)
        CALL SETARA(BASE,NL*NGRP*NGRP,ISCAT)
        CALL SETARA(BASE,NGRP,IFLUX)
        CALL SETARA(BASE,NBURN,IBURNU)
        CALL SETARA(BASE,NISO1,IDENSI)
        CALL CREINT(JPCPO,NISO1,DERIV,NBURN,KBURN,BURN0,BURN1,NGRP,
     1  NL,IMPX,IBASE(IHISO),IBASE(IITY),BASE(ICONC),ILEAK,BASE(ITOTAL),
     2  BASE(IZNUG),BASE(INUGF),BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),
     3  BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),BASE(ISCAT),BASE(IFLUX),
     4  BASE(IBURNU),BASE(IDENSI),UPS)
        CALL RLSARA(BASE(IDENSI))
        CALL RLSARA(BASE(IBURNU))
*       DATA STORAGE.
        DO 110 JGR=1,NGRP
          TOTAL(IBM,JGR)=BASE(ITOTAL+JGR-1)
          ZNUG(IBM,JGR)=BASE(IZNUG+JGR-1)
          SNUGF(IBM,JGR)=BASE(INUGF+JGR-1)
          CHI(IBM,JGR)=BASE(ICHI+JGR-1)
          OVERV(IBM,JGR)=BASE(IOVERV+JGR-1)
          DIFFX(IBM,JGR)=BASE(IDIFFX+JGR-1)
          DIFFY(IBM,JGR)=BASE(IDIFFY+JGR-1)
          DIFFZ(IBM,JGR)=BASE(IDIFFZ+JGR-1)
          H(IBM,JGR)=BASE(IH+JGR-1)
          DO 110 IGR=1,NGRP
          DO 110 IL=1,NL
          SCAT(IBM,IL,IGR,JGR)=BASE(ISCAT+NL*((JGR-1)*NGRP+IGR-1)+IL-1)
  110   CONTINUE
        CALL RLSARA(BASE(IFLUX))
        CALL RLSARA(BASE(ISCAT))
        CALL RLSARA(BASE(IH))
        CALL RLSARA(BASE(IDIFFZ))
        CALL RLSARA(BASE(IDIFFY))
        CALL RLSARA(BASE(IDIFFX))
        CALL RLSARA(BASE(IOVERV))
        CALL RLSARA(BASE(ICHI))
        CALL RLSARA(BASE(INUGF))
        CALL RLSARA(BASE(IZNUG))
        CALL RLSARA(BASE(ITOTAL))
        CALL RLSARA(BASE(ICONC))
        CALL RLSARA(IBASE(IITY))
        CALL RLSARA(IBASE(IHISO))
*       JGR IS THE SECONDARY GROUP.
        DO 130 JGR=1,NGRP
        DO 130 IL=1,NL
        IGMIN=JGR
        IGMAX=JGR
        DO IGR=NGRP,1,-1
          IF(SCAT(IBM,IL,IGR,JGR).NE.0.)THEN
            IGMIN=MIN(IGMIN,IGR)
            IGMAX=MAX(IGMAX,IGR)
          ENDIF
        ENDDO
        IJJ(IBM,IL,JGR)=IGMAX
  130   NJJ(IBM,IL,JGR)=IGMAX-IGMIN+1
      ENDIF
      CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(TEXT.EQ.'MIX')GOTO 20
  200 CONTINUE
      IF(TEXT.NE.';')CALL XABORT('@CREXSI: FINAL ; EXPECTED.')
      RETURN
      END
