*DECK DETREAD
      SUBROUTINE DETREAD(IPDET,TYPE,NREP,IPRT,LHEX)
*
*-----------------------------------------------------------------------
*
*Purpose:
*  this subroutine reads detector parameters and store them
*
* Copyright (C) 2010 Ecole Polytechnique de Montreal.
*
*Author(s): J. Koclas, E. Varin, M. Guyot
*
*Parameters: input/output
* IPDET   pointer to the L_DETECT object.
* NREP    number of values stored for detector response
* IPRT    printing flag
* LHEX    =.TRUE. if it is an hexagonal geometry
*
*-----------------------------------------------------------------------
      IMPLICIT NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER   IPDET,NREP,IPRT
      LOGICAL   LHEX
      CHARACTER TYPE*12

*----
*  LOCAL VARIABLES
*----
      CHARACTER TEXT*12,NAMDET*12
      INTEGER ITYP,NITMA,IBASE(1),IHEX,NHEX,I,IREP
      REAL FLOT,BASE,DEVPOS(6)
      DOUBLE PRECISION DFLOT
      LOGICAL LEND,LPOS,LRESP,LHEX2
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*----
*  READING INFORMATION LINKED TO DETECTOR PARAMETERS
*----
      LEND=.FALSE.
      LPOS=.FALSE.
      LRESP=.FALSE.
      LHEX2=.FALSE.

      CALL SETARA(BASE,NREP,IREP)

   10 CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.3) CALL XABORT('@DETREAD: CHARACTER DATA'
     +    //' EXPECTED(1)')
      IF(TEXT.EQ.'NAME') THEN
        CALL REDGET(ITYP,NITMA,FLOT,NAMDET,DFLOT)
        IF(ITYP.NE.3) CALL XABORT('@DETREAD: CHARACTER DATA'
     +    //' EXPECTED(2)')
      ELSEIF(TEXT.EQ.'NHEX') THEN
        LHEX2=.TRUE.
        IF(.NOT.LHEX )CALL XABORT('@DETREAD: INVALID KEYWORD NHEX')
        CALL REDGET(ITYP,NHEX,FLOT,TEXT,DFLOT)
        IF (ITYP.NE.1) CALL XABORT('@DETREAD: INTEGER DATA'
     +       //' EXPECTED(1)')
        CALL SETARA(IBASE,NHEX,IHEX)
        CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
        IF((ITYP.NE.3).AND.(TEXT.EQ.'HEX')) CALL XABORT('@DETREAD:'
     +           //' CHARACTER DATA EXPECTED HEX')
      ELSEIF(TEXT.EQ.'HEX') THEN
        DO 20 I=1,NHEX
          CALL REDGET(ITYP,IBASE(IHEX+I-1),FLOT,TEXT,DFLOT)
          IF(ITYP.NE.1)
     +      CALL XABORT('@DETREAD: INTEGER DATA EXPECTED FOR HEX')
   20   CONTINUE
      ELSEIF(TEXT.EQ.'POSITION') THEN
        LPOS=.TRUE.
        DO 30 I=1,6
          CALL REDGET(ITYP,NITMA,DEVPOS(I),TEXT,DFLOT)
          IF (ITYP.NE.2) CALL XABORT('@DETREAD: REAL DATA EXPECTED(2)')
   30   CONTINUE
      ELSEIF(TEXT.EQ.'RESP') THEN
         LRESP=.TRUE.
         DO 40 I=1,NREP
            CALL REDGET(ITYP,NITMA,BASE(IREP+I-1),TEXT,DFLOT)
            IF (ITYP.NE.2)CALL XABORT('@DETREAD: REAL DATA EXPECTED(2)')
   40   CONTINUE
      ELSEIF(TEXT.EQ.'ENDN') THEN
        LEND=.TRUE.
      ELSE
         CALL XABORT('@DETREAD: WRONG KEYWORD')
      ENDIF

      IF(.NOT.LEND) GOTO 10
*----
*  READING INFORMATION LINKED TO DETECTOR PARAMETERS
*----
      IF((.NOT.LPOS).OR.(.NOT.LRESP)) CALL XABORT('@DETREAD: POSITIONS'
     +       //' OR RESP NOT SPECIFIED')
      IF(LHEX.NEQV.LHEX2) CALL XABORT('@DETREAD: NHEX SHOULD BE'
     +       //' SPECIFIED')

      CALL LCMSIX(IPDET,' ',0)
      CALL LCMSIX(IPDET,TYPE,1)
      CALL LCMSIX(IPDET,NAMDET,1)
      CALL LCMPUT(IPDET,'POSITION',6,2,DEVPOS)
      IF(LHEX)CALL LCMPUT(IPDET,'NHEX',NHEX,1,IBASE(IHEX))
      CALL LCMPUT(IPDET,'RESPON',NREP,2,BASE(IREP))
      IF(LHEX)CALL RLSARA(IBASE(IHEX))
      CALL RLSARA(BASE(IREP))

      RETURN
      END