*DECK DEVDRV
      SUBROUTINE DEVDRV(IPDEV,IPMTX,IGEO,NMIX,NTOT,LIMIT)
*
*-----------------------------------------------------------------------
*
*Purpose:
* read specifications for the rod-devices from the input file.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal.
*
*Author(s): D. Sekki
*
*Parameters: input
* IPDEV  pointer to device information.
* IPMTX  pointer to matex information.
* IGEO   index related to the reactor geometry.
* NMIX   old maximum number of material mixtures.
* NTOT   old total number of all mixtures.
* LIMIT  core limiting coordinates.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPDEV,IPMTX,IGEO,NMIX,NTOT
      REAL LIMIT(6)
*----
*  LOCAL VARIABLES
*----
      PARAMETER(NSTATE=40,IOUT=6)
      CHARACTER TEXT*12
      INTEGER ISTATE(NSTATE),IBASE(1),RGRP
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
      DOUBLE PRECISION DFLOT
*----
*  CORE LIMITS
*----
      XMIN=LIMIT(1)
      XMAX=LIMIT(2)
      YMIN=LIMIT(3)
      YMAX=LIMIT(4)
      ZMIN=LIMIT(5)
      ZMAX=LIMIT(6)
*----
*  READ INPUT DATA
*----
      IMPX=1
      CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.3)CALL XABORT('@DEVDRV: CHARACTER DATA EXPECTED(1).')
      IF(TEXT.NE.'EDIT')GOTO 10
*     PRINTING INDEX
      CALL REDGET(ITYP,IMPX,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.1)CALL XABORT('@DEVDRV: INTEGER FOR EDIT EXPECTED.')
      CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.3)CALL XABORT('@DEVDRV: CHARACTER DATA EXPECTED(2).')
   10 IF(TEXT.NE.'NUM-ROD')CALL XABORT('@DEVDRV: KEYWORD NUM-ROD EX'
     1 //'PECTED.')
*     TOTAL NUMBER OF RODS
      CALL REDGET(ITYP,NROD,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.1)CALL XABORT('@DEVDRV: INTEGER TOTAL NUMBER OF ROD'
     1 //'S EXPECTED.')
      IF(NROD.LT.1)CALL XABORT('@DEVDRV: WRONG TOTAL NUMBER OF RODS <1')
      IF(IMPX.GT.1)WRITE(IOUT,1003)XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX
      IF(IMPX.GT.0)WRITE(IOUT,1000)NROD
*
      NTOT2=NTOT+NROD*2
      CALL SETARA(IBASE,NTOT2,IMIX)
      CALL XDISET(IBASE(IMIX),NTOT2,0)
      CALL SETARA(IBASE,NTOT,IMAT)
      CALL XDISET(IBASE(IMAT),NTOT,0)
      CALL LCMGET(IPMTX,'MAT',IBASE(IMAT))
      DO 20 I=1,NTOT
   20 IBASE(IMIX+I-1)=IBASE(IMAT+I-1)
      CALL RLSARA(IBASE(IMAT))
*----
*  READ OPTION
*----
      JPDEV=LCMLID(IPDEV,'DEV_ROD',NROD)
      K=0
   30 K=K+1
      CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(TEXT.EQ.'ROD')THEN
        CALL REDGET(ITYP,ID,FLOT,TEXT,DFLOT)
        IF(ITYP.NE.1)CALL XABORT('@DEVDRV: INTEGER ROD-ID'
     1   //' EXPECTED.')
        IF(ID.NE.K)THEN
          WRITE(IOUT,*)'@DEVDRV: READ CURRENT ROD-ID #',ID
          WRITE(IOUT,*)'@DEVDRV: EXPECTED ROD-ID #',K
          CALL XABORT('@DEVDRV: WRONG INPUT OF ID NUMBER.')
        ENDIF
        IF(ID.GT.NROD)THEN
          WRITE(IOUT,*)'@DEVDRV: READ CURRENT ROD-ID #',ID
          WRITE(IOUT,*)'@DEVDRV: GIVEN TOTAL NUMBER OF RODS:',NROD
          CALL XABORT('@DEVDRV: WRONG INPUT OF ROD-ID NUMBER. GRE'
     1     //'ATER THAN THE TOTAL NUMBER OF RODS.')
        ENDIF
      ELSEIF((TEXT.EQ.'CREATE').OR.(TEXT.EQ.';'))THEN
        GOTO 40
      ELSE
        WRITE(IOUT,*)'@DEVDRV: INVALID KEYWORD ',TEXT
        CALL XABORT('@DEVDRV: KEYWORD OR ; EXPECTED.')
      ENDIF
      IF(IMPX.GT.1)WRITE(IOUT,1001)ID
      KPDEV=LCMDIL(JPDEV,ID)
*     READ INDIVIDUAL ROD DATA
      CALL DEVGET(KPDEV,NTOT,NMIX,NTOT2,IBASE(IMIX),ID,XMAX,XMIN,
     1  YMAX,YMIN,ZMAX,ZMIN,IMPX)
      GOTO 30
   40 IF(ID.NE.NROD)THEN
        WRITE(IOUT,*)'@DEVDRV: GIVEN TOTAL NUMBER OF RODS ',NROD
        WRITE(IOUT,*)'@DEVDRV: READ ONLY THE NUMBER OF RODS ',ID
        CALL XABORT('@DEVDRV: WRONG INPUT OF ROD-DEVICES.')
      ENDIF
      IF(IMPX.GT.0)WRITE(IOUT,1002)ID
      IF(TEXT.EQ.';')GOTO 50
      RGRP=0
*     TOTAL NUMBER OF ROD-GROUPS
      CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(TEXT.NE.'ROD-GR')CALL XABORT('@DEVDRV: KEYWORD ROD-GR EX'
     1 //'PECTED.')
      CALL REDGET(ITYP,RGRP,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.1)CALL XABORT('@DEVDRV: INTEGER NUMBER OF ROD-GR'
     1 //'OUPS EXPECTED.')
      IF(RGRP.LT.1)CALL XABORT('@DEVDRV: WRONG NUMBER OF GROUPS <1')
*     CREATE ROD-GROUPS
      CALL DEVDGD(IPDEV,NROD,RGRP,IMPX)
*----
*  STATE-VECTORS
*----
   50 CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)=IGEO
      ISTATE(2)=NROD
      ISTATE(3)=RGRP
      CALL LCMPUT(IPDEV,'STATE-VECTOR',NSTATE,1,ISTATE)
      IF(IMPX.GT.1)CALL LCMLIB(IPDEV)
*     UPDATE MATEX
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMTX,'STATE-VECTOR',ISTATE)
      ISTATE(2)=NMIX+NROD*2
      ISTATE(5)=NTOT2
      CALL LCMPUT(IPMTX,'MAT',NTOT2,1,IBASE(IMIX))
      CALL LCMPUT(IPMTX,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL RLSARA(IBASE(IMIX))
      IF(IMPX.GT.4)CALL LCMLIB(IPMTX)
      RETURN
*
 1000 FORMAT(/1X,'GIVEN TOTAL NUMBER OF ROD-DEVICES:',
     1 I3//' **  READING INPUT DATA FOR RODS  **')
 1001 FORMAT(/4X,'=>',2X,'ROD #',I3.3)
 1002 FORMAT(/1X,35('-')/1X,'READ TOTAL NUMBER OF RODS:',I3)
 1003 FORMAT(//5X,'---  REACTOR CORE LIMITS  ---'//
     1 1X,'Xmin',F10.4,5X,'Ymin',F10.4,5X,'Zmin',F10.4/
     2 1X,'Xmax',F10.4,5X,'Ymax',F10.4,5X,'Zmax',F10.4/)
      END
