*DECK DEVINI
      SUBROUTINE DEVINI(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* read specification for the rod-devices, create a device object.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal.
*
*Author(s): D. Sekki
*
*Parameters: input/output
* NENTRY  number of LCM objects or files used by the operator.
* HENTRY  name of each LCM object or file:
*         HENTRY(1): create type(L_DEVICE);
*         HENTRY(2): modification type(L_MATEX).
* IENTRY  type of each LCM object or file:
*         =1 LCM memory object; =2 XSM file; =3 sequential binary file;
*         =4 sequential ascii file.
* JENTRY  access of each LCM object or file:
*         =0 the LCM object or file is created;
*         =1 the LCM object or file is open for modifications;
*         =2 the LCM object or file is open in read-only mode.
* KENTRY  LCM object address or file unit number.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER NENTRY                  	
      CHARACTER HENTRY(NENTRY)*12
      INTEGER IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*----
*  LOCAL VARIABLES
*----
      PARAMETER(NSTATE=40)
      CHARACTER HSIGN*12
      INTEGER KCHAR(3),ISTATE(NSTATE)
      COMMON BASE(1)
      REAL LIMIT(6)
*----
*  PARAMETER VALIDATION
*----
      IF(NENTRY.NE.2)CALL XABORT('@DEVINI: TWO PARAMETERS EXPECTED')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2))CALL XABORT('@DEVI'
     1 //'NI: LCM OBJECT FOR L_DEVICE EXPECTED.')
      IF(JENTRY(1).NE.0)CALL XABORT('@DEVINI: CREATE MODE EXPECTE'
     1 //'D FOR L_DEVICE.')
      HSIGN='L_DEVICE'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
      IPDEV=KENTRY(1)
      IF((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2))CALL XABORT('@DEVI'
     1 //'NI: LCM OBJECT FOR L_MATEX EXPECTED.')
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_MATEX')CALL XABORT('@DEVINI: MISSING L_MATEX.')
      IF(JENTRY(2).NE.1)CALL XABORT('@DEVINI: MODIFICATION MODE E'
     1 //'XPECTED FOR L_MATEX.')
      IPMTX=KENTRY(2)
*----
*  RECOVER INFORMATION
*----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMTX,'STATE-VECTOR',ISTATE)
      IGEO=ISTATE(6)
      IF(IGEO.NE.7)CALL XABORT('@DEVINI: ON'
     1 //'LY 3D-CARTESIAN GEOMETRY ALLOWED.')
      NMIX=ISTATE(2)
      NTOT=ISTATE(5)
      LX=ISTATE(8)
      LY=ISTATE(9)
      LZ=ISTATE(10)
*     CORE LIMITS ALONG X-AXIS
      CALL SETARA(BASE,LX+1,IX)
      CALL XDRSET(BASE(IX),LX+1,0.)
      CALL LCMGET(IPMTX,'MESHX',BASE(IX))
      LIMIT(1)=BASE(IX)
      LIMIT(2)=BASE(IX+LX)
      CALL RLSARA(BASE(IX))
*     CORE LIMITS ALONG Y-AXIS
      CALL SETARA(BASE,LY+1,IY)
      CALL XDRSET(BASE(IY),LY+1,0.)
      CALL LCMGET(IPMTX,'MESHY',BASE(IY))
      LIMIT(3)=BASE(IY)
      LIMIT(4)=BASE(IY+LY)
      CALL RLSARA(BASE(IY))
*     CORE LIMITS ALONG Z-AXIS
      CALL SETARA(BASE,LZ+1,IZ)
      CALL XDRSET(BASE(IZ),LZ+1,0.)
      CALL LCMGET(IPMTX,'MESHZ',BASE(IZ))
      LIMIT(5)=BASE(IZ)
      LIMIT(6)=BASE(IZ+LZ)
      CALL RLSARA(BASE(IZ))
*     READ ROD-DEVICES DATA
      CALL DEVDRV(IPDEV,IPMTX,IGEO,NMIX,NTOT,LIMIT)
      RETURN
      END
