*DECK DONJON
      PROGRAM DONJON
      IMPLICIT NONE
#if defined(MPI)
      include 'mpif.h'
#endif /* defined(MPI) */
*----
*  INPUT/OUTPUT UNITS
*----
      INTEGER    IOUT
      PARAMETER (IOUT=6)
*----
*  VARIABLES FOR DONJON VERSION
*----
      INTEGER    IMVERS
      CHARACTER  DATE*64,REV*48,NAMSBR*6
      PARAMETER (NAMSBR='DONJON')
*----
*  GAN-2000 PARAMETERS
*----
      INTEGER    DONDRV
      EXTERNAL   DONDRV
      INTEGER    KERNEL
*----
*  DIMENSION FOR MODULE DATA
*----
      INTEGER    NMODXT
      PARAMETER (NMODXT=48)
      CHARACTER  CMODXT(NMODXT)*12
*----
*  LOCAL VARIABLES
*----
      INTEGER    IPRINT,IER
*----
*  DATA
*----
      DATA       CMODXT
     >   /'ASM:        ','COMPO:      ','EDI:        ','EVO:        ',
     >    'EXCELT:     ','FLU:        ','GEO:        ','INFO:       ',
     >    'USS:        ','LIB:        ','MAC:        ','MCCGT:      ',
     >    'BIVACT:     ','TRIVAT:     ','SHI:        ','SYBILT:     ',
     >    'SNT:        ','NCR:        ','NXT:        ','PSP:        ',
     >    'TLM:        ','M2T:        ','CHAB:       ','CPO:        ',
     >    'SAP:        ','MC:         ','T:          ','DMAC:       ',
     >    'NDIST:      ','CRE:        ','FLUD:       ','TRIVAA:     ',
     >    'RESINI:     ','FLPOW:      ','MACINI:     ','USPLIT:     ',
     >    'DEVINI:     ','DSET:       ','NEWMAC:     ','MOVDEV:     ',
     >    'TAVG:       ','TINST:      ','CVR:        ','LZC:        ',
     >    'HST:        ','OUT:        ','DETINI:     ','DETECT:     '/
#if defined(MPI)
*----
*  MPI initialisation
*----
      INTEGER*4 IERROR, ME, NPROC
      CALL MPI_INIT(IERROR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NPROC,IERROR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ME,IERROR)
      WRITE(*,*)'CPU RANK   ===',ME
      WRITE(*,*)'WORLD SIZE ===',NPROC
#endif /* defined(MPI) */
*----
*  VERSION INFORMATION
*----
      IMVERS=4
      CALL KDRVER(REV,DATE)
      WRITE(IOUT,6000) NAMSBR,IMVERS,REV,DATE
      WRITE(IOUT,6010) NAMSBR
*----
*  EXECUTE THE CLE-2000 DRIVER
*----
      IPRINT= 0
      IER=KERNEL(NMODXT,CMODXT,DONDRV,IPRINT)
      IF( IER .NE. 0 )THEN
         WRITE(IOUT,*) 'KERNEL ERROR CODE=',IER
         CALL XABORT('DONJON: KERNEL ERROR')
      ENDIF
*----
*  ALL MODULES PROCESSED
*----
      WRITE(IOUT,6030) NAMSBR,IMVERS,REV
#if defined(MPI)
*----
*  MPI finalisation
*----
      CALL MPI_FINALIZE(IERROR)
#endif /* defined(MPI) */
      STOP
*----
*  FORMATS
*----
 6000 FORMAT(
     > ' @@@@@@@     @@@@@   @@     @@   @@@@@@   @@@@@   @@     @@'/
     > ' @@@@@@@@   @@@@@@@  @@@    @@       @@  @@@@@@@  @@@    @@'/
     > ' @@     @@ @@     @@ @@@@   @@       @@ @@     @@ @@@@   @@'/
     > ' @@     @@ @@     @@ @@ @@  @@       @@ @@     @@ @@ @@  @@'/
     > ' @@     @@ @@     @@ @@  @@ @@       @@ @@     @@ @@  @@ @@'/
     > ' @@     @@ @@     @@ @@   @@@@       @@ @@     @@ @@   @@@@'/
     > ' @@@@@@@@   @@@@@@@  @@    @@@ @@    @@  @@@@@@@  @@    @@@'/
     > ' @@@@@@@     @@@@@   @@     @@  @@@@@@    @@@@@   @@     @@'//
     > '           VERSION ',A6,I2,2X,A,4X,A/
     > '           GROUPE D''ANALYSE NUCLEAIRE'/
     > '           ECOLE POLYTECHNIQUE DE MONTREAL'//)
 6010 FORMAT(
     1 ' COPYRIGHT NOTICE FOR THIS VERSION OF ',A6,':'/
     2 ' --------------------------------------------'/
     3 ' Copyright (C) 2007 Ecole Polytechnique de Montreal '/
     4 ' This library is free software; you can redistribute it' /
     5 ' and/or modify it under the terms of the GNU Lesser General' /
     6 ' Public License as published by the Free Software Foundation;' /
     7 ' either version 2.1 of the License, or (at your option) any' /
     8 ' later version '///)
 6030 FORMAT(//1X,'@NORMAL END OF EXECUTION FOR ',A6,I2,2X,A/
     1         1X,'@CHECK FOR WARNINGS IN LISTING'/
     2         1X,'@BEFORE ASSUMING YOUR RUN WAS SUCCESSFUL')
      END
