*DECK DSET1D
      SUBROUTINE DSET1D(IPDEV,ID,LROD,IMPX)
*
*-----------------------------------------------------------------------
*
*Purpose:
* modify some parameters for a specified device.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal.
*
*Author(s): D. Sekki
*
*Parameters: input
* IPDEV  pointer to device information.
* ID     identification number of a specified device.
* LROD   flag for the device type:
*         =.true. if rod-type device; =.false. if lzc-type device.
* IMPX   printing index (=0 for no print).
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPDEV,ID,IMPX
      LOGICAL LROD
*----
*  LOCAL VARIABLES
*----
      PARAMETER(IOUT=6)
      REAL RODPOS(6),MAXPOS(6),EMTPOS(6),FULPOS(6),LENG,LVOLD,LVNEW
      DOUBLE PRECISION DFLOT
      CHARACTER TEXT*12
      INTEGER INAME(3)
*----
*  READ OPTION
*----
      ILEVEL=0
      ISPEED=0
      ISTIME=0
   10 CALL REDGET(ITYP,NITMA,FLOT,TEXT,DFLOT)
      IF(ITYP.NE.3)CALL XABORT('@DSET1D: CHARACTER DATA EXPECTED.')
      IF(TEXT.EQ.'LEVEL')THEN
        IF(ILEVEL.EQ.1)CALL XABORT('@DSET1D: LEVEL ALREADY DEFINED.')
        CALL REDGET(ITYP,NITMA,LVNEW,TEXT,DFLOT)
        IF(ITYP.NE.2)CALL XABORT('@DSET1D: REAL FOR LEVEL EXPECTED.')
        IF(LVNEW.GT.1.)CALL XABORT('@DSET1D: WRONG LEVEL VALUE > 1.')
        IF(LVNEW.LT.0.)CALL XABORT('@DSET1D: WRONG LEVEL VALUE < 0.')
        ILEVEL=1
      ELSEIF(TEXT.EQ.'SPEED')THEN
        IF(ISPEED.EQ.1)CALL XABORT('@DSET1D: SPEED ALREADY DEFINED.')
        CALL REDGET(ITYP,NITMA,SPNEW,TEXT,DFLOT)
        IF(ITYP.NE.2)CALL XABORT('@DSET1D: REAL FOR SPEED EXPECTED.')
        IF(SPNEW.LT.0.)CALL XABORT('@DSET1D: WRONG SPEED VALUE < 0.')
        ISPEED=1
      ELSEIF(TEXT.EQ.'TIME')THEN
        IF(ISTIME.EQ.1)CALL XABORT('@DSET1D: TIME ALREADY DEFINED.')
        CALL REDGET(ITYP,NITMA,TMNEW,TEXT,DFLOT)
        IF(ITYP.NE.2)CALL XABORT('@DSET1D: REAL FOR TIME EXPECTED.')
        IF(TMNEW.LT.0.)CALL XABORT('@DSET1D: WRONG TIME VALUE < 0.')
        ISTIME=1
      ELSEIF(TEXT.EQ.'END')THEN
        GOTO 20
      ELSE
        WRITE(IOUT,*)'@DSET1D: INVALID KEYWORD ',TEXT
        CALL XABORT('@DSET1D: OPTION OR END EXPECTED.')
      ENDIF
      GOTO 10
*     RECOVER DEVICE
   20 IF(LROD)THEN
        JPDEV=LCMGID(IPDEV,'DEV_ROD')
      ELSE
        JPDEV=LCMGID(IPDEV,'DEV_LZC')
      ENDIF
      KPDEV=LCMGIL(JPDEV,ID)
      IF(ILEVEL.EQ.1)THEN
*----
*  UPDATE ROD POSITION
*----
        IF(LROD)THEN
*         RECOVER OLD PARAMETERS
          CALL LCMGET(KPDEV,'ROD-POS',RODPOS)
          CALL LCMGET(KPDEV,'LENGTH',LENG)
          CALL LCMGET(KPDEV,'LEVEL',LVOLD)
          CALL LCMGET(KPDEV,'AXIS',IAXIS)
          CALL LCMGET(KPDEV,'FROM',ITOP)
          CALL LCMGET(KPDEV,'ROD-NAME',INAME)
          WRITE(TEXT,'(3A4)') (INAME(I),I=1,3)
          IF(IMPX.GT.1)WRITE(IOUT,1001)TEXT,LVOLD,RODPOS(1),
     1    RODPOS(3),RODPOS(5),RODPOS(2),RODPOS(4),RODPOS(6)
*         MODIFY ROD POSITION
          DELH=LVNEW*LENG
          IF(IAXIS.EQ.1)THEN
            IF(ITOP.EQ.1)THEN
              RODPOS(1)=RODPOS(2)-DELH
            ELSE
              RODPOS(2)=RODPOS(1)+DELH
            ENDIF
          ELSEIF(IAXIS.EQ.2)THEN
            IF(ITOP.EQ.1)THEN
              RODPOS(3)=RODPOS(4)-DELH
            ELSE
              RODPOS(4)=RODPOS(3)+DELH
            ENDIF
          ELSEIF(IAXIS.EQ.3)THEN
            IF(ITOP.EQ.1)THEN
              RODPOS(5)=RODPOS(6)-DELH
            ELSE
              RODPOS(6)=RODPOS(5)+DELH
            ENDIF
          ENDIF
*         STORE NEW PARAMETERS
          CALL LCMPUT(KPDEV,'ROD-POS',6,2,RODPOS)
          CALL LCMPUT(KPDEV,'LEVEL',1,2,LVNEW)
          IF(IMPX.GT.1)WRITE(IOUT,1002)LVNEW,RODPOS(1),RODPOS(3),
     1                   RODPOS(5),RODPOS(2),RODPOS(4),RODPOS(6)
*----
*  UPDATE LZC POSITION
*----
        ELSE
*         RECOVER OLD PARAMETERS
          CALL LCMGET(KPDEV,'MAX-POS',MAXPOS)
          CALL LCMGET(KPDEV,'EMPTY-POS',EMTPOS)
          CALL LCMGET(KPDEV,'FULL-POS',FULPOS)
          CALL LCMGET(KPDEV,'HEIGHT',LENG)
          CALL LCMGET(KPDEV,'LEVEL',LVOLD)
          CALL LCMGET(KPDEV,'AXIS',IAXIS)
          IF(IMPX.GT.1)WRITE(IOUT,1005)LVOLD,EMTPOS(1),EMTPOS(3),
     1         EMTPOS(5),EMTPOS(2),EMTPOS(4),EMTPOS(6),FULPOS(1),
     2         FULPOS(3),FULPOS(5),FULPOS(2),FULPOS(4),FULPOS(6)
*         MODIFY LZC POSITION
          DELH=LVNEW*LENG
          IF(IAXIS.EQ.1)THEN
            FULPOS(1)=MAXPOS(2)-DELH
            EMTPOS(2)=FULPOS(1)
          ELSEIF(IAXIS.EQ.2)THEN
            FULPOS(3)=MAXPOS(4)-DELH
            EMTPOS(4)=FULPOS(3)
          ELSEIF(IAXIS.EQ.3)THEN
            FULPOS(5)=MAXPOS(6)-DELH
            EMTPOS(6)=FULPOS(5)
          ENDIF
*         STORE NEW PARAMETERS
          CALL LCMPUT(KPDEV,'LEVEL',1,2,LVNEW)
          CALL LCMPUT(KPDEV,'EMPTY-POS',6,2,EMTPOS)
          CALL LCMPUT(KPDEV,'FULL-POS',6,2,FULPOS)
          IF(IMPX.GT.1)WRITE(IOUT,1006)LVNEW,EMTPOS(1),EMTPOS(3),
     1         EMTPOS(5),EMTPOS(2),EMTPOS(4),EMTPOS(6),FULPOS(1),
     2         FULPOS(3),FULPOS(5),FULPOS(2),FULPOS(4),FULPOS(6)
        ENDIF
      ENDIF
*----
*  UPDATE SPEED
*----
      IF(ISPEED.EQ.1)THEN
        IF(LROD)THEN
          CALL LCMGET(KPDEV,'SPEED',SPOLD)
          CALL LCMPUT(KPDEV,'SPEED',1,2,SPNEW)
        ELSE
          CALL LCMGET(KPDEV,'RATE',SPOLD)
          CALL LCMPUT(KPDEV,'RATE',1,2,SPNEW)
        ENDIF
        IF(IMPX.GT.1)WRITE(IOUT,1003)SPOLD,SPNEW
      ENDIF
*----
*  UPDATE TIME
*----
      IF(ISTIME.EQ.1)THEN
        CALL LCMGET(KPDEV,'TIME',TMOLD)
        CALL LCMPUT(KPDEV,'TIME',1,2,TMNEW)
        IF(IMPX.GT.1)WRITE(IOUT,1004)TMOLD,TMNEW
      ENDIF
      RETURN
*
 1001 FORMAT(/5X,'ROD-NAME =>',1X,A/
     1  5X,'PREVIOUS INSERTION LEVEL =',F8.4/
     2  5X,'PREVIOUS ROD POSITION :'/
     3  5X,'X-',F10.4,5X,'Y-',F10.4,5X,'Z-',F10.4/
     4  5X,'X+',F10.4,5X,'Y+',F10.4,5X,'Z+',F10.4)
 1002 FORMAT(
     1 /5X,'NEW INSERTION LEVEL =',F8.4/
     2  5X,'NEW ROD POSITION :'/
     3  5X,'X-',F10.4,5X,'Y-',F10.4,5X,'Z-',F10.4/
     4  5X,'X+',F10.4,5X,'Y+',F10.4,5X,'Z+',F10.4/)
 1003 FORMAT(
     1 /5X,'PREVIOUS SPEED:',F10.4/
     2  5X,'NEW SPEED:',F10.4/)
 1004 FORMAT(
     1 /5X,'PREVIOUS TIME:',F10.4/
     2  5X,'NEW TIME:',F10.4/)
 1005 FORMAT(
     1 /5X,'PREVIOUS LZC LEVEL =',F8.4/
     2  5X,'PREVIOUS EMPTY-PART POSITION :'/
     3  5X,'X-',F10.4,5X,'Y-',F10.4,5X,'Z-',F10.4/
     4  5X,'X+',F10.4,5X,'Y+',F10.4,5X,'Z+',F10.4/
     5  5X,'PREVIOUS FULL-PART POSITION :'/
     6  5X,'X-',F10.4,5X,'Y-',F10.4,5X,'Z-',F10.4/
     7  5X,'X+',F10.4,5X,'Y+',F10.4,5X,'Z+',F10.4/)
 1006 FORMAT(
     1 /5X,'NEW LZC LEVEL =',F8.4/
     2  5X,'NEW EMPTY-PART POSITION :'/
     3  5X,'X-',F10.4,5X,'Y-',F10.4,5X,'Z-',F10.4/
     4  5X,'X+',F10.4,5X,'Y+',F10.4,5X,'Z+',F10.4/
     5  5X,'NEW FULL-PART POSITION :'/
     6  5X,'X-',F10.4,5X,'Y-',F10.4,5X,'Z-',F10.4/
     7  5X,'X+',F10.4,5X,'Y+',F10.4,5X,'Z+',F10.4/)
      END
