*DECK AXGGEO
      SUBROUTINE AXGGEO(IPGEOM,IPTRKM,IPRINT,GEONAM)
C
C----
C  1- PROGRAMME STATISTICS:
C      NAME     : AXGGEO
C      USE      : GENERATE TEMPORARY TRACKING FILE
C                 TO BE USED BY PSPTRK
C      AUTHOR   : G.MARLEAU
C      CREATED  : 2001/10/30
C
C
C  2- ROUTINE PARAMETERS:
C     IPGEOM : GEOMETRY DATA STRUCTURES POINTER
C              ***> INTEGER IPGEOM
C     IPTRKM : TRACKING DATA STRUCTURES POINTER         
C              ***> INTEGER IPTRKM
C     IPRINT : PRINT LEVEL                              
C              ***> INTEGER IPRINT
C     GEONAM : GEOMETRY NAME
C              ***> CHARACTER*12 GEONAM
C----
C
      IMPLICIT     NONE
      INTEGER      IOUT,NSTATE
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NSTATE=40,
     >             NAMSBR='AXGGEO')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPGEOM
      INTEGER      IPTRKM
      INTEGER      IPRINT
      CHARACTER    GEONAM*12
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
C----
C  FOR INTEGER VECTOR
C----
      INTEGER     KEYMRG,MATALB,MATMRG
C----
C  FOR REAL VECTOR
C----
      INTEGER     VOLSUR,VOLMRG
C----
C  LOCAL PARAMETERS
C---- 
      INTEGER     ISTATE(NSTATE)
      INTEGER     ITYPEG,ITGEO
      CHARACTER   HSIGN*12
      INTEGER     KCHAR(18),ITCR
      INTEGER     NV,NS,NSOUT,NREG,NUNK,ICODE(6)
      REAL        EXTKOP(NSTATE)
      INTEGER     ITROP,MAXMIX,IREG,ISYMM
      INTEGER     IUEXP,KDROPN,KDRCLS,IRC 
C----
C  STORE SIGNATURE AND TRACK TYPE ON IPTRKM
C----
      HSIGN='L_TRACK     '
      READ(HSIGN,'(3A4)') (KCHAR(ITCR),ITCR=1,3)
      CALL LCMPUT(IPTRKM,'SIGNATURE   ',3,3,KCHAR)
      HSIGN='EXCELL      '
      READ(HSIGN,'(3A4)') (KCHAR(ITCR),ITCR=1,3)
      CALL LCMPUT(IPTRKM,'TRACK-TYPE  ',3,3,KCHAR)
C----
C  ANALYZE GEOMETRY
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      ITYPEG= ISTATE(1)
      IF(ITYPEG .EQ. 3 .OR. ITYPEG .EQ. 6 ) THEN
        ITGEO= 1
      ELSE IF(ITYPEG .EQ.  8 .OR. ITYPEG .EQ.  9 .OR.
     >        ITYPEG .EQ. 24 .OR. ITYPEG .EQ. 25      ) THEN
        ITGEO= 2
      ELSE IF(ITYPEG .EQ.  5 .OR. ITYPEG .EQ.  7 .OR.
     >        ITYPEG .EQ. 20 .OR. ITYPEG .EQ. 21 .OR.
     >        ITYPEG .EQ. 22 .OR. ITYPEG .EQ. 23      ) THEN
        ITGEO= 3
      ELSE
        ITGEO= 0
      ENDIF
      IF(ISTATE(13) .GE. 1) THEN
C----
C  CLUSTER GEOMETRY
C----     
        ISYMM=1
        CALL AXGXCW(IPGEOM ,IPTRKM,IPRINT,GEONAM,ISYMM )
        ITROP=3
      ELSE IF(ITGEO .EQ. 2 ) THEN
C----
C  HEXAGONAL 2D GEOMETRIES
C----
C          CALL AXGXHX(IPGEOM ,IPTRKM,IPRINT,GEONAM)
        ITROP=2
      ELSE IF(ITGEO .EQ. 3 ) THEN
C----
C  CARTESIAN 2D/3D ASSEMBLIES
C  CALL XELPRP TO GET GEOMETRY DIMENSIONING INFORMATION
C----
        CALL AXGXEL(IPGEOM ,IPTRKM,IPRINT,GEONAM)
        ITROP=1
      ELSE
        CALL XABORT(NAMSBR//': INVALID TYPE OF GEOMETRY')
      ENDIF
      CALL LCMGET(IPTRKM,'ICODE       ',ICODE)
      CALL LCMSIX(IPTRKM,'EXCELL      ',1)
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRKM,'STATE-VECTOR',ISTATE) 
      NV=ISTATE(3)
      NS=ISTATE(2)
      NUNK=NV+NS+1
      CALL SETARA(IBASE,NUNK,KEYMRG)
      CALL SETARA(IBASE,NUNK,MATALB)
      CALL SETARA(RBASE,NUNK,VOLSUR)
      CALL LCMGET(IPTRKM,'KEYMRG      ',IBASE(KEYMRG))
      CALL LCMGET(IPTRKM,'MATALB      ',IBASE(MATALB))
      CALL LCMGET(IPTRKM,'VOLSUR      ',RBASE(VOLSUR))
      CALL LCMSIX(IPTRKM,'EXCELL      ',2)
      CALL SETARA(IBASE,NUNK,MATMRG)
      CALL SETARA(RBASE,NUNK,VOLMRG)
      CALL XELCMP(NS    ,NV    ,
     >            RBASE(VOLSUR),IBASE(MATALB),IBASE(KEYMRG),
     >            NSOUT ,NREG  ,
     >            RBASE(VOLMRG),IBASE(MATMRG),
     >            ITGEO ,ICODE )
      MAXMIX=0
      DO 100 IREG=1,NREG
        IBASE(KEYMRG+IREG+NSOUT)= IREG
        MAXMIX=MAX(MAXMIX,IBASE(MATMRG+IREG+NSOUT))
 100  CONTINUE
      CALL LCMPUT(IPTRKM,'MATCOD',NREG,1,IBASE(MATMRG+NSOUT+1))
      CALL LCMPUT(IPTRKM,'VOLUME',NREG,2,RBASE(VOLMRG+NSOUT+1))
      CALL LCMPUT(IPTRKM,'KEYFLX',NREG,1,IBASE(KEYMRG+NSOUT+1))
      CALL XDRSET(EXTKOP,NSTATE,0.0)
      CALL LCMPUT(IPTRKM,'EXCELTRACKOP',NSTATE,2,EXTKOP)
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)=NREG
      ISTATE(2)=NREG
      ISTATE(4)=MAXMIX
      ISTATE(5)=NSOUT
      ISTATE(7)=ITROP
      ISTATE(8)=-1
      CALL LCMPUT(IPTRKM,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL RLSARA(RBASE(VOLMRG))
      CALL RLSARA(IBASE(MATMRG))
      CALL RLSARA(RBASE(VOLSUR))
      CALL RLSARA(IBASE(MATALB))
      CALL RLSARA(IBASE(KEYMRG))
C----
C  IF IPRINT >= 20
C  EXPORT TEMPORARY TRACKING FILE
C----
      IF(IPRINT .GE. 10) THEN 
        IUEXP=KDROPN('AXGGEOEXPTRK',0,3,0,0)
        CALL LCMEXP(IPTRKM,IPRINT,IUEXP,2,1)
        IRC=KDRCLS(IUEXP,1)
      ENDIF
      RETURN
      END
