*DECK AXGXCW
      SUBROUTINE AXGXCW(IPGEOM,IPTRKM,IPRINT,GEONAM,ISYMM )
C
C----
C  1- PROGRAMME STATISTICS:
C      NAME     : AXGXCW
C      USE      : ANALYSE XEL GEOMETRY - XCWTRK module
C      AUTHOR   : G.MARLEAU
C      CREATED  : 2001/10/30
C                 extracted from XCWTRK since this part 
C                 of the routine is called by the modules
C                 PSP, EDI, EXCELT and EXCELL.
C
C
C  2- ROUTINE PARAMETERS:
C     IPGEOM : GEOMETRY DATA STRUCTURES POINTER
C              ***> INTEGER IPGEOM
C     IPTRKM : TRACKING DATA STRUCTURES POINTER         
C              ***> INTEGER IPTRKM
C     IPRINT : PRINT LEVEL                              
C              ***> INTEGER IPRINT
C     GEONAM : GEOMETRY NAME
C              ***> CHARACTER*12 GEONAM
C     ISYMM  : GEOMETRY SYMMETRY
c              ***> INTEGER ISYMM
C----
C
      IMPLICIT     NONE
      INTEGER      IOUT,NALB,MREGIO,NSTATE
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NALB=6,MREGIO=100000,NSTATE=40,
     >             NAMSBR='AXGXCW')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPGEOM
      INTEGER      IPTRKM
      INTEGER      IPRINT
      CHARACTER*12 GEONAM
      INTEGER      ISYMM
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER      IBASE(1)
      REAL         RBASE
      COMMON       RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
C----
C  FOR INTEGER VECTOR
C----
      INTEGER      KEYMRG,MATALB,NRINFO,NRODS ,NRODR ,NXRS  ,
     >             NXRI  ,MATANN,MATROD,ISPLIT,MATRT 
C----
C  FOR REAL VECTOR
C----
      INTEGER      VOLSUR,RAN   ,RODS  ,RODR  ,RAD   ,VRG  
C----
C  LOCAL VARIABLES
C---- 
      LOGICAL      ILK
      INTEGER      NCODE(NALB),ICODE(NALB)
      REAL         ZCODE(NALB),ALBEDO(NALB) 
      INTEGER      ISTATE(NSTATE)
      INTEGER      NDIM  ,NSUR  ,NVOL  ,MAXJ  ,IROT  ,NBAN  ,
     >             MNAN  ,NRT   ,MSROD ,MAROD ,NSURF ,NSURX ,
     >             NMAT  ,NUNK
      REAL         RADMIN,COTE  
C----
C  SET POSITION VECTOR AND READ ISTATE
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      NDIM=2
      IF(ISTATE(1).EQ.3) THEN
        NSUR=1
      ELSE IF(ISTATE(1).EQ.20) THEN
        NSUR=4
      ELSE IF(ISTATE(1).EQ.24) THEN
        NSUR=6
      ENDIF
      MAXJ=1
      IROT=0
      CALL XCGDIM(IPGEOM,MREGIO,NSUR  ,IROT  ,ISYMM ,MAXJ  ,
     >            NVOL  ,NBAN  ,MNAN  ,NRT   ,MSROD ,MAROD ,
     >            NSURF )
C----
C  CHECK FOR SYMMETRY
C----
      NSURX=NSUR
      IF(ISYMM.GT.1) THEN
        IF(NSURX.EQ.4) THEN
          IROT=-ISYMM-400
        ELSE IF(NSURX.EQ.6) THEN
          IROT=-ISYMM-600
        ELSE
          IROT=-ISYMM-100
        ENDIF
        NSUR=1
      ENDIF
C----
C  ALLOCATE MEMORY FOR PROCESSING GEOMETRY INFORMATION
C----
      CALL SETARA(IBASE,NSUR+NVOL+1,KEYMRG)
      CALL SETARA(RBASE,NSUR+NVOL+1,VOLSUR)
      CALL SETARA(IBASE,NSUR+NVOL+1,MATALB)
      CALL SETARA(IBASE,2*MNAN,NRINFO)
      CALL SETARA(RBASE,NBAN,RAN)
      CALL SETARA(IBASE,3*NRT,NRODS)
      CALL SETARA(RBASE,2*NRT,RODS)
      CALL SETARA(IBASE,NRT,NRODR)
      CALL SETARA(RBASE,MSROD*NRT,RODR)
      CALL SETARA(IBASE,NRT,NXRS)
      CALL SETARA(IBASE,NRT*NBAN,NXRI)
      CALL SETARA(IBASE,NBAN,MATANN)
      CALL SETARA(IBASE,MSROD*NRT,MATROD)
      CALL SETARA(IBASE,NBAN,ISPLIT)
      CALL SETARA(RBASE,MNAN,RAD)
      CALL SETARA(RBASE,2*NRT,VRG)
      CALL XCGGEO(IPGEOM,IROT  ,NSUR  ,NVOL  ,NBAN  ,MNAN  ,
     >            NRT   ,MSROD ,IPRINT,ILK   ,NMAT  ,
     >            RBASE(RAN)   ,IBASE(MATANN),IBASE(NRODS) ,
     >            RBASE(RODS)  ,IBASE(MATROD),IBASE(NRODR) ,
     >            RBASE(RODR)  ,IBASE(NRINFO),IBASE(MATALB),
     >            RBASE(VOLSUR),IBASE(ISPLIT),RBASE(RAD)   ,
     >            COTE  ,RADMIN,NCODE ,ICODE ,ZCODE ,ALBEDO,
     >            IBASE(KEYMRG),IBASE(NXRS)  ,IBASE(NXRI)  ,
     >            RBASE(VRG)   )
      CALL SETARA(IBASE,NSUR,MATRT)
      CALL XCGBCM(IPTRKM,NSUR  ,NCODE ,IBASE(MATRT) )
C----
C  RELEASE TEMPORARY BLOCKS
C----
      CALL RLSARA(RBASE(VRG))
      CALL RLSARA(RBASE(RAD))
      CALL RLSARA(IBASE(ISPLIT))
      CALL RLSARA(IBASE(MATROD))
      CALL RLSARA(IBASE(MATANN))
C----
C  SAVE TRACKING FOR CLUSTER GEOMETRY
C----
      CALL XDISET(ISTATE,NSTATE,0)
      NUNK=NVOL+NSUR+1
      ISTATE(1)=NDIM
      ISTATE(2)=NSUR
      ISTATE(3)=NVOL
      ISTATE(4)=NSURX
      ISTATE(5)=NBAN
      ISTATE(6)=NUNK
      ISTATE(7)=NRT
      ISTATE(8)=MSROD
      ISTATE(9)=MAROD
      ISTATE(10)=MNAN
      CALL LCMSIX(IPTRKM,'EXCELL      ',1)
      CALL LCMPUT(IPTRKM,'STATE-VECTOR',NSTATE   ,1,ISTATE       )
      CALL LCMPUT(IPTRKM,'RAN         ',NBAN     ,2,RBASE(RAN)   )
      IF(NSURX .EQ. 4)
     >CALL LCMPUT(IPTRKM,'COTE        ',1        ,2,COTE         )
      CALL LCMPUT(IPTRKM,'RADMIN      ',1        ,2,RADMIN       )
      CALL LCMPUT(IPTRKM,'NRODS       ',3*NRT    ,1,IBASE(NRODS) )
      CALL LCMPUT(IPTRKM,'RODS        ',2*NRT    ,2,RBASE(RODS)  )
      CALL LCMPUT(IPTRKM,'NRODR       ',NRT      ,1,IBASE(NRODR) )
      CALL LCMPUT(IPTRKM,'RODR        ',MSROD*NRT,2,RBASE(RODR)  )
      CALL LCMPUT(IPTRKM,'NRINFO      ',2*NBAN   ,1,IBASE(NRINFO))
      CALL LCMPUT(IPTRKM,'NXRI        ',NRT*NBAN ,1,IBASE(NXRI)  )
      CALL LCMPUT(IPTRKM,'NXRS        ',NRT      ,1,IBASE(NXRS)  )
      CALL LCMPUT(IPTRKM,'KEYMRG      ',NUNK     ,1,IBASE(KEYMRG))
      CALL LCMPUT(IPTRKM,'MATALB      ',NUNK     ,1,IBASE(MATALB))
      CALL LCMPUT(IPTRKM,'VOLSUR      ',NUNK     ,2,RBASE(VOLSUR))
      CALL LCMSIX(IPTRKM,'EXCELL      ',2)
      CALL LCMPUT(IPTRKM,'ALBEDO      ',6        ,2,ALBEDO       )
      CALL LCMPUT(IPTRKM,'ICODE       ',6        ,1,ICODE        )
      CALL LCMPUT(IPTRKM,'NCODE       ',6        ,1,NCODE        )
C----
C  RELEASE BLOCKS FOR GEOMETRY
C----
      CALL RLSARA(IBASE(MATRT))
      CALL RLSARA(IBASE(NXRI))
      CALL RLSARA(IBASE(NXRS))
      CALL RLSARA(RBASE(RODR))
      CALL RLSARA(IBASE(NRODR))
      CALL RLSARA(RBASE(RODS))
      CALL RLSARA(IBASE(NRODS))
      CALL RLSARA(RBASE(RAN))
      CALL RLSARA(IBASE(NRINFO))
      CALL RLSARA(IBASE(MATALB))
      CALL RLSARA(RBASE(VOLSUR))
      CALL RLSARA(IBASE(KEYMRG))
      RETURN
      END
