*DECK AXGXEL
      SUBROUTINE AXGXEL(IPGEOM,IPTRKM,IPRINT,GEONAM)
C
C----
C  1- PROGRAMME STATISTICS:
C      NAME     : AXGXEL
C      USE      : ANALYSE XEL GEOMETRY - XELTRK module
C      AUTHOR   : G.MARLEAU
C      CREATED  : 2001/10/30
C                 extracted from XELTRK since this part 
C                 of the routine is called by the modules
C                 PSP, EDI, EXCELT and EXCELL.
C
C
C  2- ROUTINE PARAMETERS:
C     IPGEOM : GEOMETRY DATA STRUCTURES POINTER
C              ***> INTEGER IPGEOM
C     IPTRKM : TRACKING DATA STRUCTURES POINTER         
C              ***> INTEGER IPTRKM
C     IPRINT : PRINT LEVEL                              
C              ***> INTEGER IPRINT
C     GEONAM : GEOMETRY NAME
C              ***> CHARACTER*12 GEONAM
C----
C
      IMPLICIT     NONE
      INTEGER      IOUT,NALB,MREGIO,MXDIM,NSTATE
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NALB=6,MREGIO=100000,MXDIM=3,NSTATE=40,
     >             NAMSBR='AXGXEL')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPGEOM
      INTEGER      IPTRKM
      INTEGER      IPRINT
      CHARACTER*12 GEONAM
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER      IBASE(1)
      REAL         RBASE
      COMMON       RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
C----
C  FOR INTEGER VECTOR
C----
      INTEGER      MRGCEL, NSURO, NVOLO,IDLGEO,IDLDIM,KEYGEO,
     >             IDLTYP,KEYTYP,IDLBLK,KCELLG, ISPLT,KEYTRN,
     >             ITGEOM,KCELLT,IDLREM,MINDO , MAXDO,ICORDO,
     >             MATGEO,INDEXO,KEYSYM,MATTYP,KEYINT,KEYCYL,
     >             KEYMRG,MATALB,MINDIM,MAXDIM,ICORD , INDEX,
     >             INCELL,MATRT  
C----
C  FOR REAL VECTOR
C----
      INTEGER      REMSHO,VOLSRO,VOLSUR,REMESH
C----
C  LOCAL VARIABLES
C---- 
      INTEGER      NCODE(NALB),ICODE(NALB)
      REAL         ALBEDO(NALB) 
      INTEGER      MAXGRI(MXDIM),LCLSYM(MXDIM),LCLTRA(MXDIM),
     >             MRGSUR(-NALB:-1)
      INTEGER      ISTATE(NSTATE)
      LOGICAL      LEAKSW,LL1,LL2,L1CELL
      INTEGER      NDIM,NTYPO,NBLOCK,NBMIX,NEXTGE,IFCSYM 
      INTEGER      NTOTCO,MAXRO,NGEOME,NGIDL,NTIDL,NUNKO
      INTEGER      NTYP,NTOTCL,MAXR
      INTEGER      NSUR,NSURC,NVOL,NVOLC,NUNK,NSBC
C----
C  GET DIMENSIONING INFORMATION
C----
      CALL XELPRP( IPGEOM,  GEONAM,  NDIM,  NTYPO, NBLOCK,  NBMIX,
     >             MAXGRI,  ALBEDO, ICODE,  NCODE, LCLSYM, LCLTRA,
     >             MRGSUR,  LEAKSW,   LL1,    LL2, L1CELL, NEXTGE,
     >             IFCSYM,  IPRINT)
C----
C  ALLOCATE MEMORY - 1
C----
      CALL SETARA(IBASE,  NBLOCK,MRGCEL)
      CALL SETARA(IBASE,  NBLOCK, NSURO)
      CALL SETARA(IBASE,  NBLOCK, NVOLO)
      CALL SETARA(IBASE,  NBLOCK,IDLGEO)
      CALL SETARA(IBASE,  NBLOCK,IDLDIM)
      CALL SETARA(IBASE,  NBLOCK,KEYGEO)
      CALL SETARA(IBASE,  NBLOCK,IDLTYP)
      CALL SETARA(IBASE,  NBLOCK,KEYTYP)
      CALL SETARA(IBASE,  NBLOCK,IDLBLK)
      CALL SETARA(IBASE,3*NBLOCK,KCELLG)
      CALL SETARA(IBASE,  MREGIO, ISPLT)
      CALL SETARA(IBASE,  NBLOCK,KEYTRN)
      CALL SETARA(IBASE,  NBLOCK,ITGEOM)
      CALL SETARA(IBASE, 3*NTYPO,KCELLT)
C----
C  READ GEOMETRY BLOCK DESCRIPTION
C----
      CALL XELDCL(IPGEOM,GEONAM,NDIM  ,MAXGRI,LCLSYM,NBLOCK ,
     >            NTYPO ,LL1   ,LL2   ,IPRINT,NTOTCO,MAXRO  ,
     >            NGEOME,NTYP  ,NGIDL ,NTIDL ,NUNKO ,
     >            IBASE(KCELLG),IBASE(NSURO) ,IBASE(NVOLO) ,
     >            IBASE(IDLDIM),IBASE(IDLGEO),IBASE(KEYTRN),
     >            IBASE(KEYGEO),IBASE(IDLTYP),IBASE(KEYTYP),
     >            IBASE(MRGCEL),IBASE(IDLBLK),IBASE(ITGEOM),
     >            IBASE(KCELLT),IBASE(ISPLT) )
C----
C  RELEASE SOME MEMORY
C---
      CALL RLSARA(IBASE(KCELLT))
      CALL RLSARA(IBASE(ITGEOM))
C----
C  ALLOCATE MEMORY - 2
C----
      CALL SETARA(IBASE, NGEOME,IDLREM)
      CALL SETARA(RBASE,  MAXRO,REMSHO)
      CALL SETARA(IBASE, NTOTCO, MINDO)
      CALL SETARA(IBASE, NTOTCO, MAXDO)
      CALL SETARA(IBASE, NTOTCO,ICORDO)
      CALL SETARA(RBASE,  NGIDL,VOLSRO)
      CALL SETARA(IBASE,  NGIDL,MATGEO)
      CALL SETARA(IBASE,4*NGIDL,INDEXO)
      CALL SETARA(IBASE,  NGIDL,KEYSYM)
C----
C  PRODUCE REGION NUMBERING AND VOLUME EVALUATION
C----
      CALL XELTRP(IPGEOM,NDIM  ,NGEOME,L1CELL ,NTOTCO,NEXTGE,
     >            MAXRO ,IPRINT,IBASE(KCELLG),IBASE(NSURO) ,
     >            IBASE(NVOLO) ,IBASE(IDLDIM),IBASE(IDLGEO),
     >            IBASE(KEYTRN),IBASE(MAXDO) ,IBASE(MINDO) ,
     >            IBASE(ICORDO),RBASE(REMSHO),IBASE(IDLREM),
     >            IBASE(INDEXO),RBASE(VOLSRO),IBASE(MATGEO),
     >            IBASE(KEYSYM),IBASE(ISPLT) )
C----
C  RELEASE SOME MEMORY
C----
      CALL RLSARA(IBASE(KEYSYM))
      CALL RLSARA(IBASE(KEYTRN))
C----
C  ALLOCATE MEMORY - 3
C----
      CALL SETARA(IBASE,NTIDL,MATTYP)
      CALL SETARA(IBASE,NUNKO,KEYINT)
C----
C     INTERFACE ALL CELLS IN THE GEOMETRY
C----
      CALL XELBIN(IPGEOM,NDIM  ,NGEOME,L1CELL,NTYP  ,NGIDL ,
     >            NTIDL ,NBLOCK,MAXGRI,NUNKO ,IPRINT,
     >            IBASE(KCELLG),IBASE(NSURO) ,IBASE(NVOLO) ,
     >            IBASE(IDLGEO),IBASE(MATGEO),IBASE(KEYGEO),
     >            IBASE(IDLTYP),IBASE(IDLBLK),IBASE(KEYTYP),
     >            IBASE(MATTYP),IBASE(KEYINT),IBASE(ISPLT) )
C----
C  RELEASE SOME MEMORY
C----
      CALL RLSARA(IBASE(ISPLT))
C----
C  ALLOCATE MEMORY - 4
C----
      CALL SETARA(IBASE,NBLOCK,KEYCYL)
C----
C  COMPUTE ALLOCATION IN EXACT GEOMETRY.
C----
      CALL XELEDC(NDIM  ,MAXGRI,NGEOME,NTOTCO,NTYP  ,NBLOCK,
     >            NUNKO ,       IBASE(NSURO) ,IBASE(NVOLO) ,
     >            IBASE(MINDO) ,IBASE(MAXDO) ,IBASE(ICORDO),
     >            IBASE(IDLDIM),IBASE(KEYGEO),IBASE(KEYTYP),
     >            IBASE(IDLBLK),IBASE(KEYINT),NTOTCL,MAXR  ,
     >            NSUR  ,NVOL  ,IBASE(KEYCYL))
      NUNK= NVOL + 1 - NSUR
C----
C  ALLOCATE MEMORY - 5
C----
      CALL SETARA(RBASE,  NUNK,VOLSUR)
      CALL SETARA(IBASE,  NUNK,KEYMRG)
      CALL SETARA(IBASE,  NUNK,MATALB)
      CALL SETARA(RBASE,  MAXR,REMESH)
      CALL SETARA(IBASE,NTOTCL,MINDIM)
      CALL SETARA(IBASE,NTOTCL,MAXDIM)
      CALL SETARA(IBASE,NTOTCL, ICORD)
      CALL SETARA(IBASE,4*NUNK, INDEX)
      CALL SETARA(IBASE,  NUNK,INCELL)
C----
C  TO RECONSTRUCT THE MESH IN EXACT GEOMETRY.
C----
      CALL XELETR(IPRINT,NDIM  ,MAXGRI,NGEOME,NTOTCO,NTYP  ,
     >            NTIDL ,NBLOCK,NSUR  ,NVOL  ,NTOTCL,NUNKO ,
     >            IBASE(NSURO) ,IBASE(NVOLO) ,IBASE( MINDO),
     >            IBASE(MAXDO) ,IBASE(ICORDO),IBASE(IDLDIM),
     >            IBASE(IDLGEO),IBASE(KEYGEO),IBASE(IDLTYP),
     >            IBASE(KEYTYP),IBASE(IDLBLK),IBASE(KEYCYL),
     >            RBASE(REMSHO),IBASE(IDLREM),IBASE(INDEXO),
     >            RBASE(VOLSRO),IBASE(MATGEO),IBASE(KEYINT),
     >            IBASE(MATTYP),RBASE(REMESH),IBASE(MINDIM),
     >            IBASE(MAXDIM),IBASE(ICORD) ,RBASE(VOLSUR),
     >            IBASE(KEYMRG),IBASE(INDEX) ,IBASE(INCELL),
     >            IBASE(MATALB),NSURC ,NVOLC )
      NSUR=NSURC
      NVOL=NVOLC
      NUNK= NVOL + 1 - NSUR
      CALL RLSARA(IBASE(KEYCYL))
      CALL RLSARA(IBASE(KEYINT))
      CALL RLSARA(IBASE(MATTYP))
      CALL RLSARA(IBASE(INDEXO))
      CALL RLSARA(IBASE(MATGEO))
      CALL RLSARA(RBASE(VOLSRO))
      CALL RLSARA(IBASE(ICORDO))
      CALL RLSARA(IBASE(MAXDO))
      CALL RLSARA(IBASE(MINDO))
      CALL RLSARA(RBASE(REMSHO))
      CALL RLSARA(IBASE(IDLREM))
      CALL RLSARA(IBASE(KCELLG))
      CALL RLSARA(IBASE(IDLBLK))
      CALL RLSARA(IBASE(KEYTYP))
      CALL RLSARA(IBASE(IDLTYP))
      CALL RLSARA(IBASE(KEYGEO))
      CALL RLSARA(IBASE(IDLDIM))
      CALL RLSARA(IBASE(IDLGEO))
      CALL RLSARA(IBASE(NVOLO))
      CALL RLSARA(IBASE(NSURO))
C----
C  ALLOCATE MEMORY - 6
C----
      CALL SETARA(IBASE,-NSUR*2,MATRT)
C----
C  PREPARE MERGING OF ZONES AND SURFACES USING BOUNDARY CONDITIONS.
C  SET UP REFLECTION-TRANSMISSION MATRIX
C----
      CALL XELMRG(IPRINT,NSUR  ,NVOL  ,NSBC  ,NTOTCL,
     >            IBASE(INDEX) ,IBASE(MINDIM),IBASE(MAXDIM),
     >            LCLSYM,LCLTRA,LL1   ,LL2   ,NEXTGE,
     >            IBASE(MRGCEL),IBASE(MATALB),IBASE(KEYMRG),
     >            IBASE(INCELL),IBASE(MATRT) )
C----
C  SAVE EXCELL TRACKING FOR CARTESIAN GEOMETRY
C----
      CALL LCMSIX(IPTRKM,'EXCELL      ',1)
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)=NDIM
      ISTATE(2)=-NSUR
      ISTATE(3)=NVOL
      ISTATE(4)=NTOTCL
      ISTATE(5)=MAXR
      ISTATE(6)=NUNK
      ISTATE(7)=NEXTGE
      ISTATE(8)=LCLSYM(1)
      ISTATE(9)=LCLSYM(2)
      IF(NDIM .EQ. 3) ISTATE(10)=LCLSYM(3)
C----
C  LL1 is for diagonal symmetry 
C  with region Pi/4 to Pi/2 defined in x-y plane
C  LL2 is for diagonal symmetry 
C  with region 0 to Pi/4 defined in x-y plane
C---- 
      IF(LL1) THEN
        ISTATE(11)=-1
      ELSE IF(LL2) THEN
        ISTATE(11)=1
      ENDIF
      CALL LCMPUT(IPTRKM,'MINDIM      ',NTOTCL,1,IBASE(MINDIM))
      CALL LCMPUT(IPTRKM,'MAXDIM      ',NTOTCL,1,IBASE(MAXDIM))
      CALL LCMPUT(IPTRKM,'ICORD       ',NTOTCL,1,IBASE(ICORD) )
      CALL LCMPUT(IPTRKM,'INDEX       ',4*NUNK,1,IBASE(INDEX) )
      CALL LCMPUT(IPTRKM,'REMESH      ',MAXR  ,2,RBASE(REMESH))
      CALL LCMPUT(IPTRKM,'KEYMRG      ',NUNK  ,1,IBASE(KEYMRG))
      CALL LCMPUT(IPTRKM,'MATALB      ',NUNK  ,1,IBASE(MATALB))
      CALL LCMPUT(IPTRKM,'VOLSUR      ',NUNK  ,2,RBASE(VOLSUR))
      CALL LCMPUT(IPTRKM,'STATE-VECTOR',NSTATE,1,ISTATE    )
      CALL LCMSIX(IPTRKM,'EXCELL      ',2)
C----
C  SAVE REFLECTION-TRANSMISSION MATRIX
C----
      CALL LCMPUT(IPTRKM,'BC-REFL+TRAN',NSBC,1,IBASE(MATRT))
      CALL LCMPUT(IPTRKM,'ALBEDO      ',6     ,2,ALBEDO       )
      CALL LCMPUT(IPTRKM,'ICODE       ',6     ,1,ICODE        )
      CALL LCMPUT(IPTRKM,'NCODE       ',6     ,1,NCODE        )
      CALL RLSARA(IBASE(MATRT))
C----
C  RELEASE REMAINING MEMORY
C----
      CALL RLSARA(IBASE(INCELL))
      CALL RLSARA(IBASE(INDEX))
      CALL RLSARA(IBASE(ICORD))
      CALL RLSARA(IBASE(MAXDIM))
      CALL RLSARA(IBASE(MINDIM))
      CALL RLSARA(RBASE(REMESH))
      CALL RLSARA(IBASE(MATALB))
      CALL RLSARA(IBASE(KEYMRG))
      CALL RLSARA(RBASE(VOLSUR))
      CALL RLSARA(IBASE(MRGCEL))
      RETURN
      END
