*DECK CHAB01
      SUBROUTINE CHAB01(IPMIC,IMPX,NGRP,IMOD,TYPSEC,HISOT,VALUE,IGM,
     1 IGP,VAL,GAR1,GAR2,GAR3,DELTA)
*
*-----------------------------------------------------------------------
*
*Purpose:
* modify a specific isotope and reaction in a microlib.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPMIC   LCM pointer to the Microlib.
* IMPX    print index.
* NGRP    number of energy groups.
* IMOD    type of modification: 1: complete replacement; 2: replace
*         specific values by VALUE; 3: increase by VALUE; 4: multiply
*         by VALUE.
* TYPSEC  name of reaction to modify.
* HISOT   name of isotope to modify.
* VALUE   value used in modification operation.
* IGM     first energy group to modify.
* IGP     last energy group to modify.
* VAL     array of values used if IMOD=1.
*
*Parameters: scratch
* GAR1
* GAR2
* GAR3
* DELTA
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPMIC,IMPX,NGRP,IMOD,IGM,IGP
      CHARACTER TYPSEC*8,HISOT*12
      REAL VALUE,VAL(IGP-IGM+1),GAR1(NGRP),GAR2(NGRP),GAR3(NGRP,NGRP),
     1 DELTA(NGRP)
*----
*  LOCAL VARIABLES
*----
      PARAMETER (IOUT=6)
      CHARACTER AJUS(4)*4
      COMMON BASE(1)
      DATA AJUS/'VALE','CONS','PLUS','MULT'/
*
      CALL LCMLEN(IPMIC,HISOT,ILONG,ITYLCM)
      IF(ILONG.EQ.0) CALL XABORT('CHAB01: MISSING ISOTOPE '//HISOT//'.')
      IF(IMPX.GT.0) WRITE(IOUT,'(/17H CHAB01: MODIFY (,A,11H) REACTION ,
     1 A,12H OF ISOTOPE ,A,1H.)') AJUS(IMOD),TYPSEC,HISOT
      CALL LCMSIX(IPMIC,HISOT,1)
      CALL LCMLEN(IPMIC,TYPSEC,ILONG,ITYLCM)
      IF(ILONG.EQ.0) THEN
         CALL XABORT('CHAB01: MISSING REACTION '//TYPSEC//'.')
      ENDIF
      IF(TYPSEC.EQ.'NTOT0') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
      ELSE IF(TYPSEC.EQ.'NG') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
         CALL LCMGET(IPMIC,'NTOT0',GAR2)
         DO 20 IG1=1,NGRP
   20    GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
         CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
      ELSE IF(TYPSEC.EQ.'NELAS') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
         CALL SETARA(BASE,NGRP*NGRP,IXSSCM)
         CALL SETARA(BASE,NGRP,INJJ)
         CALL SETARA(BASE,NGRP,IIJJ)
         CALL XDRLGS(IPMIC,-1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         DO 40 IG2=1,NGRP
         DO 30 IG1=1,NGRP
   30    GAR3(IG1,IG2)=GAR3(IG1,IG2)/GAR1(IG2)
         GAR1(IG2)=GAR1(IG2)+DELTA(IG2)
         DO 40 IG1=1,NGRP
   40    GAR3(IG1,IG2)=GAR3(IG1,IG2)*GAR1(IG2)
         CALL XDRLGS(IPMIC,1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IXSSCM))
         CALL LCMGET(IPMIC,'NTOT0',GAR2)
         DO 50 IG1=1,NGRP
   50    GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
         CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
      ELSE IF(TYPSEC.EQ.'N2N') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
         CALL SETARA(BASE,NGRP*NGRP,IXSSCM)
         CALL SETARA(BASE,NGRP,INJJ)
         CALL SETARA(BASE,NGRP,IIJJ)
         CALL XDRLGS(IPMIC,-1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         DO 70 IG2=1,NGRP
         DO 60 IG1=1,NGRP
   60    GAR3(IG1,IG2)=GAR3(IG1,IG2)/GAR1(IG2)
         GAR1(IG2)=GAR1(IG2)+2.0*DELTA(IG2)
         DO 70 IG1=1,NGRP
   70    GAR3(IG1,IG2)=GAR3(IG1,IG2)*GAR1(IG2)
         CALL XDRLGS(IPMIC,1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IXSSCM))
         CALL LCMGET(IPMIC,'NTOT0',GAR2)
         DO 80 IG1=1,NGRP
   80    GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
         CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
      ELSE IF(TYPSEC.EQ.'N3N') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
         CALL SETARA(BASE,NGRP*NGRP,IXSSCM)
         CALL SETARA(BASE,NGRP,INJJ)
         CALL SETARA(BASE,NGRP,IIJJ)
         CALL XDRLGS(IPMIC,-1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         DO 100 IG2=1,NGRP
         DO 90 IG1=1,NGRP
   90    GAR3(IG1,IG2)=GAR3(IG1,IG2)/GAR1(IG2)
         GAR1(IG2)=GAR1(IG2)+3.0*DELTA(IG2)
         DO 100 IG1=1,NGRP
  100    GAR3(IG1,IG2)=GAR3(IG1,IG2)*GAR1(IG2)
         CALL XDRLGS(IPMIC,1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IXSSCM))
         CALL LCMGET(IPMIC,'NTOT0',GAR2)
         DO 110 IG1=1,NGRP
  110    GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
         CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
      ELSE IF(TYPSEC.EQ.'N4N') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
         CALL SETARA(BASE,NGRP*NGRP,IXSSCM)
         CALL SETARA(BASE,NGRP,INJJ)
         CALL SETARA(BASE,NGRP,IIJJ)
         CALL XDRLGS(IPMIC,-1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         DO 130 IG2=1,NGRP
         DO 120 IG1=1,NGRP
  120    GAR3(IG1,IG2)=GAR3(IG1,IG2)/GAR1(IG2)
         GAR1(IG2)=GAR1(IG2)+4.0*DELTA(IG2)
         DO 130 IG1=1,NGRP
  130    GAR3(IG1,IG2)=GAR3(IG1,IG2)*GAR1(IG2)
         CALL XDRLGS(IPMIC,1,IMPX,0,0,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IXSSCM))
         CALL LCMGET(IPMIC,'NTOT0',GAR2)
         DO 140 IG1=1,NGRP
  140    GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
         CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
      ELSE IF((TYPSEC(:4).EQ.'SIGS').OR.(TYPSEC(:4).EQ.'SCAT')) THEN
         READ(TYPSEC(5:6),'(I2)') IL
         CALL SETARA(BASE,NGRP*NGRP,IXSSCM)
         CALL SETARA(BASE,NGRP,INJJ)
         CALL SETARA(BASE,NGRP,IIJJ)
         CALL XDRLGS(IPMIC,-1,IMPX,IL,IL,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         DO 150 IG1=1,NGRP
         DO 150 IG2=1,NGRP
  150    GAR3(IG1,IG2)=GAR3(IG1,IG2)/GAR1(IG2)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         DO 160 IG1=1,NGRP
         DO 160 IG2=1,NGRP
  160    GAR3(IG1,IG2)=GAR3(IG1,IG2)*GAR1(IG2)
         CALL XDRLGS(IPMIC,1,IMPX,IL,IL,1,NGRP,GAR1,GAR3,ITYPRO,
     1   BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IXSSCM))
         IF(IL.EQ.0) THEN
            CALL LCMGET(IPMIC,'NTOT0',GAR2)
            DO 170 IG1=1,NGRP
  170       GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
            CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
         ENDIF
      ELSE IF((TYPSEC.EQ.'NFTOT').OR.(TYPSEC.EQ.'NUSIGF')) THEN
         CALL LCMGET(IPMIC,'NFTOT',GAR1)
         CALL LCMGET(IPMIC,'NUSIGF',GAR2)
         DO 180 IG1=1,NGRP
  180    GAR2(IG1)=GAR2(IG1)/GAR1(IG1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         DO 190 IG1=1,NGRP
  190    GAR2(IG1)=GAR1(IG1)*GAR2(IG1)
         CALL LCMPUT(IPMIC,'NFTOT',NGRP,2,GAR1)
         CALL LCMPUT(IPMIC,'NUSIGF',NGRP,2,GAR2)
         CALL LCMGET(IPMIC,'NTOT0',GAR2)
         DO 200 IG1=1,NGRP
  200    GAR2(IG1)=GAR2(IG1)+DELTA(IG1)
         CALL LCMPUT(IPMIC,'NTOT0',NGRP,2,GAR2)
      ELSE IF(TYPSEC.EQ.'NU') THEN
         CALL LCMGET(IPMIC,'NFTOT',GAR1)
         CALL LCMGET(IPMIC,'NUSIGF',GAR2)
         DO 210 IG1=1,NGRP
  210    GAR2(IG1)=GAR2(IG1)/GAR1(IG1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR2,DELTA)
         DO 220 IG1=1,NGRP
  220    GAR2(IG1)=GAR1(IG1)*GAR2(IG1)
         CALL LCMPUT(IPMIC,'NUSIGF',NGRP,2,GAR2)
      ELSE IF(TYPSEC.EQ.'CHI') THEN
         CALL LCMGET(IPMIC,TYPSEC,GAR1)
         CALL CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
         SUM=0.0
         DO 230 IG1=1,NGRP
  230    SUM=SUM+GAR1(IG1)
         DO 240 IG1=1,NGRP
  240    GAR1(IG1)=GAR1(IG1)/SUM
         CALL LCMPUT(IPMIC,TYPSEC,NGRP,2,GAR1)
      ELSE
         CALL XABORT('CHAB01: UNKNOWN REACTION '//TYPSEC//'.')
      ENDIF
  500 CALL LCMSIX(IPMIC,' ',2)
      RETURN
      END
