*DECK CHAB02
      SUBROUTINE CHAB02(NGRP,IMOD,VALUE,IGM,IGP,VAL,GAR1,DELTA)
*
*-----------------------------------------------------------------------
*
*Purpose:
* modify an array of cross section values.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* NGRP    number of energy groups.
* IMOD    type of modification: 1: complete replacement; 2: replace
*         specific values by VALUE; 3: increase by VALUE; 4: multiply
*         by VALUE.
* VALUE   value used in modification operation.
* IGM     first energy group to modify.
* IGP     last energy group to modify.
* VAL     array of values used if IMOD=1.
* GAR1    cross section array to modify.
*
*Parameters: output
* GAR1    mofified cross section array.
* DELTA   difference in cross section value.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER NGRP,IMOD,IGM,IGP
      REAL VALUE,VAL(IGP-IGM+1),GAR1(NGRP),DELTA(NGRP)
*
      CALL XDRSET(DELTA,NGRP,0.0)
      IF(IMOD.EQ.1) THEN
         DO 10 IG=IGM,IGP
         DELTA(IG)=VAL(IG-IGM+1)-GAR1(IG)
   10    GAR1(IG)=VAL(IG-IGM+1)
      ELSE IF(IMOD.EQ.2) THEN
         DO 20 IG=IGM,IGP
         DELTA(IG)=VALUE-GAR1(IG)
   20    GAR1(IG)=VALUE
      ELSE IF(IMOD.EQ.3) THEN
         DO 30 IG=IGM,IGP
         DELTA(IG)=VALUE
   30    GAR1(IG)=GAR1(IG)+VALUE
      ELSE IF(IMOD.EQ.4) THEN
         DO 40 IG=IGM,IGP
         DELTA(IG)=GAR1(IG)*(VALUE-1.0)
   40    GAR1(IG)=GAR1(IG)*VALUE
      ENDIF
      RETURN
      END
