*DECK DRAGON
      PROGRAM DRAGON
      IMPLICIT         NONE
#if defined(MPI)
      include 'mpif.h'
#endif /* defined(MPI) */
*----
*  INPUT/OUTPUT UNITS
*----
      INTEGER          IOUT
      PARAMETER       (IOUT=6)
*----
*  VARIABLES FOR DRAGON VERSION
*----
      INTEGER          IMVERS
      CHARACTER        DATE*64,REV*48,NAMSBR*6
      PARAMETER       (NAMSBR='DRAGON')
*----
*  GAN-2000 PARAMETERS
*----
      INTEGER          KDRDRV
      EXTERNAL         KDRDRV
      INTEGER          KERNEL
*----
*  DIMENSION FOR MODULE DATA
*----
      INTEGER          NMODXT
      PARAMETER       (NMODXT=30)
      CHARACTER        CMODXT(NMODXT)*12
*----
*  LOCAL VARIABLES
*----
      INTEGER          IPRINT,IER
*----
*  DATA
*----
      DATA             CMODXT
     >   /'ASM:        ','COMPO:      ','EDI:        ','EVO:        ',
     >    'EXCELT:     ','FLU:        ','GEO:        ','INFO:       ',
     >    'USS:        ','LIB:        ','MAC:        ','MCCGT:      ',
     >    'BIVACT:     ','TRIVAT:     ','SHI:        ','SYBILT:     ',
     >    'SNT:        ','NCR:        ','NXT:        ','PSP:        ',
     >    'TLM:        ','M2T:        ','CHAB:       ','CPO:        ',
     >    'SAP:        ','MC:         ','T:          ','DMAC:       ',
     >    'EPC:        ','FMT:        '/
#if defined(MPI)
*----
*  MPI initialisation
*----
      INTEGER*4 IERROR, ME, NPROC
      CALL MPI_INIT(IERROR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NPROC,IERROR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ME,IERROR)
      WRITE(*,*)'CPU RANK   ===',ME
      WRITE(*,*)'WORLD SIZE ===',NPROC
#endif /* defined(MPI) */
*----
*  VERSION INFORMATION RECOVERED FROM CVS or SVN
*----
      IMVERS=4
      CALL KDRVER(REV,DATE)
      WRITE(IOUT,6000) NAMSBR,IMVERS,REV,DATE
      WRITE(IOUT,6010) NAMSBR
*----
*  EXECUTE THE CLE-2000 DRIVER
*----
      IPRINT= 0
      IER=KERNEL(NMODXT,CMODXT,KDRDRV,IPRINT)
      IF( IER .NE. 0 )THEN
         WRITE(IOUT,*) 'KERNEL ERROR CODE=',IER
         CALL XABORT('DRAGON: KERNEL ERROR')
      ENDIF
*----
*  ALL MODULES PROCESSED
*----
      WRITE(IOUT,6030) NAMSBR,IMVERS,REV
#if defined(MPI)
*----
*  MPI finalisation
*----
      CALL MPI_FINALIZE(IERROR)
#endif /* defined(MPI) */
      STOP
*----
*  FORMATS
*----
 6000 FORMAT(
     > ' DDDDDD   RRRRRR     AAA     GGGGG    OOOOO   NN     NN'/
     > ' DDDDDDD  RRRRRRR   AAAAA   GGGGGGG  OOOOOOO  NNN    NN'/
     > ' DD   DD  RR   RR  AA   AA  GG       OO   OO  NNNN   NN'/
     > ' DD   DD  RRRRRR   AA   AA  GG  GGG  OO   OO  NN NN  NN'/
     > ' DD   DD  RRRR     AAAAAAA  GG  GGG  OO   OO  NN  NN NN'/
     > ' DD   DD  RR RR    AAAAAAA  GG   GG  OO   OO  NN   NNNN'/
     > ' DDDDDDD  RR  RR   AA   AA  GGGGGGG  OOOOOOO  NN    NNN'/
     > ' DDDDDD   RR   RR  AA   AA   GGGGG    OOOOO   NN     NN'//
     > ' VERSION ',A6,I2,2X,A,4X,A/
     > ' GROUPE D''ANALYSE NUCLEAIRE'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL'///)
 6010 FORMAT(
     > ' COPYRIGHT NOTICE FOR THIS VERSION OF ',A6,':'/
     > ' --------------------------------------------'/
     > ' Copyright (C) 2002 Ecole Polytechnique de Montreal '/
     > ' This library is free software; you can redistribute it' /
     > ' and/or modify it under the terms of the GNU Lesser General' /
     > ' Public License as published by the Free Software Foundation;' /
     > ' either version 2.1 of the License, or (at your option) any' /
     > ' later version '////)
 6030 FORMAT(//1X,'NORMAL END OF EXECUTION FOR ',A6,I2,2X,A/
     >         1X,'CHECK FOR WARNING IN LISTING'/
     >         1x,'BEFORE ASSUMING YOUR RUN WAS SUCCESSFUL')
      END
