*DECK EDIDEP
      SUBROUTINE EDIDEP(IPRINT,IPLIB,IPEDIT,NBNISO,HNNRF,ILNRF,LISO,
     1           NBCH)
*
*-----------------------------------------------------------------------
*
*Purpose:
* create the 'DEPL-CHAIN' directory on the edition LCM object.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPRINT  print parameter
* IPLIB   pointer to the internal library LCM object
* IPEDIT  pointer to the edition LCM object
* NBNISO  number of available isotopes in the edition LCM object
* HNNRF   reference names of the available isotopes in the edition
*         LCM object
* ILNRF   selection flag of the available isotopes in the edition
*         LCM object (=1 if selected)
* LISO    =.true. if we want to register each isotope after merging
*
*Parameters: output
* NBCH    number of depleting nuclides after lumping
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPRINT,IPLIB,IPEDIT,NBNISO,HNNRF(3,NBNISO),ILNRF(NBNISO),
     1 NBCH
      LOGICAL LISO
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NSTATE=40,MAXBCH=500,MAXFAT=25)
      INTEGER ISTATE(NSTATE),HICH(3,MAXBCH)
      COMMON IBASE(1)
*----
*  FIND THE DEPLETING ISOTOPES IN THE EDITION MICROLIB
*----
      CALL LCMGET(IPLIB,'STATE-VECTOR',ISTATE)
      NBISO=ISTATE(1)
      NBFISS=ISTATE(2)
      NBDPF=ISTATE(3)
      NSUPS=ISTATE(7)
      NREAC=ISTATE(8)
      NFATH=ISTATE(9)
      CALL SETARA(IBASE,3*NBISO,IHISO)
      CALL LCMGET(IPLIB,'ISOTOPESDEPL',IBASE(IHISO))
*     WE HAVE TO REGISTER SEVERAL TIMES THE SAME ISOTOPE IN THE NEW
*     DEPL-CHAIN IF WE WANT IT TO DEPLETE
      NBCH=0
        DO 20 ISO=1,NBISO
        IOF=3*(ISO-1)+1
        DO JSO=1,NBNISO
          IF(ILNRF(JSO).EQ.0) CYCLE
          IF((IBASE(IHISO+IOF-1).EQ.HNNRF(1,JSO)).AND.
     &       (IBASE(IHISO+IOF).EQ.HNNRF(2,JSO))) THEN
            IF(LISO) THEN
              NBCH=NBCH+1
              IF(NBCH.GT.MAXBCH) CALL XABORT('EDIDEP: MAXBCH '
     &          // 'OVERFLOW(1).')
              HICH(1,NBCH)=IBASE(IHISO+IOF-1)
              HICH(2,NBCH)=IBASE(IHISO+IOF)
            ELSE
              GO TO 10
            ENDIF
          ENDIF
        ENDDO
        GO TO 20
   10   IF(.NOT.LISO) THEN
          NBCH=NBCH+1
          IF(NBCH.GT.MAXBCH) CALL XABORT('EDIDEP: MAXBCH OVERFLOW(2).')
          HICH(1,NBCH)=IBASE(IHISO+IOF-1)
          HICH(2,NBCH)=IBASE(IHISO+IOF)
        ENDIF
   20   CONTINUE
*----
*  GENERATE THE DEPLETION INFORMATION CORRESPONDING TO THE AVAILABLE
*  ISOTOPES
*----
      IF(NBCH.GT.0) THEN
         MAXFP=NBDPF+30 ! reserve 30 location for lumped fp daughters
         NBFPCH=NBCH
         CALL SETARA(IBASE,NBISO,IMYLIS)
         CALL SETARA(IBASE,2*NREAC,IHREAC)
         CALL SETARA(IBASE,NREAC*NBISO,IIDREA)
         CALL SETARA(IBASE,NREAC*NBISO,IDENER)
         CALL SETARA(IBASE,NBISO,IDDECA)
         CALL SETARA(IBASE,NFATH*NBISO,IIPREA)
         CALL SETARA(IBASE,NFATH*NBISO,IPRATE)
         CALL SETARA(IBASE,NBFISS*MAXFP,IYIELD)
         CALL LCMGET(IPLIB,'CHARGEWEIGHT',IBASE(IMYLIS))
         CALL LCMGET(IPLIB,'DEPLETE-IDEN',IBASE(IHREAC))
         CALL LCMGET(IPLIB,'DEPLETE-REAC',IBASE(IIDREA))
         CALL LCMGET(IPLIB,'DEPLETE-ENER',IBASE(IDENER))
         CALL LCMGET(IPLIB,'DEPLETE-DECA',IBASE(IDDECA))
         CALL LCMGET(IPLIB,'PRODUCE-REAC',IBASE(IIPREA))
         CALL LCMGET(IPLIB,'PRODUCE-RATE',IBASE(IPRATE))
         IF(NBFISS*NBDPF.GT.0) THEN
            CALL LCMGET(IPLIB,'FISSIONYIELD',IBASE(IYIELD))
         ENDIF
*
         CALL LCMSIX(IPEDIT,'DEPL-CHAIN',1)
         CALL SETARA(IBASE,MAXFAT*NBCH,IJPREA)
         CALL SETARA(IBASE,MAXFAT*NBCH,IRRATE)
         CALL SETARA(IBASE,NREAC*NBCH,IJDREA)
         CALL SETARA(IBASE,NREAC*NBCH,IEENER)
         IF(LISO) THEN
           NBFISS2=NBFPCH
           NBFPCH2=NBFPCH
         ELSE
           NBFISS2=NBFISS
           NBFPCH2=NBFPCH
         ENDIF
         CALL SETARA(IBASE,NBFISS2*NBFPCH2,IEYIEL)
         CALL SETARA(IBASE,NBCH*3,IIPOS)
         CALL SETARA(IBASE,3*NBCH,IHHHH)
         CALL SETARA(IBASE,NBCH,IDDDD)
         CALL EDILUM(IPRINT,IPEDIT,MAXFP,NBISO,NBFISS,NBDPF,NSUPS,
     &   NREAC,NFATH,NBCH,NBFPCH,HICH,IBASE(IHISO),IBASE(IMYLIS),
     &   IBASE(IHREAC),IBASE(IIDREA),IBASE(IDENER),IBASE(IDDECA),
     &   IBASE(IIPREA),IBASE(IPRATE),IBASE(IYIELD),IBASE(IJPREA),
     &   IBASE(IRRATE),IBASE(IJDREA),IBASE(IEENER),IBASE(IEYIEL),
     &   IBASE(IIPOS),IBASE(IHHHH),IBASE(IDDDD),LISO,NBFISS2,NBFPCH2)
         CALL RLSARA(IBASE(IDDDD))
         CALL RLSARA(IBASE(IHHHH))
         CALL RLSARA(IBASE(IIPOS))
         CALL RLSARA(IBASE(IEYIEL))
         CALL RLSARA(IBASE(IEENER))
         CALL RLSARA(IBASE(IJDREA))
         CALL RLSARA(IBASE(IRRATE))
         CALL RLSARA(IBASE(IJPREA))
         CALL LCMSIX(IPEDIT,' ',2)
*
         CALL RLSARA(IBASE(IYIELD))
         CALL RLSARA(IBASE(IPRATE))
         CALL RLSARA(IBASE(IIPREA))
         CALL RLSARA(IBASE(IDDECA))
         CALL RLSARA(IBASE(IDENER))
         CALL RLSARA(IBASE(IIDREA))
         CALL RLSARA(IBASE(IHREAC))
         CALL RLSARA(IBASE(IMYLIS))
      ENDIF
      CALL RLSARA(IBASE(IHISO))
      RETURN
      END
