*DECK EDIMRG
      SUBROUTINE EDIMRG(IPTRK ,IPMRG ,IPRINT,GEONAM,ITM   ,NREGIO,
     >                  NMERGE,IMERGE)
C
C---------------------------  EDIMRG  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIMRG
C      USE      : FIND MERGE VECTOR BY MIXTURES IN IPMRG
C                 WITH IPTRK
C      MODIFIED : 2001/10/30 (G.M)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS: 
C      IPTRK    : CALCULATION TRACKING DATA STRUCTURE    
C                 ***> INTEGER IPTRKI
C      IPMRG    : MERGE GEOMETRY (ITM=-1) OR 
C                 TRACKING (ITM=1) DATA STRUCTURE        I
C                 ***> INTEGER IPMRG
C      IPRINT   : PRINT LEVEL                     
C                 ***> INTEGER IPRINT
C     GEONAM : GEOMETRY NAME
C              ***> CHARACTER*12 GEONAM
C      ITM      : TYPE OF MERGE                          I
C                 ITM = -1 -> FROM SECOND GEOMETRY
C                 ITM = 0  -> FROM CALCULATION TRACKING
C                 ITM = 1  -> FROM SECOND TRACKING
C                 ***> INTEGER ITM
C      NREGIO   : NUMBER OF REGIONS                     
C                 ***> INTEGER NREGIO
C      NMERGE   : FINAL NUMBER OF MERGED REGIONS         
C                 ***> INTEGER NMERGE
C      IMERGE   : MERGED REGIONS POSITION                
C                 ***> INTEGER IMERGE(NREGIO)
C
C---------------------------   EDIMRG  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NSTATE=40,NAMSBR='EDIMRG')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPTRK
      INTEGER     IPMRG
      INTEGER     IPRINT
      CHARACTER   GEONAM*12
      INTEGER     ITM
      INTEGER     NREGIO
      INTEGER     NMERGE
      INTEGER     IMERGE(NREGIO)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
C----
C  FOR INTEGER VECTOR
C----
      INTEGER     KEYMRG,MATALB,MATMRG
      INTEGER     IMERT
C----
C  FOR REAL VECTOR
C----
      INTEGER     VOLSUR,VOLMRG
C----
C  LOCAL PARAMETERS
C---- 
      INTEGER     ISTATE(NSTATE)
      INTEGER     IPTRK2,IMODT2,IMEDT2,ICLST2,IPRIN2
      INTEGER     ITYPEG,ITGEO
      CHARACTER   NAMTR2*12
      CHARACTER   HSIGN*12
      INTEGER     KCHAR(18),ITCR
      INTEGER     NV,NS,NSOUT,NREG,NUNK,ICODE(6)
      REAL        EXTKOP(NSTATE)
      INTEGER     ITROP,MAXMIX,IREG,ISYMM
      INTEGER     IUEXP,KDROPN,KDRCLS,IRC
      INTEGER     ITYPM
      LOGICAL     LASS,LDRASS
C----
C  LOCAL NAME OF TEMPORARY TRACKING FILE
C  WHEN IPGEO IS PROVIDED
C----
      NAMTR2='EDIMRGIPTRK2'
      IMODT2=0
      IMEDT2=1
      IPRIN2=0
      ICLST2=2
      ITYPM=1
      IF(ITM .EQ. -1) THEN
        LASS=LDRASS(IPMRG,1,IPRINT)
        CALL LCMOP(IPTRK2,NAMTR2,IMODT2,IMEDT2,IPRIN2)
        HSIGN='L_TRACK     '
        READ(HSIGN,'(3A4)') (KCHAR(ITCR),ITCR=1,3)
        CALL LCMPUT(IPTRK2,'SIGNATURE   ',3,3,KCHAR)
        HSIGN='EXCELL      '
        READ(HSIGN,'(3A4)') (KCHAR(ITCR),ITCR=1,3)
        CALL LCMPUT(IPTRK2,'TRACK-TYPE  ',3,3,KCHAR)
C----
C  ANALYZE GEOMETRY
C----
        CALL XDISET(ISTATE,NSTATE,0)
        CALL LCMGET(IPMRG,'STATE-VECTOR',ISTATE)
        ITYPEG= ISTATE(1)
        IF(ITYPEG .EQ. 3 .OR. ITYPEG .EQ. 6 ) THEN
          ITGEO= 1
        ELSE IF(ITYPEG .EQ.  8 .OR. ITYPEG .EQ.  9 .OR.
     >          ITYPEG .EQ. 24 .OR. ITYPEG .EQ. 25      ) THEN
          ITGEO= 2
        ELSE IF(ITYPEG .EQ.  5 .OR. ITYPEG .EQ.  7 .OR.
     >          ITYPEG .EQ. 20 .OR. ITYPEG .EQ. 21 .OR.
     >          ITYPEG .EQ. 22 .OR. ITYPEG .EQ. 23      ) THEN
          ITGEO= 3
        ELSE
          ITGEO= 0
        ENDIF
        IF(ISTATE(13) .GE. 1) THEN
C----
C  CLUSTER GEOMETRY
C----     
          ISYMM=1
          CALL AXGXCW(IPMRG ,IPTRK2,IPRINT,GEONAM,ISYMM )
          ITROP=3
        ELSE IF(ITGEO .EQ. 2 ) THEN
C----
C  HEXAGONAL 2D GEOMETRIES
C----
C          CALL AXGXHX(IPMRG ,IPTRK2,IPRINT,GEONAM)
          ITROP=2
        ELSE IF(ITGEO .EQ. 3 ) THEN
C----
C  CARTESIAN 2D/3D ASSEMBLIES
C  CALL XELPRP TO GET GEOMETRY DIMENSIONING INFORMATION
C----
          CALL AXGXEL(IPMRG ,IPTRK2,IPRINT,GEONAM)
          ITROP=1
        ELSE
          CALL XABORT(NAMSBR//': INVALID TYPE OF GEOMETRY')
        ENDIF
        CALL LCMGET(IPTRK2,'ICODE       ',ICODE)
        CALL LCMSIX(IPTRK2,'EXCELL      ',1)
        CALL XDISET(ISTATE,NSTATE,0)
        CALL LCMGET(IPTRK2,'STATE-VECTOR',ISTATE) 
        NV=ISTATE(3)
        NS=ISTATE(2)
        NUNK=NV+NS+1
        CALL SETARA(IBASE,NUNK,KEYMRG)
        CALL SETARA(IBASE,NUNK,MATALB)
        CALL SETARA(RBASE,NUNK,VOLSUR)
        CALL LCMGET(IPTRK2,'KEYMRG      ',IBASE(KEYMRG))
        CALL LCMGET(IPTRK2,'MATALB      ',IBASE(MATALB))
        CALL LCMGET(IPTRK2,'VOLSUR      ',RBASE(VOLSUR))
        CALL LCMSIX(IPTRK2,'EXCELL      ',2)
        CALL SETARA(IBASE,NUNK,MATMRG)
        CALL SETARA(RBASE,NUNK,VOLMRG)
        CALL XELCMP(NS    ,NV    ,
     >              RBASE(VOLSUR),IBASE(MATALB),IBASE(KEYMRG),
     >              NSOUT ,NREG  ,
     >              RBASE(VOLMRG),IBASE(MATMRG),
     >              ITGEO ,ICODE )
        MAXMIX=0
        DO 100 IREG=1,NREG
          IBASE(KEYMRG+IREG+NSOUT)= IREG
          MAXMIX=MAX(MAXMIX,IBASE(MATMRG+IREG+NSOUT))
 100    CONTINUE
        CALL LCMPUT(IPTRK2,'MATCOD',NREG,1,IBASE(MATMRG+NSOUT+1))
        CALL LCMPUT(IPTRK2,'VOLUME',NREG,2,RBASE(VOLMRG+NSOUT+1))
        CALL LCMPUT(IPTRK2,'KEYFLX',NREG,1,IBASE(KEYMRG+NSOUT+1))
        CALL XDRSET(EXTKOP,NSTATE,0.0)
        CALL LCMPUT(IPTRK2,'EXCELTRACKOP',NSTATE,2,EXTKOP)
        CALL XDISET(ISTATE,NSTATE,0)
        ISTATE(1)=NREG
        ISTATE(2)=NREG
        ISTATE(4)=MAXMIX
        ISTATE(5)=NSOUT
        ISTATE(7)=ITROP
        ISTATE(8)=-1
        CALL LCMPUT(IPTRK2,'STATE-VECTOR',NSTATE,1,ISTATE)
        CALL RLSARA(RBASE(VOLMRG))
        CALL RLSARA(IBASE(MATMRG))
        CALL RLSARA(RBASE(VOLSUR))
        CALL RLSARA(IBASE(MATALB))
        CALL RLSARA(IBASE(KEYMRG))
C----
C  IF IPRINT >= 10
C  EXPORT TEMPORARY TRACKING FILE
C----
        IF(IPRINT .GE. 10) THEN 
          IUEXP=KDROPN('EDIMRGEXP',0,3,0,0)
          CALL LCMEXP(IPTRK2,IPRINT,IUEXP,2,1)
          IRC=KDRCLS(IUEXP,1)
        ENDIF
      ELSE
        IPTRK2=IPMRG
      ENDIF
C----
C  DESTROY TEMPORARY TRACKING FILE 
C  WHEN IPGEO IS PROVIDED
C----
      CALL SETARA(IBASE,NREGIO+1,IMERT)      
      CALL XDISET(IBASE(IMERT),NREGIO+1,1)      
      CALL MRGTRK(IPTRK ,IPTRK2,IPRINT,ITYPM ,NREGIO,
     >            IBASE(IMERT))
      NMERGE=0
      DO 110 IREG=1,NREGIO
        IMERGE(IREG)=IBASE(IMERT+IREG)
        NMERGE=MAX(NMERGE,IMERGE(IREG))      
 110  CONTINUE 
      CALL RLSARA(IBASE(IMERT))      
      IF(ITM .EQ. -1) THEN
        CALL LCMCL(IPTRK2,ICLST2)
      ENDIF
      RETURN
C----
C  WARNING FORMAT
C----
      END
