*DECK EPCRMT
      SUBROUTINE EPCRMT(ISEED,NGR,NCV,IXS,ICOV,COV,NRN,DRVAR)
*-----------------------------------------------------------------------
*
*Purpose:
* Generates a random number for every subset of correlated
* groups used
*
*INPUT:
*  - ISEED: Seed for generating random numbers with RANDDN
*  - NGR  : Number of groups used
*  - NCV  : maximum dimension of covar matrix
*  - IXS  : Cross section type identifier
*  - COV  : Reduced covariance and variance matrix
*  - ICOV : Auxiliary matrix for the exploration of COV
*OUTPUT:
*  - NRN  : Number of random numbers generated (number of subsets)
*  - DRVAR: Generated random numbers, following a normal distribution
*-----------------------------------------------------------------------
*
      IMPLICIT         NONE
*----
*  Subroutine arguments
*----
      INTEGER          NGR,NCV,IXS,ISEED,ICOV(NGR,IXS),NRN
      REAL             COV(NCV,IXS)
      DOUBLE PRECISION DRVAR(NGR,IXS)
*----
*  Local variables
*----
      INTEGER          I,J,ILOC
      DOUBLE PRECISION TMP !just in case 
*----
*  Tests
*----
      NRN=0
      ILOC=1
      DO I=1,NGR
       IF ((I.EQ.1).OR.(ABS(1-COV(ILOC+1,IXS)).GT..01)) THEN       ! 1% tolerance
         CALL RANDDN(ISEED,1,DRVAR(I,IXS))
         NRN=NRN+1
       ELSE
         DRVAR(I,IXS)=DRVAR(I-1,IXS)
       ENDIF
       ILOC=ILOC+ICOV(I,IXS)
      ENDDO
      
*----
*  End of subroutine
*----
      RETURN
      END 