*DECK LHXUNH
      SUBROUTINE LHXUNH(IPTRK,IPGEOM,
     +              GEONAM,LEVEL,IPRT,MESH,NCELA,IPLANZ,NCPHY,
     +              ICODE,ZCODE,MVOSU,NREGIO,ISURF,SIDE,ISTATE,NSMIN,
     +              NSMAX,MVOLUM,IHEX,LX,MCODE,IPLANI,VLAT,ID)
C
C
C-------------------------- LHXUNH -------------------------------------
C
C                FUNCTION : LECTURE ET ANALYSE DE LA GEOMETRIE SUR LCM
C                REVISED  : JUNE 13-1991
C                AUTHOR   : M. OUISLOUMEN
C
C  INPUT PARAMETERS
C
C     GEONAM  :  NOM DE LA GEOMETRIE SUR LCM
C     LEVEL   :  NIVEAU HIERARCHIQUE
C     IPRT    :  NIVEAU D'IMPRESSION
C
C  OUTPUT PARAMETERS
C
C      MESH   : DIMENSION DU VECTEUR REMESH (VOIR ROUTINE TRKHEX)
C      NCELA  : NOMBRE DE CELLULES DANS L'ASSEMBLAGE APRES DUPLICATION
C      IPLANZ : NOMBRE DE PLANS SUIVANT L'AXE Z
C      NCPHY  : NOMBRE DE CELLULES PHYSIQUE
C      ICODE  : CONTIENT LES INDEX DES ALBEDOS PHYSIQUES
C      ZCODE  : CONTIENT LES ALBEDOS GEOMETRIQUES
C      NREGIO : NOMBRE DE REGION PHYSIQUE
C       MVOSU : DIMENSION DE VOLSUR(VOIR MESHST)
C       MCODE : =1 SI NCODE(5)=5 ,=2 SI NCODE(6)=5 ,=0 SI NON
C       ID    : VECTEUR UTILISEE DANS LA ROUTINE MESHST
C
C
C------------------------ LHXUNH ---------------------------------------
C
      PARAMETER(NLCM=25,NSTATE=40,NIXS=9,NIST=2)
      INTEGER  LNLCM(NLCM),INVLCM(NIXS),INVSTA(NIST),ISTATE(NSTATE),
     +         NCODE(6),ICODE(6),JCODE(6),ISTOR(8),VLAT(*),ID(*)
      REAL     ZCODE(6)
      LOGICAL  L1CELL,LGMERG,LGTURN,LSPLIT,LGCELL,LGSYM,LGSIDE,LGPASS
      LOGICAL  LMERG1,LTURN1
      CHARACTER LCMNM(NLCM)*12,GEONAM*12,TEXT12*12
C----
C  MEMORY ALLOCATION COMMON
C----
      INTEGER     IBASE(1)
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     IOFZD
      SAVE /SURLA/
      COMMON /SURLA/ ISUR
      DATA INVLCM,INVSTA /2,3,7,8,12,15,16,17,18,4,13/
      DATA ISTOR /12,6,6,4,3,2,2,2/
      DATA LCMNM /   'MIX',  'MESHX',  'MESHY',  'MESHZ', 'RADIUS',
     >              'SIDE', 'SPLITX', 'SPLITY', 'SPLITZ', 'SPLITR',
     >              'CELL',  'COORD',  'MERGE',   'TURN', 'CLUSTER',
     >              'NPIN',   'RPIN',   'APIN',  'BIHET', 'POURCE',
     >            'PROCEL',   'IHEX',  'NCODE',  'ZCODE', 'ICODE'/
C
      IFCOUR(N)=NINT( (4.+SQRT(1.+4.*FLOAT(N-1)/3.)
     +                 +SQRT(1.+4.*FLOAT(N-2)/3.))*.25)
      IFONC(N,L)= 2+(N-1)*(L+3*(N-2))
C
      LGSYM=.FALSE.
      LGMERG=.FALSE.
      LGTURN=.FALSE.
      L1CELL=.FALSE.
      LSPLIT=.FALSE.
      LGCELL=.FALSE.
      MCODE=0
      NRAY=0
      KRAY=0
C
C         LECTURE DES DIFFERENTS BLOCS SUR LCM
C
      DO 10 I=1,NLCM
         CALL LCMLEN(IPGEOM,LCMNM(I),LNLCM(I),ITP)
   10 CONTINUE
C
C        ELEMINATES OPTIONS NOT CHECKED BY THIS ROUTINE
C
      DO 20 I=1,NIXS
         IF(LNLCM(INVLCM(I)).NE.0)
     +           CALL XABORT('LHXUNH : '//GEONAM//' WAS NOT UNFOLDED ')
   20 CONTINUE
C
      CALL LCMLEN(IPGEOM,'STATE-VECTOR',ILEN,ITP)
      IF(ITP.NE.1.OR.ILEN.NE.NSTATE)
     +  CALL XABORT('LHXUNH : INVALID STATE VECTOR ')
      CALL XDRSET(ISTATE,NSTATE,0)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
C
C         ELEMINATES THE INVALID OPTIONS
C
      DO 30 IST=1, NIST
         IF(ISTATE(INVSTA(IST)).NE.0)
     +        CALL XABORT('LHXUNH : '//GEONAM//'WAS NOT UNFOLDED')
   30 CONTINUE
      ITYPE=ISTATE(1)
      LX=ISTATE(3)
      LZ=ISTATE(5)
      LZZ=LZ
      LREG=ISTATE(6)
      ISTAT9=ISTATE(9)
      IF(ISTATE(8).EQ.1)LGCELL=.TRUE.
      IF(ISTATE(10).EQ.1)LGMERG=.TRUE.
      IF(ISTATE(11).EQ.1)LSPLIT=.TRUE.
      NDIM=2
      NCEL=LX
      IPLANZ=1
      IF(LZ.NE.0) THEN
        NCEL=LX*LZ
        NDIM=3
        NCELP=LX
        IPLANZ=LZ
      ENDIF
      IF(LX.EQ.1)L1CELL=.TRUE.
      IF(LGCELL)THEN
        IF(L1CELL) THEN
        IF(ITYPE.NE.8.AND.ITYPE.NE.9.AND.ITYPE.NE.24.AND.ITYPE.NE.25)
     +     CALL XABORT('LHXUNH : INVALID TYPE OF GEOMETRY')
        ELSE
        IF(ITYPE.NE.8.AND.ITYPE.NE.9)
     +     CALL XABORT('LHXUNH : INVALID TYPE OF GEOMETRY')
        ENDIF
      ELSE
        IF(ITYPE.NE.8.AND.ITYPE.NE.9.AND.ITYPE.NE.24.AND.ITYPE.NE.25)
     +     CALL XABORT('LHXUNH : INVALID TYPE OF GEOMETRY')
      ENDIF
C
C         RECOVERS BOUDARY CONDITIONS
C
      CALL LCMGET(IPGEOM,'NCODE',NCODE)
      CALL LCMGET(IPGEOM,'ZCODE',ZCODE)
      CALL LCMGET(IPGEOM,'ICODE',JCODE)
      DO 35 I=1,6
        IF( JCODE(I).GT.0 )THEN
           ICODE(I)= JCODE(I)
        ELSE
           ICODE(I)= -I
        ENDIF
        IF( NCODE(I).EQ.0 )THEN
           IF( NDIM.EQ.3.AND.(I.EQ.5.OR.I.EQ.6) )THEN
              CALL XABORT('LHXUNH : A BOUNDARY CONDITION IS MISSING')
           ENDIF
           IF( I.EQ.1 )THEN
              CALL XABORT('LHXUNH : A BOUNDARY CONDITION IS MISSING')
           ENDIF
           ICODE(I)= 0
        ENDIF
   35 CONTINUE
C
C       ELEMINATIONS DES OPTIONS IMCOMPATIBLES
C
      DO 40 I=1,6
         IF(NCODE(I).EQ.4.OR.NCODE(I).EQ.7.OR.NCODE(I).EQ.3 .OR.
     +      (NDIM.EQ.2.AND.NCODE(I).EQ.5) .OR.
     +      (NDIM.EQ.2.AND.NCODE(I).EQ.10) )
     +      CALL XABORT('LHXUNH : INVALID BOUNDARY CONDITION ')
         IF((NCODE(5) .EQ. 5 .OR. NCODE(5) .EQ. 10) .AND.
     +      (NCODE(6) .EQ. 5 .OR. NCODE(6) .EQ. 10)) CALL XABORT(
     +      'LHXUNH: UNE SEULE SYMETRIE SELON Z EST VALABLE')
         IF(NCODE(5) .EQ. 5 .OR. NCODE(5) .EQ. 10 ) THEN
           ZCODE(5)=ZCODE(6)
           ICODE(5)=ICODE(6)
         ELSEIF(NCODE(6) .EQ.5 .OR. NCODE(6) .EQ. 10) THEN
           ZCODE(6)=ZCODE(5)
           ICODE(6)=ICODE(5)
         ENDIF
   40 CONTINUE
      IF(L1CELL) THEN
C
C           CAS D'UNE SEULE CELLULE
C
         IF(NCODE(5) .EQ. 5 .OR. NCODE(5) .EQ. 10 .OR.
     >      NCODE(6) .EQ. 5 .OR. NCODE(6) .EQ. 10 ) CALL XABORT(
     +    'LHXUNH: THE B.C. SYME FOR ONE CELL IS NOT PERMITTED ')
        IF(LGCELL) THEN
          CALL LCMLEN(IPGEOM,'CELL',ILEN,ITP)
          IF(ILEN.NE.3*ISTAT9.OR.ITP.NE.3) CALL XABORT('LHXUNH: '
     +                 //'MISSING DIMENSION OR TYPE OF CELL ')
          CALL SETARA(IBASE,3*ISTAT9,JCEL)
          CALL LCMGET(IPGEOM,'CELL',IBASE(JCEL))
          WRITE(TEXT12,'(3A4)') (IBASE(ITC),ITC=JCEL,JCEL+2)
          CALL LCMLEN(IPGEOM,TEXT12,ILEN,ITP)
          IF(ILEN.NE.-1.OR.ITP.NE.0) CALL XABORT('LHXUNH: '
     +                 //'INVALID CELL DATA ')
          CALL LCMSIX(IPGEOM,TEXT12,1)
        ENDIF
        CALL LCMLEN(IPGEOM,'SIDE',ISIDE,ITS)
        IF(ISIDE.EQ.0) CALL XABORT('LHXUNH: SIDE DID NOT FOUND')
        IF(ITS.NE.2) CALL XABORT('LHXUNH: SIDE MUST BE REAL')
        CALL LCMGET(IPGEOM,'SIDE',SIDE)
        CALL LCMLEN(IPGEOM,'RADIUS',ILENR,ITPR)
        CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITPS)
        IXX=1
        IF(ILENR.GT.0) IXX=ILENR
        CALL SETARA(IBASE,IXX,ISECT)
        IF(ILENS.GT.0) THEN
          IF(ILENS.NE.IXX)
     +           CALL XABORT('LHXUNH: INVALID SECTOR DIMENSION(1)')
          CALL LCMGET(IPGEOM,'SECTOR',IBASE(ISECT))
        ELSE
          CALL XDISET(IBASE(ISECT),IXX,1)
        ENDIF
        IF(ILENR.GT.0) THEN
          IF(ITPR.NE.2)CALL XABORT('LHXUNH: RADIUS MUST BE REAL')
          CALL LCMLEN(IPGEOM,'SPLITR',ILENSP,ITPS)
          NRAY=ILENR-1
          IF(ILENSP.GT.0) THEN
            IF(ILENSP.NE.NRAY)
     +        CALL XABORT('LHXUNH: INVALID SPLITR DIMENSION')
            IF(ITPS.NE.1) CALL XABORT('LHXUNH: SPLITR MUST BE INTEGER')
            CALL SETARA(IBASE,ILENSP,ISP)
            CALL LCMGET(IPGEOM,'SPLITR',IBASE(ISP))
            NRAY=0
            DO 36 J=0,ILENSP-1
               NRAY=NRAY+ABS(IBASE(ISP+J))
   36       CONTINUE
            IF(ILENS.GT.0) THEN
               CALL SETARA(IBASE,NRAY+1,LSECT)
               MADD=-1
               DO 336 J=0,ILENR-2
               KSECT=IBASE(ISECT+J)
               DO 336 ISPS=1,IBASE(ISP+J)
                 MADD=MADD+1
                 IBASE(LSECT+MADD)=KSECT
  336          CONTINUE
               IBASE(LSECT+NRAY)=IBASE(ISECT+ILENR-1)
               CALL RLSARA(IBASE(ISECT))
               ISECT=LSECT
            ENDIF
            CALL RLSARA(IBASE(ISP))
          ENDIF
        ENDIF
C
        ISURF=6
        MVOSU=0
        DO 39 K=0,NRAY
           KSECT=IBASE(ISECT+K)
           IF(KSECT.GT.1) THEN
             MVOSU=MVOSU+6*(KSECT-1)
           ELSE
             MVOSU=MVOSU+1
           ENDIF
   39   CONTINUE
        CALL RLSARA(IBASE(ISECT))
        IF(KSECT.GT.1) ISURF=6*(KSECT-1)
        MVOLUM=1+NRAY
        IF(NDIM.EQ.2) THEN
          NCELA=1
          NCPHY=1
          MESH=2+NRAY
          NREGIO=MVOSU
        ELSEIF(NDIM.EQ.3) THEN
          CALL LCMLEN(IPGEOM,'MESHZ',LZ,ITZ)
          IF(LZ.EQ.0) CALL XABORT('LHXUNH: MESHZ DID NOT FOUND')
          IF(LZ.NE.2) CALL XABORT('LHXUNH: MISSING DIMENSION OF MESHZ')
          IF(ITZ.NE.2)CALL XABORT('LHXUNH: MESHZ MUST BE REAL')
          CALL SETARA(RBASE,LZ,IZZ)
          CALL LCMGET(IPGEOM,'MESHZ',RBASE(IZZ))
          IF(RBASE(IZZ).NE.0.)
     >      CALLXABORT('LHXUNH: FIRST MESHZ MUST BE 0')
          CALL LCMLEN(IPGEOM,'SPLITZ',LSZ,ITSZ)
          MZ=LZ
          MZZ=IZZ
          IF(LSZ.GT.0) THEN
           MZ=LZ-1
           MZZ=IZZ+1
           IF(ITSZ.NE.1)CALL XABORT('LHXUNH: SPLITZ MUST BE INTEGER')
          IF(LSZ.NE.LZ-1)CALLXABORT('LHXUNH: INVALID SPLITZ DIMENSION')
           CALL SETARA(IBASE,LSZ,ISZ)
           CALL LCMGET(IPGEOM,'SPLITZ',IBASE(ISZ))
           CALL LCMSIX(IPTRK,'DATA DUP',1)
           CALL LCMPUT(IPTRK,'SPLITZD',LSZ,1,IBASE(ISZ))
           CALL LCMSIX(IPTRK,' ',2)
           MZ=IBASE(ISZ)+1
           CALL SETARA(RBASE,MZ,MZZ)
           Z=RBASE(IZZ+1)-RBASE(IZZ)
           KSP=IBASE(ISZ)
           PAS=Z/FLOAT(KSP)
           DO 38 K=0,KSP
              RBASE(MZZ+K)=PAS*FLOAT(K)+RBASE(IZZ)
   38      CONTINUE
           CALL RLSARA(IBASE(ISZ))
           CALL RLSARA(RBASE(IZZ))
          ENDIF
          CALL LCMSIX(IPTRK,'DATA DUP',1)
          CALL LCMPUT(IPTRK,'MESHZ',MZ,2,RBASE(MZZ))
          CALL LCMSIX(IPTRK,' ',2)
          CALL RLSARA(RBASE(MZZ))
          IPLANZ=MZ-1
          ISTATE(5)=IPLANZ
          NCELA=MZ-1
          ISURF=NCELA*ISURF
          NCPHY=MZ-1
          MESH=NCELA*(3+NRAY)
          NSMIN=MVOSU
          NSMAX=MVOSU
          MVOSU=NCELA*MVOSU
          MVOLUM=NCELA*MVOLUM
          NREGIO=MVOSU
        ENDIF
        NCOUR=1
        ISURF=ISURF+NSMIN+NSMAX
        RETURN
      ENDIF
C
C        TYPE DE LA SYMETRIE CONSIDEREE
C
   41 CALL LCMLEN(IPGEOM,'IHEX',ILEN,ITP)
      IF(ITP.NE.1.OR.ILEN.NE.1)CALL XABORT('LHXUNH: TYPE OF '//
     +   'SYMETRIE MUST BE INTEGER')
      CALL LCMGET(IPGEOM,'IHEX',IHEX)
      IF(IHEX.LT.1.OR.IHEX.GT.9) CALL XABORT('LHXUNH: INVALID TYPE OF '
     +   //'SYMETRIE')
      IF(NDIM.EQ.2) THEN
C
C           TRAITEMENT DE LA GEOMETRIE EN 2D
C
        NCELA=NCEL
        NCELAP=NCEL
C
C             DUPLICATION DE LA SYMETRIE CONSIDEREE
C
        IF(IHEX.LT.9) THEN
          CALL SETARA(IBASE,ISTOR(IHEX)*NCEL,IBB)
          CALL DEPLIT(IHEX,NCEL,NCELA,IBASE(IBB))
          NCELAP=NCELA
        ELSE
          CALL SETARA(IBASE,NCEL,IBB)
          DO 137 I=0,NCEL-1
               IBASE(IBB+I)=I+1
  137     CONTINUE
        ENDIF
          CALL LCMLEN(IPGEOM,'MIX',ILENX,ITPX)
          IF(ILENX.NE.NCEL.OR.ITPX.NE.1) THEN
            CALL XABORT('LHXUNH: MISSING TYPE OR DIMENSION OF MIX')
          ENDIF
          NBASE=NCEL+NCELA
          CALL LCMLEN(IPGEOM,'TURN',ILENT,ITP)
          IF(ILENT.GT.0) THEN
            IF(ILENT.NE.NCEL)CALL XABORT('LHXUNH: EXPECTED DIMENSION'//
     +      'OF TURN')
            IF(ITP.NE.1)CALL XABORT('LHXUNH: EXPECTED VALUE IN TURN ')
            LGTURN=.TRUE.
          ENDIF
          NBASE=NBASE*2
          NBASE=NBASE+NCEL+NCELA
          CALL SETARA(IBASE,NBASE,ICC)
          NBB=2*NCEL
          IF(LGCELL) THEN
            CALL LCMGET(IPGEOM,'MIX',IBASE(ICC))
            ICMAX=-1
            DO 147 IGX=0,NCEL-1
              IBASE(ICC+IGX)=-IBASE(ICC+IGX)
              ICMAX=MAX(ICMAX,IBASE(ICC+IGX))
  147       CONTINUE
            IF(ISTAT9.GT.ICMAX)CALL XABORT('LHXUNH: THERE ARE DEFINED'
     +          //' CELLS NOT USED IN THE ASSEMBLY')
          ELSE
            CALL LCMGET(IPGEOM,'MIX',IBASE(ICC))
          ENDIF
          IF(LGMERG) THEN
            CALL LCMLEN(IPGEOM,'MERGE',IAUXN,ITAUX)
            IF(IAUXN.NE.NCEL.OR.ITAUX.NE.1)CALL XABORT('LHXUNH: DIMEN'
     +         //'SION OR TYPE OF MERGE INVALID')
            CALL LCMGET(IPGEOM,'MERGE',IBASE(ICC+NCEL))
            NCPHY=0
            DO 42 I=1,NCEL
              NCPHY=MAX(NCPHY,IBASE(ICC+NCEL+I-1))
   42       CONTINUE
          ELSE
             DO 146 I=0,NCEL-1
               IBASE(ICC+NCEL+I)=IBASE(ICC+I)
  146        CONTINUE
            LGMERG=.TRUE.
            NCPHY=NCEL
          ENDIF
          IF(LGTURN) THEN
            CALL LCMLEN(IPGEOM,'TURN',IAUXN,ITAUX)
            IF(IAUXN.NE.NCEL.OR.ITAUX.NE.1)CALL XABORT('LHXUNH: DIMEN'
     +         //'SION OR TYPE OF TURN INVALID')
            CALL LCMGET(IPGEOM,'TURN',IBASE(ICC+NBB))
          ELSE
            LGTURN=.TRUE.
            DO 777 ITT=0,NCEL-1
              IBASE(ICC+NBB+ITT)=1
  777       CONTINUE
          ENDIF
          NBB=NBB+NCEL
C
C            DUPLICATION DE MERGE ET MIX
C
           DO 47 I=0,NCELA-1
            IBASE(ICC+NBB+I)=IBASE(ICC+IBASE(IBB+I)-1)
            IBASE(ICC+NBB+NCELA+I)=IBASE(ICC+IBASE(IBB+I)+NCEL-1)
   47      CONTINUE
C
C            CAS OU SIDE EST ENTREE UNE SEULE FOIS
C
          LGSIDE=.TRUE.
          CALL LCMLEN(IPGEOM,'SIDE',ISIDE,IT)
          IF(ISIDE.GT.0) THEN
            CALL LCMGET(IPGEOM,'SIDE',SIDE)
            LGSIDE=.FALSE.
          ELSEIF(.NOT.LGCELL) THEN
            CALL XABORT('LHXUNH: SIDE DID NOT FOUND ')
          ENDIF
C
C            EVALUATION DE MESH
C
          MESH=2*NCELA
          NCOUR=1
          IF(NCELAP.GT.1)NCOUR=IFCOUR(NCELAP)
          ICELC0= IFONC(NCOUR,0)
          ICELC1= IFONC(NCOUR,1)-ICELC0
          IF(LGCELL) THEN
            CALL SETARA(IBASE,2*ISTAT9,JNR)
            CALL SETARA(IBASE,3*ISTAT9,JCEL)
            CALL LCMGET(IPGEOM,'CELL',IBASE(JCEL))
            NREGIO=0
            DO 48 I=1,ISTAT9
              IRTC=JCEL+3*I-3
              WRITE(TEXT12,'(3A4)') (IBASE(ITC),ITC=IRTC,IRTC+2)
               CALL LCMSIX(IPGEOM,TEXT12,1)
               CALL LCMLEN(IPGEOM,'RADIUS',ILENR,ITP)
               CALL LCMLEN(IPGEOM,'SPLITR',ILENSP,ITP)
               IF(LGSIDE) THEN
                 CALL LCMLEN(IPGEOM,'SIDE',ISIDE,IT)
                 IF(ISIDE.EQ.0)CALL XABORT('LHXUNH: SIDE DID NOT FOUND')
                 CALL LCMGET(IPGEOM,'SIDE',SSIDE)
                 IF(I.GT.1) THEN
               IF(SSIDE.NE.SIDE)CALL XABORT('LHXUNH: INCOMPATIBLE SIDE')
                 ENDIF
                 SIDE=SSIDE
               ENDIF
               NRAY=ILENR
               IF(ILENR.GT.0)NRAY=ILENR-1
               IF(ILENSP.GT.0) THEN
                 CALL SETARA(IBASE,ILENSP,JSS)
                 CALL LCMGET(IPGEOM,'SPLITR',IBASE(JSS))
                 NRAY=0
                 DO 46 J=0,ILENSP-1
                   NRAY=NRAY+ABS(IBASE(JSS+J))
   46            CONTINUE
                 CALL RLSARA(IBASE(JSS))
               ENDIF
               IBASE(JNR+I-1)=NRAY
               CALL SETARA(IBASE,NRAY+1,IBASE(JNR+ISTAT9+I-1))
               CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITPS)
               ILOCR=IBASE(JNR+ISTAT9+I-1)
               IF(ILENS.GT.0) THEN
                 IF(ILENS.NE.NRAY+1)
     +                CALL XABORT('LHXUNH: INVALID SECTOR DIMENSION(2)')
                 CALL LCMGET(IPGEOM,'SECTOR',IBASE(ILOCR))
               ELSE
                 CALL XDISET(IBASE(ILOCR),NRAY+1,1)
                 NREGIO=NREGIO+1+NRAY
                 GOTO 430
               ENDIF
               DO 43 K=0,NRAY
                 KSECT=IBASE(IBASE(JNR+ISTAT9+I-1)+K)
                 IF(KSECT.GT.1) THEN
                   NREGIO=NREGIO+6*(KSECT-1)
                 ELSE
                   NREGIO=NREGIO+1
                 ENDIF
   43          CONTINUE
  430          CONTINUE
               CALL LCMSIX(IPGEOM,' ',2)
   48       CONTINUE
            CALL RLSARA(IBASE(JCEL))
            NRAY=0
            MVOSU=0
            MVOLUM=0
            ISURF=0
            DO 49 I=0,NCELA-1
               KRAY=IBASE(JNR+IBASE(ICC+NBB+I)-1)
               NRAY=NRAY+KRAY
               DO 490 JR=0,KRAY
                 KSECT=IBASE(IBASE(JNR+ISTAT9+IBASE(ICC+NBB+I)-1)+JR)
                 IF(KSECT.GT.1) THEN
                   MVOSU=MVOSU+6*(KSECT-1)
                 ELSE
                   MVOSU=MVOSU+1
                 ENDIF
  490          CONTINUE
               I1=I+1
               IF(I1.GE.ICELC0) THEN
                 IF(KSECT.GT.1) THEN
                   ISURF=ISURF+2*(KSECT-1)
                   IF(MOD(I1-ICELC0,ICELC1).EQ.0) ISURF=ISURF+KSECT-1
                 ELSE
                   ISURF=ISURF+2
                   IF(MOD(I1-ICELC0,ICELC1).EQ.0) ISURF=ISURF+1
                 ENDIF
               ENDIF
               MVOLUM=MVOLUM+KRAY+1
   49       CONTINUE
            MESH=NRAY+MESH
            DO 495 I=0,ISTAT9-1
               CALL RLSARA(IBASE(IBASE(JNR+ISTAT9+I)))
  495       CONTINUE
            CALL RLSARA(IBASE(JNR))
          ELSE
            CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITP)
            NREGIO=NCPHY
            MVOSU=NCELA
            MVOLUM=NCELA
            CALL SETARA(IBASE,NCEL,IXX)
            IF(ILENS.GT.0) THEN
              IF(ILENS.NE.NCEL)
     +               CALL XABORT('LHXUNH: INVALID SECTOR DIMENSION(3)')
              CALL LCMGET(IPGEOM,'SECTOR',IBASE(IXX))
            ELSE
              CALL XDISET(IBASE(IXX),NCEL,1)
            ENDIF
            ILESS=0
            NREGIO=0
            DO 50 L=0,ILENS-1
               MCEL=IBASE(ICC+L)
               IF(MCEL.GT.ILESS) THEN
                 ILESS=MCEL
                 KSECT=IBASE(IXX+L)
                 IF(KSECT.GT.1) THEN
                   NREGIO=NREGIO+6*(KSECT-1)
                 ELSE
                   NREGIO=NREGIO+1
                 ENDIF
               ENDIF
   50       CONTINUE
            MVOSU=0
            ISURF=0
            DO 51 I=1,NCELA
               KSECT=IBASE(IXX+IBASE(ICC+NBB+I-1)-1)
               IF(KSECT.GT.1) THEN
                 MVOSU=MVOSU+6*(KSECT-1)
                 IF(I.GE.ICELC0) THEN
                   ISURF=ISURF+2*(KSECT-1)
                   IF(MOD(I-ICELC0,ICELC1).EQ.0) ISURF=ISURF+KSECT-1
                 ENDIF
               ELSE
                 MVOSU=MVOSU+1
                 IF(I.GE.ICELC0) THEN
                   ISURF=ISURF+2
                   IF(MOD(I-ICELC0,ICELC1).EQ.0) ISURF=ISURF+1
                 ENDIF
               ENDIF
   51       CONTINUE
            CALL RLSARA(IBASE(IXX))
          ENDIF
C
C             DUPLICATION DE TURN
C
          MBB=2*NCELA
          IF(LGTURN) THEN
           IF (IHEX.LT.9) THEN
            CALL SETARA(IBASE,3*NCEL,IDD)
            CALL DUTURN(IHEX,IBASE(ICC+NBB-NCEL),NCEL,IBASE(ICC+NBB+MBB)
     +                  ,NCELA,IBASE(IBB),IBASE(IDD),IBASE(IDD+NCEL)
     +                  ,IBASE(IDD+2*NCEL))
            CALL RLSARA(IBASE(IDD))
           ELSE
            DO 187 I=0,NCELA-1
               IBASE(ICC+NBB+MBB+I)=IBASE(ICC+NBB-NCEL+I)
  187       CONTINUE
           ENDIF
          ENDIF
C
C             RESTORAGE DES DONNEES
C
          CALL LCMSIX(IPTRK,'DATA DUP',1)
C
C--- CE VECTEUR EST UTILE DANS LA ROUTINE MESHST
          CALL LCMPUT(IPTRK,'GENER0',NCELA,1,IBASE(IBB))
          IF(LGCELL) THEN
            CALL LCMPUT(IPTRK,'GENERATING',NCELA,1,IBASE(ICC+NBB))
          ELSE
            CALL LCMPUT(IPTRK,'MIX',NCELA,1,IBASE(ICC+NBB))
          ENDIF
          IF(LGMERG)
     +   CALL LCMPUT(IPTRK,'MERGE',NCELA,1,IBASE(ICC+NCELA+NBB))
         IF(LGTURN)
     +   CALL LCMPUT(IPTRK,'TURN',NCELA,1,IBASE(ICC+NBB+MBB))
          CALL LCMSIX(IPTRK,' ',2)
          CALL RLSARA(IBASE(IBB))
          CALL RLSARA(IBASE(ICC))
C
      ELSEIF(NDIM.EQ.3) THEN
C
C         TRAITEMENT DU CAS 3D
C
         NCELA=NCEL
         CALL LCMLEN(IPGEOM,'MIX',ILENX,ITPX)
         IF(ILENX.NE.NCEL.OR.ITPX.NE.1) CALL XABORT('LHXUNH: MISSING'
     +                                              //'VECTOR MIX')
         NBASE=NCEL
         CALL LCMLEN(IPGEOM,'TURN',ILENT,ITPT)
         IF(ILENT.GT.0)THEN
           IF(ILENT.NE.NCEL.OR.ITPT.NE.1) CALL XABORT('LHXUNH: MISSING'
     +                                                //'VECTOR TURN')
           LGTURN=.TRUE.
         ENDIF
         NBASE=NCEL+NCEL
         NBASE=NCEL+NBASE
         CALL SETARA(IBASE,NBASE,ICC)
         CALL LCMGET(IPGEOM,'MIX',IBASE(ICC))
         IF(LGCELL) THEN
           DO 144 IGX=0,NCEL-1
             IBASE(ICC+IGX)=-IBASE(ICC+IGX)
  144      CONTINUE
         ENDIF
         NBB=NCEL+NCEL
         LMERG1=.FALSE.
         LTURN1=.FALSE.
         IF(LGMERG) THEN
           CALL LCMGET(IPGEOM,'MERGE',IBASE(ICC+NCEL))
           NCPHY=0
           DO 52 I=1,NCEL
              NCPHY=MAX(NCPHY,IBASE(ICC+NCEL+I-1))
   52      CONTINUE
           LMERG1=.TRUE.
         ELSE
           DO 53 I=1,NCEL
              IBASE(ICC+I-1+NCEL)=IBASE(ICC+I-1)
   53      CONTINUE
           LGMERG=.TRUE.
           NCPHY=NCEL
         ENDIF
         IF(LGTURN) THEN
           CALL LCMGET(IPGEOM,'TURN',IBASE(ICC+NBB))
           LTURN1=.TRUE.
         ELSE
           LGTURN=.TRUE.
           DO 778 ITT=0,NCEL-1
             IBASE(ICC+NBB+ITT)=1
  778      CONTINUE
         ENDIF
         NBB=NBB+NCEL
C
C           SPLITING DE LA DIRECTION Z
C
         CALL LCMLEN(IPGEOM,'MESHZ',ILENZ,ITPZ)
         IF(LGCELL.OR.IPLANZ.GT.1) THEN
         IF(ILENZ.NE.0)CALL XABORT('LHXUNH: INVALID POSITION OF MESHZ')
         ENDIF
         IF(ILENZ.GT.0) THEN
           IF(ILENZ.NE.LZ+1.OR.ITPZ.NE.2)CALL XABORT('LHXUNH: MISSING'
     +                                 //'DIMENSION OR VALUE IN MESHZ')
           CALL SETARA(RBASE,ILENZ,IZZ)
           CALL LCMGET(IPGEOM,'MESHZ',RBASE(IZZ))
           IZZS=IZZ
           MZ=ILENZ
         ENDIF
C
C            EVALUATION DE NREGIO
C
         NREGIO=NCPHY
         CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITP)
         IF(LGCELL.OR.IPLANZ.GT.1) THEN
         IF(ILENS.NE.0)CALL XABORT('LHXUNH: INVALID POSITION OF SECTOR')
         ENDIF
         IF(ILENS.GT.0) THEN
           IF(ILENS.NE.NCEL)CALL XABORT('LHXUNH: INVALID DIMENSION OF'
     +                                  //'SECTOR')
           IF(ITP.NE.1)CALL XABORT('LHXUNH: SECTOR MUST BE INTEGER')
           CALL SETARA(IBASE,ILENS,ISEC)
           ILESS=0
           NREGIO=0
           CALL LCMGET(IPGEOM,'SECTOR',IBASE(ISEC))
           DO 54 L=0,ILENS-1
              MCEL=IBASE(ICC+L)
              IF(MCEL.GT.ILESS) THEN
                ILESS=MCEL
                KSECT=IBASE(ISEC+L)
                IF(KSECT.GT.1) THEN
                   NREGIO=NREGIO+6*(KSECT-1)
                ELSE
                   NREGIO=NREGIO+1
                ENDIF
              ENDIF
   54      CONTINUE
         ENDIF
C
         CALL LCMLEN(IPGEOM,'SPLITZ',ILEN,ITP)
         IF(ILEN.NE.0) THEN
           IF(ILEN.NE.LZ)CALL XABORT('LHXUNH: INVALID DIMENSION OF'
     +                               //'SPLITZ')
           IF(ILENZ.LT.0)CALL XABORT('LHXUNH: MESHZ MUST BE DEFINED'
     +                               //'LIKE SPLITZ')
           CALL SETARA(IBASE,LZ,ISS)
           CALL LCMGET(IPGEOM,'SPLITZ',IBASE(ISS))
           CALL LCMSIX(IPTRK,'DATA DUP',1)
           CALL LCMPUT(IPTRK,'SPLITZD',LZ,1,IBASE(ISS))
           CALL LCMSIX(IPTRK,' ',2)
           MZ=0
           DO 55 K=0,LZ-1
              MZ=MZ+IBASE(ISS+K)
   55      CONTINUE
           LSPLIT=.TRUE.
         ELSEIF(LGCELL) THEN
           CALL LCMLEN(IPGEOM,'CELL',ILEN,ITP)
           IF(ILEN.NE.3*ISTAT9.OR.ITP.NE.3)CALL XABORT('LHXUNH: '
     +                 //'MISSING DIMENSION OR TYPE OF CELL ')
           CALL SETARA(IBASE,3*ISTAT9,ICELL)
           CALL LCMGET(IPGEOM,'CELL',IBASE(ICELL))
           CALL SETARA(RBASE,3*ISTAT9,IRR)
           CALL SETARA(IBASE,ISTAT9,ISSS)
           CALL SETARA(IBASE,2*ISTAT9,ISEC)
           IAUX=0
           NREGIO=0
           DO 70 I=1,ISTAT9
              WRITE(TEXT12(1:4),'(A4)')IBASE(ICELL+3*(I-1))
              WRITE(TEXT12(5:8),'(A4)')IBASE(ICELL+3*I-2)
              WRITE(TEXT12(9:12),'(A4)')IBASE(ICELL+3*I-1)
              CALL LCMSIX(IPGEOM,TEXT12,1)
              CALL LCMGET(IPGEOM,'MESHZ',RBASE(IRR+IAUX))
              CALL LCMGET(IPGEOM,'SIDE',RBASE(IRR+2*ISTAT9+I-1))
              IAUX=IAUX+2
              CALL LCMLEN(IPGEOM,'SPLITZ',ILEN,ITP)
              IBASE(ISSS+I-1)=1
              IF(ILEN.NE.0) THEN
               IF(ITP.NE.1)CALL XABORT('LHXUNH: INVALID TYPE OF SPLITZ')
                CALL LCMGET(IPGEOM,'SPLITZ',IBASE(ISSS+I-1))
                LSPLIT=.TRUE.
              ENDIF
              CALL LCMLEN(IPGEOM,'RADIUS',ILENR,ITP)
              CALL LCMLEN(IPGEOM,'SPLITR',ILENSP,LT)
              NRAY=0
              NSECT=1
              IF(ILENR.GT.0) THEN
                IF(ITP.NE.2)CALL XABORT('LHXUNH: RADIUS MUST BE REAL ')
                NRAY=ILENR-1
                NSECT=ILENR
              ENDIF
              CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITP)
              CALL SETARA(IBASE,NSECT,ISECT)
              IF(ILENS.GT.0) THEN
                 IF(ILENS.NE.NSECT)
     +                CALL XABORT('LHXUNH: INVALID SECTOR DIMENSION(4)')
                 CALL LCMGET(IPGEOM,'SECTOR',IBASE(ISECT))
              ELSE
                 CALL XDISET(IBASE(ISECT),NSECT,1)
              ENDIF
              IF(ILENSP.GT.0) THEN
                IF(LT.NE.1)CALLXABORT('LHXUNH: SPLITR MUST BE INTEGER')
                CALL SETARA(IBASE,ILENSP,JSS)
                CALL LCMGET(IPGEOM,'SPLITR',IBASE(JSS))
                NRAY=0
                DO 246 JP=0,ILENSP-1
                  NRAY=NRAY+ABS(IBASE(JSS+JP))
  246           CONTINUE
                CALL SETARA(IBASE,NRAY+1,IBASE(ISEC+ISTAT9+I-1))
                MAD=-1
                DO 247 JP=0,ILENS-1
                   KSECT=IBASE(ISECT+JP)
                   DO 247 JT=0,IBASE(JSS+JP)-1
                   MAD=MAD+1
                   IBASE(IBASE(ISEC+ISTAT9+I-1)+MAD)=KSECT
  247           CONTINUE
                IBASE(IBASE(ISEC+ISTAT9+I-1)+MAD+1)=IBASE(ISECT+ILENS)
                CALL RLSARA(IBASE(JSS))
              ELSE
                CALL SETARA(IBASE,NRAY+1,IBASE(ISEC+ISTAT9+I-1))
                DO 248 JP=0,NSECT-1
                   IBASE(IBASE(ISEC+ISTAT9+I-1)+JP)=IBASE(ISECT+JP)
  248           CONTINUE
              ENDIF
              CALL RLSARA(IBASE(ISECT))
              IBASE(ISEC+I-1)=NRAY
              DO 255 K=0,NRAY
                 KSECT=IBASE(IBASE(ISEC+ISTAT9+I-1)+K)
                 IF(KSECT.GT.1) THEN
                   NREGIO=NREGIO+6*(KSECT-1)
                 ELSE
                   NREGIO=NREGIO+1
                 ENDIF
  255         CONTINUE
              CALL LCMSIX(IPGEOM,' ',2)
   70      CONTINUE
           CALL RLSARA(IBASE(ICELL))
C
C                 COMPATIBILITE DES DONNEES DES CELLULES D'UN MEME PLAN
C
           LZZ=LZ
           IAUX=0
           CALL SETARA(IBASE,ISTAT9,ISS)
           CALL SETARA(RBASE,LZ+1,IZZ)
           MZZ=0
           DO 80 I=1,LZ
              SIDE=RBASE(IRR+2*ISTAT9+IBASE(ICC+IAUX)-1)
              LCC=2*(IBASE(ICC+IAUX)-1)
              Z1=RBASE(IRR+LCC)
              Z2=RBASE(IRR+LCC+1)
              RBASE(IZZ+I-1)=Z1
              RBASE(IZZ+I)=Z2
              IF(LSPLIT) THEN
                 LISP=IBASE(ISSS+IBASE(ICC+IAUX)-1)
                 IBASE(ISS+I-1)=LISP
                 MZZ=MZZ+LISP
                 LZZ=MZZ
              ENDIF
              DO 75 K=2,NCELP
                 IAUX=IAUX+1
                 IF(SIDE.NE.RBASE(IRR+2*ISTAT9+IBASE(ICC+IAUX)-1))
     +                       CALL XABORT('LHXUNH: INCOMPATIBLE SIDE ')
                 LCC=2*(IBASE(ICC+IAUX)-1)
                 IF((Z1.NE.RBASE(IRR+LCC)).OR.
     +                       (Z2.NE.RBASE(IRR+LCC+1)))
     +                    CALL XABORT('LHXUNH: INCOMPATIBLE MESHZ ')
                 IF(LSPLIT) THEN
                   IF(LISP.NE.IBASE(ISSS+IBASE(ICC+IAUX)-1))
     +                       CALL XABORT('LHXUNH: INCOMPATIBLE SPLITZ')
                 ENDIF
   75         CONTINUE
              IAUX=IAUX+1
   80      CONTINUE
           CALL RLSARA(RBASE(IRR))
           CALL RLSARA(IBASE(ISSS))
           MZ=LZ+1
           IZZS=IZZ
           IF(LSPLIT)MZ=MZZ+1
         ENDIF
         IF(LSPLIT) THEN
           CALL SETARA(RBASE,MZ,IZZS)
           LAUX=0
           Z1=RBASE(IZZ)
           RBASE(IZZS)=Z1
           DO 83 K=1,LZ
              MSP=IBASE(ISS+K-1)
              Z2=RBASE(IZZ+K)
              PAS=(Z2-Z1)/REAL(MSP)
              DO 81 L=1,MSP-1
                 LAUX=LAUX+1
                 RBASE(IZZS+LAUX)=Z1+PAS*REAL(L)
   81         CONTINUE
              LAUX=LAUX+1
              RBASE(IZZS+LAUX)=Z2
              Z1=Z2
   83      CONTINUE
           CALL RLSARA(RBASE(IZZ))
         ENDIF
C
C               STORAGE DES VALEURS DE Z
C
         CALL LCMSIX(IPTRK,'DATA DUP',1)
         LSPLZM=1
         LSPLZP=1
         IF(LSPLIT) THEN
           LSPLZM=IBASE(ISS)
           LSPLZP=IBASE(ISS+LZ-1)
           CALL LCMPUT(IPTRK,'SPLITZD',LZ,1,IBASE(ISS))
         ENDIF
         IF(NCODE(5) .EQ. 5 .OR. NCODE(5) .EQ. 10) THEN
           IF(NCODE(5) .EQ. 5) THEN 
             MDZ=2*MZ-1-LSPLZM
             IOFZD=2+LSPLZM
           ELSE
             MDZ=2*MZ-1
             IOFZD=2
           ENDIF
           CALL SETARA(RBASE,MDZ,LAQ)
           IQ=0
           DO 583 IW=MZ,IOFZD,-1
              RBASE(LAQ+IQ)=-RBASE(IZZS+IW-1)+
     >                       RBASE(IZZS)+RBASE(IZZS+1)
              IQ=IQ+1
  583      CONTINUE
           DO 584 IW=1,MZ
              RBASE(LAQ+IQ)=RBASE(IZZS+IW-1)
              IQ=IQ+1
  584      CONTINUE
           CALL LCMPUT(IPTRK,'MESHZ',MDZ,2,RBASE(LAQ))
           CALL RLSARA(RBASE(LAQ))
         ELSEIF(NCODE(6) .EQ. 5 .OR. NCODE(6) .EQ. 10) THEN
           IF(NCODE(6) .EQ. 5) THEN 
             MDZ=2*MZ-LSPLZP-1
             IOFZD=LSPLZP+1
           ELSE
             MDZ=2*MZ-1
             IOFZD=1
           ENDIF
           CALL SETARA(RBASE,MDZ,LAQ)
           IQ=0
           DO 585 IW=1,MZ
              RBASE(LAQ+IQ)=RBASE(IZZS+IW-1)
              IQ=IQ+1
  585      CONTINUE
           DO 586 IW=MZ-IOFZD,1,-1
             RBASE(LAQ+IQ)=RBASE(LAQ+IQ-1)+
     >                     RBASE(IZZS+IW)-RBASE(IZZS+IW-1)
             IQ=IQ+1
  586      CONTINUE
           CALL LCMPUT(IPTRK,'MESHZ',MDZ,2,RBASE(LAQ))
           CALL RLSARA(RBASE(LAQ))
         ELSE
           CALL LCMPUT(IPTRK,'MESHZ',MZ,2,RBASE(IZZS))
         ENDIF
         CALL LCMSIX(IPTRK,' ',2)
         CALL RLSARA(RBASE(IZZS))
C
         IF(IHEX.LT.9) THEN
C
C             DUPLICATION DE LA GEOMETRIE CONSIDEREE
C
           CALL SETARA(IBASE,ISTOR(IHEX)*NCEL,IBB)
           CALL DEPLIT(IHEX,NCELP,NCELAP,IBASE(IBB))
           IAUX=NCELP
           JAUX=NCELAP
           DO 65 K=2,LZ
              DO 60 L=0,NCELAP-1
                 IBASE(IBB+JAUX+L)=IBASE(IBB+L)+IAUX
   60         CONTINUE
              IAUX=IAUX+NCELP
              JAUX=JAUX+NCELAP
   65      CONTINUE
         ELSEIF(IHEX.EQ.9) THEN
           NCELAP=NCELA/LZ
         ENDIF
         IF(LSPLIT)THEN
            NCELA=NCELAP*LZZ
         ELSE
            NCELA=NCELAP*LZ
         ENDIF
C
C        DUPLICATION DE MERGE ET MIX
C
         NBASE=NCELA+NCELA
         IF(LGTURN)NBASE=NBASE+NCELA
         CALL SETARA(IBASE,NBASE,IDD)
         CALL SETARA(IBASE,NCELA,IAD)
         IAUX=-1
         JAUX=0
         ICELSP=0
         DO 85 I=1,LZ
           IF(IHEX.LT.9) THEN
              MAXSP=IBASE(IBB+JAUX)
              MINSP=MAXSP
           ENDIF
           DO 84 J=0,NCELAP-1
             IAUX=IAUX+1
                   IF(IHEX.LT.9) THEN
             IBASE(IAD+IAUX)=IBASE(IBB+JAUX+J)+ICELSP
             MAXSP=MAX(MAXSP,IBASE(IBB+JAUX+J))
             MINSP=MIN(MINSP,IBASE(IBB+JAUX+J))
             IBASE(IDD+IAUX)=IBASE(ICC+IBASE(IBB+JAUX+J)-1)
             IBASE(IDD+NCELA+IAUX)=IBASE(ICC+NCEL+IBASE(IBB+JAUX+J)-1)
                   ELSE
             IBASE(IAD+IAUX)=IAUX+1
             IBASE(IDD+IAUX)=IBASE(ICC+JAUX+J)
             IBASE(IDD+NCELA+IAUX)=IBASE(ICC+NCEL+JAUX+J)
                   ENDIF
   84      CONTINUE
           IF(LSPLIT) THEN
             LISP=IBASE(ISS+I-1)
             DO 86 K=2,LISP
               IF(IHEX.LT.9) ICELSP=ICELSP+MAXSP-MINSP+1
               DO 82 J=0,NCELAP-1
                 IAUX=IAUX+1
                    IF(IHEX.LT.9) THEN
                 IARG=ICC+IBASE(IBB+JAUX+J)-1
                 IBASE(IAD+IAUX)=IBASE(IBB+JAUX+J)+ICELSP
                 IBASE(IDD+IAUX)=IBASE(IARG)
                 IBASE(IDD+NCELA+IAUX)=IBASE(NCEL+IARG)
                    ELSE
                 IBASE(IAD+IAUX)=IAUX+1
                 IBASE(IDD+IAUX)=IBASE(ICC+JAUX+J)
                 IBASE(IDD+NCELA+IAUX)=IBASE(ICC+NCEL+JAUX+J)
                    ENDIF
   82          CONTINUE
   86        CONTINUE
           ENDIF
           JAUX=JAUX+NCELAP
   85    CONTINUE
C
C          DUPLICATION DE TURN
C
         MBB=NCELA+NCELA
         IF(LGTURN) THEN
           IF(IHEX.LT.9)CALL SETARA(IBASE,3*NCELP,IFF)
           IAUX=2*NCEL
           JAUX=0
           DO 95 I=1,LZ
           IF(IHEX.LT.9) THEN
             CALL DUTURN(IHEX,IBASE(ICC+IAUX),NCELP,IBASE(IDD+MBB+JAUX
     +              ),NCELAP,IBASE(IBB),IBASE(IFF),IBASE(IFF+NCELP)
     +              ,IBASE(IFF+2*NCELP))
           ELSE
             DO 87 IV=0,NCELAP-1
               IBASE(IDD+MBB+JAUX+IV)=IBASE(ICC+IAUX+IV)
   87        CONTINUE
           ENDIF
             IAUX=IAUX+NCELP
             KAUX=JAUX-1
             JAUX=JAUX+NCELAP
             IF(LSPLIT) THEN
               LISP=IBASE(ISS+I-1)
               DO 92 J=2,LISP
                  DO 90 K=1,NCELAP
                    IBASE(IDD+MBB+JAUX)=IBASE(IDD+MBB+KAUX+K)
                    JAUX=JAUX+1
   90             CONTINUE
   92          CONTINUE
             ENDIF
   95      CONTINUE
           IF(IHEX.NE.9)CALL RLSARA(IBASE(IFF))
           CALL RLSARA(IBASE(ISS))
         ENDIF
         IGG=IDD
         IAA=IAD
         KK=NCELA
         IF(NCODE(5) .EQ. 5 .OR. NCODE(5) .EQ. 10) THEN
C
C             DUPLICATION DE LA SYMETRIE SELON L'AXE Z-
C
         IF(NCODE(6) .EQ. 5 .OR. NCODE(6) .EQ. 10) CALL XABORT(
     >   'LHXUNH: ONLY ONE Z SYMETRY IS PERMITED')
         IF(NCODE(6) .EQ. 5) THEN 
           KBB=NCELA+NCELA-NCELAP*LSPLZM
           IOFZD=LSPLZM
         ELSE
           KBB=NCELA+NCELA
           IOFZD=0
         ENDIF
         MCODE=1
         KK=KBB
         KBB=2*KBB
         IF(LGTURN)KBB=KBB+KK
         CALL SETARA(IBASE,KBB,IGG)
         CALL SETARA(IBASE,KK,IAA)
         IAUX=0
         JAUX=NCELA-NCELAP
         LAUX=2*NCELA-NCELAP
C
C           DUPLICATION DE MIX ET MERGE
C
         NCOUR=IFCOUR(NCELAP)
         DO 110 I=IOFZD,LZZ-1
            IPOS=0
            IBASE(IAA+IAUX)=IBASE(IAD+JAUX)
            IBASE(IGG+IAUX)=IBASE(IDD+JAUX)
            IBASE(IGG+KK+IAUX)=IBASE(IDD+LAUX)
            DO 100 J1=2,NCOUR
            DO 99 J=IFONC(J1,5)-1,IFONC(J1,0)-1,-1
              IPOS=IPOS+1
              IBASE(IAA+IAUX+IPOS)=IBASE(IAD+JAUX+J)
              IBASE(IGG+IAUX+IPOS)=IBASE(IDD+JAUX+J)
              IBASE(IGG+KK+IAUX+IPOS)=IBASE(IDD+LAUX+J)
   99       CONTINUE
            NCLCOR=1+3*J1*(J1-1)
            DO 105 J=NCLCOR-1,IFONC(J1,5),-1
              IPOS=IPOS+1
              IBASE(IAA+IAUX+IPOS)=IBASE(IAD+JAUX+J)
              IBASE(IGG+IAUX+IPOS)=IBASE(IDD+JAUX+J)
              IBASE(IGG+KK+IAUX+IPOS)=IBASE(IDD+LAUX+J)
  105       CONTINUE
  100       CONTINUE
            IAUX=IAUX+NCELAP
            JAUX=JAUX-NCELAP
            LAUX=LAUX-NCELAP
  110    CONTINUE
         DO 115 K=0,NCELA-1
            IBASE(IAA+IAUX+K)=IBASE(IAD+K)
            IBASE(IGG+IAUX+K)=IBASE(IDD+K)
            IBASE(IGG+KK+IAUX+K)=IBASE(IDD+NCELA+K)
  115    CONTINUE
C
C             DUPLICATION DE TURN
C
         IF(LGTURN) THEN
           IAUX=0
           LAUX=3*NCELA-NCELAP*IOFZD
           DO 130 I=IOFZD,LZZ-1
             J=-1
             JAUX2=0
             JAUX1=0
             DO 120 J1=1,NCOUR
             LGPASS=.TRUE.
  118        CONTINUE
             DO 119 J2=JAUX2,JAUX1,-1
               J=J+1
               ITURN=IBASE(IDD+LAUX+J2)
               IF(ITURN.LE.6) THEN
                 IF(ITURN.EQ.1) THEN
                   IBASE(IGG+2*KK+IAUX+J)=12
                 ELSEIF(ITURN.EQ.2) THEN
                   IBASE(IGG+2*KK+IAUX+J)=11
                 ELSEIF(ITURN.EQ.3) THEN
                   IBASE(IGG+2*KK+IAUX+J)=10
                 ELSEIF(ITURN.EQ.4) THEN
                   IBASE(IGG+2*KK+IAUX+J)=9
                 ELSEIF(ITURN.EQ.5) THEN
                   IBASE(IGG+2*KK+IAUX+J)=8
                 ELSEIF(ITURN.EQ.6) THEN
                   IBASE(IGG+2*KK+IAUX+J)=7
                 ENDIF
               ELSEIF(ITURN.LE.12) THEN
                 IF(ITURN.EQ.12) THEN
                   IBASE(IGG+2*KK+IAUX+J)=1
                 ELSEIF(ITURN.EQ.11) THEN
                   IBASE(IGG+2*KK+IAUX+J)=2
                 ELSEIF(ITURN.EQ.10) THEN
                   IBASE(IGG+2*KK+IAUX+J)=3
                 ELSEIF(ITURN.EQ.9) THEN
                   IBASE(IGG+2*KK+IAUX+J)=4
                 ELSEIF(ITURN.EQ.8) THEN
                   IBASE(IGG+2*KK+IAUX+J)=5
                 ELSEIF(ITURN.EQ.7) THEN
                   IBASE(IGG+2*KK+IAUX+J)=6
                 ENDIF
               ELSE
                 CALL XABORT('LHXUNH: EXPECTED VALUE OF TURN ')
               ENDIF
  119        CONTINUE
             IF(LGPASS) THEN
               JAUX2=1+3*J1*(J1-1)-1
               JAUX1=IFONC(J1,5)
               LGPASS=.FALSE.
               IF(J1.GT.1) GOTO 118
             ENDIF
             JAUX2=IFONC(J1+1,5)-1
             JAUX1=IFONC(J1+1,0)-1
  120        CONTINUE
             IAUX=IAUX+NCELAP
             LAUX=LAUX-NCELAP
  130      CONTINUE
         ENDIF
         DO 135 K=0,NCELA-1
            IBASE(IGG+2*KK+IAUX+K)=IBASE(IDD+2*NCELA+K)
  135    CONTINUE
         IPLANI=LZZ
         LZZ=2*LZZ-IOFZD
         ELSEIF(NCODE(6) .EQ. 5 .OR. NCODE(6) .EQ. 10) THEN
C
C           DULPLICATION DE LA GEOMETRIE SELON Z+
C
         IF(NCODE(6) .EQ. 5) THEN 
           KBB=NCELA+NCELA-NCELAP*LSPLZP
           IOFZD=LSPLZP
         ELSE
           KBB=NCELA+NCELA
           IOFZD=0
         ENDIF
         MCODE=2
         KK=KBB
         KBB=2*KBB
         IF(LGTURN)KBB=KBB+KK
         CALL SETARA(IBASE,KBB,IGG)
         CALL SETARA(IBASE,KK,IAA)
C
C           DUPLICATION DE MIX ET MERGE
C
         DO 140 I=0,NCELA-1
            IBASE(IAA+I)=IBASE(IAD+I)
            IBASE(IGG+I)=IBASE(IDD+I)
            IBASE(IGG+KK+I)=IBASE(IDD+NCELA+I)
  140    CONTINUE
         NCOUR=IFCOUR(NCELAP)
         LFIN=-NCELAP*IOFZD+NCELA
         IPOS=-1
         DO 145 I=IOFZD,LZZ-1
            LFIN=LFIN-NCELAP
            IPOS=IPOS+1
            IBASE(IAA+NCELA+IPOS)=IBASE(IAD+LFIN)
            IBASE(IGG+NCELA+IPOS)=IBASE(IDD+LFIN)
            IBASE(IGG+KK+NCELA+IPOS)=IBASE(IDD+NCELA+LFIN)
            DO 143 J1=2,NCOUR
            DO 141 J=IFONC(J1,5)-1,IFONC(J1,0)-1,-1
              IPOS=IPOS+1
              IBASE(IAA+NCELA+IPOS)=IBASE(IAD+LFIN+J)
              IBASE(IGG+NCELA+IPOS)=IBASE(IDD+LFIN+J)
              IBASE(IGG+KK+NCELA+IPOS)=IBASE(IDD+NCELA+LFIN+J)
  141       CONTINUE
            NCLCOR=1+3*J1*(J1-1)
            DO 142 J=NCLCOR-1,IFONC(J1,5),-1
              IPOS=IPOS+1
              IBASE(IAA+NCELA+IPOS)=IBASE(IAD+LFIN+J)
              IBASE(IGG+NCELA+IPOS)=IBASE(IDD+LFIN+J)
              IBASE(IGG+KK+NCELA+IPOS)=IBASE(IDD+NCELA+LFIN+J)
  142       CONTINUE
  143       CONTINUE
  145    CONTINUE
C
C          DUPLICATION DE TURN
C
         IF(LGTURN) THEN
           DO 150 I=0,NCELA-1
              IBASE(IGG+2*KK+I)=IBASE(IDD+2*NCELA+I)
  150      CONTINUE
           LFIN=-NCELAP*IOFZD+NCELA
           J=-1+NCELA
           DO 155 JP=IOFZD,LZZ-1
             LFIN=LFIN-NCELAP
             JAUX2=0
             JAUX1=0
             DO 154 J1=1,NCOUR
             LGPASS=.TRUE.
  152        CONTINUE
             DO 153 J2=JAUX2,JAUX1,-1
              J=J+1
              ITURN=IBASE(IDD+2*NCELA+LFIN+J2)
              IF(ITURN.LE.6) THEN
                 IF(ITURN.EQ.1) THEN
                   IBASE(IGG+2*KK+J)=12
                 ELSEIF(ITURN.EQ.2) THEN
                   IBASE(IGG+2*KK+J)=11
                 ELSEIF(ITURN.EQ.3) THEN
                   IBASE(IGG+2*KK+J)=10
                 ELSEIF(ITURN.EQ.4) THEN
                   IBASE(IGG+2*KK+J)=9
                 ELSEIF(ITURN.EQ.5) THEN
                   IBASE(IGG+2*KK+J)=8
                 ELSEIF(ITURN.EQ.6) THEN
                   IBASE(IGG+2*KK+J)=7
                 ENDIF
              ELSEIF(ITURN.LE.12) THEN
                 IF(ITURN.EQ.12) THEN
                   IBASE(IGG+2*KK+J)=1
                 ELSEIF(ITURN.EQ.11) THEN
                   IBASE(IGG+2*KK+J)=2
                 ELSEIF(ITURN.EQ.10) THEN
                   IBASE(IGG+2*KK+J)=3
                 ELSEIF(ITURN.EQ.9) THEN
                   IBASE(IGG+2*KK+J)=4
                 ELSEIF(ITURN.EQ.8) THEN
                   IBASE(IGG+2*KK+J)=5
                 ELSEIF(ITURN.EQ.7) THEN
                   IBASE(IGG+2*KK+J)=6
                 ENDIF
              ELSE
                 CALL XABORT('LHXUNH: EXPECTED VALUE OF TURN ')
              ENDIF
  153        CONTINUE
             IF(LGPASS) THEN
               JAUX2=1+3*J1*(J1-1)-1
               JAUX1=IFONC(J1,5)
               LGPASS=.FALSE.
               IF(J1.GT.1) GOTO 152
             ENDIF
             JAUX2=IFONC(J1+1,5)-1
             JAUX1=IFONC(J1+1,0)-1
  154        CONTINUE
  155      CONTINUE
         ENDIF
         CALL RLSARA(IBASE(IDD))
         CALL RLSARA(IBASE(IAD))
         CALL RLSARA(IBASE(ICC))
         IF(IHEX.NE.9)CALL RLSARA(IBASE(IBB))
         IPLANI=LZZ
         LZZ=2*LZZ-IOFZD
         ENDIF
C
C             RESTORAGE DES DONNEES
C
C ccc       CALL LCMSIX(IPGEOM,' ',0)
         NCELA=KK
         MVOSU=0
         MVOLUM=0
         MESH=3*KK
         NSMIN=0
         NSMAX=0
         ISURF=0
         NCOUR=1
         IF(NCELAP.GT.1)NCOUR=IFCOUR(NCELAP)
         ICELC0= IFONC(NCOUR,0)
         ICELC1= IFONC(NCOUR,1)-ICELC0
         MCOU=1
         LCOU=1
         CALL SETARA(ID,2*LZZ,ISUR)
         CALL XDISET(ID(ISUR),2*LZZ,0)
         IF(LGCELL) THEN
           CALL LCMSIX(IPTRK,'DATA DUP',1)
           CALL LCMPUT(IPTRK,'GENER0',KK,1,IBASE(IAA))
           CALL LCMPUT(IPTRK,'GENERATING',KK,1,IBASE(IGG))
           CALL LCMSIX(IPTRK,' ',2)
           CALL RLSARA(IBASE(IAA))
           NRAY=0
           NCDP=NCELA-NCELAP
           ICELL1=IFONC(NCOUR,5)
           IP=1
           ISAUX=0
           DO 200 I=0,KK-1
              KRAY=IBASE(ISEC+IBASE(IGG+I)-1)
              NRAY=NRAY+KRAY
              I1=I+1
              DO 205 JR=0,KRAY
                 KSECT=IBASE(IBASE(ISEC+ISTAT9+IBASE(IGG+I)-1)+JR)
                 IF(KSECT.GT.1) THEN
                   MSEC=6*(KSECT-1)
                   MVOSU=MVOSU+MSEC
                   IF(I1.LE.NCELAP)THEN
                     NSMIN=NSMIN+MSEC
                   ELSEIF(I1.GT.NCDP) THEN
                     NSMAX=NSMAX+MSEC
                   ENDIF
                 ELSE
                   MVOSU=MVOSU+1
                   IF(I1.LE.NCELAP)THEN
                     NSMIN=NSMIN+1
                   ELSEIF(I1.GT.NCDP) THEN
                     NSMAX=NSMAX+1
                   ENDIF
                 ENDIF
  205         CONTINUE
              IF(IHEX.EQ.9) THEN
                IF(MCODE.EQ.1) THEN
                  IF(I1.LE.NCELAP) THEN
                    IF(I1.LE.LCOU) THEN
                      VLAT(MCOU)=NSMIN
                      IF(I1.EQ.IFONC(MCOU,5)) VLAT(NCOUR+MCOU)=NSMIN
                    ELSE
                      LCOU=LCOU+6*MCOU
                      MCOU=MCOU+1
                    ENDIF
                  ENDIF
                ELSEIF(MCODE.EQ.2) THEN
                  IF(I1.GT.NCDP) THEN
                    I2=I1-NCDP
                    IF(I2.LE.LCOU) THEN
                      VLAT(MCOU)=NSMAX
                      IF(I2.EQ.IFONC(MCOU,5)) VLAT(NCOUR+MCOU)=NSMAX
                    ELSE
                      LCOU=LCOU+6*MCOU
                      MCOU=MCOU+1
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
              ICOX=INT(AINT(REAL(I1)/REAL(NCELAP)))
              IF(MOD(I1,NCELAP).NE.0)ICOX=ICOX+1
              ICOX=ICOX-1
              ICX=NCELAP*ICOX
              ICELC=ICELC0+ICX
              ICLIM=NCELAP+ICX
              IF(I1.GE.ICELC.AND.I1.LE.ICLIM) THEN
                IF(KSECT.GT.1) THEN
                  ISURF=ISURF+2*(KSECT-1)
                  ISURF0=ISURF
                  IF(MOD(I1-ICELC,ICELC1).EQ.0)ISURF=ISURF+KSECT-1
                  IF(I1.LE.NCELAP*IP) THEN
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=KSECT-1
                    IF(I1.EQ.ICELL1+NXX) ID(ISUR-1+LZZ+IP)=ISURF0-ISAUX
                    ID(ISUR+IP-1)=ISURF
                  ELSE
                    ISAUX=0
                    IP=IP+1
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=KSECT-1
                  ENDIF
                ELSE
                  ISURF=ISURF+2
                  ISURF0=ISURF
                  IF(MOD(I1-ICELC,ICELC1).EQ.0)ISURF=ISURF+1
                  IF(I1.LE.NCELAP*IP) THEN
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=1
                    IF(I1.EQ.ICELL1+NXX) ID(ISUR-1+LZZ+IP)=ISURF0-ISAUX
                    ID(ISUR+IP-1)=ISURF
                  ELSE
                    ISAUX=0
                    IP=IP+1
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=1
                  ENDIF
                ENDIF
              ENDIF
              MVOLUM=MVOLUM+KRAY+1
  200      CONTINUE
           DO 206 I=0,ISTAT9-1
             CALL RLSARA(IBASE(IBASE(ISEC+ISTAT9+I)))
  206      CONTINUE
           MESH=MESH+NRAY
           IF(IPLANZ.EQ.1) NSMAX=NSMIN
         ELSE
           CALL LCMSIX(IPTRK,'DATA DUP',1)
           CALL LCMPUT(IPTRK,'MIX',KK,1,IBASE(IGG))
           CALL LCMSIX(IPTRK,' ',2)
           NCDP=NCELA-NCELAP
           MVOLUM=KK
           NCOUR=IFCOUR(NCELAP)
           ICELL1=IFONC(NCOUR,5)
           IP=1
           DO 210 I=0,KK-1
              KSECT=IBASE(ISEC+IBASE(IGG+I)-1)
              ICOX=INT(AINT(REAL(I1)/REAL(NCELAP)))
              IF(MOD(I1,NCELAP).NE.0)ICOX=ICOX+1
              ICOX=ICOX-1
              ICXX=NCELAP*ICOX
              ICELC=ICELC0+ICXX
              ICLIM=NCELAP+ICXX
              I1=I+1
              IF(KSECT.GT.1) THEN
                MSEC=6*(KSECT-1)
                MVOSU=MVOSU+MSEC
                IF(I1.LE.NCELAP)THEN
                   NSMIN=NSMIN+MSEC
                ELSEIF(I1.GT.NCDP) THEN
                   NSMAX=NSMAX+MSEC
                ENDIF
                IF(I1.GE.ICELC.AND.I1.LE.ICLIM) THEN
                  ISURF=ISURF+2*(KSECT-1)
                  ISURF0=ISURF
                  IF(MOD(I1-ICELC,ICELC1).EQ.0)ISURF=ISURF+KSECT-1
                  IF(I1.LE.NCELAP*IP) THEN
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=KSECT-1
                    IF(I1.EQ.ICELL1+NXX) ID(ISUR-1+LZZ+IP)=ISURF0-ISAUX
                    ID(ISUR-1+IP)=ISURF
                  ELSE
                    ISAUX=0
                    IP=IP+1
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=KSECT-1
                  ENDIF
                ENDIF
              ELSE
                MVOSU=MVOSU+1
                IF(I1.LE.NCELAP)THEN
                   NSMIN=NSMIN+1
                ELSEIF(I1.GT.NCDP) THEN
                   NSMAX=NSMAX+1
                ENDIF
                IF(I1.GE.ICELC.AND.I1.LE.ICLIM) THEN
                  ISURF=ISURF+2
                  ISURF0=ISURF
                  IF(MOD(I1-ICELC,ICELC1).EQ.0)ISURF=ISURF+1
                  IF(I1.LE.NCELAP*IP) THEN
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=1
                    IF(I1.EQ.ICELL1+NXX) ID(ISUR-1+LZZ+IP)=ISURF0-ISAUX
                    ID(ISUR-1+IP)=ISURF
                  ELSE
                    ISAUX=0
                    IP=IP+1
                    NXX=NCELAP*(IP-1)
                    IF(I1.EQ.ICELC0+NXX) ISAUX=1
                  ENDIF
                ENDIF
              ENDIF
              IF(IHEX.EQ.9) THEN
                IF(MCODE.EQ.1) THEN
                  IF(I1.LE.NCELAP) THEN
                    IF(I1.LE.LCOU) THEN
                      VLAT(MCOU)=NSMIN
                      IF(I1.EQ.IFONC(MCOU,5)) VLAT(NCOUR+MCOU)=NSMIN
                    ELSE
                      LCOU=LCOU+6*MCOU
                      MCOU=MCOU+1
                    ENDIF
                  ENDIF
                ELSEIF(MCODE.EQ.2) THEN
                  IF(I1.GT.NCDP) THEN
                    I2=I1-NCDP
                    IF(I2.LE.LCOU) THEN
                      VLAT(MCOU)=NSMAX
                      IF(I2.EQ.IFONC(MCOU,5)) VLAT(NCOUR+MCOU)=NSMAX
                    ELSE
                      LCOU=LCOU+6*MCOU
                      MCOU=MCOU+1
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
  210      CONTINUE
           IF(IPLANZ.EQ.1) NSMAX=NSMIN
         ENDIF
         CALL RLSARA(IBASE(ISEC))
         CALL LCMSIX(IPTRK,'DATA DUP',1)
         CALL LCMPUT(IPTRK,'MERGE',KK,1,IBASE(IGG+KK))
         IF(LGTURN)CALL LCMPUT(IPTRK,'TURN',KK,1,IBASE(IGG+2*KK))
         CALL LCMSIX(IPTRK,' ',2)
         CALL RLSARA(IBASE(IGG))
C
C              MODIFICATION DU VECTEUR STATE
C
         ISTATE(5)=LZZ
         IPLANZ=LZZ
      ENDIF
      ISTATE(3)=NCELAP
      ISURF=ISURF+NSMIN+NSMAX
      RETURN
      END
