*DECK LIBA2G
      SUBROUTINE LIBA2G (NAMFIL,NGRO,IENERG)
*
*-----------------------------------------------------------------------
*
*Purpose:
* recover energy group information from an APOLIB2 library
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* NAMFIL  name of the APOLIB2 file
*
*Parameters: output
* NGRO    number of energy groups
* IENERG  SETARA pointer of the energy mesh limit array
*
*-----------------------------------------------------------------------
*
*----
*  Subroutine arguments
*----
      INTEGER NGRO,IENERG
      CHARACTER NAMFIL*(*)
*----
*  Local variables
*----
      PARAMETER (IACTO=2,IACTC=1,ILIBDA=4)
      EXTERNAL LIBA21
      INTEGER ISFICH(3),IBASE(1)
      CHARACTER TEXT80*80,NOMOBJ*20,TYPOBJ*8,TYPSEG*8,HSMG*131
      COMMON RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
*
      INTEGER TKCARO(31)
      SAVE TKCARO
      DATA TKCARO /
     &   0,   1,   2,   3,  4,   5,  6,  30,   7,  -8,
     &   9, -10,  11, -12, 13, -14, 15,  16, -17,  18,
     & -19,  20, -21,  22, 23, -24, 25, -26,  27, -28,
     &  29   /
*
      CALL AEXTPA(NAMFIL,ISFICH)
      IADRES=ISFICH(1)
      NBOBJ=ISFICH(2)
      LBLOC=ISFICH(3)
      IUNIT=KDROPN(NAMFIL,IACTO,ILIBDA,LBLOC,IHANDL)
      IF(IUNIT.LE.0) THEN
         WRITE(HSMG,'(26HLIBA2G: APOLLO-2 LIBRARY '',A16,9H'' CANNOT ,
     >   29HBE OPENED BY KDROPN (ERRCODE=,I2,2H).)') NAMFIL,IUNIT
         CALL XABORT(HSMG)
      ENDIF
      CALL SETARA(IBASE,2*NBOBJ,IVINTE)
      CALL AEXDIR(IUNIT,LBLOC,IBASE(IVINTE),IADRES,2*NBOBJ)
      IDKSV=1-TKCARO(12)
      IDKNO=1-TKCARO(14)
      IDKTY=1-TKCARO(21)
      IDKDS=1-TKCARO(10)
      IDKTS=1-TKCARO(23)
      IDKNS=TKCARO(2)+1
      IDKLS=TKCARO(8)
      DO 150 IOBJ=3,NBOBJ
         IDKOBJ=IBASE(IVINTE+2*IOBJ-2)
         LGSEG=IBASE(IVINTE+2*IOBJ-1)+1
         CALL SETARA(IBASE,LGSEG,ITCARO)
         CALL AEXDIR(IUNIT,LBLOC,IBASE(ITCARO),IDKOBJ,LGSEG)
         IDK=IBASE(ITCARO+IDKSV-1)
         CALL AEXCPC(IDK,80,IBASE(ITCARO),TEXT80)
*
         IDK=IBASE(ITCARO+IDKNO-1)
         CALL AEXCPC(IDK,20,IBASE(ITCARO),NOMOBJ)
         IDK=IBASE(ITCARO+IDKTY-1)
         CALL AEXCPC(IDK,8,IBASE(ITCARO),TYPOBJ)
         IF(TYPOBJ.EQ.'APOLIB') THEN
            JDKDS=IBASE(ITCARO+IDKDS-1)
            JDKTS=IBASE(ITCARO+IDKTS-1)
            NS=IBASE(ITCARO+IDKNS-1)
            DO 140 IS=1,NS
              IDK=JDKTS+8*(IS-1)
              CALL AEXCPC(IDK,8,IBASE(ITCARO),TYPSEG)
              IF(TYPSEG.EQ.'PMAIL') THEN
                LNGS=IBASE(ITCARO+IDKLS+IS-1)
                JDKS=IBASE(ITCARO+JDKDS+IS-1)
                CALL SETARA(IBASE,LNGS+1,ITSEGM)
                CALL AEXDIR(IUNIT,LBLOC,IBASE(ITSEGM),JDKS,LNGS+1)
                CALL AEXTRT(LIBA21,TYPSEG,NBRTYP,ICHDIM,ICHTYP,ICHDKL)
                CALL AEXGNV(3,IBASE(ITSEGM),IBASE(ICHDIM),IBASE(ICHTYP),
     1          IBASE(ICHDKL),IDK,NV)
                NGRO=NV-1
                CALL SETARA(RBASE,NGRO+1,IENERG)
                DO 130 IG=1,NV
  130           RBASE(IENERG+IG-1)=RBASE(ITSEGM+IDK+IG-2)*1.0E6
                CALL RLSARA(IBASE(ICHDIM))
                CALL RLSARA(IBASE(ICHTYP))
                CALL RLSARA(IBASE(ICHDKL))
                CALL RLSARA(IBASE(ITSEGM))
                CALL RLSARA(IBASE(ITCARO))
                GO TO 160
              ENDIF
  140       CONTINUE
         ENDIF
         CALL RLSARA(IBASE(ITCARO))
  150 CONTINUE
      CALL XABORT('LIBA2G: NO GROUP STRUCTURE AVAILABLE')
*
  160 IERR=KDRCLS(IUNIT,IACTC)
      IF(IERR.LT.0) THEN
         WRITE(HSMG,'(26HLIBA2G: APOLLO-2 LIBRARY '',A16,9H'' CANNOT ,
     >   29HBE CLOSED BY KDRCLS (ERRCODE=,I2,2H).)') NAMFIL,IERR
         CALL XABORT(HSMG)
      ENDIF
      CALL RLSARA(IBASE(IVINTE))
      RETURN
      END
