*DECK LIBADJ
      SUBROUTINE LIBADJ (IPLIB,NGRO,NBISO,NL,NDEL,ISONAM,NED,NAMEAD,GA1,
     1 GA2,SIGS,SCAT,ITYPRO)
*
*-----------------------------------------------------------------------
*
*Purpose:
* transposition of the usefull interpolated microscopic cross section
* for producing an adjoint problem
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPLIB   pointer to the lattice microscopic cross section library
*         (L_LIBRARY signature)
* NGRO    number of energy groups
* NBISO   number of isotopes present in the calculation domain
* NL      number of Legendre orders required in the calculation
*         NL=1 or higher
* NDEL    number of delayed precursor groups
* ISONAM  alias name of isotopes
* NED     number of extra vector edits from matxs
* NAMEAD  matxs names of the extra vector edits
*
*Parameters: scratch
* GA1
* GA2
* SIGS
* SCAT
* ITYPRO
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPLIB,NGRO,NBISO,NL,NDEL,ISONAM(3,NBISO),NED,
     > NAMEAD(2,NED),ITYPRO(NL)
      REAL GA1(NGRO,2),GA2(NGRO,NGRO),SIGS(NGRO,NL),SCAT(NGRO,NGRO,NL)
*----
*  LOCAL VARIABLES
*----
      CHARACTER TEXT12*12,TEXT8*8,HNUSIG*12,HCHI*12
      COMMON BASE(1)
*----
*  ***MATERIAL/ISOTOPE LOOP***
*----
      IMPX=0
      DO 200 IMT=1,NBISO
      WRITE(TEXT12,'(3A4)') (ISONAM(I0,IMT),I0=1,3)
      CALL LCMSIX(IPLIB,TEXT12,1)
      CALL SETARA(BASE,NGRO*NGRO,IXSSCM)
      CALL SETARA(BASE,NGRO,INJJ)
      CALL SETARA(BASE,NGRO,IIJJ)
      CALL XDRLGS(IPLIB,-1,IMPX,0,NL-1,1,NGRO,SIGS,SCAT,ITYPRO,
     1 BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
      INGRO=NL-1
      DO 10 IL=NL-1,0,-1
      IF(ITYPRO(IL+1).EQ.0) THEN
         INGRO=INGRO-1
      ELSE
         GO TO 20
      ENDIF
   10 CONTINUE
   20 DO 50 IL=0,INGRO
      IF(ITYPRO(IL+1).GT.0) THEN
         DO 30 I=1,NGRO
         GA1(I,1)=SIGS(NGRO-I+1,IL+1)
         DO 30 J=1,NGRO
   30    GA2(I,J)=SCAT(NGRO-J+1,NGRO-I+1,IL+1)
         DO 40 I=1,NGRO
         SIGS(I,IL+1)=GA1(I,1)
         DO 40 J=1,NGRO
   40    SCAT(NGRO-J+1,NGRO-I+1,IL+1)=GA2(J,I)
      ENDIF
   50 CONTINUE
      CALL XDRLGS(IPLIB,1,IMPX,0,INGRO,1,NGRO,SIGS,SCAT,ITYPRO,
     1 BASE(IXSSCM),BASE(INJJ),BASE(IIJJ))
      CALL RLSARA(BASE(IIJJ))
      CALL RLSARA(BASE(INJJ))
      CALL RLSARA(BASE(IXSSCM))
*
      CALL LCMLEN(IPLIB,'TRANC',LENGT,ITYLCM)
      IF (LENGT.GT.0) THEN
         CALL LCMGET(IPLIB,'TRANC',GA1(1,1))
         DO 130 I=1,NGRO
  130    GA1(I,2)=GA1(NGRO-I+1,1)
         CALL LCMPUT(IPLIB,'TRANC',NGRO,2,GA1(1,2))
      ENDIF
*
      CALL LCMGET(IPLIB,'NTOT0',GA1(1,1))
      DO 140 I=1,NGRO
  140 GA1(I,2)=GA1(NGRO-I+1,1)
      CALL LCMPUT(IPLIB,'NTOT0',NGRO,2,GA1(1,2))
*
      DO 175 IDEL=0,NDEL
      IF(IDEL.EQ.0) THEN
         HNUSIG='NUSIGF'
         HCHI='CHI'
      ELSE
         WRITE(HNUSIG,'(6HNUSIGF,I2.2)') IDEL
         WRITE(HCHI,'(3HCHI,I2.2)') IDEL
      ENDIF
      CALL LCMLEN(IPLIB,HNUSIG,LENGT,ITYLCM)
      IF (LENGT.GT.0) THEN
         CALL LCMGET(IPLIB,HNUSIG,GA1(1,1))
         SUM=0.0
         DO 150 I=1,NGRO
  150    SUM=SUM+GA1(I,1)
         DO 160 I=1,NGRO
  160    GA1(I,2)=GA1(NGRO-I+1,1)/SUM
         CALL LCMGET(IPLIB,HCHI,GA1(1,1))
         CALL LCMPUT(IPLIB,HCHI,NGRO,2,GA1(1,2))
         DO 170 I=1,NGRO
  170    GA1(I,2)=GA1(NGRO-I+1,1)*SUM
         CALL LCMPUT(IPLIB,HNUSIG,NGRO,2,GA1(1,2))
      ENDIF
  175 CONTINUE
*
      DO 190 IED=1,NED
      WRITE(TEXT8,'(2A4)') (NAMEAD(I0,IED),I0=1,2)
      IF((TEXT8.EQ.'TRANC').OR.(TEXT8.EQ.'NTOT0').OR.
     1 (TEXT8(:6).EQ.'NUSIGF').OR.(TEXT8(:3).EQ.'CHI'))
     2 GO TO 190
      CALL LCMLEN(IPLIB,TEXT8,LENGT,ITYLCM)
      IF (LENGT.GT.0) THEN
         CALL LCMGET(IPLIB,TEXT8,GA1(1,1))
         DO 180 I=1,NGRO
  180    GA1(I,2)=GA1(NGRO-I+1,1)
         CALL LCMPUT(IPLIB,TEXT8,NGRO,2,GA1(1,2))
      ENDIF
  190 CONTINUE
      CALL LCMSIX(IPLIB,' ',2)
  200 CONTINUE
*
      CALL LCMGET(IPLIB,'DELTAU',GA1(1,1))
      DO 210 I=1,NGRO
  210 GA1(I,2)=GA1(NGRO-I+1,1)
      CALL LCMPUT(IPLIB,'DELTAU',NGRO,2,GA1(1,2))
      RETURN
      END
