*DECK LIBDI5
      SUBROUTINE LIBDI5 (MAXDIL,NAMFIL,HSHI,NDIL,DILUT)
*
*-----------------------------------------------------------------------
*
*Purpose:
* find the dilutions corresponding to a resonant isotope within a
* library in Apolib-2 format.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* MAXDIL  maximum number of dilutions.
* NAMFIL  name of the APOLIB-2 file
* HSHI    library name of the self-shielding data.
*
*Parameters: output
* NDIL    number of finite dilutions.
* DILUT   dilutions.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER MAXDIL,NDIL
      CHARACTER HSHI*12
      CHARACTER NAMFIL*(*)
      REAL DILUT(MAXDIL)
*----
*  LOCAL VARIABLES
*----
      EXTERNAL LIBA21
      CHARACTER HSMG*131,TEXT8*8,TEXT20*20,NOMOBJ*20,TYPOBJ*8,TYPSEG*8
      LOGICAL LISO,LPTHOM
      INTEGER ISFICH(3),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      INTEGER TKCARO(31)
      SAVE TKCARO
      DATA TKCARO /
     &   0,   1,   2,   3,  4,   5,  6,  30,   7,  -8,
     &   9, -10,  11, -12, 13, -14, 15,  16, -17,  18,
     & -19,  20, -21,  22, 23, -24, 25, -26,  27, -28,
     &  29   /
*----
*  INDEX THE APOLIB-2 FILE.
*----
      CALL AEXTPA(NAMFIL,ISFICH)
      IADRES=ISFICH(1)
      NBOBJ=ISFICH(2)
      LBLOC=ISFICH(3)
      NIN=KDROPN(NAMFIL,2,4,LBLOC,0)
      IF(NIN.LE.0) THEN
         WRITE (HSMG,'(35HLIBDI5: UNABLE TO OPEN LIBRARY FILE,1X,A16,
     1   1H.)') NAMFIL
         CALL XABORT(HSMG)
      ENDIF
      CALL SETARA(IBASE,2*NBOBJ,IVINTE)
      CALL AEXDIR(NIN,LBLOC,IBASE(IVINTE),IADRES,2*NBOBJ)
      IDKNO=1-TKCARO(14)
      IDKTY=1-TKCARO(21)
      IDKDS=1-TKCARO(10)
      IDKTS=1-TKCARO(23)
      IDKDA=1-TKCARO(26)
      IDKNS=TKCARO(2)+1
      IDKLS=TKCARO(8)
*
      TEXT20='SSDATA'//HSHI
      LISO=.FALSE.
      DO 70 I=3,NBOBJ
      IDKOBJ=IBASE(IVINTE+2*I-2)
      LGSEG=IBASE(IVINTE+2*I-1)+1
      CALL SETARA(IBASE,LGSEG,ITCARO)
      CALL AEXDIR(NIN,LBLOC,IBASE(ITCARO),IDKOBJ,LGSEG)
      IDK=IBASE(ITCARO+IDKNO-1)
      CALL AEXCPC(IDK,20,IBASE(ITCARO),NOMOBJ)
      IDK=IBASE(ITCARO+IDKTY-1)
      CALL AEXCPC(IDK,8,IBASE(ITCARO),TYPOBJ)
      JDKDS=IBASE(ITCARO+IDKDS-1)
      JDKTS=IBASE(ITCARO+IDKTS-1)
      NS=IBASE(ITCARO+IDKNS-1)
      IDK=IBASE(ITCARO+IDKDA-1)
      CALL AEXCPC(IDK,8,IBASE(ITCARO),TEXT8)
      IF((TYPOBJ.EQ.'APOLIBE').AND.(NOMOBJ.EQ.TEXT20)) THEN
         LISO=.TRUE.
         LPTHOM=.FALSE.
         DO 60 IS=1,NS
         IDK=JDKTS+8*(IS-1)
         CALL AEXCPC(IDK,8,IBASE(ITCARO),TYPSEG)
         LNGS=IBASE(ITCARO+IDKLS+IS-1)
         IF(LNGS.LE.0) GO TO 60
         JDKS=IBASE(ITCARO+JDKDS+IS-1)
         CALL AEXTRT(LIBA21,TYPSEG,NBRTYP,ICHDIM,ICHTYP,ICHDKL)
         CALL SETARA(IBASE,LNGS+1,ITSEGM)
         CALL AEXDIR(NIN,LBLOC,IBASE(ITSEGM),JDKS,LNGS+1)
         IF(TYPSEG.EQ.'PTHOM1') THEN
            LPTHOM=.TRUE.
            CALL AEXGNV(16,IBASE(ITSEGM),IBASE(ICHDIM),IBASE(ICHTYP),
     1      IBASE(ICHDKL),IDK,NSEQHO)
            NDIL=NSEQHO-1
            IF(NDIL.GT.MAXDIL) CALL XABORT('LIBDI5: INVALID MAXDIL.')
            DILMAX=BASE(ITSEGM+IDK+NSEQHO-2)
            IF(DILMAX.LT.1.0E10) THEN
               WRITE(HSMG,'(35HLIBDI5: INVALID INFINITE DILUTION (,1P,
     1         E12.4,14H) FOR ISOTOPE ,A12,1H.)') DILMAX,HSHI
               CALL XABORT(HSMG)
            ENDIF
            DO 50 J=1,NSEQHO
   50       DILUT(J)=BASE(ITSEGM+IDK+J-2)
         ENDIF
         CALL RLSARA(IBASE(ITSEGM))
         CALL RLSARA(IBASE(ICHDIM))
         CALL RLSARA(IBASE(ICHTYP))
         CALL RLSARA(IBASE(ICHDKL))
   60    CONTINUE
         IF(.NOT.LPTHOM) CALL XABORT('LIBDI5: NO PTHOM1 SEGMENT '
     1   //'FOR ISOTOPE '//HSHI//'.')
      ENDIF
      CALL RLSARA(IBASE(ITCARO))
   70 CONTINUE
      CALL RLSARA(IBASE(IVINTE))
      IF(.NOT.LISO) CALL XABORT('LIBDI5: UNABLE TO FIND ISOTOPE '
     1 //HSHI//'.')
      IER=KDRCLS(NIN,1)
      IF(IER.LT.0) THEN
         WRITE (HSMG,'(36HLIBDI5: UNABLE TO CLOSE LIBRARY FILE,1X,A16,
     1   1H.)') NAMFIL
         CALL XABORT(HSMG)
      ENDIF
      RETURN
      END
