*DECK LIBEAI
      SUBROUTINE LIBEAI(CFILNA,NEL)
*
*-----------------------------------------------------------------------
*
*Purpose:
* initialize dimensions for depletion data with APOLIB-2
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
*Author(s): A. Hebert
*
*Parameters: input
* CFILNA  APOLIB-2 file name
*
*Parameters: output
* NEL     number of isotopes on library
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER CFILNA*(*)
      INTEGER NEL
*
      EXTERNAL LIBA21
      CHARACTER TYPOBJ*8,TYPSEG*8,TEXT8*8
      INTEGER ISFICH(3),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      INTEGER TKCARO(31)
      SAVE TKCARO
      DATA TKCARO /
     &   0,   1,   2,   3,  4,   5,  6,  30,   7,  -8,
     &   9, -10,  11, -12, 13, -14, 15,  16, -17,  18,
     & -19,  20, -21,  22, 23, -24, 25, -26,  27, -28,
     &  29   /
*----
*  PROBE AND OPEN THE APOLIB-2 FILE.
*----
      CALL AEXTPA(CFILNA,ISFICH)
      IADRES=ISFICH(1)
      NBOBJ=ISFICH(2)
      LBLOC=ISFICH(3)
      IUNIT=KDROPN(CFILNA,2,4,LBLOC,IHANDL)
      IF(IUNIT.LE.0) THEN
         TEXT8=CFILNA
         CALL XABORT('LIBEAI: APOLLO-2 LIBRARY '//TEXT8//' CANNOT BE'//
     >   ' OPENED')
      ENDIF
*----
*  INDEX THE APOLIB-2 FILE.
*----
      CALL SETARA(IBASE,2*NBOBJ,IVINTE)
      CALL AEXDIR(IUNIT,LBLOC,IBASE(IVINTE),IADRES,2*NBOBJ)
      IDKNO=1-TKCARO(14)
      IDKTY=1-TKCARO(21)
      IDKDS=1-TKCARO(10)
      IDKTS=1-TKCARO(23)
      IDKNS=TKCARO(2)+1
      IDKLS=TKCARO(8)
*
      DO 70 I=3,NBOBJ
      IDKOBJ=IBASE(IVINTE+2*I-2)
      LGSEG=IBASE(IVINTE+2*I-1)+1
      CALL SETARA(IBASE,LGSEG,ITCARO)
      CALL AEXDIR(IUNIT,LBLOC,IBASE(ITCARO),IDKOBJ,LGSEG)
      IDK=IBASE(ITCARO+IDKTY-1)
      CALL AEXCPC(IDK,8,IBASE(ITCARO),TYPOBJ)
      JDKDS=IBASE(ITCARO+IDKDS-1)
      JDKTS=IBASE(ITCARO+IDKTS-1)
      NS=IBASE(ITCARO+IDKNS-1)
      IF(TYPOBJ.EQ.'APOLIB') THEN
         DO 60 IS=1,NS
         IDK=JDKTS+8*(IS-1)
         CALL AEXCPC(IDK,8,IBASE(ITCARO),TYPSEG)
         LNGS=IBASE(ITCARO+IDKLS+IS-1)
         IF(LNGS.LE.0) GO TO 60
         JDKS=IBASE(ITCARO+JDKDS+IS-1)
         CALL AEXTRT(LIBA21,TYPSEG,NBRTYP,ICHDIM,ICHTYP,ICHDKL)
         CALL SETARA(IBASE,LNGS+1,ITSEGM)
         CALL AEXDIR(IUNIT,LBLOC,IBASE(ITSEGM),JDKS,LNGS+1)
         IF(TYPSEG.EQ.'PHEAD') THEN
            CALL AEXGNV(3,IBASE(ITSEGM),IBASE(ICHDIM),IBASE(ICHTYP),
     1      IBASE(ICHDKL),IDK,NV)
            IF(NV.EQ.0) THEN
               TEXT8=CFILNA
               CALL XABORT('LIBEAI: NO ISOTOPES PRESENT ON APOLIB-2 '//
     1         'FILE NAMED: '//TEXT8)
            ENDIF
            NEL=NV/20
         ENDIF
         CALL RLSARA(IBASE(ITSEGM))
         CALL RLSARA(IBASE(ICHDIM))
         CALL RLSARA(IBASE(ICHTYP))
         CALL RLSARA(IBASE(ICHDKL))
   60    CONTINUE
      ENDIF
      CALL RLSARA(IBASE(ITCARO))
   70 CONTINUE
      CALL RLSARA(IBASE(IVINTE))
      IERR=KDRCLS(IUNIT,1)
      IF(IERR.LT.0) THEN
         TEXT8=CFILNA
         CALL XABORT('LIBEAI: APOLLO-2 LIBRARY '//TEXT8//' CANNOT BE'//
     >   ' CLOSED')
      ENDIF
      RETURN
      END
