*DECK LIBND6
      SUBROUTINE LIBND6(CFILNA,MAXR,NEL,NMDEPL,ITNAM,ITZEA,KPAX,BPAX,
     > CHILDR,BURNDA,IWISO)
*
*-----------------------------------------------------------------------
*
*Purpose:
* read depletion data on a NDAS formatted library
*
*Copyright:
* Copyright (C) 2006 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
*Author(s): A. Hebert
*
*Parameters: input
* CFILNA  NDAS file name
* MAXR    number of reaction types
* NEL     number of isotopes on library
* NMDEPL  names of reactions:
*           NMDEPL(1)='DECAY'; NMDEPL(2)='NFTOT';
*           NMDEPL(3)='NG'   ; NMDEPL(4)='N2N';
*           etc
*
*Parameters: output
* ITNAM   reactive isotope names in chain
* ITZEA   6-digit nuclide identifier
*         atomic number z*10000 (digits) + mass number a*10 +
*         energy state (0 = ground state, 1 = first state, etc.)
* KPAX    complete reaction type matrix
* BPAX    complete branching ratio matrix
*
*Parameters: scratch
* CHILDR
* BURNDA
* IWISO
*
*-----------------------------------------------------------------------
*
      IMPLICIT NONE
*----
*  Subroutine arguments
*----
      INTEGER MAXR,NEL,ITNAM(3,NEL),ITZEA(NEL),KPAX(NEL+MAXR,NEL),
     > CHILDR(2*NEL),IWISO(NEL)
      CHARACTER CFILNA*(*),NMDEPL(MAXR)*8
      REAL BPAX(NEL+MAXR,NEL),BURNDA(2*NEL)
*
      CALL XABORT('LIBND6: NOT AVAILABLE IN THIS VERSION OF DRAGON.')
      RETURN
      END
