*DECK MCTPSP
      SUBROUTINE MCTPSP(IPTRK,POS,IREG,IEV)
*-----------------------------------------------------------------------
*
*Purpose:
* Store position and region index in TRACKING table for PSP display.
*
*Copyright:
* Copyright (C) 2008 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Le Tellier
*
*Parameters: input
* IPTRK   pointer to the TRACKING data structure.
* POS     point global coordinates.
* IREG    region/surface index.
* IEV     event index.
*
*-----------------------------------------------------------------------
      IMPLICIT NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPTRK,IREG,IEV
      DOUBLE PRECISION POS(3)
*----
*  LOCAL VARIABLES
*----
      INTEGER ILONG,ITYLCM,NPOINT
*     POINTERS
      INTEGER COORD,REGI,EVENT
*     DYNAMIC MEMORY
      INTEGER IBASE(1)
      REAL BASE
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*
      CALL LCMSIX(IPTRK,'MCpoints',1) 
      CALL LCMLEN(IPTRK,'REGI',ILONG,ITYLCM)
      NPOINT=ILONG+1
      CALL SETARA(BASE,6*NPOINT,COORD)
      CALL SETARA(IBASE,NPOINT,REGI)
      CALL SETARA(IBASE,NPOINT,EVENT)
      IF (ILONG.GT.0) THEN
         CALL LCMGET(IPTRK,'COORD',BASE(COORD))
         CALL LCMGET(IPTRK,'REGI',IBASE(REGI))
         CALL LCMGET(IPTRK,'EVENT',IBASE(EVENT))
      ENDIF
      CALL XDDSET(BASE(COORD+6*(NPOINT-1)),1,POS(1))
      CALL XDDSET(BASE(COORD+6*(NPOINT-1)+2),1,POS(2))
      CALL XDDSET(BASE(COORD+6*(NPOINT-1)+4),1,POS(3))
      IBASE(REGI+(NPOINT-1))=IREG
      IBASE(EVENT+(NPOINT-1))=IEV
      CALL LCMPUT(IPTRK,'COORD',6*NPOINT,4,BASE(COORD))
      CALL LCMPUT(IPTRK,'REGI',NPOINT,1,IBASE(REGI))
      CALL LCMPUT(IPTRK,'EVENT',NPOINT,1,IBASE(EVENT))
      CALL RLSARA(IBASE(EVENT))
      CALL RLSARA(IBASE(REGI))
      CALL RLSARA(BASE(COORD))
      CALL LCMSIX(IPTRK,' ',2)
*
      RETURN
      END
