*DECK MESHST
      SUBROUTINE MESHST(IPTRK,IPGEOM,
     >      REMESH,FVOL,STAIRS,FACST,NCEL,IPLANZ,ISTATE,
     >      NCYL,NSECT,NCPHY,VOLSUR,VOL1,VTURN,PHTURN,MATALB,SIDE,NCOUR,
     >      NSMIN,NSMAX,NS,FACB,NVOL,SURB,VSYM,SSYM,IHEX,LXI,NV,
     >          MCODE,SURL,IPLANI,VLAT,ZMIN)
C
C---------------------------- MESHST -----------------------------------
C
C       FUNCTION : - NUMEROTATION GLOBALE DE L'ASSEMBLAGE AVEC PRISE EN
C                  COMPTE DES REGROUPEMENTS DES CELLULES ET DE LEURES
C                  ORIENTATION (MERGE ET TURN)
C                  - AFFECTATION DES ALBEDOS AUX SURFACES EXTERIEURES
C                  - CALCUL DES VOLUMES DE TOUTES LES REGIONS ET DES
C                  SURFACES DES FACES EXTERNES
C                  - COORDONNEES DES HEXAGONES ET DES CYLINDRES SUR
C                  TOUTE LA GEOMETRIE
C       CREATION : JUNE 16,1991
C       REVISED  :
C       AUTHOR   : M.OUISLOUMEN
C
C
C INPUT PARAMETERS
C
C     MCODE  :  =1 SI SYMETRIE Z-,=2 SI SYMETRIE Z+, =0 SI NON
C
C OUTPUT PARAMETERS
C     REMESH : COORDONNEES DES GEOMETRIES (VOIR TRKHEX)
C    FVOL(I) : NUMERO DE LA PREMIERE ZONE DE LA CELLULE I
C    NVOL(I) : NUMERO DU PREMIER VOLUME DE LA CELLULE I AVEC SECTEURS
C    LVOL(I) : NUMERO DU VOLUME OU DEVRAIT DEBUTER LA NUMEROTATION
C    STAIRS  : VOIR TRKHEX
C    FACST   : VOIR TRKHEX
C      NCEL  : NRBE DE CELLULES DE L'ASSEMBLAGE
C  LSENS(I)  : =1, SI LA NUMEROTATION EST DANS LE SENS NORMALE,=2,SINON
C  NSECT(I)  : 6*(NSECT(I)-1)= NUMBER OF SECTORS IN REGION I
C  NCYL(I)   : NBRE DE CYLINDRE DANS LA CELLULE I
C  NCPHY     : NBRE DE CELLULE PHYSIQUE
C  VOLSUR    : VOLUMES ET SUFACES EXTERNES
C  MATALB    : NUMERO DES ALBEDOS POUR DIFFERENTES SURFACES ET MIX POUR
C              DIFFERENTS VOLUMES
C  FACB(I)   : DEBUT DE NUMEROTATION DES FACES SUP OU INF POUR LA
C              CELLULE PERIPHERIQUE I
C  SURB(I)   : DEBUT DE NUMEROTATION DE LA CELLULE I
C  VSYM(I)   : CONTIENT LES NUMEROS DES VOLUMES DE LA SYMETRIE D'ENTREE
C  SSYM(I)   : CONTIENT LES NUMEROS DES SURFACES DE LA SYMETRIE D'ENTREE
C
C SCRATCH STORAGE
C
C      VOL1  : DIMENSION NCPHY
C      VTURN : DIMENSION NCPHY
C     PHTURN : DIMENSION NCPHY
C
C
C--------------------------- MESHST ------------------------------------
C
      IMPLICIT    NONE
      INTEGER     NSTATE
      REAL        PI,SQRT3
      PARAMETER  (NSTATE=40)
      PARAMETER  (PI=3.141592653589793,SQRT3=1.732050807568877)
      INTEGER     IPTRK,IPGEOM,NCEL,IPLANZ,NCPHY,
     >            NCOUR,IHEX,LXI,NV,MCODE,IPLANI
      INTEGER     FVOL(NCEL),STAIRS(IPLANZ),FACST(IPLANZ),
     >            ISTATE(NSTATE),VOL1(NCPHY),VTURN(NCPHY),
     >            PHTURN(NCPHY),MATALB(*),NVOL(*),NSMIN,NSMAX,NS,
     >            NSECT(*),NCYL(NCEL),FACB(*),SURB(*),
     "            VSYM(*),SSYM(*),SURL(*),VLAT(*)
      REAL        REMESH(*),VOLSUR(*),SIDE,ZMIN
*----
* LOCAL VARIABLES
*----
      CHARACTER   TEXT12*12
      LOGICAL     LGCELL,L1CELL,LGSS,LGTURN,LG3D,LGPASS,LSPLIT,LGMERG
      REAL        POIDSH
      INTEGER     IFONC,IFCOUR,N,L
      INTEGER     NEIGHB
      INTEGER     LLL,KSS,LX,LZ,ISTAT9,NDIM,LZZ,ILENT,ITP,ICEL2,
     >            I,ICEL0,NCOUS,ICOU,KCEL,LCEL,ILENZ,IAZ,K,IAUX,
     >            ISURFP,ISURF,ISAUX,JSUR,ISF,IPOINT,KREG,KSURF1,
     >            KSURF2,NSURF1,NSURF2,ISUR,ITC,ILENR,MDR,IOFS,
     >            NRAY,IFRAY,ILENSP,LRAY,MADD,J,ISEC,LSECT,MIXF,
     >            IFVOL,NZONE,MVOL,JVOL,IVOL,ISURB,JSURB,IST,IY,KZAUX,
     >            NAUX,MIXX,JSP,KBB,JJ,IV,IS,ILENS,ITS,IC,KMIX,NMIX,
     >            IXZPL,KXI,NXI,LFF,LZF,ISTO,ISS1,IMERMX,ISZ,
     >            IFRT,IMER0,IMER1,ISX,IMERG,JMERG,MMCYL,IZON,IFF,
     >            ILENM,IMX2
      INTEGER     JSECT,LL,IZZ,KY,IMMS,IBSS,IFR0,IXX,ICCOIN,KCCOIN,
     >            MROT,NCPER,ISURSY,MSMAX,ISSXX,IPPZ,IPP1,IXP,JCCOIN,
     >            JP,MXI,IP,ISURB6,ITT9,ISURSX,KSURBX,K1,ICX,ICY,ICZ,
     >            IDEBX,NBASE,ICELC0,ICELC1,NCC,MCYL,NZONE1,IA,
     >            NSECTO,IV1,JVT,IVTURN,ITURN,KAUX,KVOL1,KVOL2,
     >            KSECTX,NZZ,ICXX,ICELC,ICLIM,IXX0,ISS0,JSS0,M,ISS2,
     >            IJSUR,KKB,IXV,LFROT,IVFIN,IVORIN,IVMIN,IVSYM,NZON,
     >            IVAUX,IVMAX,IVOR,IVV,IVSYM0,IVV1,KVV,KVOR,ISY,MSAUX,
     >            IVLMAX,NSAUX,IPPX,ISYAUX,LSMAX,LSPLZM,IDDX,KX2,KSECT
      INTEGER     KX1,KXP,IDEB,IYAUX,II,KSAUX,IVLAT,JTX,IX1,JX,IFR,IW,
     >            JW,MSUR,MCPHY,ISYX,LSPLZP
      REAL        VEX,X,Y,XM,YM,XP,YP,YPP,ZAUX,ZBUX,Z,SURF,R1,R2,PAS,
     >            VOLUM1,VOLUM2,R,VOLUME,VOLUMS,VCYL,SAUX,XTAN,SAUX1
C----
C  MEMORY ALLOCATION COMMON
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     IZ,MXX,IRAY,ISS,KRAY,IMIX,IPSECT,IOF,ICC,ICEL,
     >            IMX,ISECT,IRR,KNUM,NUMG,ITRN,ISPZ,KVOL,ISXY,IBB,
     >            ITT,IAA
*----
*  DATA
*----
      INTEGER     ROT(12)
      SAVE        ROT
      DATA        ROT /2,3,4,5,6,1,6,1,2,3,4,5/
C
      IFONC(N,L)= 2+(N-1)*(L+3*(N-2))
      IFCOUR(N)=NINT( (4.+SQRT(1.+4.*FLOAT(N-1)/3.)
     +                 +SQRT(1.+4.*FLOAT(N-2)/3.))*.25)
C
      LZ=ISTATE(5)
      LX=ISTATE(3)
      ISTAT9=ISTATE(9)
      LGCELL=.FALSE.
      L1CELL=.FALSE.
      LGSS=.FALSE.
      LGTURN=.FALSE.
      LG3D=.FALSE.
      IF(ISTATE(8).EQ.1) LGCELL=.TRUE.
      NDIM=2
      LZZ=1
      L1CELL=(LX.EQ.1)
      IF(LZ.GT.0) THEN
        NDIM=3
        LG3D=.TRUE.
        LZZ=LZ
        L1CELL=(LX*LZ.EQ.1)
      ENDIF
      VEX=1.5*SQRT(3.)*SIDE*SIDE
      CALL LCMLEN(IPGEOM,'TURN',ILENT,ITP)
      IF(ILENT.GT.0) LGTURN=.TRUE.
      NCOUR=1
      IF(LX.GT.1)NCOUR=IFCOUR(LX)
C
C              COORDONNEES DES CENTRES DES HEXAGONES
C
      X=0.
      Y=0.
      XM=0.
      YM=0.
      YP=0.
      XP=0.
      ICEL=1
   18 REMESH(ICEL)=X
      REMESH(NCEL+ICEL)=Y
      ICEL2=NEIGHB(ICEL,2,9,LX,POIDSH)
      IF(ICEL2.GT.LX) GOTO 20
      ICEL=ICEL2
      Y=Y+SIDE*SQRT3
      GO TO 18
   20 ICEL=1
      Y=0
   21 ICEL2=NEIGHB(ICEL,5,9,LX,POIDSH)
      IF(ICEL2.GT.LX) GOTO 22
      ICEL=ICEL2
      REMESH(ICEL)=X
      Y=Y-SIDE*SQRT3
      REMESH(NCEL+ICEL)=Y
      GOTO 21
   22 CONTINUE
      DO 30 I=2,NCOUR
         LGPASS=.FALSE.
         XP=XP+1.5*SIDE
         YP=YP+.5*SIDE*SQRT3
         ICEL=IFONC(I,0)
         ICEL0=ICEL
         X=XP
         Y=YP
         YPP=YP
   23    REMESH(ICEL)=X
         REMESH(NCEL+ICEL)=Y
         ICEL2=NEIGHB(ICEL,2,9,LX,POIDSH)
         IF(ICEL2.GT.LX) GOTO 25
         Y=Y+SIDE*SQRT3
         ICEL=ICEL2
         GO TO 23
   25    ICEL=ICEL0
         Y=YP
   26    ICEL2=NEIGHB(ICEL,5,9,LX,POIDSH)
         IF(ICEL2.GT.LX) GOTO 27
         Y=Y-SIDE*SQRT3
         ICEL=ICEL2
         REMESH(ICEL)=X
         REMESH(NCEL+ICEL)=Y
         GOTO 26
   27    IF(LGPASS) GOTO 28
         XM=XM-1.5*SIDE
         YM=YM+.5*SIDE*SQRT3
         YPP=YM
         ICEL=IFONC(I,2)
         ICEL0=ICEL
         X=XM
         Y=YM
         LGPASS=.TRUE.
         GO TO 23
   28    CONTINUE
   30 CONTINUE
C
C         POUR EVITER DES EFFETS DE DIFFERENCE
C
      NCOUS=7
      DO 31 ICOU=3,NCOUR,2
         KCEL=IFONC(ICOU,0)+6*ICOU-NCOUS
         LCEL=KCEL-3*(ICOU-1)
         REMESH(NCEL+KCEL)=0.
         REMESH(NCEL+LCEL)=0.
         NCOUS=NCOUS+1
   31 CONTINUE
      STAIRS(1)=LX
      IF(LG3D) THEN
        CALL LCMSIX(IPTRK,'DATA DUP',1)
        CALL LCMLEN(IPTRK,'MESHZ',ILENZ,ITP)
        IF(ILENZ.NE.LZZ+1)CALLXABORT('MESHST: MISSING DIMENSION MESHZ')
        CALL SETARA(RBASE,ILENZ,IZ)
        CALL LCMGET(IPTRK,'MESHZ',RBASE(IZ))
        CALL LCMSIX(IPTRK,' ',2)
C
C--- TEST SUR L'ORDONANCE DES PLANS DES CELLULES SUIVANT L'AXE Z
C
        ZAUX=RBASE(IZ)
        ZMIN=ZAUX
        DO 29 IAZ=1,ILENZ-1
          ZBUX=RBASE(IZ+IAZ)
       IF(ZAUX.GE.ZBUX)CALLXABORT('MESHST: INVALID CELLS PLAN POSITION')
          ZAUX=ZBUX
   29   CONTINUE
        Z=RBASE(IZ+1)
        DO 32 K=1,LX
          REMESH(2*NCEL+K)=Z
   32   CONTINUE
        IAUX=0
        DO 35 I=2,LZ
          STAIRS(I)=I*LX
          Z=RBASE(IZ+I)
          DO 33 K=1,LX
            IAUX=IAUX+1
            REMESH(LX+IAUX)=REMESH(K)
            REMESH(NCEL+LX+IAUX)=REMESH(NCEL+K)
            REMESH(2*NCEL+LX+IAUX)=Z
   33     CONTINUE
   35   CONTINUE
      ENDIF
C
C           CALCUL DES SURFACES EXTERNES ET AFFECTATION DES ALBEDOS
C
      ISURFP=6
      IF(NCOUR.GT.1)ISURFP=6*(3+2*(NCOUR-2))
      ISS=1
      ISURF=NS
      ISAUX=ISURF
      IF(LG3D) THEN
        ISAUX=ISURF-NSMAX
        ISS=NSMIN+1
        DO 70 I=1,NSMIN
           MATALB(I)=-6
   70   CONTINUE
        DO 71 I=1,NSMAX
           MATALB(ISAUX+I)=-5
   71   CONTINUE
      ENDIF
      DO 75 I=ISS,ISAUX
         MATALB(I)=-1
   75 CONTINUE
      JSUR=NS-NSMAX+1
      DO 80 K=1,LZZ
         ISF=ISS+ISURFP-1
         SURF=SIDE
         FACST(K)=ISF
         ISS=ISF+1
   80 CONTINUE
      IPOINT=2*NCEL
      IF(LG3D) THEN
         IPOINT=3*NCEL
      ENDIF
C
      KREG=ISURF+1
      VOLSUR(KREG)=0.
      MATALB(KREG)=0
      KSURF1=0
      KSURF2=ISAUX
      NSURF1=NSMIN+1
      NSURF2=NS+1
      ISUR=0
      IF(L1CELL) THEN
C
C            CAS D'UNE SEULE CELLULE
C
        CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITC)
        CALL LCMLEN(IPGEOM,'RADIUS',ILENR,IRR)
        MDR=ILENR
        IF(ILENR.EQ.0) MDR=1
        CALL SETARA(IBASE,MDR,ISECT)
        CALL SETARA(IBASE,MDR,MXX)
        CALL LCMLEN(IPGEOM,'MIX',ILENM,ITP)
        IF(ILENS.GT.0) THEN
          IF(ILENS.NE.MDR) CALL XABORT('MESHST: INCONSISTENT LENGTHS(1'
     +    //').')
          CALL LCMGET(IPGEOM,'SECTOR',IBASE(ISECT))
          K=0
          DO J=1,MDR
            K=K+6*(IBASE(ISECT+J-1)-1)
          ENDDO
          IF(K.NE.ILENM) THEN
            CALL XABORT('MESHST: SECTOR-DEFINED MIX INDICES EXPECTED(1'
     +      //').')
          ENDIF
          CALL SETARA(IBASE,ILENM,IMX2)
          CALL LCMGET(IPGEOM,'MIX',IBASE(IMX2))
          IOFS=0
          DO J=1,MDR
            IOFS=IOFS+1
            IBASE(MXX+J-1)=IBASE(IMX2+IOFS-1)
            DO K=2,6*(IBASE(ISECT+J-1)-1)
              IOFS=IOFS+1
              IF(IBASE(IMX2+IOFS-1).NE.IBASE(MXX+J-1)) THEN
                CALL XABORT('MESHST: SECTOR-DEPENDENT MIX NOT IM'
     +          //'PLEMENTED(1).')
              ENDIF
            ENDDO
          ENDDO
          CALL RLSARA(IBASE(IMX2))
        ELSE
          IF(ILENM.NE.MDR) CALL XABORT('MESHST: INCONSISTENT LENGTHS(2'
     +    //').')
          CALL LCMGET(IPGEOM,'MIX',IBASE(MXX))
          CALL XDISET(IBASE(ISECT),MDR,1)
        ENDIF
        IMIX=MXX
        NRAY=0
        IFRAY=ILENR-1
        IF(ILENR.GT.0) THEN
          CALL SETARA(RBASE,ILENR,IRAY)
          CALL LCMGET(IPGEOM,'RADIUS',RBASE(IRAY))
          CALL LCMLEN(IPGEOM,'SPLITR',ILENSP,ITP)
          KRAY=IRAY
          LRAY=KRAY+1
          NRAY=ILENR-1
          IF(ILENSP.GT.0) THEN
            IF(ITP.NE.1.OR.ILENSP.NE.ILENR-1)
     +         CALL XABORT('MESHST: '//
     +                     'MISSING TYPE OR DIMENSION OF SPLITR')
            CALL SETARA(IBASE,NRAY,ISS)
            CALL LCMGET(IPGEOM,'SPLITR',IBASE(ISS))
            NRAY=0
            DO 101 I=0,ILENSP-1
               NRAY=NRAY+ABS(IBASE(ISS+I))
  101       CONTINUE
            CALL SETARA(RBASE,NRAY,KRAY)
            CALL SETARA(IBASE,NRAY+1,IMIX)
            CALL SETARA(IBASE,NRAY+1,IPSECT)
            LRAY=KRAY
            R1=0.
            MADD=-1
            DO 103 J=1,ILENSP
               ISEC=IBASE(ISS+J-1)
               LSECT=IBASE(ISECT+J-1)
               MIXF=IBASE(MXX+J-1)
               IF(ISEC.EQ.0)CALL XABORT('MESHST: INVALID SPLITR')
               IF(ISEC.GT.0) THEN
                R2=RBASE(IRAY+J)
                PAS=(R2-R1)/FLOAT(ISEC)
                DO 111 K=1,ISEC
                  MADD=MADD+1
                  RBASE(KRAY+MADD)=R1+PAS*FLOAT(K)
                  IBASE(IMIX+MADD)=MIXF
                  IBASE(IPSECT+MADD)=LSECT
  111           CONTINUE
                R1=R2
               ELSE
                R2=RBASE(IRAY+J)
                R1=R1**2
                R2=R2**2
                PAS=(R2-R1)/FLOAT(-ISEC)
                DO 112 K=1,-ISEC
                  MADD=MADD+1
                  RBASE(KRAY+MADD)=SQRT(R1+PAS*FLOAT(K))
                  IBASE(IMIX+MADD)=MIXF
                  IBASE(IPSECT+MADD)=LSECT
  112           CONTINUE
                R1=SQRT(R2)
               ENDIF
  103       CONTINUE
            IBASE(IMIX+NRAY)=IBASE(MXX+ILENR-1)
            IBASE(IPSECT+NRAY)=IBASE(ISECT+ILENR-1)
            CALL RLSARA(RBASE(IRAY))
            CALL RLSARA(IBASE(MXX))
            CALL RLSARA(IBASE(ISS))
            CALL RLSARA(IBASE(ISECT))
            ISECT=IPSECT
          ENDIF
        ENDIF
        IAUX=2
        IF(LG3D)IAUX=3*NCEL
        IFVOL=0
        NZONE=NRAY+1
        MVOL=0
        JVOL=1
        IVOL=0
        ISURB=NSMIN
        JSURB=0
        DO 119 I=1,NCEL
           NVOL(I)=JVOL
           IF(LG3D) THEN
             Z=REMESH(2*NCEL+I)
             IF(I.GT.STAIRS(1)) THEN
             IST=1
             DO 129 IY=2,LZZ
             IF(I.LE.STAIRS(IY)) THEN
               IST=IY-1
               GOTO 139
             ENDIF
  129        CONTINUE
  139        KZAUX=I-STAIRS(IST)
             IF(IST.GT.1)KZAUX=KZAUX+STAIRS(IST-1)
             Z=Z-REMESH(2*NCEL+KZAUX)
             ENDIF
           ENDIF
           NCYL(I)=NRAY
           FVOL(I)=IFVOL+1
           IFVOL=IFVOL+NZONE
           DO 117 J=1,NRAY
              IAUX=IAUX+1
              REMESH(IAUX)=RBASE(LRAY+J-1)
  117      CONTINUE
           VOLUM1=0.
           IF(LG3D) THEN
             IF(IPLANZ.GT.1) THEN
               IF(I.LE.STAIRS(1)) THEN
                 FACB(I)=KSURF1
               ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                 ISUR=ISUR+1
                 FACB(LX+ISUR)=KSURF2
               ENDIF
             ELSE
               FACB(I)=KSURF1
               FACB(LX+I)=KSURF2
             ENDIF
           ENDIF
           DO 120 J=1,NRAY+1
             MVOL=MVOL+1
             KSECT=IBASE(ISECT+J-1)
             NSECT(MVOL)=KSECT
             NAUX=1
             IF(KSECT.GT.1) NAUX=6*(KSECT-1)
             IVOL=IVOL+NAUX
             MIXX=IBASE(IMIX+J-1)
             KREG=KREG+1
             IF(J.EQ.NZONE) THEN
                VOLUM2=VEX
             ELSE
                R=RBASE(LRAY+J-1)
                VOLUM2=PI*R*R
             ENDIF
             VOLUME=(VOLUM2-VOLUM1)/REAL(NAUX)
             IF(LG3D) THEN
                VOLUMS=VOLUME*.25
C
C     SURFACES SUPERIEURES ET INFERIEURES (SELON L'AXE Z)
C
                IF(IPLANZ.GT.1) THEN
                  IF(I.LE.STAIRS(1)) THEN
                    KSURF1=KSURF1+1
                    NSURF1=NSURF1-1
                    VOLSUR(NSURF1)=VOLUMS
                  ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                    KSURF2=KSURF2+1
                    NSURF2=NSURF2-1
                    VOLSUR(NSURF2)=VOLUMS
                  ENDIF
                ELSE
                  KSURF1=KSURF1+1
                  NSURF1=NSURF1-1
                  VOLSUR(NSURF1)=VOLUMS
                  KSURF2=KSURF2+1
                  NSURF2=NSURF2-1
                  VOLSUR(NSURF2)=VOLUMS
                ENDIF
                VOLUME=VOLUME*Z
             ENDIF
             VOLUM1=VOLUM2
             VOLSUR(KREG)=VOLUME
             MATALB(KREG)=MIXX
             DO 121 K=2,NAUX
                KREG=KREG+1
                VOLSUR(KREG)=VOLUME
                MATALB(KREG)=MIXX
                IF(LG3D) THEN
                  IF(IPLANZ.GT.1) THEN
                    IF(I.LE.STAIRS(1)) THEN
                      KSURF1=KSURF1+1
                      NSURF1=NSURF1-1
                      VOLSUR(NSURF1)=VOLUMS
                    ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                      KSURF2=KSURF2+1
                      NSURF2=NSURF2-1
                      VOLSUR(NSURF2)=VOLUMS
                    ENDIF
                  ELSE
                    KSURF1=KSURF1+1
                    NSURF1=NSURF1-1
                    VOLSUR(NSURF1)=VOLUMS
                    KSURF2=KSURF2+1
                    NSURF2=NSURF2-1
                    VOLSUR(NSURF2)=VOLUMS
                  ENDIF
                ENDIF
  121        CONTINUE
             JVOL=IVOL+1
  120      CONTINUE
           SURF=SIDE
           JSP=6
           KBB=1
           IF(KSECT.GT.1) THEN
             SURF=SIDE/(KSECT-1)
             JSP=NAUX
             KBB=KSECT-1
           ENDIF
           IF(LG3D)SURF=SURF*Z
           DO 118 JJ=1,JSP
              JSUR=JSUR-1
              VOLSUR(JSUR)=.25*SURF
  118      CONTINUE
           DO 122 JJ=1,6
              JSURB=JSURB+1
              SURB(JSURB)=ISURB
              ISURB=ISURB+KBB
  122      CONTINUE
  119   CONTINUE
        CALL RLSARA(IBASE(IMIX))
        CALL RLSARA(IBASE(ISECT))
        IF(LG3D)CALL RLSARA(RBASE(IZ))
        IF(NRAY.GT.0)CALL RLSARA(RBASE(KRAY))
        DO 715 IV=1,NV
         VSYM(IV)=IV
  715   CONTINUE
        DO 716 IS=1,NS
         SSYM(IS)=IS
  716   CONTINUE
        RETURN
      ENDIF
C         CAS D'UN ASSEMBLAGE DE CELLULE
C
   81 IF(LGCELL) THEN
C
C               SPLITING DES RAYONS ET DEFINITION DES SECTEURS POUR
C               LES CELLULES GENERATRICES
C
         CALL SETARA(IBASE,3*ISTAT9,IOF)
         CALL SETARA(IBASE,ISTAT9,ICC)
         CALL SETARA(IBASE,3*ISTAT9,ICEL)
         CALL LCMGET(IPGEOM,'CELL',IBASE(ICEL))
         DO 10 I=1,ISTAT9
            WRITE(TEXT12(1:4),'(A4)') IBASE(ICEL+3*(I-1))
            WRITE(TEXT12(5:8),'(A4)') IBASE(ICEL+3*I-2)
            WRITE(TEXT12(9:12),'(A4)') IBASE(ICEL+3*I-1)
            CALL LCMSIX(IPGEOM,TEXT12,1)
            CALL LCMLEN(IPGEOM,'RADIUS',ILENR,ITP)
            CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITS)
            CALL SETARA(IBASE,ILENR,ISECT)
            CALL SETARA(IBASE,ILENR,IMX)
            IF(ILENR.GT.0) THEN
              CALL LCMLEN(IPGEOM,'MIX',ILENM,ITP)
              IF(ILENS.GT.0) THEN
                IF(ILENS.NE.ILENR) CALL XABORT('MESHST: INCONSISTENT L'
     +          //'ENGTHS(3).')
                CALL LCMGET(IPGEOM,'SECTOR',IBASE(ISECT))
                K=0
                DO J=1,ILENR
                  K=K+6*(IBASE(ISECT+J-1)-1)
                ENDDO
                IF(K.NE.ILENM) THEN
                  CALL XABORT('MESHST: SECTOR-DEFINED MIX INDICES EXPE'
     +            //'CTED(2).')
                ENDIF
                CALL SETARA(IBASE,ILENM,IMX2)
                CALL LCMGET(IPGEOM,'MIX',IBASE(IMX2))
                IOFS=0
                DO J=1,ILENR
                  IOFS=IOFS+1
                  IBASE(IMX+J-1)=IBASE(IMX2+IOFS-1)
                  DO K=2,6*(IBASE(ISECT+J-1)-1)
                    IOFS=IOFS+1
                    IF(IBASE(IMX2+IOFS-1).NE.IBASE(IMX+J-1)) THEN
                      CALL XABORT('MESHST: SECTOR-DEPENDENT MIX NOT IM'
     +                //'PLEMENTED(2).')
                    ENDIF
                  ENDDO
                ENDDO
                CALL RLSARA(IBASE(IMX2))
              ELSE
                IF(ILENM.NE.ILENR) CALL XABORT('MESHST: INCONSISTENT L'
     +          //'ENGTHS(4).')
                CALL XDISET(IBASE(ISECT),ILENR,1)
                CALL LCMGET(IPGEOM,'MIX',IBASE(IMX))
              ENDIF
              CALL LCMLEN(IPGEOM,'SPLITR',ILENSP,ITP)
              IF(ILENSP.GT.0) THEN
                IF(ITP.NE.1.OR.ILENSP.NE.ILENR-1)
     +            CALL XABORT('MESHST: '//
     +                        'MISSING TYPE OR DIMENSION OF SPLITR')
                CALL SETARA(RBASE,ILENR,IRR)
                CALL LCMGET(IPGEOM,'RADIUS',RBASE(IRR))
                CALL SETARA(IBASE,ILENSP,ISS)
                CALL LCMGET(IPGEOM,'SPLITR',IBASE(ISS))
                NRAY=1
                DO 5 J=0,ILENSP-1
                 NRAY=NRAY+ABS(IBASE(ISS+J))
    5           CONTINUE
                CALL SETARA(RBASE,NRAY,IBASE(IOF+I-1))
                CALL SETARA(IBASE,NRAY,IBASE(IOF+ISTAT9+I-1))
                CALL SETARA(IBASE,NRAY,IBASE(IOF+2*ISTAT9+I-1))
                KMIX=0
                DO 7 J=0,ILENR-2
                   NMIX=IBASE(IMX+J)
                   ISEC=IBASE(ISS+J)
                   LSECT=IBASE(ISECT+J)
                   IF(ISEC.EQ.0)CALL XABORT('MESHST: INVALID SPLITR')
                   DO 6 L=1,ABS(ISEC)
                      IBASE(IBASE(IOF+ISTAT9+I-1)+KMIX)=NMIX
                      IBASE(IBASE(IOF+2*ISTAT9+I-1)+KMIX)=LSECT
                      KMIX=KMIX+1
    6              CONTINUE
    7           CONTINUE
                IBASE(IBASE(IOF+ISTAT9+I-1)+KMIX)=IBASE(IMX+ILENR-1)
                IBASE(IBASE(IOF+2*ISTAT9+I-1)+KMIX)=IBASE(ISECT+ILENR-1)
                RBASE(IBASE(IOF+I-1))=0.
                R1=0.
                IAUX=0
                DO 109 K=1,ILENSP
                  ISEC=IBASE(ISS+K-1)
                  IF(ISEC.EQ.0)CALLXABORT('MESHST: INVALID SPLITR')
                  IF(ISEC.GT.0) THEN
                   R2=RBASE(IRR+K)
                   PAS=(R2-R1)/FLOAT(ISEC)
                   DO 8 L=1,ISEC
                    IAUX=IAUX+1
                    RBASE(IBASE(IOF+I-1)+IAUX)=R1+PAS*REAL(L)
    8              CONTINUE
                   R1=R2
                  ELSE
                   R2=RBASE(IRR+K)
                   R1=R1**2
                   R2=R2**2
                   PAS=(R2-R1)/FLOAT(-ISEC)
                   DO 108 L=1,-ISEC
                    IAUX=IAUX+1
                    RBASE(IBASE(IOF+I-1)+IAUX)=SQRT(R1+PAS*REAL(L))
  108              CONTINUE
                   R1=SQRT(R2)
                  ENDIF
  109           CONTINUE
                CALL RLSARA(IBASE(ISS))
                CALL RLSARA(RBASE(IRR))
                IBASE(ICC+I-1)=NRAY-1
              ELSE
                IBASE(ICC+I-1)=ILENR-1
                CALL SETARA(RBASE,ILENR,IBASE(IOF+I-1))
                CALL LCMGET(IPGEOM,'RADIUS',RBASE(IBASE(IOF+I-1)))
                CALL SETARA(IBASE,ILENR,IBASE(IOF+ISTAT9+I-1))
                CALL SETARA(IBASE,ILENR,IBASE(IOF+2*ISTAT9+I-1))
                DO 9 J=0,ILENR-1
                   IBASE(IBASE(IOF+ISTAT9+I-1)+J)=IBASE(IMX+J)
                   IBASE(IBASE(IOF+2*ISTAT9+I-1)+J)=IBASE(ISECT+J)
    9           CONTINUE
              ENDIF
              CALL RLSARA(IBASE(IMX))
              CALL RLSARA(IBASE(ISECT))
             ELSE
              IBASE(ICC+I-1)=0
              CALL SETARA(IBASE,1,IBASE(IOF+ISTAT9+I-1))
              CALL SETARA(IBASE,1,IBASE(IOF+2*ISTAT9+I-1))
              CALL LCMLEN(IPGEOM,'MIX',ILENM,ITP)
              IF(ILENS.GT.0) THEN
             CALL LCMGET(IPGEOM,'SECTOR',IBASE(IBASE(IOF+2*ISTAT9+I-1)))
                IF(6*(IBASE(IBASE(IOF+2*ISTAT9+I-1))-1).NE.ILENM) THEN
                  CALL XABORT('MESHST: SECTOR-DEFINED MIX INDICES EXPE'
     +            //'CTED(3).')
                ENDIF
                CALL SETARA(IBASE,ILENM,IMX2)
                CALL LCMGET(IPGEOM,'MIX',IBASE(IMX2))
                DO K=2,6*(IBASE(IBASE(IOF+2*ISTAT9+I-1))-1)
                  IF(IBASE(IMX2+K-1).NE.IBASE(IMX2)) THEN
                    CALL XABORT('MESHST: SECTOR-DEPENDENT MIX NOT IMPL'
     +              //'EMENTED(3).')
                  ENDIF
                ENDDO
                IBASE(IBASE(IOF+ISTAT9+I-1))=IBASE(IMX2)
                CALL RLSARA(IBASE(IMX2))
              ELSE
                IF(ILENM.NE.1) CALL XABORT('MESHST: INCONSISTENT LENGT'
     +          //'HS(5).')
                CALL LCMGET(IPGEOM,'MIX',IBASE(IBASE(IOF+ISTAT9+I-1)))
                IBASE(IBASE(IOF+2*ISTAT9+I-1))=1
              ENDIF
             ENDIF
             IF(ILENS.EQ.0) THEN
               IF(LGTURN)CALL XABORT('MESHST: SECTOR MUST BE DEFINED '//
     +                               'OR CANCEL TURN ')
             ENDIF
             CALL LCMSIX(IPGEOM,' ',2)
   10    CONTINUE
C--- NUMEROTATION DES VOLUMES DE LA SYMETRIE D'ENTREE
         IXZPL=IPLANZ
         IF(MCODE.GT.0)IXZPL=IPLANI
         KXI=LXI*IXZPL
         NXI=KXI
         IF(IHEX.LE.9) THEN
           CALL LCMSIX(IPTRK,'DATA DUP',1)
           CALL LCMLEN(IPTRK,'SPLITZD',LFF,KSS)
           CALL LCMSIX(IPTRK,' ',2)
           LSPLIT=.FALSE.
           LZF=IXZPL
           IF(LFF.GT.0) THEN
             LZF=LFF
             NXI=LXI*LZF
             LSPLIT=.TRUE.
           ENDIF
           CALL SETARA(IBASE,2*NXI,KNUM)
           CALL LCMLEN(IPGEOM,'MERGE',LLL,KSS)
           LGMERG=.FALSE.
           IF(LLL.GT.0) THEN
             CALL LCMGET(IPGEOM,'MERGE',IBASE(KNUM))
             LGMERG=.TRUE.
             CALL SETARA(IBASE,NXI,NUMG)
             CALL LCMGET(IPGEOM,'MIX',IBASE(NUMG))
             DO I=1,NXI
               IBASE(NUMG+I-1)=-IBASE(NUMG+I-1)
             ENDDO
           ELSE
             CALL LCMGET(IPGEOM,'MIX',IBASE(KNUM))
             DO I=1,NXI
               IBASE(KNUM+I-1)=-IBASE(KNUM+I-1)
             ENDDO
             NUMG=KNUM
           ENDIF
           IF(LGTURN) THEN
             CALL LCMGET(IPGEOM,'TURN',IBASE(KNUM+NXI))
           ELSE
             CALL XDISET(IBASE(KNUM+NXI),NXI,1)
             LGTURN=.TRUE.
           ENDIF
           IVOL=0
           ISTO=0
           CALL SETARA(IBASE,KXI*3,ITRN)
           CALL SETARA(IBASE,LZF,ISPZ)
           IF(LSPLIT) THEN
              CALL LCMSIX(IPTRK,'DATA DUP',1)
              CALL LCMGET(IPTRK,'SPLITZD',IBASE(ISPZ))
              CALL LCMSIX(IPTRK,' ',2)
           ELSE
              CALL XDISET(IBASE(ISPZ),LZF,1)
           ENDIF
           CALL SETARA(IBASE,KXI,KVOL)
           ISS=-1
           ISS1=-1
           IMERMX=0
           DO 182 ISZ=0,LZF-1
           IFRT=ISS1
           IMER0=IBASE(KNUM+LXI*ISZ)
           IMER1=IMER0
           DO 482 ISX=1,LXI
             ISS=ISS+1
             ISS1=ISS1+1
             IMERG=IBASE(KNUM+ISS1)
             JMERG=IBASE(NUMG+ISS1)
             MMCYL=IBASE(ICC+JMERG-1)
             IF(LSPLIT) THEN
               IMER0=MAX(IMER0,IMERG)
               IMER1=MIN(IMER1,IMERG)
             ENDIF
             IZON=0
             DO 171 IFF=1,MMCYL+1
               JSECT=IBASE(IBASE(IOF+2*ISTAT9+JMERG-1)+IFF-1)
               IF(JSECT.GT.1) THEN
                 LL=JSECT-1
                 IZZ=6*LL
               ELSE
                 LL=1
                 IZZ=1
               ENDIF
               IZON=IZON+IZZ
  171        CONTINUE
             IMERG=IMERG+IMERMX
             IF(LGMERG) THEN
               DO 281 KY=0,ISTO-1
                 IF(IMERG.EQ.IBASE(ITRN+KXI+KY)) THEN
                   IMMS=IBASE(ITRN+2*KXI+KY)
                   IBSS=IBASE(KVOL+IMMS)
                   IBASE(KVOL+ISS)=IBSS
                   IBASE(ITRN+ISS)=IBASE(ITRN+IMMS)
                   GOTO 381
                 ENDIF
  281          CONTINUE
             ENDIF
             IBASE(ITRN+KXI+ISTO)=IMERG
             IBASE(ITRN+2*KXI+ISTO)=ISS
             ISTO=ISTO+1
             IBASE(KVOL+ISS)=IVOL+1
             IVOL=IVOL+IZON
             IBASE(ITRN+ISS)=IVOL-IZZ+LL*ROT(IBASE(KNUM+NXI+ISS1))
  381      CONTINUE
  482      CONTINUE
           IF(LSPLIT) THEN
             IFR0=IFRT
             DO 582 IXX=1,IBASE(ISPZ+ISZ)-1
             IMERMX=IMERMX+IMER0-IMER1+1
             IFRT=IFR0
           DO 682 ISX=1,LXI
             ISS=ISS+1
             IFRT=IFRT+1
             IMERG=IBASE(KNUM+IFRT)
             JMERG=IBASE(NUMG+IFRT)
             MMCYL=IBASE(ICC+JMERG-1)
             IZON=0
             DO 671 IFF=1,MMCYL+1
               JSECT=IBASE(IBASE(IOF+2*ISTAT9+JMERG-1)+IFF-1)
               IF(JSECT.GT.1) THEN
                 LL=JSECT-1
                 IZZ=6*LL
               ELSE
                 LL=1
                 IZZ=1
               ENDIF
               IZON=IZON+IZZ
  671        CONTINUE
             IMERG=IMERG+IMERMX
             IF(LGMERG) THEN
               DO 681 KY=0,ISTO-1
                 IF(IMERG.EQ.IBASE(ITRN+KXI+KY)) THEN
                   IMMS=IBASE(ITRN+2*KXI+KY)
                   IBSS=IBASE(KVOL+IMMS)
                   IBASE(KVOL+ISS)=IBSS
                   IBASE(ITRN+ISS)=IBASE(ITRN+IMMS)
                   GOTO 781
                 ENDIF
  681          CONTINUE
             ENDIF
             IBASE(ITRN+KXI+ISTO)=IMERG
             IBASE(ITRN+2*KXI+ISTO)=ISS
             ISTO=ISTO+1
             IBASE(KVOL+ISS)=IVOL+1
             IVOL=IVOL+IZON
             IBASE(ITRN+ISS)=IVOL-IZZ+LL*ROT(IBASE(KNUM+NXI+IFRT))
  781      CONTINUE
  682      CONTINUE
  582        CONTINUE
           ENDIF
  182      CONTINUE
C--- RECHERCHE DU NOMBRE DE SURFACES QUE PRESENTE LA SYMETRIE
           ICCOIN=-1
           JCCOIN=-1
           KCCOIN=-1
           MROT=6
           IF(IHEX.EQ.1) THEN
             NCPER=NINT(REAL(NCOUR)/2.)
           ELSEIF(IHEX.EQ.2) THEN
             NCPER=NCOUR
             MROT=3
           ELSEIF(IHEX.EQ.3) THEN
             NCPER=2*NINT(REAL(NCOUR)/2.)-1
             ICCOIN=LXI-NINT(REAL(NCPER)/2.)+1
             MROT=3
           ELSEIF(IHEX.EQ.4) THEN
             NCPER=3*NINT(REAL(NCOUR)/2.)-2
             IF(MOD(NCOUR,2).EQ.0)NCPER=NCPER+1
             ICCOIN=LXI-NCPER+NINT(REAL(NCOUR)/2.)
             MROT=2
           ELSEIF(IHEX.EQ.5) THEN
             NCPER=1
             IF(NCOUR.GT.1)NCPER=2*(NCOUR-1)
             ICCOIN=LXI-NCPER+NCOUR-1
             KCCOIN=LXI
             MROT=3
           ELSEIF(IHEX.EQ.6) THEN
             NCPER=1
             IF(NCOUR.GT.1)NCPER=4+3*(NCOUR-2)-1
             KCCOIN=LXI-NCPER+NCOUR-1
             ICCOIN=KCCOIN+NCOUR-1
             JCCOIN=ICCOIN+NCOUR-1
             MROT=2
           ELSEIF(IHEX.EQ.7) THEN
             NCPER=1
             IF(NCOUR.GT.1)NCPER=3*NCOUR-2
             ICCOIN=LXI-NCOUR+1
             KCCOIN=ICCOIN-NCOUR+1
             MROT=1
           ELSEIF(IHEX.EQ.8) THEN
             NCPER=1
             IF(NCOUR.GT.1)NCPER=2*(NCOUR+NINT(REAL(NCOUR)/2.))-3
             JCCOIN=LXI-NINT(REAL(NCOUR)/2.)+1
             KCCOIN=JCCOIN-NCOUR+1
             ICCOIN=KCCOIN-NCOUR+1
             MROT=1
           ELSEIF(IHEX.EQ.9) THEN
             MROT=1
             NCPER=1
             IF(NCOUR.GT.1) NCPER=6*(NCOUR-1)
             ICCOIN=IFONC(NCOUR,0)
             JCCOIN=IFONC(NCOUR,1)
             KCCOIN=IFONC(NCOUR,2)
           ELSE
             CALL XABORT('MESHST: INVALID TYPE OF SYMETRIE ')
           ENDIF
           ISURSY=0
           ISAUX=1
           MSMAX=0
           ISSXX=0
           IPPZ=LZF
           IPP1=IPLANZ
           IF(MCODE.GT.0) THEN
              IPPZ=LZF
              IPP1=IPLANI
           ENDIF
           CALL SETARA(IBASE,6*IPP1,ISXY)
           IXP=0
           DO 500 JP=1,IPPZ
           MXI=LXI*(JP-1)
           DO 501 IP=IXP+1,IXP+IBASE(ISPZ+JP-1)
           ISURB6=0
           ITT9=IBASE(NUMG+LXI+MXI-1)-1
           ISURSX=IBASE(IBASE(IOF+2*ISTAT9+ITT9)+IBASE(ICC+ITT9))-1
           KSURBX=ISURSX
           IF(ISURSX.EQ.0) THEN
             ISURSX=1
             KSURBX=1
           ENDIF
           DO 183 K1=LXI+MXI,LXI+MXI-NCPER+1,-1
             K=IBASE(NUMG+K1-1)
             MMCYL=IBASE(ICC+K-1)
             JSECT=IBASE(IBASE(IOF+2*ISTAT9+K-1)+MMCYL)
             ICX=2
             IF(IHEX.GT.2) THEN
               IF(K1.EQ.ICCOIN+MXI)ICX=3
               IF(K1.EQ.JCCOIN+MXI)ICX=3
               IF(K1.EQ.KCCOIN+MXI)ICX=3
               IF(IHEX.EQ.9) THEN
                 IF(K1.EQ.MXI+IFONC(NCOUR,3))ICX=3
                 IF(K1.EQ.MXI+IFONC(NCOUR,4))ICX=3
                 IF(K1.EQ.MXI+IFONC(NCOUR,5))ICX=3
               ENDIF
               IF(K1.GE.ICCOIN+MXI) THEN
                 IF(IHEX.LE.4) THEN
                   IF(K1.EQ.MXI+LXI.AND.MOD(NCOUR,2).NE.0) THEN
                     ICY=1
                     IF(IHEX.EQ.4)ICY=2
                     ISURB6=ISURB6+ICY*(JSECT-1)
                     IF(JSECT.EQ.1)ISURB6=ISURB6+ICY
                     IF(IHEX.EQ.3) ICX=1
                   ELSE
                     ISURB6=ISURB6+2*(JSECT-1)
                     IF(JSECT.EQ.1)ISURB6=ISURB6+2
                   ENDIF
                 ELSE
                   ICZ=ICX
                   IF(K1.EQ.ICCOIN+MXI)ICZ=2
                   ISURB6=ISURB6+ICZ*(JSECT-1)
                   IF(JSECT.EQ.1)ISURB6=ISURB6+ICZ
                 ENDIF
               ENDIF
             ENDIF
             IF(JSECT.GT.1) THEN
               ISURSY=ISURSY+ICX*(JSECT-1)
             ELSE
               ISURSY=ISURSY+ICX
             ENDIF
  183      CONTINUE
           IDEBX=2
           IF(JSECT.GT.1)IDEBX=JSECT
           IF(IHEX.EQ.1.OR.IHEX.EQ.3.OR.IHEX.EQ.4.OR.IHEX.EQ.8) THEN
           IF(MOD(NCOUR,2).NE.0) THEN
             IF(JSECT.GT.1) THEN
               ISURSY=ISURSY-JSECT+1
             ELSE
               ISURSY=ISURSY-1
             ENDIF
             IF(IHEX.EQ.8) THEN
               ISURSY=ISURSY-ISURSX
               ISURB6=ISURB6-ISURSX
             ENDIF
           ENDIF
           ENDIF
           IBASE(ISXY+IP-1)=ISURSY
           IBASE(ISXY+IPP1+IP-1)=ISURSX
           IBASE(ISXY+2*IPP1+IP-1)=ISURB6
           IBASE(ISXY+3*IPP1+IP-1)=IDEBX+ISAUX-1
           IBASE(ISXY+4*IPP1+IP-1)=KSURBX
           IBASE(ISXY+5*IPP1+IP-1)=ISAUX
           ISAUX=ISURSY+1
           MSMAX=MSMAX+ISURSY-ISSXX
           ISSXX=ISURSY
  501      CONTINUE
           IXP=IXP+IBASE(ISPZ+JP-1)
  500      CONTINUE
           CALL RLSARA(IBASE(KNUM))
           IF(LGMERG) CALL RLSARA(IBASE(NUMG))
           CALL RLSARA(IBASE(ISPZ))
         ENDIF
         CALL RLSARA(IBASE(ICEL))
         NBASE=NCEL+NCEL
         IF(LGTURN)NBASE=NBASE+NCEL
         CALL SETARA(IBASE,NBASE,IBB)
         CALL LCMSIX(IPTRK,'DATA DUP',1)
         CALL LCMGET(IPTRK,'GENERATING',IBASE(IBB))
         CALL LCMGET(IPTRK,'MERGE',IBASE(IBB+NCEL))
         IF(LGTURN)CALL LCMGET(IPTRK,'TURN',IBASE(IBB+2*NCEL))
         CALL LCMSIX(IPTRK,' ',2)
         CALL XDISET(VOL1,NCPHY,0)
         CALL XDISET(VTURN,NCPHY,0)
         IAUX=IPOINT
         IFVOL=1
         MVOL=0
         ICELC0=IFONC(NCOUR,0)
         ICELC1=IFONC(NCOUR,1)-ICELC0
         JVOL=1
         IVOL=0
         ISURB=NSMIN
         JSURB=0
         DO 100 I=1,NCEL
            NVOL(I)=JVOL
            IF(LG3D) THEN
              DO 40 J=1,LZZ
                 NCC=J*LX
                 IF(I.LE.NCC) THEN
                   Z=RBASE(IZ+J-1)
                   GO TO 42
                 ENDIF
   40         CONTINUE
            ENDIF
   42       CONTINUE
            MCYL=IBASE(ICC+IBASE(IBB+I-1)-1)
            IF(MCYL.GT.0) THEN
C
C               STORAGE DES COORDONNEES DES CYLINDRES
C        ==> ATTENTION:  LES AXES DES CYLINDRES SONT SELON Z
C
              DO 43 J=1,MCYL
                 IAUX=IAUX+1
                 REMESH(IAUX)=RBASE(IBASE(IOF+IBASE(IBB+I-1)-1)+J)
   43         CONTINUE
            ENDIF
            NCYL(I)=MCYL
            NZONE1=1+MCYL
            NZONE=0
            DO 60 IA=0,NZONE1-1
              NZONE=NZONE+IBASE(IBASE(IOF+2*ISTAT9+IBASE(IBB+I-1)-1)+IA)
   60       CONTINUE
            NSECTO=IBASE(IBASE(IOF+2*ISTAT9+IBASE(IBB+I-1)-1)+NZONE1-1)
            MCPHY=IBASE(IBB+NCEL+I-1)
            IV1=VOL1(MCPHY)
            IF(IV1.GT.0) THEN
              IF(LGTURN) THEN
                JVT=PHTURN(MCPHY)
                IVTURN=VTURN(MCPHY)
                ITURN=IBASE(IBB+2*NCEL+I-1)
                LL=-1
                IF(JVT.GT.6) LL=1
                KAUX=NSECTO-1
                IF(ITURN.LE.6) THEN
                  LL=-LL
                  IF(ITURN.NE.6)KAUX=KAUX*(ITURN+1)
                ELSEIF(ITURN.GE.9) THEN
                  KAUX=(ITURN-8)*KAUX
                ELSEIF(ITURN.EQ.7) THEN
                  KAUX=5*KAUX
                ENDIF
              ENDIF
            ELSE
              KVOL1=1
              IF(MCPHY.GT.1)KVOL1=VOL1(MCPHY-1)
              KVOL2=KVOL1+NZONE-1
              IF(LGTURN) THEN
                ITURN=IBASE(IBB+2*NCEL+I-1)
                PHTURN(MCPHY)=ITURN
                IF(ITURN.LE.6) THEN
                  IF(ITURN.EQ.6) THEN
                    VTURN(MCPHY)=KVOL2+NSECTO-1
                  ELSE
                    VTURN(MCPHY)=KVOL2+(NSECTO-1)*(ITURN+1)
                  ENDIF
                ELSEIF(ITURN.GE.8) THEN
                  VTURN(MCPHY)=KVOL2+(NSECTO-1)*(ITURN-8)+1
                ELSE
                  VTURN(MCPHY)=KVOL2+(NSECTO-1)*5+1
                ENDIF
              ENDIF
              VOL1(MCPHY)=KVOL2+1
            ENDIF
            VOLUM1=0.
            IF(LG3D) THEN
              IF(IPLANZ.GT.1) THEN
                IF(I.LE.STAIRS(1)) THEN
                  FACB(I)=KSURF1
                ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                  ISUR=ISUR+1
                  FACB(LX+ISUR)=KSURF2
                ENDIF
              ELSE
                FACB(I)=KSURF1
                FACB(LX+I)=KSURF2
              ENDIF
              Z=REMESH(2*NCEL+I)
              IF(I.GT.STAIRS(1)) THEN
                IST=1
                DO 329 IY=2,LZZ
                  IF(I.LE.STAIRS(IY)) THEN
                    IST=IY-1
                    GOTO 339
                  ENDIF
  329           CONTINUE
  339           KZAUX=I-STAIRS(IST)
                IF(IST.GT.1)KZAUX=KZAUX+STAIRS(IST-1)
                Z=Z-REMESH(2*NCEL+KZAUX)
              ENDIF
            ENDIF
            KSECTX=IBASE(IBASE(IOF+2*ISTAT9+IBASE(IBB+I-1)-1)+NZONE1-1)
            NZZ=NZONE1
            IF(KSECTX.GT.3)NZZ=NZONE1-1
            DO 45 J=1,NZZ
               MIXX=IBASE(IBASE(IOF+ISTAT9+IBASE(IBB+I-1)-1)+J-1)
               KSECT=IBASE(IBASE(IOF+2*ISTAT9+IBASE(IBB+I-1)-1)+J-1)
               NAUX=1
               IF(KSECT.GT.1) NAUX=6*(KSECT-1)
               IVOL=IVOL+NAUX
               MVOL=MVOL+1
               NSECT(MVOL)=KSECT
               KREG=KREG+1
               IF(J.EQ.NZONE1) THEN
                 VOLUM2=VEX
               ELSE
                 R=RBASE(J+IBASE(IOF+IBASE(IBB+I-1)-1))
                 VOLUM2=PI*R*R
               ENDIF
               VOLUME=(VOLUM2-VOLUM1)/REAL(NAUX)
               IF(LG3D) THEN
                 VOLUMS=VOLUME*.25
                 VOLUME=VOLUME*Z
C
C     SURFACES SUPERIEURES ET INFERIEURES (SELON L'AXE Z)
C
                 IF(IPLANZ.GT.1) THEN
                   IF(I.LE.STAIRS(1)) THEN
                     KSURF1=KSURF1+1
                     NSURF1=NSURF1-1
                     VOLSUR(NSURF1)=VOLUMS
                   ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                     KSURF2=KSURF2+1
                     NSURF2=NSURF2-1
                     VOLSUR(NSURF2)=VOLUMS
                   ENDIF
                 ELSE
                   KSURF1=KSURF1+1
                   NSURF1=NSURF1-1
                   VOLSUR(NSURF1)=VOLUMS
                   KSURF2=KSURF2+1
                   NSURF2=NSURF2-1
                   VOLSUR(NSURF2)=VOLUMS
                 ENDIF
               ENDIF
               VOLUM1=VOLUM2
               VOLSUR(KREG)=VOLUME
               MATALB(KREG)=MIXX
               DO 44 K=2,NAUX
                  KREG=KREG+1
                  VOLSUR(KREG)=VOLUME
                  MATALB(KREG)=MIXX
                  IF(LG3D) THEN
                  IF(IPLANZ.GT.1) THEN
                    IF(I.LE.STAIRS(1)) THEN
                      KSURF1=KSURF1+1
                      NSURF1=NSURF1-1
                      VOLSUR(NSURF1)=VOLUMS
                    ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                      KSURF2=KSURF2+1
                      NSURF2=NSURF2-1
                      VOLSUR(NSURF2)=VOLUMS
                    ENDIF
                  ELSE
                    KSURF1=KSURF1+1
                    NSURF1=NSURF1-1
                    VOLSUR(NSURF1)=VOLUMS
                    KSURF2=KSURF2+1
                    NSURF2=NSURF2-1
                    VOLSUR(NSURF2)=VOLUMS
                  ENDIF
                  ENDIF
   44          CONTINUE
   45       CONTINUE
            ICXX=LX*INT(AINT(REAL(I/(LX+1))))
            ICELC=ICELC0+ICXX
            ICLIM=LX+ICXX
            IF(KSECTX.GT.3) THEN
C
C TRAITEMENT DU VOLUME A BORDURE HEXAGONALE DANS LE CAS OU KSECT>3
C
             KSECT=KSECTX
             MIXX=IBASE(IBASE(IOF+ISTAT9+IBASE(IBB+I-1)-1)+NZONE1)
             NAUX=6*(KSECT-1)
             IVOL=IVOL+NAUX
             MVOL=MVOL+1
             NSECT(MVOL)=KSECT
             VCYL=VOLUM1/REAL(NAUX)
             SAUX=0.
             IXX0=KREG
             ISS0=NSURF1
             JSS0=NSURF2
             DO 445 M=1,KSECT-1
               IXX=IXX0
               ISS1=ISS0
               ISS2=JSS0
               XTAN=TAN(REAL(M)*PI/(3*(KSECT-1)))
               SAUX1=XTAN/(1.+XTAN/SQRT3)
               VOLUME=.5*SIDE*SIDE*(SAUX1-SAUX)
               VOLUME=VOLUME-VCYL
               VOLUMS=VOLUME
               IF(LG3D) VOLUME=VOLUME*Z
               DO 444  K=1,6
                 IXX=IXX+1
                 KREG=KREG+1
                 VOLSUR(IXX)=VOLUME
                 MATALB(IXX)=MIXX
                 IF(LG3D) THEN
                 IF(IPLANZ.GT.1) THEN
                   IF(I.LE.STAIRS(1)) THEN
                     KSURF1=KSURF1+1
                     NSURF1=NSURF1-1
                     ISS1=ISS1-1
                     VOLSUR(ISS1)=VOLUMS
                   ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                     KSURF2=KSURF2+1
                     NSURF2=NSURF2-1
                     ISS2=ISS2-1
                     VOLSUR(ISS2)=VOLUMS
                   ENDIF
                 ELSE
                   KSURF1=KSURF1+1
                   NSURF1=NSURF1-1
                   ISS1=ISS1-1
                   VOLSUR(ISS1)=VOLUMS
                   KSURF2=KSURF2+1
                   NSURF2=NSURF2-1
                   ISS2=ISS2-1
                   VOLSUR(ISS2)=VOLUMS
                 ENDIF
                 ISS1=ISS1-KSECT+2
                 ISS2=ISS2-KSECT+2
                 ENDIF
                 IXX=IXX+KSECT-2
 444           CONTINUE
               IF(I.GE.ICELC.AND.I.LE.ICLIM) THEN
                 SURF=.5*SIDE*(SAUX1-SAUX)/SQRT3
                 IF(LG3D)SURF=SURF*Z
                 JSUR=JSUR-1
                 VOLSUR(JSUR)=SURF
                 IJSUR=JSUR-KSECT+1
                 VOLSUR(IJSUR)=SURF
                 IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                   IJSUR=IJSUR-KSECT+1
                   VOLSUR(IJSUR)=SURF
                 ENDIF
               ENDIF
               IXX0=IXX0+1
               ISS0=ISS0-1
               JSS0=JSS0-1
               SAUX=SAUX1
 445         CONTINUE
             IF(I.GE.ICELC.AND.I.LE.ICLIM) THEN
               JSUR=JSUR-KSECT+1
               JSURB=JSURB+2
               SURB(JSURB-1)=ISURB
               KKB=KSECT-1
               ISURB=ISURB+KKB+KKB
               SURB(JSURB)=ISURB-KKB
               IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                 JSUR=JSUR-KSECT+1
                 JSURB=JSURB+1
                 SURB(JSURB)=ISURB
                 ISURB=ISURB+KKB
               ENDIF
             ENDIF
            ELSE
            IF(I.GE.ICELC.AND.I.LE.ICLIM) THEN
              SURF=SIDE*.25
              IF(LG3D)SURF=SURF*Z
              KKB=1
              IF(KSECT.GT.1) THEN
                KKB=KSECT-1
                SURF=SURF/KKB
              ENDIF
              DO 99 IXX=1,KKB
              JSUR=JSUR-2
              VOLSUR(JSUR)=SURF
              VOLSUR(JSUR+1)=SURF
              IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                JSUR=JSUR-1
                VOLSUR(JSUR)=SURF
              ENDIF
   99         CONTINUE
              JSURB=JSURB+2
              SURB(JSURB-1)=ISURB
              ISURB=ISURB+KKB+KKB
              SURB(JSURB)=ISURB-KKB
              IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                JSURB=JSURB+1
                SURB(JSURB)=ISURB
                ISURB=ISURB+KKB
              ENDIF
            ENDIF
            ENDIF
            JVOL=IVOL+1
            FVOL(I)=IFVOL
            IFVOL=IFVOL+NZONE1
  100    CONTINUE
         DO 110 I=0,ISTAT9-1
            CALL RLSARA(IBASE(IBASE(IOF+ISTAT9+I)))
            CALL RLSARA(IBASE(IBASE(IOF+2*ISTAT9+I)))
            IF(IBASE(ICC+I).GT.0)CALL RLSARA(RBASE(IBASE(IOF+I)))
  110    CONTINUE
         CALL RLSARA(IBASE(IOF))
         CALL RLSARA(IBASE(ICC))
      ELSE
C
C           CAS DE CELLULE HOMOGENES
C
         CALL SETARA(IBASE,2*NCEL,IBB)
         CALL LCMSIX(IPTRK,'DATA DUP',1)
         CALL LCMGET(IPTRK,'MERGE',IBASE(IBB))
         CALL LCMGET(IPTRK,'MIX',IBASE(IBB+NCEL))
         CALL LCMSIX(IPTRK,' ',2)
         CALL LCMLEN(IPGEOM,'SECTOR',ILENS,ITP)
         CALL SETARA(IBASE,NCEL,ICC)
         IF(ILENS.GT.0) THEN
            CALL XABORT('MESHST: SECTORS NOT IMPLEMENTED.')
         ELSE
            CALL XDISET(IBASE(ICC),NCEL,1)
         ENDIF
         IF(LGTURN) THEN
           CALL LCMSIX(IPTRK,'DATA DUP',1)
           CALL SETARA(IBASE,NCEL,ITT)
           CALL LCMGET(IPTRK,'TURN',IBASE(ITT))
           CALL LCMSIX(IPTRK,' ',2)
         ENDIF
         CALL XDISET(VOL1,NCPHY,0)
         IFVOL=1
         MVOL=0
         ICELC0=IFONC(NCOUR,0)
         ICELC1=IFONC(NCOUR,1)-ICELC0
         JVOL=1
         IVOL=0
         ISURB=NSMIN
         JSURB=0
         DO 200 I=1,NCEL
            NVOL(I)=JVOL
            NSECTO=IBASE(ICC+I-1)
            ICXX=LX*INT(AINT(REAL(I/(LX+1))))
            ICELC=ICELC0+ICXX
            ICLIM=LX+ICXX
            NSECT(I)=NSECTO
            NCYL(I)=0
            NZONE=1
            IF(NSECTO.GT.1)NZONE=6*(NSECTO-1)
            IVOL=IVOL+NZONE
            JVOL=IVOL+1
            MCPHY=IBASE(IBB+I-1)
            IV1=VOL1(MCPHY)
            IF(IV1.GT.0) THEN
              IF(LGTURN) THEN
                JVT=PHTURN(MCPHY)
                IVTURN=VTURN(MCPHY)
                LL=-1
                IF(JVT.GT.6)LL=1
                KAUX=NSECTO-1
                ITURN=IBASE(ITT+I-1)
                IF(ITURN.LE.6) THEN
                  LL=-1
                  IF(ITURN.NE.6)KAUX=KAUX*(ITURN+1)
                ELSEIF(ITURN.GE.9) THEN
                  KAUX=(ITURN-8)*KAUX
                ELSEIF(ITURN.EQ.7) THEN
                  KAUX=5*KAUX
                ENDIF
              ENDIF
            ELSE
              KVOL1=1
              IF(MCPHY.GT.1)KVOL1=VOL1(MCPHY-1)
              KVOL2=KVOL1+NZONE-1
              IF(LGTURN) THEN
                ITURN=IBASE(ITT+I-1)
                PHTURN(MCPHY)=ITURN
                IF(ITURN.LE.6) THEN
                  IF(ITURN.EQ.6) THEN
                    VTURN(MCPHY)=KVOL2+NSECTO-1
                  ELSE
                    VTURN(MCPHY)=KVOL2+(NSECTO-1)*(ITURN+1)
                  ENDIF
                ELSEIF(ITURN.GE.8) THEN
                  VTURN(MCPHY)=KVOL2+(NSECTO-1)*(ITURN-8)+1
                ELSE
                  VTURN(MCPHY)=KVOL2+(NSECTO-1)*5+1
                ENDIF
              ENDIF
              VOL1(MCPHY)=KVOL2+1
            ENDIF
            IF(NSECTO.LE.3) THEN
            IF(I.GE.ICELC.AND.I.LE.ICLIM) THEN
              SURF=SIDE*.25
              IF(LG3D)SURF=SURF*Z
              KKB=1
              IF(NSECTO.GT.1) THEN
                KKB=NSECTO-1
                SURF=SURF/(NSECTO-1)
              ENDIF
              DO 556 IXX=1,KKB
              JSUR=JSUR-2
              VOLSUR(JSUR)=SURF
              VOLSUR(JSUR+1)=SURF
              IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                JSUR=JSUR-1
                VOLSUR(JSUR)=SURF
              ENDIF
  556         CONTINUE
              JSURB=JSURB+2
              SURB(JSURB-1)=ISURB
              ISURB=ISURB+KKB+KKB
              SURB(JSURB)=ISURB-KKB
              IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                JSURB=JSURB+1
                SURB(JSURB)=ISURB
                ISURB=ISURB+KKB
              ENDIF
            ENDIF
            VOLUME=VEX/NZONE
            IF(LG3D) THEN
              Z=REMESH(2*NCEL+I)
              IF(I.GT.STAIRS(1)) THEN
                IST=1
                DO 429 IY=2,LZZ
                  IF(I.LE.STAIRS(IY)) THEN
                    IST=IY-1
                    GOTO 439
                  ENDIF
  429           CONTINUE
  439           KZAUX=I-STAIRS(IST)
                IF(IST.GT.1)KZAUX=KZAUX+STAIRS(IST-1)
                Z=Z-REMESH(2*NCEL+KZAUX)
              ENDIF
              VOLUMS=VOLUME*.25
              VOLUME=VOLUME*Z
C
C     SURFACES SUPERIEURES ET INFERIEURES (SELON L'AXE Z)
C
              IF(IPLANZ.GT.1) THEN
                IF(I.LE.STAIRS(1)) THEN
                   FACB(I)=KSURF1
                   KSURF1=KSURF1+1
                   NSURF1=NSURF1-1
                   VOLSUR(NSURF1)=VOLUMS
                 ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                   ISUR=ISUR+1
                   FACB(LX+ISUR)=KSURF2
                   KSURF2=KSURF2+1
                   NSURF2=NSURF2-1
                   VOLSUR(NSURF2)=VOLUMS
                 ENDIF
               ELSE
                 FACB(I)=KSURF1
                 FACB(LX+I)=KSURF2
                 KSURF1=KSURF1+1
                 NSURF1=NSURF1-1
                 VOLSUR(NSURF1)=VOLUMS
                 KSURF2=KSURF2+1
                 NSURF2=NSURF2-1
                 VOLSUR(NSURF2)=VOLUMS
               ENDIF
             ENDIF
             MIXX=IBASE(IBB+NCEL+I-1)
             DO 65 J=1,NZONE
               KREG=KREG+1
               VOLSUR(KREG)=VOLUME
               MATALB(KREG)=MIXX
               IF(LG3D) THEN
               IF(IPLANZ.GT.1) THEN
                 IF(I.LE.STAIRS(1)) THEN
                   KSURF1=KSURF1+1
                   NSURF1=NSURF1-1
                   VOLSUR(NSURF1)=VOLUMS
                 ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                   KSURF2=KSURF2+1
                   NSURF2=NSURF2-1
                   VOLSUR(NSURF2)=VOLUMS
                 ENDIF
               ELSE
                 KSURF1=KSURF1+1
                 NSURF1=NSURF1-1
                 VOLSUR(NSURF1)=VOLUMS
                 KSURF2=KSURF2+1
                 NSURF2=NSURF2-1
                 VOLSUR(NSURF2)=VOLUMS
               ENDIF
               ENDIF
   65        CONTINUE
             ELSE
C
C  TRAITEMENT DU CAS OU NSECTO>3
C
             KSECT=NSECTO
             MIXX=IBASE(IBB+NCEL+I-1)
             NAUX=6*(KSECT-1)
             IVOL=IVOL+NAUX
             MVOL=MVOL+1
             NSECT(MVOL)=KSECT
             SAUX=0.
             IXX0=KREG
             ISS0=NSURF1
             JSS0=NSURF2
             DO 555 M=1,KSECT-1
               IXX=IXX0
               ISS1=ISS0
               ISS2=JSS0
               XTAN=TAN(REAL(M)*PI/(3*(KSECT-1)))
               SAUX1=XTAN/(1.+XTAN/SQRT3)
               VOLUME=.5*SIDE*SIDE*(SAUX1-SAUX)
               VOLUMS=VOLUME
               IF(LG3D) VOLUME=VOLUME*Z
               DO 554  K=1,6
                 IXX=IXX+1
                 KREG=KREG+1
                 VOLSUR(IXX)=VOLUME
                 MATALB(IXX)=MIXX
                 IF(LG3D) THEN
                 IF(IPLANZ.GT.1) THEN
                   IF(I.LE.STAIRS(1)) THEN
                     KSURF1=KSURF1+1
                     NSURF1=NSURF1-1
                     ISS1=ISS1-1
                     VOLSUR(ISS1)=VOLUMS
                   ELSEIF(I.GT.STAIRS(IPLANZ-1)) THEN
                     KSURF2=KSURF2+1
                     NSURF2=NSURF2-1
                     ISS2=ISS2-1
                     VOLSUR(ISS2)=VOLUMS
                   ENDIF
                 ELSE
                   KSURF1=KSURF1+1
                   NSURF1=NSURF1-1
                   ISS1=ISS1-1
                   VOLSUR(ISS1)=VOLUMS
                   KSURF2=KSURF2+1
                   NSURF2=NSURF2-1
                   ISS2=ISS2-1
                   VOLSUR(ISS2)=VOLUMS
                 ENDIF
                 ISS1=ISS1-KSECT+2
                 ISS2=ISS2-KSECT+2
                 ENDIF
                 IXX=IXX+KSECT-2
 554           CONTINUE
               IF(I.GE.ICELC.AND.I.LE.ICLIM) THEN
                 SURF=.5*SIDE*(SAUX1-SAUX)/SQRT3
                 IF(LG3D)SURF=SURF*Z
                 JSUR=JSUR-1
                 VOLSUR(JSUR)=SURF
                 IJSUR=JSUR-KSECT+1
                 VOLSUR(IJSUR)=SURF
                 IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                   IJSUR=IJSUR-KSECT+1
                   VOLSUR(IJSUR)=SURF
                 ENDIF
               ENDIF
               IXX0=IXX0+1
               ISS0=ISS0-1
               JSS0=JSS0-1
               SAUX=SAUX1
 555         CONTINUE
             IF(I.GE.ICELC.AND.I.LE.ICLIM) THEN
               JSUR=JSUR-KSECT+1
               JSURB=JSURB+2
               SURB(JSURB-1)=ISURB
               KKB=KSECT-1
               ISURB=ISURB+KKB+KKB
               SURB(JSURB)=ISURB-KKB
               IF(MOD(I-ICELC,ICELC1).EQ.0) THEN
                 JSUR=JSUR-KSECT+1
                 JSURB=JSURB+1
                 SURB(JSURB)=ISURB
                 ISURB=ISURB+KKB
               ENDIF
             ENDIF
             ENDIF
             FVOL(I)=IFVOL
             IFVOL=IFVOL+1
  200    CONTINUE
         CALL RLSARA(IBASE(ICC))
         IF(LGTURN) CALL RLSARA(IBASE(ITT))
      ENDIF
      IF(LG3D)CALL RLSARA(RBASE(IZ))
C
C--- CONSTRUCTION DU VECTEUR VSYM QUI CONTIENT POUR CHAQUE VOLUME DE
C--- DE L'ASSEMBLAGE SON EQUIVALENT DANS LA SYMETRIE D'ENTREE
C
      IF(LGCELL.AND.(IHEX.LE.9)) THEN
        CALL SETARA(IBASE,NCEL,IAA)
        CALL LCMSIX(IPTRK,'DATA DUP',1)
        CALL LCMGET(IPTRK,'GENER0',IBASE(IAA))
        CALL LCMSIX(IPTRK,' ',2)
        IXV=0
        DO 300 IC=1,NCEL
           MCYL=NCYL(IC)
           LFROT=ROT(IBASE(IBB+2*NCEL+IC-1))
           IVFIN=IBASE(KVOL+IBASE(IAA+IC-1)-1)
           IVORIN=IBASE(ITRN+IBASE(IAA+IC-1)-1)
           IVMIN=IVFIN
           IVSYM=NVOL(IC)
           IXX=IXV
           NZON=0
           DO 310 I=1,MCYL
             IXX=IXX+1
             LSECT=NSECT(IXX)
             IF(LSECT.GT.1) THEN
               NZON=NZON+6*(LSECT-1)
             ELSE
               NZON=NZON+1
             ENDIF
  310      CONTINUE
           LSECT=NSECT(IXX+1)
           IF(LSECT.GT.1) THEN
             IVAUX=INT(REAL(IVORIN-IVFIN-NZON+1)/REAL(LSECT-1))
           ELSE
             IVAUX=IVORIN-IVFIN-NZON+1
           ENDIF
           DO 320 K=1,MCYL+1
              IXV=IXV+1
              LSECT=NSECT(IXV)
              IF(LSECT.EQ.1) THEN
                VSYM(IVSYM)=IVMIN
                IVMAX=IVMIN
              ELSE
                IVOR=IVMIN+IVAUX*(LSECT-1)-1
                IVV=LFROT-1
                IVSYM0=IVSYM
                IVSYM=IVSYM+6*(LSECT-1)-1
                IVMAX=IVMIN+6*(LSECT-1)-1
                IF(IBASE(IBB+2*NCEL+IC-1).LE.6) THEN
                  IVV1=LFROT*(LSECT-1)
                  IVV=(5-IVV)*(LSECT-1)
                ELSE
                  IVV1=IVV*(LSECT-1)+1
                  IVV=(6-IVV)*(LSECT-1)-1
                ENDIF
                IF(IBASE(IBB+2*NCEL+IC-1).LE.6) THEN
                  KVV=IVSYM-IVV
                  KVOR=IVOR
                  DO 315 L=KVV,IVSYM
                    VSYM(L)=KVOR
                    KVOR=KVOR+1
                    IF(KVOR.GT.IVMAX)KVOR=IVMIN
  315             CONTINUE
                  DO 316 L=IVSYM0,KVV-1
                    VSYM(L)=KVOR
                    KVOR=KVOR+1
                    IF(KVOR.GT.IVMAX)KVOR=IVMIN
  316             CONTINUE
                ELSE
                  KVV=IVSYM0+IVV1-1
                  KVOR=IVOR
                  DO 317 L=KVV,IVSYM0,-1
                    VSYM(L)=KVOR
                    KVOR=KVOR+1
                    IF(KVOR.GT.IVMAX)KVOR=IVMIN
  317             CONTINUE
                  DO 318 L=IVSYM,KVV+1,-1
                    VSYM(L)=KVOR
                    KVOR=KVOR+1
                    IF(KVOR.GT.IVMAX)KVOR=IVMIN
  318             CONTINUE
                ENDIF
              ENDIF
              IVMIN=IVMAX+1
              IVSYM=IVSYM+1
  320      CONTINUE
  300   CONTINUE
        CALL RLSARA(IBASE(IAA))
C--- CONSTRUCTION DU VECTEUR SSYM QUI CONTIENT POUR CHAQUE SURFACE
C--- DE L'ASSEMBLAGE SON EQUIVALENT DANS LA SYMETRIE D'ENTREE
        ISY=0
        MSAUX=NS
        ISYX=NSMIN+1
        IVLMAX=0
        IF(LG3D) THEN
          MSAUX=(NS-NSMIN-NSMAX)/IPLANZ
C--- CAS DE LA SYMETRIE Z- (MCODE=1) SSYM EST REMPLIT PLUS LOIN
          IF(MCODE.NE.1) THEN
          IF(IHEX.NE.9) THEN
          DO 301 ISUR=1,NSMIN
             SSYM(ISUR)=VSYM(ISUR)
             IVLMAX=MAX(IVLMAX,VSYM(ISUR))
  301     CONTINUE
          ELSE
          DO 311 ISUR=1,NSMIN
             SSYM(ISUR)=ISUR
  311     CONTINUE
          IVLMAX=NSMIN
          ENDIF
          ENDIF
          ISY=NSMIN
        ENDIF
        IPPZ=IPP1
        NSAUX=0
        IF(MCODE.EQ.1) THEN
          DO 302 IPPX=IPPZ+1,IPLANZ
            NSAUX=NSAUX+(SURL(IPPX)-SURL(IPPX-1))
  302     CONTINUE
          ISYX=ISYX+NSAUX
        ENDIF
        MSAUX=0
        ISYAUX=ISYX
        LSMAX=NSMIN+NSAUX
        IF(MCODE.EQ.0) LSMAX=NS
        LSPLZM=2*IPPZ-IPLANZ
        DO 600 IP=1,IPPZ
         IF(LG3D) THEN
          IF(MCODE.EQ.1) THEN
            LSMAX=LSMAX+(SURL(IPPZ-LSPLZM+IP)-SURL(IPPZ-LSPLZM-1+IP))
            ISYAUX=ISYAUX+MSAUX
            MSAUX=SURL(IPPZ-LSPLZM+IP)-SURL(IPPZ-LSPLZM-1+IP)
          ELSE
            LSMAX=NSMIN+SURL(IP)
            ISYAUX=ISYX+MSAUX
            MSAUX=SURL(IP)
          ENDIF
         ENDIF
         ISY=ISYAUX-1
        ISURSY=IBASE(ISXY+IP-1)
        ISURSX=IBASE(ISXY+IPP1+IP-1)
        ISURB6=IBASE(ISXY+2*IPP1+IP-1)
        IDEBX=IBASE(ISXY+3*IPP1+IP-1)
        KSURBX=IBASE(ISXY+4*IPP1+IP-1)
        ISAUX=IBASE(ISXY+5*IPP1+IP-1)
        IDDX=ISURSX
        KX2=ISURSY
        KX1=ISURSY-ISURSX+1
        KXP=1
        IF(IHEX.GE.3) THEN
           ISY=ISURB6+ISY
           IF(IHEX.EQ.3.OR.IHEX.EQ.8) THEN
             IDDX=0
             KX2=KX1
             KX1=ISURSY
             KXP=-1
           ENDIF
           IF(IHEX.EQ.4.OR.IHEX.EQ.7)ISY=ISY-KSURBX
        ENDIF
        IDEB=ISAUX
        IF(IHEX.EQ.2.OR.IHEX.EQ.7)IDEB=IDEBX
        IF(IHEX.EQ.5.OR.IHEX.EQ.6) THEN
          IDDX=-ISURSY
          ISURSX=0
          ISURSY=0
          KX1=0
          KX2=-1
        ENDIF
        DO 400 I=1,MROT
        DO 349 K=KX1,KX2,KXP
          ISY=ISY+1
          IF(IHEX.GE.3) THEN
            IF(ISY.GT.LSMAX) ISY=ISYAUX
          ENDIF
          SSYM(ISY)=K+IVLMAX
  349   CONTINUE
        IF(IHEX.LT.9) THEN
        DO 350 K=ISURSY-ISURSX,ISAUX,-1
          ISY=ISY+1
          IF(IHEX.GE.3) THEN
            IF(ISY.GT.LSMAX) ISY=ISYAUX
          ENDIF
          SSYM(ISY)=K+IVLMAX
  350   CONTINUE
        ENDIF
        DO 351 K=IDEB,ISURSY-IDDX
          ISY=ISY+1
          IF(IHEX.GE.3) THEN
            IF(ISY.GT.LSMAX) ISY=ISYAUX
          ENDIF
          SSYM(ISY)=K+IVLMAX
  351   CONTINUE
  400   CONTINUE
  600   CONTINUE
C
C---SURFACE LATERALES SUPERIEURES DANS LE CAS 3D
C
        IF(LG3D) THEN
        IF(MCODE.LE.1) THEN
        IYAUX=0
        IF(IPLANZ.GT.1) THEN
        IYAUX=IVLMAX
        DO 599 II=NSMIN+1,NV-NSMAX
           IYAUX=MAX(VSYM(II),IYAUX)
  599   CONTINUE
        ENDIF
        IF(IHEX.NE.9) THEN
          IAUX=NV-NSMAX
          DO 601 II=NS-NSMAX+1,NS
           IAUX=IAUX+1
           SSYM(II)=IVLMAX+MSMAX+VSYM(IAUX)-IYAUX
  601     CONTINUE
        ELSE
          IAUX=0
          IF(MCODE.GT.0) THEN
           KSAUX=SURL(IPLANI)
          ELSE
           KSAUX=SSYM(NS-NSMAX)
          ENDIF
          DO 611 II=NS-NSMAX+1,NS
           IAUX=IAUX+1
           SSYM(II)=IAUX+KSAUX
  611     CONTINUE
        ENDIF
        ENDIF
C--- CAS DE SYMETRIE Z-
        IF(MCODE.EQ.1) THEN
          IF(IHEX.NE.9) THEN
            DO 602 IV=1,NSMAX
             SSYM(IV)=IVLMAX+MSMAX+VSYM(IV)-IYAUX
  602       CONTINUE
          ELSE
            IVLAT=1
            IAUX=0
            JTX=NS-NSMAX
            DO 612 IX1=1,NCOUR
              DO 613 JX=JTX+VLAT(NCOUR+IX1),JTX+IVLAT,-1
                IAUX=IAUX+1
                SSYM(IAUX)=SSYM(JX)
  613         CONTINUE
            DO 614 JX=JTX+VLAT(IX1),JTX+VLAT(NCOUR+IX1)+1,-1
                IAUX=IAUX+1
                SSYM(IAUX)=SSYM(JX)
  614       CONTINUE
            IVLAT=VLAT(IX1)+1
  612       CONTINUE
          ENDIF
          IFR=NSMIN
          LSPLZM=2*IPLANI-IPLANZ
          DO 605 IW=IPLANZ,IPPZ+1,-1
            DO 603 JW=SURL(IPLANZ+IW),SURL(IW-1)+1,-1
               IFR=IFR+1
               SSYM(IFR)=SSYM(NSMIN+JW)
  603       CONTINUE
            DO 604 JW=SURL(IW),SURL(IPLANZ+IW)+1,-1
               IFR=IFR+1
               SSYM(IFR)=SSYM(NSMIN+JW)
  604       CONTINUE
  605     CONTINUE
        ELSEIF(MCODE.EQ.2) THEN
          IFR=NS-NSMAX+1
          MSUR=0
          LSPLZP=2*IPLANI-IPLANZ
          DO 705 IW=1,IPPZ-LSPLZP
            DO 704 JW=SURL(IPLANZ+IW)+1,SURL(IW)
               IFR=IFR-1
               SSYM(IFR)=SSYM(NSMIN+JW)
  704       CONTINUE
            DO 703 JW=MSUR+1,SURL(IPLANZ+IW)
               IFR=IFR-1
               SSYM(IFR)=SSYM(NSMIN+JW)
  703       CONTINUE
            MSUR=SURL(IW)
  705     CONTINUE
          IF(IHEX.NE.9) THEN
            IAUX=NV-NSMIN
            DO 706 II=NS-NSMAX+1,NS
             IAUX=IAUX+1
             SSYM(II)=VSYM(IAUX)
  706       CONTINUE
          ELSE
            IVLAT=1
            IAUX=NS-NSMAX
            DO 712 IX1=1,NCOUR
              DO 713 JX=VLAT(NCOUR+IX1),IVLAT,-1
                IAUX=IAUX+1
                SSYM(IAUX)=SSYM(JX)
  713         CONTINUE
            DO 714 JX=VLAT(IX1),VLAT(NCOUR+IX1)+1,-1
                IAUX=IAUX+1
                SSYM(IAUX)=SSYM(JX)
  714       CONTINUE
            IVLAT=VLAT(IX1)+1
  712       CONTINUE
          ENDIF
        ENDIF
        ENDIF
        CALL RLSARA(IBASE(ISXY))
        CALL RLSARA(IBASE(IBB))
        CALL RLSARA(IBASE(KVOL))
        CALL RLSARA(IBASE(ITRN))
      ELSE
        DO 717 ISUR=1,NS
          SSYM(ISUR)=ISUR
  717   CONTINUE
        DO 718 IVOL=1,NV
          VSYM(IVOL)=IVOL
  718   CONTINUE
      ENDIF
      RETURN
      END
