*DECK NXTPR3
      SUBROUTINE NXTPR3(IPTRK)
*
*-----------------------------------------------------------------------
*
*Purpose:
* To analyse a 3D prismatic geometry from a general 3D geometry analysis.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
*Author(s): R. Le Tellier
*
*Parameters: input
* IPTRK   pointer to the nxt tracking (L_TRACK).
*
*-----------------------------------------------------------------------
*
      IMPLICIT NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPTRK
*----
*  LOCAL VARIABLES
*----
      INTEGER NSTATE,IOUT
      PARAMETER(NSTATE=40,IOUT=6)
      INTEGER GSTATE(NSTATE),ESTATE(NSTATE),KSIGN(3),ICODE(6),NCODE(6),
     1 KTYPE(3)
      INTEGER IZ,IX,IY,NFREG,NFSUR,NDIM,ITYPBC,IDIRG,NBOCEL,NBUCEL,
     1 IDIAG,ISAXIS(3),NOCELL(3),NUCELL(3),MAXMSH,MAXMDH,MAXREG,NBTCLS,
     2 MAXPIN,MAXMSP,MAXRSP,MXGSUR,MXGREG,NUNK,IDIR,JJ,NUCELZ,NZP,
     3 N2REG,N2SUR,N2CEL,N2PIN,I,K,NUNK2,NFSURO,ISUR,NUNKO,ITEMP
      REAL RSTATT(NSTATE),ALBEDO(6)
      DOUBLE PRECISION DZ1,DZ2
      CHARACTER NAMASG*9,NAMREC*12
      LOGICAL HALFS(2),SSYM(2),INVER
      CHARACTER CDIR(4)*1
      DATA CDIR /'X','Y','Z','R'/
      INTEGER JPTRK,IUNFLD,MATALB,SURVOL,SURVOL1,DGMESH,INDEX,IDREG,
     1 IDSUR,MESHC,NSURC,NREGC,IDIRC,NTPIN,DCMESH,ITPIN,DRAPIN,IND2T3,
     2 ZCOR,REGI,CELID,PINID,NZC,MATALB2,SURVOL2,SURVOLF,KEYMRG,IND2T3F,
     3 ZCORF,MATALBF
      INTEGER ISMX,ISMY
      INTEGER LCMDID
      INTEGER IBASE(1)
      REAL BASE
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*----
* RECOVER STATE-VECTOR
*----
      CALL XDISET(GSTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',GSTATE)
      NFREG=GSTATE(1)
      NFSUR=GSTATE(5)
      IZ=GSTATE(39)
*---
      IF (IZ.EQ.3) THEN
         IX=1
         IY=2
      ELSEIF (IZ.EQ.2) THEN
         IX=3
         IY=1
         CALL XABORT('NXTPR3: ONLY PRIZ IMPLEMENTED WITH NXT.')
      ELSEIF (IZ.EQ.1) THEN
         IX=2
         IY=3
         CALL XABORT('NXTPR3: ONLY PRIZ IMPLEMENTED WITH NXT.')
      ELSE
         CALL XABORT('NXTPR3: ILLEGAL PROJECTION AXIS')
      ENDIF
*----
* RECOVER INFORMATION FROM NXT 3D GEOMETRY ANALYSIS
*----
      CALL LCMGET(IPTRK,'EXCELTRACKOP',RSTATT)
      CALL LCMGET(IPTRK,'SIGNATURE',KSIGN)
      CALL LCMGET(IPTRK,'TRACK-TYPE',KTYPE)
      CALL LCMGET(IPTRK,'ICODE',ICODE)
      CALL LCMGET(IPTRK,'NCODE',NCODE)
      CALL LCMGET(IPTRK,'ALBEDO',ALBEDO)
      JPTRK=LCMDID(IPTRK,'PROJECTION')
      CALL LCMSIX(JPTRK,'NXTRecords',1)
      CALL LCMSIX(IPTRK,'NXTRecords',1)
      WRITE(NAMASG,'(A1,I8.8)') 'G',1
      NAMREC=NAMASG//'DIM'
      CALL XDISET(ESTATE,NSTATE,0)
      CALL LCMGET(IPTRK,NAMREC,ESTATE)
      NDIM     =ESTATE( 1)
      IF (NDIM.NE.3) 
     1 CALL XABORT('NXTPR3: NON 3D GEOMETRY')
      ITYPBC   =ESTATE( 2)
      IDIRG    =ESTATE( 3)
      NBOCEL   =ESTATE( 4)
      NBUCEL   =ESTATE( 5)
      IDIAG    =ESTATE( 6)
      ISAXIS(1)=ESTATE( 7)
      ISAXIS(2)=ESTATE( 8)
      ISAXIS(3)=ESTATE( 9)
      IF (ISAXIS(IZ).NE.0)
     1 CALL XABORT('NXTPR3: Z+- SYMMETRIES NOT YET TREATED')
      NOCELL(1)=ESTATE(10)
      NOCELL(2)=ESTATE(11)
      NOCELL(3)=ESTATE(12)
      NUCELL(1)=ESTATE(13)
      NUCELL(2)=ESTATE(14)
      NUCELL(3)=ESTATE(15)
      MAXMSH   =ESTATE(16)
      MAXREG   =ESTATE(17)
      NBTCLS   =ESTATE(18)
      MAXPIN   =ESTATE(19)
      MAXMSP   =ESTATE(20)
      MAXRSP   =ESTATE(21)
      IF (NFSUR.NE.ESTATE(22))
     1 CALL XABORT('NXTPR3: INCONSISTENT NUMBER OF OUTER SURFACES')
      IF (NFREG.NE.ESTATE(23))
     1 CALL XABORT('NXTPR3: INCONSISTENT NUMBER OF REGIONS')
      MXGSUR   =ESTATE(24)
      MXGREG   =ESTATE(25)
      NUNK=NFSUR+NFREG+1
      MAXMDH=MAX(MAXMSH,MAXMSP,MAXREG)
*     surface-volumes and mixture indexes
      CALL SETARA(IBASE,NUNK,MATALB)
      CALL SETARA(BASE,2*NUNK,SURVOL)
      CALL SETARA(BASE,NUNK,SURVOL1)
      CALL LCMGET(IPTRK,'MATALB      ',IBASE(MATALB))
      CALL LCMGET(IPTRK,'SAreaRvolume',BASE(SURVOL))
      CALL XDRSDB(NUNK,BASE(SURVOL1),BASE(SURVOL),1)
*     cell index and orientation for the cells filling the geometry
      CALL SETARA(IBASE,2*2*NBUCEL,IUNFLD)
      NAMREC=NAMASG//'CUF'
      CALL LCMGET(IPTRK,NAMREC,IBASE(IUNFLD))
*     global mesh for geometry
      CALL SETARA(BASE,2*(MAXMDH+2)*4,DGMESH)
      CALL XDDSET(BASE(DGMESH),(MAXMDH+2)*4,0.D0)
      JJ=2
      DO IDIR=1,NDIM
         NAMREC=NAMASG//'SM'//CDIR(IDIR)
        CALL LCMGET(IPTRK,NAMREC,BASE(DGMESH+JJ))
        JJ=JJ+2*(MAXMDH+2)
      ENDDO
      NUCELZ=NUCELL(IZ)
      CALL SETARA(IBASE,(NUCELZ+1)*4*(MXGSUR+MXGREG+1),INDEX)
      CALL SETARA(IBASE,(NUCELZ+1)*MXGREG,IDREG)
      CALL SETARA(IBASE,(NUCELZ+1)*MXGSUR,IDSUR)
      CALL SETARA(IBASE,NUCELZ*4,MESHC)
      CALL SETARA(IBASE,NUCELZ,NSURC)
      CALL SETARA(IBASE,NUCELZ,NREGC)
      CALL SETARA(IBASE,NUCELZ,IDIRC)
      CALL SETARA(IBASE,NUCELZ,NTPIN)
      CALL SETARA(BASE,(NUCELZ+1)*2*4*(MAXMDH+2),DCMESH)
      CALL SETARA(IBASE,(NUCELZ+1)*3*MAXPIN,ITPIN)
      CALL SETARA(BASE,(NUCELZ+1)*6*2*MAXPIN,DRAPIN)
      CALL SETARA(IBASE,NUNK*(MAXMDH*NUCELZ+2),IND2T3)
      CALL SETARA(BASE,2*MAXMDH*NUCELZ+2,ZCOR)
      CALL SETARA(IBASE,NUNK,REGI)
      CALL SETARA(IBASE,NBUCEL,CELID)
      CALL SETARA(IBASE,NBUCEL*MAXPIN,PINID)
      CALL SETARA(IBASE,NUCELZ,NZC)
      CALL SETARA(IBASE,NUNK,MATALB2)
      CALL SETARA(BASE,2*NUNK,SURVOL2)
*----
* CONSTRUCT 2D GEOMETRY ANALYSIS
*----
*     CONSTRUCT (2D,Z)->3D INDEX AND FILL IN LEVEL 1-2 DESCRIPTION
      CALL NXT3T2(IPTRK,JPTRK,IX,IY,IZ,NFREG,NFSUR,NUNK,ITYPBC,MAXMDH,
     1     NUCELL,NBUCEL,MXGSUR,MXGREG,MAXPIN,IBASE(MATALB),
     2     BASE(SURVOL),IBASE(IUNFLD),BASE(DGMESH),IBASE(INDEX),
     3     IBASE(IDSUR),IBASE(IDREG),IBASE(MESHC),IBASE(NSURC),
     4     IBASE(NREGC),IBASE(IDIRC),IBASE(NTPIN),BASE(DCMESH),
     5     IBASE(ITPIN),BASE(DRAPIN),NZP,N2REG,N2SUR,N2CEL,N2PIN,
     6     IBASE(IND2T3),BASE(ZCOR),IBASE(REGI),IBASE(CELID),
     7     IBASE(PINID),IBASE(NZC),IBASE(MATALB2),BASE(SURVOL2))
*     NXT LEVEL 0 DESCRIPTION
*     record DIM
      ESTATE(1)=2
      ESTATE(4)=ESTATE(4)/NUCELL(3)
      ESTATE(5)=ESTATE(5)/NUCELL(3)
      ESTATE(9)=0
      ESTATE(12)=0
      ESTATE(13)=NUCELL(IX)
      ESTATE(14)=NUCELL(IY)
      ESTATE(15)=0
      ESTATE(16)=N2CEL
      ESTATE(22)=N2SUR
      ESTATE(23)=N2REG
      NAMREC=NAMASG//'DIM'
      CALL LCMPUT(JPTRK,NAMREC,NSTATE,1,ESTATE)
*     record CUF
      NAMREC=NAMASG//'CUF'
      CALL LCMPUT(JPTRK,NAMREC,2*ESTATE(5),1,IBASE(IUNFLD+2*NBUCEL))
*     record SMX,SMY
      NAMREC=NAMASG//'SM'//CDIR(IX)
      CALL LCMIOF(IPTRK,NAMREC,ISMX)
      NAMREC=NAMASG//'SM'//CDIR(1)
      CALL LCMPUT(JPTRK,NAMREC,2*(NUCELL(IX)+1),4,BASE(ISMX))
      NAMREC=NAMASG//'SM'//CDIR(IY)
      CALL LCMIOF(IPTRK,NAMREC,ISMY)
      NAMREC=NAMASG//'SM'//CDIR(2)
      CALL LCMPUT(JPTRK,NAMREC,2*(NUCELL(IY)+1),4,BASE(ISMY))
      CALL LCMIOF(IPTRK,'KEYMRG      ',KEYMRG)
*---
*  ADDITIONAL RECORDS TO MODIFY/ADD IN /PROJECTION/
*---
*     KEYMRG ARRAY
      CALL LCMPUT(JPTRK,'KEYMRG      ',N2SUR+N2REG+1,1,
     1     IBASE(KEYMRG+NFSUR-N2SUR))
*     NXT SPECIFIC STATE-VECTOR
      CALL LCMSIX(JPTRK,' ',2)
      GSTATE(1)=N2REG
      GSTATE(2)=N2REG
      GSTATE(5)=N2SUR
      GSTATE(8)=1
      GSTATE(9)=0
      GSTATE(10)=0
      GSTATE(13)=1
      CALL LCMPUT(JPTRK,'STATE-VECTOR',NSTATE,1,GSTATE)
      CALL LCMPUT(JPTRK,'EXCELTRACKOP',NSTATE,2,RSTATT)  
      CALL LCMPUT(JPTRK,'SIGNATURE   ',3,3,KSIGN)
      CALL LCMPUT(JPTRK,'TRACK-TYPE  ',3,3,KTYPE)
      CALL LCMPUT(JPTRK,'ICODE       ',6,1,ICODE)
      CALL LCMPUT(JPTRK,'ALBEDO      ',6,2,ALBEDO)
*---
*  TAKE CARE OF SYMMETRIES ALONG THE PROJECTION AXIS 
*  UPDATE RECORDS ACCORDINGLY
*---
*     MAIN STATE-VECTOR: store the number of z-plan in the prismatic geometry
      CALL LCMSIX(IPTRK,' ',2)
      CALL XDISET(GSTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',GSTATE)
      GSTATE(39)=NZP
*     NCODE ARRAY
      DO JJ=1,2
         HALFS(JJ)=(NCODE(2*(IZ-1)+JJ).EQ.5)
         SSYM(JJ)=((NCODE(2*(IZ-1)+JJ).EQ.10).OR.(HALFS(JJ)))
      ENDDO
      INVER=(SSYM(1).AND.(.NOT.SSYM(2)))
      IF (SSYM(1).OR.SSYM(2)) NCODE(2*IZ)=30
      IF (SSYM(1).AND.SSYM(2)) NCODE(2*IZ-1)=30
      IF (HALFS(1).OR.HALFS(2)) 
     1 CALL XABORT('NXTPR3: SYME NOT SUPPORTED IN PRISMATIC, USE SSYM.')
      CALL LCMPUT(IPTRK,'NCODE       ',6,1,NCODE)
*
      IF (SSYM(1)) CALL XDISET(IBASE(IND2T3+NFSUR+1),N2REG,0)
      IF (SSYM(2)) 
     1 CALL XDISET(IBASE(IND2T3+(NZP+1)*NUNK+NFSUR+1),N2REG,0)
      NFSURO=NFSUR
      NUNKO=NUNK
      IF (SSYM(1)) NFSUR=NFSUR-N2REG
      IF (SSYM(2)) NFSUR=NFSUR-N2REG
      NUNK=NFSUR+NFREG+1
*
      NUNK2=N2SUR+N2REG+1
      CALL SETARA(IBASE,NUNK2*(NZP+2),IND2T3F)
      CALL SETARA(BASE,NUNK,SURVOLF)
      CALL SETARA(IBASE,NUNK,MATALBF)
      DO JJ=0,NFREG
         BASE(SURVOLF+NFSUR+JJ)=BASE(SURVOL1+NFSURO+JJ)
         IBASE(MATALBF+NFSUR+JJ)=IBASE(MATALB+NFSURO+JJ)
      ENDDO
      JJ=-1
      ISUR=0
      DO 10 K=0,NZP+1
      DO 10 I=0,NUNK2-1
         JJ=JJ+1
         IDIR=IBASE(IND2T3+K*NUNKO+I+NFSURO-N2SUR)
         IF (IDIR.LT.0) THEN
            ISUR=ISUR+1
            IBASE(IND2T3F+JJ)=-ISUR
            BASE(SURVOLF+NFSUR-ISUR)=0.25*BASE(SURVOL1+NFSURO+IDIR)
            IBASE(MATALBF+NFSUR-ISUR)=IBASE(MATALB+NFSURO+IDIR)
         ELSE
            IBASE(IND2T3F+JJ)=IDIR
         ENDIF
 10   CONTINUE
      IF (ISUR.NE.NFSUR) THEN
         write(*,*) ISUR,NFSUR,NFSURO,N2REG
         CALL XABORT('TROUBLE')
      ENDIF   
      GSTATE(5)=NFSUR
      CALL SETARA(BASE,(NZP+1),ZCORF)
      IF (INVER) THEN
         DO K=0,(NZP+1)/2
            DO I=0,NUNK2-1
               ITEMP=IBASE(IND2T3F+K*NUNK2+I)
               IBASE(IND2T3F+K*NUNK2+I)=IBASE(IND2T3F+(NZP+1-K)*NUNK2+I)
               IBASE(IND2T3F+(NZP+1-K)*NUNK2+I)=ITEMP
            ENDDO
         ENDDO
         BASE(ZCORF)=0.0
         DO K=1,NZP
            CALL XDDSET(DZ2,1,BASE(ZCOR+2*(NZP-K+1)))
            CALL XDDSET(DZ1,1,BASE(ZCOR+2*(NZP-K)))
            BASE(ZCORF+K)=BASE(ZCORF+K-1)+REAL(DZ2-DZ1)
         ENDDO
      ELSE
         CALL XDRSDB(NZP+1,BASE(ZCORF),BASE(ZCOR),1)
      ENDIF
      CALL LCMPUT(JPTRK,'MATALB      ',NUNK,1,IBASE(MATALBF))
      CALL LCMPUT(JPTRK,'VOLSUR      ',NUNK,2,BASE(SURVOLF))
      CALL LCMPUT(JPTRK,'IND2T3      ',NUNK2*(NZP+2),1,IBASE(IND2T3F))  
      CALL LCMPUT(JPTRK,'ZCOORD      ',(NZP+1),2,BASE(ZCORF))   
      CALL LCMPUT(IPTRK,'STATE-VECTOR',NSTATE,1,GSTATE)
      CALL RLSARA(BASE(ZCORF))
      CALL RLSARA(IBASE(MATALBF))
      CALL RLSARA(BASE(SURVOLF))
      CALL RLSARA(IBASE(IND2T3F))
*----
*  DEALLOCATE MEMORY
*----
      CALL RLSARA(BASE(SURVOL2))
      CALL RLSARA(IBASE(MATALB2))
      CALL RLSARA(IBASE(NZC))
      CALL RLSARA(IBASE(CELID))
      CALL RLSARA(IBASE(REGI))
      CALL RLSARA(BASE(ZCOR))
      CALL RLSARA(IBASE(IND2T3))
      CALL RLSARA(BASE(DRAPIN))
      CALL RLSARA(IBASE(ITPIN))
      CALL RLSARA(BASE(DCMESH))
      CALL RLSARA(IBASE(IDSUR))
      CALL RLSARA(IBASE(IDREG))
      CALL RLSARA(IBASE(INDEX))
      CALL RLSARA(BASE(DGMESH))
      CALL RLSARA(IBASE(IUNFLD))
      CALL RLSARA(BASE(SURVOL1))
      CALL RLSARA(BASE(SURVOL))
      CALL RLSARA(IBASE(MATALB))
*
      RETURN
      END
