*DECK PIJSDB
      SUBROUTINE PIJSDB(NBELEM,RVECT,DBVECT,KDIR)
*
*-----------------------------------------------------------------------
*
*Purpose:
* double precision to/from simple precision conversion.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): G. Marleau
*
*Parameters: input
* NBELEM  number of words to translate.
* KDIR    direction of translation:
*         =1: from double to simple precision;
*         =2: from simple to double precision.
*
*Parameters: input/output
* RVECT   simple precision vector.
* DBVECT  double precision vector.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER           NBELEM,KDIR
      REAL              RVECT(NBELEM)
      DOUBLE PRECISION  DBVECT(NBELEM)
*----
*  LOCAL VARIABLES
*----
      CHARACTER         CERROR*4
*
      IF(KDIR.EQ.1) THEN
*----
*  FROM DOUBLE TO SIMPLE PRECISION
*----
        DO 100 IELEM=1,NBELEM
          RVECT(IELEM)=REAL(DBVECT(IELEM))
 100    CONTINUE
      ELSE IF(KDIR.EQ.2) THEN
*----
*  FROM SIMPLE TO DOUBLE PRECISION
*----
        DO 200 IELEM=NBELEM,1,-1
          DBVECT(IELEM)=DBLE(RVECT(IELEM))
 200    CONTINUE
      ELSE
*----
*  INVALID VALUE FOR KDIR
*----
        WRITE(CERROR,'(I4)') KDIR
        CALL XABORT('PIJSDB: ONLY KDIR=1 AND KDIR=2 ALLOWED; KDIR='
     >  //CERROR//' FOUND')
      ENDIF
      RETURN
      END
