*DECK PSPGEO
      SUBROUTINE PSPGEO(IPRINT,ISPSP ,ITYPE ,ICOLR ,IPGEOM,NAMFIL,
     >                  NAMLEG,NUNKNO,FLUX  )
C
C----
C  1- PROGRAMME STATISTICS:
C      NAME     : PSP
C      USE      : GEOMETRY POSTSCRIPT PLOT UTILITY MODULE
C      AUTHOR   : G.MARLEAU
C      CREATED  : 99-01-21
C
C      MODIFICATION LOG
C      --------------------------------------------------------------
C      | DATE AND INITIALS  | MOTIVATIONS
C      --------------------------------------------------------------
C      | 99-01-21 G.M.      | PSPGEO IS FOR GENERATION OF GRAPHICS
C      |                    | FOR EXCELL TYPE GEOMETRIES
C      |                    | BASED ON XELDRV FOR EXCELL
C      |                    | GEOMETRY ANALYSIS
C      ______________________________________________________________
C
C  2- ROUTINE PARAMETERS:
C     IPRINT : PRINT LEVEL                              I
C     ISPSP  : PSP FILE UNIT                            I
C     ITYPE  : TYPE OF GRAPHIC                          I
C              =  0 COLOR PER REGION NUMBER
C                 1 COLOR PER MATERIAL
C                 2 COLOR FOR FLUX (ONE GROUP)
C                 3 COLOR FOR FLUX (MULTIGROUP)
C     ICOLR  : COLOR SET USED                           I
C              = -4 FILL HSB WITH NO-CONTOUR
C              = -3 FILL CMYK WITH NO-CONTOUR
C              = -2 FILL RGB WITH NO-CONTOUR
C              = -1 FILL BW WITH NO-CONTOUR
C              =  0 NO FILL CONTOUR ONLY
C              =  1 FILL BW AND CONTOUR
C              =  2 FILL RGB AND CONTOUR
C              =  3 FILL CMYK AND CONTOUR
C              =  4 FILL HSB AND CONTOUR
C     IPGEOM : GEOMETRY DATA STRUCTURES POINTER         I
C     NANFIL : GEOMETRY FILE NAME                       C*12
C     NAMLEG : LEGEND NAME                              C*24
C     NUNKNO : NUMBER OF UNKNOW                         I
C     FLUX   : FLUXES                                   R(NUNKNO)
C----
C
      IMPLICIT     NONE
      INTEGER      IOUT,NSTATE,NALB,MREGIO,MXDIM
      REAL         ZERO,ONE
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NSTATE=40,NALB=6,MREGIO=100000,MXDIM=3,
     >             ZERO=0.0,ONE=1.0,NAMSBR='PSPGEO')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPRINT,ISPSP,ITYPE,ICOLR,IPGEOM,NUNKNO
      CHARACTER    NAMFIL*12,NAMLEG*24
      REAL         FLUX(NUNKNO)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER      IBASE(1)
      REAL         RBASE
      COMMON       RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
      INTEGER      INCELL,INDEX,ICORD,MAXDIM,MINDIM,JREMSH,
     >             JCOLRG,MATALB,KEYMRG,JVOLSU,MRGCEL,MATRT,
     >             KEYCYL,KEYINT,MATTYP,INDEXO,MATGEO,JVOLSO,
     >             ICORDO,MAXDO,MINDO,JRMSHO,IDLREM,KCELLG,
     >             IDLBLK,KEYTYP,IDLTYP,KEYGEO,IDLDIM,IDLGEO,
     >             NVOLO,NSURO,ISPLT,KEYSYM,KEYTRN,KCELLT,
     >             ITGEOM,JVRG,JRAD,ISPLIT,MATROD,MATANN,
     >             NXRS,NXRI,NRODR,NRINFO,JRODR,JRODS,NRODS,
     >             JRAN,KEYFLX
C----
C  LOCAL VARIABLES
C----
      INTEGER      ISTATE(NSTATE),NDIM,NVOL,NSUR,
     >             NCODE(NALB),ICODE(NALB),IMS(NALB),
     >             MAXGRI(MXDIM),LCLSYM(MXDIM),LCLTRA(MXDIM),
     >             MRGSUR(-NALB:-1),NEXTGE,
     >             MAXRO ,NTOTCO,NTYP  ,NGEOME,NBLOCK,NTYPO ,
     >             IFCSYM,NBMIX ,MAXR  ,NTOTCL,NSBC  ,NUNK  ,
     >             NTIDL ,NGIDL ,NUNKO ,NBAN  ,IROT  ,NRT   ,
     >             MNAN  ,ITGEO ,ITYPEG,MAXJ  ,ISYMM ,NMAT  ,
     >             IHS   ,MAROD ,MSROD ,NSURX ,NSURF ,
     >             NREGT ,IREG
      INTEGER      NSURC,NVOLC
      LOGICAL      LEAKSW,LL1,LL2,L1CELL
      REAL         ZCODE(NALB),ALBEDO(NALB),COTE,RADMIN
C----
C  ANALYZE GEOMETRY
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      ITYPEG= ISTATE(1)
      IF(ITYPEG .EQ. 3 .OR. ITYPEG .EQ. 6 ) THEN
         ITGEO= 1
      ELSE IF(ITYPEG .EQ.  8 .OR. ITYPEG .EQ.  9 .OR.
     >        ITYPEG .EQ. 24 .OR. ITYPEG .EQ. 25      ) THEN
        ITGEO= 2
      ELSE IF(ITYPEG .EQ.  5 .OR. ITYPEG .EQ.  7 .OR.
     >        ITYPEG .EQ. 20 .OR. ITYPEG .EQ. 21 .OR.
     >        ITYPEG .EQ. 22 .OR. ITYPEG .EQ. 23      ) THEN
        ITGEO= 3
      ELSE
        ITGEO= 0
      ENDIF
      IF( ISTATE(13) .GE. 1 ) THEN
C----
C  CLUSTER CELLS
C----
        ISYMM=1
        NDIM=2
        IF(ITYPEG .EQ. 3) THEN
          NSUR=1
        ELSE IF(ITYPEG .EQ. 20) THEN
          NSUR=4
        ELSE IF(ITYPEG .EQ. 24) THEN
          NSUR=6
        ELSE
          CALL XABORT(NAMSBR//
     >      ': ONLY ONE-CELL CLUSTERS ARE AVAILABLE')
        ENDIF
        MAXJ=1
        IROT=0
        CALL XCGDIM(IPGEOM,MREGIO,NSUR  ,IROT  ,ISYMM ,MAXJ  ,
     >              NVOL  ,NBAN  ,MNAN  ,NRT   ,MSROD ,MAROD ,
     >              NSURF )
C----
C  CHECK FOR SYMMETRY
C----
        NSURX=NSUR
        DO 110 IHS=1,NSUR
          IMS(IHS)=IHS
 110    CONTINUE
        IF(ISYMM.GT.1) THEN
          IF(NSURX.EQ.4) THEN
            IROT=-ISYMM-400
          ELSE IF(NSURX.EQ.6) THEN
            IROT=-ISYMM-600
          ELSE
            IROT=-ISYMM-100
          ENDIF
          DO 111 IHS=1,NSURX
            IMS(IHS)=1
 111      CONTINUE
          NSUR=1
        ENDIF
C----
C  ALLOCATE MEMORY FOR GRAPHICS
C----
        CALL SETARA(RBASE,NBAN,JRAN)
        CALL SETARA(IBASE,3*NRT,NRODS)
        CALL SETARA(RBASE,2*NRT,JRODS)
        CALL SETARA(RBASE,MSROD*NRT,JRODR)
        CALL SETARA(IBASE,NSUR+NVOL+1,MATALB)
        CALL SETARA(RBASE,4*NVOL,JCOLRG)
        CALL SETARA(IBASE,2*MNAN,NRINFO)
        CALL SETARA(IBASE,NRT,NRODR)
        CALL SETARA(IBASE,NRT*NBAN,NXRI)
C----
C  ALLOCATE TEMPORARY BLOCKS
C----
        CALL SETARA(IBASE,NSUR+NVOL+1,KEYMRG)
        CALL SETARA(RBASE,NSUR+NVOL+1,JVOLSU)
        CALL SETARA(IBASE,NRT,NXRS)
        CALL SETARA(IBASE,NBAN,MATANN)
        CALL SETARA(IBASE,MSROD*NRT,MATROD)
        CALL SETARA(IBASE,NBAN,ISPLIT)
        CALL SETARA(RBASE,MNAN,JRAD)
        CALL SETARA(RBASE,2*NRT,JVRG)
        CALL XCGGEO(IPGEOM,IROT  ,NSUR  ,NVOL  ,NBAN  ,MNAN  ,
     >              NRT   ,MSROD ,IPRINT,LEAKSW,NMAT  ,
     >              RBASE(JRAN)  ,IBASE(MATANN),IBASE(NRODS) ,
     >              RBASE(JRODS) ,IBASE(MATROD),IBASE(NRODR) ,
     >              RBASE(JRODR) ,IBASE(NRINFO),IBASE(MATALB),
     >              RBASE(JVOLSU),IBASE(ISPLIT),RBASE(JRAD)  ,
     >              COTE  ,RADMIN,NCODE ,ICODE ,ZCODE ,ALBEDO,
     >              IBASE(KEYMRG),IBASE(NXRS)  ,IBASE(NXRI)  ,
     >              RBASE(JVRG)  )
C----
C  RELEASE TEMPORARY BLOCKS
C----
        CALL RLSARA(RBASE(JVRG))
        CALL RLSARA(RBASE(JRAD))
        CALL RLSARA(IBASE(ISPLIT))
        CALL RLSARA(IBASE(MATROD))
        CALL RLSARA(IBASE(MATANN))
        CALL RLSARA(IBASE(NXRS))
        CALL RLSARA(RBASE(JVOLSU))
C----
C  GENERATE GRAPHICS
C----
        NSUR=-NSUR
        IF(ITYPE .EQ. 2 .OR. ITYPE .EQ. 3) THEN
          NREGT=0
          DO 120 IREG=KEYMRG-NSUR+1,KEYMRG-NSUR+NVOL
            NREGT=MAX(NREGT,IBASE(IREG))
 120      CONTINUE
          CALL SETARA(IBASE,NREGT,KEYFLX)
          DO 121 IREG=1,NREGT
            IBASE(IREG+KEYFLX-1)=IREG
 121      CONTINUE
        ELSE
          NREGT=1
          CALL SETARA(IBASE,NREGT,KEYFLX)
          IBASE(KEYFLX)=0
        ENDIF
        CALL PSPLEG(IPRINT,ISPSP ,ITYPE ,ICOLR ,NSUR  ,NVOL  ,
     >              NAMLEG,NUNKNO,FLUX  ,NREGT ,
     >              IBASE(MATALB),IBASE(KEYMRG),IBASE(KEYFLX),
     >              RBASE(JCOLRG))
        CALL PSPXCG(IPRINT,ISPSP ,ICOLR ,NBAN  ,NRT   ,MSROD ,
     >              NSURX ,NSUR  ,NVOL  ,COTE  ,
     >              RBASE(JRAN)  ,IBASE(NRODS) ,RBASE(JRODS) ,
     >              RBASE(JRODR) ,IBASE(NRINFO),IBASE(NRODR) ,
     >              IBASE(NXRI)  ,IBASE(KEYMRG),RBASE(JCOLRG))
C----
C  RELEASE MEMORY FOR GRAPHICS
C----
        CALL RLSARA(IBASE(KEYFLX))
        CALL RLSARA(IBASE(KEYMRG))
        CALL RLSARA(IBASE(NXRI))
        CALL RLSARA(IBASE(NRODR))
        CALL RLSARA(IBASE(NRINFO))
        CALL RLSARA(RBASE(JCOLRG))
        CALL RLSARA(IBASE(MATALB))
        CALL RLSARA(RBASE(JRODR))
        CALL RLSARA(RBASE(JRODS))
        CALL RLSARA(IBASE(NRODS))
        CALL RLSARA(RBASE(JRAN))
C      ELSE IF(ITGEO .EQ. 2 ) THEN
C----
C  HEXAGONAL 2D GEOMETRIES
C         CALL PSPXHX(IPRINT,IPGEOM,TITREC)
      ELSE IF(ITGEO .EQ. 3 ) THEN
C----
C  CARTESIAN 2D/3D ASSEMBLIES
C  CALL XELPRP TO GET GEOMETRY DIMENSIONING INFORMATION
C----
        CALL XELPRP( IPGEOM,  NAMFIL,  NDIM,  NTYPO, NBLOCK,  NBMIX,
     >               MAXGRI,  ALBEDO, ICODE,  NCODE, LCLSYM, LCLTRA,
     >               MRGSUR,  LEAKSW,   LL1,    LL2, L1CELL, NEXTGE,
     >               IFCSYM,  IPRINT)
C----
C  ALLOCATE MEMORY - 1
C----
        CALL SETARA(IBASE,  NBLOCK,MRGCEL)
        CALL SETARA(IBASE,  NBLOCK, NSURO)
        CALL SETARA(IBASE,  NBLOCK, NVOLO)
        CALL SETARA(IBASE,  NBLOCK,IDLGEO)
        CALL SETARA(IBASE,  NBLOCK,IDLDIM)
        CALL SETARA(IBASE,  NBLOCK,KEYGEO)
        CALL SETARA(IBASE,  NBLOCK,IDLTYP)
        CALL SETARA(IBASE,  NBLOCK,KEYTYP)
        CALL SETARA(IBASE,  NBLOCK,IDLBLK)
        CALL SETARA(IBASE,3*NBLOCK,KCELLG)
        CALL SETARA(IBASE,  MREGIO, ISPLT)
        CALL SETARA(IBASE,  NBLOCK,KEYTRN)
        CALL SETARA(IBASE,  NBLOCK,ITGEOM)
        CALL SETARA(IBASE, 3*NTYPO,KCELLT)
C----
C  CALL XELDCL TO READ GEOMETRY BLOCK DESCRIPTION
C----
        CALL XELDCL(IPGEOM,NAMFIL,NDIM  ,MAXGRI,LCLSYM,NBLOCK ,
     >              NTYPO ,LL1   ,LL2   ,IPRINT,NTOTCO,MAXRO  ,
     >              NGEOME,NTYP  ,NGIDL ,NTIDL ,NUNKO ,
     >              IBASE(KCELLG),IBASE(NSURO) ,IBASE(NVOLO) ,
     >              IBASE(IDLDIM),IBASE(IDLGEO),IBASE(KEYTRN),
     >              IBASE(KEYGEO),IBASE(IDLTYP),IBASE(KEYTYP),
     >              IBASE(MRGCEL),IBASE(IDLBLK),IBASE(ITGEOM),
     >              IBASE(KCELLT),IBASE(ISPLT) )
C----
C  RELEASE SOME MEMORY
C---
        CALL RLSARA(IBASE(KCELLT))
        CALL RLSARA(IBASE(ITGEOM))
C----
C  ALLOCATE MEMORY - 2
C----
        CALL SETARA(IBASE, NGEOME,IDLREM)
        CALL SETARA(RBASE,  MAXRO,JRMSHO)
        CALL SETARA(IBASE, NTOTCO, MINDO)
        CALL SETARA(IBASE, NTOTCO, MAXDO)
        CALL SETARA(IBASE, NTOTCO,ICORDO)
        CALL SETARA(RBASE,  NGIDL,JVOLSO)
        CALL SETARA(IBASE,  NGIDL,MATGEO)
        CALL SETARA(IBASE,4*NGIDL,INDEXO)
        CALL SETARA(IBASE,  NGIDL,KEYSYM)
C----
C  CALL XELTRP TO PRODUCE REGION NUMBERING
C  AND VOLUME EVALUATION
C----
        CALL XELTRP(IPGEOM,NDIM  ,NGEOME,L1CELL ,NTOTCO,NEXTGE,
     >              MAXRO ,IPRINT,IBASE(KCELLG),IBASE(NSURO) ,
     >              IBASE(NVOLO) ,IBASE(IDLDIM),IBASE(IDLGEO),
     >              IBASE(KEYTRN),IBASE(MAXDO) ,IBASE(MINDO) ,
     >              IBASE(ICORDO),RBASE(JRMSHO),IBASE(IDLREM),
     >              IBASE(INDEXO),RBASE(JVOLSO),IBASE(MATGEO),
     >              IBASE(KEYSYM),IBASE(ISPLT) )
C----
C  RELEASE SOME MEMORY
C----
        CALL RLSARA(IBASE(KEYSYM))
        CALL RLSARA(IBASE(KEYTRN))
C----
C  ALLOCATE MEMORY - 3
C----
        CALL SETARA(IBASE,NTIDL,MATTYP)
        CALL SETARA(IBASE,NUNKO,KEYINT)
C----
C     INTERFACE ALL CELLS IN THE GEOMETRY
C----
        CALL XELBIN(IPGEOM,NDIM  ,NGEOME,L1CELL,NTYP  ,NGIDL ,
     >              NTIDL ,NBLOCK,MAXGRI,NUNKO ,IPRINT,
     >              IBASE(KCELLG),IBASE(NSURO) ,IBASE(NVOLO) ,
     >              IBASE(IDLGEO),IBASE(MATGEO),IBASE(KEYGEO),
     >              IBASE(IDLTYP),IBASE(IDLBLK),IBASE(KEYTYP),
     >              IBASE(MATTYP),IBASE(KEYINT),IBASE(ISPLT) )
C----
C  RELEASE SOME MEMORY
C----
        CALL RLSARA(IBASE(ISPLT))
C----
C  ALLOCATE MEMORY - 4
C----
        CALL SETARA(IBASE,NBLOCK,KEYCYL)
C----
C  COMPUTE ALLOCATION IN EXACT GEOMETRY.
C----
        CALL XELEDC(NDIM  ,MAXGRI,NGEOME,NTOTCO,NTYP  ,NBLOCK,
     >              NUNKO ,       IBASE(NSURO) ,IBASE(NVOLO) ,
     >              IBASE(MINDO) ,IBASE(MAXDO) ,IBASE(ICORDO),
     >              IBASE(IDLDIM),IBASE(KEYGEO),IBASE(KEYTYP),
     >              IBASE(IDLBLK),IBASE(KEYINT),NTOTCL,MAXR  ,
     >              NSUR  ,NVOL  ,IBASE(KEYCYL))
        NUNK= NVOL + 1 - NSUR
C----
C  ALLOCATE MEMORY - 5
C----
        CALL SETARA(RBASE,  NUNK,JVOLSU)
        CALL SETARA(IBASE,  NUNK,KEYMRG)
        CALL SETARA(IBASE,  NUNK,MATALB)
        CALL SETARA(RBASE,4*NVOL,JCOLRG)
        CALL SETARA(RBASE,  MAXR,JREMSH)
        CALL SETARA(IBASE,NTOTCL,MINDIM)
        CALL SETARA(IBASE,NTOTCL,MAXDIM)
        CALL SETARA(IBASE,NTOTCL, ICORD)
        CALL SETARA(IBASE,4*NUNK, INDEX)
        CALL SETARA(IBASE,  NUNK,INCELL)
C----
C  TO RECONSTRUCT THE MESH IN EXACT GEOMETRY.
C----
        CALL XELETR(IPRINT,NDIM  ,MAXGRI,NGEOME,NTOTCO,NTYP  ,
     >              NTIDL ,NBLOCK,NSUR  ,NVOL  ,NTOTCL,NUNKO ,
     >              IBASE(NSURO) ,IBASE(NVOLO) ,IBASE( MINDO),
     >              IBASE(MAXDO) ,IBASE(ICORDO),IBASE(IDLDIM),
     >              IBASE(IDLGEO),IBASE(KEYGEO),IBASE(IDLTYP),
     >              IBASE(KEYTYP),IBASE(IDLBLK),IBASE(KEYCYL),
     >              RBASE(JRMSHO),IBASE(IDLREM),IBASE(INDEXO),
     >              RBASE(JVOLSO),IBASE(MATGEO),IBASE(KEYINT),
     >              IBASE(MATTYP),RBASE(JREMSH),IBASE(MINDIM),
     >              IBASE(MAXDIM),IBASE(ICORD) ,RBASE(JVOLSU),
     >              IBASE(KEYMRG),IBASE(INDEX) ,IBASE(INCELL),
     >              IBASE(MATALB),NSURC ,NVOLC )
        NSUR=NSURC
        NVOL=NVOLC
        NUNK= NVOL + 1 - NSUR
        CALL RLSARA(IBASE(KEYCYL))
        CALL RLSARA(IBASE(KEYINT))
        CALL RLSARA(IBASE(MATTYP))
        CALL RLSARA(IBASE(INDEXO))
        CALL RLSARA(IBASE(MATGEO))
        CALL RLSARA(RBASE(JVOLSO))
        CALL RLSARA(IBASE(ICORDO))
        CALL RLSARA(IBASE(MAXDO))
        CALL RLSARA(IBASE(MINDO))
        CALL RLSARA(RBASE(JRMSHO))
        CALL RLSARA(IBASE(IDLREM))
        CALL RLSARA(IBASE(KCELLG))
        CALL RLSARA(IBASE(IDLBLK))
        CALL RLSARA(IBASE(KEYTYP))
        CALL RLSARA(IBASE(IDLTYP))
        CALL RLSARA(IBASE(KEYGEO))
        CALL RLSARA(IBASE(IDLDIM))
        CALL RLSARA(IBASE(IDLGEO))
        CALL RLSARA(IBASE(NVOLO))
        CALL RLSARA(IBASE(NSURO))
C----
C  ALLOCATE MEMORY - 6
C----
        CALL SETARA(IBASE,-NSUR*2,MATRT)
C----
C  PREPARE MERGING OF ZONES AND SURFACES USING BOUNDARY CONDITIONS.
C  SET UP REFLECTION-TRANSMISSION MATRIX
C----
        CALL XELMRG(IPRINT,NSUR  ,NVOL  ,NSBC  ,NTOTCL,
     >              IBASE(INDEX) ,IBASE(MINDIM),IBASE(MAXDIM),
     >              LCLSYM,LCLTRA,LL1   ,LL2   ,NEXTGE,
     >              IBASE(MRGCEL),IBASE(MATALB),IBASE(KEYMRG),
     >              IBASE(INCELL),IBASE(MATRT) )
        CALL RLSARA(IBASE(MATRT))
C----
C  GENERATE POSTSCRIPT FILE FOR GEOMETRY
C----
        IF(NDIM .EQ. 2) THEN
          IF(ITYPE .EQ. 2 .OR. ITYPE .EQ. 3) THEN
            NREGT=0
            DO 130 IREG=KEYMRG-NSUR+1,KEYMRG-NSUR+NVOL
              NREGT=MAX(NREGT,IBASE(IREG))
 130        CONTINUE
            CALL SETARA(IBASE,NREGT,KEYFLX)
            DO 131 IREG=1,NREGT
              IBASE(IREG+KEYFLX-1)=IREG
 131        CONTINUE
          ELSE
            NREGT=1
            CALL SETARA(IBASE,NREGT,KEYFLX)
            IBASE(KEYFLX)=0
          ENDIF
          CALL PSPLEG(IPRINT,ISPSP ,ITYPE ,ICOLR ,NSUR  ,NVOL  ,
     >                NAMLEG,NUNKNO,FLUX  ,NREGT ,
     >                IBASE(MATALB),IBASE(KEYMRG),IBASE(KEYFLX),
     >                RBASE(JCOLRG))
          CALL PSPXEL(IPRINT,ISPSP ,ICOLR ,NDIM  ,NSUR  ,NVOL  ,
     >                NTOTCL,MAXR  ,
     >                IBASE(MINDIM),IBASE(MAXDIM),IBASE(KEYMRG),
     >                IBASE(INDEX) ,RBASE(JREMSH),RBASE(JCOLRG))
        ELSE
          WRITE(IOUT,6000)
        ENDIF
C----
C  RELEASE REMAINING MEMORY
C----
        CALL RLSARA(IBASE(INCELL))
        CALL RLSARA(IBASE(INDEX))
        CALL RLSARA(IBASE(ICORD))
        CALL RLSARA(IBASE(MAXDIM))
        CALL RLSARA(IBASE(MINDIM))
        CALL RLSARA(RBASE(JREMSH))
        CALL RLSARA(RBASE(JCOLRG))
        CALL RLSARA(IBASE(MATALB))
        CALL RLSARA(IBASE(KEYMRG))
        CALL RLSARA(RBASE(JVOLSU))
        CALL RLSARA(IBASE(MRGCEL))
      ELSE
        CALL XABORT(NAMSBR//
     >    ': INVALID TYPE OF GEOMETRY')
      ENDIF
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(' POSTSCRIPT PLOT NOT YET ALLOWED FOR 3-D',
     >       ' CARTESIAN GEOMETRIES')
      END
