*DECK SAPCAL
      SUBROUTINE SAPCAL(IMPX,IPSAP,IPDEPL,IPEDIT)
*
*-----------------------------------------------------------------------
*
*Purpose:
* store the results of an elementary calculation in the Saphyb.
*
*Copyright:
* Copyright (C) 2007 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IMPX    print parameter.
* IPSAP   pointer to the Saphyb.
* IPDEPL  pointer to the burnup object (L_BURNUP signature).
* IPEDIT  pointer to the edition object (L_EDIT signature).
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IMPX,IPSAP,IPDEPL,IPEDIT
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NDIMSA=50,NSTATE=40,MAXMAC=2)
      INTEGER IDATA(NDIMSA),IPAR(NSTATE),KCHAR(3),TYPMAC(MAXMAC),
     1 IBASE(1)
      REAL BIRRAD(2)
      CHARACTER CDIRO*12,HSMG*131,TEXT20*20
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      CALL LCMGET(IPEDIT,'LAST-EDIT',KCHAR)
      WRITE(CDIRO,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMSIX(IPEDIT,CDIRO,1)
      CALL LCMLEN(IPEDIT,'STATE-VECTOR',ILONG,ITYLCM)
      IF(ILONG.NE.0) THEN
         CALL LCMGET(IPEDIT,'STATE-VECTOR',IPAR)
         NBISO=IPAR(2)
         NDFI=IPAR(20)
      ELSE
         NBISO=0
         NDFI=0
      ENDIF
      CALL LCMSIX(IPEDIT,'MACROLIB',1)
      CALL LCMGET(IPEDIT,'STATE-VECTOR',IPAR)
      NG=IPAR(1)
      NMIL=IPAR(2)
      NL=IPAR(3)
      IF(IPAR(4).GT.1) CALL XABORT('SAPCAL: CANNOT PROCESS MULTIPLE FI'
     1 //'SSION SPECTRA.')
      ITRANC=IPAR(6)
      NPRC=IPAR(7)
*
      CALL LCMGET(IPSAP,'DIMSAP',IDATA)
      NREA=IDATA(4)
      NISO=IDATA(5)
      NMAC=IDATA(6)
      NADRX=IDATA(18)
      ICAL=IDATA(19)+1
      IF(IDATA(19).EQ.0) THEN
*        COMPLETE DIMSAP AND CONTENU DIRECTORY.
         IF(IDATA(7).EQ.0) THEN
            IDATA(7)=NMIL
            CALL SETARA(BASE,5*NMIL,IHMIX)
            DO 10 IMIL=1,NMIL
            TEXT20=' '
            WRITE(TEXT20,'(3HMIX,I5.5)') IMIL
            READ(TEXT20,'(5A4)') (BASE(IHMIX+(IMIL-1)*5+I0),I0=0,4)
   10       CONTINUE
            CALL LCMSIX(IPSAP,'geom',1)
            CALL LCMPUT(IPSAP,'NOMMIL',5*NMIL,3,BASE(IHMIX))
            CALL LCMSIX(IPSAP,' ',2)
            CALL RLSARA(BASE(IHMIX))
         ELSE IF(NMIL.NE.IDATA(7)) THEN
            WRITE(HSMG,'(42HSAPCAL: ELEMENTARY CALCULATION WITH AN INV,
     1      22HALIB NB. OF MIXTURES =,I7,3H NE,I7,1H.)') NMIL,IDATA(7)
            CALL XABORT(HSMG)
         ENDIF
         IDATA(20)=NG
         IDATA(31)=NPRC
         CALL LCMSIX(IPSAP,'contenu',1)
         CALL SETARA(IBASE,NMIL,IWORKT)
         CALL SETARA(IBASE,NMIL,IWORKR)
         CALL XDISET(IBASE(IWORKT),NMIL,0)
         CALL XDISET(IBASE(IWORKR),NMIL,0)
         IF(NMAC.GT.0) CALL LCMGET(IPSAP,'TYPMAC',TYPMAC)
         DO 20 IMAC=1,NMAC
         IF(TYPMAC(IMAC).EQ.1) CALL XDISET(IBASE(IWORKT),NMIL,IMAC)
         IF(TYPMAC(IMAC).EQ.2) CALL XDISET(IBASE(IWORKR),NMIL,IMAC)
   20    CONTINUE
         CALL LCMPOF(IPSAP,'TOTMAC',NMIL,1,IWORKT)
         CALL LCMPOF(IPSAP,'RESMAC',NMIL,1,IWORKR)
         CALL LCMSIX(IPSAP,' ',2)
*
*        RECOVER MIXTURE VOLUMES.
         CALL SETARA(BASE,NMIL,IVOL)
         CALL LCMGET(IPEDIT,'VOLUME',BASE(IVOL))
         CALL LCMSIX(IPSAP,'geom',1)
         CALL LCMPOF(IPSAP,'XVOLMT',NMIL,2,IVOL)
         CALL LCMSIX(IPSAP,' ',2)
      ELSE
         IF(NMIL.NE.IDATA(7)) THEN
            WRITE(HSMG,'(42HSAPCAL: ELEMENTARY CALCULATION WITH AN INV,
     1      22HALIB NB. OF MIXTURES =,I7,3H NE,I7,1H.)') NMIL,IDATA(7)
            CALL XABORT(HSMG)
         ELSE IF(NG.NE.IDATA(20)) THEN
            WRITE(HSMG,'(42HSAPCAL: ELEMENTARY CALCULATION WITH AN INV,
     1      20HALIB NB. OF GROUPS =,I7,3H NE,I7,1H.)') NG,IDATA(20)
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
      CALL LCMSIX(IPEDIT,' ',2)
*----
*  RECOVER THE FLUX NORMALIZATION FACTOR.
*----
      IF(IPDEPL.NE.0) THEN
         CALL LCMGET(IPDEPL,'BURNUP-IRRAD',BIRRAD)
         BURN=BIRRAD(1)/8.64E-4
         CALL LCMLEN(IPDEPL,'FLUX-NORM',ILONG,ITYLCM)
         IF(ILONG.EQ.0) THEN
            WRITE(HSMG,'(40HSAPCAL: THE ''FLUX-NORM'' RECORD IS NOT SE,
     1      20HT FOR BURNUP STEP AT,E12.5,14H MW-DAY/TONNE.)') BURN
            CALL XABORT(HSMG)
         ENDIF
         CALL LCMGET(IPDEPL,'FLUX-NORM',FNORM)
         IF(IMPX.GT.0) WRITE(6,100) FNORM,BURN
      ELSE
         FNORM=1.0
         IF(IMPX.GT.0) WRITE(6,110)
      ENDIF
*----
*  RECOVER THE CROSS SECTIONS.
*----
      MAXRDA=(NREA*NG+NL*NG+NL*NG*NG)*(NISO+NMAC)
      MAXIDA=(2*NG+7)*NL*(NISO+NMAC)
      CALL SETARA(BASE,NMIL,IFLUMI)
      CALL SETARA(BASE,NMIL,IRESMA)
      CALL SETARA(BASE,(NREA+2)*(NISO+NMAC)*(NADRX+NMIL),IADRX)
      CALL SETARA(BASE,(NISO+NMAC)*NMIL,IISOMI)
      CALL SETARA(BASE,NMIL,INISOM)
      CALL SETARA(BASE,NMIL,IISADR)
      CALL SETARA(BASE,NMIL,ILENGX)
      CALL SETARA(BASE,NMIL,ILENGP)
      CALL SETARA(BASE,MAXRDA,IRDATA)
      CALL SETARA(BASE,MAXIDA,IIDATA)
      CALL SETARA(BASE,NG,IFLUX)
      CALL SETARA(BASE,NG,IOVERV)
      CALL SETARA(BASE,(NPRC+1)*NG,IDNUSI)
      CALL SETARA(BASE,NPRC*NG,IDCHI)
      CALL SETARA(BASE,NPRC,IWORKD)
      CALL SETARA(BASE,NG,IIFDG)
      CALL SETARA(BASE,NG+1,IIADR)
      CALL SETARA(BASE,NG,IIFDG2)
      CALL SETARA(BASE,NG+1,IIADR2)
      CALL SETARA(BASE,NMIL,IIJJ1)
      CALL SETARA(BASE,NMIL,INJJ1)
      CALL SETARA(BASE,NMIL,IIPOS)
      CALL SETARA(BASE,NG,IIJJ2)
      CALL SETARA(BASE,NG,INJJ2)
      CALL SETARA(BASE,NG*NMIL,IWORK1)
      CALL SETARA(BASE,NG,IWORK2)
      CALL SETARA(BASE,NG*NREA,IDATA1)
      CALL SETARA(BASE,NG*NL,IDATA2)
      CALL SETARA(BASE,NG*NG*NL,IDATA3)
      CALL SETARA(BASE,NG*NG,IDATA4)
      CALL SETARA(BASE,3*NBISO,IISONA)
      CALL SETARA(BASE,NBISO,IMIX)
      CALL SETARA(BASE,NBISO,IDEN)
      CALL SETARA(BASE,NBISO,IITYPE)
      CALL SETARA(BASE,NISO,IDENIS)
      CALL SETARA(BASE,NG,ISPH)
      CALL SETARA(BASE,NBISO,ICONCE)
      CALL SETARA(BASE,NBISO,IDECAY)
      CALL SAPCA2(IPSAP,IPEDIT,NREA,NISO,NMAC,NADRX,NPRC,NG,NL,
     1 ITRANC,NMIL,NBISO,ICAL,MAXRDA,MAXIDA,FNORM,NISOTS,NMILNR,
     2 NISFS,NISPS,NISYS,BASE(IFLUMI),BASE(IRESMA),BASE(IADRX),
     3 BASE(IISOMI),BASE(INISOM),BASE(IISADR),BASE(ILENGX),BASE(ILENGP),
     4 BASE(IRDATA),BASE(IIDATA),BASE(IFLUX),BASE(IOVERV),BASE(IDNUSI),
     5 BASE(IDCHI),BASE(IWORKD),BASE(IIFDG),BASE(IIADR),BASE(IIFDG2),
     6 BASE(IIADR2),BASE(IIJJ1),BASE(INJJ1),BASE(IIPOS),BASE(IIJJ2),
     7 BASE(INJJ2),BASE(IWORK1),BASE(IWORK2),BASE(IDATA1),BASE(IDATA2),
     8 BASE(IDATA3),BASE(IDATA4),BASE(IISONA),BASE(IMIX),BASE(IDEN),
     9 BASE(IITYPE),BASE(IDENIS),BASE(ISPH),BASE(ICONCE),BASE(IDECAY))
      CALL RLSARA(BASE(IDECAY))
      CALL RLSARA(BASE(ICONCE))
      CALL RLSARA(BASE(ISPH))
      CALL RLSARA(BASE(IDENIS))
      CALL RLSARA(BASE(IITYPE))
      CALL RLSARA(BASE(IDEN))
      CALL RLSARA(BASE(IMIX))
      CALL RLSARA(BASE(IISONA))
      CALL RLSARA(BASE(IDATA4))
      CALL RLSARA(BASE(IDATA3))
      CALL RLSARA(BASE(IDATA2))
      CALL RLSARA(BASE(IDATA1))
      CALL RLSARA(BASE(IWORK2))
      CALL RLSARA(BASE(IWORK1))
      CALL RLSARA(BASE(INJJ2))
      CALL RLSARA(BASE(IIJJ2))
      CALL RLSARA(BASE(IIPOS))
      CALL RLSARA(BASE(INJJ1))
      CALL RLSARA(BASE(IIJJ1))
      CALL RLSARA(BASE(IIADR2))
      CALL RLSARA(BASE(IIFDG2))
      CALL RLSARA(BASE(IIADR))
      CALL RLSARA(BASE(IIFDG))
      CALL RLSARA(BASE(IWORKD))
      CALL RLSARA(BASE(IDCHI))
      CALL RLSARA(BASE(IDNUSI))
      CALL RLSARA(BASE(IOVERV))
      CALL RLSARA(BASE(IFLUX))
      CALL RLSARA(BASE(IIDATA))
      CALL RLSARA(BASE(IRDATA))
      CALL RLSARA(BASE(ILENGP))
      CALL RLSARA(BASE(ILENGX))
      CALL RLSARA(BASE(IISADR))
      CALL RLSARA(BASE(INISOM))
      CALL RLSARA(BASE(IISOMI))
      CALL RLSARA(BASE(IADRX))
      CALL RLSARA(BASE(IRESMA))
      CALL RLSARA(BASE(IFLUMI))
*----
*  COMPLETE DIMSAP.
*----
      IDATA(18)=NADRX
      IF(IDATA(21).EQ.0) THEN
         IDATA(21)=NISYS
         IDATA(32)=NISOTS
         IDATA(33)=NMILNR
      ELSE
         IF(NISYS.NE.IDATA(21)) THEN
            WRITE(HSMG,'(42HSAPCAL: ELEMENTARY CALCULATION WITH AN INV,
     1      21HALIB VALUE OF NISOY =,I7,3H NE,I7,1H.)') NISYS,IDATA(21)
            CALL XABORT(HSMG)
         ELSE IF(NISOTS.NE.IDATA(32)) THEN
            WRITE(HSMG,'(43HSAPCAL: ELEMENTARY CALCULATION WITH AN INVA,
     1      21HLIB NB. OF ISOTOPES =,I7,3H NE,I7,1H.)') NISOTS,IDATA(32)
            CALL XABORT(HSMG)
         ELSE IF(NMILNR.NE.IDATA(33)) THEN
            WRITE(HSMG,'(43HSAPCAL: ELEMENTARY CALCULATION WITH AN INVA,
     1      47HLIB NB. OF MIXTURES WITH DELAYED NEUTRON DATA =,I7,3H NE,
     2      I7,1H.)') NMILNR,IDATA(33)
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
*----
*  RECOVER THE FISSION YIELDS.
*----
      IF(NISYS.GT.0) THEN
         CALL SETARA(BASE,NISYS,IADRY)
         CALL SETARA(BASE,(NISFS+NMAC)*NISPS,IYLDS)
         CALL SETARA(BASE,3*NBISO,IISONA)
         CALL SETARA(BASE,NBISO,IMIX)
         CALL SETARA(BASE,NBISO,IDEN)
         CALL SETARA(BASE,NBISO,IITYPE)
         CALL SETARA(BASE,NDFI,IPIFI)
         CALL SETARA(BASE,NDFI,IPYIEL)
         CALL SETARA(BASE,NMIL*NG,IFLUXE)
         CALL SETARA(BASE,NG,ISIG)
         CALL SETARA(BASE,NBISO,IPFIRA)
         CALL SAPGEY(IPSAP,IPEDIT,NISO,NMAC,NG,NMIL,NBISO,ICAL,NDFI,
     1   NISFS,NISPS,NISYS,BASE(IADRY),BASE(IYLDS),BASE(IISONA),
     2   BASE(IMIX),BASE(IDEN),BASE(IITYPE),BASE(IPIFI),BASE(IPYIEL),
     3   BASE(IFLUXE),BASE(ISIG),BASE(IPFIRA))
         CALL RLSARA(BASE(IPFIRA))
         CALL RLSARA(BASE(ISIG))
         CALL RLSARA(BASE(IFLUXE))
         CALL RLSARA(BASE(IPYIEL))
         CALL RLSARA(BASE(IPIFI))
         CALL RLSARA(BASE(IITYPE))
         CALL RLSARA(BASE(IDEN))
         CALL RLSARA(BASE(IMIX))
         CALL RLSARA(BASE(IISONA))
         CALL RLSARA(BASE(IYLDS))
         CALL RLSARA(BASE(IADRY))
      ENDIF
*
      CALL LCMSIX(IPEDIT,' ',2)
      CALL LCMPUT(IPSAP,'DIMSAP',NDIMSA,1,IDATA)
      RETURN
*
  100 FORMAT(45H SAPCAL: NORMALIZE THE FLUX WITH THE FACTOR =,1P,E12.5,
     1 26H TAKEN FROM BURNUP STEP AT,E12.5,14H MW-DAY/TONNE.)
  110 FORMAT(36H SAPCAL: THE FLUX IS NOT NORMALIZED.)
      END
