*DECK SPHROW
      SUBROUTINE SPHROW(IPSPH,TEXT3,NWGTH,NGROUP,NGCOND,NREGIO,VOLUME,
     1 IGCOND,FLUXES,IPRINT,COURIN)
*
*-----------------------------------------------------------------------
*
*Purpose:
* calculation of the averaged row fluxes.
*
*Copyright:
* Copyright (C) 2008 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPSPH   pointer to the LCM directory containing SPH-related options.
* TEXT3   equal tp 'GAP' or 'ROW'.
* NWGTH   type of weighting for P1 cross section information:
*         = 0 P0; = 1 P1.
* NGROUP  number of energy groups in the reference calculation.
* NGCOND  number of condensed groups.
* NREGIO  number of regions in the reference calculation.
* VOLUME  volume of regions.
* IGCOND  limit of condensed groups.
* FLUXES  fluxes.
* IPRINT  print flag.
*
*Parameters: output
* COURIN  averaged row fluxes.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPSPH,NWGTH,NGROUP,NGCOND,NREGIO,IGCOND(NGCOND),IPRINT
      CHARACTER TEXT3*(*)
      REAL VOLUME(NREGIO),FLUXES(NREGIO,NGROUP,NWGTH+1),
     1 COURIN(NGCOND,NWGTH+1)
*----
*  LOCAL VARIABLES
*----
      DOUBLE PRECISION SUM,SUD
      COMMON IBASE(1)
*
      CALL LCMLEN(IPSPH,TEXT3,NROW,ITYLCM)
      CALL LCMIOF(IPSPH,TEXT3,IIROW)
      DO 20 INL=1,NWGTH+1
      IGRFIN=0
      DO 20 IGRCD=1,NGCOND
      COURIN(IGRCD,INL)=0.0
      IGRDEB=IGRFIN+1
      IGRFIN=IGCOND(IGRCD)
      DO 20 IGR=IGRDEB,IGRFIN
      SUM=0.0D0
      SUD=0.0D0
      DO 10 IROW=1,NROW
      IREG=IBASE(IIROW+IROW-1)
      SUM=SUM+FLUXES(IREG,IGR,INL)*VOLUME(IREG)
   10 SUD=SUD+VOLUME(IREG)
   20 COURIN(IGRCD,INL)=COURIN(IGRCD,INL)+SUM/SUD
      IF(IPRINT.GT.3) THEN
         WRITE(6,'(/19H SPHROW: VALUES OF ,A,22H FLUXES PER MACRO-GROU,
     1   6HPS ARE)') TEXT3
	 DO 30 INL=1,NWGTH+1
	 WRITE(6,'(10H LEGENDRE=,I3,2H: ,1P,5E12.5:/(15X,5E12.5))')
     1   INL-1,(COURIN(IGRCD,INL),IGRCD=1,NGCOND)
   30    CONTINUE
      ENDIF
      RETURN
      END
