*DECK SYBWIJ
      SUBROUTINE SYBWIJ (NREG,MAXPTS,SIGT,SIGW,PIJ)
*
*-----------------------------------------------------------------------
*
*Purpose:
* scattering reduction for collision probabilities.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* NREG    total number of regions.
* MAXPTS  first dimension of matrix PIJ.
* SIGT    total macroscopic cross sections ordered by volume.
* SIGW    P0 within-group scattering macroscopic cross sections
*         ordered by volume.
* PIJ     reduced collision probability matrix.
*
*Parameters: output
*  PIJ    scattering-reduced collision probability matrix.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER NREG,MAXPTS
      REAL SIGT(NREG),SIGW(NREG),PIJ(MAXPTS,NREG)
*----
*  LOCAL VARIABLES
*----
      COMMON BASE(1)
*
      CALL SETARA(BASE,2*NREG*NREG,IWIJ)
      DO 20 I=1,NREG
      DO 10 J=1,NREG
      BASE(IWIJ+(NREG+J-1)*NREG+I-1)=PIJ(I,J)
   10 BASE(IWIJ+(J-1)*NREG+I-1)=-PIJ(I,J)*SIGW(J)
   20 BASE(IWIJ+(I-1)*NREG+I-1)=1.0+BASE(IWIJ+(I-1)*NREG+I-1)
      CALL ALSB(NREG,NREG,BASE(IWIJ),IER,NREG)
      IF(IER.NE.0) CALL XABORT('SYBWIJ: SINGULAR MATRIX.')
      DO 30 J=1,NREG
      DO 30 I=1,NREG
   30 PIJ(I,J)=BASE(IWIJ+(NREG+J-1)*NREG+I-1)
      CALL RLSARA(BASE(IWIJ))
      RETURN
      END
