*DECK TRAXS
      SUBROUTINE TRAXS(IPMAC1,IPMAC2,NG,NMIL,NL,NF,NDEL,ISTEP,GAR1)
*
*-----------------------------------------------------------------------
*
*Purpose:
* macrolib transposition.
*
*Copyright:
* Copyright (C) 2008 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPMAC1  pointer to the transposed macrolib (L_MACROLIB signature).
* IPMAC2  pointer to the original macrolib (L_MACROLIB signature).
* NG      number of energy groups.
* NMIL    number of homogenized mixtures.
* NL      number of Legendre orders.
* NF      number of fissile isotopes.
* NDEL    number of precursor groups.
* ISTEP   number of components in STEP directory
*
*Parameters: scratch
* GAR1
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPMAC1,IPMAC2,NG,NMIL,NL,NF,NDEL,ISTEP
      REAL GAR1(NG+1)
*----
*  LOCAL VARIABLES
*----
      PARAMETER(NCOPY1=4,NCOPY2=11)
      CHARACTER TEXT12*12,TCOPY1(NCOPY1)*12,TCOPY2(NCOPY2)*12
      COMMON BASE(1)
      DATA TCOPY1/'ENERGY','DELTAU','FLUXDISAFACT','DIFFB1HOM'/
      DATA TCOPY2/'ADDXSNAME-P0','FISSIONINDEX','ALBEDO','VOLUME',
     1 'LAMBDA-D','BETA-D','K-EFFECTIVE','K-INFINITY','B2  B1HOM',
     2 'B2  HETE','TIMESTAMP'/
*----
*  COPY THE INFORMATION ON ROOT
*----
      DO ICOPY=1,NCOPY1
        TEXT12=TCOPY1(ICOPY)
        CALL LCMLEN(IPMAC2,TEXT12,ILONG,ITYLCM)
        IF(ILONG.GT.0) THEN
          CALL LCMGET(IPMAC2,TEXT12,GAR1)
          CALL SETARA(BASE,ILONG,IOF)
          DO I=1,ILONG
            BASE(IOF+I-1)=GAR1(ILONG+1-I)
          ENDDO
          CALL LCMPOF(IPMAC1,TEXT12,ILONG,2,IOF)
        ENDIF
      ENDDO
      DO ICOPY=1,NCOPY2
        TEXT12=TCOPY2(ICOPY)
        CALL LCMLEN(IPMAC2,TEXT12,ILONG,ITYLCM)
        IF(ILONG.GT.0) THEN
          CALL SETARA(BASE,ILONG,IOF)
          CALL LCMGET(IPMAC2,TEXT12,BASE(IOF))
          CALL LCMPOF(IPMAC1,TEXT12,ILONG,2,IOF)
        ENDIF
      ENDDO
*----
*  COPY THE INFORMATION ON DIRECTORY GROUP
*----
      CALL SETARA(BASE,NMIL*NF*NG,IGAR1A)
      CALL SETARA(BASE,NMIL*NF*NG,IGAR1B)
      CALL SETARA(BASE,NG*NG*NMIL,IGAR2)
      CALL SETARA(BASE,NMIL*NG,IGAR3)
      CALL SETARA(BASE,NMIL,IIJJ)
      CALL SETARA(BASE,NMIL,INJJ)
      CALL SETARA(BASE,NMIL,IIPOS)
      CALL TRAGRO(IPMAC1,IPMAC2,NG,NMIL,NL,NF,NDEL,BASE(IGAR1A),
     1 BASE(IGAR1B),BASE(IGAR2),BASE(IGAR3),BASE(IIJJ),BASE(INJJ),
     2 BASE(IIPOS))
      IF(ISTEP.GT.0) THEN
        JPMAC2=LCMGID(IPMAC2,'STEP')
        JPMAC1=LCMLID(IPMAC1,'STEP',ISTEP)
        DO IS=1,ISTEP
          KPMAC2=LCMGIL(JPMAC2,IS)
          KPMAC1=LCMDIL(JPMAC1,IS)
          CALL TRAGRO(KPMAC1,KPMAC2,NG,NMIL,NL,NF,NDEL,BASE(IGAR1A),
     1    BASE(IGAR1B),BASE(IGAR2),BASE(IGAR3),BASE(IIJJ),BASE(INJJ),
     2    BASE(IIPOS))
        ENDDO
      ENDIF
      CALL RLSARA(BASE(IIPOS))
      CALL RLSARA(BASE(INJJ))
      CALL RLSARA(BASE(IIJJ))
      CALL RLSARA(BASE(IGAR3))
      CALL RLSARA(BASE(IGAR2))
      CALL RLSARA(BASE(IGAR1B))
      CALL RLSARA(BASE(IGAR1A))
*
      RETURN
      END
