*DECK XELCOP
      SUBROUTINE XELCOP( IFILE1, IFILE2)
************************************************************************
*                                                                      *
*           NAME: XELCOP                                               *
*      COMPONENT: EXCELL                                               *
*          LEVEL: 2 (CALLED BY 'EXCELT')                               *
*        VERSION: 1.0                                                  *
*       CREATION: 91/07                                                *
*       MODIFIED: 00/03 (R.R.) DECLARE ALL VARIABLE TYPES              *
*         AUTHOR: ROBERT ROY                                           *
*                                                                      *
*     SUBROUTINE: THIS ROUTINE WILL COPY A DRAGON TRACKING FILE;       *
*                 THE FILE *IFILE1* IS COPIED OVER *IFILE2*.           *
*                                                                      *
*           NOTE: THE FILES "IFILE1" AND "IFILE2" ARE SUPPOSED TO BE:  *
*                 1) CONNECTED AND OPENED;                             *
*                 2) PLACED FOR ACCESSING THE FIRST RECORD (REWIND).   *
*                                                                      *
*--------+-------------- V A R I A B L E S -------------+--+-----------*
*  NAME  /                  DESCRIPTION                 /IO/MOD(DIMENS)*
*--------+----------------------------------------------+--+-----------*
* IFILE1 / FIRST  TRACKING FILE # (AT INPUT).           /I./INT        *
* IFILE2 / SECOND TRACKING FILE # (AT OUTPUT).          /I./INT        *
************************************************************************
      IMPLICIT           NONE
C
      REAL               WEIGHT
      INTEGER            IFILE1,IFILE2,NCOMNT,NTRK,IREC,IC,IR,
     >                   NDIM,ISPEC,NV,NS,NALBG,NCOR,NANGL,MXSEG,IANG,
     >                   LINE,NUNKNO,VOLSUR,MATALB,ANGLES,DENSTY,
     >                   ICODE,ALBEDO,NRSEG,SEGLEN
      CHARACTER          CTRK*4, COMENT*80
      INTEGER            IOUT
      PARAMETER        ( IOUT=6 )
C
      REAL               RD
      COMMON             RD(1)
      INTEGER            ID(1)
      EQUIVALENCE       (RD(1),ID(1))
C
C.1)  READ AND COPY FIRST RECORDS (HEADER, COMMENTS) ------------------
C
      IREC= 1
      READ (IFILE1,ERR=991) CTRK,NCOMNT,NTRK
      WRITE(IFILE2,ERR=992) CTRK,NCOMNT,NTRK
      DO 10 IC= 1, NCOMNT
         IREC= IREC+1
         READ (IFILE1,ERR=991) COMENT
         WRITE(IFILE2,ERR=992) COMENT
   10 CONTINUE
C
C.2)  READ AND COPY MAIN RECORD AND GET USEFUL DIMENSIONS -------------
C
      IREC= IREC+1
      READ (IFILE1,ERR=991) NDIM,ISPEC,NV,NS,NALBG,NCOR,NANGL,MXSEG
      WRITE(IFILE2,ERR=992) NDIM,ISPEC,NV,NS,NALBG,NCOR,NANGL,MXSEG
      NUNKNO= NV+NS+1
C
C.2.1) ALLOCATE SPACE TO COPY SUBSEQUENT RECORDS
      CALL SETARA( RD,     NUNKNO, VOLSUR)
      CALL SETARA( ID,     NUNKNO, MATALB)
      CALL SETARA( ID,      NALBG,  ICODE)
      CALL SETARA( RD,      NALBG, ALBEDO)
      CALL SETARA( RD, NDIM*NANGL, ANGLES)
      CALL SETARA( RD,      NANGL, DENSTY)
      CALL SETARA( RD,      MXSEG, SEGLEN)
      CALL SETARA( ID,      MXSEG,  NRSEG)
C
C.2.2) COPY ALL RECORDS BEFORE TRACKS
      IREC= IREC+1
      READ (IFILE1,ERR=991) (RD(VOLSUR+IR),IR=0,NUNKNO-1)
      WRITE(IFILE2,ERR=992) (RD(VOLSUR+IR),IR=0,NUNKNO-1)
      IREC= IREC+1
      READ (IFILE1,ERR=991) (ID(MATALB+IR),IR=0,NUNKNO-1)
      WRITE(IFILE2,ERR=992) (ID(MATALB+IR),IR=0,NUNKNO-1)
      IREC= IREC+1
      READ (IFILE1,ERR=991) (ID( ICODE+IR),IR=0,NALBG-1)
      WRITE(IFILE2,ERR=992) (ID( ICODE+IR),IR=0,NALBG-1)
      IREC= IREC+1
      READ (IFILE1,ERR=991) (RD(ALBEDO+IR),IR=0,NALBG-1)
      WRITE(IFILE2,ERR=992) (RD(ALBEDO+IR),IR=0,NALBG-1)
      IREC= IREC+1
      READ (IFILE1,ERR=991) (RD(ANGLES+IR),IR=0,NDIM*NANGL-1)
      WRITE(IFILE2,ERR=992) (RD(ANGLES+IR),IR=0,NDIM*NANGL-1)
      IREC= IREC+1
      READ (IFILE1,ERR=991) (RD(DENSTY+IR),IR=0,NANGL-1)
      WRITE(IFILE2,ERR=992) (RD(DENSTY+IR),IR=0,NANGL-1)
C
C.3)   NOW, COPY ALL TRACKS -------------------------------------------
C
   20 CONTINUE
         IREC= IREC + 1
         READ (IFILE1,END=40,ERR=991) IANG,LINE,WEIGHT,
     >                      (ID(NRSEG +IR),IR=0,LINE-1),
     >                      (RD(SEGLEN+IR),IR=0,LINE-1)
         WRITE(IFILE2,       ERR=992) IANG,LINE,WEIGHT,
     >                      (ID(NRSEG +IR),IR=0,LINE-1),
     >                      (RD(SEGLEN+IR),IR=0,LINE-1)
      GO TO 20
C
   40 CONTINUE
C
C.4)   RELEASE TEMPORARY SPACE AND REWIND BOTH FILES ------------------
C
      CALL RLSARA( ID(  NRSEG ))
      CALL RLSARA( RD( SEGLEN ))
      CALL RLSARA( RD( DENSTY ))
      CALL RLSARA( RD( ANGLES ))
      CALL RLSARA( RD( ALBEDO ))
      CALL RLSARA( ID(  ICODE ))
      CALL RLSARA( ID( MATALB ))
      CALL RLSARA( RD( VOLSUR ))
      REWIND IFILE1
      REWIND IFILE2
      RETURN
C
  991 WRITE(IOUT,'(30H ERROR= RECORD DESTROYED...    )')
      WRITE(IOUT,'(31H ERROR= UNABLE TO READ  RECORD ,I10)') IREC
      WRITE(IOUT,'(31H ERROR=              ON FILE FT,I2.2)') IFILE1
      CALL XABORT( 'XELCOP: --- READ  TRACKING FILE FAILED' )
  992 WRITE(IOUT,'(30H ERROR= NOT ENOUGH SPACE...    )')
      WRITE(IOUT,'(31H ERROR= UNABLE TO WRITE RECORD ,I8.8)') IREC
      WRITE(IOUT,'(31H ERROR=              ON FILE FT,I2.2)') IFILE1
      CALL XABORT( 'XELCOP: --- WRITE TRACKING FILE FAILED' )
C
      END
