      FUNCTION     CLECOP(IUNITI, IUNITO)
C
C     CLE-2000 SYSTEM: R.ROY (09/1999), VERSION 2.1
C
C             *CLECOP* WILL COPY ONE OBJECT FILE TO ANOTHER
C
C      INPUT: *IUNITI* IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C             *IUNITO* IS ITS COPY
C
C       NOTE: FACULTATIVE IN THE CLE-2000 SYSTEM.
C             THIS UTILITARY FUNCTION CAN BE USED IN THE APPLICATION
C             (MUST BE USED IN CASES WHERE THE OBJECT FILE IS RECURSIVE)
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      INTEGER      CLECOP,IUNITO,IUNITI
C
C     IMPOSING SOME LIMITS TO AVOID STUPID VALUES...
C
      INTEGER      IRETCD,NRECOR,NINPUT,MAXLVL,NSTACK,IRECOR,
     1             IXRLST,IOULST,IDBLST,NOBJET
      INTEGER      ILOGFL(9)
      CHARACTER*12 CL2000,CPARIN
      LOGICAL      LEXIST
C
      INTEGER  INDLIN, IDATIN, IDCLIN, IDEFIN, IUSEIN
      REAL             ADATIN
      CHARACTER*72     CDATIN
      DOUBLE PRECISION DDATIN
      DATA CL2000/ 'CLE2000(V21)' /
C
      CLECOP= 0
      INQUIRE( UNIT=IUNITI,EXIST=LEXIST )
      IF( .NOT.LEXIST ) GO TO 9000
      INQUIRE( UNIT=IUNITO,EXIST=LEXIST )
      IF( .NOT.LEXIST ) GO TO 9000
      IRECOR= 1
C
C     READ AND WRITE TOP OF OBJECT FILE
      READ (IUNITI,REC=IRECOR,ERR=9023,IOSTAT=IRETCD)
     1      CPARIN,CDATIN,NRECOR,NINPUT,MAXLVL,NSTACK,
     2      IXRLST,IOULST,IDBLST,NOBJET
      IF( IRETCD.NE.0 ) GO TO 9024
      WRITE(IUNITO,REC=IRECOR,ERR=9025,IOSTAT=IRETCD)
     1      CPARIN,CDATIN,NRECOR,NINPUT,MAXLVL,NSTACK,
     2      IXRLST,IOULST,IDBLST,NOBJET
      IF( IRETCD.NE.0 ) GO TO 9024
C
C     VERIFY CONSISTENCY OF VERSION
      IF( CPARIN.NE.CL2000 ) GO TO 9002
      IF( NRECOR.LE.0 ) GO TO 9003
      IF( NRECOR.NE.NINPUT+NSTACK+NOBJET ) GO TO 9003
C
C     CASE WHERE THERE ARE NO LOG-FILE (TRIVIAL FILE)
      IF( NINPUT.EQ.1 ) GO TO 666
C
C     COPY ALL LOG-FILE RECORDS
      DO 10 IRECOR= 2, NINPUT
         READ (IUNITI,REC=IRECOR,ERR=9023,IOSTAT=IRETCD)
     1      CPARIN,CDATIN,ILOGFL
         IF( IRETCD.NE.0 ) GO TO 9024
         WRITE(IUNITO,REC=IRECOR,ERR=9025,IOSTAT=IRETCD) 
     1      CPARIN,CDATIN,ILOGFL
         IF( IRETCD.NE.0 ) GO TO 9024
   10 CONTINUE
C
C     CASE WHERE THERE ARE NO CLE-2000 VARIABLES
      IF( NSTACK+NOBJET.LE.0 ) GO TO 666
C
C     COPY ALL VAR-STACK AND OBJECT RECORDS
      DO 20 IRECOR= NINPUT+1, NINPUT+NSTACK+NOBJET
         READ (IUNITI,REC=IRECOR,ERR=9023,IOSTAT=IRETCD)
     1      CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN,
     2      IDCLIN,IDEFIN,IUSEIN
         IF( IRETCD.NE.0 ) GO TO 9024
         WRITE(IUNITO,REC=IRECOR,ERR=9025,IOSTAT=IRETCD) 
     1      CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN,
     2      IDCLIN,IDEFIN,IUSEIN
         IF( IRETCD.NE.0 ) GO TO 9024
   20 CONTINUE
C
  666 RETURN
 9000 CLECOP= 9000
      GO TO 666
 9001 CLECOP= 9001
      GO TO 666
 9002 CLECOP= 9002
      GO TO 666
 9003 CLECOP= 9003
      GO TO 666
 9023 CLECOP= 9023
      GO TO 666
 9024 CLECOP= IRETCD
      GO TO 666
 9025 CLECOP= 9025
      GO TO 666
      END
