      FUNCTION CLELOG(IREDIN, IWRITE, IUNITO)
C
C     CLE-2000 SYSTEM: R.ROY (11/1999), VERSION 2.1
C
C             *CLELOG* FIRST-PASS COMPILE OF THE INPUT UNIT  *IREDIN*
C                      COMPILER COMMENTS ARE WRITTEN ON UNIT *IWRITE*
C                      RESULT IS THE OBJECT D.A. UNIT        *IUNITO*
C
C        USE:          INPUT DATA IS COPIED ON D.A. UNIT,
C                      SENTENCES AND LOGIC DESCRIPTORS ARE SEPARATED,
C                      LOGICAL LEVELS ARE BUILT AND LOGIC IS CHECKED. 
C
C      INPUT: *IREDIN* IS THE INPUT  UNIT
C             *IWRITE* IS THE OUTPUT UNIT FOR COMPILER COMMENTS
C             *IUNITO* IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C
C       NOTE: *CLELOG* = 0 IF NO PROBLEM WAS ENCOUNTERED WHILE COMPILING
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      INTEGER      CLELOG, IREDIN, IWRITE, IUNITO
      INTEGER      NINPUT, ILINES, IRETCD, IXRLST, IOULST, IDBLST,
     1             JST1BG, JST2BG, NWORDS, IWORDS, NRECOR,
     2             JCM0BG, JCM0ND, JSC0BG, JFNDBG, JFNDND, JKTHEN, 
     3             JKELSE, JKREPE, JKDODO, JQUITP, NEQUAL, 
     4             ILOOP1, JLOOP2, IAPO12, ILENGV,
     5             JINDEX, IPOINT, IFLOAT, IDOUBL, NSTLVL, NLEVEL,
     6             ILOGIN, IRECOR, JRECOR, KRECOR, JLINES,
     7             ILEVEL, JLEVEL, MAXLVL, NWRSEN, NRECIO
      INTEGER      NMAWRD,    NSTACK,    NDECAL,
     1             NMASKC,    NDIMST,    NLOGKW
      PARAMETER  ( NMAWRD=36, NSTACK= 0, NDECAL=4,
     1             NMASKC=3,  NDIMST=64, NLOGKW=15 )
      INTEGER      MASKCK(NMASKC),IPACKI(NMASKC),
     1             MASOLD(NMASKC),IPAOLD(NMASKC),
     2             IDEBWD(NMAWRD),IFINWD(NMAWRD),JNDLEC(NMAWRD),
     3             IRCLVL(NDIMST),ITYLVL(NDIMST),
     4             LVELBG(NLOGKW),LVELND(NLOGKW)
      CHARACTER*12 CL2000, CPARIN, CHREND, CSEMIC, CBLA12, 
     1             CRECBG, CRECND, CLOGBG(NLOGKW), CLOGND(NLOGKW)
      CHARACTER*72 MYRECO, RWRITE, CTITLE, CBLA72, CDATIN,
     1             CERROR, CEMASK, TERROR(7)
      CHARACTER*84 RECRED
      CHARACTER*15 DIGPED
      CHARACTER*61 ONELET
      LOGICAL      LAPOS1, LAPOS2, LNBPRV, LNBCUR, LNWSEN, LRECIO,
     1             L1LETT
C
      DATA CL2000,CBLA12 / 'CLE2000(V21)','            ' /
      DATA CTITLE
     1/'* CLE-2000 VERS 2.1 * R.ROY, EPM COPYRIGHT 1999 * '/
      DATA TERROR/
     1  '! CLELOG: UNEXPECTED CHARACTERS TO BE REPLACED WITH BLANKS',
     2  '! CLELOG: UNBALANCED OPENING OR CLOSING STRINGS           ',
     3  '! CLELOG: MISPLACED SEMICOLON ...; OR ;... OR ...;...     ',
     4  '! CLELOG: CHARACTERS SUPPRESSED OUTSIDE COLUMN RANGE 1:72 ',
     5  '! CLELOG: << AND >> NOT ALLOWED IN STRINGS (SUPPRESSED)   ',
     6  '! CLELOG: (* ... *) INVALID COMMENTS (USE ! INSTEAD)      ',
     7  '! CLELOG: QUIT "..." . SHOULD APPEAR ALONE A SINGLE LINE  ' /
      DATA CBLA72 / ' ' /
      DATA CSEMIC / ';' /
      DATA DIGPED/'0123456789+-.ED'/
      DATA ONELET
     1 /'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+-*/%<>=;'/
      DATA CLOGBG
     1  / 'INTEGER' , 'REAL'    , 'STRING'   , 'DOUBLE', 'LOGICAL',
     2    'EVALUATE', 'ECHO'    , 'ELSEIF'   , 'IF'    , 'WHILE'  ,
     3    'UNTIL'   , 'ENDWHILE', 'REPEAT'   , 'ELSE'  , 'ENDIF'  /
      DATA LVELBG
     1  /  0        ,  0        ,  0         ,  0      ,  0       ,
     2     0        ,  0        , -1         ,  0      ,  0       ,
     3    -1        , -1        ,  0         , -1      , -1       /
      DATA CLOGND
     1  / ';'       , ';'       , ';'        , ';'     , ';'      ,
     2    ';'       , ';'       , 'THEN'     , 'THEN'  , 'DO'     ,
     3    ';'       , ';'       , 'REPEAT'   , 'ELSE'  , ';'      /
      DATA LVELND
     1  /  0        ,  0        ,  0         ,  0      ,  0       ,
     2     0        ,  0        ,  0         , +1      , +1       ,
     3    -1        , -1        , +1         ,  0      , -1       /
C
      CLELOG= 0
      LAPOS1=.FALSE.
      LAPOS2=.FALSE.
      WRITE(IWRITE,'(A72,1X,A7)') CTITLE,'   LINE'
      ILINES= 0
      IDBLST=-1
      IXRLST=-1
      IOULST=-1
C
      LNWSEN=.TRUE.
      LRECIO=.TRUE.
      L1LETT=.TRUE.
      NEQUAL= 0
      NWRSEN=-2
      NRECIO= 0
      NLEVEL= 1
      MAXLVL= 0
      IRECOR= 0
      NSTLVL= 0
      CRECBG= CBLA12
      CHREND= CSEMIC
C
C     WRITE TOP OF OBJECT FILE
      NINPUT= 1
      NRECOR= 1
      WRITE(IUNITO,REC=NRECOR,ERR=9001,IOSTAT=IRETCD)
     1   CL2000,CBLA72,NRECOR,NINPUT,MAXLVL,NSTACK,IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9002
C
C     DUMP INPUT FILE TO OBJECT FILE
      CEMASK= CBLA72
      RECRED= ' '
   10 CONTINUE
         ILINES= ILINES+1
C
C        READ A NEW RECORD
         READ (IREDIN,'(A80)',END=100) RECRED(NDECAL+1:NDECAL+80)
         MYRECO= RECRED(NDECAL+1:NDECAL+72)
C
C        OUPUT THE RECORD
         WRITE (IWRITE,'(A72,1X,I7.4)') MYRECO, ILINES
C
C        SUPPRESS ! EXCLAMATION COMMENTS FROM *RECRED* AND RECORD
         JCM0BG= INDEX(RECRED,'!')
         IF( JCM0BG.NE.0 )THEN
            RECRED(JCM0BG:80)= ' '
            IF( JCM0BG+NDECAL.LE.72 )THEN
               MYRECO(JCM0BG-NDECAL:72)= CBLA72(JCM0BG-NDECAL:72)
            ENDIF
         ENDIF
C
C        SUPPRESS RECORD IF ALL COMMENTS OR BLANK
         IF( MYRECO(1:1).EQ.'*'.OR.MYRECO.EQ.CBLA72 )GO TO 10
C
C        ANYTHING OUTSIDE COLUMNS NDECAL+1:NDECAL+72 RANGE IN *RECRED*
         IF( RECRED(NDECAL+73:NDECAL+80).NE.'       ' )THEN
            WRITE(IWRITE,'(A80)') RECRED(NDECAL+1:NDECAL+80)
            WRITE(IWRITE,'(A72,A8)') CBLA72,'????????'
            WRITE(IWRITE,'(A72)') TERROR(4)
            CLELOG= CLELOG+1
         ENDIF
         DO 20 ILOOP1=1,72
C
C           SUPPRESS UNEXPECTED CHARACTERS
            IF( LLT(MYRECO(ILOOP1:ILOOP1), ' ') )THEN
               CEMASK(ILOOP1:ILOOP1)= '?'
               MYRECO(ILOOP1:ILOOP1)= ' '
               RECRED(ILOOP1+NDECAL:ILOOP1+NDECAL)= ' '
               CERROR= TERROR(1)
               CLELOG= CLELOG+1
            ENDIF
   20    CONTINUE
C
C        SUPPRESS STRINGS OF TYPES: '...' OR "...." FROM *RECRED*
   25    JST1BG= INDEX(RECRED,' ''')
         IF( JST1BG.EQ.0 ) JST1BG= 84
         JST2BG= INDEX(RECRED,' "')
         IF( JST2BG.EQ.0 ) JST2BG= 84
         JFNDBG= MIN( JST1BG,JST2BG )
         IF( JFNDBG.NE.84 )THEN
            IF( JFNDBG.EQ.JST1BG )THEN
               JFNDND= INDEX(RECRED(JFNDBG+2:84),''' ')+JFNDBG+1
            ELSE
               JFNDND= INDEX(RECRED(JFNDBG+2:84),'" ') +JFNDBG+1
            ENDIF
            IF( JFNDND.EQ.JFNDBG+1 )THEN
               CEMASK(JFNDBG-NDECAL+1:JFNDBG-NDECAL+1)='?'
               CERROR= TERROR(2)
               CLELOG= CLELOG+1
               JFNDND= 84
            ENDIF
C
C           STRING IS FOUND, CHECK IF << OR >> IS CONTAINED INSIDE
            JCM0BG= INDEX(RECRED(JFNDBG+1:JFNDND),'<<')+JFNDBG
            JCM0ND= INDEX(RECRED(JFNDBG+1:JFNDND),'>>')+JFNDBG
            IF( JCM0BG.NE.JFNDBG )THEN
               CEMASK(JCM0BG-NDECAL:JCM0BG-NDECAL+1)='??'
               MYRECO(JCM0BG-NDECAL:JCM0BG-NDECAL+1)='  '
               CERROR= TERROR(5)
               CLELOG= CLELOG+1
            ENDIF
            IF( JCM0ND.NE.JFNDBG )THEN
               CEMASK(JCM0ND-NDECAL:JCM0ND-NDECAL+1)='??'
               MYRECO(JCM0ND-NDECAL:JCM0ND-NDECAL+1)='  '
               CERROR= TERROR(5)
               CLELOG= CLELOG+1
            ENDIF
            RECRED(JFNDBG+1:JFNDND)= ' '
            GO TO 25
         ENDIF
C
C        CONTROL STRANGE FORMS OF TYPES: ...'... OR ..."...
         JST1BG= INDEX(RECRED,'''')
         IF( JST1BG.NE.0 )THEN
            CEMASK(JST1BG-NDECAL:JST1BG-NDECAL)='?'
            CERROR= TERROR(2)
            CLELOG= CLELOG+1
            RECRED(JST1BG:JST1BG)= ' '
            MYRECO(JST1BG-NDECAL:JST1BG-NDECAL)= ' '
         ENDIF
C
         IF( CEMASK.NE.CBLA72 )THEN
            WRITE (IWRITE,'(A72)') CEMASK
            WRITE (IWRITE,'(A72)') CERROR
            CEMASK= CBLA72
         ENDIF
C
C        SUPPRESS OLD FORMS OF COMMENTS: (*...  ...*)
   26    JCM0BG= INDEX(RECRED,' (*' )
         JCM0ND= INDEX(RECRED,'*) ' )
         IF( JCM0BG.NE.0 )THEN
CC          CEMASK(JCM0BG-NDECAL+1:JCM0BG-NDECAL+2)= '??'
            CERROR= '! WARNING: (* ... *) OBSOLETE COMMENTS '
     1            //'(USE ! INSTEAD)'
            IF( JCM0ND.EQ.0 )THEN
               MYRECO(JCM0BG-NDECAL:72)= '  '
               RECRED(JCM0BG:84)= ' '
               CERROR= TERROR(6)
               CLELOG= CLELOG+1
            ELSE
CC             CEMASK(JCM0ND-NDECAL:JCM0ND-NDECAL+1)= '??'
               MYRECO(JCM0BG-NDECAL:JCM0ND-NDECAL+1)= ' '
               RECRED(JCM0BG:JCM0ND+1)= ' ' 
            ENDIF
            GO TO 26
         ELSEIF( JCM0ND.NE.0 )THEN
            CEMASK(JCM0ND-NDECAL:JCM0ND-NDECAL+1)= '??'
            CERROR= TERROR(6)
            CLELOG= CLELOG+1
            RECRED(1:JCM0ND+1)= ' '
            MYRECO(1:JCM0ND-NDECAL+1)= ' '
            GO TO 26
         ENDIF
C
         IF( CEMASK.NE.CBLA72 )THEN
            WRITE (IWRITE,'(A72)') CEMASK
            WRITE (IWRITE,'(A72)') CERROR
            CEMASK= CBLA72
         ENDIF
C
C        TO SEPARATE LOGIC, PUT RETURNS FOR INPUT LINES ENDING WITH:
C                     *;*, *REPEAT*, *THEN*, *ELSE* OR *DO*
   30    CONTINUE
            JSC0BG= INDEX(RECRED,' ; ' )
            IF( JSC0BG.EQ.0 )THEN
C
C              CONTROL STRANGE FORMS OF TYPES: ...; OR ;... OR ...;...
               JSC0BG= INDEX(RECRED,';')
               IF( JSC0BG.NE.0 )THEN
                  CEMASK(JSC0BG-NDECAL:JSC0BG-NDECAL)='?'
                  CERROR= TERROR(3)
                  CLELOG= CLELOG+1
                  RECRED(JSC0BG:JSC0BG)= ' '
                  MYRECO(JSC0BG-NDECAL:JSC0BG-NDECAL)=' '
               ENDIF
               JFNDBG= 84
            ELSE
               JFNDBG= JSC0BG
               ILENGV= 1
            ENDIF
            JKTHEN= INDEX(RECRED,' THEN ' )
            IF( JKTHEN.EQ.0 ) JKTHEN= 84
            IF( JKTHEN.LT.JFNDBG )THEN
               JFNDBG= JKTHEN
               ILENGV= 4
            ENDIF
            JKELSE= INDEX(RECRED,' ELSE ' )
            IF( JKELSE.EQ.0 ) JKELSE= 84
            IF( JKELSE.LT.JFNDBG )THEN
               JFNDBG= JKELSE
               ILENGV= 4
            ENDIF
            JKREPE= INDEX(RECRED,' REPEAT ' )
            IF( JKREPE.EQ.0 ) JKREPE= 84
            IF( JKREPE.LT.JFNDBG )THEN
               JFNDBG= JKREPE
               ILENGV= 6
            ENDIF
            JKDODO= INDEX(RECRED,' DO ' )
            IF( JKDODO.EQ.0 ) JKDODO= 84
            IF( JKDODO.LT.JFNDBG )THEN
               JFNDBG= JKDODO
               ILENGV= 2
            ENDIF
            JQUITP= INDEX(RECRED,' QUIT ' )
            IF( JQUITP.EQ.0 ) JQUITP= 84
            IF( JQUITP.LT.JFNDBG )THEN
               JFNDBG= JQUITP
               ILENGV= 4
            ENDIF
C
            IF( JFNDBG.EQ.84 )THEN
               RWRITE= MYRECO
               MYRECO= CBLA72
            ELSE
               IF( JFNDBG.EQ.JQUITP )THEN
C                 QUIT. WAS FOUND FIRST
C                 WRITE(IWRITE,*) ' QUIT. WAS FOUND FIRST'
C
C                 *END-OF-FILE*
                  MYRECO(1:JFNDBG-NDECAL+ILENGV)= 
     1               CBLA72(1:JFNDBG-NDECAL+ILENGV)
                  GO TO 200
               ELSE
                  RWRITE= CBLA72
                  RWRITE(1:JFNDBG-NDECAL+ILENGV)= 
     1               MYRECO(1:JFNDBG-NDECAL+ILENGV)
                  MYRECO(1:JFNDBG-NDECAL+ILENGV)= 
     1               CBLA72(1:JFNDBG-NDECAL+ILENGV)
                  RECRED(JFNDBG+1:JFNDBG+ILENGV)= ' '
               ENDIF
            ENDIF
            IF( CEMASK.NE.CBLA72 )THEN
               WRITE (IWRITE,'(A72)') CEMASK
               WRITE (IWRITE,'(A72)') CERROR
               CEMASK= CBLA72
               GO TO 30
            ENDIF
C
C        SUPPRESS RECORD IF ALL IS STILL BLANK
         IF( RWRITE.EQ.CBLA72 ) GO TO 10
C
C        NEW RECORD FOUND, READY TO PROCESS *RWRITE*
         DO 40 ILOOP1=1,NMASKC
            MASKCK(ILOOP1)= 0
            IPACKI(ILOOP1)= 0
   40    CONTINUE
C
C        *** BEWARE **** FROM HERE WORDS ARE IN REVERSE ORDER...
C
C BEGIN: CONSTRUCT MASK NUMBERS
C
C        PREVIOUS NON-BLANK CHARACTER (ASSUME BLANK AT START)
         LNBPRV=.FALSE.
         NWORDS= 0
         DO 50 ILOOP1=72,1,-1
            JLOOP2=(ILOOP1+23)/24
            MASKCK(JLOOP2)= 2*MASKCK(JLOOP2)
            IF( LAPOS1 )THEN
C
C              ALL CHARACTERS ARE MASKED WHILE *LAPOS1*
               MASKCK(JLOOP2)= MASKCK(JLOOP2)+1
               LAPOS1= RWRITE(ILOOP1:ILOOP1).NE.''''
C
C              MAKE AS IF PREVIOUS WAS BLANK
               LNBPRV=.FALSE.
               IDEBWD(NWORDS)= IDEBWD(NWORDS)-1
            ELSEIF( LAPOS2 )THEN
C
C              ALL CHARACTERS ARE MASKED WHILE *LAPOS1*
               MASKCK(JLOOP2)= MASKCK(JLOOP2)+1
               LAPOS2= RWRITE(ILOOP1:ILOOP1).NE.'"'
C
C              MAKE AS IF PREVIOUS WAS BLANK
               LNBPRV=.FALSE.
               IDEBWD(NWORDS)= IDEBWD(NWORDS)-1
            ELSE
               LNBCUR= RWRITE(ILOOP1:ILOOP1).NE.' '
               IF( LNBCUR )THEN
C
C                 FIND A NON-BLANK CHARACTER, MASK IT
                  MASKCK(JLOOP2)= MASKCK(JLOOP2)+1
                  IF( LNBPRV )THEN
                     IDEBWD(NWORDS)= IDEBWD(NWORDS)-1
                  ELSE
C
C                    PREVIOUS ONE WAS BLANK, LOOK FOR ' OR "
                     LAPOS1= RWRITE(ILOOP1:ILOOP1).EQ.''''
                     LAPOS2= RWRITE(ILOOP1:ILOOP1).EQ.'"'
                     IF( LAPOS1.OR.LAPOS2 )THEN
                        IAPO12= ILOOP1
                     ENDIF
C
C                    BEGIN A NEW WORD (REVERSED ORDER)
                     NWORDS= NWORDS+1
                     IFINWD(NWORDS)= ILOOP1
                     IDEBWD(NWORDS)= ILOOP1
                  ENDIF
               ELSEIF( LNBPRV )THEN
C
C                 FIND A BLANK CHARACTER, BUT AFTER A NON-BLANK
C                 THIS COULD BE A MISTAKE IF ' OR " ARE NOT IN USE.
                  IF( ((.NOT.LAPOS1).AND.
     1                  RWRITE(ILOOP1+1:ILOOP1+1).EQ.'''')
     2            .OR.((.NOT.LAPOS2).AND.
     3                  RWRITE(ILOOP1+1:ILOOP1+1).EQ.'"' ) )THEN
                     CEMASK(ILOOP1+1:ILOOP1+1)='?'
                  ENDIF
               ENDIF
               LNBPRV= LNBCUR
            ENDIF
   50    CONTINUE
         IF( LAPOS1 .OR. LAPOS2 )THEN
            CEMASK(IAPO12:IAPO12)='?'
            LAPOS1=.FALSE.
            LAPOS2=.FALSE.
         ENDIF
         IF( CEMASK.NE.CBLA72 )THEN
            WRITE (IWRITE,'(A72)') CEMASK
            WRITE (IWRITE,'(A72)') TERROR(2)
            CEMASK= CBLA72
         ENDIF
C END:   CONSTRUCT MASK NUMBERS
C
C BEGIN: IDENTITY TYPES AND PACK *JNDLEC* WITH (ITYP-1) DATA
         DO 60 IWORDS= 1, NWORDS
            ILENGV= IFINWD(IWORDS)-IDEBWD(IWORDS)+1
            CDATIN(1:ILENGV)= RWRITE(IDEBWD(IWORDS):IFINWD(IWORDS))
C
C           DETERMINATION OF TYPE FOR THAT WORD
            IF( CDATIN(1:1).EQ.''''.OR.CDATIN(1:1).EQ.'"'   )THEN
               JNDLEC(IWORDS)= 2
            ELSEIF( ILENGV.EQ.1 )THEN
               JINDEX= INDEX(DIGPED,CDATIN(1:1))
               IF( JINDEX.GT.0.AND.JINDEX.LE.10 )THEN
                  JNDLEC(IWORDS)= 0
               ELSE
                  JNDLEC(IWORDS)= 2
                  L1LETT= L1LETT.AND.INDEX(ONELET,CDATIN(1:1)).NE.0
               ENDIF
            ELSE
               IPOINT= 0
               IFLOAT= 0
               IDOUBL= 0
               DO 61 ILOOP1= 1, ILENGV
                  JINDEX= INDEX(DIGPED,CDATIN(ILOOP1:ILOOP1))
                  IF( JINDEX.EQ.0 )THEN
                     GO TO 62
                  ELSEIF( JINDEX.EQ.11.OR.JINDEX.EQ.12 )THEN
                     IF( ILOOP1.NE.1 )THEN
C
C                       CHECK SIGN AFTER EXPONENT
                        IF( ILOOP1-1.NE.IFLOAT.AND.
     1                      ILOOP1-1.NE.IDOUBL )THEN
                           JINDEX= 0
                           GO TO 62
                        ENDIF
                     ENDIF
                  ELSEIF( JINDEX.EQ.13 )THEN
                     IF( IPOINT.NE.0 )THEN
                        JINDEX= 0
                        GO TO 62
                     ENDIF
                     IPOINT= ILOOP1
                  ELSEIF( JINDEX.EQ.14 )THEN
                     IF( IFLOAT.NE.0.OR.ILOOP1.EQ.1 )THEN
                        JINDEX= 0
                        GO TO 62
                     ENDIF
                     IFLOAT= ILOOP1
                  ELSEIF( JINDEX.EQ.15 )THEN
                     IF( IDOUBL.NE.0.OR.ILOOP1.EQ.1 )THEN
                        JINDEX= 0
                        GO TO 62
                     ENDIF
                     IDOUBL= ILOOP1
                  ENDIF
   61          CONTINUE
   62          CONTINUE
               IF( JINDEX.EQ.0 )THEN
                  JNDLEC(IWORDS)= 2
               ELSEIF( IDOUBL.NE.0 )THEN
                  JNDLEC(IWORDS)= 3
               ELSEIF( IFLOAT.NE.0.OR.IPOINT.NE.0 )THEN
                  JNDLEC(IWORDS)= 1
               ELSE
                  JNDLEC(IWORDS)= 0
               ENDIF
            ENDIF
            JLOOP2= (2*(NWORDS-IWORDS+1)+23)/24
            IPACKI(JLOOP2)= IPACKI(JLOOP2)*4
            IPACKI(JLOOP2)= IPACKI(JLOOP2)+JNDLEC(IWORDS)
C
C           COUNT FOR THE NUMBER OF *:=*, *<<.>>* AND *>>.<<*
C                 AND THE NUMBER OF *$.* BEFORE *:=*
            IF( JNDLEC(IWORDS).EQ.2 )THEN
               IF( ILENGV.EQ.2.AND.CDATIN(1:ILENGV).EQ.':=' )THEN
                  NEQUAL= NEQUAL+1
               ELSEIF( ILENGV.GE.2 )THEN
                  IF( CDATIN(1:2).EQ.'>>' )THEN
                     LRECIO= ILENGV.GE.5
                     IF( LRECIO )THEN
                        LRECIO= CDATIN(ILENGV-1:ILENGV).EQ.'<<'
     1                         .AND.CDATIN(3:3).NE.'$'
                     ENDIF
                     NRECIO= NRECIO+1
                  ELSEIF( CDATIN(1:2).EQ.'<<' )THEN
                     LRECIO= ILENGV.GE.5
                     IF( LRECIO )THEN
                        LRECIO= CDATIN(ILENGV-1:ILENGV).EQ.'>>'
     1                         .AND.CDATIN(3:3).NE.'$'
                     ENDIF
                     NRECIO= NRECIO+1
                  ENDIF
               ENDIF
            ENDIF
   60    CONTINUE
C END:   IDENTITY TYPES AND PACK *JNDLEC* WITH (ITYP-1) DATA
C
C        NOW, LOOK FOR 1-ST WORD OF SENTENCES
         IF( LNWSEN.AND.JNDLEC(NWORDS).EQ.2
     1             .AND.IFINWD(NWORDS)-IDEBWD(NWORDS).LE.11 )THEN
C
C           RECOVER 1-ST WORD TO CHECK BEGIN OF SENTENCE
            CPARIN= RWRITE(IDEBWD(NWORDS):IFINWD(NWORDS))
            ILOGIN= 0
            DO 80 ILOOP1= 1, NLOGKW
               IF( CPARIN.EQ.CLOGBG(ILOOP1) ) ILOGIN= ILOOP1
   80       CONTINUE
C
C           BACKWARD COMPATIBILITY ( *CHARACTER* / *PRINT* )
            IF(     CPARIN.EQ.'CHARACTER   ' )THEN
               ILOGIN= 3
               CERROR='! WARNING: *CHARACTER* => *STRING* (REPLACED)'
               WRITE(IWRITE,'(A72)') CERROR
            ELSEIF( CPARIN.EQ.'PRINT       ')THEN
               ILOGIN= 7
               CERROR='! WARNING: *PRINT*     => *ECHO*   (REPLACED)'
               WRITE(IWRITE,'(A72)') CERROR
            ENDIF
C
            IF( ILOGIN.EQ.0 )THEN
               CRECBG= CBLA12
               CHREND= CSEMIC
            ELSE
               CRECBG= CLOGBG(ILOGIN)
               CHREND= CLOGND(ILOGIN)
C
C              KEYWORDS: *IF*/*WHILE*/*REPEAT*
               IF( ILOGIN.EQ.9.OR.ILOGIN.EQ.10.OR.ILOGIN.EQ.13 )THEN
                  IF( NSTLVL.EQ.NDIMST ) GO TO 7000
                  NSTLVL= NSTLVL+1
                  ITYLVL(NSTLVL)= ILOGIN
                  IRCLVL(NSTLVL)= NINPUT+1
C
C              KEYWORDS: *ENDWHILE*
               ELSEIF( ILOGIN.EQ.12 )THEN
                  IF( ITYLVL(NSTLVL).NE.10 ) GO TO 7001
C
C              KEYWORDS: *UNTIL*
               ELSEIF( ILOGIN.EQ.11 )THEN
                  IF( ITYLVL(NSTLVL).NE.13 ) GO TO 7001
C
C              KEYWORD:  *ELSEIF*/*ELSE*
               ELSEIF( ILOGIN.EQ.8.OR.ILOGIN.EQ.14 )THEN
                  IF( NSTLVL.EQ.0 ) GO TO 7000
                  IF( ITYLVL(NSTLVL).NE.8.AND.
     1                ITYLVL(NSTLVL).NE.9 ) GO TO 7001
                  ITYLVL(NSTLVL)= ILOGIN
C
C              KEYWORD:  *ENDIF*
               ELSEIF( ILOGIN.EQ.15 )THEN
                  IF( ITYLVL(NSTLVL).NE.8.AND.
     1                ITYLVL(NSTLVL).NE.9.AND.
     2                ITYLVL(NSTLVL).NE.14 ) GO TO 7001
               ENDIF
C
C              KEYWORDS:  *UNTIL*/*ENDWHILE*/*ENDIF*
               IF( ILOGIN.EQ.11.OR.ILOGIN.EQ.12.OR.ILOGIN.EQ.15 )THEN
                  IF( NSTLVL.EQ.0 ) GO TO 7002
                  IRECOR= IRCLVL(NSTLVL)
                  JRECOR= NINPUT+1
                  NSTLVL= NSTLVL-1
C
C                 REWRITE OLD RECORD TO KEEP LINK WITH THIS END
                  READ (IUNITO,REC=IRECOR,ERR=9003,IOSTAT=IRETCD)
     1            CPARIN,CDATIN,JLINES,JLEVEL,KRECOR,MASOLD,IPAOLD
                  IF( IRETCD.NE.0 ) GO TO 9004
                  WRITE(IUNITO,REC=IRECOR,ERR=9001,IOSTAT=IRETCD)
     1            CPARIN,CDATIN,JLINES,JLEVEL,JRECOR,MASOLD,IPAOLD
                  IF( IRETCD.NE.0 ) GO TO 9002
               ENDIF
            ENDIF
         ENDIF
C
         IF( ILOGIN.EQ.0 )THEN
            ILEVEL= 0
C
C           STATEMENTS OUTSIDE CLE-2000, STRINGS MUST BE '...'
            DO 85 IWORDS= 1, NWORDS
               IF( JNDLEC(IWORDS).EQ.2.AND.
     1             RWRITE(IDEBWD(IWORDS):IDEBWD(IWORDS)).EQ.'"' )THEN
                  CEMASK(IDEBWD(IWORDS):IDEBWD(IWORDS))='?'
                  CEMASK(IFINWD(IWORDS):IFINWD(IWORDS))='?'
                  WRITE (IWRITE,'(A72)') CEMASK
                  CERROR= '! WARNING: OUTSIDE CLE-2000,'
     1                  //' ENCLOSE STRINGS IN ''...'' (REPLACED)'
                  WRITE (IWRITE,'(A72)') CERROR
                  CEMASK= CBLA72
                  RWRITE(IDEBWD(IWORDS):IDEBWD(IWORDS))=''''
                  RWRITE(IFINWD(IWORDS):IFINWD(IWORDS))=''''
               ENDIF
  85        CONTINUE
         ELSE
C
C           FOR CLE-2000 STATEMENTS,
C           AND INVALID *ILENGV* > 12 FOR STRINGS NOT ENCLOSED BY "..."
            DO 90 IWORDS= 1, NWORDS
               IF( JNDLEC(IWORDS).EQ.2.AND.
     1             RWRITE(IDEBWD(IWORDS):IDEBWD(IWORDS)).NE.'"' )THEN
                  IF( RWRITE(IDEBWD(IWORDS):IDEBWD(IWORDS)).EQ.'''')THEN
                     CEMASK(IDEBWD(IWORDS):IDEBWD(IWORDS))='?'
                     CEMASK(IFINWD(IWORDS):IFINWD(IWORDS))='?'
                     WRITE (IWRITE,'(A72)') CEMASK
                     CERROR= '! WARNING: INSIDE CLE-2000,'
     1                     //' ENCLOSE STRINGS IN "..." (REPLACED)'
                     WRITE (IWRITE,'(A72)') CERROR
                     CEMASK= CBLA72
                     RWRITE(IDEBWD(IWORDS):IDEBWD(IWORDS))='"'
                     RWRITE(IFINWD(IWORDS):IFINWD(IWORDS))='"'
                  ELSE
                     IF( IFINWD(IWORDS)-IDEBWD(IWORDS).GT.11) GO TO 5012
                  ENDIF
               ENDIF
   90       CONTINUE
            ILEVEL= NLEVEL+LVELBG(ILOGIN)
            MAXLVL= MAX(MAXLVL,ILEVEL)
            NWRSEN= NWRSEN+NWORDS
         ENDIF
C
C        RECOVER LAST WORD TO CHECK END OF SENTENCE
         IF( JNDLEC(1).EQ.2.AND.IFINWD(1)-IDEBWD(1).LE.11 )THEN
            CRECND= RWRITE(IDEBWD(1):IFINWD(1))
         ELSE
            CRECND= CBLA12
         ENDIF
C
C        WRITE RECORD OR PART OF IT
         NINPUT= NINPUT+1
         WRITE(IUNITO,REC=NINPUT,ERR=9001,IOSTAT=IRETCD)
     1    CRECBG,RWRITE,ILINES,ILEVEL,IRECOR,MASKCK,IPACKI
         IF( IRETCD.NE.0 ) GO TO 9002
         IF( .NOT.LRECIO ) GO TO 7005
         IRECOR= 0
         CRECBG= CBLA12
         LNWSEN= CRECND.EQ.CHREND
         IF( LNWSEN )THEN
            IF( ILOGIN.NE.0 )THEN
               NLEVEL= NLEVEL+LVELND(ILOGIN)
               IF( NRECIO.NE.0 ) GO TO 7005
               IF( .NOT.L1LETT ) GO TO 5001
C
C              KEYWORDS: *INTEGER*/*REAL*/*STRING*/
C                        *DOUBLE*/*LOGICAL*
               IF( ILOGIN.LE.5 )THEN
                  IF( NEQUAL.EQ.0 )THEN
                     IF( NWRSEN.LE.0 ) GO TO 7004
                  ELSEIF( NEQUAL.EQ.1 )THEN
                     IF( NWRSEN.LE.2 ) GO TO 7004
                  ELSE
                     GO TO 7003
                  ENDIF
                  IF( NLEVEL.NE.1 ) GO TO 7006
C
C              KEYWORD: *EVALUATE*/
               ELSEIF( ILOGIN.EQ.6 )THEN
                  IF( NEQUAL.NE.1 ) GO TO 7003
                  IF( NWRSEN.LE.2 ) GO TO 7004
C
C              KEYWORDS: *ECHO*/*ELSEIF*/*IF*/*WHILE*/*UNTIL*
               ELSEIF( ILOGIN.GE.7.AND.ILOGIN.LE.11 )THEN
                  IF( NEQUAL.NE.0 ) GO TO 7003
                  IF( NWRSEN.LE.0 ) GO TO 7004
C
C              KEYWORDS: *REPEAT*/*ELSE*
               ELSEIF( ILOGIN.EQ.13.OR.ILOGIN.EQ.14 )THEN
                  IF( NEQUAL.NE.0 ) GO TO 7003
                  IF( NWRSEN.NE.-1 ) GO TO 7004
C
C              KEYWORDS: *ENDWHILE*/*ENDIF*
               ELSEIF( ILOGIN.EQ.12.OR.ILOGIN.EQ.15 )THEN
                  IF( NEQUAL.NE.0 ) GO TO 7003
                  IF( NWRSEN.NE.0 ) GO TO 7004
               ENDIF
            ELSE
C
C              USE OF <<.>> OR >>.<<, BUT STILL NO CLE-2000 INSTRUCTION
               IF( MAXLVL.EQ.0.AND.NRECIO.NE.0 ) GO TO 7005
            ENDIF
C
C           RESET NUMBER OF EQUALS, WORDS, <<.>> >>.<<, $.
            NEQUAL= 0
            NWRSEN=-2
            NRECIO= 0
            L1LETT=.TRUE.
         ENDIF
         IF( MYRECO.NE.CBLA72 ) GO TO 30
      GO TO 10
  100 CONTINUE
      MYRECO='QUIT .'
      WRITE(IWRITE,'(A72,A8)') MYRECO,'IMPLICIT'
      MYRECO='     .'
  200 CONTINUE
      IF( NLEVEL.NE.1.OR.CHREND.NE.CSEMIC ) GO TO 7007
      WRITE(IWRITE,*)
      RWRITE= CBLA72
      JFNDBG= INDEX(MYRECO,'"')
      IF( JFNDBG.NE.0 )THEN
         JFNDND= INDEX(MYRECO(JFNDBG+1:72),'"')+JFNDBG
         IF( JFNDND.EQ.JFNDBG )THEN
            CEMASK(JFNDBG:JFNDBG)='?'
            WRITE (IWRITE,'(A72)') CEMASK
            WRITE (IWRITE,'(A72)') TERROR(7)
            CLELOG= CLELOG+1
            CEMASK= CBLA72
         ELSE
            RWRITE= MYRECO(JFNDBG+1:JFNDND-1)
            MYRECO(JFNDBG:JFNDND)= CBLA72(JFNDBG:JFNDND)       
         ENDIF
      ELSE
      ENDIF
      IF( INDEX(RWRITE,'NODEBUG').EQ.0 )THEN
         IF( INDEX(RWRITE,'DEBUG').NE.0 )THEN
            IDBLST= +1
         ENDIF
      ENDIF
      IF( INDEX(RWRITE,'NOXREF').EQ.0 )THEN
         IF( INDEX(RWRITE,'XREF').NE.0 )THEN
            IXRLST= +1
         ENDIF
      ENDIF
      IF( INDEX(RWRITE,'NOLIST').EQ.0 )THEN
         IF( INDEX(RWRITE,'LIST').NE.0 )THEN
            IOULST= +1
         ENDIF
      ENDIF
      JFNDND= INDEX(MYRECO,'.')
      IF( JFNDND.EQ.0 )THEN
         WRITE (IWRITE,'(A72)') TERROR(7)
         CLELOG= CLELOG+1 
      ELSE
         MYRECO(JFNDND:JFNDND)= ' '        
      ENDIF
      IF( MYRECO.NE.CBLA72 )THEN
         WRITE (IWRITE,'(A72)') TERROR(7)
         CLELOG= CLELOG+1 
      ENDIF
C
C     REWRITE TOP OF OBJECT FILE TO KEEP THE NUMBER OF RECORDS
C                                    AND THE MAXIMUM LEVEL
C                                   TRANSMIT LAST STRING AS TITLE
      NRECOR= NINPUT
      WRITE(IUNITO,REC=1,ERR=9001,IOSTAT=IRETCD)
     1      CL2000,RWRITE,NRECOR,NINPUT,MAXLVL,NSTACK,
     2      IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9002
C
  666 RETURN
C
 5001 WRITE(IWRITE,*)'! CLELOG: INVALID 1-CHARACTER WORD IN CLE-2000'
      CLELOG= 5001
      GO TO 666
 5012 WRITE(IWRITE,*)'! CLELOG: MORE THAN 12-CHARACTER WORD IN CLE-2000'
      CLELOG= 5012
      GO TO 666
 7000 WRITE(IWRITE,*)'! CLELOG: KEYWORD= *',CLOGBG(ILOGIN),
     1 '*, BUT MAXIMUM NUMBER OF LEVELS IS ACHIEVED'
      WRITE(IWRITE,*)'! CLELOG: REVISE YOUR LOGIC'
      CLELOG= 7000
      GO TO 666
 7001 WRITE(IWRITE,*)'! CLELOG: AFTER *',CLOGBG(ITYLVL(NSTLVL)),
     1 '*, NOT EXPECTING KEYWORD= *',CLOGBG(ILOGIN),'*'
      WRITE(IWRITE,*)'! CLELOG: REVISE YOUR LOGIC'
      CLELOG= 7001
      GO TO 666
 7002 WRITE(IWRITE,*)'! CLELOG: KEYWORD= *',CLOGBG(ILOGIN),
     1 '*, BUT NOTHING LEFT FOR THIS LEVEL'
      WRITE(IWRITE,*)' CLELOG: REVISE YOUR LOGIC'
      CLELOG= 7002
      GO TO 666
 7003 WRITE(IWRITE,*)'! CLELOG: KEYWORD= *',CLOGBG(ILOGIN),
     1 '*, BUT THE NUMBER OF EQUALS *:=* IS ',NEQUAL
      CLELOG= 7003
      GO TO 666
 7004 WRITE(IWRITE,*)'! CLELOG: KEYWORD= *',CLOGBG(ILOGIN),
     1 '*, BUT THE NUMBER OF WORDS IS ',NWRSEN
      CLELOG= 7003
      GO TO 666
 7005 WRITE(IWRITE,*)'! CLELOG: INVALID <<.>> OR >>.<< INSTRUCTION'
      CLELOG= 7005
      GO TO 666
 7006 WRITE(IWRITE,*)'! CLELOG: DECLARATION AS *',CLOGBG(ILOGIN),
     1 '* MUST APPEAR AT LOGIC LEVEL 1'
      CLELOG= 7006
      GO TO 666
 7007 WRITE(IWRITE,*)'! CLELOG: INCONSISTENT END-OF-FILE, ',
     1               ' LOGIC LEVEL IS ',NLEVEL,'> 1'
      WRITE(IWRITE,*)'! CLELOG: EXPECTING *',CHREND,
     1               '* AT THE END OF STATEMENT ',CRECBG
      CLELOG= 7007
      GO TO 666
 9001 IRETCD= -1
 9002 WRITE(IWRITE,*)'! CLELOG: WRITING RETURN CODE =',IRETCD
      CLELOG= IRETCD
      GO TO 666
 9003 IRETCD= -1
 9004 WRITE(IWRITE,*)'! CLELOG: READING RETURN CODE =',IRETCD
      CLELOG= IRETCD
      GO TO 666
C
      END
