      FUNCTION CLEPIL(IREDIN, IWRITE, IUNITO, CLECST)
C
C     CLE-2000 SYSTEM: R.ROY (03/1999), VERSION 2.1
C
C             *CLEPIL* WILL PERFORM A SYNTACTICAL ANALYSIS
C                      AND COMPILE THE INPUT UNIT *IREDIN*.
C                      RESULT IS THE OBJECT D.A. UNIT *IUNITO*
C                      COMPILER COMMENTS ARE WRITTEN ON UNIT *IWRITE*
C                      WORDS ARE SEPARATED AND CLASSIFIED BY TYPES.
C                      EVERYTHING IS CHECKED FOR CORRECT EXECUTION.
C
C      INPUT: *IREDIN* IS THE INPUT  UNIT
C             *IWRITE* IS THE OUTPUT UNIT FOR COMPILER COMMENTS
C             *IUNITO* IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C             *CLECST* IS THE EXTERNAL FUNCTION FOR *CLE-2000* CONSTANTS
C
C       NOTE: *CLEPIL* = 0 IF NO PROBLEM WAS ENCOUNTERED WHILE COMPILING
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
C     IMPLICIT     NONE
C
      INTEGER      CLEPIL, IREDIN, IWRITE, IUNITO, CLECST
      EXTERNAL                                     CLECST
      INTEGER      CLELOG, CLESTK, CLEXRF, IRETCD, ISTEPC
      CHARACTER*12 CLISTC(3)
      DATA CLISTC /'CLELOG', 'CLESTK', 'CLEXRF'/
C
      CLEPIL= 0
      ISTEPC= 1
C
C     CONSTRUCT OBJECT FILE AND ANALYSE LOGIC
      IRETCD= CLELOG(IREDIN, IWRITE, IUNITO)
      IF( IRETCD.NE.0 ) GO TO 9002
      ISTEPC= 2
C
C     ADD CLE-2000 VARIABLES
      IRETCD= CLESTK(IUNITO, IWRITE, CLECST)
      IF( IRETCD.NE.0 ) GO TO 9002
      ISTEPC= 3
C
C     X-REF CLE-2000 VARIABLES
      IRETCD= CLEXRF(IUNITO, IWRITE)
      IF( IRETCD.NE.0 ) GO TO 9002
C
  666 RETURN
C
 9002 WRITE(IWRITE,*)'! CLEPIL: ERROR CODE IN >> ',
     1 CLISTC(ISTEPC),' << ERROR NUMBER (',IRETCD,')'
      CLEPIL= IRETCD
      GO TO 666
C
      END
