      FUNCTION CLESTK(IUNITO, IWRITE, CLECST)
C
C     CLE-2000 SYSTEM: R.ROY (11/1999), VERSION 2.1
C
C             *CLESTK* SECOND-PASS COMPILE OF THE D.A. UNIT  *IUNITO*
C                      RESULT IS STILL THE OBJECT D.A. UNIT  *IUNITO*
C                      COMPILER COMMENTS ARE WRITTEN ON UNIT *IWRITE*
C                      STACK IS BUILT AT THE END OF          *IUNITO*
C
C        USE:          VARIABLE NAMES ARE DEFINED AND ALLOCATED,
C                      CONSISTENCE OF TYPES IN EVALUATIONS IS CHECKED,
C                      <<.>> AND >>.<< STATEMENTS ARE ALSO CHECKED.
C
C      INPUT: *IUNITO* IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C             *IWRITE* IS THE OUTPUT UNIT FOR COMPILER COMMENTS
C             *CLECST* IS THE EXTERNAL FUNCTION FOR *CLE-2000* CONSTANTS
C
C       NOTE: *CLESTK* = 0 IF NO PROBLEM WAS ENCOUNTERED WHILE COMPILING
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      INTEGER      CLESTK, IUNITO, IWRITE, CLECST
      EXTERNAL                             CLECST
C
      INTEGER      NMAWRD,    NMASKC,     NDIMST,    NDEFKW,
     1             NLOGKW,    NKEYWD
      PARAMETER  ( NMAWRD=36, NMASKC= 3,  NDIMST=64, NDEFKW=6,
     1             NLOGKW=15, NKEYWD=39 )
      INTEGER      MASKCK(NMASKC), IPACKI(NMASKC),
     1             IDEBWD(NMAWRD+1), IFINWD(NMAWRD+1), JNDLEC(NMAWRD),
     2             INDRGT(NDIMST), INDLFT(NDIMST), IRCLFT(NDIMST)
      CHARACTER*12 CKEYWD(NKEYWD), CLOGND(NLOGKW),  
     1             CL2000, CPARIN, CPARAV, CHREND, CEQUAL
      CHARACTER*72 MYRECO, CERROR, CBLA72
      CHARACTER*53 ALPHAB
      CHARACTER*10 DIGITS
      INTEGER      NRECOR, NINPUT, MAXLVL, NSTACK, IXRLST, IOULST,
     1             IDBLST, ILINES, ILEVEL, JRECOR, ILOGIN,
     2             IWORDS, NWORDS, ILOOP1, JLOOP2, JBIPRV, JBICUR,
     3             IRETCD, IRECOR, IVABEG, IVAEND,
     4             ILOWRC, IMEDRC, IHIGRC, NSTLFT, NSTRGT
      LOGICAL      LEQUAL, LOGPRV
C
      INTEGER  INDLIN, IDATIN, IDCLIN, IDEFIN, IUSEIN
      REAL             ADATIN
      CHARACTER*72     CDATIN
      DOUBLE PRECISION DDATIN
      INTEGER      JIN1,JIN2,JIN3,JINT
C
      DATA CERROR/'* CLE-2000 VERS 2.1 * ERROR FOUND FOR THIS LINE * '/
      DATA CL2000,CEQUAL / 'CLE2000(V21)',':=          ' /
      DATA CBLA72 / ' ' /
      DATA ALPHAB
     1  / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz' /
      DATA DIGITS
     1  / '0123456789' /
      DATA CKEYWD
     1  / 'INTEGER' , 'REAL'    , 'STRING'   , 'DOUBLE', 'LOGICAL',
     2    'EVALUATE', 'ECHO'    , 'ELSEIF'   , 'IF'    , 'WHILE'  ,
     3    'UNTIL'   , 'ENDWHILE', 'REPEAT'   , 'ELSE'  , 'ENDIF'  ,
     4    'THEN'    , 'DO'      , 'QUIT'     ,
     5    'NOT'     , 'ABS'     , 'CHS'      , 'LN'    , 'SIN'    ,
     6    'COS'     , 'TAN'     , 'ARCSIN'   , 'ARCCOS', 'ARCTAN' ,
     7    'EXP'     , 'SQRT'    , 'R_TO_I'   , 'D_TO_I', 'I_TO_R' ,
     8    'D_TO_R'  , 'I_TO_D'  , 'R_TO_D'   , 'I_TO_S', '_MIN_'  ,
     9    '_MAX_'   /
      DATA CLOGND
     1  / ';'       , ';'       , ';'        , ';'     , ';'      ,
     2    ';'       , ';'       , 'THEN'     , 'THEN'  , 'DO'     ,
     3    ';'       , ';'       , 'REPEAT'   , 'ELSE'  , ';'      /
C
C
      CLESTK= 0
C
C     READ TOP OF OBJECT FILE
      READ (IUNITO,REC=1,ERR=9023,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,NRECOR,NINPUT,MAXLVL,NSTACK,IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9024
      IF( CPARIN.NE.CL2000 ) GO TO 9025
      IF( NSTACK.NE.0 ) GO TO 9025
C
C     CASE WHERE THERE ARE NO CLE-2000 SENTENCES
      IF( MAXLVL.EQ.0 ) GO TO 666
      IVABEG= NINPUT
      IVAEND= NINPUT
      ILOGIN= 0
      NSTLFT= 0
      NSTRGT= 0
C
C***  MAIN LOOP OVER RECORDS (BEGIN)
      DO 100 IRECOR= 2, NINPUT
C
C     READ A NEW RECORD
      READ(IUNITO,REC=IRECOR,ERR=9023,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,ILINES,ILEVEL,JRECOR,MASKCK,IPACKI
      IF( IRETCD.NE.0 ) GO TO 9024
C
C     RECORDS OUTSIDE CLE-2000, CHECK >>.<< DEFINITIONS
C                                 AND <<.>> USES (FOR DECLARED VARIABLE)
      IF( ILEVEL.EQ.0 )THEN
  10     ILOOP1= INDEX(MYRECO,'>>')
         JLOOP2= INDEX(MYRECO,'<<')
         IF( ILOOP1.NE.0.OR.JLOOP2.NE.0 )THEN
            IF( ILOOP1.EQ.0 ) GO TO 5006
            IF( JLOOP2.EQ.0 ) GO TO 5006
C
C           RECOVER VARIABLE NAME INSIDE <<.>> OR >>.<<
            IF( JLOOP2.GT.ILOOP1 )THEN
               CPARAV= MYRECO(ILOOP1+2:JLOOP2-1)
               MYRECO(ILOOP1:JLOOP2+1)= CBLA72(ILOOP1:JLOOP2+1)
            ELSE
               CPARAV= MYRECO(JLOOP2+2:ILOOP1-1)
               MYRECO(JLOOP2:ILOOP1+1)= CBLA72(JLOOP2:ILOOP1+1)
            ENDIF
            ILOWRC= IVABEG
            IHIGRC= IVAEND+1
   11       CONTINUE
            IF( IHIGRC-ILOWRC.LE.1 )THEN
C
C              VARIABLE WAS NOT FOUND (USED BEFORE DECLARED...)
               GO TO 5004
            ELSE
               IMEDRC= (IHIGRC+ILOWRC)/2
               READ (IUNITO,REC=IMEDRC,ERR=9003,IOSTAT=IRETCD)
     1            CPARIN,CDATIN,INDLIN,
     2            IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
               IF( IRETCD.NE.0 ) GO TO 9004
               IF( CPARIN.EQ.CPARAV )THEN
                  IF( JLOOP2.GT.ILOOP1.AND.IDEFIN.EQ.0 )THEN
C
C                    CHANGE FIRST DEFINED LINE FOR >>.<<
                     WRITE(IUNITO,REC=IMEDRC,ERR=9001,IOSTAT=IRETCD)
     1                  CPARIN,CDATIN,INDLIN,
     2                  IDATIN,ADATIN,DDATIN,IDCLIN,ILINES,IUSEIN
                     IF( IRETCD.NE.0 ) GO TO 9002
                  ELSEIF( ILOOP1.GT.JLOOP2.AND.IUSEIN.EQ.0 )THEN
C
C                    CHANGE FIRST USED    LINE FOR <<.>>
                     WRITE(IUNITO,REC=IMEDRC,ERR=9001,IOSTAT=IRETCD)
     1                  CPARIN,CDATIN,INDLIN,
     2                  IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,ILINES
                     IF( IRETCD.NE.0 ) GO TO 9002
                  ENDIF
               ELSEIF( CPARIN.LT.CPARAV )THEN
                  ILOWRC= IMEDRC
                  GO TO 11
               ELSE
                  IHIGRC= IMEDRC
                  GO TO 11
               ENDIF
            ENDIF
            GO TO 10
         ENDIF
C
C     RECORDS INSIDE CLE-2000, CHECK ALL DECLARATIONS AND DEFINITIONS
      ELSE
         LOGPRV= ILOGIN.EQ.0
         IF( LOGPRV )THEN
            DO 20 ILOOP1= 1, NLOGKW-4
               IF( CPARIN.EQ.CKEYWD(ILOOP1) ) ILOGIN= ILOOP1
   20       CONTINUE
            IF( ILOGIN.EQ.0 ) GO TO 100
C
C           KEYWORDS: *ECHO*/*ELSEIF*/*IF*/*WHILE*/*UNTIL*
C           ASSUME THAT THERE WAS AN *:=* SIGN 
C           (AS IF WE WERE THEN ON RIGHT SIDE OF AN EVALUATE)
            LEQUAL= ILOGIN.GT.NDEFKW
            IF( LEQUAL )THEN
               NSTLFT= 1
               INDLFT(1)= 5
            ENDIF
            CHREND= CLOGND(ILOGIN)
         ENDIF
C
C        HERE, WE HAVE FOUND A SENTENCE INCLUDING A STACK...
C
C        BEGIN: MASK RECOVERY
         IWORDS= 1
         NWORDS= 1
         JBIPRV= 0
         DO 30 ILOOP1=1,72
            JLOOP2=(ILOOP1+23)/24
            JBICUR= MOD(MASKCK(JLOOP2),2)
            IWORDS= IWORDS+JBIPRV*(1-JBICUR)
            IDEBWD(NWORDS)= ILOOP1
            IFINWD(IWORDS)= ILOOP1
            NWORDS= NWORDS+JBICUR*(1-JBIPRV)
            JBIPRV= JBICUR
            MASKCK(JLOOP2)= MASKCK(JLOOP2)/2
   30    CONTINUE
         NWORDS= NWORDS-1
C        END:   MASK RECOVERY
C
         IF( LOGPRV )THEN
C
C           THIS IS A NEW *ILOGIN*
            IF( NWORDS.EQ.1 ) GO TO 100
C
C           START AT CURRENT WORD NUMBER 2
            IWORDS= 2
         ELSE
C           THIS IS NOW THE FIRST WORD, BUT WITH AN OLD *ILOGIN*
            IWORDS= 1
         ENDIF
C
C        BEGIN: UNPACK JNDLEC WITH TYPES (ITYP-1)
         DO 31 ILOOP1= 1,NWORDS
            JLOOP2=(2*ILOOP1+23)/24
            JNDLEC(ILOOP1)= MOD(IPACKI(JLOOP2),4)
            IPACKI(JLOOP2)= IPACKI(JLOOP2)/4
   31    CONTINUE
C        END:   UNPACK JNDLEC WITH TYPES (ITYP-1)
C   
         DO 50 ILOOP1= IWORDS, NWORDS
            IF( JNDLEC(ILOOP1).EQ.2.AND.
     1          MYRECO(IDEBWD(ILOOP1):IDEBWD(ILOOP1)).NE.'"' )THEN
               CPARAV= MYRECO(IDEBWD(ILOOP1):IFINWD(ILOOP1))
               IF( CPARAV.EQ.CHREND )THEN
                  IF( ILOOP1.NE.NWORDS ) GO TO 9010
C
C                 END OF STATEMENT REACHED
C
C                 CHECK CONSISTENCY ON NUMBER OF LEFT/RIGHT EVALUATIONS
                  IF( ILOGIN.NE.7.AND.LEQUAL )THEN
                     IF( NSTLFT.NE.NSTRGT ) GO TO 9008
                     DO 40 JLOOP2= 1, NSTLFT
                       IF( INDRGT(JLOOP2).NE.INDLFT(JLOOP2) )GO TO 9009
   40                CONTINUE
                  ENDIF
C
C                 RESET *ILOGIN* AND LEFT/RIGHT NUMBERS
                  ILOGIN= 0
                  NSTLFT= 0
                  NSTRGT= 0
               ELSEIF( LEQUAL )THEN
C
C
C                 RIGHT-SIDE: VALUES, OPERATIONS & VARIABLES
C
C                 VALUES ARE NOW EXCLUDED, STILL OPERATIONS & VARIABLES
C
C                 CHECK CONVERSION OPERATIONS
                  IF( CPARAV.EQ.'R_TO_I' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.2 ) GO TO 8001
                     INDRGT(NSTRGT)= 1
                  ELSEIF( CPARAV.EQ.'D_TO_I' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.4 ) GO TO 8001
                     INDRGT(NSTRGT)= 1
                  ELSEIF( CPARAV.EQ.'I_TO_R' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1 ) GO TO 8001
                     INDRGT(NSTRGT)= 2
                  ELSEIF( CPARAV.EQ.'D_TO_R' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.4 ) GO TO 8001
                     INDRGT(NSTRGT)= 2
                  ELSEIF( CPARAV.EQ.'I_TO_D' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1 ) GO TO 8001
                     INDRGT(NSTRGT)= 4
                  ELSEIF( CPARAV.EQ.'R_TO_D' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.2 ) GO TO 8001
                     INDRGT(NSTRGT)= 4
                  ELSEIF( CPARAV.EQ.'I_TO_S' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1 ) GO TO 8001
                     INDRGT(NSTRGT)= 3
C
C                 CHECK UNARY OPERATIONS
                  ELSEIF( CPARAV.EQ.'NOT' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.5 ) GO TO 8002
                  ELSEIF( CPARAV.EQ.'CHS'.OR.CPARAV.EQ.'ABS' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1.AND.
     1                   INDRGT(NSTRGT).NE.2.AND.
     2                   INDRGT(NSTRGT).NE.4 ) GO TO 8002
                  ELSEIF( CPARAV.EQ.'EXP'   .OR.CPARAV.EQ.'LN'    .OR.
     1                    CPARAV.EQ.'SIN'   .OR.CPARAV.EQ.'COS'   .OR.
     2                    CPARAV.EQ.'TAN'   .OR.CPARAV.EQ.'ARCSIN'.OR.
     3                    CPARAV.EQ.'ARCCOS'.OR.CPARAV.EQ.'ARCTAN'.OR.
     4                    CPARAV.EQ.'SQRT' )THEN
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.2.AND.
     1                   INDRGT(NSTRGT).NE.4 ) GO TO 8003
C
C                 CHECK BINARY OPERATIONS
                  ELSEIF( CPARAV.EQ.'_MIN_'.OR.CPARAV.EQ.'_MAX_' )THEN
                     NSTRGT= NSTRGT-1
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1.AND.
     1                   INDRGT(NSTRGT).NE.2.AND.
     2                   INDRGT(NSTRGT).NE.4 ) GO TO 8006
                     IF( INDRGT(NSTRGT).NE.INDRGT(NSTRGT+1) )GO TO 8006
                  ELSEIF( CPARAV.EQ.'+'.OR.CPARAV.EQ.'-' )THEN
                     NSTRGT= NSTRGT-1
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.INDRGT(NSTRGT+1) )GO TO 8004
                  ELSEIF( CPARAV.EQ.'*'.OR.CPARAV.EQ.'/' )THEN
                     NSTRGT= NSTRGT-1
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).EQ.3 ) GO TO 8004
                     IF( INDRGT(NSTRGT).NE.INDRGT(NSTRGT+1) )GO TO 8004
                  ELSEIF( CPARAV.EQ.'%' )THEN
                     NSTRGT= NSTRGT-1
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1 ) GO TO 8004
                     IF( INDRGT(NSTRGT).NE.INDRGT(NSTRGT+1) )GO TO 8004
                  ELSEIF( CPARAV.EQ.'**' )THEN
                     NSTRGT= NSTRGT-1
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).NE.1.AND.
     1                   INDRGT(NSTRGT).NE.2.AND.
     2                   INDRGT(NSTRGT).NE.4 ) GO TO 8004
                     IF( INDRGT(NSTRGT).NE.INDRGT(NSTRGT+1) )GO TO 8004
                  ELSEIF( CPARAV.EQ.'<' .OR.CPARAV.EQ.'>' .OR.
     1                    CPARAV.EQ.'=' .OR.CPARAV.EQ.'<='.OR.
     2                    CPARAV.EQ.'>='.OR.CPARAV.EQ.'<>' )THEN
                     NSTRGT= NSTRGT-1
                     IF( NSTRGT.LE.0 ) GO TO 9006
                     IF( INDRGT(NSTRGT).EQ.5 ) GO TO 8005
                     IF( INDRGT(NSTRGT).NE.INDRGT(NSTRGT+1) )GO TO 8005
                     INDRGT(NSTRGT)= 5
                  ELSE
C
C                    RIGHT-SIDE VARIABLES (FOR ... := ... ; )
C
C                    USING *CPARAV* VARIABLE, SCAN ALL DECLARED VARIABLES
                     ILOWRC= IVABEG
                     IHIGRC= IVAEND+1
   41                CONTINUE
                     IF( IHIGRC-ILOWRC.LE.1 )THEN
C
C                       VARIABLE NOT FOUND
                        IF( CPARAV(1:1).NE.'$' ) GO TO 5004
C                       ONLY INTERESTED IN PARAMETRIC CONSTANTS
                        IVAEND= IVAEND+1
C
C                       SHIFT GREATER VARIABLES
                        IF( IHIGRC.NE.IVAEND )THEN
                           DO 42 JLOOP2= IVAEND-1,IHIGRC,-1
                              READ (IUNITO,REC=JLOOP2,ERR=9003,
     1                           IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                         IDATIN,ADATIN,DDATIN,
     3                                         IDCLIN,IDEFIN,IUSEIN
                              IF( IRETCD.NE.0 ) GO TO 9004
                              WRITE(IUNITO,REC=JLOOP2+1,ERR=9001,
     1                           IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                         IDATIN,ADATIN,DDATIN,
     3                                         IDCLIN,IDEFIN,IUSEIN
                              IF( IRETCD.NE.0 ) GO TO 9002
   42                      CONTINUE
                        ENDIF
C
C                       NEW PARAMETRIC CONSTANT FOUND ? => CALL *CLECST*
                        IRETCD= CLECST(CPARAV,INDLIN,IDATIN,
     1                                        ADATIN,CDATIN,DDATIN)
                        IF( IRETCD.NE.0 ) GO TO 5005
C
C                       VALID PARAMETRIC CONSTANT, WRITE AT END
                        WRITE(IUNITO,REC=IHIGRC,ERR=9001,IOSTAT=IRETCD) 
     1                     CPARAV,CDATIN,INDLIN,
     2                     IDATIN,ADATIN,DDATIN,ILINES,ILINES,ILINES
                        IF( IRETCD.NE.0 ) GO TO 9002
CDEBUG
C     WRITE(IWRITE,*) ' => ',CKEYWD(ABS(INDLIN)),' : ',CPARAV
CDEBUG
                     ELSE
                        IMEDRC= (IHIGRC+ILOWRC)/2
                        READ (IUNITO,REC=IMEDRC,ERR=9003,IOSTAT=IRETCD)
     1                     CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN,
     2                                          IDCLIN,IDEFIN,IUSEIN
                        IF( IRETCD.NE.0 ) GO TO 9004
                        IF( CPARIN.EQ.CPARAV )THEN
                           IF( IUSEIN.EQ.0 )THEN
C
C                             CHANGE FIRST USED LINE FOR VARIABLE
                              WRITE(IUNITO,REC=IMEDRC,ERR=9001,
     1                         IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                         IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,ILINES
                              IF( IRETCD.NE.0 ) GO TO 9002
                           ENDIF
                        ELSEIF( CPARIN.LT.CPARAV )THEN
                           ILOWRC= IMEDRC
                           GO TO 41
                        ELSE
                           IHIGRC= IMEDRC
                           GO TO 41
                        ENDIF
                     ENDIF
                     IF( NSTRGT.EQ.NDIMST ) GO TO 9005
                     NSTRGT= NSTRGT+1
                     INDRGT(NSTRGT)= ABS(INDLIN)
                  ENDIF
               ELSE
                  IF( CPARAV.EQ.CEQUAL )THEN
                     LEQUAL=.TRUE.
C
C                    FIRST DEFINED LINE FOR LEFT ( := ) VARIABLES FOR
C                    KEYWORDS: *INTEGER*/*REAL*/*STRING*
C                             /*DOUBLE*/*LOGICAL*
                     IF( ILOGIN.NE.6 )THEN
                        DO 43 JLOOP2= 1, NSTLFT
                           READ (IUNITO,REC=IRCLFT(JLOOP2),ERR=9003,
     1                        IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                        IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
                           IF( IRETCD.NE.0 ) GO TO 9004
                           WRITE(IUNITO,REC=IRCLFT(JLOOP2),ERR=9001,
     1                        IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                        IDATIN,ADATIN,DDATIN,IDCLIN,IDCLIN,IUSEIN
                           IF( IRETCD.NE.0 ) GO TO 9002
   43                   CONTINUE
                     ENDIF
                  ELSE
C
C                    DECLARATION FOR A VARIABLE
C                    ( PARAMETRIC CONSTANTS SHOULD NOT BE DECLARED)
                     IF( CPARAV(1:1).EQ.'$' ) GO TO 5002
C
C                    NEW VARIABLE NAME FOUND ?
                     ILOWRC= IVABEG
                     IHIGRC= IVAEND+1
   44                CONTINUE
C
C                    BINARY SEARCH (WITH POSSIBLE INSERTION)
                     IF( IHIGRC-ILOWRC.LE.1 )THEN
C
C                       NEW VARIABLE NAME FOUND (INVALID *EVALUATE*)
                        IVAEND= IVAEND+1
                        IF( ILOGIN.EQ.6 ) GO TO 5004
C
C                       CHECK IF VARIABLE NAME COMPLIES WITH THE RULES
                        DO 45 JLOOP2= 2,12
                           JIN1=INDEX(ALPHAB,CPARAV(JLOOP2:JLOOP2))
                           JIN2=INDEX(DIGITS,CPARAV(JLOOP2:JLOOP2))
                           JIN3=INDEX(CPARAV(JLOOP2:JLOOP2),' ')
                           JINT=JIN1+JIN2+JIN3
                           IF( JINT.EQ.0 )THEN
                              WRITE(IWRITE,*)' CLESTK: CHARACTER *',
     1                         CPARAV(JLOOP2:JLOOP2),'* IS NOT ALLOWED'
                              GO TO 5001
                           ENDIF
   45                   CONTINUE
C
C                       CHECK IF VARIABLE NAME IS A KEYWORD
                        DO 46 JLOOP2= 1,NKEYWD
                           IF( CPARAV.EQ.CKEYWD(JLOOP2) ) THEN
                              WRITE(IWRITE,*)' CLESTK: VARIABLE *',
     1                           CPARAV,'* IS A CLE-2000 KEYWORD'
                              GO TO 5001
                           ENDIF
   46                   CONTINUE
C
C                       SHIFT GREATER VARIABLES
                        IF( IHIGRC.NE.IVAEND )THEN
                           DO 47 JLOOP2= IVAEND-1,IHIGRC,-1
                              READ (IUNITO,REC=JLOOP2,ERR=9003,
     1                           IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                         IDATIN,ADATIN,DDATIN,
     3                                         IDCLIN,IDEFIN,IUSEIN
                              IF( IRETCD.NE.0 ) GO TO 9004
                              WRITE(IUNITO,REC=JLOOP2+1,ERR=9001,
     1                           IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                         IDATIN,ADATIN,DDATIN,
     3                                         IDCLIN,IDEFIN,IUSEIN
                              IF( IRETCD.NE.0 ) GO TO 9002
   47                      CONTINUE
                           IF( NSTLFT.NE.0 )THEN
                              DO 48 JLOOP2= 1,NSTLFT
                                IF( IRCLFT(JLOOP2).GE.IHIGRC)
     1                             IRCLFT(JLOOP2)= IRCLFT(JLOOP2)+1
   48                         CONTINUE
                           ENDIF
                        ENDIF
                        CDATIN=  CBLA72
                        INDLIN= -ILOGIN
                        IDATIN=  0
                        ADATIN=  0.
                        DDATIN=  0.D0
                        IDCLIN=  ILINES
                        IDEFIN=  0
                        IUSEIN=  0
C
C                       VALID VARIABLE NAME, WRITE AT *IHIGRC*
                        WRITE(IUNITO,REC=IHIGRC,ERR=9001,IOSTAT=IRETCD) 
     1                     CPARAV,CDATIN,INDLIN,
     2                     IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
                        IF( IRETCD.NE.0 ) GO TO 9002
C
C                       COUNT LEFT VARIABLES (FOR ... := ... ; ) AND
C                       KEEP RECORD NUMBER (IN CASE OF := DEFINITION)
                        IF( NSTLFT.EQ.NDIMST ) GO TO 9005
                        NSTLFT= NSTLFT+1
                        IRCLFT(NSTLFT)= IHIGRC
                        INDLFT(NSTLFT)= ILOGIN
CDEBUG
C     WRITE(IWRITE,*) ' => ',CKEYWD(ABS(INDLIN)),' : ',CPARAV
CDEBUG
                     ELSE
                        IMEDRC= (IHIGRC+ILOWRC)/2
                        READ (IUNITO,REC=IMEDRC,ERR=9003,IOSTAT=IRETCD) 
     1                     CPARIN,CDATIN,INDLIN,
     2                     IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
                        IF( IRETCD.NE.0 ) GO TO 9004
                        IF( CPARIN.EQ.CPARAV )THEN
                           IF( ILOGIN.EQ.6 )THEN
                              IF( IDEFIN.EQ.0 )THEN
C
C                                CHANGE FIRST DEFINED LINE FOR VARIABLE
                                 WRITE(IUNITO,REC=IMEDRC,ERR=9001,
     1                              IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                            IDATIN,ADATIN,DDATIN,
     3                                            IDCLIN,ILINES,IUSEIN
                                 IF( IRETCD.NE.0 ) GO TO 9002
                              ELSEIF( NSTLFT.NE.0 )THEN
C
C                                VARIABLE DEFINED ONCE IN *EVALUATE* ?
                                 DO 49 JLOOP2= 1,NSTLFT
                                    IF( IMEDRC.EQ.IRCLFT(JLOOP2) )
     1                                 GO TO 5007
   49                            CONTINUE
                              ENDIF
                              IF( NSTLFT.EQ.NDIMST ) GO TO 9005
                              NSTLFT= NSTLFT+1
                              INDLFT(NSTLFT)= ABS(INDLIN)
                              IRCLFT(NSTLFT)= IMEDRC
                           ELSE
C
C                             VARIABLE ALREADY DECLARED
                              GO TO 5003
                           ENDIF
                        ELSEIF( CPARIN.LT.CPARAV )THEN
                           ILOWRC= IMEDRC
                           GO TO 44
                        ELSE
                           IHIGRC= IMEDRC
                           GO TO 44
                        ENDIF
                     ENDIF
                  ENDIF
               ENDIF
            ELSE
               IF( .NOT.LEQUAL ) GO TO 5001
               IF( NSTRGT.EQ.NDIMST ) GO TO 9005
               NSTRGT= NSTRGT+1
               INDRGT(NSTRGT)= JNDLEC(ILOOP1)+1
            ENDIF
   50    CONTINUE
      ENDIF
C
  100 CONTINUE
C***  MAIN LOOP OVER RECORDS (END)
C
C     ALL VARIABLES ARE NOW SORTED AT THE END OF THE OBJECT FILE
C
C     REWRITE TOP OF OBJECT FILE TO UPDATE *NSTACK*/*NRECOR*
      READ (IUNITO,REC=1,ERR=9003,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,JRECOR,NINPUT,MAXLVL,NSTACK,IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9004
      NSTACK= IVAEND-IVABEG
      NRECOR= IVAEND
      WRITE(IUNITO,REC=1,ERR=9001,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,NRECOR,NINPUT,MAXLVL,NSTACK,IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9002
C
  666 RETURN
C
 5000 WRITE(IWRITE,'(A72,A8)') CERROR,'    LINE'
      WRITE(IWRITE,'(A72,1X,I7.4)') MYRECO,ILINES
      WRITE(IWRITE,*)
      GO TO 666
 5001 WRITE(IWRITE,*)'! CLESTK: INVALID VARIABLE NAME IN RECORD'
      CLESTK= 5001
      GO TO 5000
 5002 WRITE(IWRITE,*)'! CLESTK: *',CPARAV,'* CANNOT BE DECLARED'
      CLESTK= 5002
      GO TO 5000
 5003 WRITE(IWRITE,*)'! CLESTK: VARIABLE DECLARED TWICE *',CPARAV,'*'
      CLESTK= 5003
      GO TO 5000
 5004 WRITE(IWRITE,*)'! CLESTK: VARIABLE NOT YET DECLARED *',CPARAV,'*'
      CLESTK= 5004
      GO TO 5000
 5005 WRITE(IWRITE,*)'! CLESTK: INVALID PARAMETER *',CPARAV,'*'
      CLESTK= 5005
      GO TO 5000
 5006 WRITE(IWRITE,*)'! CLESTK: INVALID VARIABLE FOR >>.<< OR <<.>>'
      CLESTK= 5006
      GO TO 5000
 5007 WRITE(IWRITE,*)'! CLESTK: VARIABLE EVALUATED TWICE *',CPARAV,'*'
      CLESTK= 5007
      GO TO 5000
 8000 WRITE(IWRITE,*)'! CLESTK: *',CPARAV,'* WITH TYPE ',
     1                             CKEYWD(INDRGT(NSTRGT))
      GO TO 5000
 8001 WRITE(IWRITE,*)'! CLESTK: INVALID TYPE_TO_TYPE CONVERSION'
      CLESTK= 8001
      GO TO 8000
 8002 WRITE(IWRITE,*)'! CLESTK: INVALID *NOT* OR *ABS*'
      CLESTK= 8002
      GO TO 8000
 8003 WRITE(IWRITE,*)'! CLESTK: INVALID TYPE FOR REAL/DOUBLE FUNCTION'
      CLESTK= 8003
      GO TO 8000
 8004 WRITE(IWRITE,*)'! CLESTK: INVALID TYPE FOR +,-,*,/,% OR **'
      CLESTK= 8004
      GO TO 8000
 8005 WRITE(IWRITE,*)'! CLESTK: INVALID TYPE FOR <,>,=,<=,>= OR <>'
      CLESTK= 8005
      GO TO 8000
 8006 WRITE(IWRITE,*)'! CLESTK: INVALID TYPE FOR _MIN_ OR _MAX_'
      CLESTK= 8006
      GO TO 8000
 9001 IRETCD= -1
 9002 WRITE(IWRITE,*)'! CLESTK: WRITING RETURN CODE =',IRETCD
      CLESTK= IRETCD
      GO TO 666
 9003 IRETCD= -1
 9004 WRITE(IWRITE,*)'! CLESTK: READING RETURN CODE =',IRETCD
      CLESTK= IRETCD
      GO TO 666
 9005 WRITE(IWRITE,*)'! CLESTK: *STACK* MEMORY IS FULL'
      CLESTK= 9005
      GO TO 5000
 9006 WRITE(IWRITE,*)'! CLESTK: *STACK* MEMORY IS EMPTY'
      CLESTK= 9006
      GO TO 5000
 9008 WRITE(IWRITE,*)'! CLESTK: ERROR ON THE NUMBER OF EVALUATIONS'
      WRITE(IWRITE,*)'! CLESTK: LEFT=',NSTLFT,' VS. RIGHT=',NSTRGT
      CLESTK= 9008
      GO TO 5000
 9009 WRITE(IWRITE,*)'! CLESTK: ERROR ON THE TYPE OF AN EVALUATION'
      CLESTK= 9009
      GO TO 5000
 9010 WRITE(IWRITE,*)'! CLESTK: UNEXPECTED END OF STATEMENT'
      CLESTK= 9010
      GO TO 5000
 9023 IRETCD= -1
 9024 WRITE(IWRITE,*)'! CLESTK: IOSTAT RETURN CODE =',IRETCD
      WRITE(IWRITE,*)'! CLESTK: IMPOSSIBLE TO USE THIS *OBJECT* FILE'
      CLESTK= -2
      GO TO 666
 9025 WRITE(IWRITE,*)'! CLESTK: IMPOSSIBLE TO USE OLD  *OBJECT* FILE'
      CLESTK= -3
      GO TO 666
      END
