      SUBROUTINE       DRVIOX( IPTDAT, MINPUT )
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *DRVIOX* IS USED TO INPUT/OUTPUT CLE-2000 VALUES
C                                 INTO/FROM    DATA STRUCTURE.
C
C      INPUT: *IPTDAT* IS THE DATA STRUCTURE POINTER (ALLOCATED)
C             *MINPUT* IS AN INTEGER -1: TO READ DATA INPUT (IN MAIN)
C                                     0: TO GET  THIS INPUT (IN PROC)
C                                    +1: TO RETURN VALUES   (IN MAIN)
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT         NONE
C
      INTEGER          IPTDAT, MINPUT
      INTEGER          IWRITE
      PARAMETER      ( IWRITE= 6 )
      LOGICAL          LCATRU, LCAFAL
      PARAMETER      ( LCATRU=.TRUE., LCAFAL=.FALSE. )
C
C     VARIABLES FOR *REDGET*
      INTEGER          ITYP, NITMA
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      CHARACTER*72     TEXT
C
C     VARIABLES FOR *REDOPN/REDCLS*
      INTEGER          JREAD, JWRITE, JRECIN
C
      INTEGER          NEMBED, NDATC2, NUSEC2, NTYPC2
C
C     EQUIVALENCE FOR DOUBLE INPUT/OUTPUT
      REAL             REQUI(2)
      EQUIVALENCE    ( DFLOT, REQUI )
C
      INTEGER          LCMNAM(18)
      INTEGER          ICTLEN
      CHARACTER*12     CSEMIC, CDDOT, CDDDOT, VARNAM, TEXT12
      CHARACTER*2      CTYPES(5)
      DATA             CSEMIC, CDDOT, CDDDOT
     1               /    ';',   '::',  ':::' /
      DATA CTYPES / '_I', '_R', '_S', '_D', '_L' /
C
      IF( MINPUT.EQ.-1 )THEN
C
C        INPUT CLE-2000 VARIABLES FROM MAIN PROGRAM
         NEMBED= 0
         NDATC2= 0
         NUSEC2= 0
   10    CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
         IF(ITYP .EQ. 3) THEN
           ICTLEN=NITMA
         ELSE
           ICTLEN=0
         ENDIF
            IF( ITYP.EQ.3.AND.TEXT(1:12).EQ.CSEMIC(1:12)
     1                   .AND.NEMBED.EQ.0 )THEN
C
C              END OF STATEMENT REACHED
               CALL LCMPUT(IPTDAT,'!_NUM_VALUES',1,1,NDATC2)
               CALL LCMPUT(IPTDAT,'!_USE_VALUES',1,1,NUSEC2)
C
C              CLOSE CLE-2000 FILE
               CALL REDCLS(JREAD,JWRITE,JRECIN)
               CALL LCMPUT(IPTDAT,'!_C2M_INPFIL',1,1,JREAD)
               CALL LCMPUT(IPTDAT,'!_C2M_OUTFIL',1,1,JWRITE)
               CALL LCMPUT(IPTDAT,'!_C2M_RECORD',1,1,JRECIN)
               GO TO 666
            ELSE
               NDATC2= NDATC2+1
               WRITE(VARNAM,'(8H!_C2M_V_,I4.4)') NDATC2
               CALL LCMSIX(IPTDAT,VARNAM,1)
               CALL LCMPUT(IPTDAT,'C2M_TYPE',1,1,ITYP)
               IF( ITYP.LT.0 )THEN
                  TEXT12= TEXT(1:12)
                  CALL LCMCAR(TEXT12, LCATRU ,LCMNAM)
                  CALL LCMPUT(IPTDAT,'C2M_NAME',3,3,LCMNAM)
               ELSEIF( ITYP.EQ.3 )THEN
                  IF( TEXT(1:ICTLEN).EQ.CDDDOT )THEN
                     NEMBED= NEMBED + 1
                  ELSEIF( TEXT(1:ICTLEN).EQ.CSEMIC )THEN
                     NEMBED= NEMBED - 1
                  ELSEIF( TEXT(1:ICTLEN).EQ.CDDOT )THEN
                     CALL XABORT('DRVIOX: INPUT DATA MISTAKE (ACT).') 
                  ENDIF
                  CALL LCMCAR(TEXT, LCATRU ,LCMNAM)
                  CALL LCMPUT(IPTDAT,'C2M_VALUE',18,3,LCMNAM)
                  CALL LCMPUT(IPTDAT,'C2M_LONGC',1,1,ICTLEN)
               ELSEIF( ITYP.EQ.1.OR.ITYP.EQ.5 )THEN
                  CALL LCMPUT(IPTDAT,'C2M_VALUE',1,1,NITMA)
               ELSEIF( ITYP.EQ.2 )THEN
                  CALL LCMPUT(IPTDAT,'C2M_VALUE',1,2,FLOTT)
               ELSEIF( ITYP.EQ.4 )THEN
                  CALL LCMPUT(IPTDAT,'C2M_VALUE',2,4,REQUI)
               ELSE
                  CALL XABORT('DRVIOX: INVALID TYPE (ACT).')
               ENDIF
               CALL LCMSIX(IPTDAT,' ',2)
            ENDIF
         GO TO 10
      ELSEIF( MINPUT.EQ.0 )THEN
C
C        READ/WRITE CLE-2000 VARIABLES IN THE PROCEDURE CALL
         CALL LCMGET(IPTDAT,'!_NUM_VALUES',NDATC2)
         CALL LCMGET(IPTDAT,'!_USE_VALUES',NUSEC2)
   20    CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
         IF(ITYP .EQ. 3) THEN
           ICTLEN=NITMA
         ELSE
           ICTLEN=0
         ENDIF
            IF( ITYP.EQ.3.AND.TEXT(1:12).EQ.CSEMIC )THEN
               CALL LCMPUT(IPTDAT,'!_USE_VALUES',1,1,NUSEC2)
               GO TO 666
            ELSE
               NUSEC2= NUSEC2+1
               IF( NUSEC2.GT.NDATC2 )THEN
                  WRITE(IWRITE,*) 'DRVIOX: PROC WAS CALLED WITH ONLY ',
     1                            NDATC2,' PARAMETERS.'
                  CALL XABORT( 'DRVIOX: INVALID NUMBER OF PARAMETERS' )
               ENDIF
               WRITE(VARNAM,'(8H!_C2M_V_,I4.4)') NUSEC2
               CALL LCMSIX(IPTDAT,VARNAM,1)
               CALL LCMGET(IPTDAT,'C2M_TYPE',NTYPC2)
               IF( -ITYP.NE.NTYPC2 )THEN
                  IF( ITYP.LT.0 )THEN
                     WRITE(IWRITE,*) 'DRVIOX: DUMMY VARIABLE NAME *',
     1                 TEXT(1:12),'* OF TYPE( ',CTYPES(-ITYP),' )'
                  ELSE
                     WRITE(IWRITE,*) 'DRVIOX: DUMMY VALUE OF TYPE( ',
     1                 CTYPES(ITYP),' )'
                  ENDIF
                  IF( NTYPC2.LT.0 )THEN
                     CALL LCMGET(IPTDAT,'C2M_NAME',LCMNAM)
                     CALL LCMCAR(TEXT12, LCAFAL ,LCMNAM)
                     TEXT= TEXT12
                     WRITE(IWRITE,*) 'DRVIOX: ACTUAL VARIABLE NAME *',
     1                 TEXT12,'* OF TYPE( ',CTYPES(-NTYPC2),' )'
                  ELSE
                     WRITE(IWRITE,*) 'DRVIOX: ACTUAL VALUE OF TYPE( ',
     1                 CTYPES(NTYPC2),' )'
                  ENDIF
                  CALL XABORT('DRVIOX: INVALID TYPE (DUMMY).')
               ELSEIF( ITYP.LT.0 )THEN
                  TEXT12= TEXT(1:12)
                  CALL LCMCAR(TEXT12, LCATRU ,LCMNAM)
                  CALL LCMPUT(IPTDAT,'C2M_NAME',3,3,LCMNAM)
C*                  WRITE(IWRITE,*) 'REDPUT: ',CTYPES(-ITYP),' INTO *',
C*     1                TEXT(1:12),'*'
                  NITMA=0
                  FLOTT=0.0
                  DFLOT=0.0D0
                  TEXT=' '
                  IF( ITYP.EQ.-1.OR.ITYP.EQ.-5 )THEN
                     CALL LCMGET(IPTDAT,'C2M_VALUE',NITMA)
C*                     WRITE(IWRITE,*) 'REDPUT:  VALUE=',NITMA
C*                     WRITE(IWRITE,*) 'REDPUT:  '
                  ELSEIF( ITYP.EQ.-2 )THEN
                     CALL LCMGET(IPTDAT,'C2M_VALUE',FLOTT)
C*                     WRITE(IWRITE,*) 'REDPUT:  VALUE=',FLOTT
C*                     WRITE(IWRITE,*) 'REDPUT:  '
                  ELSEIF( ITYP.EQ.-3 )THEN
                     CALL LCMGET(IPTDAT,'C2M_VALUE',LCMNAM)
                     CALL LCMGET(IPTDAT,'C2M_LONGC',ICTLEN)
                     NITMA=ICTLEN
                     CALL LCMCAR(TEXT, LCAFAL ,LCMNAM)
C*                     WRITE(IWRITE,*) 'REDPUT:  VALUE=',TEXT
C*                     WRITE(IWRITE,*) 'REDPUT:  '
                  ELSEIF( ITYP.EQ.-4 )THEN
                     CALL LCMGET(IPTDAT,'C2M_VALUE',REQUI)
C*                     WRITE(IWRITE,*) 'REDPUT:  VALUE=',DFLOT
C*                     WRITE(IWRITE,*) 'REDPUT:  '
                  ELSE
                     CALL XABORT('DRVIOX: INVALID TYPE (DUMMY).')
                  ENDIF
                  CALL REDPUT(NTYPC2,NITMA,FLOTT,TEXT,DFLOT)
               ELSE
                  IF( ITYP.EQ.1.OR.ITYP.EQ.5 )THEN
                     CALL LCMPUT(IPTDAT,'C2M_VALUE',1,1,NITMA)
                  ELSEIF( ITYP.EQ.2 )THEN
                     CALL LCMPUT(IPTDAT,'C2M_VALUE',1,2,FLOTT)
                  ELSEIF( ITYP.EQ.3 )THEN
                     CALL LCMCAR(TEXT, LCATRU ,LCMNAM)
                     CALL LCMPUT(IPTDAT,'C2M_VALUE',18,3,LCMNAM)
                     CALL LCMPUT(IPTDAT,'C2M_LONGC',1,1,NITMA)
                  ELSEIF( ITYP.EQ.4 )THEN
                     CALL LCMPUT(IPTDAT,'C2M_VALUE',2,4,REQUI)
                  ELSE
                     CALL XABORT('DRVIOX: INVALID TYPE (DUMMY).')
                  ENDIF
               ENDIF
               CALL LCMSIX(IPTDAT,' ',2)
            ENDIF
         GO TO 20
      ELSEIF( MINPUT.EQ.+1 )THEN
C
C        RETURN BACK ARGUMENT VALUES IN ACTUAL MAIN VARIABLES
C
C        OPEN MAIN CLE-2000 FILE IN ITS ACTUAL STATE
         CALL LCMGET(IPTDAT,'!_C2M_INPFIL',JREAD)
         CALL LCMGET(IPTDAT,'!_C2M_OUTFIL',JWRITE)
         CALL LCMGET(IPTDAT,'!_C2M_RECORD',JRECIN)
         CALL REDOPN(JREAD,JWRITE,JRECIN)
C
C        FIRST, CHECK CONSISTENCE OF DATA (READ EVERYTHING?)
         CALL LCMGET(IPTDAT,'!_NUM_VALUES',NDATC2)
         CALL LCMGET(IPTDAT,'!_USE_VALUES',NUSEC2)
         IF( NDATC2.NE.NUSEC2 )THEN
            WRITE(IWRITE,*) 'DRVIOX: PROC WAS CALLED WITH ',
     1                       NDATC2,' PARAMETERS,'
            WRITE(IWRITE,*) 'DRVIOX:                 ONLY ',
     1                       NUSEC2,' WERE USED.'
            CALL XABORT('DRVIOX: INVALID PROCEDURE CALL')
         ENDIF
C
C        CONSISTENT RETURN (NOW, *REDPUT* IN THE REVERSE ORDER)
         DO 40 NUSEC2= NDATC2,1,-1
            WRITE(VARNAM,'(8H!_C2M_V_,I4.4)') NUSEC2
            CALL LCMSIX(IPTDAT,VARNAM,1)
            CALL LCMGET(IPTDAT,'C2M_TYPE',ITYP)
            NITMA=0
            FLOTT=0.0
            DFLOT=0.0D0
            TEXT=' '
            IF( ITYP.LT.0 )THEN
               IF( ITYP.EQ.-1.OR.ITYP.EQ.-5 )THEN
                  CALL LCMGET(IPTDAT,'C2M_VALUE',NITMA)
C*                  WRITE(IWRITE,*) 'REDPUT:  VALUE=',NITMA
C*                  WRITE(IWRITE,*) 'REDPUT:  '
               ELSEIF( ITYP.EQ.-2 )THEN
                  CALL LCMGET(IPTDAT,'C2M_VALUE',FLOTT)
C*                  WRITE(IWRITE,*) 'REDPUT:  VALUE=',FLOTT
C*                  WRITE(IWRITE,*) 'REDPUT:  '
               ELSEIF( ITYP.EQ.-3 )THEN
                  CALL LCMGET(IPTDAT,'C2M_VALUE',LCMNAM)
                  CALL LCMGET(IPTDAT,'C2M_LONGC',ICTLEN)
                  NITMA=ICTLEN
                  CALL LCMCAR(TEXT, LCAFAL ,LCMNAM)
C*                  WRITE(IWRITE,*) 'REDPUT:  VALUE=',TEXT
C*                  WRITE(IWRITE,*) 'REDPUT:  '
               ELSEIF( ITYP.EQ.-4 )THEN
                  CALL LCMGET(IPTDAT,'C2M_VALUE',REQUI)
C*                  WRITE(IWRITE,*) 'REDPUT:  VALUE=',DFLOT
C*                  WRITE(IWRITE,*) 'REDPUT:  '
               ELSE
                  CALL XABORT('DRVIOX: INVALID TYPE (DUMMY).')
               ENDIF
               NTYPC2= -ITYP
               CALL REDPUT(NTYPC2,NITMA,FLOTT,TEXT,DFLOT)
            ENDIF
            CALL LCMSIX(IPTDAT,' ',2)
   40    CONTINUE
      ELSE
         CALL XABORT( 'DRVIOX: INVALID VALUE FOR *MINPUT* ARG' )
      ENDIF
  666 RETURN
      END
