*DECK DRVUTL
      SUBROUTINE DRVUTL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* STANDARD UTILITY MODULE FOR LINKED LIST OR XSM FILES.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =0 CLE-2000 VARIABLE; =1 LINKED LIST; =2 XSM FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LIST OF UTILITY ACTIONS:
*   IMPR : PRINT A BLOCK.
*   COPY : COPY A BLOCK OR A DIRECTORY.
*   CREA : CREATE A BLOCK.
*   DEL  : DELETE A BLOCK.
*   STAT : COMPARE TWO BLOCKS.
*   ADD  : ADD TWO FLOATING POINT BLOCKS OR DIRECTORIES COMPONENT BY
*          COMPONENT.
*   MULT : MULTIPLY THE FLOATING POINT COMPONENTS OF A BLOCK OR
*          DIRECTORY BY A CONSTANT.
*   STEP : CHANGE OF DIRECTORY LEVEL.
*   DIR  : PRINT THE ACTIVE DIRECTORY CONTENT.
*   DUMP : DUMP THE ACTIVE AND SON DIRECTORIES ON THE PRINTER.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 03/02/88 ---
*
      PARAMETER(MAXLEV=50)
      CHARACTER HENTRY(*)*12,TEXT4*4,NAMT*12,NAMT2*12,TEXT12*12,
     1 NAMMY*12,NAMLCM*12,CTYP(3)*11,CENT(3)*9,HSMG*131
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
      REAL RRR(12)
      DOUBLE PRECISION DFLOTT,DDD(6)
      EQUIVALENCE (RRR,DDD)
      INTEGER IBASE(1),IPKEEP(MAXLEV)
      LOGICAL EMPTY,LCM,LBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1))
      DATA (CTYP(ITY),ITY=1,3)/'CLE_2000','LINKED_LIST','XSM_FILE'/
      DATA (CENT(ITY),ITY=1,3)/'CREATE','IN_OUT','READ-ONLY'/
      SAVE CTYP,CENT
*
* PARAMETER VALIDATION.
      IF(NENTRY.EQ.0) CALL XABORT('DRVUTL: PARAMETER EXPECTED.')
      IF(JENTRY(1).EQ.0) THEN
         IF(IENTRY(1).GT.2) CALL XABORT('DRVUTL: THE UTILITY MODULE WO'
     1   //'RKS ONLY WITH LINKED LISTS AND XSM FILES.')
      ELSE IF(JENTRY(1).EQ.1) THEN
         IF(IENTRY(1).GT.2) CALL XABORT('DRVUTL: THE UTILITY MODULE WO'
     1   //'RKS ONLY WITH LINKED LISTS AND XSM FILES.')
      ELSE IF(JENTRY(1).EQ.2) THEN
         IF(IENTRY(1).GT.2) CALL XABORT('DRVUTL: THE UTILITY MODULE WO'
     1   //'RKS ONLY WITH LINKED LISTS AND XSM FILES.')
      ENDIF
      IND=JENTRY(1)
      ITYPE=IENTRY(1)
      IPLIST=KENTRY(1)
      IPKEEP(1)=IPLIST
      ILEV=1
      CALL LCMINF(IPLIST,TEXT12,NAMMY,EMPTY,ILONG,LCM)
      WRITE(6,180) CTYP(ITYPE+1),TEXT12,CENT(IND+1),NAMMY
*
* PERFORM SOME UTILITY ACTIONS.
   15 CALL REDGET(INDIC,NITMA,DPREC,TEXT4,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'IMPR') THEN
*        PRINT A LCM OR XSM BLOCK.
         CALL REDGET(INDPRT,ISET,FLOTT,NAMT,DFLOTT)
         IF(INDPRT.EQ.1) THEN
            CALL LCMLEL(IPLIST,ISET,ILONG,ITYBLK)
            IF(ILONG.EQ.0) THEN
               WRITE (6,245) ISET
               CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
               GO TO 15
            ENDIF
         ELSE IF(INDPRT.EQ.3) THEN
            CALL LCMLEN(IPLIST,NAMT,ILONG,ITYBLK)
            IF(ILONG.EQ.0) THEN
               WRITE (6,250) NAMT
               CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
               GO TO 15
            ENDIF
         ELSE
            CALL XABORT('DRVUTL: BLOCK-NAME OR LIST INDEX EXPECTED.')
         ENDIF
         IF(ITYBLK.EQ.10) CALL XABORT('DRVUTL: '//NAMT//' IS A LIST OF'
     1   //' ARRAYS. USE A STEP UP KEYWORD TO ACCESS THE LIST.')
         CALL SETARA(BASE,ILONG,IASS)
         IF(INDPRT.EQ.1) THEN
            CALL LCMGDL(IPLIST,ISET,BASE(IASS))
         ELSE IF(INDPRT.EQ.3) THEN
            CALL LCMGET(IPLIST,NAMT,BASE(IASS))
         ENDIF
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            LL=NITMA
         ELSE IF(INDIC.NE.3) THEN
           CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         ELSE IF(TEXT4.NE.'*') THEN
           CALL XABORT('DRVUTL: CHARACTER * EXPECTED.')
         ELSE
            LL=99999999
         ENDIF
         ICONT=0
         IF(ITYBLK.EQ.1) THEN
           DO 300 I=1,ILONG
             IF(IBASE(IASS+I-1).NE.0) ICONT=ICONT+1
 300       CONTINUE
         ELSE IF(ITYBLK.EQ.2) THEN
           DO 301 I=1,ILONG
             IF(BASE(IASS+I-1).NE.0.0) ICONT=ICONT+1
 301       CONTINUE
         ELSE IF(ITYBLK.EQ.4) THEN
           DO 303 I=1,ILONG,2
             RRR(1)=BASE(IASS+I-1)
             RRR(2)=BASE(IASS+I)
             IF(DDD(1).NE.0.0D0) ICONT=ICONT+1
 303       CONTINUE
         ELSE IF(ITYBLK.EQ.6) THEN
           DO 304 I=1,ILONG,2
             RRR(1)=BASE(IASS+I-1)
             RRR(2)=BASE(IASS+I)
             IF(RRR(1).NE.0.0.AND.RRR(2).NE.0.0) ICONT=ICONT+1
 304       CONTINUE
         ENDIF
         IF(INDPRT.EQ.1) THEN
            WRITE (6,225) ISET,ILONG,ICONT
         ELSE IF(INDPRT.EQ.3) THEN
            WRITE (6,230) NAMT,ILONG,ICONT
         ENDIF
         IMAX=MIN0(LL,ILONG)
         IF((IMAX.GT.0).AND.(ITYBLK.EQ.1)) THEN
            WRITE (6,'(1X,13I10)') (IBASE(IASS+I-1),I=1,IMAX)
         ELSE IF((IMAX.GT.0).AND.(ITYBLK.EQ.2)) THEN
            WRITE (6,'(1X,1P,10E13.4)') (BASE(IASS+I-1),I=1,IMAX)
         ELSE IF((IMAX.GT.0).AND.(ITYBLK.EQ.3)) THEN
            WRITE (6,'(1X,32A4)') (BASE(IASS+I-1),I=1,IMAX)
         ELSE IF((IMAX.GT.0).AND.(ITYBLK.EQ.4)) THEN
            DO 25 I=1,1+IMAX/12
            IOFSET=IASS+(I-1)*12-1
            DO 20 J=1,MIN(12,IMAX-(I-1)*12)
   20       RRR(J)=BASE(IOFSET+J)
            WRITE(6,'(1X,1P,6D21.12)') (DDD(J),J=1,MIN(6,IMAX/2-
     1      (I-1)*6))
   25       CONTINUE
         ELSE IF((IMAX.GT.0).AND.(ITYBLK.EQ.5)) THEN
            WRITE(6,'(1X,65L2)') (LBASE(IASS+I-1),I=1,IMAX)
         ELSE IF((IMAX.GT.0).AND.(ITYBLK.EQ.6)) THEN
            WRITE(6,'(1X,1P,4(2H (,E13.4,1H,,E13.4,1H)))')
     1      (BASE(IASS+I-1),I=1,IMAX)
         ELSE IF((IMAX.GT.0).AND.(ITYBLK.EQ.0)) THEN
            WRITE (6,240) NAMT
         ENDIF
         WRITE (6,'(/)')
         CALL RLSARA(BASE(IASS))
      ELSE IF(TEXT4.EQ.'COPY') THEN
*        COPY AND NAME A BLOCK OR DIRECTORY ON LCM OR XSM.
         IF(IND.EQ.2) CALL XABORT('DRVUTL: COPY IS A FORBIDDEN OPERATIO'
     1   //'N IN READ-ONLY MODE.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT2,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL LCMLEN(IPLIST,NAMT,ILONG,ITYBLK)
         IF(ILONG.EQ.-1) THEN
*           COPY A COMPLETE DIRECTORY.
            CALL LCMSIX(IPLIST,NAMT,1)
            NUNIT=KDROPN('DUMMYSQ',0,2,0,0)
            IF(NUNIT.LE.0) CALL XABORT('DRVUTL: KDROPN FAILURE.')
            CALL LCMEXP(IPLIST,0,NUNIT,1,1)
            REWIND(NUNIT)
            CALL LCMSIX(IPLIST,' ',2)
            CALL LCMSIX(IPLIST,NAMT2,1)
            CALL LCMEXP(IPLIST,0,NUNIT,1,2)
            IRC=KDRCLS(NUNIT,2)
            IF(IRC.LT.0) CALL XABORT('DRVUTL: KDRCLS FAILURE.')
            CALL LCMSIX(IPLIST,' ',2)
         ELSE IF(ILONG.GT.0) THEN
*           COPY A SINGLE RECORD.
            CALL SETARA(BASE,ILONG,INAMT)
               CALL LCMGET(IPLIST,NAMT,BASE(INAMT))
               CALL LCMPUT(IPLIST,NAMT2,ILONG,ITYBLK,BASE(INAMT))
            CALL RLSARA(BASE(INAMT))
         ELSE IF(ILONG.EQ.0) THEN
            CALL XABORT('DRVUTL: '''//NAMT//''' IS NOT STORED ON LCM O'
     1      //'R XSM.')
         ENDIF
      ELSE IF(TEXT4.EQ.'CREA') THEN
         IF(IND.EQ.2) CALL XABORT('DRVUTL: CREA IS A FORBIDDEN OPERATIO'
     1   //'N IN READ-ONLY MODE.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL REDGET(INDIC,ILONG,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('DRVUTL: INTEGER DATA EXPECTED.')
         ILONG2=ILONG
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF((INDIC.NE.3).AND.(TEXT4.NE.'=')) CALL XABORT('DRVUTL: = SI'
     1   //'GN EXPECTED.')
         CALL SETARA(BASE,2*ILONG,INAMT)
         CALL REDGET(INDIC,BASE(INAMT),BASE(INAMT),TEXT4,DDD(1))
         IF(INDIC.EQ.3) THEN
            READ(TEXT4,'(A4)') BASE(INAMT)
         ELSE IF(INDIC.EQ.4) THEN
            BASE(INAMT)=RRR(1)
            BASE(INAMT+1)=RRR(2)
         ENDIF
         INDICO=INDIC
         DO 30 I=1,ILONG-1
         CALL REDGET(INDIC,BASE(INAMT+I),BASE(INAMT+I),TEXT4,DDD(1))
         IF(INDIC.NE.INDICO) CALL XABORT('DRVUTL: INCONSISTENT DATA T'
     1   //'YPE.')
         IF(INDIC.EQ.3) THEN
            READ(TEXT4,'(A4)') BASE(INAMT+I)
         ELSE IF(INDIC.EQ.4) THEN
            BASE(INAMT+2*I)=RRR(1)
            BASE(INAMT+2*I+1)=RRR(2)
         ENDIF
   30    CONTINUE
         IF(INDIC.EQ.4) ILONG2=2*ILONG
         CALL LCMPUT(IPLIST,NAMT,ILONG2,INDICO,BASE(INAMT))
         CALL RLSARA(BASE(INAMT))
      ELSE IF(TEXT4.EQ.'DEL') THEN
*        DELETE A BLOCK.
         IF(IND.EQ.2) CALL XABORT('DRVUTL: DEL IS A FORBIDDEN OPERATION'
     1   //' IN READ-ONLY MODE.')
         IF(ITYPE.GT.1) CALL XABORT('DRVUTL: DEL CAN ONLY BE USED WITH '
     1   //'LINKED-LISTS.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL LCMDEL(IPLIST,NAMT)
      ELSE IF(TEXT4.EQ.'STAT') THEN
*        COMPARE TWO BLOCKS STORED ON LCM OR XSM.
*        READ RELATIVE OR ABSOLUTE ERROR.
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
*        RECOVERY OF THE FIRST BLOCK.
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL LCMLEN(IPLIST,NAMT,ILONG1,IT1BLK)
         CALL SETARA(BASE,ILONG1,INAMT1)
         CALL LCMGET(IPLIST,NAMT,BASE(INAMT1))
*        RECOVERY OF THE SECOND BLOCK.
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL LCMLEN(IPLIST,NAMT,ILONG2,IT2BLK)
         IF(ILONG2.NE.ILONG1) THEN
           CALL XABORT('DRVUTL: THE 2 BLOCKS ARE OF DIFFERENT LENGTH.')
         ELSE IF(IT1BLK.NE.IT2BLK) THEN
           CALL XABORT('DRVUTL: THE 2 BLOCKS ARE OF DIFFERENT TYPES.')
         ENDIF
         CALL SETARA(BASE,ILONG2,INAMT2)
         CALL LCMGET(IPLIST,NAMT,BASE(INAMT2))
*        COMPARE THE TWO BLOCKS.
         EPSMAX=0.0
         EPSAVG=0.0
         IF(TEXT4(1:3).EQ.'REL') THEN
             WRITE (6,200) 'RELATIVE'
             DO 40 I=1,ILONG1
             IF(BASE(INAMT2+I-1).NE.0.0) THEN
                ABSEP=ABS((BASE(INAMT1+I-1)-BASE(INAMT2+I-1))/
     1                BASE(INAMT2+I-1))
             ELSE
                ABSEP=0.0
             ENDIF
             IF(EPSMAX.LT.ABSEP) THEN
                EPSMAX=ABSEP
                INGRO=I
             ENDIF
   40        EPSAVG=EPSAVG+ABSEP
             EPSMAX=100.0*EPSMAX
             EPSAVG=100.0*EPSAVG/REAL(ILONG1)
             WRITE (6,210) ILONG1,EPSMAX,INGRO,EPSAVG
          ELSE IF(TEXT4(1:3).EQ.'ABS') THEN
             WRITE (6,200) 'ABSOLUTE'
             DO 50 I=1,ILONG1
             ABSEP=ABS(BASE(INAMT1+I-1)-BASE(INAMT2+I-1))
             IF(EPSMAX.LT.ABSEP) THEN
                EPSMAX=ABSEP
                INGRO=I
             ENDIF
   50        EPSAVG=EPSAVG+ABSEP
             EPSAVG=EPSAVG/REAL(ILONG1)
             WRITE (6,220) ILONG1,EPSMAX,INGRO,EPSAVG
         ELSE
            CALL XABORT('DRVUTL: CHOOSE RELATIVE OR ABSOLUTE')
         ENDIF
         CALL RLSARA(BASE(INAMT2))
         CALL RLSARA(BASE(INAMT1))
      ELSE IF(TEXT4.EQ.'ADD') THEN
*        ADD TWO BLOCKS OR DIRECTORIES STORED ON LCM OR XSM.
*        RECOVERY OF THE FIRST BLOCK.
         IF(IND.EQ.2) CALL XABORT('DRVUTL: ADD IS A FORBIDDEN OPERATIO'
     1   //'N IN READ-ONLY MODE.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT2,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         CALL LCMLEN(IPLIST,NAMT,ILONG1,IT1BLK)
         IF(ILONG1.EQ.-1) THEN
*           ADD TWO DIRECTORIES.
            NUNIT=KDROPN('DUMMYSQ',0,2,0,0)
            IF(NUNIT.LE.0) CALL XABORT('DRVUTL: KDROPN FAILURE.')
            CALL LCMEXP(IPLIST,0,NUNIT,1,1)
            REWIND(NUNIT)
            CALL LCMOP(IPLIS1,'DUMMYDA',0,1,0)
            CALL LCMEXP(IPLIS1,0,NUNIT,1,2)
            IRC=KDRCLS(NUNIT,2)
            IF(IRC.LT.0) CALL XABORT('DRVUTL: KDRCLS FAILURE.')
            CALL LCMSIX(IPLIS1,NAMT,1)
            CALL LCMSIX(IPLIST,NAMT2,1)
            CALL LCMADD(IPLIS1,IPLIST)
            CALL LCMSIX(IPLIS1,' ',2)
            CALL LCMSIX(IPLIST,' ',2)
            CALL LCMCL(IPLIS1,2)
         ELSE IF(ILONG1.GT.0) THEN
*           ADD TWO RECORDS.
            IF(IT1BLK.NE.2) CALL XABORT('DRVUTL: '''//NAMT//''' IS NOT'
     1      //' OF REAL TYPE.')
            CALL SETARA(BASE,ILONG1,INAMT1)
            CALL LCMGET(IPLIST,NAMT,BASE(INAMT1))
            CALL LCMLEN(IPLIST,NAMT2,ILONG2,IT2BLK)
            IF(ILONG2.NE.ILONG1) THEN
               CALL XABORT('DRVUTL: THE 2 BLOCKS ARE OF DIFFERENT LENGT'
     1         //'H.')
            ELSE IF(IT1BLK.NE.IT2BLK) THEN
               CALL XABORT('DRVUTL: THE 2 BLOCKS ARE OF DIFFERENT TYPE'
     1         //'S.')
            ENDIF
            CALL SETARA(BASE,ILONG2,INAMT2)
            CALL LCMGET(IPLIST,NAMT2,BASE(INAMT2))
            DO 60 I=1,ILONG2
   60       BASE(INAMT2+I-1)=BASE(INAMT1+I-1)+BASE(INAMT2+I-1)
            CALL LCMPUT(IPLIST,NAMT2,ILONG2,IT1BLK,BASE(INAMT2))
            CALL RLSARA(BASE(INAMT2))
            CALL RLSARA(BASE(INAMT1))
         ELSE IF(ILONG1.EQ.0) THEN
            CALL XABORT('DRVUTL: '''//NAMT//''' IS NOT STORED.')
         ENDIF
      ELSE IF(TEXT4.EQ.'MULT') THEN
*        MULTIPLY AN LCM OR XSM BLOCK OR DIRECTORY BY A CONSTANT.
*        RECOVERY OF A BLOCK OR DIRECTORY.
         IF(IND.EQ.2) CALL XABORT('DRVUTL: MULT IS A FORBIDDEN OPERATIO'
     1   //'N IN READ-ONLY MODE.')
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
*        READ A NUMBER.
         CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
         IF(INDIC.EQ.3) CALL XABORT('DRVUTL: INTEGER OR REAL NUMBER EX'
     1   //'PECTED.')
         IF(INDIC.EQ.1) FLOTT=REAL(NITMA)
         CALL LCMLEN(IPLIST,NAMT,ILONG1,ITYBLK)
         IF(ILONG1.EQ.-1) THEN
*           MULTIPLY A DIRECTORY FLOATTING CONTENT BY A REAL NUMBER.
            CALL LCMSIX(IPLIST,NAMT,1)
            CALL LCMULT(IPLIST,FLOTT)
            CALL LCMSIX(IPLIST,' ',2)
         ELSE IF(ILONG1.GT.0) THEN
*           MULTIPLY A REAL RECORD BY A REAL NUMBER.
            IF(ITYBLK.NE.2) CALL XABORT('DRVUTL: '''//NAMT//''' IS NOT'
     1      //' OF REAL TYPE.')
            CALL SETARA(BASE,ILONG1,INAMT1)
            CALL LCMGET(IPLIST,NAMT,BASE(INAMT1))
            DO 90 I=1,ILONG1
   90       BASE(INAMT1+I-1)=BASE(INAMT1+I-1)*FLOTT
            CALL LCMPUT(IPLIST,NAMT,ILONG1,ITYBLK,BASE(INAMT1))
            CALL RLSARA(BASE(INAMT1))
         ELSE IF(ILONG1.EQ.0) THEN
            CALL XABORT('DRVUTL: '''//NAMT//''' IS NOT STORED.')
         ENDIF
      ELSE IF(TEXT4.EQ.'STEP') THEN
*        CHANGE THE HIERARCHICAL LEVEL ON THE LCM OR XSM FILE.
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECTED.')
         IF(TEXT4.EQ.'UP') THEN
            CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
            IF(INDIC.NE.3) CALL XABORT('DRVUTL: CHARACTER DATA EXPECT'
     1      //'ED.')
            WRITE (6,190) NAMT
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) CALL XABORT('DRVUTL: MAXLEV OVERFLOW.')
            IPLIST=LCMGID(IPLIST,NAMT)
            IPKEEP(ILEV)=IPLIST
         ELSE IF(TEXT4.EQ.'AT') THEN
            CALL REDGET(INDIC,NITMA,FLOTT,NAMT,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('DRVUTL: INTEGER DATA EXPECTED.')
            WRITE (6,195) NITMA
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) CALL XABORT('DRVUTL: MAXLEV OVERFLOW.')
            IPLIST=LCMGIL(IPLIST,NITMA)
            IPKEEP(ILEV)=IPLIST
         ELSE IF(TEXT4.EQ.'DOWN') THEN
            WRITE (6,'(/35H DRVUTL: STEP DOWN TO PARENT LEVEL.)')
            ILEV=ILEV-1
            IF(ILEV.LT.1) CALL XABORT('DRVUTL: TOO MANY STEPS DOWN.')
            IPLIST=IPKEEP(ILEV)
         ELSE IF(TEXT4.EQ.'ROOT') THEN
            WRITE (6,'(/33H DRVUTL: STEP DOWN TO ROOT LEVEL.)')
            ILEV=1
            IPLIST=IPKEEP(1)
         ENDIF
      ELSE IF(TEXT4.EQ.'DIR') THEN
*        PRINT THE DIRECTORY OF THE ACTIVE LEVEL.
         CALL LCMLIB(IPLIST)
      ELSE IF(TEXT4.EQ.'DUMP') THEN
*        DUMP THE ACTIVE AND SON DIRECTORIES ON THE PRINTER.
         CALL LCMEXP(IPLIST,0,6,2,1)
      ELSE IF(TEXT4.EQ.';') THEN
         CALL LCMINF(IPLIST,NAMLCM,NAMMY,EMPTY,ILONG,LCM)
         WRITE(6,260) NAMMY
         RETURN
      ELSE
         WRITE(HSMG,'(8HDRVUTL: ,A4,30H IS AN INVALID UTILITY ACTION.)
     1   ') TEXT4
         CALL XABORT(HSMG)
      ENDIF
      GO TO 15
*
  180 FORMAT (/36H DRVUTL: PERFORM UTILITY ACTIONS ON ,A11,8H NAMED ',
     1 A12,10H' OPEN IN ,A9,29H MODE WITH ACTIVE DIRECTORY ',A12,2H'.)
  190 FORMAT (/27H DRVUTL: STEP UP TO LEVEL ',A12,2H'.)
  195 FORMAT (/27H DRVUTL: STEP AT COMPONENT ,I5,1H.)
  200 FORMAT (/17H DRVUTL: COMPARE ,A8,26H ERRORS OF THE TWO BLOCKS:/)
  210 FORMAT (/5H LEN=,I6,5X,7HEPSMAX=,F8.2,15H % IN COMPONENT,I6/16X,
     1 7HEPSAVG=,F8.2,2H %)
  220 FORMAT (/5H LEN=,I6,5X,7HEPSMAX=,E10.5,13H IN COMPONENT,I6/16X,
     1 7HEPSAVG=,E10.5)
  225 FORMAT (/29H DRVUTL: CONTENT OF COMPONENT,I6,5X,8HLENGTH =,I10,
     1 5X,26HNUMBER OF NON ZERO TERMS =,I10/)
  230 FORMAT (/27H DRVUTL: CONTENT OF BLOCK ',A12,1H',5X,8HLENGTH =,
     1 I10,5X,26HNUMBER OF NON ZERO TERMS =,I10/)
  240 FORMAT (/16H DRVUTL: BLOCK ',A12,21H' IS OF UNKNOWN TYPE./)
  245 FORMAT (/18H DRVUTL: COMPONENT,I6,27H IS NOT STORED ON THE CURRE,
     1 20HNT LCM OR XSM LEVEL./)
  250 FORMAT (/16H DRVUTL: BLOCK ',A12,28H' IS NOT STORED ON THE CURRE,
     1 20HNT LCM OR XSM LEVEL./)
  260 FORMAT (/40H DRVUTL: LEAVING WITH ACTIVE DIRECTORY ',A12,2H'.)
      END
