      FUNCTION     KDRCLN( IPTRUN, IPRINT )
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *KDRCLN* IS USED TO CLEAN NON-DUMMY ARGUMENTS 
C                      AFTER PROCEDURE ENDING.
C
C      INPUT: *IPTRUN* IS THE EXEC STRUCTURE POINTER (ALLOCATED)
C             *IPRINT* IS THE PRINTING INDEX (=0 FOR NO PRINT)
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      INTEGER      KDRCLN
      INTEGER      IPTRUN
      INTEGER      IPRINT
C
      INTEGER      NDCLKW, IWRITE
      PARAMETER  ( NDCLKW= 8, IWRITE= 6)
      LOGICAL      LCATRU, LCAFAL
      PARAMETER  ( LCATRU=.TRUE., LCAFAL=.FALSE. )
      INTEGER      KDROPN, KDRCLS
      INTEGER      IPARAM, JPARAM, KPARAM, JDISPE, IRETCD
      CHARACTER*12 HPARAM, RECNAM, OBJ1ST, CDCLKW(NDCLKW)
      INTEGER      LCMNAM(18)
C
      DATA CDCLKW  
     1   /'PROCEDURE   ','MODULE      ','LINKED_LIST ','XSM_FILE    ',
     2    'SEQ_BINARY  ','SEQ_ASCII   ','DIR_ACCESS  ','PARAMETER   ' /
C
      KDRCLN= 0
C
      RECNAM=' '
      CALL LCMNXT(IPTRUN,RECNAM)
      OBJ1ST= RECNAM
   10 CONTINUE
C
      IF( RECNAM(1:1).NE.'!' )THEN
         CALL LCMSIX(IPTRUN,RECNAM,1)
         IF( IPRINT.GT.0 )THEN
            WRITE(IWRITE,*)' KDRCLN: CLEANING FOR '//RECNAM
         ENDIF
         CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
         CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
         CALL LCMCAR(HPARAM, LCAFAL ,LCMNAM)
         CALL LCMGET(IPTRUN,'JPARAM',JPARAM)
         IF( JPARAM.EQ.-1 .AND.
     1       (ABS(IPARAM).GE.3.AND.ABS(IPARAM).LT.NDCLKW) )THEN
            IF( IPARAM.GT.0 )THEN
               JDISPE= 1
C
C              DESTROY OBJECT
               IF( IPARAM.EQ.3.OR.IPARAM.EQ.4 )THEN
                  CALL LCMGET(IPTRUN,'KPARAM',KPARAM)
                  CALL LCMOP (KPARAM,RECNAM,JDISPE,IPARAM-2,0)
                  CALL LCMCL (KPARAM,2)
               ELSEIF( IPARAM.EQ.5.OR.IPARAM.EQ.6.OR.IPARAM.EQ.7 )THEN
                  KPARAM= KDROPN( HPARAM,JDISPE,IPARAM-3,0,0 )
                  IF( KPARAM.LE.0 )THEN
                     WRITE(IWRITE,'(28HKDRCLN: KDROPN FAILURE. IRC=,
     1                  I3,9H ON FILE ,A12,5H (2).)') KPARAM,HPARAM
                     WRITE(IWRITE,*)'KDRCLN: CANNOT OPEN FILE *'//
     1                  RECNAM//'*'
                     KDRCLN= -1
                     GO TO 666
                  ENDIF
                  IRETCD= KDRCLS( KPARAM,2 )
                  IF( IRETCD.LT.0 )THEN
                     WRITE(IWRITE,'(29HKDRCLN: KDRCLS FAILURE. IERR=,
     1                  I3,7H NUNIT=,I5,1H ,A12)') IRETCD,KPARAM,
     2                  CDCLKW(IPARAM)
                     WRITE(IWRITE,*)'KDRCLN: CANNOT DESTROY FILE *'//
     1                  RECNAM//'*'
                     KDRCLN= -1
                     GO TO 666
                  ENDIF
               ENDIF
C
               IF( IPRINT.GT.0 )THEN
                  WRITE(IWRITE,*) ' KDRCLN: DEL '//
     1                       CDCLKW(IPARAM)//' *'//
     2                       RECNAM//'* (WILL NEVER EXIST ANYMORE)'
               ENDIF
               IPARAM= -IPARAM
               CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
            ELSE
               IF( IPRINT.GT.1 )THEN
                  WRITE(IWRITE,*) ' KDRCLN: DEL '//
     1                       CDCLKW(-IPARAM)//' *'//
     2                       RECNAM//'* (WAS NOT DEFINED ANYWAY)'
               ENDIF
            ENDIF
         ENDIF
         CALL LCMSIX(IPTRUN,' ',2)
      ENDIF
      CALL LCMNXT(IPTRUN,RECNAM)
      IF( RECNAM.NE.OBJ1ST ) GO TO 10
  666 RETURN
      END
