*DECK KDRCPU
#if defined(F90)
      SUBROUTINE KDRCPU(CPUSEC)
!
!-----------------------------------------------------------------------
!
! SYSTEM CLOCK.
!
! OUTPUT PARAMETER:
!  CPUSEC : NUMBER OF SECONDS ELAPSED SINCE THE FIRST CALL TO KDRCPU.
!
!---------------------------------------------- A. HEBERT ; 09/09/94 ---
!
      INTEGER :: ITLOC,IRATE
      INTEGER,SAVE :: ISAVE=0,ITLOC0
!
      IF(ISAVE==0) THEN
         CALL SYSTEM_CLOCK(COUNT=ITLOC0)
         ISAVE=1
      ENDIF
      CALL SYSTEM_CLOCK(COUNT=ITLOC,COUNT_RATE=IRATE)
      CPUSEC=REAL(ITLOC-ITLOC0)/REAL(IRATE)
      RETURN
      END
#elif defined(Linux) || defined(MSDOS)
      SUBROUTINE KDRCPU(CPUSEC)
      INTEGER time
      SAVE ISAVE,ITLOC0
      DATA ISAVE/0/
      IF(ISAVE.EQ.0) THEN
         ITLOC0=Time()
         ISAVE=1
      ENDIF
      ITLOC=Time()-ITLOC0
      CPUSEC=REAL(ITLOC)
      RETURN
      END
#elif defined(Unix)
      SUBROUTINE KDRCPU(CPUSEC)
      INTEGER time
      SAVE ISAVE,ITLOC0
      DATA ISAVE/0/
      IF(ISAVE.EQ.0) THEN
         ITLOC0=time(%VAL(0))
         ISAVE=1
      ENDIF
      ITLOC=time(%VAL(0))-ITLOC0
      CPUSEC=REAL(ITLOC)
      RETURN
      END
#elif defined(MVS)
      SUBROUTINE KDRCPU(CPUSEC)
      INTEGER IRCODE
      REAL*8  ACUCPU
      REAL    CPUSEC
      CALL CPUTIME(ACUCPU,IRCODE)
      IF(IRCODE.EQ.0) THEN
        CPUSEC=ACUCPU*1.0D-6
      ELSE
        CPUSEC=0.0
      ENDIF
      RETURN
      END
#elif defined(NOSBE)
      SUBROUTINE KDRCPU(CPUSEC)
      CPUSEC=SECOND()
      RETURN
      END
#elif defined(CRAY)
      SUBROUTINE KDRCPU(CPUSEC)
      CALL SECOND(CPUSEC)
      RETURN
      END
#elif defined(MACAB)
      SUBROUTINE KDRCPU(CPUSEC)
      CPUSEC=SECNDS(0.0)
      RETURN
      END
#elif defined(MACLS)
      SUBROUTINE KDRCPU(CPUSEC)
      CPUSEC=SECNDS(0.0)
      RETURN
      END
#elif defined(VMS)
      SUBROUTINE KDRCPU(CPUSEC)
C     ****************************************************************
C     RETURN CURRENT CP TIME.
C     VAX/VMS/FORTRAN-77
C     **************************************************************
      IMPLICIT INTEGER*2 (W)
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER JPI$_CPU='00000407'X
      PARAMETER JPI$_CPL='0000040D'X
      PARAMETER JPI$_BFR='0000040C'X
      PARAMETER JPI$_DRC='0000040B'X
      PARAMETER JPI$_PGF='0000040A'X
      DIMENSION LTIMES(6)
      COMMON /TIMCOM/ WLEN1, WCODE1, LADDR1, LENAD1,
     1                WLEN2, WCODE2, LADDR2, LENAD2,
     2                WLEN3, WCODE3, LADDR3, LENAD3,
     3                WLEN4, WCODE4, LADDR4, LENAD4,
     4                WLEN5, WCODE5, LADDR5, LENAD5
     5                WLEN6, WCODE6
      DATA WLEN1,WLEN2,WLEN3,WLEN4,WLEN5,WLEN6/4,4,4,4,4,4/
      DATA LENAD1,LENAD2,LENAD3,LENAD4,LENAD5/0,0,0,0,0/
      DATA WCODE1 /JPI$_CPU/
      DATA WCODE2 /JPI$_CPL/
      DATA WCODE3 /JPI$_BFR/
      DATA WCODE4 /JPI$_DRC/
      DATA WCODE5 /JPI$_PGF/
      DATA WCODE6 /0/
C
      LADDR1=%LOC(LTIMES(1))
      LADDR2=%LOC(LTIMES(2))
      LADDR3=%LOC(LTIMES(3))
      LADDR4=%LOC(LTIMES(4))
      LADDR5=%LOC(LTIMES(5))
C
      CALL SYS$GETJPI(,,,WLEN1,,,)
      CPUSEC=LTIMES(1)/100.
      RETURN
      END
#else
      SUBROUTINE KDRCPU(CPUSEC)
      CPUSEC=0.0
      RETURN
      END
#endif
