      FUNCTION KDRDDA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *KDRDDA* IS THE MODULE FOR *DIR_ACCESS  * DECLARATIONS
C                      =0 IF NO ERROR
C
C      INPUT: *NENTRY* IS THE # OF LINKED LISTS AND FILES USED.
C             *HENTRY* NAMES OF EACH OBJECT <- LINKED LIST OR FILE.
C                      ( CHARACTER*12 HENTRY(NENTRY) )
C             *IENTRY* TYPES OF EACH OBJECT ( INTEGER IENTRY(NENTRY) )
C                      =1 LINKED LIST; 
C                      =2 XSM FILE;
C                      =3 SEQUENTIAL BINARY FILE; 
C                      =4 SEQUENTIAL ASCII FILE;
C                      =5 DIRECT ACCESS FILE.
C             *JENTRY* MODES OF EACH OBJECT ( INTEGER JENTRY(NENTRY) )
C                      =0 THE OBJECT IS CREATED;
C                      =1 THE OBJECT IS OPENED FOR MODIFICATIONS;
C                      =2 THE OBJECT IS OPENED IN READ-ONLY MODE.
C             *KENTRY* POINTERS TO OBJECTS ( INTEGER KENTRY(NENTRY) )
C                      =FILE UNIT NUMBER; 
C                      =LINKED LIST ADDRESS OTHERWISE.
C
      IMPLICIT         NONE
C
      INTEGER          KDRDDA
      INTEGER          NENTRY
      CHARACTER        HENTRY(NENTRY)*12
      INTEGER          IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C
C     VARIABLES FOR *REDGET*
      INTEGER          ITYP, NITMA
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      CHARACTER*72     TEXT
C
      LOGICAL          LNDATA, LNFILE, LEXIST
      INTEGER          IPTRUN, ILOOP1, IPARAM, LPARAM, IPRINT
      INTEGER          LCMNAM(18)
      LOGICAL          LCATRU, LCAFAL
      PARAMETER      ( LCATRU=.TRUE., LCAFAL=.FALSE. )
      CHARACTER*12     CSEMIC, CEDIT,  CFILE, CRECL
      CHARACTER*72     MESSAG, FILENM
      INTEGER          IWRITE
      PARAMETER      ( IWRITE= 6 )
      DATA CSEMIC,CEDIT,CFILE,CRECL
     1   / ';           ','EDIT        ','FILE        ','RECL        '/
C
      KDRDDA= 0
C
      IPRINT= 0
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
      LNDATA= ITYP.NE.10.AND.(ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC)
      IF( LNDATA )THEN
         IF( ITYP.EQ.3 )THEN
            IF( TEXT(1:12).EQ.CEDIT )THEN
               CALL REDGET(ITYP,IPRINT,FLOTT,TEXT,DFLOT)
               IF( ITYP.NE.1.AND.IPRINT.LT.0 )THEN
                  MESSAG= 'KDRDDA: AFTER *EDIT*, PUT A POSITIVE INT'
                  WRITE(IWRITE,'(A72)') MESSAG
                  KDRDDA= -1
                  GO TO 666 
               ENDIF
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            ENDIF
            IF( TEXT(1:12).EQ.CFILE )THEN
               LNFILE=.TRUE.
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            ELSE
               LNFILE=.FALSE.
            ENDIF
            IF( TEXT(1:12).NE.CRECL )THEN
               MESSAG= 'KDRDDA: KEYWORD *RECL* MUST BE THERE'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRDDA= -2
               GO TO 666
            ENDIF
         ELSE
            MESSAG= 'KDRDDA: INVALID INPUT'
            WRITE(IWRITE,'(A72)') MESSAG
            KDRDDA= -3
            GO TO 666
         ENDIF
      ENDIF
      DO 100 ILOOP1= 1, NENTRY
         IPTRUN= KENTRY(ILOOP1)
         IPARAM= IENTRY(ILOOP1)
         IF( ABS(IPARAM).NE.7 ) GO TO 8001
         IF( LNDATA )THEN
            LPARAM= 0
            FILENM= CSEMIC
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            IF( ITYP.EQ.1 ) LPARAM= NITMA
            IF( ITYP.EQ.3 ) FILENM= TEXT
            IF( LNFILE )THEN
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
               IF( ITYP.EQ.1 ) LPARAM= NITMA
               IF( ITYP.EQ.3 ) FILENM= TEXT
            ENDIF
            IF( LPARAM.LE.0 )THEN
               MESSAG= 'KDRDDA: INVALID VALUE FOR *RECL*'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRDDA= -4
               GO TO 666
            ELSE
C
C              REGISTER RECORD LENGTH OF EACH DA FILES
               CALL LCMPUT(IPTRUN,'LPARAM',1,1,LPARAM)
            ENDIF
            IF( LNFILE )THEN
               IF( FILENM(1:12).EQ.CSEMIC )THEN
                  MESSAG= 'KDRDDA: INVALID FILE NAME'
                  WRITE(IWRITE,'(A72)') MESSAG
                  KDRDDA= -5
                  GO TO 666
               ENDIF
               INQUIRE(FILE=FILENM, EXIST=LEXIST)
C
C              DEFINE EXISTENCE MODE
               IF( LEXIST )THEN
                  IF( IPRINT.NE.0 )THEN
                     WRITE(IWRITE,'(A8,A72)') 'OLD/DA: ',TEXT
                  ENDIF
                  IF( IPARAM.LT.0 )THEN
                     IENTRY(ILOOP1)= -IPARAM
                  ENDIF
                  JENTRY(ILOOP1)= 2
               ELSE
                  IF( IPRINT.NE.0 )THEN
                     WRITE(IWRITE,'(A8,A72)') 'NEW/DA: ',TEXT
                  ENDIF
                  IF( IPARAM.GT.0 )THEN
                     IENTRY(ILOOP1)= -IPARAM
                  ENDIF
                  JENTRY(ILOOP1)= 0
               ENDIF
C
C              REGISTER FILE NAME
               CALL LCMCAR(TEXT, LCATRU ,LCMNAM)
               CALL LCMPUT(IPTRUN,'HPARAM',18,3,LCMNAM)
            ENDIF
         ELSE
C
C           ONLY VERIFY IF *RECL* MAKES SENSE FOR A DEFINED DA
            IF( IPARAM.GT.0 )THEN
               CALL LCMGET(IPTRUN,'LPARAM',LPARAM)
               IF( LPARAM.LE.0 )THEN
                  MESSAG= 'KDRDDA: INVALID VALUE FOR *RECL*'
                  WRITE(IWRITE,'(A72)') MESSAG
                  KDRDDA= -6
                  GO TO 666
               ENDIF
            ENDIF
         ENDIF
  100 CONTINUE
C
C     CAN WE FOUND *;* AT THE END OF THE SENTENCE ?
      IF( LNDATA )THEN   
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
         IF( ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC )GO TO 8002
      ENDIF
  666 RETURN
C
 8001 MESSAG='KDRDDA: INVALID TYPE IN *DIR_ACCESS  * DATA.'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDDA=8001
      GO TO 666
 8002 MESSAG='KDRDDA: INVALID END  IN *DIR_ACCESS  * DATA.'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDDA=8002
      GO TO 666
      END
