      FUNCTION KDRDPR(CMODXT,NMODXT,
     1                CLECST,NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *KDRDPR* IS THE MODULE FOR *PROCEDURE   * DECLARATIONS
C                      =0 IF NO ERROR
C
C      INPUT: *CMODXT* IS THE LIST OF NAMES FOR CODE-DEPENDENT MODULES
C                      ( CHARACTER*12 CMODXT(1:NMODXT) )DEFINED VALUES
C             *NMODXT* IS THE NUMBER OF CODE-DEPENDENT MODULES
C             *CLECST* IS THE USER-DEFINED ROUTINE FOR CLE-2000 PARMS
C             *NENTRY* IS THE # OF LINKED LISTS AND FILES USED.
C             *HENTRY* NAMES OF EACH OBJECT <- LINKED LIST OR FILE.
C                      ( CHARACTER*12 HENTRY(NENTRY) )
C             *IENTRY* TYPES OF EACH OBJECT ( INTEGER IENTRY(NENTRY) )
C                      =1 LINKED LIST; 
C                      =2 XSM FILE;
C                      =3 SEQUENTIAL BINARY FILE; 
C                      =4 SEQUENTIAL ASCII FILE;
C                      =5 DIRECT ACCESS FILE.
C             *JENTRY* MODES OF EACH OBJECT ( INTEGER JENTRY(NENTRY) )
C                      =0 THE OBJECT IS CREATED;
C                      =1 THE OBJECT IS OPENED FOR MODIFICATIONS;
C                      =2 THE OBJECT IS OPENED IN READ-ONLY MODE.
C             *KENTRY* POINTERS TO OBJECTS ( INTEGER KENTRY(NENTRY) )
C                      =FILE UNIT NUMBER; 
C                      =LINKED LIST ADDRESS OTHERWISE.
C
C     SYNTAX: 
C              PROCEDURE *HENTRY(I=1,NENTRY)* ;
C                (DEFAULT VALUES, CHECK EXISTENCE)
C
C              PROCEDURE *HENTRY(I=1,NENTRY)* :: *DATA* ;
C                (USER DEFINED VALUES, ACCESS TO CLE-2000 COMPILER)
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT         NONE
C
      INTEGER          KDRDPR
      INTEGER          NENTRY,NMODXT
      CHARACTER*12     CMODXT(NMODXT)
      INTEGER          CLECST
      EXTERNAL         CLECST
      CHARACTER        HENTRY(NENTRY)*12
      INTEGER          IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C
C     VARIABLES FOR *REDGET*
      INTEGER          ITYP, NITMA
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      CHARACTER*72     TEXT
C
C     CLE-2000/GAN-2000 COMPILING ROUTINES
      INTEGER          CLEPIL, OBJPIL
      LOGICAL          LNDATA
      INTEGER          IPTRUN, ILOOP1, IPARAM
      CHARACTER*72     FILENM, FILINP, FILOBJ, FILOUT, MESSAG
      INTEGER          KDROPN, KDRCLS
      INTEGER          IRETCD, JTYP
      LOGICAL          LEXIST
      LOGICAL          LCATRU, LCAFAL
      PARAMETER      ( LCATRU=.TRUE., LCAFAL=.FALSE. )
C
C     VARIABLES FOR FILE ACCESS
      INTEGER          ICOUT,ICINP,ICOBJ,IWRITE,LRCLEN
      PARAMETER      ( IWRITE=6, LRCLEN=30 )
C
C     FILE EXTENSIONS
      INTEGER          LCMNAM(18)
      CHARACTER*4      CSINP,CSOBJ,CSOUT
      CHARACTER*12     CSEMIC
      DATA CSINP, CSOBJ, CSOUT, CSEMIC
     1   / '.c2m','.o2m','.l2m',';           '/
C
      KDRDPR= 0
C
      IF( NENTRY.LE.0 ) GO TO 666
C
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
      LNDATA= ITYP.NE.10.AND.(ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC)
      IF( LNDATA )THEN
         MESSAG='KDRDPR: NOT DEVELOPED YET (RR)'
         WRITE(IWRITE,'(A72)') MESSAG
         KDRDPR= -666
         GO TO 666
      ENDIF
      DO 100 ILOOP1= 1, NENTRY
         IPTRUN= KENTRY(ILOOP1)
         IPARAM= IENTRY(ILOOP1)
         IF( LNDATA )THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            IF( ITYP.EQ.3 )THEN
               FILENM= TEXT(1:12)
            ELSE
               GO TO 8001
            ENDIF           
         ELSE
            CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
            CALL LCMCAR(FILENM, LCAFAL ,LCMNAM)
         ENDIF
C
         JTYP= INDEX(FILENM,' ')-1
         IF( IPARAM.EQ.+1 )THEN
C
C           ONLY VERITY IF *FILENM* EXISTS
            INQUIRE( FILE=FILENM, EXIST= LEXIST )
            IF( .NOT.LEXIST )THEN
               MESSAG= '* KDRDPR: OBJECT FILE *'//FILENM(1:JTYP)//
     1                 '* DOES NOT EXIST: MUST BE COMPILED'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRDPR= -1
               GO TO 666
            ENDIF
         ELSE
         IF( JTYP.EQ.-1.OR.JTYP.GT.68 ) GO TO 9009
         FILINP= FILENM(1:JTYP)//CSINP
         FILOBJ= FILENM(1:JTYP)//CSOBJ
         FILOUT= FILENM(1:JTYP)//CSOUT
         INQUIRE( FILE=FILOBJ, EXIST=LEXIST )
         IF( .NOT.LEXIST )THEN
            WRITE(IWRITE,*) 'KDRDPR: COMPILING *PROC= ',HENTRY(ILOOP1)
            WRITE(IWRITE,*) '                   NAME= ',FILENM(1:JTYP)
C
C           GO FOR COMPILATION
C           OPEN OUTPUT FILE (UNKNOWN) SUFFIX IS '.l2m'
            ICOUT= KDROPN(FILOUT,0,3,0,0)
            IF( ICOUT.LE.0 ) GO TO 9007
C
C           CREATE OBJECT FILE SUFFIX IS '.o2m'
            ICOBJ= KDROPN(FILOBJ,0,4,LRCLEN,0)
            IF( ICOBJ.LE.0 ) GO TO 9001
C
C           OPEN SOURCE FILE (READ-ONLY) SUFFIX IS '.c2m'
            ICINP= KDROPN(FILINP,2,3,0,0)
            IF( ICINP.LE.0 ) GO TO 9003
C
C           COMPILE NEW FUNCTION
            IRETCD= CLEPIL(ICINP,ICOUT,ICOBJ,CLECST)
            IF( IRETCD.NE.0 )THEN
               WRITE(IWRITE,'(A72)') FILENM
               MESSAG='* KDRDPR: COMPILING PREVIOUS PROC (ERROR CODE)'
               WRITE(IWRITE,'(A72,4HIRC=,I4)') MESSAG,IRETCD
               KDRDPR=-2
               GO TO 666
            ENDIF
C
C           ADD OBJECTS/MODULES TO OBJECT FILE
            IRETCD= OBJPIL(ICOBJ,ICOUT,CMODXT,NMODXT)
            IF( IRETCD.NE.0 )THEN
               WRITE(IWRITE,'(A72)') FILENM
               MESSAG='* KDRDPR: INVALID OBJ IN PREVIOUS PROC (ERROR)'
               WRITE(IWRITE,'(A72,4HIRC=,I4)') MESSAG,IRETCD
               KDRDPR=-3
               GO TO 666
            ENDIF
C
C           CLOSE & KEEP SOURCE, OUTPUT & OBJECT FILES
            IRETCD= KDRCLS(ICINP,1)
            IF( IRETCD.NE.0 )GO TO 9004
            IRETCD= KDRCLS(ICOUT,1)
            IF( IRETCD.NE.0 )GO TO 9008
            IRETCD= KDRCLS(ICOBJ,1)
            IF( IRETCD.NE.0 )GO TO 9002
         ENDIF
            IENTRY(ILOOP1)=-IPARAM
            CALL LCMCAR(FILOBJ, LCATRU ,LCMNAM)
            CALL LCMPUT(IPTRUN,'HPARAM',18,3,LCMNAM)
         ENDIF
  100 CONTINUE
C
C     CAN WE FOUND *;* AT THE END OF THE SENTENCE ?
      IF( LNDATA )THEN   
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
         IF( ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC )GO TO 8002
      ENDIF
  666 RETURN
C
 8001 MESSAG='KDRDPR: INVALID TYPE IN *PROCEDURE* DATA.'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=8001
      GO TO 666
 8002 MESSAG='KDRDPR: INVALID END  IN *PROCEDURE* DATA.'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=8002
      GO TO 666
 9000 WRITE(IWRITE,'(A72)') FILENM
      MESSAG='KDRDPR: PROBLEM WITH PREVIOUS FILE NAME'
      WRITE(IWRITE,'(A72)') MESSAG
      GO TO 666
 9001 MESSAG='KDRDPR: ERROR WHEN OPENING OBJECT FILE *.o2m'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9001
      GO TO 9000
 9002 MESSAG='KDRDPR: ERROR WHEN CLOSING OBJECT FILE *.o2m'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9002
      GO TO 9000
 9003 MESSAG='KDRDPR: ERROR WHEN OPENING SOURCE FILE *.c2m'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9003
      GO TO 9000
 9004 MESSAG='KDRDPR: ERROR WHEN CLOSING SOURCE FILE *.c2m'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9004
      GO TO 9000
 9007 MESSAG='KDRDPR: ERROR WHEN OPENING OUTPUT FILE *.l2m'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9007
      GO TO 9000
 9008 MESSAG='KDRDPR: ERROR WHEN CLOSING OUTPUT FILE *.l2m'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9008
      GO TO 9000
 9009 MESSAG='KDRDPR: THIS FILE NAME IS INVALID'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDPR=9009
      GO TO 9000
      END
