      FUNCTION KDRDXF(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *KDRDXF* IS THE MODULE FOR *XSM_FILE    * DECLARATIONS
C                      =0 IF NO ERROR
C
C      INPUT: *NENTRY* IS THE # OF LINKED LISTS AND FILES USED.
C             *HENTRY* NAMES OF EACH OBJECT <- LINKED LIST OR FILE.
C                      ( CHARACTER*12 HENTRY(NENTRY) )
C             *IENTRY* TYPES OF EACH OBJECT ( INTEGER IENTRY(NENTRY) )
C                      =1 LINKED LIST; 
C                      =2 XSM FILE;
C                      =3 SEQUENTIAL BINARY FILE; 
C                      =4 SEQUENTIAL ASCII FILE;
C                      =5 DIRECT ACCESS FILE.
C             *JENTRY* MODES OF EACH OBJECT ( INTEGER JENTRY(NENTRY) )
C                      =0 THE OBJECT IS CREATED;
C                      =1 THE OBJECT IS OPENED FOR MODIFICATIONS;
C                      =2 THE OBJECT IS OPENED IN READ-ONLY MODE.
C             *KENTRY* POINTERS TO OBJECTS ( INTEGER KENTRY(NENTRY) )
C                      =FILE UNIT NUMBER; 
C                      =LINKED LIST ADDRESS OTHERWISE.
C
      IMPLICIT         NONE
C
      INTEGER          KDRDXF
      INTEGER          NENTRY
      CHARACTER        HENTRY(NENTRY)*12
      INTEGER          IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C
C     VARIABLES FOR *REDGET*
      INTEGER          ITYP, NITMA
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      CHARACTER*72     TEXT
C
      LOGICAL          LNDATA,LEXIST
      INTEGER          IPTRUN, ILOOP1, IPARAM, IPRINT
      INTEGER          LCMNAM(18)
      LOGICAL          LCATRU, LCAFAL
      PARAMETER      ( LCATRU=.TRUE., LCAFAL=.FALSE. )
      CHARACTER*12     CSEMIC,CEDIT,CFILE
      CHARACTER*72     MESSAG
      INTEGER          IWRITE
      PARAMETER      ( IWRITE= 6 )
      DATA CSEMIC,CEDIT,CFILE
     1    / ';           ','EDIT        ','FILE        '/
C
      KDRDXF= 0
C
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
      LNDATA= ITYP.NE.10.AND.(ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC)
      IF( LNDATA )THEN
         IF( ITYP.EQ.3 )THEN
            IF( TEXT(1:12).EQ.CEDIT )THEN
               CALL REDGET(ITYP,IPRINT,FLOTT,TEXT,DFLOT)
               IF( ITYP.NE.1.AND.IPRINT.LT.0 )THEN
                  MESSAG= 'KDRDXF: AFTER *EDIT*, PUT A POSITIVE INT'
                  WRITE(IWRITE,'(A72)') MESSAG
                  KDRDXF= -1
                  GO TO 666 
               ENDIF
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            ENDIF
            IF( TEXT(1:12).NE.CFILE )THEN
               MESSAG= 'KDRDXF: EXPECTING *FILE* KEYWORD'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRDXF= -2
               GO TO 666                
            ENDIF
         ELSE
            MESSAG= 'KDRDXF: INVALID INPUT'
            WRITE(IWRITE,'(A72)') MESSAG
            KDRDXF= -666
            GO TO 666
         ENDIF
      ENDIF
      DO 100 ILOOP1= 1, NENTRY
         IPARAM= IENTRY(ILOOP1)
         IF( ABS(IPARAM).NE.4 ) GO TO 8001
         IF( LNDATA )THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            IF( ITYP.NE.3 )THEN
               MESSAG= 'KDRDXF: INVALID FILE NAME'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRDXF= -666
               GO TO 666
            ENDIF
            INQUIRE(FILE=TEXT, EXIST=LEXIST)
C
C           DEFINE EXISTENCE MODE
            IF( LEXIST )THEN
               IF( IPRINT.NE.0 )THEN
                  WRITE(IWRITE,'(A8,A72)') 'OLD/XF: ',TEXT
               ENDIF
               IF( IPARAM.LT.0 )THEN
                  IENTRY(ILOOP1)= -IPARAM
               ENDIF
               JENTRY(ILOOP1)= 2
            ELSE
               IF( IPRINT.NE.0 )THEN
                  WRITE(IWRITE,'(A8,A72)') 'NEW/XF: ',TEXT
               ENDIF
               IF( IPARAM.GT.0 )THEN
                  IENTRY(ILOOP1)= -IPARAM
               ENDIF
               JENTRY(ILOOP1)= 0
            ENDIF
C
C           REGISTER FILE NAME
            IPTRUN= KENTRY(ILOOP1)
            CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
            CALL LCMCAR(TEXT, LCATRU ,LCMNAM)
            CALL LCMPUT(IPTRUN,'HPARAM',18,3,LCMNAM)
            CALL LCMSIX(IPTRUN,' ',2)
         ENDIF
  100 CONTINUE
C
C     CAN WE FOUND *;* AT THE END OF THE SENTENCE ?
      IF( LNDATA )THEN   
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
         IF( ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC )GO TO 8002
      ENDIF
  666 RETURN
C
 8001 MESSAG='KDRDXF: INVALID TYPE IN *XSM_FILE    * DATA.'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDXF=8001
      GO TO 666
 8002 MESSAG='KDRDXF: INVALID END  IN *XSM_FILE    * DATA.'
      WRITE(IWRITE,'(A72)') MESSAG
      KDRDXF=8002
      GO TO 666
      END
