      FUNCTION     KDRPRM(IPTRUN,MINPUT,
     1                    NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *KDRPRM* IS USED TO PASS DUMMY ARGUMENTS 
C                              IN CLE-2000 PROCEDURES.
C
C
C      INPUT: *IPTRUN* IS THE EXEC STRUCTURE POINTER (ALLOCATED)
C             *MINPUT* IS AN INTEGER -1: TO READ PARM INPUT (IN MAIN)
C                                     0: TO GET  PARM INPUT (IN PROC)
C                                    +1: TO RETURN VALUES   (IN MAIN)
C             *NENTRY* IS THE # OF LINKED LISTS AND FILES USED.
C             *HENTRY* NAMES OF EACH OBJECT <- LINKED LIST OR FILE.
C                      ( CHARACTER*12 HENTRY(NENTRY) )
C             *IENTRY* TYPES OF EACH OBJECT ( INTEGER IENTRY(NENTRY) )
C                      =1 LINKED LIST; 
C                      =2 XSM FILE;
C                      =3 SEQUENTIAL BINARY FILE; 
C                      =4 SEQUENTIAL ASCII FILE;
C                      =5 DIRECT ACCESS FILE.
C             *JENTRY* MODES OF EACH OBJECT ( INTEGER JENTRY(NENTRY) )
C                      =0 THE OBJECT IS CREATED;
C                      =1 THE OBJECT IS OPENED FOR MODIFICATIONS;
C                      =2 THE OBJECT IS OPENED IN READ-ONLY MODE.
C             *KENTRY* POINTERS TO OBJECTS ( INTEGER KENTRY(NENTRY) )
C                      =FILE UNIT NUMBER; 
C                      =LINKED LIST ADDRESS OTHERWISE.
C
      IMPLICIT     NONE
C
      INTEGER      KDRPRM
      INTEGER      IPTRUN
      INTEGER      NENTRY
      CHARACTER    HENTRY(NENTRY)*12
      INTEGER      IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
      INTEGER      MINPUT
C
      INTEGER      NDCLKW, IWRITE, MPARA2
      PARAMETER  ( NDCLKW= 8, IWRITE= 6, MPARA2=64 )
      LOGICAL      LCATRU, LCAFAL
      PARAMETER  ( LCATRU=.TRUE., LCAFAL=.FALSE. )
      CHARACTER    HPARA2(MPARA2)*12
      INTEGER      IPARA2(MPARA2),JPARA2(MPARA2),KPARA2(MPARA2)
      INTEGER      ILOOP1, JLOOP2, NPARA2, IPRINT, IRETCD
      INTEGER      NPARAM, IPARAM, JPARAM, KPARAM, LPARAM, NUSEPR
      CHARACTER*12 APARAM, DPARAM, OBJNAM, CMODUL,CDCLKW(NDCLKW)
      INTEGER      LCMNAM(18)
      CHARACTER*12 CSEMIC,CDDOT,CDDDOT,CEDIT
      CHARACTER*72 HPARAM, MESSAG
      LOGICAL      LNDATA, L2DATA
C
C     DECLARATION MODULES
      INTEGER      KDRDDA, KDRDLL, KDRDMD, KDRDSA, KDRDSB, KDRDXF
C
C     VARIABLES FOR *REDGET*
      INTEGER          ITYP, NITMA, JREAD, JWRITE, JRECIN
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      CHARACTER*72     TEXT
C
      DATA CDCLKW  
     1   /'PROCEDURE   ','MODULE      ','LINKED_LIST ','XSM_FILE    ',
     2    'SEQ_BINARY  ','SEQ_ASCII   ','DIR_ACCESS  ','PARAMETER   ' /
      DATA CSEMIC,CDDOT,CDDDOT,CEDIT 
     1  / ';           ','::          ',':::         ','EDIT        ' /
C
C     'HPARAM' = TRUE NAME (ABSOLUTE VALUE, USE FOR OPENING/CLOSING)
C     'APARAM' = ACTUAL ARGUMENT NAME (FROM MAIN CALLING PROC)
C     'DPARAM' = DUMMY  ARGUMENT NAME (INSIDE PROC CALLED BY MAIN)
C
      KDRPRM= 0
C
      IF( MINPUT.EQ.-1 )THEN
C
C        PUT OBJECTS INTO *IPTRUN* BEFORE CALLING A PROCEDURE
         IF( NENTRY.NE.0 )THEN
            DO 10 ILOOP1= 1, NENTRY
C*  UP +1
               CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
               CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
               CALL LCMCAR(HPARAM, LCAFAL ,LCMNAM)
               CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
               CALL LCMGET(IPTRUN,'KPARAM',KPARAM)
               CALL LCMGET(IPTRUN,'LPARAM',LPARAM)
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN  0
C*  UP +1
               CALL LCMSIX(IPTRUN,'!_CALL_GIRL_',1)
               WRITE(OBJNAM,'(8H!GL2M_O_,I4.4)') ILOOP1
C*  UP +2
               CALL LCMSIX(IPTRUN,OBJNAM,1)
               CALL LCMPUT(IPTRUN,'HPARAM',18,3,LCMNAM)
               CALL LCMCAR(HENTRY(ILOOP1), LCATRU ,LCMNAM)
               CALL LCMPUT(IPTRUN,'APARAM',3,3,LCMNAM)
               CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
C
C              TRANSPORT OBJECT CALLING MODE
               JPARAM= JENTRY(ILOOP1)
               CALL LCMPUT(IPTRUN,'JPARAM',1,1,JPARAM)
C
               CALL LCMPUT(IPTRUN,'KPARAM',1,1,KPARAM)
               CALL LCMPUT(IPTRUN,'LPARAM',1,1,LPARAM)
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN +1
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN  0
   10       CONTINUE               
         ENDIF
C*  UP +1
         CALL LCMSIX(IPTRUN,'!_CALL_GIRL_',1)
         CALL LCMPUT(IPTRUN,'!_NUM_OBJETS',1,1,NENTRY)
         NUSEPR= 0
         CALL LCMPUT(IPTRUN,'!_USE_OBJETS',1,1,NUSEPR)
         CALL LCMSIX(IPTRUN,' ',2)    
C*DOWN  0
C
      ELSEIF( MINPUT.EQ.0 )THEN
C
C        LINK DUMMY OBJECTS WITH THEIR ACTUAL ARGUMENTS
         IF( NENTRY.LE.0 )THEN
            MESSAG= 'KDRPRM: *PARAMETER* WITHOUT OBJECTS'
            KDRPRM= -1
            WRITE(IWRITE,'(A72)') MESSAG
            GO TO 666
         ENDIF
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
         LNDATA= ITYP.NE.10.AND.(ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC)
         IPRINT= 0
         IF( LNDATA.AND.ITYP.EQ.3.AND.TEXT(1:12).EQ.CEDIT )THEN
            CALL REDGET(ITYP,IPRINT,FLOTT,TEXT,DFLOT)
            IF( ITYP.NE.1.AND.IPRINT.LT.0 )THEN
               MESSAG= 'KDRPRM: AFTER *EDIT*, PUT A POSITIVE INT'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRPRM= -2
               GO TO 666 
            ENDIF
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            LNDATA= ITYP.NE.10.AND.(ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC)
         ENDIF
         CALL LCMGET(IPTRUN,'!_NUM_OBJETS',NPARAM)
         CALL LCMGET(IPTRUN,'!_USE_OBJETS',NUSEPR)
         IF( NENTRY+NUSEPR.GT.NPARAM )THEN
            MESSAG= 'KDRPRM: TOO MANY PARAMETERS'
            WRITE(IWRITE,'(A72)') MESSAG
            KDRPRM=-3
            GO TO 666
         ENDIF
         DO 20 ILOOP1= 1, NENTRY
            WRITE(OBJNAM,'(8H!GL2M_O_,I4.4)') ILOOP1+NUSEPR
C*  UP +1
            CALL LCMSIX(IPTRUN,OBJNAM,1)
            CALL LCMCAR(HENTRY(ILOOP1), LCATRU ,LCMNAM)
            CALL LCMPUT(IPTRUN,'DPARAM',3,3,LCMNAM)
            CALL LCMGET(IPTRUN,'APARAM',LCMNAM)
            CALL LCMCAR(APARAM, LCAFAL ,LCMNAM)
            CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
            CALL LCMCAR(HPARAM, LCAFAL ,LCMNAM)
            CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
            CALL LCMGET(IPTRUN,'JPARAM',JPARAM)
            CALL LCMGET(IPTRUN,'KPARAM',KPARAM)
            CALL LCMGET(IPTRUN,'LPARAM',LPARAM)
            CALL LCMSIX(IPTRUN,' ',2)
C*DOWN  0
C*  UP +1
            CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
            CALL LCMPUT(IPTRUN,'HPARAM',18,3,LCMNAM)
            CALL LCMPUT(IPTRUN,'KPARAM',1,1,KPARAM)
            CALL LCMPUT(IPTRUN,'LPARAM',1,1,LPARAM)
            IENTRY(ILOOP1)= IPARAM
            JENTRY(ILOOP1)= JPARAM
            CALL LCMSIX(IPTRUN,' ',2)
C*DOWN  0
            IF( IPRINT.GT.0 )THEN
               WRITE(IWRITE,7000) 'PARAMETER ',HENTRY(ILOOP1),' <= ',
     1            APARAM,' WITH NAME(*',HPARAM,'*)' 
               IF( IPARAM.LE.0 )THEN
                  WRITE(IWRITE,7001) CDCLKW(-IPARAM),' UNDEFINED.'   
               ELSE
                  WRITE(IWRITE,7001) CDCLKW( IPARAM),'   DEFINED.' 
               ENDIF 
            ENDIF
   20    CONTINUE
         NUSEPR= NUSEPR+NENTRY
         CALL LCMPUT(IPTRUN,'!_USE_OBJETS',1,1,NUSEPR)
C
C        NOW, CALL THE EMBEDDED DECLARATION MODULE IF DATA
   21    CONTINUE
C           MAKES IT A *DO WHILE* STRUCTURE
            IF( .NOT.LNDATA ) GO TO 27
            IF( ITYP.NE.3.OR.TEXT(1:12).NE.CDDDOT )THEN
               MESSAG='KDRPRM: INVALID EMBEDDED DECL MODUL DATA'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRPRM=-4
               GO TO 666
            ENDIF
C
C           GET DECLARATION MODULE NAME
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            NUSEPR= 0
            DO 22 ILOOP1= 1, NDCLKW
               IF( TEXT(1:12).EQ.CDCLKW(ILOOP1) ) NUSEPR= ILOOP1
   22       CONTINUE
            IF( NUSEPR.EQ.0 )THEN
               MESSAG='KDRPRM: INVALID DECLARATION KEYWORD'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRPRM=-5
               GO TO 666
            ENDIF
            CMODUL= CDCLKW(NUSEPR)
C
C           GET OBJECT LIST
            NPARA2= 0
            DO 25 ILOOP1= 1, NENTRY+1
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
               IF( ITYP.EQ.3 )THEN
                  IF( TEXT(1:12).EQ.CSEMIC )THEN
                     L2DATA=.FALSE.
                     CALL REDCLS(JREAD,JWRITE,JRECIN)
                     GO TO 26
                  ELSEIF( TEXT(1:12).EQ.CDDOT )THEN
                     L2DATA=.TRUE.
                     GO TO 26
                  ELSE
C
C                    READER'S NAME *MUST* BE ONE OF *HENTRY*
                     DO 23 JLOOP2= 1, NENTRY
                        IF( TEXT(1:12).EQ.HENTRY(JLOOP2) )THEN
                           NPARA2= NPARA2+1
                           HPARA2(NPARA2)= HENTRY(JLOOP2)
                           IPARA2(NPARA2)= IENTRY(JLOOP2)
                           JPARA2(NPARA2)= JENTRY(JLOOP2)
                           KPARA2(NPARA2)= KENTRY(JLOOP2)
                           GO TO 25
                        ENDIF
   23                CONTINUE
                     IF( ILOOP1.NE.NENTRY+1 )THEN
                        MESSAG='KDRPRM: OBJECT *'//TEXT(1:12)//
     1                         '* NOT IN THE INPUT LIST'
                        KDRPRM=-7
                     ELSE
                        MESSAG= 'KDRPRM: TOO MANY OBJECTS IN '//
     1                          'EMBEDDED MODULE'
                        KDRPRM=-8
                     ENDIF
                     WRITE(IWRITE,'(A72)') MESSAG
                     GO TO 666
                  ENDIF
               ELSE
                  MESSAG='KDRPRM: INVALID TYPE IN EMBEDDED MODULE'
                  WRITE(IWRITE,'(A72)') MESSAG
                  KDRPRM=-6
                  GO TO 666
               ENDIF
   25       CONTINUE
   26       CONTINUE
C
C           NOW CALL THE SELECTED DECLARATION MODULE
            IF( CMODUL.EQ.'MODULE      ' )THEN
C              *MODULE      * DECLARATION MODULE
               IRETCD= KDRDMD(NPARA2,HPARA2,IPARA2,JPARA2,KPARA2)
            ELSEIF( CMODUL.EQ.'LINKED_LIST ' )THEN
C                    *LINKED_LIST * DECLARATION MODULE
               IRETCD= KDRDLL(NPARA2,HPARA2,IPARA2,JPARA2,KPARA2)
            ELSEIF( CMODUL.EQ.'XSM_FILE    ' )THEN
C              *XSM_FILE    * DECLARATION MODULE
               IRETCD= KDRDXF(NPARA2,HPARA2,IPARA2,JPARA2,KPARA2)
            ELSEIF( CMODUL.EQ.'SEQ_BINARY  ' )THEN
C              *SEQ_BINARY  * DECLARATION MODULE
               IRETCD= KDRDSB(NPARA2,HPARA2,IPARA2,JPARA2,KPARA2)
            ELSEIF( CMODUL.EQ.'SEQ_ASCII   ' )THEN
C              *SEQ_ASCII   * DECLARATION MODULE
               IRETCD= KDRDSA(NPARA2,HPARA2,IPARA2,JPARA2,KPARA2)
            ELSEIF( CMODUL.EQ.'DIR_ACCESS  ' )THEN
C              *DIR_ACCESS  * DECLARATION MODULE
               IRETCD= KDRDDA(NPARA2,HPARA2,IPARA2,JPARA2,KPARA2)
            ELSE
C
C              OTHERWISE, DECLARATION MODULE IS NOT AVAILABLE
               MESSAG='* KDRPRM: EMBEDDED PARAMETER MODULE *'//CMODUL
     1              //'* IS NOT AVAILABLE'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRPRM=-9
               GO TO 666
            ENDIF
            IF( IRETCD.NE.0 )THEN
               MESSAG='* KDRPRM: PROBLEM WITH EMBEDDED MODULE *'//
     1                CMODUL//'*'
               WRITE(IWRITE,'(A72)') MESSAG
               KDRPRM=-666
               GO TO 666
            ENDIF
C
            IF( .NOT.L2DATA )THEN
               CALL REDOPN(JREAD,JWRITE,JRECIN)
            ENDIF
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            LNDATA= ITYP.NE.10.AND.(ITYP.NE.3.OR.TEXT(1:12).NE.CSEMIC)
         GO TO 21
   27    CONTINUE
      ELSEIF( MINPUT.EQ.+1 )THEN
C
C        RETURN OBJECTS CREATED IN THE PROCEDURE BEFORE ENDING
         CALL LCMGET(IPTRUN,'!_NUM_OBJETS',NPARAM)
         CALL LCMGET(IPTRUN,'!_USE_OBJETS',NUSEPR)
         IF( NPARAM.NE.NUSEPR )THEN
            MESSAG='KDRPRM: SOME PARAMETERS WERE NOT USED'
            WRITE(IWRITE,'(A72)') MESSAG
            KDRPRM=-10
            GO TO 666
         ENDIF
         IF( NPARAM.NE.0 )THEN
            DO 30 ILOOP1= 1, NPARAM
               WRITE(OBJNAM,'(8H!GL2M_O_,I4.4)') ILOOP1
C*  UP +1
               CALL LCMSIX(IPTRUN,OBJNAM,1)
               CALL LCMGET(IPTRUN,'DPARAM',LCMNAM)
               CALL LCMCAR(DPARAM, LCAFAL ,LCMNAM)
               CALL LCMGET(IPTRUN,'APARAM',LCMNAM)
               CALL LCMCAR(APARAM, LCAFAL ,LCMNAM)
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN  0
C*  UP +1
               CALL LCMSIX(IPTRUN,DPARAM,1)
               CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
               CALL LCMGET(IPTRUN,'KPARAM',KPARAM)
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN  0
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN -1
C*  UP  0
               CALL LCMSIX(IPTRUN,APARAM,1)
               CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
               CALL LCMPUT(IPTRUN,'KPARAM',1,1,KPARAM)
               CALL LCMSIX(IPTRUN,' ',2)
C*DOWN -1
C*  UP  0
               CALL LCMSIX(IPTRUN,'!_CALL_GIRL_',1)
   30       CONTINUE
C
         ENDIF
      ELSE
         MESSAG= 'KDRPRM: INVALID VALUE FOR *MINPUT* ARG' 
         WRITE(IWRITE,'(A72)') MESSAG
         KDRPRM= -3
      ENDIF
  666 RETURN
*----
*  Formats
*----
 7000 FORMAT(1X,A10,A12,A4,A12,A12,A72,A2)
 7001 FORMAT(11X,A12,A11)
      END
