*DECK KDRSTD
      INTEGER FUNCTION KDRSTD(HMODUL,NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* standard utility operator driver for Ganlib.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input/output
* HMODUL  name of the operator.
* NENTRY  number of LCM objects or files used by the operator.
* HENTRY  name of each LCM object or file.
* IENTRY  type of each LCM object or file:
*         =1 LCM memory object; =2 XSM file; =3 sequential binary file;
*         =4 sequential ascii file.
* JENTRY  access of each LCM object or file:
*         =0 the LCM object or file is created;
*         =1 the LCM object or file is open for modifications;
*         =2 the LCM object or file is open in read-only mode.
* KENTRY  LCM object address or file unit number.
*
*Parameters: output
* KDRSTD  completion flag (=0: operator HMODUL exists; =1: does not
*         exists).
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER HMODUL*(*),HENTRY(NENTRY)*12
      INTEGER IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*
      KDRSTD=0
      IF(HMODUL.EQ.'EQU:' )THEN
*        STANDARD EQUALITY MODULE.
         CALL DRVEQU(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'GREP:') THEN
*        STANDARD GREP MODULE.
         CALL DRVGRP(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'UTL:') THEN
*        STANDARD LCM/XSM UTILITY MODULE.
         CALL DRVUTL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'ADD:') THEN
*        STANDARD ADDITION MODULE.
         CALL DRVADD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'MPX:') THEN
*        STANDARD MULTIPLICATION MODULE.
         CALL DRVMPX(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'STAT:') THEN
*        STANDARD COMPARE MODULE.
         CALL DRVSTA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'BACKUP:') THEN
*        STANDARD BACKUP MODULE.
         CALL DRVBAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'RECOVER:') THEN
*        STANDARD RECOVERY MODULE.
         CALL DRVREC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'FIND0:') THEN
*        STANDARD MODULE TO FIND ZERO OF A CONTINUOUS FUNCTION.
         CALL DRV000(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'MSTR:') THEN
*        MANAGE USER-DEFINED STRUCTURES.
         CALL MSTR(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'MODUL1:') THEN
*        USER-DEFINED MODULE.
         CALL DRVMO1(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'ABORT:') THEN
*        REQUESTED ABORT.
         CALL XABORT('KDRSTD: REQUESTED ABORT.')
#if defined(MPI)
      ELSEIF(HMODUL.EQ.'DRVMPI:')THEN
*        INITIALIZE MPI.
         CALL DRVMPI(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSEIF(HMODUL.EQ.'SNDMPI:')THEN
*        EXPORT LL OR XSM USING MPI.
         CALL SNDMPI(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
#endif /* defined(MPI) */
      ELSE
         KDRSTD=1
      ENDIF
      RETURN
      END
