      FUNCTION KERNEL(NMODXT,CMODXT,CLESTD,IPRINT)
C
C     GAN-2000 SYSTEM: R.ROY (01/2000), VERSION 2.1
C
C             *KERNEL* IS THE MAIN FUNCTION OF THE DRIVER.
C                      ON RETURN, THE MODULE NUMBER IS SENT TO MAIN.
C
C      INPUT: *CMODXT* IS THE LIST OF NAMES FOR CODE-DEPENDENT MODULES
C                      ( CHARACTER*12 CMODXT(1:NMODXT) )DEFINED VALUES
C             *NMODXT* IS THE NUMBER OF CODE-DEPENDENT MODULES
C             *CLECST* IS THE USER-DEFINED ROUTINE FOR CLE-2000 PARMS
C             *CLESTD* IS THE USER-DEFINED MODULE DISPATCH ROUTINE
C             *IPRINT* IS THE PRINTING INDEX (=0 FOR NO PRINT)
CC
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT         NONE
      INTEGER          KERNEL,NMODXT,MAXENT,IPRINT,NENTRY
      CHARACTER*12     CMODXT(NMODXT)
C
C     DEFINITIONS FOR *CLE2000* ROUTINES
      INTEGER          CLEPIL,CLECOP,CLECST,CLESTD,OBJPIL
      EXTERNAL                       CLECST,CLESTD
C     DEFINITIONS FOR *CLE2000* ROUTINES
C
C     DECLARATION MODULES & I/O FUNCTIONS
      INTEGER          KDRDDA,KDRDLL,KDRDMD,KDRDSA,KDRDSB,KDRDXF,
     1                 KDRDPR,KDROPN,KDRCLS,KDRFST,KDRPRM,KDRCLN
C
C     FIXED UNITS FOR FILE ACCESS AND OBJECTS
      INTEGER          IREAD,IWRITE,IWRLVL,NDCLKW,LRCLEN
      PARAMETER      ( IREAD=  5, IWRITE= 6, IWRLVL= 6, NDCLKW= 8,
     1                 LRCLEN=30, MAXENT=1000  )
C     FIXED UNITS FOR FILE ACCESS
C
C     VARIABLES FOR *REDGET*
      INTEGER          ITYP,NITMA
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      CHARACTER*72     TEXT
C     VARIABLES FOR *REDGET*
C
      CHARACTER*72     FILENM,MESSAG,CPROCE,HPARAM
      INTEGER          ILEVEL,ISTACK,JSTACK,JWRITE,JRECIN,IRETCD,JTYP
      LOGICAL          LOBNEW
      LOGICAL          LCATRU, LCAFAL
      PARAMETER      ( LCATRU=.TRUE., LCAFAL=.FALSE. )
C
      INTEGER          IPTRUN
      INTEGER          NMODUL,MINPUT,ILOGIN,ICOBJ,ILOOP1,IER
      INTEGER          IPARAM,JPARAM,KPARAM,LPARAM,JDISPE,LINDEX
      CHARACTER*12     CDCLKW(NDCLKW),CMODUL
      LOGICAL          LDATAV
      INTEGER          LCMNAM(18)
      CHARACTER*12     HENTRY(MAXENT)
      INTEGER          IENTRY(MAXENT),JENTRY(MAXENT),KENTRY(MAXENT)
C
C     KEYWORDS AND MODULES ACCEPTED BY THIS SIMPLIFIED DRIVER
      CHARACTER*12     CSEMIC,CDDOT,CEQUAL
      SAVE             IPTRUN,JSTACK,JWRITE,JRECIN,LDATAV
C
      DATA CDCLKW  
     1   /'PROCEDURE   ','MODULE      ','LINKED_LIST ','XSM_FILE    ',
     2    'SEQ_BINARY  ','SEQ_ASCII   ','DIR_ACCESS  ','PARAMETER   ' /
      DATA CSEMIC, CDDOT, CEQUAL 
     1   /    ';',   '::',  ':=' /
C
      KERNEL= 0
C
C     FIRST STEP, INITIALIAZE STUFF AND COMPILE MAIN
C
      ILEVEL=1
      WRITE (FILENM,'(4H_FIL,I3.3)') ILEVEL
C
C     OPEN DIRECT-ACCESS FILE FOR MAIN INPUT FILE
      ISTACK= KDROPN(FILENM,0,4,LRCLEN,0)
      IF( ISTACK.LE.0 ) GO TO 9001
C
C     COMPILE MAIN INPUT INTO OBJECT FILE
      IRETCD= CLEPIL(IREAD,IWRITE,ISTACK,CLECST)
      IF( IRETCD.NE.0 )THEN
         MESSAG= '* KERNEL: COMPILING _MAIN.c2m FILE (ERROR CODE)'
         WRITE(IWRITE,'(A72,4HIRC=,I4)') MESSAG,IRETCD
         GO TO 666
      ENDIF
C
C     ADD OBJECTS/MODULES TO OBJECT FILE
      IRETCD= OBJPIL(ISTACK,IWRITE,CMODXT,NMODXT)
      IF( IRETCD.NE.0 )THEN
         MESSAG= '* KERNEL: BAD OBJECTS _MAIN.c2m FILE (ERROR CODE)'
         WRITE(IWRITE,'(A72,4HIRC=,I4)') MESSAG,IRETCD
         GO TO 666
      ENDIF
      CALL LCMOP (IPTRUN,'!GL_2000_RUN',0,1,0)
      IF( IPRINT.GT.0 )THEN
         MESSAG= '* KERNEL: STARTING EXECUTION ON _MAIN.o2m FILE'
         WRITE(IWRITE,'(A72)') MESSAG
      ENDIF
      CALL REDOPN(ISTACK,IWRITE,0)
C
C     CONSTRUCT OBJECT LIST IN MEMORY
   10 CONTINUE
C
C        GET SENTENCE
         JDISPE= 0
         NENTRY= 0
         NMODUL= 0
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
C
C        TREAT FIRST WORD
         IF( ITYP.EQ.3 )THEN
            ILOGIN= 0
            DO 20 ILOOP1= 1,NDCLKW
               IF( TEXT(1:12).EQ.CDCLKW(ILOOP1)) ILOGIN= ILOOP1
   20       CONTINUE
C        
C           OUTSIDE THE DATA SECTION ( *HERE*  ::  ... )
   30       CONTINUE
            
            IF( TEXT(1:12).EQ.CEQUAL )THEN
               JDISPE= 2
            ELSEIF( TEXT(1:12).EQ.CDDOT )THEN
C           
C              FOR PROCEDURE/MODULE WITHOUT DATA, BRANCH NOW
               LDATAV= .TRUE.
               GO TO 40
            ELSEIF( TEXT(1:12).EQ.CSEMIC )THEN
C           
C              FOR PROCEDURE/MODULE WITH    DATA, BRANCH NOW
               LDATAV= .FALSE.
               GO TO 40
            ELSE
               CALL LCMSIX(IPTRUN,TEXT,1)
               IF( ILOGIN.NE.0 )THEN
                  IF( TEXT(1:12).EQ.CDCLKW(ILOGIN) )THEN
C
C                    DECLARATION ITSELF IS A MODULE
                     IPARAM= 2
                  ELSE
C
C                    TYPE IS SET TO VALUE < 0 (UNDEFINED)
                     IPARAM= -ILOGIN
                  ENDIF
                  HPARAM= TEXT
                  CALL LCMCAR(HPARAM, LCATRU ,LCMNAM)
                  CALL LCMPUT(IPTRUN,'HPARAM',18,3,LCMNAM)
                  CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
                  JPARAM=-1
                  CALL LCMPUT(IPTRUN,'JPARAM',1,1,JPARAM)
                  KPARAM= 0
                  CALL LCMPUT(IPTRUN,'KPARAM',1,1,KPARAM)
                  LPARAM= 0
                  CALL LCMPUT(IPTRUN,'LPARAM',1,1,LPARAM)
               ELSE
                  CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
                  CALL LCMCAR(HPARAM, LCAFAL ,LCMNAM)
                  CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
                  CALL LCMGET(IPTRUN,'KPARAM',KPARAM)
                  CALL LCMGET(IPTRUN,'LPARAM',LPARAM)
               ENDIF
               IF( NMODUL.EQ.0.AND.(ABS(IPARAM).EQ.1.OR.
     1                              ABS(IPARAM).EQ.2) )THEN
C
C                 ONCE MODULE/PROCEDURE FOUND, RESET *JDISPE=2*
C                                              (READ-ONLY MODE)
                  CMODUL= TEXT(1:12)
                  JDISPE= 2
                  IF( ABS(IPARAM).EQ.2 )THEN
                     NMODUL= 1
                  ELSE
                     NMODUL=-1
                     CPROCE= HPARAM
                     IF( IPARAM.EQ.-1 )THEN
                        WRITE(IWRITE,*) CPROCE
                        MESSAG= '* KERNEL: THIS FILE DOES NOT EXIST'
                        WRITE(IWRITE,'(A72)') MESSAG
                        GO TO 666
                     ENDIF
                  ENDIF
               ELSE
                  LOBNEW=.TRUE.
                  IF( NENTRY.NE.0 )THEN
                     DO 35 ILOOP1= 1,NENTRY
                        IF( HENTRY(ILOOP1).EQ.TEXT(1:12) )THEN
                           IF( JENTRY(ILOOP1).EQ.0 )THEN
C
C                             OBJECT GOES TO (MODIFICATION) MODE
                              JENTRY(ILOOP1)= 1
                           ELSE
                              MESSAG= 'KERNEL: INCONSISTENT CALL'
                              WRITE(IWRITE,'(A72)') MESSAG
                              GO TO 666
                           ENDIF
                           LOBNEW=.FALSE.
                        ENDIF
   35                CONTINUE
                  ENDIF
                  IF( LOBNEW )THEN
                     NENTRY= NENTRY+1
                     IF( NENTRY.GT.MAXENT )THEN
                        MESSAG= 'KERNEL: TOO MANY OBJECTS'
                        WRITE(IWRITE,'(A72)') MESSAG
                        GO TO 666
                     ENDIF
                     HENTRY(NENTRY)= TEXT(1:12)
                     JENTRY(NENTRY)= JDISPE
                  ENDIF
               ENDIF
               CALL LCMSIX(IPTRUN,' ',2)
            ENDIF
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOT)
            GO TO 30
   40    CONTINUE
            IF( NMODUL.EQ.0 )THEN
               IF( NENTRY.EQ.0 )THEN
                  CMODUL= 'IOX:'
               ELSE
                  CMODUL= 'EQU:'
               ENDIF
               NMODUL=  1 
            ENDIF
            IF( NMODUL.EQ.1 )THEN
C
C              FOR MODULES
               IF( .NOT.LDATAV )THEN
C
C                 DISCONNECT READER
                  CALL REDCLS(JSTACK,JWRITE,JRECIN)
               ENDIF
               IF( ILOGIN.EQ.0 )THEN
                  IF( CMODUL.EQ.'IOX:' )THEN
                     IF( ILEVEL.EQ.1 )THEN
                        MESSAG='KERNEL: CALLING MODULE *IOX:*'//
     1                         ' AT MAIN LEVEL'
                        WRITE(IWRITE,'(A72)') MESSAG
                        GO TO 666
                     ELSEIF( NENTRY.NE.0 )THEN
                        MESSAG='KERNEL: MODULE *IOX:* WITH '//
     1                         'INVALID PARAMETERS'
                        WRITE(IWRITE,'(A72)') MESSAG
                        GO TO 666
                     ENDIF
                     MINPUT=  0
                     CALL DRVIOX( IPTRUN, MINPUT )
                  ELSE
C
                     DO 50 ILOOP1= 1,NENTRY
                        CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
                        CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
                        CALL LCMCAR(HPARAM, LCAFAL ,LCMNAM)
                        CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
                        CALL LCMGET(IPTRUN,'JPARAM',JPARAM)
                        CALL LCMGET(IPTRUN,'KPARAM',KPARAM)
                        CALL LCMGET(IPTRUN,'LPARAM',LPARAM)
C
C                       CONSISTENCY TESTS
                        IF( JENTRY(ILOOP1).EQ.0 )THEN
                           IF( JPARAM.EQ.2.OR.IPARAM.GE.0 )THEN
                              MESSAG='KERNEL: '//CDCLKW(IPARAM)//
     1                        ' *'//HENTRY(ILOOP1)//'* ALREADY EXISTS'
                              WRITE(IWRITE,'(A72)') MESSAG
                              KERNEL=-2
                              GO TO 666
                           ENDIF
                           IPARAM=-IPARAM
                           CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
                        ELSEIF( JENTRY(ILOOP1).EQ.1 )THEN
                           IF( JPARAM.EQ.2 )THEN
                              MESSAG='KERNEL: '//CDCLKW(ABS(IPARAM))//
     1                        ' *'//HENTRY(ILOOP1)//'* IS PROTECTED'
                              WRITE(IWRITE,'(A72)') MESSAG
                              KERNEL=-2
                              GO TO 666
                           ELSEIF( IPARAM.LE.0 )THEN
                              MESSAG= 'KERNEL: '//CDCLKW(-IPARAM)//
     1                        ' *'//HENTRY(ILOOP1)//'* IS NOT DEFINED'
                              WRITE(IWRITE,'(A72)') MESSAG
                              KERNEL=-2
                              GO TO 666
                           ENDIF
                        ELSEIF( JENTRY(ILOOP1).EQ.2 )THEN
                           IF( IPARAM.LE.0 )THEN
C
C                             ALLOW ACCESS TO ANY FILE AT MAIN LEVEL
                              IF( ILEVEL.EQ.1 .AND. 
     1                           (IPARAM.EQ.-4 .OR. IPARAM.EQ.-5 .OR.
     2                            IPARAM.EQ.-6 .OR. IPARAM.EQ.-7) )THEN
                                 IPARAM= -IPARAM
                                 CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
                              ELSE
                                 MESSAG='KERNEL: '//CDCLKW(-IPARAM)//
     1                        ' *'//HENTRY(ILOOP1)//'* IS NOT DEFINED'
                                 WRITE(IWRITE,'(A72)') MESSAG
                                 KERNEL=-2
                                 GO TO 666
                              ENDIF
                           ENDIF
                        ELSE
                           MESSAG= ' KERNEL: INVALID *JENTRY*'
                           WRITE(IWRITE,'(A72)') MESSAG
                           GO TO 666
                        ENDIF
                        JDISPE= JENTRY(ILOOP1)
                        IF( IPRINT.GT.1 )THEN
                           LINDEX= INDEX(HPARAM,' ')-1
                           IF( LINDEX.EQ.-1 ) LINDEX=72
                           IF( JDISPE.EQ.0 )THEN
                              WRITE(IWRITE,*) ' KERNEL: OPN '
     1                           //CDCLKW(IPARAM)//' *'//
     2                           HPARAM(1:LINDEX)//
     3                           '* IN CREATION     MODE'
                           ELSEIF( JDISPE.EQ.1 )THEN
                              WRITE(IWRITE,*) ' KERNEL: OPN '
     1                           //CDCLKW(IPARAM)//' *'//
     2                           HPARAM(1:LINDEX)//
     3                           '* IN MODIFICATION MODE'
                           ELSEIF( JDISPE.EQ.2 )THEN
                              WRITE(IWRITE,*) ' KERNEL: OPN '
     1                           //CDCLKW(IPARAM)//' *'//
     2                           HPARAM(1:LINDEX)//
     3                           '* IN READ/ONLY    MODE'
                           ENDIF
                        ENDIF
                        IF( IPARAM.EQ.3.OR.IPARAM.EQ.4 )THEN
                           CALL LCMOP (KPARAM,HPARAM,JDISPE,IPARAM-2,0)
                        ELSEIF( IPARAM.EQ.5.OR.IPARAM.EQ.6
     1                                     .OR.IPARAM.EQ.7 )THEN
                           KPARAM= KDROPN(HPARAM,JDISPE,IPARAM-3,
     1                                    LPARAM,0)
                           IF( KPARAM.LE.0 )THEN
                              WRITE(IWRITE,*) ' KERNEL: PROBLEM '//
     1                           'WHEN OPENING FILE *'//
     2                           HPARAM//'*'
                              WRITE(MESSAG,
     1                          '(28HKERNEL: KDROPN FAILURE. IRC=,I3)')
     2                            KPARAM
                              WRITE(IWRITE,'(A72)') MESSAG
                              GO TO 666
                           ENDIF
                        ELSE
                           WRITE(IWRITE,*) ' KERNEL: USE '//
     1                           CDCLKW(ABS(IPARAM))//' *'//
     2                           HPARAM//'* IS IMPOSSIBLE'
                           MESSAG= 'KERNEL: INVALID *IPARAM*'
                           WRITE(IWRITE,'(A72)') MESSAG
                           GO TO 666
                        ENDIF
                        KENTRY(ILOOP1)= KPARAM
                        IENTRY(ILOOP1)= IPARAM-2
                        IF( JDISPE.EQ.0 )THEN
                           CALL LCMPUT(IPTRUN,'KPARAM',1,1,KPARAM)
                        ELSEIF( CMODUL.EQ.'DELETE:' )THEN
                           IF( ABS(JPARAM).NE.1 )THEN
                              WRITE(IWRITE,*) ' KERNEL: KIL '//
     1                           CDCLKW(IPARAM)//' *'//
     2                           HPARAM//'* IS IMPOSSIBLE'
                              WRITE(IWRITE,*) ' KERNEL:    *'//
     1                           HPARAM//'* IS A PROTECTED PARAMETER.'
                              MESSAG= 'KERNEL: INVALID DELETE'
                              WRITE(IWRITE,'(A72)') MESSAG
                              GO TO 666
                           ENDIF
                           KPARAM= 0
                           IPARAM=-IPARAM
                           CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
                           CALL LCMPUT(IPTRUN,'KPARAM',1,1,KPARAM)
                        ENDIF
                        CALL LCMSIX(IPTRUN,' ',2)
   50                CONTINUE
C
C                    CALLING MODULES
                     JDISPE= 1
                     IF( CMODUL.EQ.'END:' )THEN
                         IF( LDATAV )THEN
                            MESSAG= 'KERNEL: *END:* HAS NO DATA'
                            WRITE(IWRITE,'(A72)') MESSAG
                            GO TO 666
                         ELSEIF( NENTRY.NE.0 )THEN
                            MESSAG= 'KERNEL: *END:* HAS NO OBJECT'
                            WRITE(IWRITE,'(A72)') MESSAG
                            GO TO 666
                        ENDIF
                        IER= 0
                     ELSEIF( CMODUL.EQ.'DELETE:' )THEN
C                       STANDARD DELETE MODULE (SEE BELOW).
                        JDISPE= 2
                        IER= 0
                     ELSE
C                       CALLING ANOTHER STANDARD UTILITY MODULE.
                        IER= CLESTD(CMODUL,NENTRY,HENTRY,IENTRY,JENTRY,
     1                              KENTRY)
                     ENDIF
                     IF(IER.NE.0) THEN
                        MESSAG='* KERNEL: MODULE *'//CMODUL//
     1                  '* NOT FOUND'
                        WRITE(IWRITE,'(A72)') MESSAG
                        GO TO 666
                     ENDIF
C                 
C                    CLOSE EVERYTHING
                     DO 70 ILOOP1= 1, NENTRY
                        IPARAM= IENTRY(ILOOP1)
                        IF( IPRINT.GT.1 )THEN
                           CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
                           CALL LCMGET(IPTRUN,'HPARAM',LCMNAM)
                           CALL LCMCAR(HPARAM, LCAFAL ,LCMNAM)
                           CALL LCMSIX(IPTRUN,' ',2)
                           LINDEX= INDEX(HPARAM,' ')-1
                           IF( LINDEX.EQ.-1 ) LINDEX=72
                           IF( JDISPE.EQ.1 )THEN
                              WRITE(IWRITE,*) ' KERNEL: CLS '
     1                           //CDCLKW(IPARAM+2)//
     2                           ' *'//HPARAM(1:LINDEX)//'*'
                           ELSE
                              WRITE(IWRITE,*) ' KERNEL: KIL '//
     1                           CDCLKW(IPARAM)//' *'//
     2                           HPARAM(1:LINDEX)//
     3                           '* (AS IF IT NEVER EXISTED)'
                           ENDIF
                        ENDIF
                        IF( IPARAM.EQ.1.OR.IPARAM.EQ.2 )THEN
                           CALL LCMCL (KENTRY(ILOOP1),JDISPE)
                        ELSEIF( IPARAM.EQ.3.OR.IPARAM.EQ.4
     1                                     .OR.IPARAM.EQ.5 )THEN
                           KPARAM= KDRCLS(KENTRY(ILOOP1),JDISPE)
                           IF( KPARAM.LT.0)THEN
                              WRITE(MESSAG,
     1                        '(28HKERNEL: KDRCLS FAILURE. IRC=,I3,
     2                        7H NUNIT=,I5)') KPARAM,KENTRY(ILOOP1)
                              WRITE(IWRITE,'(A72)') MESSAG
                              GO TO 666
                           ENDIF
                        ELSE
                           MESSAG='KERNEL: UNABLE TO CLOSE '//
     1                        HENTRY(ILOOP1)
                           WRITE(IWRITE,'(A72)') MESSAG
                           GO TO 666
                        ENDIF
   70                CONTINUE
                  ENDIF
               ELSE
C
C                 CHARGE ENTRIES FOR DECLARATION MODULES
                  DO 80 ILOOP1= 1,NENTRY
                     CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
                     CALL LCMGET(IPTRUN,'IPARAM',IPARAM)
                     IENTRY(ILOOP1)= IPARAM
                     CALL LCMGET(IPTRUN,'JPARAM',JPARAM)
                     JENTRY(ILOOP1)= JPARAM
                     KENTRY(ILOOP1)= IPTRUN
                     CALL LCMSIX(IPTRUN,' ',2)
   80             CONTINUE
                  IF( CMODUL.EQ.'PARAMETER' )THEN
C                   *PARAMETER   * DECLARATION MODULE
                     MINPUT=   0
                     IRETCD= KDRPRM(IPTRUN,MINPUT,
     1                              NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                     IF( IRETCD.NE.0 )THEN
                        MESSAG='* KERNEL: PROBLEM ACCEPTING PARAMETERS'
                        WRITE(IWRITE,'(A72)') MESSAG
                        GO TO 666
                     ENDIF
                  ELSEIF( CMODUL.EQ.'PROCEDURE   ' )THEN
C                    *PROCEDURE   * DECLARATION MODULE
                     IRETCD= KDRDPR(CMODXT,NMODXT,CLECST,
     1                              NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSEIF( CMODUL.EQ.'MODULE      ' )THEN
C                    *MODULE      * DECLARATION MODULE
                     IRETCD= KDRDMD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSEIF( CMODUL.EQ.'LINKED_LIST ' )THEN
C                    *LINKED_LIST * DECLARATION MODULE
                     IRETCD= KDRDLL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSEIF( CMODUL.EQ.'XSM_FILE    ' )THEN
C                    *XSM_FILE    * DECLARATION MODULE
                     IRETCD= KDRDXF(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSEIF( CMODUL.EQ.'SEQ_BINARY  ' )THEN
C                    *SEQ_BINARY  * DECLARATION MODULE
                     IRETCD= KDRDSB(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSEIF( CMODUL.EQ.'SEQ_ASCII   ' )THEN
C                    *SEQ_ASCII   * DECLARATION MODULE
                     IRETCD= KDRDSA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSEIF( CMODUL.EQ.'DIR_ACCESS  ' )THEN
C                    *DIR_ACCESS  * DECLARATION MODULE
                     IRETCD= KDRDDA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
                  ELSE
C
C                    OTHERWISE, DECLARATION MODULE IS NOT AVAILABLE
                     MESSAG='* KERNEL: DECLARATION MODULE *'//CMODUL
     1                    //'* NOT AVAILABLE IN THIS CODE'
                     WRITE(IWRITE,'(A72)') MESSAG
                     GO TO 666
                  ENDIF
                  IF( IRETCD.NE.0 )THEN
                     MESSAG='* KERNEL: PROBLEM WITH MODULE *'//CMODUL
     1                   //'*'
                     WRITE(IWRITE,'(A72)') MESSAG
                     KERNEL=-666
                     GO TO 666
                  ENDIF
C
C                 RECOVER ENTRIES FROM DECLARATION MODULES
                  DO 90 ILOOP1= 1,NENTRY
                     CALL LCMSIX(IPTRUN,HENTRY(ILOOP1),1)
                     IPARAM= IENTRY(ILOOP1)
                     CALL LCMPUT(IPTRUN,'IPARAM',1,1,IPARAM)
                     JPARAM= JENTRY(ILOOP1)
                     CALL LCMPUT(IPTRUN,'JPARAM',1,1,JPARAM)
                     CALL LCMSIX(IPTRUN,' ',2)
   90             CONTINUE
               ENDIF
               IF( IPRINT.GT.0 )THEN
                  MESSAG= '* KERNEL: END OF MODULE    *'//CMODUL//'*'
                  WRITE(IWRITE,'(A72,4HLVL=,I4)') MESSAG, ILEVEL
                  WRITE(IWRITE,'(1X)')
               ENDIF
               IF( .NOT.LDATAV.AND.CMODUL.NE.'END:' )THEN
C
C                 RECONNECT READER IF DISCONNECTED OUTSIDE END:
                  CALL REDOPN(JSTACK,JWRITE,JRECIN)
               ENDIF
            ELSE
C
C              FOR PROCEDURES
               MINPUT= -1
               IRETCD= KDRPRM(IPTRUN,MINPUT,
     1                        NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
               IF( IRETCD.NE.0 )THEN
                  MESSAG='* KERNEL: PROBLEM PASSING PARAMETERS'
                  WRITE(IWRITE,'(A72)') MESSAG
                  GO TO 666
               ENDIF
C
C              HERE, ONE STEP UP
               CALL LCMSIX(IPTRUN,'!_CALL_GIRL_',1)
               ILEVEL= ILEVEL+1
               CALL LCMPUT(IPTRUN,'!_RUN_LEVEL ',1,1,ILEVEL)
C
               IF( LDATAV )THEN
C              
C                 FOR PROCEDURES, READ DATA SECTION ( ...   :: *HERE* )
                  CALL DRVIOX( IPTRUN, MINPUT )
               ELSE
C              
C                 FOR PROCEDURES, WITHOUT DATA SECTION
                  CALL REDCLS(JSTACK,JWRITE,JRECIN)
                  CALL LCMPUT(IPTRUN,'!_C2M_INPFIL',1,1,JSTACK)
                  CALL LCMPUT(IPTRUN,'!_C2M_OUTFIL',1,1,JWRITE)
                  CALL LCMPUT(IPTRUN,'!_C2M_RECORD',1,1,JRECIN)
                  CALL LCMPUT(IPTRUN,'!_NUM_VALUES',1,1,0)
                  CALL LCMPUT(IPTRUN,'!_USE_VALUES',1,1,0)
               ENDIF
               IF( IPRINT.GT.0 )THEN
                  MESSAG= '* KERNEL: BEG PROCEDURE    *'//
     1                    CMODUL//'* (LEVEL: STEP   UP)'
                  WRITE(IWRITE,'(A72,4HLVL=,I4)') MESSAG, ILEVEL
               ENDIF
               WRITE (FILENM,'(4H_FIL,I3.3)') ILEVEL
               JSTACK= KDROPN(FILENM,0,4,LRCLEN,0)
               IF( JSTACK.LE.0 ) GO TO 9001
               ICOBJ = KDROPN(CPROCE,1,4,LRCLEN,0)
               IF( ICOBJ.LE.0 )THEN
                  MESSAG= '* KERNEL: DID YOU FORGET TO COMPILE ?'
                  WRITE(IWRITE,'(A72)') MESSAG
                  FILENM= CPROCE
                  GO TO 9001
               ENDIF
C
C              NOW, MAKE A COPY OF OBJECT FILE
               IRETCD= CLECOP(ICOBJ,JSTACK)
               IF( IRETCD.NE.0 )THEN
                  WRITE(IWRITE,'(A72)') CPROCE
                  MESSAG= 
     1            '* KERNEL: COPYING   PREVIOUS FILE (ERROR CODE)'
                  WRITE(IWRITE,'(A72,4HIRC=,I4)') MESSAG, IRETCD
                  GO TO 666
               ENDIF
C
C              CLOSE AND KEEP ORIGINAL OBJECT FILE
               IRETCD = KDRCLS(ICOBJ,1)
               IF( IRETCD.NE.0 )GO TO 9002
               CALL REDOPN(JSTACK,IWRLVL,0)
            ENDIF
         ELSEIF( ITYP.EQ.9.OR.ITYP.EQ.10 )THEN
C
C           A FUNCTION CALL HAS ENDED
            IF( ILEVEL.EQ.1 ) GO TO 100
C
C           RETURN BACK TO PREVIOUS LEVEL AT SELECTED RECORD
            MINPUT= +1
            IRETCD= KDRPRM(IPTRUN,MINPUT,
     1                     NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
            IF( IRETCD.NE.0 )THEN
               MESSAG='* KERNEL: PROBLEM RETURNING PARAMETERS'
               WRITE(IWRITE,'(A72)') MESSAG
               GO TO 666
            ENDIF
C
C           RECOVERING OUTPUT IN DATA FIELD
            CALL DRVIOX( IPTRUN, MINPUT )
C
C           CLEANING NON-DUMMY OBJECTS
            IRETCD= KDRCLN( IPTRUN, IPRINT )
            IF( IRETCD.NE.0 )THEN
               MESSAG='* KERNEL: PROBLEM CLEANING NON-DUMMY OBJECTS'
               WRITE(IWRITE,'(A72)') MESSAG
               GO TO 666
            ENDIF
C
C           HERE, ONE STEP DOWN 
            CALL LCMSIX(IPTRUN,' ',2)
C
C           CLEAN UP ROUTINE THINGS
            WRITE (FILENM,'(4H_FIL,I3.3)') ILEVEL
            IRETCD= KDRFST(FILENM,JSTACK,JTYP,ILOOP1)
            IF( IRETCD.NE.4 ) GO TO 9001
            IRETCD= KDRCLS(JSTACK,2)
            IF( IRETCD.LT.0 ) GO TO 9002
            ILEVEL= ILEVEL-1
            IF( IPRINT.GT.0 )THEN
               IF( ITYP.EQ.9 )THEN
                  MESSAG= '* KERNEL: END PROCEDURE     '//
     1                    ' NO MORE DATA (LEVEL: STEP DOWN)'
               ELSE
                  MESSAG= '* KERNEL: END PROCEDURE     '//
     1                    ' RETURN       (LEVEL: STEP DOWN)'
               ENDIF
               WRITE(IWRITE,'(A72,4HLVL=,I4)') MESSAG, ILEVEL
            ENDIF
         ELSE
            MESSAG= 'KERNEL: INVALID TYPE'
            WRITE(IWRITE,'(A72)') MESSAG
            GO TO 666
         ENDIF
      GO TO 10
  100 CONTINUE
C
C     TRYING TO CLOSE ALL DA FILES...
      IF( ILEVEL.NE.1 )THEN
C
C        THIS IS AN ERROR, RECURSIVE CALLS ARE NOT WELL-TREATED
         MESSAG= '* KERNEL: INVALID RECURSIVE CALLS BETWEEN LEVELS'
         WRITE(IWRITE,'(A72,4HLVL=,I4)') MESSAG, ILEVEL
         DO 110 JTYP= ILEVEL, 2, -1
            WRITE (FILENM,'(4H_FIL,I3.3)') JTYP
            IRETCD= KDRFST(FILENM,JSTACK,ITYP,ILOOP1)
            IF( IRETCD.NE.4 ) GO TO 9001
            IRETCD= KDRCLS(JSTACK,2)
            IF( IRETCD.LT.0 ) GO TO 9002
  110    CONTINUE
         MESSAG= '* KERNEL: EXECUTION WITH EMBEDDED LEVEL ERRORS.'
         WRITE(IWRITE,'(A72)') MESSAG
         ILEVEL= 1
      ELSEIF( IPRINT.GT.0 )THEN
         MESSAG= '*'
         WRITE(IWRITE,'(A72)') MESSAG
         MESSAG= '* KERNEL: EXECUTION HAS ENDED WELL.'
         WRITE(IWRITE,'(A72)') MESSAG
      ENDIF
C
C     CLOSE AND DESTROY MAIN OBJECT FILE
      WRITE (FILENM,'(4H_FIL,I3.3)') ILEVEL
      IRETCD= KDRFST(FILENM,ISTACK,JTYP,ILOOP1)
      IF( IRETCD.NE.4 ) GO TO 9001
      IRETCD= KDRCLS(ISTACK,2)
      IF( IRETCD.NE.0 ) GO TO 9002
C
C     ILEVEL= 0 IS THE ENDING FLAG FOR CALLING PROGRAM
      ILEVEL= 0
      RETURN
C
  666 KERNEL=666
      RETURN
C
 9001 WRITE(IWRITE,'(A72)') FILENM
      MESSAG= 'KERNEL: ERROR WHEN OPENING OBJECT FILE'
      WRITE(IWRITE,'(A72)') MESSAG
      GO TO 666
 9002 WRITE(IWRITE,'(A72)') FILENM
      MESSAG= 'KERNEL: ERROR WHEN CLOSING OBJECT FILE'
      WRITE(IWRITE,'(A72)') MESSAG
      GO TO 666
      END
