*DECK LCMADD
      SUBROUTINE LCMADD(IPLIS1,IPLIS2)
*
*-----------------------------------------------------------------------
*
* ADD THE FLOATING POINT INFORMATION CONTAINED IN THE ACTIVE DIRECTORIES
* OF TWO TABLES OR XSM FILES POINTED BY IPLIS1 AND IPLIS2 AND STORE THE
* RESULT IN THE TABLE OR XSM FILE POINTED BY IPLIS2.
*
* INPUT PARAMETERS:
*  IPLIS1 : ADDRESS OF THE TABLE OR HANDLE TO THE XSM FILE.
*  IPLIS2 : ADDRESS OF THE TABLE OR HANDLE TO THE XSM FILE.
*
* OUTPUT PARAMETER:
*  IPLIS2 : ADDRESS OF THE TABLE OR HANDLE TO THE XSM FILE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 02/11/93 ----
*
      PARAMETER (MAXLEV=50)
      CHARACTER NAMT*12,HSMG*131,CTMP1*4,CTMP2*4,HNAME1*12,HNAME2*12,
     1 NAMMY*12,PATH(MAXLEV)*12,FIRST(MAXLEV)*12
      REAL RR1(2),RR2(2)
      DOUBLE PRECISION DD1,DD2
      INTEGER IBASE(1),KDATA1(MAXLEV),KDATA2(MAXLEV),IVEC(MAXLEV),
     1 KJLON(MAXLEV),IGO(MAXLEV)
      LOGICAL EMPTY,LCM1,LCM2,LBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1)),(RR1(1),DD1),
     1 (RR2(1),DD2)
*
      IF(IPLIS1.EQ.IPLIS2) THEN
         WRITE(HSMG,'(45HLCMADD: TWO TABLES OR XSM FILES HAVE THE SAME,
     1   9H HANDLE =,I10,1H.)') IPLIS1
         CALL XABORT(HSMG)
      ENDIF
      CALL LCMVAL(IPLIS1,' ')
      CALL LCMVAL(IPLIS2,' ')
      ILEV=1
      KDATA1(1)=IPLIS1
      KDATA2(1)=IPLIS2
      KJLON(1)=-1
      IVEC(1)=1
      IGO(1)=5
*
* ASSOCIATIVE TABLE.
   10 CALL LCMINF(IPLIS1,HNAME1,NAMMY,EMPTY,ILONG,LCM1)
      CALL LCMINF(IPLIS2,HNAME2,NAMMY,EMPTY,ILONG,LCM2)
      IF(EMPTY) GO TO (150,150,270,270,380),IGO(ILEV)
      NAMT=' '
      CALL LCMNXT(IPLIS1,NAMT)
*
      FIRST(ILEV)=NAMT
   15 CALL LCMLEN(IPLIS1,NAMT,ILON1,ITY1)
      CALL LCMLEN(IPLIS2,NAMT,ILON2,ITY2)
      IF((ILON1.NE.ILON2).OR.(ITY1.NE.ITY2)) THEN
         WRITE(6,'(/21H LCMADD: TWO BLOCKS '',A12,6H'' OF '',A12,
     1   7H'' AND '',A12,23H'' ARE OF UNEQUAL TYPE (,2I4,8H) OR LEN,
     2   5HGTH (,2I7,2H).)') NAMT,HNAME1,HNAME2,ITY1,ITY2,ILON1,ILON2
         GO TO 10
      ENDIF
      IF(ITY1.EQ.0) THEN
*        ASSOCIATIVE TABLE DATA.
         ILEV=ILEV+1
         IF(ILEV.GT.MAXLEV) THEN
            WRITE(HSMG,'(2A,A12,A)') 'LCMADD: TOO MANY DIRECTORY ',
     1      'LEVELS ON ''',HNAME2,'''(1).'
            CALL XABORT(HSMG)
         ENDIF
         KJLON(ILEV)=-1
         KDATA1(ILEV)=LCMGID(IPLIS1,NAMT)
         KDATA2(ILEV)=LCMGID(IPLIS2,NAMT)
         PATH(ILEV)=NAMT
         IPLIS1=KDATA1(ILEV)
         IPLIS2=KDATA2(ILEV)
         IVEC(ILEV)=1
         IGO(ILEV)=1
         GO TO 10
      ELSE IF(ITY1.EQ.10) THEN
*        LIST DATA.
         ILEV=ILEV+1
         IF(ILEV.GT.MAXLEV) THEN
            WRITE(HSMG,'(2A,A12,A)') 'LCMADD: TOO MANY DIRECTORY ',
     1      'LEVELS ON ''',HNAME2,'''(2).'
            CALL XABORT(HSMG)
         ENDIF
         KJLON(ILEV)=ILON1
         KDATA1(ILEV)=LCMGID(IPLIS1,NAMT)
         KDATA2(ILEV)=LCMGID(IPLIS2,NAMT)
         PATH(ILEV)=NAMT
         IPLIS1=KDATA1(ILEV)
         IPLIS2=KDATA2(ILEV)
         IVEC(ILEV)=0
         IGO(ILEV)=2
         GO TO 190
      ELSE IF(ITY1.LE.6) THEN
         IF(ITY1.EQ.1) THEN
*           INTEGER DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIS1,NAMT,BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMIOF(IPLIS2,NAMT,IAS2)
            ELSE
               CALL SETARA(BASE,ILON2,IAS2)
               CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
            ENDIF
            DO 80 I=1,ILON1
            IF(IBASE(IAS1+I-1).NE.IBASE(IAS2+I-1)) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT INTEGER DATA ON TH,
     1         27HE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               CALL XABORT(HSMG)
            ENDIF
   80       CONTINUE
         ELSE IF((ITY1.EQ.2).OR.(ITY1.EQ.6)) THEN
*           SINGLE PRECISION OR COMPLEX DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIS1,NAMT,BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMIOF(IPLIS2,NAMT,IAS2)
            ELSE
               CALL SETARA(BASE,ILON2,IAS2)
               CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
            ENDIF
            DO 90 I=1,ILON1
   90       BASE(IAS2+I-1)=BASE(IAS1+I-1)+BASE(IAS2+I-1)
            IF(LCM2) THEN
               CALL LCMPOF(IPLIS2,NAMT,ILON2,ITY2,IAS2)
            ELSE
               CALL LCMPUT(IPLIS2,NAMT,ILON2,ITY2,BASE(IAS2))
            ENDIF
         ELSE IF(ITY1.EQ.3) THEN
*           CHARACTER*4 DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIS1,NAMT,BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMIOF(IPLIS2,NAMT,IAS2)
            ELSE
               CALL SETARA(BASE,ILON2,IAS2)
               CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
            ENDIF
            DO 100 I=1,ILON1
              WRITE(CTMP1,'(A4)') BASE(IAS1+I-1)
              WRITE(CTMP2,'(A4)') BASE(IAS2+I-1)
              IF(CTMP1.NE.CTMP2) THEN
                 WRITE(HSMG,'(37HLCMADD: INCONSISTENT CHARACTER DATA O,
     1           31HN THE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
                 CALL XABORT(HSMG)
              ENDIF
  100       CONTINUE
         ELSE IF(ITY1.EQ.4) THEN
*           DOUBLE PRECISION DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIS1,NAMT,BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMIOF(IPLIS2,NAMT,IAS2)
            ELSE
               CALL SETARA(BASE,ILON2,IAS2)
               CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
            ENDIF
            DO 110 I=1,ILON1/2
            RR1(1)=BASE(IAS1+(I-1)*2)
            RR1(2)=BASE(IAS1+(I-1)*2+1)
            RR2(1)=BASE(IAS2+(I-1)*2)
            RR2(2)=BASE(IAS2+(I-1)*2+1)
            DD2=DD1+DD2
            BASE(IAS2+(I-1)*2)=RR2(1)
  110       BASE(IAS2+(I-1)*2+1)=RR2(2)
            IF(LCM2) THEN
               CALL LCMPOF(IPLIS2,NAMT,ILON2,ITY2,IAS2)
            ELSE
               CALL LCMPUT(IPLIS2,NAMT,ILON2,ITY2,BASE(IAS2))
            ENDIF
         ELSE IF(ITY1.EQ.5) THEN
*           LOGICAL DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGET(IPLIS1,NAMT,BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMIOF(IPLIS2,NAMT,IAS2)
            ELSE
               CALL SETARA(BASE,ILON2,IAS2)
               CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
            ENDIF
            DO 120 I=1,ILON1
            IF(LBASE(IAS1+I-1).NEQV.LBASE(IAS2+I-1)) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT LOGICAL DATA ON TH,
     1         27HE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               CALL XABORT(HSMG)
            ENDIF
  120       CONTINUE
         ELSE
            CALL XABORT('LCMADD: INVALID DATA TYPE(1).')
         ENDIF
         IF(.NOT.LCM2) CALL RLSARA(BASE(IAS2))
         CALL RLSARA(BASE(IAS1))
      ENDIF
      CALL LCMNXT(IPLIS1,NAMT)
      IF(NAMT.NE.FIRST(ILEV)) GO TO 15
      GO TO (150,150,270,270,380),IGO(ILEV)
*
  150 NAMT=PATH(ILEV)
      ILEV=ILEV-1
      IPLIS1=KDATA1(ILEV)
      IPLIS2=KDATA2(ILEV)
      CALL LCMNXT(IPLIS1,NAMT)
      IF(NAMT.NE.FIRST(ILEV)) GO TO 15
      GO TO (150,150,270,270,380),IGO(ILEV)
*
* LIST.
  190 IVEC(ILEV)=IVEC(ILEV)+1
      IF(IVEC(ILEV).GT.KJLON(ILEV)) THEN
         GO TO (150,150,270,270,380),IGO(ILEV)
      ENDIF
      CALL LCMLEL(KDATA1(ILEV),IVEC(ILEV),ILON1,ITY1)
      CALL LCMLEL(KDATA2(ILEV),IVEC(ILEV),ILON2,ITY2)
      IF((ILON1.NE.ILON2).OR.(ITY1.NE.ITY2)) THEN
         WRITE(6,'(/24H LCMADD: TWO COMPONENTS ,I6,5H OF '',A12,
     1   7H'' AND '',A12,23H'' ARE OF UNEQUAL TYPE (,2I4,8H) OR LEN,
     2   5HGTH (,2I7,2H).)') IVEC(ILEV),HNAME1,HNAME2,ITY1,ITY2,ILON1,
     3   ILON2
         GO TO 190
      ENDIF
      IF((ILON1.NE.0).AND.(ITY1.EQ.0)) THEN
*        ASSOCIATIVE TABLE DATA.
         ILEV=ILEV+1
         IF(ILEV.GT.MAXLEV) THEN
            WRITE(HSMG,'(2A,A12,A)') 'LCMADD: TOO MANY DIRECTORY ',
     1      'LEVELS ON ''',HNAME2,'''(3).'
            CALL XABORT(HSMG)
         ENDIF
         KJLON(ILEV)=-1
         KDATA1(ILEV)=LCMGIL(IPLIS1,IVEC(ILEV-1))
         KDATA2(ILEV)=LCMGIL(IPLIS2,IVEC(ILEV-1))
         IPLIS1=KDATA1(ILEV)
         IPLIS2=KDATA2(ILEV)
         IVEC(ILEV)=1
         IGO(ILEV)=3
         GO TO 10
      ELSE IF((ILON1.NE.0).AND.(ITY1.EQ.10)) THEN
*        LIST DATA.
         ILEV=ILEV+1
         IF(ILEV.GT.MAXLEV) THEN
            WRITE(HSMG,'(2A,A12,A)') 'LCMADD: TOO MANY DIRECTORY ',
     1      'LEVELS ON ''',HNAME2,'''(4).'
            CALL XABORT(HSMG)
         ENDIF
         KJLON(ILEV)=ILON1
         KDATA1(ILEV)=LCMGIL(IPLIS1,IVEC(ILEV-1))
         KDATA2(ILEV)=LCMGIL(IPLIS2,IVEC(ILEV-1))
         IPLIS1=KDATA1(ILEV)
         IPLIS2=KDATA2(ILEV)
         IVEC(ILEV)=0
         IGO(ILEV)=4
         GO TO 190
      ELSE IF((ILON1.NE.0).AND.(ITY1.LE.6)) THEN
         IF(ITY1.EQ.1) THEN
*           INTEGER DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGDL(IPLIS1,IVEC(ILEV),BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMGSL(IPLIS2,IVEC(ILEV),IAS2)
            ELSE
               CALL SETARA(BASE,ILON1,IAS2)
               CALL LCMGDL(IPLIS2,IVEC(ILEV),BASE(IAS2))
            ENDIF
            DO 220 I=1,ILON1
            IF(IBASE(IAS1+I-1).NE.IBASE(IAS2+I-1)) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT INTEGER DATA ON TH,
     1         32HE TWO DIRECTORIES. LIST ELEMENT=,I5,1H.)') IVEC(ILEV)
               CALL XABORT(HSMG)
            ENDIF
  220       CONTINUE
          ELSE IF((ITY1.EQ.2).OR.(ITY1.EQ.6)) THEN
*           SINGLE PRECISION OR COMPLEX DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGDL(IPLIS1,IVEC(ILEV),BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMGSL(IPLIS2,IVEC(ILEV),IAS2)
            ELSE
               CALL SETARA(BASE,ILON2,IAS2)
               CALL LCMGDL(IPLIS2,IVEC(ILEV),BASE(IAS2))
            ENDIF
            DO 230 I=1,ILON1
  230       BASE(IAS2+I-1)=BASE(IAS1+I-1)+BASE(IAS2+I-1)
            IF(LCM2) THEN
               CALL LCMPSL(IPLIS2,IVEC(ILEV),ILON2,ITY2,IAS2)
            ELSE
               CALL LCMPDL(IPLIS2,IVEC(ILEV),ILON2,ITY2,BASE(IAS2))
            ENDIF
         ELSE IF(ITY1.EQ.3) THEN
*           CHARACTER*4 DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGDL(IPLIS1,IVEC(ILEV),BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMGSL(IPLIS2,IVEC(ILEV),IAS2)
            ELSE
               CALL SETARA(BASE,ILON1,IAS2)
               CALL LCMGDL(IPLIS2,IVEC(ILEV),BASE(IAS2))
            ENDIF
            DO 240 I=1,ILON1
              WRITE(CTMP1,'(A4)') BASE(IAS1+I-1)
              WRITE(CTMP2,'(A4)') BASE(IAS2+I-1)
              IF(CTMP1.NE.CTMP2) THEN
                 WRITE(HSMG,'(38HLCMADD: INCONSISTENT CHARACTER DATA ON,
     1           35H THE TWO DIRECTORIES. LIST ELEMENT=,I5,1H.)')
     2           IVEC(ILEV)
                 CALL XABORT(HSMG)
              ENDIF
  240       CONTINUE
         ELSE IF(ITY1.EQ.4) THEN
*           DOUBLE PRECISION DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGDL(IPLIS1,IVEC(ILEV),BASE(IAS1))
            IF(LCM2) THEN
               CALL LCMGSL(IPLIS2,IVEC(ILEV),IAS2)
            ELSE
               CALL SETARA(BASE,ILON1,IAS2)
               CALL LCMGDL(IPLIS2,IVEC(ILEV),BASE(IAS2))
            ENDIF
            DO 250 I=1,ILON1/2
            RR1(1)=BASE(IAS1+(I-1)*2)
            RR1(2)=BASE(IAS1+(I-1)*2+1)
            RR2(1)=BASE(IAS2+(I-1)*2)
            RR2(2)=BASE(IAS2+(I-1)*2+1)
            DD2=DD1+DD2
            BASE(IAS2+(I-1)*2)=RR2(1)
  250       BASE(IAS2+(I-1)*2+1)=RR2(2)
            IF(LCM2) THEN
               CALL LCMPSL(IPLIS2,IVEC(ILEV),ILON2,ITY2,IAS2)
            ELSE
               CALL LCMPDL(IPLIS2,IVEC(ILEV),ILON2,ITY2,BASE(IAS2))
            ENDIF
         ELSE IF(ITY1.EQ.5) THEN
*           LOGICAL DATA.
            CALL SETARA(BASE,ILON1,IAS1)
            CALL LCMGDL(IPLIS1,IVEC(ILEV),BASE(IAS2))
            IF(LCM2) THEN
               CALL LCMGSL(IPLIS2,IVEC(ILEV),IAS2)
            ELSE
               CALL SETARA(BASE,ILON1,IAS2)
               CALL LCMGDL(IPLIS2,IVEC(ILEV),BASE(IAS2))
            ENDIF
            DO 260 I=1,ILON1
            IF(LBASE(IAS1+I-1).NEQV.LBASE(IAS2+I-1)) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT LOGICAL DATA ON TH,
     1         32HE TWO DIRECTORIES. LIST ELEMENT=,I5,1H.)') IVEC(ILEV)
               CALL XABORT(HSMG)
            ENDIF
  260       CONTINUE
         ELSE
            CALL XABORT('LCMADD: INVALID DATA TYPE(2).')
         ENDIF
         IF(.NOT.LCM2) CALL RLSARA(BASE(IAS2))
         CALL RLSARA(BASE(IAS1))
      ENDIF
      GO TO 190
*
  270 ILEV=ILEV-1
      IPLIS1=KDATA1(ILEV)
      IPLIS2=KDATA2(ILEV)
      GO TO 190
*
  380 RETURN
      END
