*DECK LCMCL
      SUBROUTINE LCMCL(IPLIST,IACT)
*
*----------------------------------------------------------------------
*
* CLOSE, DESTROY OR ERASE A TABLE WITH VALIDATION.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE EXISTING TABLE.
*    IACT : =1 TO CLOSE; =2 TO DESTROY; =3 TO ERASE AND CLOSE.
*
*------------------------------------ AUTHOR: A. HEBERT ; 21/10/93 ----
*
      PARAMETER (MAXLEV=50)
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2)
      CHARACTER HSMG*131
      INTEGER PTMP
      INTEGER KDATA(MAXLEV),KJLON(MAXLEV),IVEC(MAXLEV),IGO(MAXLEV)
      COMMON IBASE(1)
*
      IF((IBASE(IPLIST+IHEAD).NE.100).AND.(IBASE(IPLIST+IHEAD).NE.200))
     1   THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMCL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+K),K=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+ILLIST).GE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMCL: THE OBJECT ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS A LIST.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         IF(IACT.EQ.3) THEN
            WRITE(HSMG,'(A,3A4,A)') 'LCMCL: THE XSM FILE ''',
     1      (IBASE(IPLIST+IHNAM+I),I=0,2),''' CANNOT BE ERASED.'
            CALL XABORT(HSMG)
         ENDIF
         CALL XSMCL(IPLIST,IACT)
         RETURN
      ELSE IF((IACT.NE.1).AND.(IACT.NE.2).AND.(IACT.NE.3)) THEN
         WRITE(HSMG,'(A,I3,A,3A4,A)') 'LCMCL: INVALID ACTION (',IACT,
     1   ') ON THE TABLE ''',(IBASE(IPLIST+IHNAM+K),K=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMCL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+K),K=0,2),''' IS ALREADY CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IFATH).NE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMCL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+K),K=0,2),''' IS NOT ROOT.'
         CALL XABORT(HSMG)
      ENDIF
*
      CALL LCMVAL(IPLIST,' ')
*
      IF((IACT.EQ.2).OR.(IACT.EQ.3)) THEN
*        DESTROY OR ERASE THE TABLE.
         IF(IBASE(IPLIST+IMODE).EQ.2) THEN
            WRITE(HSMG,'(2A,3A4,A)') 'LCMCL: CANNOT DESTROY OR ERASE ',
     1      'THE TABLE ''',(IBASE(IPLIST+IHNAM+I),I=0,2),
     2      ''' OPEN IN READ-ONLY MODE.'
            CALL XABORT(HSMG)
         ENDIF
*
*        RECURSIVE DESTRUCTION OF THE TABLE CONTENT WITH ADDRESS IPLIST.
*        ILEV IS THE RECURSION LEVEL.
         ILEV=1
         KDATA(1)=IPLIST
         KJLON(1)=-1
         IVEC(1)=1
         IGO(1)=5
*
*        ASSOCIATIVE TABLE.
   10    INODE=IBASE(IPLIST+INEXT)
         IF(INODE.EQ.0) GO TO (70,70,90,90,110),IGO(ILEV)
         NREF=IBASE(IPLIST+INREF)
         IREF=0
   20    IREF=IREF+1
         IF(IREF.GT.NREF) THEN
            IF(INODE.NE.0) CALL RLSARA(IBASE(INODE))
            GO TO (70,70,90,90,110),IGO(ILEV)
         ENDIF
         PTMP=INODE+10*(IREF-1)
         ILONG=IBASE(PTMP+JJLON)
         ITYLCM=IBASE(PTMP+JJTYP)
         IF(ITYLCM.EQ.0) THEN
*           ASSOCIATIVE TABLE DATA.
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) THEN
               WRITE(HSMG,'(2A,3A4,A)') 'LCMEQU: TOO MANY DIRECTORY ',
     1         'LEVELS ON ''',(IBASE(IPLIST+IHNAM+I),I=0,2),'''(1).'
               CALL XABORT(HSMG)
            ENDIF
            KDATA(ILEV)=IBASE(PTMP+JDATA)
            KJLON(ILEV)=-1
            IPLIST=KDATA(ILEV)
            IVEC(ILEV)=1
            IGO(ILEV)=1
            GO TO 10
         ELSE IF(ITYLCM.EQ.10) THEN
*           LIST DATA.
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) THEN
               WRITE(HSMG,'(2A,3A4,A)') 'LCMEQU: TOO MANY DIRECTORY ',
     1         'LEVELS ON ''',(IBASE(IPLIST+IHNAM+I),I=0,2),'''(3).'
               CALL XABORT(HSMG)
            ENDIF
            KDATA(ILEV)=IBASE(PTMP+JDATA)
            KJLON(ILEV)=ILONG
            IPLIST=KDATA(ILEV)
            IVEC(ILEV)=0
            IGO(ILEV)=2
            GO TO 80
         ELSE IF(ITYLCM.NE.99) THEN
            CALL RLSARA(IBASE(IBASE(PTMP+JDATA)))
         ENDIF
         GO TO 20
*
   70    ILEV=ILEV-1
         IREF=IBASE(IPLIST+IFDIR)
         IOFPRE=IPLIST
         CALL LCMKEP(IBASE(IPLIST+ICANG),2,IPLIST)
         CALL RLSARA(IBASE(IOFPRE))
         IPLIST=KDATA(ILEV)+(IVEC(ILEV)-1)*LFNODE
         INODE=IBASE(IPLIST+INEXT)
         NREF=IBASE(IPLIST+INREF)
         GO TO 20
*
*        LIST.
   80    IVEC(ILEV)=IVEC(ILEV)+1
         IF(IVEC(ILEV).GT.KJLON(ILEV)) THEN
            GO TO (70,70,90,90,110),IGO(ILEV)
         ENDIF
         KNODE=IBASE(KDATA(ILEV)+(IVEC(ILEV)-1)*LFNODE+INEXT)
         IF(KNODE.EQ.0) GO TO 80
         ILONG=IBASE(KNODE+JJLON)
         ITYLCM=IBASE(KNODE+JJTYP)
         IF(ITYLCM.EQ.0) THEN
*           ASSOCIATIVE TABLE DATA.
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) THEN
               WRITE(HSMG,'(2A,3A4,A)') 'LCMEQU: TOO MANY DIRECTORY ',
     1         'LEVELS ON ''',(IBASE(IPLIST+IHNAM+I),I=0,2),'''(4).'
               CALL XABORT(HSMG)
            ENDIF
            KDATA(ILEV)=IBASE(KNODE+JDATA)
            KJLON(ILEV)=-1
            IPLIST=KDATA(ILEV)
            IVEC(ILEV)=1
            IGO(ILEV)=3
            GO TO 10
         ELSE IF(ITYLCM.EQ.10) THEN
*           LIST DATA.
            ILEV=ILEV+1
            IF(ILEV.GT.MAXLEV) THEN
               WRITE(HSMG,'(2A,3A4,A)') 'LCMEQU: TOO MANY DIRECTORY ',
     1         'LEVELS ON ''',(IBASE(IPLIST+IHNAM+I),I=0,2),'''(5).'
               CALL XABORT(HSMG)
            ENDIF
            KDATA(ILEV)=IBASE(KNODE+JDATA)
            KJLON(ILEV)=ILONG
            IPLIST=KDATA(ILEV)
            IVEC(ILEV)=0
            IGO(ILEV)=4
            GO TO 80
         ELSE IF(ITYLCM.NE.99) THEN
            CALL RLSARA(IBASE(IBASE(KNODE+JDATA)))
            CALL RLSARA(IBASE(KNODE))
         ENDIF
         GO TO 80         
*
   90    ILEV=ILEV-1
         IOFPRE=IPLIST
         CALL LCMKEP(IBASE(IPLIST+ICANG),2,IPLIST)
         CALL RLSARA(IBASE(IOFPRE))
         IPLIST=KDATA(ILEV)
         KNODE=IBASE(KDATA(ILEV)+(IVEC(ILEV)-1)*LFNODE+INEXT)
         CALL RLSARA(IBASE(KNODE))
         GO TO 80
*        END OF RECURSIVE DESTRUCTION
      ELSE
         IPKEEP=IBASE(IPLIST+ICANG)
         N=IBASE(IPKEEP)
         IF(N.GT.0) THEN
            IOF=IBASE(IPKEEP+2)
            DO 100 I=1,N
            IOFPRE=IBASE(IOF+I-1)
  100       IBASE(IOFPRE+IMODE)=0
         ENDIF
      ENDIF
*
  110 IF((IBASE(IPLIST+IFATH).EQ.0).AND.(IACT.EQ.2)) THEN
*        DESTROY THE TABLE.
         IBASE(IPLIST+IHEAD)=0
         IPKEEP=IBASE(IPLIST+ICANG)
         N=IBASE(IPKEEP)
         IF(N.GT.0) THEN
            IOF=IBASE(IPKEEP+2)
            DO 120 I=1,N
            CALL RLSARA(IBASE(IBASE(IOF+I-1)))
  120       CONTINUE
            CALL RLSARA(IBASE(IOF))
         ENDIF
         CALL RLSARA(IBASE(IBASE(IPLIST+ICANG)))
         CALL RLSARA(IBASE(IPLIST))
         IPLIST=0
      ELSE IF((IBASE(IPLIST+IFATH).EQ.0).AND.(IACT.EQ.3)) THEN
*        ERASE THE TABLE.
         IBASE(IPLIST+INEXT)=0
         IBASE(IPLIST+IMODE)=0
         IBASE(IPLIST+INREF)=0
      ELSE
         IBASE(IPLIST+IMODE)=0
      ENDIF
      RETURN
      END
