*DECK LCMDID
      FUNCTION LCMDID(IPLIST,NAMP)
*
*----------------------------------------------------------------------
*
* CREATE/ACCESS A DAUGHTER ASSOCIATIVE TABLE IN A FATHER TABLE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE FATHER TABLE.
*    NAMP : CHARACTER*12 NAME OF THE DAUGHTER ASSOCIATIVE TABLE.
*
* OUTPUT PARAMETER:
*  LCMDID : ADDRESS OF THE DAUGHTER ASSOCIATIVE TABLE.
*
*------------------------------------ AUTHOR: A. HEBERT ; 27/10/93 ----
*
      PARAMETER (MAXEXT=70,LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JCMT=7)
      INTEGER INAMT(3),PTMP
      CHARACTER NAMP*(*),NAMT*12,HSMG*131
      COMMON IBASE(1)
*
      IF((IBASE(IPLIST+IHEAD).NE.100).AND.(IBASE(IPLIST+IHEAD).NE.200))
     1   THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDID: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+K),K=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+ILLIST).GE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDID: THE OBJECT ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS A LIST.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMDID(IPLIST,NAMP,JPLIST)
         LCMDID=JPLIST
         RETURN
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDID: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDID: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS OPEN IN READ-ONLY MODE.'
         CALL XABORT(HSMG)
      ENDIF
*
*     MOVE TO A SON DIRECTORY.
      NAMT=NAMP
      CALL LCMCAR(NAMT,.TRUE.,INAMT)
*     CHECK IF THE DIRECTORY EXISTS IN THE NODE TABLE.
      IPNODE=IBASE(IPLIST+INEXT)
      MODE=IBASE(IPLIST+IMODE)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      IF(IPNODE.EQ.0) GO TO 15
      JHASH=10*IBASE(IPLIST+IMAX)
      DO 10 I=IBASE(IPNODE+JHASH+IPOS),1,-1
      PTMP=IPNODE+10*(I-1)
      IF(INAMT(1).EQ.IBASE(PTMP+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(PTMP+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(PTMP+JCMT+2)) THEN
*              THE DIRECTORY EXISTS IN THE NODE TABLE.
               IREF=I
               GO TO 60
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
*
*     CREATE A NEW NODE TABLE.
   15 IREF=IBASE(IPLIST+INREF)+1
      IF(IREF.GT.IBASE(IPLIST+IMAX)) THEN
*        INCREASE THE SIZE OF THE NODE TABLE.
         NSIZE=10*(IBASE(IPLIST+IMAX)+MAXEXT)+LHASH
         CALL SETARA(IBASE,NSIZE,JPNODE)
         IBASE(IPLIST+INEXT)=JPNODE
         JHASH2=10*(IBASE(IPLIST+IMAX)+MAXEXT)
         IF(IPNODE.NE.0) THEN
            DO 20 I=0,10*IBASE(IPLIST+IMAX)-1
   20       IBASE(JPNODE+I)=IBASE(IPNODE+I)
            DO 30 I=0,LHASH-1
   30       IBASE(JPNODE+JHASH2+I)=IBASE(IPNODE+JHASH+I)
            CALL RLSARA(IBASE(IPNODE))
         ELSE
            DO 35 I=0,LHASH-1
   35       IBASE(JPNODE+JHASH2+I)=0
         ENDIF
         IBASE(IPLIST+IMAX)=IBASE(IPLIST+IMAX)+MAXEXT
         IPNODE=JPNODE
         JHASH=JHASH2
      ENDIF
      IBASE(IPNODE+JHASH+IPOS)=MAX(IREF,IBASE(IPNODE+JHASH+IPOS))
      IBASE(IPLIST+INREF)=IREF
      DO 40 I=1,3
   40 IBASE(IPNODE+10*(IREF-1)+JCMT+I-1)=INAMT(I)
      IBASE(IPNODE+10*(IREF-1)+JJLON)=-1
      IBASE(IPNODE+10*(IREF-1)+JJTYP)=0
*
      CALL SETARA(IBASE,LFNODE,JPLIST)
      DO 50 I=0,3
   50 IBASE(JPLIST+I)=IBASE(IPLIST+I)
      IBASE(JPLIST+ILLIST)=-1
      IBASE(JPLIST+IMODE)=0
      IBASE(JPLIST+INEXT)=0
      IBASE(JPLIST+IFATH)=IPLIST
      IBASE(JPLIST+IFDIR)=IREF
      IBASE(JPLIST+IMAX)=0
      IBASE(JPLIST+INREF)=0
      IBASE(JPLIST+ICANG)=IBASE(IPLIST+ICANG)
      CALL LCMKEP(IBASE(JPLIST+ICANG),1,JPLIST)
      IBASE(IPNODE+10*(IREF-1)+JDATA)=JPLIST
*
* SWITCH TO THE SON DIRECTORY.
   60 PTMP=IPNODE+10*(IREF-1)
      IF((IBASE(PTMP+JJLON).NE.-1).OR.(IBASE(PTMP+JJTYP).NE.0)) THEN
         WRITE(HSMG,'(A,A12,A,3A4,A)') 'LCMDID: ''',NAMT,
     1   ''' IS AN INVALID DIRECTORY TYPE. TABLE=''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ENDIF
      JPLIST=IBASE(PTMP+JDATA)
      IBASE(JPLIST+IMODE)=MODE
      LCMDID=JPLIST
      RETURN
      END
