*DECK LCMDIL
      FUNCTION LCMDIL(IPLIST,ISET)
*
*----------------------------------------------------------------------
*
* CREATE/ACCESS THE HIERARCHICAL STRUCTURE OF A NODE TABLE LOCATED IN
* A LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LIST.
*    ISET : POSITION IN THE FATHER LIST OF THE SON TABLE.
*
* OUTPUT PARAMETER:
*  LCMDIL : ADDRESS OF THE SON TABLE.
*
*------------------------------------ AUTHOR: A. HEBERT ; 27/10/93 ----
*
      PARAMETER (MAXEXT=70,LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JCMT=7,NSIZE=10)
      PARAMETER (LXDIR1=11)
      INTEGER PTMP
      CHARACTER HSMG*131,TEXT4*4,TEXT12*12
      COMMON IBASE(1)
*
      IF((ISET.LE.0).OR.(ISET.GT.IBASE(IPLIST+ILLIST))) THEN
         WRITE(HSMG,'(A,I5,A,I5,A,3A4,A)') 'LCMDIL: LIST INDEX',ISET,
     1   ' OUT OF BOUNDS (1,',IBASE(IPLIST+ILLIST),') IN OBJECT ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMDID(IPLIST+(ISET-1)*LXDIR1,' ',JPLIST)
         LCMDIL=JPLIST
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDIL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDIL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMDIL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS OPEN IN READ-ONLY MODE.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IFATH).EQ.0) THEN
         WRITE(HSMG,'(2A)') 'LCMDIL: THE FATHER TABLE (''/'') IS NOT',
     1   ' A LIST.'
         CALL XABORT(HSMG)
      ELSE
         IP=IBASE(IPLIST+IFDIR)
         PTMP=IBASE(IBASE(IPLIST+IFATH)+INEXT)+10*(IP-1)
         IF(IBASE(PTMP+JJTYP).NE.10) THEN
            CALL LCMCAR(TEXT12,.FALSE.,IBASE(PTMP+JCMT))
            WRITE(HSMG,'(A,A12,A)') 'LCMDIL: THE FATHER TABLE ''',
     1      TEXT12,''' IS NOT A LIST.'
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
      IPNODE=IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)
*
      MODE=IBASE(IPLIST+IMODE)
      IF(IPNODE.EQ.0) THEN
         LENOLD=0
         ITYOLD=0
      ELSE
         LENOLD=IBASE(IPNODE+JJLON)
         ITYOLD=IBASE(IPNODE+JJTYP)
      ENDIF
*
      IF(ITYOLD.NE.0) THEN
         WRITE(HSMG,'(A,I5,A,3A4,A)') 'LCMDIL: LIST ELEMENT',ISET,
     1   ' IS AN INVALID DIRECTORY TYPE. TABLE=''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF((LENOLD.NE.0).AND.(LENOLD.NE.-1)) THEN
         WRITE(HSMG,'(A,I5,A,3A4,A)') 'LCMDIL: LIST ELEMENT',ISET,
     1   ' IS AN INVALID DIRECTORY LENGTH. TABLE=''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(LENOLD.EQ.0) THEN
*        CREATE A NEW NODE TABLE.
         CALL SETARA(IBASE,NSIZE,IPNODE)
         IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)=IPNODE
         IBASE(IPLIST+(ISET-1)*LFNODE+IMAX)=1
         IBASE(IPLIST+(ISET-1)*LFNODE+INREF)=1
         TEXT4=' '
         CALL LCMCAR(TEXT4,.TRUE.,INAMT)
         DO 30 I=1,3
   30    IBASE(IPNODE+JCMT+I-1)=INAMT
         IBASE(IPNODE+JJLON)=-1
         IBASE(IPNODE+JJTYP)=0
         CALL SETARA(IBASE,LFNODE,JPLIST)
         DO 70 J=0,3
   70    IBASE(JPLIST+J)=IBASE(IPLIST+J)
         IBASE(JPLIST+IMODE)=0
         IBASE(JPLIST+ILLIST)=-1
         IBASE(JPLIST+INEXT)=0
         IBASE(JPLIST+IFATH)=IPLIST
         IBASE(JPLIST+IFDIR)=1
         IBASE(JPLIST+IMAX)=0
         IBASE(JPLIST+INREF)=0
         IBASE(JPLIST+ICANG)=IBASE(IPLIST+ICANG)
         CALL LCMKEP(IBASE(JPLIST+ICANG),1,JPLIST)
         IBASE(IPNODE+JDATA)=JPLIST
      ENDIF
*
* SWITCH TO THE SON DIRECTORY.
      JPLIST=IBASE(IPNODE+JDATA)
      IBASE(JPLIST+IMODE)=MODE
      LCMDIL=JPLIST
      RETURN
      END
