*DECK LCMGLC
      SUBROUTINE LCMGLC(IPCPO,IPOS,LENG,NLIN,CARR)
*
*-----------------------------------------------------------------------
*
*Purpose:
* get an array of character variables from a LCM list component.
*
*Copyright:
* Copyright (C) 2010 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPCPO   pointer to the LCM object.
* IPOS    list index.
* LENG    length of each character variable in the array CARR.
* NLIN    dimension of array CARR.
*
*Parameters: output
* CARR    array of character variables.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPCPO,IPOS,LENG,NLIN
      CHARACTER*(*) CARR(NLIN)
*----
*  LOCAL VARIABLES
*----
      CHARACTER*13  FMT
      CHARACTER*131 HSMG
      COMMON IBASE(1)
*
      FMT='(           )'
      CALL SETARA(IBASE,NLIN*(LENG+3)/4,IARR)
*----
*  Read from LCM object
*----
      CALL LCMLEL(IPCPO,IPOS,ILONG,ITYLCM)
      IF(ILONG.EQ.0) THEN
         CALL LCMLIB(IPCPO)
         WRITE(HSMG,'(8HLCMGLC: ,I5,21H-TH RECORD NOT FOUND.)') IPOS
         CALL XABORT(HSMG)
      ENDIF
      CALL LCMGDL(IPCPO,IPOS,IBASE(IARR))
*----
*  Define format and dimensions for conversion
*----
      N=LENG/4
      M=MOD(LENG,4)
      IF(N.GT.0)WRITE(FMT(2:9),'(I6,''A4'')') N
      IF(M.GT.0)THEN
         IF(N.GT.0)FMT(10:10)=','
         WRITE(FMT(11:12),'(''A'',I1)') M
         N=N+1
      ENDIF
*----
*  Convert integers to strings
*----
      DO 10 I=1,NLIN
         WRITE(CARR(I)(1:LENG),FMT) (IBASE(IARR+(I-1)*N+J-1),J=1,N)
  10  CONTINUE
      CALL RLSARA(IBASE(IARR))
*
      END
