*DECK LCMKEP
      SUBROUTINE LCMKEP(IPKEEP,IMODE,IPLIST)
*
*-----------------------------------------------------------------------
*
* KEEP THE ADDRESSES OF THE FIXED LENGTH RESIDENT-MEMORY STRUCTURES.
*
* INPUT PARAMETERS:
*  IPKEEP : SETARA ADDRESS OF THE DATABASE HANDLE (ALWAYS THE SAME).
*  IMODE  : =1: ADD TO THE DATABASE; =2: REMOVE FROM THE DATABASE.
*  IPLIST : ADDRESS OF AN ACTIVE DIRECTORY.
*
* OUTPUT PARAMETER:
*  IPLIST : LAST ACTIVE DIRECTORY IN THE DATABASE. =0 IF THE
*           DATABASE IS EMPTY.
*
* DATABASE HANDLE STRUCTURE:
*  0 : NUMBER OF ADDRESSES IN THE DATABASE.
*  1 : MAXIMUM SLOTS IN THE DATABASE.
*  2 : ADDRESS OF THE DATABASE.
*
*------------------------------------------------ AUTHOR: A. HEBERT ----
*
      PARAMETER(MAXIT=100)
      COMMON IBASE(1)
*
      N=IBASE(IPKEEP)
      NMAX=IBASE(IPKEEP+1)
      IOF=IBASE(IPKEEP+2)
      IF(IMODE.EQ.1) THEN
         IF(IBASE(IPLIST).NE.100) THEN
            CALL XABORT('LCMKEP: WRONG HEADER(1).')
         ELSE IF(N+1.GT.NMAX) THEN
            NMAX=NMAX+MAXIT
            CALL SETARA(IBASE,NMAX,INEW)
            DO 10 I=1,N
   10       IBASE(INEW+I-1)=IBASE(IOF+I-1)
            IF(N.GT.0) CALL RLSARA(IBASE(IOF))
            IBASE(IPKEEP+1)=NMAX
            IBASE(IPKEEP+2)=INEW
            IOF=INEW
         ENDIF
         IBASE(IPKEEP)=N+1
         IBASE(IOF+N)=IPLIST
      ELSE IF(IMODE.EQ.2) THEN
         DO 20 I=N,1,-1
         IF(IBASE(IOF+I-1).EQ.IPLIST) THEN
            I0=I
            GO TO 30
         ENDIF
   20    CONTINUE
         CALL XABORT('LCMKEP: UNABLE TO FIND AN ADDRESS.')
   30    DO 40 I=I0,N-1
   40    IBASE(IOF+I-1)=IBASE(IOF+I)
         IBASE(IPKEEP)=IBASE(IPKEEP)-1
         IF(IBASE(IPKEEP).EQ.0) THEN
            IPLIST=0
            CALL RLSARA(IBASE(IOF))
            IBASE(IPKEEP+1)=0
            IBASE(IPKEEP+2)=0
         ELSE
            IPLIST=IBASE(IOF+IBASE(IPKEEP)-1)
            IF(IBASE(IPLIST).NE.100) THEN
               CALL XABORT('LCMKEP: WRONG HEADER(2).')
            ENDIF
         ENDIF
      ELSE
         CALL XABORT('LCMKEP: INVALID VALUE OF IMODE.')
      ENDIF
      RETURN
      END
