*DECK LCMLEL
      SUBROUTINE LCMLEL(IPLIST,ISET,ILONG,ITYLCM)
*
*-----------------------------------------------------------------------
*
* RETURN THE LENGTH AND TYPE OF A LIST ENTRY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LIST.
*    ISET : POSITION OF THE SPECIFIC ELEMENT.
*
* OUTPUT PARAMETERS:
*  ILONG  : NUMBER OF INFORMATION ELEMENTS POINTED BY THE LCM ENTRY.
*           ILONG=0 IS RETURNED IF THE ENTRY DOES NOT EXISTS.
*  ITYLCM : TYPE OF INFORMATION ELEMENTS POINTED BY THE LCM ENTRY.
*           1: INTEGER                  2: SINGLE PRECISION
*           3: CHARACTER*4              4: DOUBLE PRECISION
*           5: LOGICAL                  6: COMPLEX
*          99: EMPTY NODE
*
*------------------------------------- AUTHOR: A. HEBERT ; 20/02/00 ----
*
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,ICANG=11,LFNODE=12)
      PARAMETER (JJLON=1,JJTYP=2,JCMT=7)
      PARAMETER (LXDIR1=11)
      CHARACTER HSMG*131,TEXT12*12
      INTEGER PTMP
      COMMON IBASE(1)
*
      IF((ISET.LE.0).OR.(ISET.GT.IBASE(IPLIST+ILLIST))) THEN
         WRITE(HSMG,'(A,I5,A,I5,A,3A4,A)') 'LCMLEL: LIST INDEX',ISET,
     1   ' OUT OF BOUNDS (1,',IBASE(IPLIST+ILLIST),') IN OBJECT ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMLEN(IPLIST+(ISET-1)*LXDIR1,' ',ILONG,ITYLCM)
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLEL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLEL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IFATH).EQ.0) THEN
         WRITE(HSMG,'(2A)') 'LCMLEL: THE FATHER TABLE (''/'') IS NOT',
     1   ' A LIST.'
         CALL XABORT(HSMG)
      ELSE
         IP=IBASE(IPLIST+IFDIR)
         PTMP=IBASE(IBASE(IPLIST+IFATH)+INEXT)+10*(IP-1)
         IF(IBASE(PTMP+JJTYP).NE.10) THEN
            CALL LCMCAR(TEXT12,.FALSE.,IBASE(PTMP+JCMT))
            WRITE(HSMG,'(A,A12,A)') 'LCMLEL: THE FATHER TABLE ''',
     1      TEXT12,''' IS NOT A LIST.'
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
      IPNODE=IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)
      IF(IPNODE.EQ.0) THEN
         ILONG=0
         ITYLCM=99
      ELSE
         ILONG=IBASE(IPNODE+JJLON)
         ITYLCM=IBASE(IPNODE+JJTYP)
      ENDIF
      RETURN
      END
