*DECK LCMLEN
      SUBROUTINE LCMLEN(IPLIST,NAMP,ILONG,ITYLCM)
*
*-----------------------------------------------------------------------
*
* RETURN THE LENGTH AND TYPE OF A TABLE ENTRY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE TABLE.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*
* OUTPUT PARAMETERS:
*  ILONG  : NUMBER OF INFORMATION ELEMENTS POINTED BY THE LCM ENTRY.
*           ILONG=0 IS RETURNED IF THE ENTRY DOES NOT EXISTS.
*           ILONG=-1 IS RETURNED FOR A SCALAR DIRECTORY.
*  ITYLCM : TYPE OF INFORMATION ELEMENTS POINTED BY THE LCM ENTRY.
*           0: DIRECTORY                1: INTEGER
*           2: SINGLE PRECISION         3: CHARACTER*4
*           4: DOUBLE PRECISION         5: LOGICAL
*           6: COMPLEX                 99: EMPTY NODE
*
*------------------------------------- AUTHOR: A. HEBERT ; 28/10/93 ----
*
      PARAMETER (LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IMODE=8,IMAX=9)
      PARAMETER (JJLON=1,JJTYP=2,JCMT=7)
      CHARACTER NAMP*(*),NAMT*12,HSMG*131
      INTEGER INAMT(3)
      COMMON IBASE(1)
*
      IF((IBASE(IPLIST+IHEAD).NE.100).AND.(IBASE(IPLIST+IHEAD).NE.200))
     1   THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLEN: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+ILLIST).GE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLEN: THE OBJECT ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS A LIST.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMLEN(IPLIST,NAMP,ILONG,ITYLCM)
         RETURN
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLEN: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      CALL LCMCAR(NAMT,.TRUE.,INAMT)
      IPNODE=IBASE(IPLIST+INEXT)
      IF(IPNODE.EQ.0) GO TO 20
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      JHASH=10*IBASE(IPLIST+IMAX)
      DO 10 I=IBASE(IPNODE+JHASH+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               ILONG=IBASE(IPNODE+10*(I-1)+JJLON)
               ITYLCM=IBASE(IPNODE+10*(I-1)+JJTYP)
               RETURN
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
   20 ILONG=0
      ITYLCM=99
      RETURN
      END
