*DECK LCMLID
      FUNCTION LCMLID(IPLIST,NAMP,ILONG)
*
*----------------------------------------------------------------------
*
* CREATE/ACCESS THE HIERARCHICAL STRUCTURE OF A LIST IN A FATHER TABLE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE FATHER TABLE.
*    NAMP : CHARACTER*12 NAME OF THE LIST.
*   ILONG : DIMENSION OF THE LIST.
*
* OUTPUT PARAMETER:
*  LCMLID : ADDRESS OF THE LIST.
*
*------------------------------------ AUTHOR: A. HEBERT ; 20/02/00 ----
*
      PARAMETER (MAXEXT=70,LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JCMT=7)
      INTEGER INAMT(3),PTMP
      CHARACTER NAMP*(*),NAMT*12,HSMG*131,HNAME*12
      COMMON IBASE(1)
*
      IF((IBASE(IPLIST+IHEAD).NE.100).AND.(IBASE(IPLIST+IHEAD).NE.200))
     1   THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLID: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+K),K=0,2),''' HAS THE WRONG HEADER(1).'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+ILLIST).GE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMLID: THE OBJECT ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS A LIST.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMLID(IPLIST,NAMP,ILONG,JPLIST)
         LCMLID=JPLIST
         RETURN
      ENDIF
*
*     MOVE TO A LIST.
      NAMT=NAMP
      CALL LCMCAR(NAMT,.TRUE.,INAMT)
*     CHECK IF THE LIST EXISTS IN THE NODE TABLE.
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,A12,A)') 'LCMLID: THE TABLE ''',HNAME,
     1   ''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(A,A12,A)') 'LCMLID: THE TABLE ''',HNAME,
     1   ''' IS OPEN IN READ-ONLY MODE.'
         CALL XABORT(HSMG)
      ELSE IF(ILONG.LE.0) THEN
         WRITE(HSMG,'(2A,I5,A,A12,A,A12,A)') 'LCMLID: INVALID NODE',
     1   ' LENGTH (',ILONG,'). TABLE = ''',HNAME,''' NODE = ''',NAMT,
     2   '''.'
         CALL XABORT(HSMG)
      ENDIF
*
      IPNODE=IBASE(IPLIST+INEXT)
      MODE=IBASE(IPLIST+IMODE)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      LENOLD=0
      ITYOLD=10
      IF(IPNODE.EQ.0) GO TO 20
      JHASH=10*IBASE(IPLIST+IMAX)
      DO 10 I=IBASE(IPNODE+JHASH+IPOS),1,-1
      PTMP=IPNODE+10*(I-1)
      IF(INAMT(1).EQ.IBASE(PTMP+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(PTMP+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(PTMP+JCMT+2)) THEN
*              THE LIST EXISTS IN THE NODE TABLE.
               IREF=I
               LENOLD=IBASE(PTMP+JJLON)
               ITYOLD=IBASE(PTMP+JJTYP)
               GO TO 20
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
*
   20 IF(ITYOLD.NE.10) THEN
         WRITE(HSMG,'(A,A12,A,A12,A)') 'LCMLID: ''',NAMT,
     1   ''' IS AN INVALID LIST TYPE. TABLE=''',HNAME,'''.'
         CALL XABORT(HSMG)
      ELSE IF((LENOLD.NE.0).AND.(LENOLD.GT.ILONG)) THEN
         WRITE(HSMG,'(A,A12,A,A12,A,I6,A)') 'LCMLID: THE LIST ''',
     1   NAMT,''' OF THE TABLE ''',HNAME,''' HAS AN INVALID LENGTH (',
     2   ILONG,').'
         CALL XABORT(HSMG)
      ENDIF
*
      IF(LENOLD.EQ.0) THEN
*        CREATE A NEW NODE TABLE.
         IREF=IBASE(IPLIST+INREF)+1
         IF(IREF.GT.IBASE(IPLIST+IMAX)) THEN
*           INCREASE THE SIZE OF THE NODE TABLE.
            NSIZE=10*(IBASE(IPLIST+IMAX)+MAXEXT)+LHASH
            CALL SETARA(IBASE,NSIZE,JPNODE)
            IBASE(IPLIST+INEXT)=JPNODE
            JHASH2=10*(IBASE(IPLIST+IMAX)+MAXEXT)
            IF(IPNODE.NE.0) THEN
               DO 30 I=0,10*IBASE(IPLIST+IMAX)-1
   30          IBASE(JPNODE+I)=IBASE(IPNODE+I)
               DO 40 I=0,LHASH-1
   40          IBASE(JPNODE+JHASH2+I)=IBASE(IPNODE+JHASH+I)
               CALL RLSARA(IBASE(IPNODE))
            ELSE
               DO 45 I=0,LHASH-1
   45          IBASE(JPNODE+JHASH2+I)=0
            ENDIF
            IBASE(IPLIST+IMAX)=IBASE(IPLIST+IMAX)+MAXEXT
            IPNODE=JPNODE
            JHASH=JHASH2
         ENDIF
         PTMP=IPNODE+10*(IREF-1)
         IBASE(IPNODE+JHASH+IPOS)=MAX(IREF,IBASE(IPNODE+JHASH+IPOS))
         IBASE(IPLIST+INREF)=IREF
         DO 50 I=1,3
   50    IBASE(PTMP+JCMT+I-1)=INAMT(I)
         IBASE(PTMP+JJTYP)=10
      ENDIF
*
      IF(ILONG.NE.LENOLD) THEN
         IBASE(PTMP+JJLON)=ILONG
         CALL SETARA(IBASE,ILONG*LFNODE,IOFSET)
         IOFNEW=IOFSET
         DO 80 I=1,ILONG
         IF(I.LE.LENOLD) THEN
            DO 60 J=0,LFNODE-1
   60       IBASE(IOFSET+J)=IBASE(IBASE(PTMP+JDATA)+(I-1)*LFNODE+J)
         ELSE
            DO 70 J=0,3
   70       IBASE(IOFSET+J)=IBASE(IPLIST+J)
            IBASE(IOFSET+IMODE)=0
            IBASE(IOFSET+ILLIST)=0
            IBASE(IOFSET+INEXT)=0
            IBASE(IOFSET+IFATH)=IPLIST
            IBASE(IOFSET+IFDIR)=IREF
            IBASE(IOFSET+IMAX)=0
            IBASE(IOFSET+INREF)=0
            IBASE(IOFSET+ICANG)=IBASE(IPLIST+ICANG)
         ENDIF
   80    IOFSET=IOFSET+LFNODE
         IBASE(IOFNEW+ILLIST)=ILONG
         CALL LCMKEP(IBASE(IOFNEW+ICANG),1,IOFNEW)
         IBASE(PTMP+JDATA)=IOFNEW
      ENDIF
*
* SWITCH TO THE SON LIST.
      JPLIST=IBASE(PTMP+JDATA)
      DO 90 I=1,ILONG
   90 IBASE(JPLIST+(I-1)*LFNODE+IMODE)=MODE
      LCMLID=JPLIST
      RETURN
      END
