*DECK LCMLIL
      FUNCTION LCMLIL(IPLIST,ISET,ILONG)
*
*----------------------------------------------------------------------
*
* CREATE/ACCESS THE HIERARCHICAL STRUCTURE OF A LIST EMBEDDED IN
* ANOTHER LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE FATHER LIST.
*    ISET : POSITION OF THE EMBEDDED LIST IN THE FATHER LIST.
*   ILONG : DIMENSION OF THE EMBEDDED LIST.
*
* OUTPUT PARAMETER:
*  LCMLIL : ADDRESS OF THE EMBEDDED LIST.
*
*------------------------------------ AUTHOR: A. HEBERT ; 18/04/00 ----
*
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JCMT=7,NSIZE=10)
      PARAMETER (LXDIR1=11)
      CHARACTER HSMG*131,HNAME*12,TEXT4*4
      COMMON IBASE(1)
*
      IF((ISET.LE.0).OR.(ISET.GT.IBASE(IPLIST+ILLIST))) THEN
         WRITE(HSMG,'(A,I5,A,I5,A,3A4,A)') 'LCMLIL: LIST INDEX',ISET,
     1   ' OUT OF BOUNDS (1,',IBASE(IPLIST+ILLIST),') IN OBJECT ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         IOFF=IPLIST+(ISET-1)*LXDIR1
         CALL XSMLID(IOFF,' ',ILONG,JPLIST)
         LCMLIL=JPLIST
         RETURN
      ENDIF
*
*     MOVE TO A LIST.
*     CHECK IF THE LIST EXISTS IN THE NODE TABLE.
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(A,A12,A)') 'LCMLIL: THE TABLE ''',HNAME,
     1   ''' HAS THE WRONG HEADER(1).'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,A12,A)') 'LCMLIL: THE TABLE ''',HNAME,
     1   ''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(A,A12,A)') 'LCMLIL: THE TABLE ''',HNAME,
     1   ''' IS OPEN IN READ-ONLY MODE.'
      ELSE IF(ILONG.LE.0) THEN
         WRITE(HSMG,'(2A,I5,A,A12,2A,I5,A)') 'LCMLIL: INVALID NODE',
     1   ' LENGTH (',ILONG,'). TABLE = ''',HNAME,''' LIST ELEMENT ',
     2   '= ''',ISET,'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IFATH).EQ.0) THEN
         WRITE(HSMG,'(2A)') 'LCMLIL: THE FATHER TABLE (''/'') IS NOT',
     1   ' A LIST.'
         CALL XABORT(HSMG)
      ENDIF
*
      MODE=IBASE(IPLIST+IMODE)
      IPNODE=IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)
      IF(IPNODE.EQ.0) THEN
         LENOLD=0
         ITYOLD=10
      ELSE
         LENOLD=IBASE(IPNODE+JJLON)
         ITYOLD=IBASE(IPNODE+JJTYP)
      ENDIF
*
      IF(ITYOLD.NE.10) THEN
         WRITE(HSMG,'(A,I5,A,A12,A)') 'LCMLIL: LIST ELEMENT ',ISET,
     1   ' IS AN INVALID LIST TYPE. TABLE=''',HNAME,'''.'
         CALL XABORT(HSMG)
      ELSE IF((LENOLD.NE.0).AND.(LENOLD.GT.ILONG)) THEN
         WRITE(HSMG,'(2A,I5,A,A12,2A,I6,A)') 'LCMLIL: THE LIST EL',
     1   'EMENT ',ISET,' OF THE TABLE ''',HNAME,''' HAS AN INVALI',
     2   'D LENGTH (',ILONG,').'
         CALL XABORT(HSMG)
      ENDIF
*
      IF(LENOLD.EQ.0) THEN
*        CREATE A NEW NODE TABLE.
         CALL SETARA(IBASE,NSIZE,IPNODE)
         IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)=IPNODE
         IBASE(IPLIST+(ISET-1)*LFNODE+IMAX)=1
         IBASE(IPLIST+(ISET-1)*LFNODE+INREF)=1
         TEXT4=' '
         CALL LCMCAR(TEXT4,.TRUE.,INAMT)
         DO 10 I=1,3
   10    IBASE(IPNODE+JCMT+I-1)=INAMT
         IBASE(IPNODE+JJTYP)=10
      ENDIF
*
      IF(ILONG.NE.LENOLD) THEN
         IBASE(IPNODE+JJLON)=ILONG
         CALL SETARA(IBASE,ILONG*LFNODE,IOFSET)
         IOFNEW=IOFSET
         DO 40 I=1,ILONG
         IF(I.LE.LENOLD) THEN
            DO 20 J=0,LFNODE-1
   20       IBASE(IOFSET+J)=IBASE(IBASE(IPNODE+JDATA)+(I-1)*LFNODE+J)
         ELSE
            DO 30 J=0,3
   30       IBASE(IOFSET+J)=IBASE(IPLIST+J)
            IBASE(IOFSET+IMODE)=0
            IBASE(IOFSET+ILLIST)=0
            IBASE(IOFSET+INEXT)=0
            IBASE(IOFSET+IFATH)=IPLIST+(ISET-1)*LFNODE
            IBASE(IOFSET+IFDIR)=1
            IBASE(IOFSET+IMAX)=0
            IBASE(IOFSET+INREF)=0
            IBASE(IOFSET+ICANG)=IBASE(IPLIST+ICANG)
         ENDIF
   40    IOFSET=IOFSET+LFNODE
         IBASE(IOFNEW+ILLIST)=ILONG
         CALL LCMKEP(IBASE(IOFNEW+ICANG),1,IOFNEW)
         IBASE(IPNODE+JDATA)=IOFNEW
      ENDIF
*
* SWITCH TO THE SON LIST.
      JPLIST=IBASE(IPNODE+JDATA)
      DO 50 I=1,ILONG
   50 IBASE(JPLIST+(I-1)*LFNODE+IMODE)=MODE
      LCMLIL=JPLIST
      RETURN
      END
