*DECK LCMNOD
      SUBROUTINE LCMNOD(NUNIT,IMODE,IDIR,JLONG,ITYLCM,IASS)
*
*-----------------------------------------------------------------------
*
* EXPORT/IMPORT A SINGLE NODE. CALLED BY LCMEXP.
*
*  NUNIT  : FILE UNIT NUMBER WHERE THE EXPORT/IMPORT IS PERFORMED.
*  IMODE  : TYPE OF EXPORT/IMPORT FILE:
*           =1 SEQUENTIAL UNFORMATTED; =2 SEQUENTIAL FORMATTED (ASCII).
*   IDIR  : =1 TO EXPORT ; =2 TO IMPORT.
*  JLONG  : NODE LENGTH.
* ITYLCM  : NODE TYPE.
*   IASS  : SETARA NODE OFFSET.
*
*------------------------------------- AUTHOR: A. HEBERT ; 28/10/93 ----
*
      PARAMETER (NBLK=24,LENDAT=4)
      REAL RRR(2*NBLK)
      INTEGER III(2*NBLK),IBASE(1)
      LOGICAL LLL(2*NBLK)
      DOUBLE PRECISION DDD(NBLK)
      EQUIVALENCE (RRR,III,LLL,DDD),(BASE(1),IBASE(1))
      COMMON BASE(1)
*
      IF(IDIR.EQ.1) THEN
*        EXPORT A NODE.
         IF(ITYLCM.EQ.1) THEN
*           INTEGER DATA.
            DO 40 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IOFSET=IASS+(I-1)*NBLK-1
            DO 30 J=1,JMIN
   30       RRR(J)=BASE(IOFSET+J)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               WRITE(NUNIT) (III(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               WRITE(NUNIT,'(8I10)') (III(J),J=1,JMIN)
            ENDIF
   40       CONTINUE
         ELSE IF(ITYLCM.EQ.2) THEN
*           SINGLE PRECISION DATA.
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               DO 50 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               IOFSET=IASS+(I-1)*NBLK-1
               WRITE(NUNIT) (BASE(IOFSET+J),J=1,JMIN)
   50          CONTINUE
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               WRITE(NUNIT,'(1P,5E16.8)') (BASE(IASS+I-1),I=1,JLONG)
            ENDIF
         ELSE IF(ITYLCM.EQ.3) THEN
*           CHARACTER*4 DATA.
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               DO 60 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               WRITE(NUNIT) (LENDAT,K=1,JMIN)
   60          CONTINUE
               DO 70 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               IOFSET=IASS+(I-1)*NBLK-1
               WRITE(NUNIT) (BASE(IOFSET+J),J=1,JMIN)
   70          CONTINUE
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               WRITE(NUNIT,'(8I10)') (LENDAT,I=1,JLONG)
               WRITE(NUNIT,'(20A4)') (BASE(IASS+I-1),I=1,JLONG)
            ENDIF
         ELSE IF(ITYLCM.EQ.4) THEN
*           DOUBLE PRECISION DATA.
            DO 90 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IOFSET=IASS+2*(I-1)*NBLK-1
            DO 80 J=1,2*JMIN
   80       RRR(J)=BASE(IOFSET+J)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               WRITE(NUNIT) (DDD(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               WRITE(NUNIT,'(1P,4D20.12)') (DDD(J),J=1,JMIN)
            ENDIF
   90       CONTINUE
         ELSE IF(ITYLCM.EQ.5) THEN
*           LOGICAL DATA.
            DO 110 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IOFSET=IASS+(I-1)*NBLK-1
            DO 100 J=1,JMIN
  100       RRR(J)=BASE(IOFSET+J)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               WRITE(NUNIT) (LLL(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               WRITE(NUNIT,'(8L10)') (LLL(J),J=1,JMIN)
            ENDIF
  110       CONTINUE
         ELSE IF(ITYLCM.EQ.6) THEN
*           COMPLEX DATA.
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               DO 120 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               IOFSET=IASS+2*(I-1)*NBLK-1
               WRITE(NUNIT) (BASE(IOFSET+J),J=1,2*JMIN)
  120          CONTINUE
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               WRITE(NUNIT,'(1P,5E16.8)') (BASE(IASS+I-1),I=1,2*JLONG)
            ENDIF
         ENDIF
         CALL RLSARA(BASE(IASS))
      ELSE IF(IDIR.EQ.2) THEN
*        IMPORT A NODE.
         IF(ITYLCM.EQ.1) THEN
*           INTEGER DATA.
            CALL SETARA(BASE,JLONG,IASS)
            DO 190 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               READ(NUNIT) (III(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(8I10)') (III(J),J=1,JMIN)
            ENDIF
            IOFSET=IASS+(I-1)*NBLK-1
            DO 190 J=1,JMIN
  190       BASE(IOFSET+J)=RRR(J)
         ELSE IF(ITYLCM.EQ.2) THEN
*           SINGLE PRECISION DATA.
            CALL SETARA(BASE,JLONG,IASS)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               DO 200 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               IOFSET=IASS+(I-1)*NBLK-1
               READ(NUNIT) (BASE(IOFSET+J),J=1,JMIN)
  200          CONTINUE
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(5E16.0)') (BASE(IASS+I-1),I=1,JLONG)
            ENDIF
         ELSE IF(ITYLCM.EQ.3) THEN
*           CHARACTER*4 DATA.
            KLONG=0
            DO 210 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               READ(NUNIT) (III(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(8I10)') (III(J),J=1,JMIN)
            ENDIF
            DO 210 J=1,JMIN
  210       KLONG=KLONG+III(J)
            JLONG=(KLONG+3)/4
            CALL SETARA(BASE,JLONG,IASS)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               DO 220 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               IOFSET=IASS+(I-1)*NBLK-1
               READ(NUNIT) (BASE(IOFSET+J),J=1,JMIN)
  220          CONTINUE
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(20A4)') (BASE(IASS+I-1),I=1,JLONG)
            ENDIF
         ELSE IF(ITYLCM.EQ.4) THEN
*           DOUBLE PRECISION DATA.
            CALL SETARA(BASE,2*JLONG,IASS)
            DO 230 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               READ(NUNIT) (DDD(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(4D20.0)') (DDD(J),J=1,JMIN)
            ENDIF
            IOFSET=IASS+2*(I-1)*NBLK-1
            DO 230 J=1,2*JMIN
  230       BASE(IOFSET+J)=RRR(J)
         ELSE IF(ITYLCM.EQ.5) THEN
*           LOGICAL DATA.
            CALL SETARA(BASE,JLONG,IASS)
            DO 240 I=1,1+(JLONG-1)/NBLK
            JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               READ(NUNIT) (LLL(J),J=1,JMIN)
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(8L10)') (LLL(J),J=1,JMIN)
            ENDIF
            IOFSET=IASS+(I-1)*NBLK-1
            DO 240 J=1,JMIN
  240       BASE(IOFSET+J)=RRR(J)
         ELSE IF(ITYLCM.EQ.6) THEN
*           COMPLEX DATA.
            CALL SETARA(BASE,2*JLONG,IASS)
            IF((NUNIT.NE.0).AND.(IMODE.EQ.1)) THEN
               DO 250 I=1,1+(JLONG-1)/NBLK
               JMIN=MIN(NBLK,JLONG-(I-1)*NBLK)
               IOFSET=IASS+2*(I-1)*NBLK-1
               READ(NUNIT) (BASE(IOFSET+J),J=1,2*JMIN)
  250          CONTINUE
            ELSE IF((NUNIT.NE.0).AND.(IMODE.EQ.2)) THEN
               READ(NUNIT,'(5E16.0)') (BASE(IASS+I-1),I=1,2*JLONG)
            ENDIF
         ENDIF
      ENDIF
      RETURN
      END
