*DECK LCMOP
      SUBROUTINE LCMOP(IPLIST,NAMP,IMP,MEDIUM,IMPX)
*
*-----------------------------------------------------------------------
*
* OPEN AN EXISTING OR CREATE A NEW TABLE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE EXISTING TABLE IF IMP=1 OR IMP=2.
*    NAMP : CHARACTER*12 NAME OF THE TABLE IF IMP=0.
*     IMP : =0 TO CREATE A NEW TABLE; =1 TO MODIFY AN EXISTING TABLE;
*           =2 TO ACCESS AN EXISTING TABLE IN READ-ONLY MODE.
*  MEDIUM : =1 USE A TABLE; =2 USE AN XSM FILE.
*    IMPX : IF IMPX=0, WE SUPPRESS PRINTING ON LCMOP.
*
* OUTPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE NEW TABLE IF IMP=0.
*    NAMP : CHARACTER*12 NAME OF THE TABLE IF IMP=1 OR IMP=2.
*
* FIXED LENGTH RESIDENT-MEMORY STRUCTURE (BLOCK 1):
*    0 IHEAD  : HEADER (=200 FOR AN XSM FILE).
*    1 IHNAM  : CHARACTER*12 NAME OF THE XSM FILE.
*    4 ILLIST : NUMBER OF ELEMENTS IN THE LIST.
*    5 INEXT  : 0/SETARA INDEX OF BLOCK 2.
*    6 IFATH  : 0/SETARA INDEX OF FATHER TABLE (BLOCK 1).
*    7 IFDIR  : 0/RECORD INDEX IN FATHER TABLE.
*    8 IMODE  : 0=CLOSED/1=MODIFICATION MODE/2=READ-ONLY MODE.
*    9 IMAX   : MAXIMUM NUMBER OF RECORDS IN TABLE.
*   10 INREF  : EXACT NUMBER OF RECORDS IN TABLE.
*   11 ICANG  : SETARA ADDRESS OF THE DATABASE HANDLE.
*
* VARIABLE LENGTH RESIDENT-MEMORY STRUCTURE (BLOCK 2):
*    10-WORD BLOCK REPETED IBASE(IMAX) TIMES:
*       0 JDATA  : DATA OFFSET.
*       1 JJLON  : RECORD LENGTH (IN WORDS).
*       2 JJTYP  : RECORD TYPE.
*       3 JIDAT  : FIRST/LAST ELEMENT OF RECORD (4 WORDS).
*       7 JCMT   : CHARACTER*12 NAME OF RECORD (3 WORDS).
* 10*IBASE(IMAX) : HASH TABLE.
*
*-----------------------------------------------------------------------
*
      INTEGER IPLIST,PTMP
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JCMT=7)
      CHARACTER NAMP*(*),HNAME*12,TEXT12*12,HSMG*131
      COMMON IBASE(1)
*
      IF(MEDIUM.EQ.2) THEN
*        USE A XSM FILE TO STORE INFORMATION
         CALL XSMOP(IPLIST,NAMP,IMP,IMPX)
         RETURN
      ELSE IF(MEDIUM.NE.1) THEN
         WRITE(HSMG,'(A,I3,A)') 'LCMOP: INVALID MEDIUM (',MEDIUM,').'
         CALL XABORT(HSMG)
      ELSE IF((IMP.LT.0).OR.(IMP.GT.2)) THEN
         HNAME=NAMP
         WRITE(HSMG,'(A,I3,A,A12,A)') 'LCMOP: INVALID ACTION (',IMP,
     1   ') ON TABLE ''',HNAME,'''.'
         CALL XABORT(HSMG)
      ENDIF
      IF(IMP.EQ.0) THEN
         CALL SETARA(IBASE,LFNODE,IPLIST)
         CALL SETARA(IBASE,3,IPKEEP)
         IBASE(IPLIST+IHEAD)=100
         IF(NAMP.EQ.' ') THEN
            HNAME='*TEMPORARY*'
         ELSE
            HNAME=NAMP
         ENDIF
         READ(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         IBASE(IPLIST+ILLIST)=-1
         IBASE(IPLIST+INEXT)=0
         IBASE(IPLIST+IFATH)=0
         IBASE(IPLIST+IFDIR)=0
         IBASE(IPLIST+IMODE)=1
         IBASE(IPLIST+IMAX)=0
         IBASE(IPLIST+INREF)=0
         IBASE(IPLIST+ICANG)=IPKEEP
         IBASE(IPKEEP)=0
         IBASE(IPKEEP+1)=0
         IBASE(IPKEEP+2)=0
      ELSE
         WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         IF((IBASE(IPLIST+IHEAD).NE.100).OR.(IBASE(IPLIST+IMODE).NE.0))
     1   THEN
            IF(IBASE(IPLIST+IHEAD).NE.100) THEN
              WRITE(HSMG,'(A,A12,A,I10,A)') 'LCMOP: THE TABLE ''',
     1        HNAME,''' WITH ADDRESS =',IPLIST,' HAS THE WRONG HEADER.'
            ELSE IF(IBASE(IPLIST+IMODE).NE.0) THEN
              IF(IBASE(IPLIST+IFATH).EQ.0) THEN
                TEXT12='/'
              ELSE
                IPNODE=IBASE(IBASE(IPLIST+IFATH)+INEXT)
                IF(IPNODE.EQ.0) THEN
                   TEXT12=' '
                ELSE
                   PTMP=IPNODE+10*(IBASE(IPLIST+IFDIR)-1)
                   CALL LCMCAR(TEXT12,.FALSE.,IBASE(PTMP+JCMT))
                ENDIF
              ENDIF
              WRITE(HSMG,'(A,A12,A,A12,A,I10,A)') 'LCMOP: DIRECTORY ''',
     1        TEXT12,''' IN THE TABLE ''',HNAME,''' WITH ADDRESS =',
     2        IPLIST,' IS ALREADY OPEN.'
            ENDIF
            CALL XABORT(HSMG)
         ENDIF
         NAMP=HNAME
         IBASE(IPLIST+IMODE)=IMP
         IPKEEP=IBASE(IPLIST+ICANG)
         N=IBASE(IPKEEP)
         IF(N.GT.0) THEN
            IOF=IBASE(IPKEEP+2)
            DO 10 I=1,N
   10       IBASE(IBASE(IOF+I-1)+IMODE)=IMP
         ENDIF
      ENDIF
*
      HNAME=NAMP
      IF((IMPX.GT.0).AND.(IMP.EQ.0)) THEN
         WRITE (6,'(/1X,2A,A12,A,I12,A)') 'LCMOP: OPEN A NEW TABLE N',
     1   'AMED ''',HNAME,''' WITH ADDRESS =',IPLIST,'.'
      ELSE IF((IMPX.GT.0).AND.(IMP.EQ.1)) THEN
         WRITE (6,'(/1X,2A,A12,A,I12,A)') 'LCMOP: MODIFY A TABLE NAM',
     1   'ED ''',HNAME,''' WITH ADDRESS =',IPLIST,'.'
      ELSE IF((IMPX.GT.0).AND.(IMP.EQ.2)) THEN
         WRITE (6,'(/1X,A,A12,A,I12,A)') 'LCMOP: OPEN A TABLE NAMED ''',
     1   HNAME,''' WITH ADDRESS =',IPLIST,' IN READ-ONLY MODE.'
      ENDIF
      RETURN
      END
