*DECK LCMPLC
      SUBROUTINE LCMPLC(IPCPO,IPOS,LENG,NLIN,CARR)
*
*-----------------------------------------------------------------------
*
*Purpose:
* put an array of character variables in a LCM list component.
*
*Copyright:
* Copyright (C) 2010 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPCPO   pointer to the LCM object.
* IPOS    list index.
* LENG    length of each character variable in the array CARR.
* NLIN    dimension of array CARR.
* CARR    array of character variables.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPCPO,IPOS,LENG,NLIN
      CHARACTER*(*) CARR(NLIN)
*----
*  LOCAL VARIABLES
*----
      CHARACTER*13  FMT
      COMMON IBASE(1)
*
      FMT='(           )'
*----
*  Define format and dimensions for conversion
*----
      CALL SETARA(IBASE,NLIN*(LENG+3)/4,IARR)
      N=LENG/4
      M=MOD(LENG,4)
      IF(N.GT.0)WRITE(FMT(2:9),'(I6,''A4'')') N
      IF(M.GT.0)THEN
         IF(N.GT.0)FMT(10:10)=','
         WRITE(FMT(11:12),'(''A'',I1)') M
         N=N+1
      ENDIF
*----
*  Convert strings to integers
*----
      DO 10 I=1,NLIN
         READ(CARR(I)(1:LENG),FMT) (IBASE(IARR+(I-1)*N+J-1),J=1,N)
  10  CONTINUE
*----
*  Write to LCM object
*----
      CALL LCMPSL(IPCPO,IPOS,N*NLIN,3,IARR)
*
      END
