*DECK LCMPOF
      SUBROUTINE LCMPOF(IPLIST,NAMP,ILONG,ITYPE,IOFDUM)
*
*-----------------------------------------------------------------------
*
* ADD A NEW SETARA POINTER ENTRY IN THE TABLE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE TABLE.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*  IOFDUM : SETARA POINTER OF THE FIRST INFORMATION ELEMENT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 29/10/93 ----
*
      PARAMETER (MAXEXT=70,LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IMODE=8,IMAX=9,
     1 INREF=10)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JIDAT=3,JCMT=7)
      CHARACTER NAMP*(*),NAMT*12,HSMG*131
      INTEGER IBASE(1),INAMT(3)
      LOGICAL LBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1))
*
      IF((IBASE(IPLIST+IHEAD).NE.100).AND.(IBASE(IPLIST+IHEAD).NE.200))
     1   THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPOF: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IOFDUM.EQ.0) THEN
         NAMT=NAMP
         WRITE(HSMG,'(2A,A12,A,3A4,A)') 'LCMPOF: THE SETARA POINTER OF',
     1   ' NODE ''',NAMT,''' IS NOT ASSOCIATED IN THE TABLE ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(ILONG.LE.0) THEN
         NAMT=NAMP
         WRITE(HSMG,'(A,I5,A,A12,A,3A4,A)') 'LCMPOF: INVALID LENGTH (',
     1   ILONG,') FOR NODE ''',NAMT,''' IN THE TABLE ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+ILLIST).GE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPOF: THE OBJECT ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS A LIST.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMPOF(IPLIST,NAMP,ILONG,ITYPE,IOFDUM)
         RETURN
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPOF: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPOF: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS OPEN IN READ-ONLY MODE.'
         CALL XABORT(HSMG)
      ENDIF
*
* SCAN THE NODAL TABLE AND INCLUDE THE NEW ENTRY.
      NAMT=NAMP
      CALL LCMCAR(NAMT,.TRUE.,INAMT)
      IPNODE=IBASE(IPLIST+INEXT)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      IF(IPNODE.EQ.0) GO TO 15
      JHASH=10*IBASE(IPLIST+IMAX)
      DO 10 I=IBASE(IPNODE+JHASH+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               IREF=I
*              REMOVE THE OLD NODE.
               JOFDUM=IBASE(IPNODE+10*(IREF-1)+JDATA)
               IF(JOFDUM.NE.IOFDUM) CALL RLSARA(IBASE(JOFDUM))
               GO TO 60
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
   15 IREF=IBASE(IPLIST+INREF)+1
      IF(IREF.GT.IBASE(IPLIST+IMAX)) THEN
*        INCREASE THE SIZE OF THE NODE TABLE.
         NSIZE=10*(IBASE(IPLIST+IMAX)+MAXEXT)+LHASH
         CALL SETARA(IBASE,NSIZE,JPNODE)
         IBASE(IPLIST+INEXT)=JPNODE
         JHASH2=10*(IBASE(IPLIST+IMAX)+MAXEXT)
         IF(IPNODE.NE.0) THEN
            DO 20 I=0,10*IBASE(IPLIST+IMAX)-1
   20       IBASE(JPNODE+I)=IBASE(IPNODE+I)
            DO 30 I=0,LHASH-1
   30       IBASE(JPNODE+JHASH2+I)=IBASE(IPNODE+JHASH+I)
            CALL RLSARA(IBASE(IPNODE))
         ELSE
            DO 40 I=0,LHASH-1
   40       IBASE(JPNODE+JHASH2+I)=0
         ENDIF
         IBASE(IPLIST+IMAX)=IBASE(IPLIST+IMAX)+MAXEXT
         IPNODE=JPNODE
         JHASH=JHASH2
      ENDIF
      IBASE(IPNODE+JHASH+IPOS)=MAX(IREF,IBASE(IPNODE+JHASH+IPOS))
      IBASE(IPLIST+INREF)=IREF
      DO 50 I=1,3
   50 IBASE(IPNODE+10*(IREF-1)+JCMT+I-1)=INAMT(I)
*
* STORE THE INFORMATION RELATIVE TO THE NEW INFORMATION ELEMENT.
   60 IBASE(IPNODE+10*(IREF-1)+JDATA)=IOFDUM
      IBASE(IPNODE+10*(IREF-1)+JJLON)=ILONG
      IBASE(IPNODE+10*(IREF-1)+JJTYP)=ITYPE
*
* STORE THE FIRST AND LAST ELEMENTS FOR VALIDATION PURPOSE.
      IF((ITYPE.EQ.1).OR.(ITYPE.EQ.3)) THEN
         IBASE(IPNODE+10*(IREF-1)+JIDAT)=IBASE(IOFDUM)
         IBASE(IPNODE+10*(IREF-1)+JIDAT+1)=IBASE(IOFDUM+ILONG-1)
      ELSE IF(ITYPE.EQ.2) THEN
         BASE(IPNODE+10*(IREF-1)+JIDAT)=BASE(IOFDUM)
         BASE(IPNODE+10*(IREF-1)+JIDAT+1)=BASE(IOFDUM+ILONG-1)
      ELSE IF((ITYPE.EQ.4).OR.(ITYPE.EQ.6)) THEN
         BASE(IPNODE+10*(IREF-1)+JIDAT)=BASE(IOFDUM)
         BASE(IPNODE+10*(IREF-1)+JIDAT+1)=BASE(IOFDUM+1)
         BASE(IPNODE+10*(IREF-1)+JIDAT+2)=BASE(IOFDUM+ILONG-2)
         BASE(IPNODE+10*(IREF-1)+JIDAT+3)=BASE(IOFDUM+ILONG-1)
      ELSE IF(ITYPE.EQ.5) THEN
         LBASE(IPNODE+10*(IREF-1)+JIDAT)=LBASE(IOFDUM)
         LBASE(IPNODE+10*(IREF-1)+JIDAT+1)=LBASE(IOFDUM+ILONG-1)
      ENDIF
      IOFDUM=0
      RETURN
      END
