*DECK LCMPSL
      SUBROUTINE LCMPSL(IPLIST,ISET,ILONG,ITYPE,IOFDUM)
*
*-----------------------------------------------------------------------
*
* ADD A NEW SETARA POINTER ENTRY IN THE LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LIST.
*    ISET : POSITION OF THE SPECIFIC ELEMENT.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*  IOFDUM : SETARA POINTER OF THE FIRST INFORMATION ELEMENT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 20/02/00 ----
*
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JIDAT=3,JCMT=7,NSIZE=10)
      PARAMETER (LXDIR1=11)
      CHARACTER HSMG*131,TEXT4*4,TEXT12*12
      INTEGER PTMP,IBASE(1)
      LOGICAL LBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1))
*
      IF((ISET.LE.0).OR.(ISET.GT.IBASE(IPLIST+ILLIST))) THEN
         WRITE(HSMG,'(A,I5,A,I5,A,3A4,A)') 'LCMPSL: LIST INDEX',ISET,
     1   ' OUT OF BOUNDS (1,',IBASE(IPLIST+ILLIST),') IN OBJECT ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IOFDUM.EQ.0) THEN
         WRITE(HSMG,'(2A,I5,A,3A4,A)') 'LCMPSL: THE SETARA POINTER OF',
     1   ' LIST ELEMENT',ISET,' IS NOT ASSOCIATED IN THE TABLE ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(ILONG.LE.0) THEN
         WRITE(HSMG,'(A,I5,A,I5,A,3A4,A)') 'LCMPSL: INVALID LENGTH (',
     1   ILONG,') FOR LIST ELEMENT',ISET,' IN THE TABLE ''',
     2   (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMPOF(IPLIST+(ISET-1)*LXDIR1,' ',ILONG,ITYPE,IOFDUM)
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPSL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPSL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMPSL: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS OPEN IN READ-ONLY MODE.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IFATH).EQ.0) THEN
         WRITE(HSMG,'(2A)') 'LCMPSL: THE FATHER TABLE (''/'') IS NOT',
     1   ' A LIST.'
         CALL XABORT(HSMG)
      ELSE
         IP=IBASE(IPLIST+IFDIR)
         PTMP=IBASE(IBASE(IPLIST+IFATH)+INEXT)+10*(IP-1)
         IF(IBASE(PTMP+JJTYP).NE.10) THEN
            CALL LCMCAR(TEXT12,.FALSE.,IBASE(PTMP+JCMT))
            WRITE(HSMG,'(A,A12,A)') 'LCMPSL: THE FATHER TABLE ''',
     1      TEXT12,''' IS NOT A LIST.'
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
*
      IPNODE=IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)
      IF(IPNODE.EQ.0) THEN
         CALL SETARA(IBASE,NSIZE,IPNODE)
         IBASE(IPLIST+(ISET-1)*LFNODE+INEXT)=IPNODE
         IBASE(IPLIST+(ISET-1)*LFNODE+IMAX)=1
         IBASE(IPLIST+(ISET-1)*LFNODE+INREF)=1
         TEXT4=' '
         CALL LCMCAR(TEXT4,.TRUE.,INAMT)
         DO 10 I=1,3
   10    IBASE(IPNODE+JCMT+I-1)=INAMT
      ELSE
         JOFDUM=IBASE(IPNODE+JDATA)
         IF(JOFDUM.NE.IOFDUM) CALL RLSARA(IBASE(JOFDUM))
      ENDIF
*
* STORE THE INFORMATION RELATIVE TO THE NEW INFORMATION ELEMENT.
      IBASE(IPNODE+JDATA)=IOFDUM
      IBASE(IPNODE+JJLON)=ILONG
      IBASE(IPNODE+JJTYP)=ITYPE
*
* STORE THE FIRST AND LAST ELEMENTS FOR VALIDATION PURPOSE.
      IF((ITYPE.EQ.1).OR.(ITYPE.EQ.3)) THEN
         IBASE(IPNODE+JIDAT)=IBASE(IOFDUM)
         IBASE(IPNODE+JIDAT+1)=IBASE(IOFDUM+ILONG-1)
      ELSE IF(ITYPE.EQ.2) THEN
         BASE(IPNODE+JIDAT)=BASE(IOFDUM)
         BASE(IPNODE+JIDAT+1)=BASE(IOFDUM+ILONG-1)
      ELSE IF((ITYPE.EQ.4).OR.(ITYPE.EQ.6)) THEN
         BASE(IPNODE+JIDAT)=BASE(IOFDUM)
         BASE(IPNODE+JIDAT+1)=BASE(IOFDUM+1)
         BASE(IPNODE+JIDAT+2)=BASE(IOFDUM+ILONG-2)
         BASE(IPNODE+JIDAT+3)=BASE(IOFDUM+ILONG-1)
      ELSE IF(ITYPE.EQ.5) THEN
         LBASE(IPNODE+JIDAT)=LBASE(IOFDUM)
         LBASE(IPNODE+JIDAT+1)=LBASE(IOFDUM+ILONG-1)
      ENDIF
      IOFDUM=0
      RETURN
      END
