*DECK LCMSIX
      SUBROUTINE LCMSIX(IPLIST,NAMP,IACT)
*
*----------------------------------------------------------------------
*
* MOVE IN THE HIERARCHICAL STRUCTURE OF A NODE TABLE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE TABLE.
*    NAMP : CHARACTER*12 NAME OF THE DIRECTORY IF IACT=1. NOT USED IF
*           IACT.NE.1.
*    IACT : TYPE OF MOVEMENT IN THE HIERARCHICAL STRUCTURE.
*           0: RETURN TO THE ROOT DIRECTORY;
*           1: MOVE TO A SON DIRECTORY;
*           2: MOVE BACK TO THE PARENT DIRECTORY.
*
*------------------------------------ AUTHOR: A. HEBERT ; 27/10/93 ----
*
      PARAMETER (MAXEXT=70,LHASH=251)
      INTEGER PTMP
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,INEXT=5,IFATH=6,IFDIR=7,
     1 IMODE=8,IMAX=9,INREF=10,ICANG=11,LFNODE=12)
      PARAMETER (JDATA=0,JJLON=1,JJTYP=2,JCMT=7)
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,NAMMY*12,HSMG*131
      INTEGER INAMT(3)
      COMMON IBASE(1)
*
      IF((IBASE(IPLIST+IHEAD).NE.100).AND.(IBASE(IPLIST+IHEAD).NE.200))
     1   THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMSIX: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF((IACT.LT.0).OR.(IACT.GT.2)) THEN
         WRITE(HSMG,'(A,I3,A,3A4,A)') 'LCMSIX: INVALID ACTION (',IACT,
     1   ') ON THE TABLE ''',(IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+ILLIST).GE.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMSIX: THE OBJECT ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS A LIST.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMSIX(IPLIST,NAMP,IACT)
         RETURN
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(A,3A4,A)') 'LCMSIX: THE TABLE ''',
     1   (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS CLOSED.'
         CALL XABORT(HSMG)
      ENDIF
      IF((IACT.EQ.0).AND.(IBASE(IPLIST+IFATH).EQ.0)) RETURN
      IPNODE=IBASE(IPLIST+INEXT)
      MODE=IBASE(IPLIST+IMODE)
      NAMT=NAMP
      CALL LCMCAR(NAMT,.TRUE.,INAMT)
      IF(IACT.EQ.1) THEN
*        MOVE TO A SON DIRECTORY.
*        CHECK IF THE DIRECTORY EXISTS IN THE NODE TABLE.
         IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
         IF(IPNODE.EQ.0) GO TO 15
         JHASH=10*IBASE(IPLIST+IMAX)
         DO 10 I=IBASE(IPNODE+JHASH+IPOS),1,-1
         IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
            IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
               IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
                  IREF=I
                  GO TO 60
               ENDIF
            ENDIF
         ENDIF
   10    CONTINUE
*
*        THE DIRECTORY DOES NOT EXISTS IN THE NODE TABLE.
   15    IF(IBASE(IPLIST+IMODE).EQ.2) THEN
            IF(IBASE(IPLIST+IFATH).EQ.0) THEN
              NAMMY='/'
            ELSE
              PTMP=IBASE(IBASE(IPLIST+IFATH)+INEXT)
              IF(PTMP.EQ.0) THEN
                 NAMMY=' '
              ELSE
                 IP=IBASE(IPLIST+IFDIR)
                 CALL LCMCAR(NAMMY,.FALSE.,IBASE(PTMP+10*(IP-1)+JCMT))
              ENDIF
            ENDIF
            WRITE(6,'(/1X,2A,A12,A,A12,A,3A4,A)') 'UNABLE TO CREATE ',
     1      'DIRECTORY ''',NAMT,''' FROM DIRECTORY ''',NAMMY,
     2      ''' IN TABLE ''',(IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
            WRITE(HSMG,'(A,3A4,A)') 'LCMSIX: THE TABLE ''',
     1      (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS IN READ-ONLY MODE.'
            CALL XABORT(HSMG)
         ENDIF
*
*        CREATE A NEW NODE TABLE.
         IREF=IBASE(IPLIST+INREF)+1
         IF(IREF.GT.IBASE(IPLIST+IMAX)) THEN
*           INCREASE THE SIZE OF THE NODE TABLE.
            NSIZE=10*(IBASE(IPLIST+IMAX)+MAXEXT)+LHASH
            CALL SETARA(IBASE,NSIZE,JPNODE)
            IBASE(IPLIST+INEXT)=JPNODE
            JHASH2=10*(IBASE(IPLIST+IMAX)+MAXEXT)
            IF(IPNODE.NE.0) THEN
               DO 20 I=0,10*IBASE(IPLIST+IMAX)-1
   20          IBASE(JPNODE+I)=IBASE(IPNODE+I)
               DO 30 I=0,LHASH-1
   30          IBASE(JPNODE+JHASH2+I)=IBASE(IPNODE+JHASH+I)
               CALL RLSARA(IBASE(IPNODE))
            ELSE
               DO 35 I=0,LHASH-1
   35          IBASE(JPNODE+JHASH2+I)=0
            ENDIF
            IBASE(IPLIST+IMAX)=IBASE(IPLIST+IMAX)+MAXEXT
            IPNODE=JPNODE
            JHASH=JHASH2
         ENDIF
         IBASE(IPNODE+JHASH+IPOS)=MAX(IREF,IBASE(IPNODE+JHASH+IPOS))
         IBASE(IPLIST+INREF)=IREF
         DO 40 I=1,3
   40    IBASE(IPNODE+10*(IREF-1)+JCMT+I-1)=INAMT(I)
         IBASE(IPNODE+10*(IREF-1)+JJLON)=-1
         IBASE(IPNODE+10*(IREF-1)+JJTYP)=0
*
         CALL SETARA(IBASE,LFNODE,JPLIST)
         DO 50 I=0,3
   50    IBASE(JPLIST+I)=IBASE(IPLIST+I)
         IBASE(JPLIST+ILLIST)=-1
         IBASE(JPLIST+IMODE)=0
         IBASE(JPLIST+INEXT)=0
         IBASE(JPLIST+IFATH)=IPLIST
         IBASE(JPLIST+IFDIR)=IREF
         IBASE(JPLIST+IMAX)=0
         IBASE(JPLIST+INREF)=0
         IBASE(JPLIST+ICANG)=IBASE(IPLIST+ICANG)
         CALL LCMKEP(IBASE(JPLIST+ICANG),1,JPLIST)
         IBASE(IPNODE+10*(IREF-1)+JDATA)=JPLIST
*
* SWITCH TO THE SON DIRECTORY.
   60    PTMP=IPNODE+10*(IREF-1)
         IF((IBASE(PTMP+JJLON).NE.-1).OR.(IBASE(PTMP+JJTYP).NE.0)) THEN
            WRITE(HSMG,'(A,A12,A,3A4,A)') 'LCMSIX: ''',NAMT,
     1      ''' IS AN INVALID DIRECTORY TYPE. TABLE=''',
     2      (IBASE(IPLIST+IHNAM+I),I=0,2),'''.'
            CALL XABORT(HSMG)
         ENDIF
         IPLIST=IBASE(PTMP+JDATA)
         IBASE(IPLIST+IMODE)=MODE
      ELSE IF((IACT.EQ.0).OR.(IACT.EQ.2)) THEN
*        MOVE BACK TO THE ROOT OR PARENT DIRECTORY.
         IF(IBASE(IPLIST+IFATH).EQ.0) THEN
            WRITE(HSMG,'(A,3A4,A)') 'LCMSIX: THE TABLE ''',
     1      (IBASE(IPLIST+IHNAM+I),I=0,2),''' IS ON ROOT DIRECTORY.'
            CALL XABORT(HSMG)
         ENDIF
   80    JPLIST=IPLIST
         IPLIST=IBASE(JPLIST+IFATH)
         IF((IACT.EQ.0).AND.(IBASE(IPLIST+IFATH).NE.0)) GO TO 80
      ENDIF
      RETURN
      END
