*DECK MSTGET
      SUBROUTINE MSTGET(IPSTR,ACSTR,TYSTR,IPRINT,NELEM,IBEG,IEND,IINC,
     1           NAME)
*
*-----------------------------------------------------------------------
*
*Purpose:
* Retrieve data from an existing block and put them into input variables.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Le Tellier
*
*Parameters: input
* IPSTR   structure address.
* ACSTR   structure access.
* TYSTR   structure type.
* IPRINT  level of print index.
* NELEM   number of elements.
* IBEG    index of the first element.
* IEND    index of the last element.
* IINC    index increment between two consecutive elements.
* NAME    block name.
*
*-----------------------------------------------------------------------
      IMPLICIT NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPSTR,ACSTR,TYSTR,IPRINT,NELEM,IBEG,IEND,IINC
      CHARACTER NAME*12  
*----
*  LOCAL VARIABLES
*----
      INTEGER IOUT
      PARAMETER (IOUT=6)
      INTEGER INDIC,NITMA,NARA,ITYP,SIZE,IARA,II,JJ
      REAL FLOTT,BASE
      DOUBLE PRECISION DFLOTT
      CHARACTER TEXT12*12 
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))   
*
*     RETRIEVING BLOCK
      CALL LCMLEN(IPSTR,NAME,SIZE,ITYP)
      IF (ITYP.LE.2) THEN
         NARA=SIZE
      ELSEIF (ITYP.EQ.3) THEN
         NARA=SIZE/3
      ELSEIF (ITYP.EQ.4) THEN
         NARA=SIZE/2
      ELSE 
         CALL XABORT('MSTGET: UNSUPPORTED TYPE')
      ENDIF 
      IF (NARA.LE.0) THEN
         CALL LCMLIB(IPSTR)
         CALL XABORT('MSTGET: INVALID BLOCK '//NAME//'.')
      ENDIF
      IF (IEND.GT.NARA) 
     1  CALL XABORT('MSTGET: INCOMPATIBLE SIZE')
      CALL SETARA(BASE,SIZE,IARA)
      CALL LCMGET(IPSTR,NAME,BASE(IARA))
      IF (IPRINT.GT.2) 
     1 WRITE(IOUT,*) 'MSTGET: RETRIEVING DATA FROM '//NAME//' BLOCK'
*     PUT USER REQUESTED DATA IN INPUT VARIABLES
      DO II=IBEG,IEND,IINC
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (-INDIC.NE.ITYP)
     1      CALL XABORT('MSTGET: INVALID VARIABLE TYPE.')
         IF (ITYP.EQ.1) THEN
            NITMA=IBASE(IARA-1+II)
         ELSEIF (ITYP.EQ.2) THEN
            FLOTT=BASE(IARA-1+II)
         ELSEIF (ITYP.EQ.3) THEN
            WRITE(TEXT12,'(3A4)') (IBASE(IARA+3*(II-1)+JJ),JJ=0,2)
            NITMA=12
         ELSEIF (ITYP.EQ.4) THEN
            CALL XDDSET(DFLOTT,1,BASE(IARA+2*(II-1)))         
         ENDIF
         CALL REDPUT(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      ENDDO
*
      RETURN
      END
      
      
