*DECK MSTMOV
      SUBROUTINE MSTMOV(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY,IPSTR,ACSTR,
     1           TYSTR,IPRINT,NBDIR,DIRS,ROOT)
*
*-----------------------------------------------------------------------
*
*Purpose:
* Analyse user defined path.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Le Tellier
*
*Parameters: input
* NENTRY  number of LCM objects or files used by the operator.
* HENTRY  name of each LCM object or file:
*         HENTRY(1): modification type(L_TRACK);
*         HENTRY(2): sequential binary tracking file.
*         HENTRY(3): read-only type(L_GEOM).
* IENTRY  type of each LCM object or file:
*         =1 LCM memory object; =2 XSM file; =3 sequential binary file;
*         =4 sequential ascii file.
* JENTRY  access of each LCM object or file:
*         =0 the LCM object or file is created;
*         =1 the LCM object or file is open for modifications;
*         =2 the LCM object or file is open in read-only mode.
* KENTRY  LCM object address or file unit number.
* IPSTR   structure address.
* ACSTR   structure access.
* TYSTR   structure type.
* NBDIR   number of successive directories.
* DIRS    array of directories names.
* ROOT    flag to know if the path is relative or absolute.
*
*-----------------------------------------------------------------------
      IMPLICIT NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER NENTRY,IPRINT,IPSTR,ACSTR,TYSTR,NBDIR
      CHARACTER HENTRY(NENTRY)*12,DIRS(NBDIR)*12
      INTEGER IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
      LOGICAL ROOT
*----
*  LOCAL VARIABLES
*----
      INTEGER IOUT,NSTATE,I,NBLOCK,IBLNAM,IBLTYP,IBLLEN
      PARAMETER(IOUT=6,NSTATE=40)
      INTEGER ISTATE(NSTATE)
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
         IF (ROOT) THEN
*        FIRST OF ALL, GOING TO ROOT DIR IF THE PATH IS ABSOLUTE
            IF (IPRINT.GT.2) WRITE(IOUT,*) 'MSTMOV: GOING TO ROOT DIR'
            CALL LCMSIX(IPSTR,' ',0)
         ENDIF
         DO I=1,NBDIR
*        ENTERING SUCCESSIVE DIRECTORIES
*        (A DIRECTORY IS CREATED IF IT DOES NOT EXIST
*         AND THE STRUCTURE IS NOT IN READ-ONLY MODE)
            CALL LCMGET(IPSTR,'STATE-VECTOR',ISTATE)
            NBLOCK=ISTATE(40)
            CALL SETARA(IBASE,3*(NBLOCK+1),IBLNAM)
            CALL SETARA(IBASE,(NBLOCK+1),IBLTYP)
            CALL SETARA(IBASE,(NBLOCK+1),IBLLEN)
            IF (NBLOCK.GT.0) THEN
               CALL LCMGET(IPSTR,'REC-NAMES',IBASE(IBLNAM))
               CALL LCMGET(IPSTR,'REC-TYPES',IBASE(IBLTYP))
               CALL LCMGET(IPSTR,'REC-LENGTHS',IBASE(IBLLEN))
            ENDIF
            CALL MSTCDI(IPSTR,ACSTR,TYSTR,IPRINT,NBLOCK,DIRS(I),
     1           IBASE(IBLNAM),IBASE(IBLTYP),IBASE(IBLLEN))
            CALL RLSARA(IBASE(IBLLEN))
            CALL RLSARA(IBASE(IBLTYP))
            CALL RLSARA(IBASE(IBLNAM))
         ENDDO
*
         RETURN
         END
