      FUNCTION OBJSTK(IUNITO, IWRITE, CMODXT, NMODXT)
C
C     GAN-2000 SYSTEM: R.ROY (12/1999), VERSION 2.0
C
C             *OBJSTK* FIRST-PASS COMPILE OF THE D.A. UNIT   *IUNITO*
C                                 NOW INCLUDING OBJECTS & MODULES
C                      RESULT IS STILL THE OBJECT D.A. UNIT  *IUNITO*
C                      COMPILER COMMENTS ARE WRITTEN ON UNIT *IWRITE*
C                      STACK IS BUILT AT THE END OF          *IUNITO*
C
C        USE:          MODULE+OBJECT NAMES ARE DEFINED AND ALLOCATED,
C                      CONSISTENCE OF OBJECTS IN CALL 
C                      STATEMENTS ARE ALSO CHECKED.
C
C      INPUT: *IUNITO* IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C             *IWRITE* IS THE OUTPUT UNIT FOR COMPILER COMMENTS
C             *CMODXT* IS THE LIST OF NAMES FOR CODE-DEPENDENT MODULES
C                      CMODXT(1:NMODXT) CHARACTER*12 DEFINED VALUES
C             *NMODXT* IS THE NUMBER OF CODE-DEPENDENT MODULES
C
C       NOTE: *OBJSTK* = 0 IF NO PROBLEM WAS ENCOUNTERED WHILE COMPILING
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      INTEGER      OBJSTK, IUNITO, IWRITE, NMODXT
      CHARACTER*12 CMODXT(NMODXT)
C
      INTEGER      NMAWRD,    NMASKC,     NDCLKW,   NKEYWD,
     1             NMODST
      PARAMETER  ( NMAWRD=36, NMASKC= 3,  NDCLKW=8, NKEYWD=39,
     1             NMODST=17 )
      INTEGER      MASKCK(NMASKC), IPACKI(NMASKC),
     1             IDEBWD(NMAWRD+1), IFINWD(NMAWRD+1), JNDLEC(NMAWRD)
      CHARACTER*12 CKEYWD(NKEYWD), CDCLKW(NDCLKW), CMODST(NMODST),
     1             CMODUL, CSEMIC, CDDOT,  CDDDOT, CL2000, CPARIN, 
     2             CPARAV
      CHARACTER*8  CTCALL
      CHARACTER*18 CTCIOX, CTCOBJ
      CHARACTER*72 MYRECO, CERROR, CTITLO, CTOTCL, CBLA72
      CHARACTER*53 ALPHAB
      CHARACTER*10 DIGITS
      CHARACTER*16 CLISTO
      INTEGER      NRECOR, NINPUT, MAXLVL, NSTACK, IXRLST, IOULST,
     1             IDBLST, ILINES, ILEVEL, JRECOR, ILOGIN, IMODUL,
     2             IWORDS, NWORDS, ILOOP1, JLOOP2, JBIPRV, JBICUR,
     3             IRETCD, IRECOR, IVABEG, IVAEND, KRECOR, NOBJET,
     4             ILOWRC, IMEDRC, IHIGRC, NEMBED, NMODUL, NDATAV
      LOGICAL      LEQUAL, LOGPRV, LDATAV
C
      INTEGER  INDLIN, IDATIN, IDCLIN, IDEFIN, IUSEIN
      REAL             ADATIN
      CHARACTER*72     CDATIN
      DOUBLE PRECISION DDATIN
      INTEGER      JIN1,JIN2,JIN3,JIN4,JIN5,JINT
C
      DATA CERROR,CTITLO
     1 /'* GAN-2000 VERS 2.1 * ERROR FOUND FOR THIS LINE',
     2  '* GAN-2000 VERS 2.1 * CALLING SEQUENCE'/
      DATA CL2000 / 'CLE2000(V21)' /
      DATA CBLA72 / ' ' /
      DATA ALPHAB
     1  / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz' /
      DATA DIGITS
     1  / '0123456789' /
      DATA CKEYWD
     1  / 'INTEGER' , 'REAL'    , 'STRING'   , 'DOUBLE', 'LOGICAL',
     2    'EVALUATE', 'ECHO'    , 'ELSEIF'   , 'IF'    , 'WHILE'  ,
     3    'UNTIL'   , 'ENDWHILE', 'REPEAT'   , 'ELSE'  , 'ENDIF'  ,
     4    'THEN'    , 'DO'      , 'QUIT'     ,
     5    'NOT'     , 'ABS'     , 'CHS'      , 'LN'    , 'SIN'    ,
     6    'COS'     , 'TAN'     , 'ARCSIN'   , 'ARCCOS', 'ARCTAN' ,
     7    'EXP'     , 'SQRT'    , 'R_TO_I'   , 'D_TO_I', 'I_TO_R' ,
     8    'D_TO_R'  , 'I_TO_D'  , 'R_TO_D'   , 'I_TO_S', '_MIN_'  ,
     9    '_MAX_'   /
      DATA CDCLKW  
     1   /'PROCEDURE   ','MODULE      ','LINKED_LIST ','XSM_FILE    ',
     2    'SEQ_BINARY  ','SEQ_ASCII   ','DIR_ACCESS  ','PARAMETER   '/
      DATA CMODST
     1   /'ADD:        ','BACKUP:     ','DELETE:     ','END:        ',
     2    'EQU:        ','FIND0:      ','ABORT:      ','GREP:       ',
     3    'IOX:        ','MPX:        ','RECOVER:    ','STAT:       ',
     4    'UTL:        ','MSTR:       ','MODUL1:     ','DRVMPI:     ',
     5    'SNDMPI:     '/
      DATA CSEMIC, CDDOT, CDDDOT
     1   /    ';',   '::',  ':::'/
C
C
      OBJSTK= 0
C
C     READ TOP OF OBJECT FILE
      READ (IUNITO,REC=1,ERR=9023,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,NRECOR,NINPUT,MAXLVL,NSTACK,IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9024
      IF( CPARIN.NE.CL2000 ) GO TO 9025
      IF( IDBLST.GT.0 )THEN
         WRITE(IWRITE,'(A72,1X,A7)') CTITLO,'   LINE'
         WRITE(IWRITE,'(1H )')
      ENDIF
      IVABEG= NINPUT+NSTACK
      IVAEND= NINPUT+NSTACK
      ILOGIN= 0
      LEQUAL=.FALSE.
      LDATAV=.FALSE.
      NOBJET= -1
      NDATAV= -1
      IMODUL= 0
      LOGPRV=.TRUE.
      NEMBED= 0
      NMODUL= 0
C
C***  MAIN LOOP OVER RECORDS (BEGIN)
      DO 100 IRECOR= 2, NINPUT
C
C     READ A NEW RECORDJRECOR
      READ(IUNITO,REC=IRECOR,ERR=9023,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,ILINES,ILEVEL,JRECOR,MASKCK,IPACKI
      IF( IRETCD.NE.0 ) GO TO 9024
C
C     RECORDS  INSIDE CLE-2000, NOTHING TO DO
      IF( ILEVEL.NE.0 ) GO TO 100
C
C     RECORDS OUTSIDE CLE-2000, SCRUTINIZE...
C
C     BEGIN: MASK RECOVERY
      IWORDS= 1
      NWORDS= 1
      JBIPRV= 0
      DO 10 ILOOP1=1,72
         JLOOP2=(ILOOP1+23)/24
         JBICUR= MOD(MASKCK(JLOOP2),2)
         IWORDS= IWORDS+JBIPRV*(1-JBICUR)
         IDEBWD(NWORDS)= ILOOP1
         IFINWD(IWORDS)= ILOOP1
         NWORDS= NWORDS+JBICUR*(1-JBIPRV)
         JBIPRV= JBICUR
         MASKCK(JLOOP2)= MASKCK(JLOOP2)/2
   10 CONTINUE
      NWORDS= NWORDS-1
C     END:   MASK RECOVERY
C
C     BEGIN: UNPACK JNDLEC WITH TYPES (ITYP-1)
      DO 11 ILOOP1= 1,NWORDS
         JLOOP2=(2*ILOOP1+23)/24
         JNDLEC(ILOOP1)= MOD(IPACKI(JLOOP2),4)
         IPACKI(JLOOP2)= IPACKI(JLOOP2)/4
   11 CONTINUE
C     END:   UNPACK JNDLEC WITH TYPES (ITYP-1)
C                              
C     CHECK ALL DECLARATION STATEMENTS, IF NOT YET FOUND
      IF( LOGPRV )THEN
         KRECOR= IRECOR
         IF( JNDLEC(1).EQ.2.AND.
     1       MYRECO(IDEBWD(1):IDEBWD(1)).NE.''''.AND.
     2       IFINWD(1)-IDEBWD(1).LE.11 )THEN
            CPARAV= MYRECO(IDEBWD(1):IFINWD(1))
            DO 20 ILOOP1= 1, NDCLKW
               IF( CPARAV.EQ.CDCLKW(ILOOP1) ) ILOGIN= ILOOP1
   20       CONTINUE
            IF( ILOGIN.NE.0 )THEN
               CMODUL= CDCLKW(ILOGIN)
               IMODUL= -ILOGIN
               NMODUL= NMODUL+1
            ENDIF
         ENDIF
      ENDIF
      LOGPRV=.FALSE.
C
C     SCAN OTHER WORDS
      DO 50 ILOOP1= 1, NWORDS
C
C        ARE WE IN THE DATA SECTION ?
         IF( LDATAV )THEN
            NDATAV= NDATAV+1
C
C           INSIDE  THE DATA SECTION ( ...   :: *HERE* )
C           THEN COUNT EMBEDDED MODULES UNTIL MODULE ENDING
            IF( JNDLEC(ILOOP1).EQ.2.AND.
     1          MYRECO(IDEBWD(ILOOP1):IDEBWD(ILOOP1)).NE.''''.AND.
     2          IFINWD(ILOOP1)-IDEBWD(ILOOP1).LE.2 )THEN
               CPARAV= MYRECO(IDEBWD(ILOOP1):IFINWD(ILOOP1))
               IF( CPARAV.EQ.CDDDOT )THEN
                  NEMBED= NEMBED + 1
               ELSEIF( CPARAV.EQ.CSEMIC )THEN
                  IF( ILOOP1.NE.NWORDS ) GO TO 9010
                  IF( NEMBED.EQ.0 )THEN
C
C                    END OF STATEMENT REACHED
                     LOGPRV=.TRUE.
                  ELSE
                     NEMBED= NEMBED - 1
                  ENDIF
               ELSEIF( CPARAV.EQ.CDDOT )THEN
                  GO TO 5002 
               ENDIF
            ENDIF
         ELSE
C
C           OUTSIDE THE DATA SECTION ( *HERE*  ::  ... )
C           NOTE:   EVERY OBJECT/MODULE MUST BE FIRST DECLARED
            IF( JNDLEC(ILOOP1).NE.2.OR.
     1          MYRECO(IDEBWD(ILOOP1):IDEBWD(ILOOP1)).EQ.''''.OR.
     2          IFINWD(ILOOP1)-IDEBWD(ILOOP1).GT.15 ) GO TO 5001
            CLISTO= MYRECO(IDEBWD(ILOOP1):IFINWD(ILOOP1))
C
            IF( IFINWD(ILOOP1)-IDEBWD(ILOOP1).EQ.1.AND.
     1              CLISTO(1:2).EQ.':=' )THEN
               LEQUAL=.TRUE.
            ELSE
C
C              REMAININGS: 1 MODULE & OBJECTS ... 
               IF( IFINWD(ILOOP1)-IDEBWD(ILOOP1).GT.11 ) GO TO 5001
               CPARAV= MYRECO(IDEBWD(ILOOP1):IFINWD(ILOOP1))
               IF( CPARAV.EQ.CSEMIC )THEN
                  IF( ILOOP1.NE.NWORDS ) GO TO 9010
C
C                 END OF STATEMENT REACHED
                  LOGPRV=.TRUE.
               ELSEIF( CPARAV.EQ.CDDOT )THEN
                  LDATAV= .TRUE.
               ELSEIF( CPARAV.EQ.CDDDOT )THEN
                  GO TO 5002
               ELSE
C
C                 USING *CPARAV* VARIABLE, SCAN ALL DECLARED OBJECTS
                  ILOWRC= IVABEG
                  IHIGRC= IVAEND+1
   41             CONTINUE
                  IF( IHIGRC-ILOWRC.LE.1 )THEN
C
C                    OBJECT/MODULE NOT FOUND
                     IF( ILOGIN.EQ.0 ) GO TO 5004
                     IVAEND= IVAEND+1
C
C                    SHIFT GREATER VALUES
                     IF( IHIGRC.NE.IVAEND )THEN
                        DO 42 JLOOP2= IVAEND-1,IHIGRC,-1
                           READ (IUNITO,REC=JLOOP2,ERR=9003,
     1                        IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                      IDATIN,ADATIN,DDATIN,
     3                                      IDCLIN,IDEFIN,IUSEIN
                           IF( IRETCD.NE.0 ) GO TO 9004
                           WRITE(IUNITO,REC=JLOOP2+1,ERR=9001,
     1                        IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                      IDATIN,ADATIN,DDATIN,
     3                                      IDCLIN,IDEFIN,IUSEIN
                           IF( IRETCD.NE.0 ) GO TO 9002
   42                   CONTINUE
                     ENDIF
C
C                    CHECK IF OBJECT/MODULE NAME COMPLIES WITH THE RULES
                     IF( INDEX(ALPHAB,CPARAV(1:1)).EQ.0 )THEN
                        WRITE(IWRITE,*)'! OBJSTK: CHARACTER *',
     1                   CPARAV(JLOOP2:JLOOP2),'* IS NOT ALLOWED'
                        GO TO 5001
                     ENDIF
                     DO 45 JLOOP2= 2,12
                        JIN1=INDEX(ALPHAB,CPARAV(JLOOP2:JLOOP2))
                        JIN2=INDEX(DIGITS,CPARAV(JLOOP2:JLOOP2))
                        JIN3=INDEX(CPARAV(JLOOP2:JLOOP2),' ')
                        JIN4=INDEX(CPARAV(JLOOP2:JLOOP2),'.')
                        JIN5=INDEX(CPARAV(JLOOP2:JLOOP2),':')
                        JINT=JIN1+JIN2+JIN3+JIN4+JIN5
                        
                        IF( JINT.EQ.0 )THEN
                           WRITE(IWRITE,*)'! OBJSTK: CHARACTER *',
     1                      CPARAV(JLOOP2:JLOOP2),'* IS NOT ALLOWED'
                           GO TO 5001
                        ENDIF
   45                CONTINUE
C
C                    CHECK IF OBJECT/MODULE NAME IS A KEYWORD
                     DO 46 JLOOP2= 1,NKEYWD
                        IF( CPARAV.EQ.CKEYWD(JLOOP2) ) THEN
                           WRITE(IWRITE,*)'! OBJSTK: OBJECT *',
     1                        CPARAV,'* IS A CLE-2000 KEYWORD'
                           GO TO 5001
                        ENDIF
   46                CONTINUE
C
C                    VALID OBJECT/MODULE NAME, WRITE AT END
                     CDATIN=  CBLA72
                     INDLIN= -ILOGIN
                     IDATIN=  0
                     ADATIN=  0.
                     DDATIN=  0.D0
                     IDCLIN=  ILINES
                     IDEFIN=  0
                     IUSEIN=  0
                     DO 47 JLOOP2= 1,NDCLKW
                        IF( CPARAV.EQ.CDCLKW(JLOOP2) ) THEN
C
C                          TO ACCEPT DECLARATIONS AS DEFINED MODULES
                           INDLIN= +2
                        ENDIF
   47                CONTINUE
C
C                    VALID OBJECT/MODULE NAME, WRITE AT *IHIGRC*
                     WRITE(IUNITO,REC=IHIGRC,ERR=9001,IOSTAT=IRETCD) 
     1                  CPARAV,CDATIN,INDLIN,
     2                  IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
                     IF( IRETCD.NE.0 ) GO TO 9002
                     NOBJET= NOBJET+1
CDEBUG
C     WRITE(IWRITE,*) ' => ',CDCLKW(ABS(INDLIN)),' : ',CPARAV
CDEBUG
                  ELSE
                     IMEDRC= (IHIGRC+ILOWRC)/2
                     READ (IUNITO,REC=IMEDRC,ERR=9003,IOSTAT=IRETCD)
     1                  CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN,
     2                                       IDCLIN,IDEFIN,IUSEIN
                     IF( IRETCD.NE.0 ) GO TO 9004
                     IF( CPARIN.EQ.CPARAV )THEN
C
C                       OBJECT/MODULE FOUND
                        IF( ILOGIN.NE.0 )THEN
C
C                          DECLARATION STATEMENT, VERIFY CONSISTENCY
C                          IF IT IS THE DECLARATION MODULE NAME
                           IF( CPARAV.EQ.CDCLKW(ILOGIN) )THEN
                              IF( INDLIN.NE.+2 ) GO TO 8000
C
C                          OTHERWISE
                           ELSE
                              IF( ABS(INDLIN).NE.ILOGIN ) GO TO 8000
                           ENDIF
                        ELSE
                           IF( ABS(INDLIN).EQ.1.OR.
     1                         ABS(INDLIN).EQ.2 )THEN
C
C                             PROC/MODULE NAME IS FOUND
                              CMODUL= CPARAV
                              IMODUL= ABS(INDLIN)
                              NMODUL= NMODUL+1
                              LEQUAL=.TRUE.
                           ELSE
                              IF( LEQUAL.AND.IUSEIN.EQ.0 )THEN
C
C                                CHANGE FIRST USED LINE FOR OBJECT
                                 WRITE(IUNITO,REC=IMEDRC,ERR=9001,
     1                           IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                         IDATIN,ADATIN,DDATIN,
     3                                         IDCLIN,IDEFIN,ILINES
                                 IF( IRETCD.NE.0 ) GO TO 9002
                              ELSEIF( .NOT.LEQUAL.AND.IDEFIN.EQ.0 )THEN
C
C                                CHANGE FIRST DEFINED LINE FOR OBJECT
                                 WRITE(IUNITO,REC=IMEDRC,ERR=9001,
     1                           IOSTAT=IRETCD)CPARIN,CDATIN,INDLIN,
     2                                         IDATIN,ADATIN,DDATIN,
     3                                         IDCLIN,ILINES,IUSEIN
                                 IF( IRETCD.NE.0 ) GO TO 9002
                              ENDIF
                           ENDIF
                           NOBJET= NOBJET+1
                        ENDIF
                     ELSEIF( CPARIN.LT.CPARAV )THEN
                        ILOWRC= IMEDRC
                        GO TO 41
                     ELSE
                        IHIGRC= IMEDRC
                        GO TO 41
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
   50 CONTINUE
C
C     STATEMENT END WAS REACHED, 
C     WRITE MODULE NAME IN 1ST RECORD OF THIS STATEMENT
C                 
      IF( LOGPRV )THEN
         IF( NMODUL.EQ.0 )THEN
C
C           NO MODULE FOUND, IMPOSE 
C                 => CMODUL = 'IOX:' (WHEN NO OBJECTS)
C                 => CMODUL = 'EQU:' (OTHERWISE)
            IF( NOBJET.EQ.-1 )THEN
               CMODUL='IOX:'
            ELSE
               CMODUL='EQU:'
            ENDIF
            NMODUL= 1
            IMODUL= 2
         ELSEIF( NMODUL.NE.1 )THEN
            GO TO 5008
         ENDIF
         IF( IMODUL.EQ.2 )THEN
C
C           VERIFY MODULE NAMES 
            JLOOP2= 0
C           1) AMONG DECLARATION MODULES
            DO 61 ILOOP1= 1, NDCLKW
               IF( CMODUL.EQ.CDCLKW(ILOOP1) ) JLOOP2= ILOOP1
   61       CONTINUE
C           2) AMONG AVAILABLE STANDARD MODULES
            DO 62 ILOOP1= 1, NMODST
               IF( CMODUL.EQ.CMODST(ILOOP1) ) JLOOP2= ILOOP1
   62       CONTINUE
C           3) AMONG AVAILABLE CODE-DEPENDENT MODULES
            DO 63 ILOOP1= 1, NMODXT
               IF( CMODUL.EQ.CMODXT(ILOOP1) ) JLOOP2= ILOOP1
   63       CONTINUE
C
            IF( JLOOP2.EQ.0 )THEN
C              MODULE NOT FOUND
               ILOOP1= INDEX(CMODUL,' ')-1
               IF( ILOOP1.EQ.-1 ) ILOOP1=12
               WRITE(IWRITE,*)'! OBJSTK: MODULE ',CMODUL(1:ILOOP1),
     1                        ' NOT AVAILABLE IN THIS CODE'
               WRITE(6,*)'OBJSTK: MODULE ',CMODUL(1:ILOOP1),
     1                        ' NOT AVAILABLE IN THIS CODE'
               OBJSTK= OBJSTK+1
            ENDIF
         ENDIF
C
C
         READ (IUNITO,REC=KRECOR,ERR=9023,IOSTAT=IRETCD)
     1      CPARIN,MYRECO,ILINES,ILEVEL,JRECOR,MASKCK,IPACKI
         IF( IRETCD.NE.0 ) GO TO 9024
C
C        WITH MODULE NAME, ADD THE NUMBER OF DATA ITEMS (EXCEPT *;*)
         WRITE(IUNITO,REC=KRECOR,ERR=9023,IOSTAT=IRETCD)
     1      CMODUL,MYRECO,ILINES,ILEVEL,NDATAV,MASKCK,IPACKI
         IF( IRETCD.NE.0 ) GO TO 9024
         IF( IDBLST.GT.0 )THEN
            IF( IMODUL.GT.0 )THEN
               CTCALL= 'CALL    '
            ELSE
               CTCALL= 'DECLARE '
               CMODUL= '            '
            ENDIF
            IF( NOBJET.EQ.-1 )THEN
               CTCOBJ= ' WITHOUT  OBJ    ,' 
            ELSE
               WRITE(CTCOBJ,'(6H WITH ,I3,9H OBJ VAL,)') NOBJET
            ENDIF
            IF( NDATAV.EQ.-1 )THEN
               CTCIOX= ' WITHOUT  I/O     ' 
            ELSE
               WRITE(CTCIOX,'(6H WITH ,I3,9H I/O VAL )') NDATAV
            ENDIF
            WRITE(CTOTCL,'(A8,A12,A12,A18,A18)') CTCALL,
     1            CDCLKW(ABS(IMODUL)),CMODUL,CTCOBJ,CTCIOX
            WRITE (IWRITE,'(A72,1X,I7.4)') CTOTCL, ILINES
         ENDIF
C
C        RESET THINGS BEFORE NEXT MODULE...
         NMODUL= 0
         LEQUAL=.FALSE.
         LDATAV=.FALSE.
         NOBJET= -1
         NDATAV= -1
         IMODUL= 0
         ILOGIN= 0
      ENDIF
C
  100 CONTINUE
C***  MAIN LOOP OVER RECORDS (END)
C
C     ALL VARIABLES ARE NOW SORTED AT THE END OF THE OBJECT FILE
C
C     REWRITE TOP OF OBJECT FILE TO UPDATE *NSTACK*/*NRECOR*
      READ (IUNITO,REC=1,ERR=9003,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,JRECOR,NINPUT,MAXLVL,NSTACK,
     2   IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9004
      NOBJET= IVAEND-IVABEG
      NRECOR= IVAEND
      WRITE(IUNITO,REC=1,ERR=9001,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,NRECOR,NINPUT,MAXLVL,NSTACK,
     2   IXRLST,IOULST,IDBLST,NOBJET
      IF( IRETCD.NE.0 ) GO TO 9002
      IF( IDBLST.GT.0 ) WRITE(IWRITE,'(1H )')
C
  666 RETURN
C
 5000 WRITE(IWRITE,'(A72,A8)') CERROR,'    LINE'
      WRITE(IWRITE,'(A72,1X,I7.4)') MYRECO,ILINES
      WRITE(IWRITE,*)
      GO TO 666
 5001 WRITE(IWRITE,*)'! OBJSTK: INVALID OBJECT/MODULE NAME IN RECORD'
      OBJSTK= 5001
      GO TO 5000
 5002 WRITE(IWRITE,*)'! OBJSTK: INVALID EMBEDDED MODULES, REVIEW SYNTAX'
      OBJSTK= 5002
      GO TO 5000
 5004 WRITE(IWRITE,*)'! OBJSTK: OBJECT/MODULE NOT YET DECLARED *',
     1                CPARAV,'*'
      OBJSTK= 5004
      GO TO 5000
 5008 WRITE(IWRITE,*)'! OBJSTK: MORE THAN 1 MODULE FOUND'
      OBJSTK= 5008
      GO TO 5000
 8000 WRITE(IWRITE,*)'! OBJSTK: *',CPARAV,'* NOW WITH TYPE ',
     1                             CDCLKW(ILOGIN)
      OBJSTK= 8000
      GO TO 5000
 9001 IRETCD= -1
 9002 WRITE(IWRITE,*)'! OBJSTK: WRITING RETURN CODE =',IRETCD
      OBJSTK= IRETCD
      GO TO 666
 9003 IRETCD= -1
 9004 WRITE(IWRITE,*)'! OBJSTK: READING RETURN CODE =',IRETCD
      OBJSTK= IRETCD
      GO TO 666
 9010 WRITE(IWRITE,*)'! OBJSTK: UNEXPECTED END OF STATEMENT'
      OBJSTK= 9010
      GO TO 5000
 9023 IRETCD= -1
 9024 WRITE(IWRITE,*)'! OBJSTK: IOSTAT RETURN CODE =',IRETCD
      WRITE(IWRITE,*)'! OBJSTK: IMPOSSIBLE TO USE THIS *OBJECT* FILE'
      OBJSTK= -2
      GO TO 666
 9025 WRITE(IWRITE,*)'! OBJSTK: IMPOSSIBLE TO USE OLD  *OBJECT* FILE'
      OBJSTK= -3
      GO TO 666
      END
