      FUNCTION OBJXRF(IUNITO, IWRITE)
C
C     CLE-2000 SYSTEM: R.ROY (11/1999), VERSION 2.1
C
C             *OBJXRF* X-REF FOR OBJECTS ON THE D.A. UNIT  *IUNITO*
C                      OUTPUT IS WRITTEN ON UNIT           *IWRITE*
C
C        USE:          DRESS UP A LIST OF OBJECTS AND LINES WHERE USED.
C                      IN DEBUG MODE, ATTEMPT TO LIST POSSIBLE ERRORS.
C
C      INPUT: *IUNITO* IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C             *IWRITE* IS THE OUTPUT UNIT
C
C       NOTE: *OBJXRF* = 0 IF NO PROBLEM WAS ENCOUNTERED WHILE COMPILING
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      INTEGER      OBJXRF, IUNITO, IWRITE
C
      INTEGER      NMAWRD,    NMASKC,     NDCLKW,   NTOTXR
      PARAMETER  ( NMAWRD=36, NMASKC= 3,  NDCLKW=8, NTOTXR=7 )
      INTEGER      MASKCK(NMASKC), IPACKI(NMASKC), LINXRF(NTOTXR),
     1             IDEBWD(NMAWRD+1), IFINWD(NMAWRD+1), JNDLEC(NMAWRD)
      CHARACTER*12 CL2000, CPARIN, CPARAV, CEQUAL, MYPARM,
     1             CDCLKW(NDCLKW), CBLA12, CERROR, CSEMIC, CDDOT
      CHARACTER*72 MYRECO, CTITXR, CTITDB
      CHARACTER*24 HEADER
      CHARACTER*20 CBLA20, CDEFST, CUSEST
      CHARACTER*2  CTYPES(NDCLKW)
      INTEGER      NRECOR, NINPUT, MAXLVL, NSTACK, IXRLST, IOULST,
     1             IDBLST, ILINES, ILEVEL, ISTACK, JRECOR, ILOGIN,
     2             IWORDS, NWORDS, ILOOP1, JLOOP2, JBIPRV, JBICUR,
     3             IRETCD, IRECOR, IUSELN, IDEFLN, JLINES, NXREFT,
     4             NOBJET
      LOGICAL      LEQUAL, LFIRST
C
      INTEGER  INDLIN, IDATIN, IDCLIN, IDEFIN, IUSEIN
      REAL             ADATIN
      CHARACTER*72     CDATIN
      DOUBLE PRECISION DDATIN
C
      DATA CL2000,CEQUAL / 'CLE2000(V21)',':=          ' /
      DATA CDCLKW  
     1   /'PROCEDURE   ','MODULE      ','LINKED_LIST ','XSM_FILE    ',
     2    'SEQ_BINARY  ','SEQ_ASCII   ','DIR_ACCESS  ','PARAMETER   ' /
      DATA CSEMIC, CDDOT
     1   /    ';',   '::' /
      DATA CBLA12,CBLA20/ ' ',' '/
      DATA CTYPES / 'PR', 'MD', 'LL', 'XF', 'SB', 'SA', 'DA', '--' /
      DATA CTITXR, CTITDB
     1 / '* GAN-2000 VERS 2.1 * CROSS REFERENCE LISTING',
     2   '* GAN-2000 VERS 2.1 * DEBUG (WARNINGS AND ERRORS)' /
C
      OBJXRF= 0
C
C     READ TOP OF OBJECT FILE
      READ (IUNITO,REC=1,ERR=9023,IOSTAT=IRETCD)
     1   CPARIN,MYRECO,NRECOR,NINPUT,MAXLVL,NSTACK,
     2   IXRLST,IOULST,IDBLST,NOBJET
      IF( IRETCD.NE.0 ) GO TO 9024
      IF( CPARIN.NE.CL2000 ) GO TO 9025
C
C     CASES WHERE THERE ARE NO OBJECTS/MODULE
      IF( NOBJET.EQ.0 ) GO TO 666
C
C     CASE WHERE DEBUG IS ACTIVE
      IF( IDBLST.GT.0 )THEN
         LFIRST=.TRUE.
         CERROR= CBLA12
         CDEFST= CBLA20
         CUSEST= CBLA20
         DO 60 IRECOR=NINPUT+NSTACK+1,NINPUT+NSTACK+NOBJET
            READ (IUNITO,REC=IRECOR,ERR=9023,IOSTAT=IRETCD) 
     1         CPARIN,CDATIN,INDLIN,
     2         IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
            IF( IRETCD.NE.0 ) GO TO 9024
            IF( ABS(INDLIN).EQ.1.OR.
     1          ABS(INDLIN).EQ.2.OR.
     2          ABS(INDLIN).EQ.NDCLKW ) GO TO 60
            IF( IDEFIN.EQ.0 )THEN
               CDEFST='NOT DEFINED'
               IF( IUSEIN.EQ.0 )THEN
                  CUSEST='NOT USED'
                  CERROR='WARNING'
               ELSE
                  CUSEST='BEFORE DEFINED'
                  CERROR='EXTERNAL'
               ENDIF
            ELSEIF( IUSEIN.EQ.0 )THEN
               CUSEST='NOT USED'
               CERROR='WARNING'
            ELSE
               IF( IDCLIN.GT.IDEFIN )THEN
                  CDEFST='BEFORE DECLARED'
                  CERROR='ERROR'
                  OBJXRF= OBJXRF+1
               ENDIF
               IF( IDEFIN.GT.IUSEIN )THEN
                  CUSEST='BEFORE DEFINED'
                  CERROR='ERROR'
                  OBJXRF= OBJXRF+1
               ENDIF
            ENDIF
            IF( LFIRST.AND.CERROR.NE.CBLA12 )THEN
               WRITE(IWRITE,*)
               WRITE(IWRITE,'(A72)') CTITDB
               WRITE(IWRITE,'(A12,1H/,A12,1H/,A20,1H/,A20)')
     1            'REPORT-----','OBJECT------',
     2            'DEFINED-STATUS------','USED-STATUS---------'
               LFIRST=.FALSE.
            ENDIF
            IF( CERROR.NE.CBLA12 )THEN
               WRITE(IWRITE,'(A12,1H/,A12,1H/,A20,1H/,A20)')
     1         CERROR,CPARIN,CDEFST,CUSEST
               CERROR= CBLA12
               CDEFST= CBLA20
               CUSEST= CBLA20
            ENDIF
   60    CONTINUE
         IF(.NOT.LFIRST)THEN
            IF( OBJXRF.GT.0 )THEN
               WRITE(IWRITE,'(A12,1H>,A14,1H=,I7)')
     1         'REPORT-----',' NB. OF ERRORS',OBJXRF                  
               WRITE(IWRITE,'(A12,1H>,A26)')
     1         'REPORT-----',' MAY STILL EXECUTE WELL...'                  
            ENDIF
            WRITE(IWRITE,*)
         ENDIF
      ENDIF
C
C     CASE WHERE NO XREF WAS ASKED
      IF( IXRLST.LE.0 ) GO TO 666
C
      WRITE(IWRITE,'(A72)') CTITXR
      WRITE(IWRITE,'(1H )')
      WRITE(IWRITE,'(A12,A4,A8,A56)')'OBJECT      ','TYPE',' LIN_DCL',
     1  '    ****   FOUND IN LINES (- MEANS NEW EVALUATION)  ****'
      WRITE(IWRITE,'(1H )')
C
C***  MAIN LOOP OVER VARIABLES (BEGIN)
      DO 200 ISTACK= NINPUT+NSTACK+1, NINPUT+NSTACK+NOBJET
      READ(IUNITO,REC=ISTACK) MYPARM,CDATIN,INDLIN,
     1          IDATIN,ADATIN,DDATIN,IDCLIN,IDEFIN,IUSEIN
C
C     IF WE DO NOT WANT TO SEE PROCEDURES
C      IF( ABS(INDLIN).EQ.1 ) GO TO 200
C     IF WE DO NOT WANT TO SEE MODULES
      IF( ABS(INDLIN).EQ.2 ) GO TO 200
C
C     PREPARE HEADER FOR VARIABLE *MYPARM*
      WRITE(HEADER,'(A12,1X,A2,1X,I7.4,1H_)')
     1               MYPARM,CTYPES(ABS(INDLIN)),IDCLIN
C
      ILOGIN= 0
      JLINES= 0
      IUSELN= 0
      IDEFLN= 0
      NXREFT= 0
C
C***  MAIN LOOP OVER RECORDS   (BEGIN)
      DO 100 IRECOR= 2, NINPUT
C
C     READ A NEW RECORD
      READ(IUNITO,REC=IRECOR)
     1   CPARIN,MYRECO,ILINES,ILEVEL,JRECOR,MASKCK,IPACKI
C
C     RECORDS OUTSIDE CLE-2000
      IF( ILEVEL.EQ.0 )THEN
C
C        SKIP OBJECT/MODULE DECLARATIONS
         IF( CPARIN.NE.CBLA12 )THEN
            ILOGIN= 0
            DO 20 ILOOP1= 1, NDCLKW
               IF( CPARIN.EQ.CDCLKW(ILOOP1) ) ILOGIN= ILOOP1
   20       CONTINUE
            LEQUAL=.FALSE.
         ENDIF
         IF( ILOGIN.NE.0 ) GO TO 100
C
C        HERE, WE HAVE FOUND A SENTENCE INCLUDING A STACK...
C
C        BEGIN: MASK RECOVERY
         IWORDS= 1
         NWORDS= 1
         JBIPRV= 0
         DO 30 ILOOP1=1,72
            JLOOP2=(ILOOP1+23)/24
            JBICUR= MOD(MASKCK(JLOOP2),2)
            IWORDS= IWORDS+JBIPRV*(1-JBICUR)
            IDEBWD(NWORDS)= ILOOP1
            IFINWD(IWORDS)= ILOOP1
            NWORDS= NWORDS+JBICUR*(1-JBIPRV)
            JBIPRV= JBICUR
            MASKCK(JLOOP2)= MASKCK(JLOOP2)/2
   30    CONTINUE
         NWORDS= NWORDS-1
C        END:   MASK RECOVERY
C
C        BEGIN: UNPACK JNDLEC WITH TYPES (ITYP-1)
         DO 40 ILOOP1= 1,NWORDS
            JLOOP2=(2*ILOOP1+23)/24
            JNDLEC(ILOOP1)= MOD(IPACKI(JLOOP2),4)
            IPACKI(JLOOP2)= IPACKI(JLOOP2)/4
   40    CONTINUE
C        END:   UNPACK JNDLEC WITH TYPES (ITYP-1)
C   
         DO 50 ILOOP1= 1, NWORDS
            IF( JNDLEC(ILOOP1).EQ.2.AND.
     1          MYRECO(IDEBWD(ILOOP1):IDEBWD(ILOOP1)).NE.''''.AND.
     2          IFINWD(ILOOP1)-IDEBWD(ILOOP1).LE.11 )THEN
               CPARAV= MYRECO(IDEBWD(ILOOP1):IFINWD(ILOOP1))
               IF( CPARAV.EQ.CSEMIC.OR.CPARAV.EQ.CDDOT )THEN
C
                  IF( .NOT.LEQUAL.AND.IDEFLN.NE.0 )THEN
                     IUSELN= IDEFLN
                  ENDIF
C
C                 RESET *ILOGIN* AND LEFT/RIGHT NUMBERS
                  ILOGIN= -10
                  IDEFLN= 0
                  GO TO 55
               ELSEIF( LEQUAL )THEN
                  IF( CPARAV.EQ.MYPARM )THEN
C
C                     USING THIS VARIABLE
                      IF( IUSELN.EQ.0 ) IUSELN= ILINES
                  ENDIF
C
               ELSE
                  IF( CPARAV.EQ.CEQUAL )THEN
                     LEQUAL=.TRUE.
                     IF( IDEFLN.NE.0 )THEN
C
C                       *:=* SIGN IMPLIES REDEFINITION
                        IUSELN= -IDEFLN
                     ENDIF
                     IDEFLN= 0
C
                  ELSE
C
C                    KEEP THE DEFINITION LINE UNTIL *:=* OR END
                     IF( CPARAV.EQ.MYPARM ) IDEFLN= ILINES
                  ENDIF
               ENDIF
            ENDIF
   50    CONTINUE
   55    CONTINUE
      ENDIF
C
C     HAVE WE FOUND A NEW XREF LINE ?
      IF( IUSELN.NE.0.AND.IUSELN.NE.JLINES )THEN
         IF( NXREFT.EQ.NTOTXR )THEN
            WRITE(IWRITE,'(A24,7I8.4)') HEADER, LINXRF
            HEADER= ' '
            NXREFT= 0
         ENDIF
         NXREFT= NXREFT+1
         LINXRF(NXREFT)= IUSELN
         JLINES= IUSELN
      ENDIF
      IUSELN= 0
C
  100 CONTINUE
C***  MAIN LOOP OVER RECORDS   (END)
C
C     POSSIBLE INCOMPLETE LAST LINE...
      IF( NXREFT.NE.0 )THEN
         WRITE(IWRITE,'(A24,7I8.4)') HEADER,
     1                              (LINXRF(JLOOP2),JLOOP2=1,NXREFT)
      ELSEIF( HEADER.NE.' ' )THEN
         WRITE(IWRITE,'(A24,A56)') HEADER,
     1   ' <= WARNING: NEVER DEFINED, NEVER USED... POSSIBLE ERROR'
      ENDIF
  200 CONTINUE
C***  MAIN LOOP OVER VARIABLES (END)
C
      WRITE(IWRITE,'(1H )')
  666 RETURN
 9023 IRETCD= -1
 9024 WRITE(IWRITE,*)'! OBJXRF: IOSTAT RETURN CODE =',IRETCD
      WRITE(IWRITE,*)'! OBJXRF: IMPOSSIBLE TO USE THIS *OBJECT* FILE'
      OBJXRF= -2
      GO TO 666
 9025 WRITE(IWRITE,*)'! OBJXRF: IMPOSSIBLE TO USE OLD  *OBJECT* FILE'
      OBJXRF= -3
      GO TO 666
      END
