      SUBROUTINE REDGET (ITYP,NITMA,FLOTT,TEXT,DFLOT)
C
C     CLE-2000 SYSTEM: R.ROY (04/1999), VERSION 2.1
C                      G. MARLEAU (10/2001) VERSION 2.2
C
C     THIS PACKAGE CONTAINS 4 ENTRY POINTS:
C          *REDGET* TO OUTPUT VALUES FROM INPUT STREAM;
C          *REDPUT* TO INPUT VALUES FOR CLE-2000 VARIABLES;
C          *REDOPN* TO OPEN THE DA-FILE CONTAINING CLE-2000 DATA;
C          *REDCLS* TO CLOSE THE DA-FILE AT A CURRENT RECORD POSITION.
C
C     CLE-2000 DA-FILES MUST BE FIRST COMPILED USING *CLEPIL* COMPILER.
C     IF NO ERROR OCCURS, DA-FILES ARE ACCESSED BY THE DRIVER PROGRAM
C          BY CALLING THE *REDOPN* ENTRY POINT.
C     WHEN A PROCEDURE IS TO BE CALLED, BE SURE THAT YOU HAVE FLUSHED
C          A RECORD (THAT IS READING UNTIL THE END OF SENTENCE *;*),
C          THEN CALL THE *REDCLS* ENTRY POINT AND KEEP THE OUTPUT
C          PARAMETERS FOR SUBSEQUENT USE OF THE CALLING PROGRAM;
C          YOU MAY THEN OPEN ANOTHER DA-FILE, AND SO ON.
C     BEWARE: THE *REDPUT* ENTRY IS RELIABLE, BUT NOT NORMALLY USED
C          BY OBJECT-ORIENTED DRIVER; THE PROBLEM WITH THIS ENTRY
C          IS THAT IT COULD MODIFY VALUES WITHOUT ANY CONTROL WITHIN
C          OBJECTS.
C
C
C          *REDGET* ENTRY POINT
C                   TO OUTPUT VALUES FROM INPUT STREAM
C                   EITHER BY SCANNING THE INPUT AREA
C                             OUTSIDE CLE-2000 SENTENCES;
C                       OR BY USING THE COMMAND <<.>>
C                             TO GET THE CONTENT OF A CLE-2000 VARIABLE;
C                       OR BY USING THE COMMAND >>.<<
C                             TO GET NAME & TYPE OF A CLE-2000 VARIABLE.
C
C     OUTPUT VARIABLES:
C          *ITYP*   TYPE FOR VARIABLE (-5: UNDEFINED LOGICAL
C                                      -4: UNDEFINED DOUBLE
C                                      -3: UNDEFINED STRING
C                                      -2: UNDEFINED REAL
C                                      -1: UNDEFINED INTEGER
C                                      +1:   DEFINED INTEGER
C                                      +2:   DEFINED REAL
C                                      +3:   DEFINED STRING
C                                      +4:   DEFINED DOUBLE
C                                      +5:   DEFINED LOGICAL )
C          *NITMA*  INTEGER VALUE IF *ITYP*.EQ.+1.OR.*ITYP*.EQ.+5
C          *FLOTT*  REAL    VALUE IF *ITYP*.EQ.+2
C          *TEXT*   STRING  VALUE IF *ITYP*.EQ.+3.OR.*ITYP*.LT.0
C          *DFLOT*  DOUBLE  VALUE IF *ITYP*.EQ.+4
C
C     NOTE: LOGICAL VALUES ARE GIVEN EITHER BY *TRUE* = *NITMA*.EQ.+1
C                                        OR BY *FALSE*= *NITMA*.EQ.-1
C           IN CASES WHERE *ITYP*.LT.0, WE MUST BE IN A >>*<< STATEMENT
C                          AND *TEXT* GIVES THE VARIABLE NAME.
C
C     NEXT STATEMENT (IN COMMENT) IS *NOT* STANDARD IN FORTRAN-77:
      IMPLICIT     NONE
C
      CHARACTER*(*)    TEXT
      INTEGER          ITYP, NITMA, IINP1, IOUT1, NREC
      REAL             FLOTT
      DOUBLE PRECISION DFLOT
      INTEGER          IUNITO, IWRITE
C
      INTEGER      IRETCD, ILENGT, NSTLVL, NRECOR, NWORDS, IWORDS,
     1             ILOOP1, JLOOP2, ILOGIN, IRECOR, NINPUT, ILENGV,
     2             MAXLVL, NSTLFT, NSTRGT, ILEVEL, JLEVEL, INDLIN, 
     3             INDLE2, NSTACK, IDEPAR, IVABEG, IVAEND, 
     4             JWRITE, ILGTPR, IDEFKW, ILINES, JLINES, JRECOR,
     5             IHIGRC, ILOWRC, IMEDRC, NSTPUT, JBICUR, JBIPRV,
     6             IXRLST, IOULST, IDBLST
      INTEGER      NLOGKW,    NDIMST,    IFINAL,    NMASKC,   NMAWRD
      PARAMETER  ( NLOGKW=15, NDIMST=64, IFINAL=74, NMASKC=3, NMAWRD=36)
      INTEGER      MASKCK(NMASKC), IPACKI(NMASKC),
     1             IDEBWD(NMAWRD+1), IFINWD(NMAWRD+1), JNDLEC(NMAWRD)
      CHARACTER*12 CL2000, CPARAV, CHREND, CPARIN, FORMIN,
     1             CLOGBG(NLOGKW), CLOGND(NLOGKW) 
      CHARACTER*72 MYRECO, CBLA72
      CHARACTER*80 CPRINT
      LOGICAL      LRDPUT, LRGTST
C
      INTEGER      INDLEC, IDATIN, ILENG1, ILENG2
      REAL                 ADATIN
      CHARACTER*72         CDATAV, CDATIN, CDATA1, CDATA2
      CHARACTER*72         CDATA3
      INTEGER              II,JJ
      DOUBLE PRECISION     DDATIN
C
C     STACK VALUES
      INTEGER      INDRGT(NDIMST), IRCLVL(NDIMST),
     1             IRCLFT(NDIMST), IRCPUT(NDIMST)
      INTEGER              INTSTK(NDIMST)
      REAL                 RELSTK(NDIMST)
      CHARACTER*72         CHRSTK(NDIMST)
      DOUBLE PRECISION     DBLSTK(NDIMST)
      LOGICAL              LOGSTK(NDIMST)
C
      SAVE IUNITO,IWRITE,JWRITE,IVABEG,IVAEND,ILOGIN,NWORDS,
     1     NINPUT,IRECOR,MYRECO,NSTLVL,IRCLVL,NSTPUT,IRCPUT,
     2     INDRGT,IRCLFT,INTSTK,RELSTK,CHRSTK,DBLSTK,LOGSTK,
     3     IDEBWD,IFINWD,JNDLEC,IWORDS,IOULST,IDBLST
C
      DATA CLOGBG
     1  / 'INTEGER' , 'REAL'    , 'STRING'   , 'DOUBLE', 'LOGICAL',
     2    'EVALUATE', 'ECHO'    , 'ELSEIF'   , 'IF'    , 'WHILE'  ,
     3    'UNTIL'   , 'ENDWHILE', 'REPEAT'   , 'ELSE'  , 'ENDIF'  /
      DATA CLOGND
     1  / ';'       , ';'       , ';'        , ';'     , ';'      ,
     2    ';'       , ';'       , 'THEN'     , 'THEN'  , 'DO'     ,
     3    ';'       , ';'       , 'REPEAT'   , 'ELSE'  , ';'      /
      DATA CL2000,CBLA72 / 'CLE2000(V21)','            ' /
      DATA NINPUT,IRECOR,NSTLVL,NSTPUT,IWORDS,NWORDS 
     1   /      0,     0,     0,     0,     0,     0 /
C
C     TAKE ANY LEVEL AS INPUT
      ILEVEL= -1
C
CL01> ***LOOP*** OVER WORDS (BEGIN)
C
   10 IWORDS= IWORDS+1
      IF( IWORDS.GT.NWORDS ) THEN
C
CL02>    ***LOOP*** OVER RECORDS (BEGIN)
C
   20    IRECOR= IRECOR+1
         IF( IRECOR.GT.NINPUT )THEN
            IF( NINPUT.EQ.0 )THEN
C
C              REDGET IS CLOSED
               ITYP=10
               IF( IDBLST.GT.0.AND.IWRITE.GT.0 )THEN
                  MYRECO='*READER IS CLOSED ON THAT FILE.'
                  WRITE(IWRITE,'(2H.|,A72,2H|.)') MYRECO
               ENDIF
            ELSE
               ITYP= 9
               IF( IWRITE.NE.0 )THEN
                  IF( IDBLST.GT.0 )THEN
                     MYRECO='QUIT "DEBUG" .'
                     WRITE(IWRITE,'(2H.|,A72,2H|.)') MYRECO
                  ENDIF
                  WRITE(IWRITE,'(2H .,72(1H-),1H.)')
               ENDIF
            ENDIF
            RETURN
         ENDIF
C
C        READ A NEW RECORD
         READ(IUNITO,REC=IRECOR,ERR=8000)
     1      CPARIN,MYRECO,ILINES,JLEVEL,JRECOR,MASKCK,IPACKI
         IF( ILEVEL.GE.0.AND.JLEVEL.NE.ILEVEL ) GO TO 20
C
CL02>    ***LOOP*** OVER RECORDS (ACCEPTED)
C
C        RECORD IS ACCEPTED, PRINT WHEN REQUESTED
         IF( IDBLST.LE.0.AND.JLEVEL.EQ.0 )THEN
            IF( IOULST.GT.0.AND.IWRITE.NE.0 )THEN
               WRITE(IWRITE,'(2H<|,A72,2H|<,I4.4)') MYRECO,ILINES
            ENDIF
         ELSEIF( IDBLST.GT.0.AND.IWRITE.NE.0 )THEN
            IF( JLEVEL.EQ.0 )THEN
               WRITE(IWRITE,'(2H<|,A72,2H|<,I4.4)') MYRECO,ILINES
            ELSE
               WRITE(IWRITE,'(2H.|,A72,2H|.,I4.4)') MYRECO,ILINES
            ENDIF
         ENDIF
C
C        BEGIN: MASK RECOVERY
         IWORDS= 1
         NWORDS= 1
         JBIPRV= 0
         DO 21 ILOOP1=1,72
            JLOOP2=(ILOOP1+23)/24
            JBICUR= MOD(MASKCK(JLOOP2),2)
            IWORDS= IWORDS+JBIPRV*(1-JBICUR)
            IDEBWD(NWORDS)= ILOOP1
            IFINWD(IWORDS)= ILOOP1
            NWORDS= NWORDS+JBICUR*(1-JBIPRV)
            JBIPRV= JBICUR
            MASKCK(JLOOP2)= MASKCK(JLOOP2)/2
   21    CONTINUE
         NWORDS= NWORDS-1
C        END:   MASK RECOVERY
C
C        THIS IS NOW THE FIRST WORD
         IWORDS= 1
         IF( JLEVEL.NE.0 )THEN
C
CL03>       THIS IS A NEW *CLE-2000* RECORD (BEGIN)
            IF( CPARIN.NE.' ' )THEN  
C
CL04>          TREAT SIGNIFICANT 1ST-WORD OF CLE-2000 STATEMENT (BEGIN)
               NSTLFT= 0
               NSTRGT= 0
               DO 60 ILOOP1= 1, NLOGKW
                  IF( CLOGBG(ILOOP1).EQ.CPARIN ) ILOGIN= ILOOP1
   60          CONTINUE
CDEBUG
C              SECURITY CHECK
C              IF( ILOGIN.EQ.0 )THEN
C                 CALL XABORT(CDATAV)
C              ENDIF
C              SECURITY CHECK
CDEBUG
               LRGTST= ILOGIN.GE.7.AND.ILOGIN.LE.11
               CHREND= CLOGND(ILOGIN)
C
C              KEYWORDS: *IF*/*WHILE*/*UNTIL*
               IF( ILOGIN.EQ.9.OR.ILOGIN.EQ.10.OR.ILOGIN.EQ.11 )THEN
                  NSTLVL= NSTLVL+1
                  IF( NSTLVL.GT.NDIMST ) GO TO 9002
                  IRCLVL(NSTLVL)= JRECOR-1
C
C              KEYWORDS: *ELSEIF*/*ELSE*
               ELSEIF( ILOGIN.EQ.8.OR.ILOGIN.EQ.14 )THEN
                  IF( ILEVEL.EQ.-1 )THEN
                     IF( NSTLVL.EQ.0 ) GO TO 9001
                     IRECOR= IRCLVL(NSTLVL)
                     NWORDS= 1
                  ELSE
                     ILEVEL= -1
                  ENDIF
C
C              KEYWORD:  *ENDWHILE*
               ELSEIF( ILOGIN.EQ.12 )THEN
                  IF( ILEVEL.EQ.-1 )THEN
                     IRECOR= JRECOR-1
                     NWORDS= 1
                  ELSE
                     ILEVEL= -1
                  ENDIF
C
C              KEYWORD:  *ENDIF*
               ELSEIF( ILOGIN.EQ.15 )THEN
                  ILEVEL= -1
                  IF( NSTLVL.EQ.0 ) GO TO 9001
                  NSTLVL= NSTLVL-1
C
C              KEYWORD:  *ECHO*
               ELSEIF( ILOGIN.EQ.7 )THEN
                  JLINES= ILINES
               ENDIF
C
C              CYCLE ON WORDS WITHOUT UNPACKING (ONE WORD ONLY)
               IF( NWORDS.EQ.IWORDS ) GO TO 10
               DO 31 ILOOP1= 1,NWORDS
C
CL05>             UNPACK INDLEC ONLY IF MORE THAN 1 WORD (BEGIN)
                  JLOOP2=(2*ILOOP1+23)/24
                  JNDLEC(ILOOP1)= MOD(IPACKI(JLOOP2),4)+1
                  IPACKI(JLOOP2)= IPACKI(JLOOP2)/4
CL05>             UNPACK INDLEC ONLY IF MORE THAN 1 WORD (END)
C   
   31          CONTINUE
C
CL04>          TREAT SIGNIFICANT 1ST-WORD OF CLE-2000 STATEMENTS (END)
C              RETURN TO NEXT WORD
C
               GO TO 10
            ENDIF
CL03>       THIS IS A NEW *CLE-2000* RECORD (END)
C
         ELSE
C
CL03>       RECORD OUTSIDE *CLE-2000* (BEGIN)
            ILOGIN= 0
CL03>       RECORD OUTSIDE *CLE-2000* (END)
C
         ENDIF
         DO 32 ILOOP1= 1,NWORDS
C
CL03>       RECORD OUTSIDE *CLE-2000* OR NEW *CLE-2000* RECORD,
C                                     BUT CONTINUATION STATEMENT (BEGIN)
C           THEN, ALWAYS UNPACK INDLEC
            JLOOP2=(2*ILOOP1+23)/24
            JNDLEC(ILOOP1)= MOD(IPACKI(JLOOP2),4)+1
            IPACKI(JLOOP2)= IPACKI(JLOOP2)/4
C
CL03>       RECORD OUTSIDE *CLE-2000* OR NEW *CLE-2000* RECORD,
C                                     BUT CONTINUATION STATEMENT (END)
C
   32    CONTINUE
C
CL02>    ***LOOP*** OVER RECORDS (END)
C
      ENDIF
C
CL01> ***LOOP*** OVER WORDS (ACCEPTED)
C
C     DETERMINE NEXT WORD
      ILENGV= IFINWD(IWORDS)-IDEBWD(IWORDS)+1
      INDLEC= JNDLEC(IWORDS)
C
      IF( INDLEC.EQ.3 )THEN
         CDATAV= CBLA72
         CDATAV(1:ILENGV)= MYRECO(IDEBWD(IWORDS):IFINWD(IWORDS))
      ELSEIF( INDLEC.EQ.1 )THEN
         CDATIN(1:ILENGV)= MYRECO(IDEBWD(IWORDS):IFINWD(IWORDS))
         WRITE(FORMIN,'(2H(I,I2,1H))',ERR=8001) ILENGV
         READ (CDATIN,FORMIN,ERR=8001) IDATIN
      ELSEIF( INDLEC.EQ.2 )THEN
         CDATIN(1:ILENGV)= MYRECO(IDEBWD(IWORDS):IFINWD(IWORDS))
         WRITE(FORMIN,'(2H(E,I2,3H.0))',ERR=8002) ILENGV
         READ (CDATIN,FORMIN,ERR=8002) ADATIN
      ELSE
         CDATIN(1:ILENGV)= MYRECO(IDEBWD(IWORDS):IFINWD(IWORDS))
         WRITE(FORMIN,'(2H(D,I2,3H.0))',ERR=8004) ILENGV
         READ (CDATIN,FORMIN,ERR=8004) DDATIN
      ENDIF
      IF( ILOGIN.EQ.0 )THEN
C
CL02>    WORDS OUTSIDE *CLE2000* STATEMENTS: HIT AND RUN...
C
         IF( INDLEC.EQ.3 )THEN
C
CL03>       STRING, <<.>> OR >>.<< TREATMENT
C
            LRDPUT= CDATAV(1:2).EQ.'>>'
            IF( CDATAV(1:2).EQ.'<<'.OR.LRDPUT )THEN
C
CL04>          CASES <<.>> OR >>.<<
C
               CPARAV= CDATAV(3:ILENGV-2)
C
C              GET VARIABLE WITH A BINARY SEARCH IN SORTED FILE
C
C              SET UPPER AND LOWER BOUNDS
               ILOWRC= IVABEG
               IHIGRC= IVAEND
   11          IMEDRC= (IHIGRC+ILOWRC)/2
               READ (IUNITO,REC=IMEDRC)
     1             CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN
               IF( CPARIN.EQ.CPARAV )THEN
                  IF( LRDPUT )THEN
C
C                    KEEP RECORD NUMBER FOR *REDPUT*
                     NSTPUT= NSTPUT+1
                     IF( NSTPUT.GT.NDIMST ) GO TO 9004
                     IRCPUT(NSTPUT)= IMEDRC
C
C                    MAKE THE VARIABLE UNDEFINED
                     INDLIN= -ABS(INDLIN)
                     WRITE(IUNITO,REC=IMEDRC)
     1                  CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN
C
C                    SEND BACK NEGATIVE TYPE AND  
C                              VARIABLE NAME TO THE APPLICATION
                     ITYP= INDLIN
                     ILENGT=MIN(LEN(TEXT),12)
                     TEXT(1:ILENGT)= CPARIN(1:ILENGT)
                  ELSE
                     IF( INDLIN.LE.0 ) GO TO 9008
C
C                    SEND BACK TYPE AND DEFINED VALUES
                     ITYP= INDLIN
                     IF( ITYP.EQ.1.OR.ITYP.EQ.5 )THEN
                        NITMA= IDATIN
                     ELSEIF( ITYP.EQ.2 )THEN
                        FLOTT= ADATIN
                     ELSEIF( ITYP.EQ.3 )THEN
                        ILENGT=MIN(LEN(TEXT),72)
                        NITMA=MIN(IDATIN,ILENGT)
                        TEXT(1:ILENGT)= CDATIN(1:ILENGT)
                     ELSEIF( ITYP.EQ.4 )THEN
                        DFLOT= DDATIN
                     ENDIF
                  ENDIF
               ELSEIF( CPARIN.LT.CPARAV )THEN
                  ILOWRC= IMEDRC
                  GO TO 11
               ELSE
                  IHIGRC= IMEDRC
                  GO TO 11
               ENDIF
            ELSEIF( CDATAV(1:1).EQ.'''' )THEN
               CDATIN= CBLA72
               IF( ILENGV.GT.2 )THEN
                  CDATIN(1:ILENGV-2)= CDATAV(2:ILENGV-1)
               ENDIF
               ITYP= 3
               ILENGT= MIN(LEN(TEXT),72)
               NITMA=MIN(ILENGV-2,ILENGT)
               TEXT(1:ILENGT)= CDATIN(1:ILENGT)
            ELSE
               ITYP= 3
               ILENGT= MIN(LEN(TEXT),72)
               NITMA=MIN(ILENGV,ILENGT)
               TEXT(1:ILENGT)= CDATAV(1:ILENGT)
            ENDIF
         ELSE
C
CL03>       OTHER THAN STRING TREATMENT
            ITYP= INDLEC
            IF( ITYP.EQ.1.OR.ITYP.EQ.5 )THEN
               NITMA= IDATIN
            ELSEIF( ITYP.EQ.2 )THEN
               FLOTT= ADATIN
            ELSEIF( ITYP.EQ.4 )THEN
               DFLOT= DDATIN
            ENDIF
         ENDIF
         RETURN
C
CL02>    WORDS OUTSIDE *CLE2000* STATEMENTS: END.
C
      ELSE
C
CL02>    PROCESS *CLE2000* STATEMENTS: DRINK, DRIVE (BEGIN)
C
C        WATCH FOR STRINGS...
C
CL03>    IF( INDLEC.EQ.3.AND.CDATAV(1:1).EQ.'"' )THEN
         IF( INDLEC.EQ.3.AND.CDATAV(1:1).EQ.'"' )THEN
            NSTRGT= NSTRGT+1
            INDRGT(NSTRGT)= INDLEC
            CHRSTK(NSTRGT)= CBLA72
            IF( ILENGV.GT.2 )THEN
               CHRSTK(NSTRGT)(1:ILENGV-2)= CDATAV(2:ILENGV-1)
            ENDIF
            INTSTK(NSTRGT)= ILENGV-2
C
CL03>    ELSEIF( LRGTST )THEN
         ELSEIF( LRGTST )THEN
C
CL04>       IF( INDLEC.EQ.3 )THEN
            IF( INDLEC.EQ.3 )THEN
               CPARAV= CDATAV(1:12)
C
CL05>          IF( CPARAV.EQ.CHREND )THEN
               IF( CPARAV.EQ.CHREND )THEN
C
C                 TRUEWAY LEFT/RIGHT
C
C                 KEYWORDS: *INTEGER*/*REAL*/*STRING*/
C                           *DOUBLE*/*LOGICAL*/*EVALUATE*
                  IF( ILOGIN.LE.6 )THEN
C
C                    PUT VARIABLE VALUES
   25                CONTINUE
                     INDLIN= INDRGT(NSTLFT)
                     IMEDRC= IRCLFT(NSTLFT)
                     READ (IUNITO,REC=IMEDRC) CPARIN,CDATIN,
     1                  INDLE2,IDATIN,ADATIN,DDATIN
                     IF    ( INDLIN.EQ.1 )THEN
                        IDATIN= INTSTK(NSTLFT)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        ADATIN= RELSTK(NSTLFT)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        CDATIN= CHRSTK(NSTLFT)
                        IDATIN= INTSTK(NSTLFT)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        DDATIN= DBLSTK(NSTLFT)
                     ELSEIF( INDLIN.EQ.5 )THEN
                        IF( LOGSTK(NSTLFT) )THEN
                           IDATIN= +1
                        ELSE
                           IDATIN= -1
                        ENDIF
                     ENDIF
                     WRITE(IUNITO,REC=IMEDRC) CPARIN,CDATIN,
     1                  INDLIN,IDATIN,ADATIN,DDATIN
                     NSTLFT= NSTLFT-1
                     IF( NSTLFT.NE.0 ) GO TO 25
C
C                 KEYWORD: *ECHO* (PRINTER UTILITY )                    
                  ELSEIF( ILOGIN.EQ.7 )THEN
                     WRITE(CPRINT,'(2H>|,A72,2H|>,I4.4)')CBLA72,JLINES
                     IDEPAR= 3
                     DO 300 ILOOP1= 1, NSTRGT
                        INDLIN= INDRGT(ILOOP1)
                        IF( INDLIN.EQ.1 )THEN
                           INDLE2= ABS(INTSTK(ILOOP1))
                           DO 301 JLOOP2= 1, 12
                              INDLE2= INDLE2/10
                              IF( INDLE2.EQ.0 )THEN
                                 ILGTPR= JLOOP2
                                 GO TO 302
                              ENDIF
  301                      CONTINUE
  302                      CONTINUE
                           IF( INTSTK(ILOOP1).LT.0 )ILGTPR= ILGTPR+1
                           WRITE(FORMIN,'(2H(I,I2.2,1H))') ILGTPR
                           WRITE(CDATIN,FORMIN) INTSTK(ILOOP1)
                        ELSEIF( INDLIN.EQ.2 )THEN
                           WRITE(CDATIN,'(1P,E13.6)') RELSTK(ILOOP1)
                           ILGTPR= 13
                        ELSEIF( INDLIN.EQ.3 )THEN
                           CDATIN= CHRSTK(ILOOP1)
                           ILGTPR= INTSTK(ILOOP1)
                        ELSEIF( INDLIN.EQ.4 )THEN
                           WRITE(CDATA1,'(1P,E22.15)') DBLSTK(ILOOP1)
                           INDLE2= INDEX(CDATA1(1:22),'E')
                           IF( INDLE2.EQ.0 )THEN
                              CDATIN(1:23)= CDATA1(1:18)
     1                                //'D'//CDATA1(19:22)
                           ELSE
                              CDATA1(INDLE2:INDLE2)='D'
                              CDATIN(1:23)= CDATA1(1:20)
     1                               //'0'//CDATA1(21:22)
                           ENDIF
                           ILGTPR= 23
                        ELSEIF( INDLIN.EQ.5 )THEN
                           IF( LOGSTK(ILOOP1) )THEN
                              CDATIN= '.TRUE.'
                              ILGTPR= 6
                           ELSE
                              CDATIN= '.FALSE.'
                              ILGTPR= 7
                           ENDIF
                        ELSEIF( INDLIN.EQ.-1 )THEN
                           CDATIN= '?_I'
                           ILGTPR= 3
                        ELSEIF( INDLIN.EQ.-2 )THEN
                           CDATIN= '?_R'
                           ILGTPR= 3
                        ELSEIF( INDLIN.EQ.-3 )THEN
                           CDATIN= '?_S'
                           ILGTPR= 3
                        ELSEIF( INDLIN.EQ.-4 )THEN
                           CDATIN= '?_D'
                           ILGTPR= 3
                        ELSEIF( INDLIN.EQ.-5 )THEN
                           CDATIN= '?_L'
                           ILGTPR= 3
                        ELSE
                           GO TO 9007
                        ENDIF
                        IF( IDEPAR+ILGTPR.GE.IFINAL )THEN
                           IF( IWRITE.NE.0 )THEN
                              WRITE(IWRITE,'(A80)') CPRINT
                           ENDIF
                           WRITE(CPRINT,'(2H>|,A72,2H|>,I4.4)')
     1                                         CBLA72,  JLINES
                           IDEPAR= 3
                        ENDIF
                        CPRINT(IDEPAR:IDEPAR+ILGTPR-1)= CDATIN(1:ILGTPR)
                        IDEPAR= IDEPAR+ILGTPR+1
                        IF( IDEPAR.GE.IFINAL )THEN
                           IF( IWRITE.NE.0 )THEN
                              WRITE(IWRITE,'(A80)') CPRINT
                           ENDIF
                           WRITE(CPRINT,'(2H>|,A72,2H|>,I4.4)')
     1                                         CBLA72,  JLINES
                           IDEPAR= 3
                        ENDIF
  300                CONTINUE
                     IF( IWRITE.NE.0.AND.IDEPAR.NE.3 )THEN
                        WRITE(IWRITE,'(A80)') CPRINT
                     ENDIF
C
C                 KEYWORDS: *ELSEIF*/*IF*
                  ELSEIF( ILOGIN.EQ.8.OR.ILOGIN.EQ.9 )THEN
                     IF( INDRGT(NSTRGT).NE.5 ) GO TO 9006
                     IF( LOGSTK(NSTRGT) )THEN
                        ILEVEL= -1
                     ELSE
                        ILEVEL= JLEVEL
                     ENDIF
C
C                 KEYWORD: *UNTIL*
                  ELSEIF( ILOGIN.EQ.11 )THEN
                     IF( NSTLVL.EQ.0 ) GO TO 9001
                     IF( INDRGT(NSTRGT).NE.5 ) GO TO 9006
                     IF( .NOT.LOGSTK(NSTRGT) )THEN
                        IRECOR= IRCLVL(NSTLVL)
                        IWORDS= NWORDS
                     ENDIF
                     NSTLVL= NSTLVL-1
C
C                 KEYWORD: *WHILE*
                  ELSEIF( ILOGIN.EQ.10 )THEN
                     IF( NSTLVL.EQ.0 ) GO TO 9001
                     IF( INDRGT(NSTRGT).NE.5 ) GO TO 9006
                     IF( .NOT.LOGSTK(NSTRGT) )THEN
                        ILEVEL= JLEVEL
                        IRECOR= IRCLVL(NSTLVL)
                        IWORDS= NWORDS
                     ENDIF
                     NSTLVL= NSTLVL-1
                  ENDIF
C
CL05>          ELSEIF( CPARAV.NE.CHREND )THEN
               ELSE
C
C                 CHECK CONVERSION OPERATIONS
                  IF    ( CPARAV.EQ.'R_TO_I' )THEN
                     INDRGT(NSTRGT)= SIGN(1,INDRGT(NSTRGT))
                     INTSTK(NSTRGT)= INT(RELSTK(NSTRGT))
                  ELSEIF( CPARAV.EQ.'D_TO_I' )THEN
                     INDRGT(NSTRGT)= SIGN(1,INDRGT(NSTRGT))
                     INTSTK(NSTRGT)= IDINT(DBLSTK(NSTRGT))
                  ELSEIF( CPARAV.EQ.'I_TO_R' )THEN
                     INDRGT(NSTRGT)= SIGN(2,INDRGT(NSTRGT))
                     RELSTK(NSTRGT)= FLOAT(INTSTK(NSTRGT))
                  ELSEIF( CPARAV.EQ.'D_TO_R' )THEN
                     INDRGT(NSTRGT)= SIGN(2,INDRGT(NSTRGT))
                     RELSTK(NSTRGT)= SNGL(DBLSTK(NSTRGT))
                  ELSEIF( CPARAV.EQ.'I_TO_D' )THEN
                     INDRGT(NSTRGT)= SIGN(4,INDRGT(NSTRGT))
                     DBLSTK(NSTRGT)= DBLE(INTSTK(NSTRGT))
                  ELSEIF( CPARAV.EQ.'R_TO_D' )THEN
                     INDRGT(NSTRGT)= SIGN(4,INDRGT(NSTRGT))
                     DBLSTK(NSTRGT)= DBLE(RELSTK(NSTRGT))
                  ELSEIF( CPARAV.EQ.'I_TO_S' )THEN
                     INDRGT(NSTRGT)= SIGN(3,INDRGT(NSTRGT))
                     IF(INTSTK(NSTRGT) .GT. 99999999) GO TO 9013
                     IF(INTSTK(NSTRGT) .LT. -9999999) GO TO 9014
                     WRITE(CDATA3,'(I8)') INTSTK(NSTRGT)
                     JJ=0
                     CHRSTK(NSTRGT)=CBLA72
                     DO 500 II=1,8
                       IF(CDATA3(II:II) .NE. ' ') THEN
                         JJ=JJ+1
                         CHRSTK(NSTRGT)(JJ:JJ)=CDATA3(II:II)
                       ENDIF
 500                 CONTINUE
                     INTSTK(NSTRGT)=JJ
C
C                 CHECK UNARY OPERATIONS
                  ELSEIF( CPARAV.EQ.'NOT' )THEN
                     LOGSTK(NSTRGT)= .NOT.LOGSTK(NSTRGT)
                  ELSEIF( CPARAV.EQ.'CHS' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                        INTSTK(NSTRGT)= -INTSTK(NSTRGT)
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= -RELSTK(NSTRGT)
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= -DBLSTK(NSTRGT)
                     ENDIF
                  ELSEIF( CPARAV.EQ.'ABS' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                        INTSTK(NSTRGT)= ABS(INTSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= ABS(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= ABS(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'EXP' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= EXP(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= EXP(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'LN' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= LOG(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= LOG(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'SIN' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= SIN(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= SIN(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'COS' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= COS(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= COS(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'TAN' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= TAN(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= TAN(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'ARCSIN' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= ASIN(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= ASIN(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'ARCCOS' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= ACOS(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= ACOS(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'ARCTAN' )THEN
                     IF    ( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= ATAN(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= ATAN(DBLSTK(NSTRGT))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'SQRT' )THEN
                     IF( INDRGT(NSTRGT).EQ.2 )THEN
                        IF( RELSTK(NSTRGT).LT.0.0 )THEN
                           IDEFKW= 2
                           GO TO 9009
                        ENDIF
                        RELSTK(NSTRGT)= SQRT(RELSTK(NSTRGT))
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        IF( DBLSTK(NSTRGT).LT.0.0D0 )THEN
                           IDEFKW= 4
                           GO TO 9009
                        ENDIF
                        DBLSTK(NSTRGT)= SQRT(DBLSTK(NSTRGT))
                     ENDIF
C
C                 CHECK BINARY OPERATIONS
                  ELSEIF( CPARAV.EQ.'_MIN_' )THEN
                    NSTRGT= NSTRGT-1
                    INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                    IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                      INTSTK(NSTRGT)= 
     >                MIN(INTSTK(NSTRGT),INTSTK(NSTRGT+1))
                    ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                      RELSTK(NSTRGT)= 
     >                MIN(RELSTK(NSTRGT),RELSTK(NSTRGT+1))
                    ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                      DBLSTK(NSTRGT)= 
     >                MIN(DBLSTK(NSTRGT),DBLSTK(NSTRGT+1))
                    ENDIF
                  ELSEIF( CPARAV.EQ.'_MAX_' )THEN
                    NSTRGT= NSTRGT-1
                    INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                    IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                      INTSTK(NSTRGT)= 
     >                MAX(INTSTK(NSTRGT),INTSTK(NSTRGT+1))
                    ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                      RELSTK(NSTRGT)= 
     >                MAX(RELSTK(NSTRGT),RELSTK(NSTRGT+1))
                    ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                      DBLSTK(NSTRGT)= 
     >                MAX(DBLSTK(NSTRGT),DBLSTK(NSTRGT+1))
                    ENDIF
                  ELSEIF( CPARAV.EQ.'+' )THEN
                     NSTRGT= NSTRGT-1
                     INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                        INTSTK(NSTRGT)= INTSTK(NSTRGT)+INTSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= RELSTK(NSTRGT)+RELSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.3 )THEN
                        ILENG2= INTSTK(NSTRGT)
                        ILENG1= INTSTK(NSTRGT+1)
                        CDATA2= CHRSTK(NSTRGT)
                        CDATA1= CHRSTK(NSTRGT+1)
                        IF( ILENG1.EQ.0 )THEN
                           IF( ILENG2.EQ.0 )THEN
                              CHRSTK(NSTRGT)= CBLA72
                           ELSE
                              CHRSTK(NSTRGT)= CDATA2
                           ENDIF
                        ELSEIF( ILENG2.EQ.0 )THEN
                           CHRSTK(NSTRGT)= CDATA1
                        ELSEIF( ILENG1+ILENG2.EQ.72 )THEN
                           CHRSTK(NSTRGT)= CDATA2(1:ILENG2)
     1                                   //CDATA1(1:ILENG1)
                        ELSEIF( ILENG1+ILENG2.LT.72 )THEN
                           CHRSTK(NSTRGT)= CDATA2(1:ILENG2)
     1                                   //CDATA1(1:ILENG1)
     2                                   //CDATA2(ILENG1+ILENG2+1:72)
                        ELSE
                           WRITE(JWRITE,*) 'REDGET: '
     1                      //'STRING IS LONGER THAN 72 CHRS'
                           GO TO 9012
                        ENDIF
                        INTSTK(NSTRGT)= ILENG1+ILENG2
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= DBLSTK(NSTRGT)+DBLSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.5 )THEN
                        LOGSTK(NSTRGT)= LOGSTK(NSTRGT).OR.
     1                                  LOGSTK(NSTRGT+1)
                     ENDIF
                  ELSEIF( CPARAV.EQ.'-' )THEN
                     NSTRGT= NSTRGT-1
                     INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                        INTSTK(NSTRGT)= INTSTK(NSTRGT)-INTSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= RELSTK(NSTRGT)-RELSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.3 )THEN
                        ILENG2= INTSTK(NSTRGT)
                        ILENG1= INTSTK(NSTRGT+1)
                        IF( ILENG1.NE.0 )THEN
                           IF( ILENG2.LT.ILENG1 )THEN
                              WRITE(JWRITE,*) 'REDGET: '
     1                               //'IMPOSSIBLE TO - A SUBSTRING '
     2                               //'WITH LENGTH LESS THAN STRING'
                              GO TO 9012
                           ENDIF
                           CDATA2= CHRSTK(NSTRGT)
                           CDATA1= CHRSTK(NSTRGT+1)
                           IF( CDATA2(ILENG2-ILENG1+1:ILENG2)
     1                         .NE.CDATA1(1:ILENG1) )THEN
                              WRITE(JWRITE,*) 'REDGET: '
     1                               //'IMPOSSIBLE TO - A SUBSTRING '
     2                               //'NOT AT THE END OF A STRING'
                              GO TO 9012
                           ELSEIF( ILENG1.EQ.ILENG2 )THEN
                              CHRSTK(NSTRGT)= CBLA72
                           ELSE
                              CHRSTK(NSTRGT)= CDATA2(1:ILENG2-ILENG1)
     1                                      //CBLA72(ILENG2-ILENG1+1:72)
                           ENDIF
                           INTSTK(NSTRGT)= ILENG2-ILENG1
                        ENDIF
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= DBLSTK(NSTRGT)-DBLSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.5 )THEN
                        LOGSTK(NSTRGT)= LOGSTK(NSTRGT).OR.
     1                                  (.NOT.LOGSTK(NSTRGT+1))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'*' )THEN
                     NSTRGT= NSTRGT-1
                     INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                        INTSTK(NSTRGT)= INTSTK(NSTRGT)*INTSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        RELSTK(NSTRGT)= RELSTK(NSTRGT)*RELSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        DBLSTK(NSTRGT)= DBLSTK(NSTRGT)*DBLSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.5 )THEN
                        LOGSTK(NSTRGT)= LOGSTK(NSTRGT).AND.
     1                                  LOGSTK(NSTRGT+1)
                     ENDIF
                  ELSEIF( CPARAV.EQ.'%' )THEN
                     NSTRGT= NSTRGT-1
                     INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     IF    ( INDRGT(NSTRGT).EQ.1 )THEN
                        IF( INTSTK(NSTRGT+1).EQ.0 )THEN
                           IDEFKW= 1
                           GO TO 9010
                        ENDIF
                    INTSTK(NSTRGT)= MOD(INTSTK(NSTRGT),INTSTK(NSTRGT+1))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'/' )THEN
                     NSTRGT= NSTRGT-1
                     INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     IF( INDRGT(NSTRGT).EQ.1 )THEN
                        IF( INTSTK(NSTRGT+1).EQ.0 )THEN
                           IDEFKW= 1
                           GO TO 9010
                        ENDIF
                        INTSTK(NSTRGT)= INTSTK(NSTRGT)/INTSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        IF( RELSTK(NSTRGT+1).EQ.0.0 )THEN
                           IDEFKW= 2
                           GO TO 9010
                        ENDIF
                        RELSTK(NSTRGT)= RELSTK(NSTRGT)/RELSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        IF( DBLSTK(NSTRGT+1).EQ.0.0D0 )THEN
                           IDEFKW= 4
                           GO TO 9010
                        ENDIF
                        DBLSTK(NSTRGT)= DBLSTK(NSTRGT)/DBLSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.5 )THEN
                        LOGSTK(NSTRGT)= LOGSTK(NSTRGT).AND.
     1                                  (.NOT.LOGSTK(NSTRGT+1))
                     ENDIF
                  ELSEIF( CPARAV.EQ.'**' )THEN
                     NSTRGT= NSTRGT-1
                     INDRGT(NSTRGT)=MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     IF( INDRGT(NSTRGT).EQ.1 )THEN
                        IF( INTSTK(NSTRGT).LT.0.AND.
     1                      INTSTK(NSTRGT+1).LT.0 )THEN
                           IDEFKW= 1
                           GO TO 9011
                        ENDIF
                        INTSTK(NSTRGT)= INTSTK(NSTRGT)**INTSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.2 )THEN
                        IF( RELSTK(NSTRGT).LT.0.0 .AND.
     1                      RELSTK(NSTRGT+1).LT.0.0 )THEN
                           IDEFKW= 2
                           GO TO 9011
                        ENDIF
                        RELSTK(NSTRGT)= RELSTK(NSTRGT)**RELSTK(NSTRGT+1)
                     ELSEIF( INDRGT(NSTRGT).EQ.4 )THEN
                        IF( DBLSTK(NSTRGT).LT.0.D0.AND.
     1                      DBLSTK(NSTRGT+1).LT.0.D0 )THEN
                           IDEFKW= 4
                           GO TO 9011
                        ENDIF
                        DBLSTK(NSTRGT)= DBLSTK(NSTRGT)**DBLSTK(NSTRGT+1)
                     ENDIF
                  ELSEIF( CPARAV.EQ.'<' )THEN
                     NSTRGT= NSTRGT-1
                     INDLIN= MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     INDRGT(NSTRGT)= 5
                     IF( INDLIN.EQ.1 )THEN
                        LOGSTK(NSTRGT)= INTSTK(NSTRGT).LT.
     1                                  INTSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        LOGSTK(NSTRGT)= RELSTK(NSTRGT).LT.
     1                                  RELSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        LOGSTK(NSTRGT)= CHRSTK(NSTRGT).LT.
     1                                  CHRSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        LOGSTK(NSTRGT)= DBLSTK(NSTRGT).LT.
     1                                  DBLSTK(NSTRGT+1)
                     ELSE
                        INDRGT(NSTRGT)= -5
                     ENDIF
                  ELSEIF( CPARAV.EQ.'>' )THEN
                     NSTRGT= NSTRGT-1
                     INDLIN= MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     INDRGT(NSTRGT)= 5
                     IF( INDLIN.EQ.1 )THEN
                        LOGSTK(NSTRGT)= INTSTK(NSTRGT).GT.
     1                                  INTSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        LOGSTK(NSTRGT)= RELSTK(NSTRGT).GT.
     1                                  RELSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        LOGSTK(NSTRGT)= CHRSTK(NSTRGT).GT.
     1                                  CHRSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        LOGSTK(NSTRGT)= DBLSTK(NSTRGT).GT.
     1                                  DBLSTK(NSTRGT+1)
                     ELSE
                        INDRGT(NSTRGT)= -5
                     ENDIF
                  ELSEIF( CPARAV.EQ.'=' )THEN
                     NSTRGT= NSTRGT-1
                     INDLIN= MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     INDRGT(NSTRGT)= 5
                     IF( INDLIN.EQ.1 )THEN
                        LOGSTK(NSTRGT)= INTSTK(NSTRGT).EQ.
     1                                  INTSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        LOGSTK(NSTRGT)= RELSTK(NSTRGT).EQ.
     1                                  RELSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        LOGSTK(NSTRGT)= CHRSTK(NSTRGT).EQ.
     1                                  CHRSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        LOGSTK(NSTRGT)= DBLSTK(NSTRGT).EQ.
     1                                  DBLSTK(NSTRGT+1)
                     ELSE
                        INDRGT(NSTRGT)= -5
                     ENDIF
                  ELSEIF( CPARAV.EQ.'<=' )THEN
                     NSTRGT= NSTRGT-1
                     INDLIN= MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     INDRGT(NSTRGT)= 5
                     IF( INDLIN.EQ.1 )THEN
                        LOGSTK(NSTRGT)= INTSTK(NSTRGT).LE.
     1                                  INTSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        LOGSTK(NSTRGT)= RELSTK(NSTRGT).LE.
     1                                  RELSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        LOGSTK(NSTRGT)= CHRSTK(NSTRGT).LE.
     1                                  CHRSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        LOGSTK(NSTRGT)= DBLSTK(NSTRGT).LE.
     1                                  DBLSTK(NSTRGT+1)
                     ELSE
                        INDRGT(NSTRGT)= -5
                     ENDIF
                  ELSEIF( CPARAV.EQ.'>=' )THEN
                     NSTRGT= NSTRGT-1
                     INDLIN= MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     INDRGT(NSTRGT)= 5
                     IF( INDLIN.EQ.1 )THEN
                        LOGSTK(NSTRGT)= INTSTK(NSTRGT).GE.
     1                                  INTSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        LOGSTK(NSTRGT)= RELSTK(NSTRGT).GE.
     1                                  RELSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        LOGSTK(NSTRGT)= CHRSTK(NSTRGT).GE.
     1                                  CHRSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        LOGSTK(NSTRGT)= DBLSTK(NSTRGT).GE.
     1                                  DBLSTK(NSTRGT+1)
                     ELSE
                        INDRGT(NSTRGT)= -5
                     ENDIF
                  ELSEIF( CPARAV.EQ.'<>' )THEN
                     NSTRGT= NSTRGT-1
                     INDLIN= MIN(INDRGT(NSTRGT),INDRGT(NSTRGT+1))
                     INDRGT(NSTRGT)= 5
                     IF( INDLIN.EQ.1 )THEN
                        LOGSTK(NSTRGT)= INTSTK(NSTRGT).NE.
     1                                  INTSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.2 )THEN
                        LOGSTK(NSTRGT)= RELSTK(NSTRGT).NE.
     1                                  RELSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.3 )THEN
                        LOGSTK(NSTRGT)= CHRSTK(NSTRGT).NE.
     1                                  CHRSTK(NSTRGT+1)
                     ELSEIF( INDLIN.EQ.4 )THEN
                        LOGSTK(NSTRGT)= DBLSTK(NSTRGT).NE.
     1                                  DBLSTK(NSTRGT+1)
                     ELSE
                        INDRGT(NSTRGT)= -5
                     ENDIF
                  ELSE
C
C                    NO CHANCE, MAN... TRY IT WITH VARIABLES
                     ILOWRC= IVABEG
                     IHIGRC= IVAEND
   50                IMEDRC= (IHIGRC+ILOWRC)/2
                     READ (IUNITO,REC=IMEDRC)CPARIN,CDATIN,
     1                         INDLIN,IDATIN,ADATIN,DDATIN
                     IF( CPARIN.EQ.CPARAV )THEN
C
C                       STACK VARIABLE VALUE
                        NSTRGT= NSTRGT+1
                        INDRGT(NSTRGT)= INDLIN
                        IF    ( INDLIN.EQ.1 )THEN
                           INTSTK(NSTRGT)= IDATIN
                        ELSEIF( INDLIN.EQ.2 )THEN
                           RELSTK(NSTRGT)= ADATIN
                        ELSEIF( INDLIN.EQ.3 )THEN
                           CHRSTK(NSTRGT)= CDATIN
                           INTSTK(NSTRGT)= IDATIN
                        ELSEIF( INDLIN.EQ.4 )THEN
                           DBLSTK(NSTRGT)= DDATIN
                        ELSEIF( INDLIN.EQ.5 )THEN
                           LOGSTK(NSTRGT)= IDATIN.EQ.+1
                        ENDIF
                     ELSEIF( CPARIN.LT.CPARAV )THEN
                        ILOWRC= IMEDRC
                        GO TO 50
                     ELSE
                        IHIGRC= IMEDRC
                        GO TO 50
                     ENDIF
                  ENDIF
CL05>          ENDIF( ON CPARAV )
               ENDIF
C
CL04>       ELSEIF( INDLEC.NE.3 )THEN
            ELSE
               NSTRGT= NSTRGT+1
               INDRGT(NSTRGT)= INDLEC
               IF( INDLEC.EQ.1 )THEN
                  INTSTK(NSTRGT)= IDATIN
               ELSEIF( INDLEC.EQ.2 )THEN
                  RELSTK(NSTRGT)= ADATIN
               ELSEIF( INDLEC.EQ.4 )THEN
                  DBLSTK(NSTRGT)= DDATIN
               ENDIF
C
CL04>       ENDIF( ON INDLEC )
            ENDIF
C
CL03>    ELSEIF( .NOT.LRGTST )THEN
         ELSE
            CPARAV= CDATAV(1:12)
            IF( CPARAV.EQ.CHREND )THEN
               LRGTST=.FALSE.
            ELSEIF( ILOGIN.LE.6.AND.CPARAV.EQ.':=' )THEN
               LRGTST=.TRUE.
            ELSE
               NSTLFT= NSTLFT+1
C
C              FIND RECORD NUMBER FOR VARIABLE *CPARAV*
               ILOWRC= IVABEG
               IHIGRC= IVAEND
   27          IMEDRC= (IHIGRC+ILOWRC)/2
               READ (IUNITO,REC=IMEDRC) CPARIN,CDATIN,
     1                    INDLIN,IDATIN,ADATIN,DDATIN
               IF( CPARIN.EQ.CPARAV )THEN
                  IRCLFT(NSTLFT)= IMEDRC
               ELSEIF( CPARIN.LT.CPARAV )THEN
                  ILOWRC= IMEDRC
                  GO TO 27
               ELSE
                  IHIGRC= IMEDRC
                  GO TO 27
               ENDIF
            ENDIF
C
CL03>    ENDIF( ON LRGTST )
         ENDIF
C
CL02>    PROCESS *CLE2000* STATEMENTS: AND HIT... (END)
C
      ENDIF
C
CL01> ***LOOP*** OVER WORDS (END)
C
      GO TO 10
C
 8000 WRITE(JWRITE,*) 'IREC= ',IRECOR
      WRITE(JWRITE,*) ' REC= ',MYRECO
      CALL XABORT( 'REDGET: PROBLEM READING *RECORD*, USE DEBUG')
 8001 WRITE(JWRITE,*) 'FMT = ',FORMIN
      WRITE(JWRITE,*) 'DATA= ',CDATIN
      CALL XABORT( 'REDGET: PROBLEM READING *INTEGER*, USE DEBUG') 
 8002 WRITE(JWRITE,*) 'FMT = ',FORMIN
      WRITE(JWRITE,*) 'DATA= ',CDATIN
      CALL XABORT( 'REDGET: PROBLEM READING *REAL*, USE DEBUG') 
 8004 WRITE(JWRITE,*) 'FMT = ',FORMIN
      WRITE(JWRITE,*) 'DATA= ',CDATIN
      CALL XABORT( 'REDGET: PROBLEM READING *DOUBLE*, USE DEBUG') 
 9001 CALL XABORT( 'REDGET: EMBEDDED LOGIC LEVEL .LT.  1 (MIN)')
 9002 CALL XABORT( 'REDGET: EMBEDDED LOGIC LEVEL .GT. 64 (MAX)')
 9004 CALL XABORT( 'REDGET: NUMBER OF >>.<< ACCUMULATED.GT. 64 (MAX)')
 9006 WRITE(JWRITE,*) 'UNDEFINED LOGICAL IN *'//CLOGBG(ILOGIN)
     1  //'* OPERATION'
      CALL XABORT( 'REDGET: IMPOSSIBLE LOGICAL OPERATION')
 9007 CALL XABORT( 'REDGET: IMPOSSIBLE TO PRINT VALUE')
 9008 WRITE(JWRITE,*) 'VARIABLE *',CPARAV,'* HAS STILL NO VALUE'
      CALL XABORT( 'REDGET: IMPOSSIBLE TO GET VALUE')
 9009 WRITE(JWRITE,*) '*'//CLOGBG(IDEFKW)//'* HAS NEGATIVE VALUE'
      CALL XABORT( 'REDGET: IMPOSSIBLE TO TAKE *SQRT*')
 9010 WRITE(JWRITE,*) '*'//CLOGBG(IDEFKW)//'* DIVISION BY 0'
      CALL XABORT( 'REDGET: IMPOSSIBLE TO DIVIDE')
 9011 WRITE(JWRITE,*) '*'//CLOGBG(IDEFKW)//'* .LT. 0 '
     1              //'RAISED TO POWER .LT. 0'
      CALL XABORT( 'REDGET: IMPOSSIBLE TO TAKE POWER')
 9012 CALL XABORT( 'REDGET: IMPOSSIBLE TO + OR - STRINGS')
 9013 CALL XABORT( 'REDGET: INTEGER < 99999999'//
     1' REQUIRED FOR CONVERSION TO STRING')
 9014 CALL XABORT( 'REDGET: INTEGER > -9999999'//
     1' REQUIRED FOR CONVERSION TO STRING')
      GO TO 10
*
      ENTRY REDPUT (ITYP,NITMA,FLOTT,TEXT,DFLOT)
C
C          *REDPUT* ENTRY POINT
C                   TO INPUT VALUES FOR CLE-2000 VARIABLES
C                   USING THE COMMAND >>.<<
C     INPUT VARIABLES:
C          *ITYP*   TYPE FOR VARIABLE (+1: INTEGER
C                                      +2: REAL
C                                      +3: STRING
C                                      +4: DOUBLE
C                                      +5: LOGICAL )
C          *NITMA*  INTEGER VALUE IF *ITYP*.EQ.+1.OR.*ITYP*.EQ.+5
C          *FLOTT*  REAL    VALUE IF *ITYP*.EQ.+2
C          *TEXT*   STRING  VALUE IF *ITYP*.EQ.+3
C          *DFLOT*  DOUBLE  VALUE IF *ITYP*.EQ.+4
C
C     NOTE: LOGICAL VALUES ARE GIVEN EITHER BY *TRUE* = *NITMA*.EQ.+1
C                                        OR BY *FALSE*= *NITMA*.EQ.-1
C
      IF(ITYP .EQ. 3) THEN
        ILENGT=NITMA 
      ELSE
        ILENGT=0
      ENDIF
      IF( NSTPUT.EQ.0 )THEN
         CALL XABORT('REDPUT: NOTHING TO PUT')
      ELSEIF( ILENGT.GT.72 )THEN
         CALL XABORT('REDPUT: STRING LENGTH RESTRICTED TO 72')
      ELSEIF( ITYP.LE.0 )THEN
         CALL XABORT('REDPUT: PLEASE USE *ITYP*.GT.0')
      ELSEIF( IRECOR.EQ.0 .OR. IRECOR.GT.NINPUT )THEN
         CALL XABORT('REDPUT: READER IS CLOSED OR FILE END')
      ENDIF
      IMEDRC= IRCPUT(NSTPUT)
      READ(IUNITO,REC=IMEDRC)
     1   CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN
      IF( INDLIN.GE.0 )THEN
         CALL XABORT('REDPUT: CANNOT PUT ON A DEFINED VALUE')
      ENDIF
      INDLIN= ABS(INDLIN)
      IF( INDLIN.NE.ITYP )THEN
         CALL XABORT('REDPUT: INCOMPATIBLE TYPE OF THE VARIABLE')
      ENDIF
      IF( INDLIN.EQ.1 )THEN
         IDATIN= NITMA
      ELSEIF( INDLIN.EQ.2 )THEN
         ADATIN= FLOTT
      ELSEIF( INDLIN.EQ.3 )THEN
         CDATIN= CBLA72
         IF( TEXT(1:ILENGT).EQ.CBLA72(1:ILENGT) )THEN
C
C           ALL BLANK STRING IS CONSIDERED AS NULL-STRING => ""
            IDATIN= 0
         ELSEIF( TEXT(1:1).EQ.'"' )THEN
C
C           THIS IS A "...." STRING =>  START "...
            IF( ILENGT.EQ.1 )THEN
C
C              PROVIDES A WAY FOR APPLICATION TO PUT A '"' STRING
               IDATIN= 1
               CDATIN(1:1)= TEXT(1:1)
            ELSE
C
C              LOOK FOR => END ..."
               IDATIN= INDEX(TEXT(2:ILENGT),'"')-1
               IF( IDATIN.LT.0 )THEN
                  IF( TEXT(2:ILENGT).EQ.CBLA72(2:ILENGT) )THEN
                     IDATIN= 1
                     CDATIN(1:1)= TEXT(1:1)
                  ELSE
                     CALL XABORT('REDPUT: INVALID STRING " NEVER ENDS)')
                  ENDIF
               ELSEIF( IDATIN.NE.0 )THEN
                  IF( ILENGT.EQ.IDATIN+2 )THEN
                     CDATIN(1:IDATIN)= TEXT(2:IDATIN+1)
                  ELSE
                     IF( TEXT  (IDATIN+3:ILENGT).NE.
     1                   CBLA72(IDATIN+3:ILENGT) )THEN
                        CALL XABORT('REDPUT: "." + OTHER WORDS')
                     ENDIF
                     CDATIN(1:IDATIN)= TEXT(2:IDATIN+1)
                  ENDIF
               ENDIF
            ENDIF
         ELSE
            CDATIN(1:ILENGT)= TEXT(1:ILENGT)
            IDATIN=ILENGT
         ENDIF
      ELSEIF( INDLIN.EQ.4 )THEN
         DDATIN= DFLOT
      ELSEIF( INDLIN.EQ.5 )THEN
         IDATIN= NITMA
         IF( IDATIN.NE.-1.AND.IDATIN.NE.+1 )THEN
            CALL XABORT('REDPUT: LOGICAL IS UNDEFINED')
         ENDIF
      ELSE
         CALL XABORT('REDPUT: UNDEFINED TYPE')
      ENDIF
      WRITE(IUNITO,REC=IMEDRC)
     1   CPARIN,CDATIN,INDLIN,IDATIN,ADATIN,DDATIN
C
C     ONE LESS TO PUT
      NSTPUT= NSTPUT-1
      RETURN
*
      ENTRY REDOPN (IINP1,IOUT1,NREC)
C
C          *REDOPN* ENTRY POINT
C                   TO OPEN THE DA-FILE CONTAINING CLE-2000 DATA
C     INPUT VARIABLES:
C          *IINP1* IS THE CLE-2000 DA-FILE UNIT
C          *IOUT1* IS THE OUTPUT FILE UNIT FOR MESSAGES (NORMALLY 6)
C          *NREC*  IS THE RECORD NUMBER WHERE WE START READING
C
      IUNITO= IINP1
      IWRITE= IOUT1
      IF( IWRITE.EQ.0 )THEN
         JWRITE= 6
      ELSE
         JWRITE= IWRITE
      ENDIF
C
C     READ TOP OF OBJECT FILE
      IRECOR= 1
      READ(IUNITO,REC=IRECOR,ERR=9023,IOSTAT=IRETCD)
     1     CPARAV,MYRECO,NRECOR,NINPUT,MAXLVL,NSTACK,
     2     IXRLST,IOULST,IDBLST
      IF( IRETCD.NE.0 ) GO TO 9024
      IF( CPARAV.NE.CL2000 ) GO TO 9025
      IF( NREC.NE.0 ) IRECOR= NREC
      NWORDS= 0
      IWORDS= 0
      IVABEG= NINPUT
      IVAEND= NINPUT+NSTACK+1
      IF( IWRITE.NE.0.AND.IRECOR.EQ.1 )THEN
C
C        WRITE TITLE AND OPTIONS
*         IF( MYRECO.NE.CBLA72 )THEN
*            WRITE(IWRITE,'(2H .,72(1H-),1H.)')
*            WRITE(IWRITE,'(2H .,A72,1H.)') MYRECO
*         ENDIF
      ENDIF
 6666 RETURN
 9023 IRETCD= -1
 9024 WRITE(JWRITE,*)' IOSTAT RETURN CODE =',IRETCD
      CALL XABORT( 'REDOPN: IMPOSSIBLE TO USE THIS *STACK* FILE')
 9025 CALL XABORT( 'REDOPN: UNABLE TO OPEN FILE' )
      GO TO 6666
*
      ENTRY REDCLS (IINP1,IOUT1,NREC)
C
C          *REDCLS* ENTRY POINT
C                   TO CLOSE THE DA-FILE AT A CURRENT RECORD POSITION
C     OUTPUT VARIABLES:
C          *IINP1* IS THE CLE-2000 DA-FILE UNIT
C          *IOUT1* IS THE OUTPUT FILE UNIT FOR MESSAGES (NORMALLY 6)
C          *NREC*  IS THE RECORD NUMBER WHERE WE STOP READING
C
      IF( NWORDS.NE.IWORDS )THEN
         CALL XABORT('REDCLS: RECORD NOT FINISHED => CANNOT CLOSE')
      ENDIF
      NREC=  IRECOR
      IINP1= IUNITO
      IOUT1= IWRITE
C
C     WE PUT IRECOR=0 TO CLOSE THE READER (SEE START OF *REDGET*)
      IRECOR= 0
      NINPUT= 0
      NWORDS= 0
      IWORDS= 0
      RETURN
*
      END
