/* Author: R.Roy (99/03/01) */
/* Subroutine setara */

#include "xabort.h"

#if defined(absoft) || defined(CRAY) || defined(MSDOS)
#define SETARA SETARA
#define RLSARA RLSARA

#elif defined(SunOS) || defined(Linux) || defined(DEC) || defined(MIPS)
#define SETARA setara_
#define RLSARA rlsara_

#else
#define SETARA setara
#define RLSARA rlsara

#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#if defined(DEC) || ( defined(Linux) && defined(__x86_64__) )
#  define LCMDECAL 8
#else
#  define LCMDECAL 4
#endif

static char AbortString[80];

#if defined(debug)
void SETARA(long *base, long *length, long *iof)
{
    char *nomsub="SETARA";
    long  *kaddr;
    int lentot, i;

    lentot = (*length * LCMDECAL ) + LCMDECAL*4 ;
    kaddr = (long *)malloc(lentot);
    if (kaddr == 0) {
        sprintf(AbortString,"%s: invalid return code %ld length=%d",nomsub,(long)kaddr,lentot);
        XABORT(AbortString,strlen(AbortString));
    }
    *iof = kaddr - base + 3;
    #if defined(zero)
      for (i=0; i < *length; i++) base[*iof + i - 1] = 0.0;
    #endif
    base[*iof - 2] = *length + 2;
    base[*iof - 3] = *length + 2;
    base[*iof + *length - 1] = *length + 2;
    base[*iof + *length    ] = *length + 2;
    return;
}

/* Subroutine rlsara */
void RLSARA(long *base)
{
    char *nomsub="RLSARA";
    long  *icode, il1, il2;

    icode=base;
    --icode;
    il1=*icode;
    --icode;
    il2=*icode;
    if (il1 == il2) {
        il2= *(icode+il1);
        if (il1 == il2) {
            il2= *(icode+il1+1);
            if (il1 == il2) {
                free(icode);
            } else {
                sprintf(AbortString,"%s: RLSARA error 1.",nomsub);
                XABORT(AbortString,strlen(AbortString));
            }
        } else {
            sprintf(AbortString,"%s: RLSARA error 2.",nomsub);
            XABORT(AbortString,strlen(AbortString));
        }
    } else {
        sprintf(AbortString,"%s: RLSARA error 3.",nomsub);
        XABORT(AbortString,strlen(AbortString));
    }
    return;
}

#else

void SETARA(long *base, long *length, long *iof)
{
    char *nomsub="SETARA";
    long  *kaddr;
    int  lentot, i;
    static long isr = 1;

    lentot = (*length * LCMDECAL ) + LCMDECAL*2;
    kaddr = (long *)malloc(lentot);
    if (kaddr == 0) {
        sprintf(AbortString,"%s: invalid return code %ld length=%d",nomsub,(long)kaddr,lentot);
        XABORT(AbortString,strlen(AbortString));
    }
    *(kaddr+1) = *length + 2;
    *iof = kaddr - base + 3;
    #if defined(zero)
      for (i=0; i < *length; i++) base[*iof + i - 1] = 0.0;
    #endif
    return;
}

/* Subroutine RLSARA */
void RLSARA(long *base)
{
    free(base - 2);
    return;
}

#endif
