*DECK XSMLEN
      SUBROUTINE XSMLEN(IPLIST,NAMP,ILONG,ITYPE)
*
*-----------------------------------------------------------------------
*
* RETURN THE LENGTH AND TYPE OF A BLOCK. RETURN 0 IF THE BLOCK DOES NOT
* EXISTS.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*   NAMP  : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*           ILONG=-1 IS RETURNED FOR A SCALAR DIRECTORY.
*           ILONG=0 IF THE BLOCK DOES NOT EXISTS.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*           0: DIRECTORY                1: INTEGER
*           2: SINGLE PRECISION         3: CHARACTER*4
*           4: DOUBLE PRECISION         5: LOGICAL
*           6: COMPLEX                 99: UNDEFINED
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      INTEGER PFXS2
      CHARACTER NAMP*(*),NAMT*12,HNAME*12,HSMG*131
      PARAMETER (IHEAD=0,IHNAM=1,IIMPF=5,IIDIR=6,IBLOC=7)
      PARAMETER (IOFMAX=30,KIFILE=0,KIDIR=1,KMODIF=2,KIOFT=3,
     1 KNMT=4,KLINK=5,KIROOT=6,KMYNAM=7,KIOFS=10,KJLON=KIOFS+IOFMAX,
     2 KJTYP=KJLON+IOFMAX,KCMT=KJTYP+IOFMAX)
      COMMON IBASE(1)
*
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      IF(IBASE(IPLIST+IHEAD).NE.200) THEN
         WRITE(HSMG,'(A,A12,A)') 'XSMLEN: THE XSM FILE ''',HNAME,
     1   ''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      PFXS2=IBASE(IPLIST+IBLOC)
*     -------------------------------------------------
      CALL XSMREP(NAMT,1,IBASE(IPLIST+IIDIR),PFXS2,III)
*     -------------------------------------------------
      ILONG=0
      ITYPE=99
      IF(III.GT.0) THEN
*        THE BLOCK EXISTS.
         ILONG=IBASE(PFXS2+KJLON+III-1)
         ITYPE=IBASE(PFXS2+KJTYP+III-1)
      ENDIF
      RETURN
      END
