*DECK XSMLID
      SUBROUTINE XSMLID(IPLIST,NAMP,ILONG,JPLIST)
*
*-----------------------------------------------------------------------
*
* CREATE/ACCESS THE HIERARCHICAL STRUCTURE OF A LIST IN A XSM FILE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE FATHER TABLE.
*    NAMP : CHARACTER*12 NAME OF THE DAUGHTER LIST.
*   ILONG : DIMENSION OF THE DAUGHTER LIST.
*
* OUTPUT PARAMETER:
*  JPLIST : ADDRESS OF THE DAUGHTER LIST.
*
*------------------------------------ AUTHOR: A. HEBERT ; 20/02/00 -----
*
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,IIMPF=5,IIDIR=6,IBLOC=7,
     1 ICANG=8,IFATH=9,LXDIR1=11)
      PARAMETER (IOFMAX=30,KIFILE=0,KIDIR=1,KMODIF=2,KIOFT=3,
     1 KNMT=4,KLINK=5,KIROOT=6,KMYNAM=7,KIOFS=10,KJLON=KIOFS+IOFMAX,
     2 KJTYP=KJLON+IOFMAX,KCMT=KJTYP+IOFMAX)
      PARAMETER(IPRIM=3,IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
      INTEGER PFXS2
      CHARACTER NAMP*(*),NAMT*12,HSMG*131,HNAME*12
      COMMON IBASE(1)
*
      NAMT=NAMP
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      IF(IBASE(IPLIST+IHEAD).NE.200) THEN
         WRITE(HSMG,'(A,A12,A)') 'XSMLID: THE XSM FILE ''',HNAME,
     1   ''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ELSE IF(ILONG.LE.0) THEN
         WRITE(HSMG,'(2A,I5,A,A12,A,A12,A)') 'XSMLID: INVALID NODE',
     1   ' LENGTH (',ILONG,'). XSM FILE = ''',HNAME,''' NODE = ''',
     2   NAMT,'''.'
         CALL XABORT(HSMG)
      ENDIF
      PFXS2=IBASE(IPLIST+IBLOC)
*     -------------------------------------------------
      CALL XSMREP(NAMT,2,IBASE(IPLIST+IIDIR),PFXS2,III)
*     -------------------------------------------------
      LENOLD=IBASE(PFXS2+KJLON+III-1)
      ITYOLD=IBASE(PFXS2+KJTYP+III-1)
      IF(((ILONG.GT.LENOLD).AND.(ITYOLD.EQ.10)).OR.
     1        (LENOLD.EQ.0)) THEN
*        CREATE ILONG-LENOLD NEW LIST EXTENTS ON THE XSM FILE.
         IF(IBASE(IPLIST+IIMPF).EQ.2) THEN
            WRITE(HSMG,'(A,A12,A)') 'XSMLID: THE XSM FILE ''',HNAME,
     1      ''' IS OPEN IN READ-ONLY MODE(2).'
            CALL XABORT(HSMG)
         ENDIF
         IBASE(PFXS2+KJLON+III-1)=ILONG
         IBASE(PFXS2+KJTYP+III-1)=10
         IDIOLD=IBASE(PFXS2+KIOFS+III-1)
         IBASE(PFXS2+KIOFS+III-1)=IBASE(PFXS2+KIOFT)
         IDIR=IBASE(PFXS2+KIOFS+III-1)
         IBASE(PFXS2+KIOFT)=IBASE(PFXS2+KIOFT)+ILONG
         IROOLD=IBASE(PFXS2+KIDIR)
         CALL XSMDIR(2,PFXS2)
*
         CALL SETARA(IBASE,ILONG,IIVEC)
         IF(LENOLD.GT.0) THEN
            CALL KDIGET(IBASE(PFXS2+KIFILE),IBASE(IIVEC),IDIOLD,
     1      LENOLD,IRC)
            IF(IRC.NE.0) GO TO 110
         ENDIF
         DO 10 I=ABS(LENOLD)+1,ILONG
         IBASE(IIVEC+I-1)=IBASE(PFXS2+KIOFT)
         IBASE(PFXS2+KIROOT)=IROOLD
         READ(NAMT,'(3A4)') (IBASE(PFXS2+KMYNAM+I0),I0=0,2)
         IBASE(PFXS2+KNMT)=0
         IBASE(PFXS2+KIDIR)=IBASE(PFXS2+KIOFT)
         IBASE(PFXS2+KIOFT)=IBASE(PFXS2+KIOFT)+KLONG
         IBASE(PFXS2+KLINK)=IBASE(PFXS2+KIDIR)
         CALL XSMDIR(2,PFXS2)
   10    CONTINUE
         CALL KDIPUT(IBASE(PFXS2+KIFILE),IBASE(IIVEC),IDIR,ILONG,IRC)
         IF(IRC.NE.0) GO TO 100
         CALL RLSARA(IBASE(IIVEC))
      ELSE IF((LENOLD.EQ.ILONG).AND.(ITYOLD.EQ.10)) THEN
         IDIR=IBASE(PFXS2+KIOFS+III-1)
      ELSE IF(ITYOLD.NE.10) THEN
         WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         WRITE(HSMG,'(A,A12,A,A12,A)') 'XSMLID: BLOCK ''',NAMT,
     1   ''' IS NOT A LIST OF THE XSM FILE ''',HNAME,'''.'
         CALL XABORT(HSMG)
      ELSE
         WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         WRITE(HSMG,'(2A,A12,A,A12,A,I6,A)') 'XSMLID: THE LIST ''',
     1   NAMT,''' OF THE XSM FILE ''',HNAME,
     2   ''' HAS AN INVALID LENGTH (',ILONG,').'
         CALL XABORT(HSMG)
      ENDIF
      CALL SETARA(IBASE,ILONG,IIVEC)
      CALL KDIGET(IBASE(PFXS2+KIFILE),IBASE(IIVEC),IDIR,ILONG,IRC)
      IF(IRC.NE.0) GO TO 110
      CALL SETARA(IBASE,ILONG*LXDIR1,IOFSET)
      JPLIST=IOFSET
      DO 40 I=1,ILONG
      DO 30 J=1,LXDIR1
   30 IBASE(IOFSET+J-1)=IBASE(IPLIST+J-1)
      IBASE(IOFSET+ILLIST)=0
      IBASE(IOFSET+IIDIR)=IBASE(IIVEC+I-1)
      IBASE(IOFSET+IFATH)=IPLIST
   40 IOFSET=IOFSET+LXDIR1
      IBASE(JPLIST+ILLIST)=ILONG
      CALL XSMKEP(IBASE(IPLIST+ICANG),1,JPLIST)
      CALL RLSARA(IBASE(IIVEC))
      RETURN
*
  100 IRC=KDRCLS(IUNIT,1)
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      WRITE(HSMG,'(A,I6,A,A12,A)') 'XSMLID: KDIPUT ERROR NB.',IRC,
     1 ' ON XSM FILE ''',HNAME,'''.'
      CALL XABORT(HSMG)
  110 IRC=KDRCLS(IUNIT,1)
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      WRITE(HSMG,'(A,I6,A,A12,A)') 'XSMLID: KDIGET ERROR NB.',IRC,
     1 ' ON XSM FILE ''',HNAME,'''.'
      CALL XABORT(HSMG)
      END
