*DECK XSMOP
      SUBROUTINE XSMOP(IPLIST,NAMP,IMP,IMPX)
*
*-----------------------------------------------------------------------
*
* OPEN AN EXISTING OR CREATE A NEW XSM FILE. VECTORIAL VERSION.
*
* THE XSM DATABASE RESULTS FROM THE JUXTAPOSITION OF A HIERARCHICAL
* LOGICAL STRUCTURE INTO A DIRECT ACCESS FILE WITH FIXE LENGTH RECORDS.
* THE DIRECT ACCESS FILE IS FORTRAN-77 COMPATIBLE AND IS MANAGED BY
* KDIGET/PUT/CL. XSMOP/PUT/GET/LEN/VEC/NXT/CL ENTRIES PROVIDE A SET OF
* METHODS TO ACCESS A XSM FILE.
*
* THE LOGICAL STRUCTURE OF A XSM FILE IS MADE OF A ROOT DIRECTORY FOL-
* LOWED BY VARIABLE-LENGTH BLOCKS CONTAINING THE USEFULL INFORMATION.
* EACH TIME A DIRECTORY IS FULL, AN EXTENT IS AUTOMATICALLY CREATED AT
* THE END OF THE FILE, SO THAT THE TOTAL NUMBER OF BLOCKS IN A DIREC-
* TORY IS ONLY LIMITED BY THE MAXIMUM SIZE OF THE DIRECT ACCESS FILE.
* ANY BLOCK CAN CONTAIN A SUB-DIRECTORY IN ORDER TO CREATE A HIERAR-
* CHICAL STRUCTURE.
*
* INPUT PARAMETERS:
*    NAMP : CHARACTER*12 NAME OF THE XSM FILE.
*     IMP : TYPE OF ACCESS.  =0: NEW FILE MODE;
*                            =1: MODIFICATION MODE;
*                            =2: READ ONLY MODE.
*    IMPX : IF IMPX=0, WE SUPPRESS PRINTING ON XSMOP.
*
* OUTPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*    NAMP : CHARACTER*12 NAME OF THE XSM FILE IF IMP=1 OR IMP=2.
*
* THE ACTIVE DIRECTORY IS MADE OF TWO BLOCKS LINKED TOGETHER. A BLOCK 1
* IS ALLOCATED FOR EACH SCALAR DIRECTORY OR VECTOR DIRECTORY COMPONENT.
* BLOCK 2 IS UNIQUE FOR A GIVEN XSM FILE; EVERY BLOCK 1 IS POINTING TO
* THE SAME BLOCK 2.
*
* ACTIVE DIRECTORY RESIDENT-MEMORY XSM STRUCTURE (BLOCK 1):
*    0 IHEAD  : HEADER (=200 FOR AN XSM FILE).
*    1 IHNAM  : CHARACTER*12 NAME OF THE XSM FILE.
*    4 ILLIST : NUMBER OF ELEMENTS IN THE LIST.
*    5 IIMPF  : TYPE OF ACCESS (1:MODIF OR 2:READ-ONLY).
*    6 IIDIR  : OFFSET OF ACTIVE DIRECTORY ON XSM FILE.
*    7 IBLOC  : ADDRESS OF BLOCK 2 IN MEMORY.
*    8 ICANG  : SETARA ADDRESS OF THE DATABASE HANDLE.
*    9 IFATH  : SETARA ADDRESS OF THE FATHER ACTIVE DIRECTORY RESIDENT-
*               MEMORY XSM STRUCTURE. =0 FOR ROOT DIRECTORY.
*   10 ICANG2 : SETARA ADDRESS OF THE XSMIOF DATABASE.
*
* ACTIVE DIRECTORY RESIDENT-MEMORY XSM STRUCTURE (BLOCK 2):
*    0 KIFILE : XSM (KDI) FILE UNIT NUMBER.
*    1 KIDIR  : OFFSET OF ACTIVE DIRECTORY ON XSM FILE.
*    2 KMODIF : =1 IF THE ACTIVE DIRECTORY EXTENT HAS BEEN MODIFIED.
*    3 KIOFT  : MAXIMUM ADDRESS ON XSM FILE.
*    4 KNMT   : EXACT NUMBER OF NODES ON THE ACTIVE DIRECTORY EXTENT.
*    5 KLINK  : OFFSET OF THE NEXT DIRECTORY EXTENT.
*    6 KIROOT : OFFSET OF ANY PARENT DIRECTORY EXTENT.
*    7 KMYNAM : CHARACTER*12 NAME OF THE ACTIVE DIRECTORY. ='/' FOR
*               THE ROOT LEVEL.
*   10 KIOFS  : OFFSET LIST (POSITION OF THE FIRST ELEMENT OF EACH BLOCK
*               THAT BELONG TO THE ACTIVE DIRECTORY EXTENT).
*   40 KJLON  : LENGTH OF EACH RECORD (JLONG=0 FOR A DIRECTORY) THAT 
*               BELONG TO THE ACTIVE DIRECTORY EXTENT.
*   70 KJTYP  : TYPE OF EACH BLOCK THAT BELONG TO THE ACTIVE DIRECTORY
*               EXTENT.
*  100 KCMT   : LIST OF CHARACTER*12 NAMES OF EACH BLOCK (RECORD OR
*               DIRECTORY) THAT BELONG TO THE ACTIVE DIRECTORY EXTENT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,IIMPF=5,IIDIR=6,IBLOC=7,
     1 ICANG=8,IFATH=9,ICANG2=10,LXDIR1=11)
      PARAMETER (IOFMAX=30,KIFILE=0,KIDIR=1,KMODIF=2,KIOFT=3,
     1 KNMT=4,KLINK=5,KIROOT=6,KMYNAM=7,KIOFS=10,KJLON=KIOFS+IOFMAX,
     2 KJTYP=KJLON+IOFMAX,KCMT=KJTYP+IOFMAX,LXDIR2=KCMT+3*IOFMAX)
      INTEGER PFXSM,PFXS2
      CHARACTER NAMP*(*),NAMT*72,HSMG*131,HMYNAM*12,HEADER*4
      PARAMETER (IPRIM=3,IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
*     IPRIM=OFFSET OF THE ROOT DIRECTORY.
*     KLONG=LENGTH OF A DIRECTORY EXTENT IN MEMORY.
      COMMON IBASE(1)
*
* OPEN THE XSM FILE.
      NAMT=NAMP
      IF((IMP.LT.0).OR.(IMP.GT.2)) THEN
         WRITE(HSMG,'(A,I3,A,A12,A)') 'XSMOP: INVALID ACTION (',IMP,
     1   ') ON XSM FILE ''',NAMT,'''.'
         CALL XABORT(HSMG)
      ENDIF
      CALL SETARA(IBASE,LXDIR1,PFXSM)
      CALL SETARA(IBASE,LXDIR2,PFXS2)
*
      CALL SETARA(IBASE,3,IPKEEP)
      IBASE(PFXSM+ICANG)=IPKEEP
      IBASE(IPKEEP)=0
      IBASE(IPKEEP+1)=0
      IBASE(IPKEEP+2)=0
*
      CALL SETARA(IBASE,3,IPKEP2)
      IBASE(PFXSM+ICANG2)=IPKEP2
      IBASE(IPKEP2)=0
      IBASE(IPKEP2+1)=0
      IBASE(IPKEP2+2)=0
*
      IBASE(PFXSM+IHEAD)=200
      IBASE(PFXSM+ILLIST)=-1
      IBASE(PFXSM+IIMPF)=IMP
      IBASE(PFXSM+IBLOC)=PFXS2
      IBASE(PFXSM+IFATH)=0
      READ(NAMT,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IUNIT=KDIOP(NAMT,IMP)
      IF(IUNIT.EQ.0) THEN
         WRITE(HSMG,'(2A,A12,A,I12,A)') 'XSMOP: UNABLE TO OPEN XSM FI',
     1   'LE ''',NAMT,''' (IER =',IUNIT,').'
         CALL XABORT(HSMG)
      ENDIF
      IBASE(PFXS2+KIFILE)=IUNIT
      IF(IMPX.GT.1) WRITE (6,'(/2A,I5,A,A12,A,I3)') ' XSMOP: KDI FILE',
     1 ' OPEN =',IBASE(PFXS2+KIFILE),' NAME =''',NAMT,''' ACTION =',IMP
      IF(IMP.GE.1) THEN
*        RECOVER THE ROOT DIRECTORY IF THE XSM FILE ALREADY EXISTS.
         CALL KDIGET(IBASE(PFXS2+KIFILE),IBUF,0,1,IRC)
         IF(IRC.NE.0) GO TO 140
         WRITE(HEADER,'(A4)') IBUF
         IF(HEADER.NE.'$XSM') THEN
           WRITE(HSMG,'(A,A12,A)') 'XSMOP: WRONG HEADER ON XSM FILE ''',
     1     NAMT,'''.'
           CALL XABORT(HSMG)
         ENDIF
         CALL KDIGET(IBASE(PFXS2+KIFILE),IBASE(PFXS2+KIOFT),1,1,IRC)
         IF(IRC.NE.0) GO TO 140
         CALL KDIGET(IBASE(PFXS2+KIFILE),IBASE(PFXS2+KIDIR),2,1,IRC)
         IF(IRC.NE.0) GO TO 140
         IBASE(PFXSM+IIDIR)=IBASE(PFXS2+KIDIR)
         CALL XSMDIR(1,PFXS2)
         IBASE(PFXS2+KMODIF)=0
         IF(IMPX.GT.0) WRITE (6,180) NAMP,IBASE(PFXS2+KIOFT),
     1   (IBASE(PFXS2+KMYNAM+I),I=0,2)
      ELSE
*        NEW-FILE MODE.
         IBASE(PFXSM+IIMPF)=1
         IBASE(PFXS2+KIOFT)=IPRIM+KLONG
         IBASE(PFXS2+KIDIR)=IPRIM
         IBASE(PFXSM+IIDIR)=IPRIM
         IBASE(PFXS2+KIROOT)=-1
         IBASE(PFXS2+KNMT)=0
         IBASE(PFXS2+KLINK)=IBASE(PFXS2+KIDIR)
         HMYNAM='/'
         READ(HMYNAM,'(3A4)') (IBASE(PFXS2+KMYNAM+I0),I0=0,2)
         IBASE(PFXS2+KMODIF)=1
         HEADER='$XSM'
         READ(HEADER,'(A4)') IBUF
         CALL KDIPUT(IBASE(PFXS2+KIFILE),IBUF,0,1,IRC)
         IF(IRC.NE.0) GO TO 150
         CALL KDIPUT(IBASE(PFXS2+KIFILE),IBASE(PFXS2+KIOFT),1,1,IRC)
         IF(IRC.NE.0) GO TO 150
         CALL KDIPUT(IBASE(PFXS2+KIFILE),IBASE(PFXS2+KIDIR),2,1,IRC)
         IF(IRC.NE.0) GO TO 150
      ENDIF
      IPLIST=PFXSM
      RETURN
*
  140 WRITE(HSMG,'(A,I6,A,A12,A)') 'XSMOP: KDIGET ERROR NB.',IRC,
     1 ' ON XSM FILE ''',NAMT,'''.'
      CALL XABORT(HSMG)
  150 WRITE(HSMG,'(A,I6,A,A12,A)') 'XSMOP: KDIPUT ERROR NB.',IRC,
     1 ' ON XSM FILE ''',NAMT,'''.'
      CALL XABORT(HSMG)
  180 FORMAT (/35H XSMOP: XSM FILE RECOVERY. FILE = ',A8,1H'/27X,
     1 28HHIGHEST ATTAINABLE ADDRESS =,I10/27X,20HACTIVE DIRECTORY = ',
     2 3A4,1H'/)
      END
