*DECK XSMPUT
      SUBROUTINE XSMPUT(IPLIST,NAMP,ILONG,ITYPE,DATA1)
*
*-----------------------------------------------------------------------
*
* COPY A BLOCK FROM MEMORY INTO THE XSM FILE.
*
* INPUT PARAMETER:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*           0: DIRECTORY                1: INTEGER
*           2: SINGLE PRECISION         3: CHARACTER*4
*           4: DOUBLE PRECISION         5: LOGICAL
*           6: COMPLEX
*   DATA1 : INFORMATION ELEMENTS. DIMENSION DATA1(ILONG)
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      INTEGER PFXS2
      CHARACTER NAMP*(*),NAMT*12,HNAME*12,HSMG*131
      DIMENSION DATA1(*)
      PARAMETER (IHEAD=0,IHNAM=1,IIMPF=5,IIDIR=6,IBLOC=7)
      PARAMETER (IOFMAX=30,KIFILE=0,KIDIR=1,KMODIF=2,KIOFT=3,
     1 KNMT=4,KLINK=5,KIROOT=6,KMYNAM=7,KIOFS=10,KJLON=KIOFS+IOFMAX,
     2 KJTYP=KJLON+IOFMAX,KCMT=KJTYP+IOFMAX)
      COMMON IBASE(1)
*
* COPY A BLOCK FROM MEMORY INTO THE XSM FILE.
      NAMT=NAMP
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      IF(IBASE(IPLIST+IIMPF).EQ.2) THEN
         WRITE(HSMG,'(A,A12,A)') 'XSMPUT: THE XSM FILE ''',HNAME,
     1   ''' IS OPEN IN READ-ONLY MODE.'
         CALL XABORT(HSMG)
      ELSE IF(ILONG.LE.0) THEN
         WRITE(HSMG,'(A,I5,A,A12,A,A12,A)') 'XSMPUT: INVALID LENGTH (',
     1   ILONG,') FOR NODE ''',NAMT,''' IN THE XSM FILE ''',HNAME,'''.'
         CALL XABORT(HSMG)
      ELSE IF((ITYPE.LE.0).OR.(ITYPE.GE.8)) THEN
         WRITE(HSMG,'(A,I3,A,A12,A)') 'XSMPUT: INVALID TYPE NUMBER (',
     1   ITYPE,') FOR XSM FILE ''',HNAME,'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).NE.200) THEN
         WRITE(HSMG,'(A,A12,A)') 'XSMPUT: THE XSM FILE ''',HNAME,
     1   ''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ENDIF
      PFXS2=IBASE(IPLIST+IBLOC)
*     -------------------------------------------------
      CALL XSMREP(NAMT,2,IBASE(IPLIST+IIDIR),PFXS2,III)
*     -------------------------------------------------
      IBASE(PFXS2+KMODIF)=1
      IF(ILONG.GT.IBASE(PFXS2+KJLON+III-1)) THEN
         IBASE(PFXS2+KIOFS+III-1)=IBASE(PFXS2+KIOFT)
         IBASE(PFXS2+KIOFT)=IBASE(PFXS2+KIOFT)+ILONG
      ENDIF
      IBASE(PFXS2+KJLON+III-1)=ILONG
      IBASE(PFXS2+KJTYP+III-1)=ITYPE
      CALL KDIPUT(IBASE(PFXS2+KIFILE),DATA1,IBASE(PFXS2+KIOFS+III-1),
     1 ILONG,IRC)
      IF(IRC.NE.0) GO TO 150
      RETURN
*
  150 WRITE(HSMG,'(A,I6,A,A12,A)') 'XSMPUT: KDIPUT ERROR NB.',IRC,
     1 ' ON XSM FILE ''',HNAME,'''.'
      CALL XABORT(HSMG)
      END
