*DECK XSMREP
      SUBROUTINE XSMREP(NAMT,IND,IDIR,PFXS2,III)
*
*-----------------------------------------------------------------------
*
* FIND A BLOCK (RECORD OR DIRECTORY) POSITION IN THE ACTIVE DIRECTORY
* AND RELATED EXTENTS.
*
* INPUT PARAMETERS:
*  NAMT   : CHARACTER*12 NAME OF THE REQUIRED BLOCK.
*  IND    : =1 SEARCH NAMT ; =2 SEARCH AND POSITIONNING IN AN EMPTY
*           SLOT OF THE ACTIVE DIRECTORY IF NAMT DOES NOT EXISTS.
*  IDIR   : OFFSET OF ACTIVE DIRECTORY ON XSM FILE.
*  PFXS2  : ADDRESS OF MEMORY-RESIDENT XSM STRUCTURE (BLOCK 2).
*
* OUTPUT PARAMETER:
*  III    : RETURN CODE. =0 IF THE BLOCK NAMED NAMT DOES NOT EXISTS;
*           =POSITION IN THE ACTIVE DIRECTORY EXTENT IF NAMT EXTSTS.
*           =0 OR 1 IF NAMT=' '.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IHEAD=0,IHNAM=1,IIMPF=5,IIDIR=6,IBLOC=7)
      PARAMETER (IOFMAX=30,KIFILE=0,KIDIR=1,KMODIF=2,KIOFT=3,
     1 KNMT=4,KLINK=5,KIROOT=6,KMYNAM=7,KIOFS=10,KJLON=KIOFS+IOFMAX,
     2 KJTYP=KJLON+IOFMAX,KCMT=KJTYP+IOFMAX)
      PARAMETER(IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
      INTEGER PFXS2
      CHARACTER NAMT*(*),CMT(IOFMAX)*12,NAMP*12,HSMG*131,HNAME*12
      COMMON IBASE(1)
*
      IF(IBASE(PFXS2+KIDIR).NE.IDIR) THEN
*        SWITCH TO THE CORRECT ACTIVE DIRECTORY (BLOCK 2).
         IF(IBASE(PFXS2+KMODIF).EQ.1) CALL XSMDIR(2,PFXS2)
         IBASE(PFXS2+KIDIR)=IDIR
         CALL XSMDIR(1,PFXS2)
      ENDIF
*
      IF(NAMT.EQ.'***HANDLE***') THEN
         CALL XABORT('XSMREP: ***HANDLE*** IS A RESERVED KEYWORD.')
      ENDIF
      NAMP=NAMT
      IF(NAMT.EQ.' ') NAMP='***HANDLE***'
*
      DO 10 I=1,IBASE(PFXS2+KNMT)
      WRITE(CMT(I),'(3A4)') (IBASE(PFXS2+KCMT+3*(I-1)+II),II=0,2)
   10 CONTINUE
*
      IPOS=-1
      IF(IBASE(PFXS2+KNMT).LT.IOFMAX) IPOS=IBASE(PFXS2+KIDIR)
      IF(IBASE(PFXS2+KNMT).EQ.0) GO TO 50
      DO 20 I=1,IBASE(PFXS2+KNMT)
      IF(NAMP.EQ.CMT(I)) THEN
*        THE BLOCK ALREADY EXISTS.
         III=I
         RETURN
      ENDIF
   20 CONTINUE
*
*     THE BLOCK NAMP DOES NOT EXISTS IN THE ACTIVE DIRECTORY EXTENT. WE
*     SEARCH IN OTHER EXTENTS THAT BELONG TO THE ACTIVE DIRECTORY.
      IF(IBASE(PFXS2+KIDIR).NE.IBASE(PFXS2+KLINK)) THEN
*        RECOVER A NEW DIRECTORY EXTENT.
         ISTART=IBASE(PFXS2+KLINK)
         IF(IBASE(PFXS2+KMODIF).EQ.1) CALL XSMDIR(2,PFXS2)
         IBASE(PFXS2+KIDIR)=ISTART
   30    CALL XSMDIR(1,PFXS2)
         DO 35 I=1,IBASE(PFXS2+KNMT)
         WRITE(CMT(I),'(3A4)') (IBASE(PFXS2+KCMT+3*(I-1)+II),II=0,2)
   35    CONTINUE
         IF(IBASE(PFXS2+KNMT).LT.IOFMAX) IPOS=IBASE(PFXS2+KIDIR)
         DO 40 I=1,IBASE(PFXS2+KNMT)
         IF(NAMP.EQ.CMT(I)) THEN
*           THE BLOCK NAMP WAS FOUND IN THE ACTIVE DIRECTORY EXTENT.
            III=I
            RETURN
         ENDIF
   40    CONTINUE
         IF(IBASE(PFXS2+KLINK).EQ.ISTART) GO TO 50
         IBASE(PFXS2+KIDIR)=IBASE(PFXS2+KLINK)
         GO TO 30
      ENDIF
   50 III=0
      IF(IND.EQ.1) RETURN
*
      IF((IPOS.GE.0).AND.(IPOS.NE.IBASE(PFXS2+KIDIR))) THEN
*        AN EXTENT WITH AN EMPTY SLOT WAS FOUND.
         IF(IBASE(PFXS2+KMODIF).EQ.1) CALL XSMDIR(2,PFXS2)
         IBASE(PFXS2+KIDIR)=IPOS
         CALL XSMDIR(1,PFXS2)
      ELSE IF(IPOS.EQ.-1) THEN
*        THE ACTIVE DIRECTORY IS FULL. CREATE AN EXTENT.
         IPOS=IBASE(PFXS2+KLINK)
         IBASE(PFXS2+KLINK)=IBASE(PFXS2+KIOFT)
         IF(IBASE(PFXS2+KMODIF).EQ.1) THEN
            CALL XSMDIR(2,PFXS2)
         ELSE
            CALL KDIPUT(IBASE(PFXS2+KIFILE),IBASE(PFXS2+KLINK),
     1      IBASE(PFXS2+KIDIR)+3,1,IRC)
            IF(IRC.NE.0) GO TO 150
         ENDIF
         IBASE(PFXS2+KIDIR)=IBASE(PFXS2+KLINK)
         IBASE(PFXS2+KLINK)=IPOS
         IBASE(PFXS2+KIOFT)=IBASE(PFXS2+KIOFT)+KLONG
         IBASE(PFXS2+KNMT)=0
      ENDIF
      IBASE(PFXS2+KNMT)=IBASE(PFXS2+KNMT)+1
      III=IBASE(PFXS2+KNMT)
      IBASE(PFXS2+KMODIF)=1
      IBASE(PFXS2+KJLON+III-1)=0
      IBASE(PFXS2+KJTYP+III-1)=99
      READ(NAMP,'(3A4)') (IBASE(PFXS2+KCMT+(III-1)*3+I),I=0,2)
      RETURN
*
  150 IRC=KDRCLS(IBASE(PFXS2+KIFILE),1)
      WRITE(HNAME,'(3A4)') (IBASE(PFXS2+IHNAM+I),I=0,2)
      WRITE(HSMG,'(A,I6,A,A12,A)') 'XSMREP: KDIPUT ERROR NB.',IRC,
     1 ' ON XSM FILE ''',HNAME,'''.'
      CALL XABORT(HSMG)
      END
