*DECK XSMSIX
      SUBROUTINE XSMSIX(IPLIST,NAMP,IACT)
*
*-----------------------------------------------------------------------
*
* MOVE IN THE SCALAR HIERARCHICAL STRUCTURE OF A XSM FILE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE FATHER/SON TABLE.
*    NAMP : CHARACTER*12 NAME OF THE SON TABLE IF IACT=1.
*           NOT USED IF IACT=0 OR IACT=2.
*    IACT : TYPE OF MOVEMENT IN THE HIERARCHICAL STRUCTURE.
*           0: MOVE BACK TO THE ROOT DIRECTORY;
*           1: MOVE TO A SON VECTORIAL DIRECTORY;
*           2: MOVE BACK TO THE PARENT DIRECTORY.
*
*------------------------------------ AUTHOR: A. HEBERT ; 09/10/99 -----
*
      PARAMETER (IHEAD=0,IHNAM=1,ILLIST=4,IIMPF=5,IIDIR=6,IBLOC=7,
     1 ICANG=8,IFATH=9,LXDIR1=11)
      PARAMETER (IOFMAX=30,KIFILE=0,KIDIR=1,KMODIF=2,KIOFT=3,
     1 KNMT=4,KLINK=5,KIROOT=6,KMYNAM=7,KIOFS=10,KJLON=KIOFS+IOFMAX,
     2 KJTYP=KJLON+IOFMAX,KCMT=KJTYP+IOFMAX)
      PARAMETER(IPRIM=3,IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
      INTEGER PFXS2
      CHARACTER NAMP*(*),NAMT*12,HSMG*131,HNAME*12
      COMMON IBASE(1)
*
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      IF((IACT.LT.0).OR.(IACT.GT.2)) THEN
         WRITE(HSMG,'(A,I3,A,A12,A)') 'XSMSIX: INVALID ACTION (',IACT,
     1   ') ON THE XSM FILE ''',HNAME,'''.'
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).NE.200) THEN
         WRITE(HSMG,'(A,A12,A)') 'XSMSIX: THE XSM FILE ''',HNAME,
     1   ''' HAS THE WRONG HEADER.'
         CALL XABORT(HSMG)
      ENDIF
      IF(IACT.EQ.1) THEN
*        MOVE TO A SON DIRECTORY.
         NAMT=NAMP
         PFXS2=IBASE(IPLIST+IBLOC)
*        -------------------------------------------------
         CALL XSMREP(NAMT,2,IBASE(IPLIST+IIDIR),PFXS2,III)
*        -------------------------------------------------
         LENOLD=IBASE(PFXS2+KJLON+III-1)
         IF(LENOLD.EQ.-1) LENOLD=1
         ITYOLD=IBASE(PFXS2+KJTYP+III-1)
         IF(LENOLD.EQ.0) THEN
*           CREATE A NEW SCALAR DIRECTORY EXTENT ON THE XSM FILE.
            IF(IBASE(IPLIST+IIMPF).EQ.2) THEN
               WRITE(HSMG,'(A,A12,A)') 'XSMSIX: THE XSM FILE ''',HNAME,
     1         ''' IS OPEN IN READ-ONLY MODE(1).'
               CALL XABORT(HSMG)
            ENDIF
            IBASE(PFXS2+KJLON+III-1)=-1
            IBASE(PFXS2+KJTYP+III-1)=0
            IBASE(PFXS2+KIOFS+III-1)=IBASE(PFXS2+KIOFT)
            IDIR=IBASE(PFXS2+KIOFS+III-1)
            IBASE(PFXS2+KIOFT)=IBASE(PFXS2+KIOFT)+KLONG
            CALL XSMDIR(2,PFXS2)
            IBASE(PFXS2+KIROOT)=IBASE(PFXS2+KIDIR)
            READ(NAMT,'(3A4)') (IBASE(PFXS2+KMYNAM+I0),I0=0,2)
            IBASE(PFXS2+KIDIR)=IBASE(PFXS2+KIOFS+III-1)
            IBASE(PFXS2+KNMT)=0
            IBASE(PFXS2+KLINK)=IBASE(PFXS2+KIDIR)
            IBASE(PFXS2+KMODIF)=1
         ELSE IF((LENOLD.EQ.1).AND.(ITYOLD.EQ.0)) THEN
            IDIR=IBASE(PFXS2+KIOFS+III-1)
         ELSE IF(ITYOLD.NE.0) THEN
            WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
            WRITE(HSMG,'(A,A12,A,A12,A)') 'XSMSIX: BLOCK ''',NAMT,
     1      ''' IS NOT A DIRECTORY OF THE XSM FILE ''',HNAME,'''.'
            CALL XABORT(HSMG)
         ENDIF
         CALL SETARA(IBASE,LXDIR1,IOFSET)
         DO 20 J=1,LXDIR1
   20    IBASE(IOFSET+J-1)=IBASE(IPLIST+J-1)
         CALL XSMKEP(IBASE(IOFSET+ICANG),1,IOFSET)
         IBASE(IOFSET+ILLIST)=-1
         IBASE(IOFSET+IIDIR)=IDIR
         IBASE(IOFSET+IFATH)=IPLIST
         IPLIST=IOFSET
      ELSE IF((IACT.EQ.0).OR.(IACT.EQ.2)) THEN
*        MOVE BACK TO THE ROOT OR PARENT DIRECTORY.
   50    PFXS2=IBASE(IPLIST+IBLOC)
         IF(IBASE(PFXS2+KMODIF).EQ.1) CALL XSMDIR(2,PFXS2)
         IF(IBASE(PFXS2+KIDIR).NE.IBASE(IPLIST+IIDIR)) THEN
*           SWITCH TO THE CORRECT ACTIVE DIRECTORY (BLOCK 2).
            IBASE(PFXS2+KIDIR)=IBASE(IPLIST+IIDIR)
            CALL XSMDIR(1,PFXS2)
         ENDIF
         IF(IBASE(PFXS2+KIROOT).EQ.-1) THEN
            IF(IACT.EQ.0) THEN
               IF(IBASE(IPLIST).NE.200) THEN
                  CALL XABORT('XSMSIX: WRONG HEADER(1).')
               ENDIF
               RETURN
            ENDIF
            WRITE(HSMG,'(A,A12,A)') 'XSMSIX: THE XSM FILE ''',HNAME,
     1      ''' IS ALREADY ON ROOT DIRECTORY.'
            CALL XABORT(HSMG)
         ENDIF
         WRITE(NAMT,'(3A4)') (IBASE(PFXS2+KMYNAM+I0),I0=0,2)
         IOFSET=IPLIST
         IPLIST=IBASE(IPLIST+IFATH)
*        -------------------------------------------------
         CALL XSMREP(NAMT,1,IBASE(IPLIST+IIDIR),PFXS2,III)
*        -------------------------------------------------
         IF(III.EQ.0) THEN
            WRITE(HSMG,'(2A,A12,A,A12,A)') 'XSMSIX: UNABLE TO STEP DO',
     1      'WN ON FATHER RECORD ''',NAMT,''' FOR XSM FILE ''',HNAME,
     2      '''.'
            CALL XABORT(HSMG)
         ENDIF
         IOFPRE=IOFSET
         CALL XSMKEP(IBASE(IOFSET+ICANG),2,IOFSET)
         CALL RLSARA(IBASE(IOFPRE))
         IF((IACT.EQ.0).AND.(IBASE(IPLIST+IIDIR).NE.IPRIM)) THEN
            GO TO 50
         ELSE IF(IBASE(IPLIST).NE.200) THEN
            CALL XABORT('XSMSIX: WRONG HEADER(2).')
         ENDIF
      ENDIF
      RETURN
      END
