
/**********************************/
/* C API for kdi file support     */
/* author: A. Hebert (30/04/2002) */
/**********************************/

/*
Copyright (C) 2002 Ecole Polytechnique de Montreal

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
*/

#if defined(CRAY) || defined(DEC) || ( defined(Linux) && defined(__x86_64__) )
#define lnword 8
#else
#define lnword 4
#endif

#if !defined(MSDOS)
#include <unistd.h>
#endif
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include "kdi.h"

long offset;

kdi_file * KDIOP_C(char *nomC,long iactio)
{
  kdi_file *my_file;
  my_file = (kdi_file *) malloc(sizeof(*my_file));
  strcpy(my_file->nom,nomC);
  my_file->fd = NULL;
  if (iactio == 0) {
     FILE *file ;
     long fd;
     if ( ( file = fopen(nomC,"rb") ) != NULL ) {
        fclose(file) ;
        perror ("open error 0 in KDIOP_C ");
        return NULL;
     }
     fd = creat(nomC,0600);
     close(fd);
     my_file->fd = fopen(nomC,"r+b");
  } else if (iactio == 1) {
     FILE *file ;
     if ( ( file = fopen(nomC,"rb") ) == NULL ) {
        perror ("open error 1 in KDIOP_C ");
        return NULL;
     }
     fclose(file) ;
     my_file->fd = fopen(nomC,"r+b");
  } else if (iactio == 2) {
     FILE *file ;
     if ( ( file = fopen(nomC,"rb") ) == NULL ) {
        perror ("open error 2 in KDIOP_C ");
        return NULL;
     }
     my_file->fd = file;
  } else {
     return NULL;
  }
  if ( my_file->fd == NULL ) {
     perror ("open error 3 in KDIOP_C ");
     return NULL;
  }
  return my_file;
}

long KDIPUT_C(kdi_file *my_file,long *data,long iofset,long length)
{
  long irc;
  offset=iofset*lnword;
  if (my_file == NULL) {
     irc = -1;
  } else if (fseek(my_file->fd,offset,0) >= 0) {
     long n, iof;
     irc = 0;
     iof = 0;
     while ((n = fwrite(&data[iof],lnword,length,my_file->fd)) < length-iof) {
        if (n < 0) return n-1;
        iof+=n;
     }
  } else {
     irc = -3;
  }
  return irc;
}

long KDIGET_C(kdi_file *my_file,long *data,long iofset,long length)
{
  long irc;
  offset=iofset*lnword;
  if (my_file == NULL) {
     irc = -1;
  } else if (fseek(my_file->fd,offset,0) >= 0) {
     long n, iof;
     irc=0;
     iof=0;
     while ((n = fread(&data[iof],lnword,length,my_file->fd)) < length-iof) {
        if (n < 0) return n-1;
        iof+=n;
     }
  } else {
     irc = -3;
  }
  return irc;
}

long KDICL_C(kdi_file *my_file,long istatu)
{
  long irc;
  if (my_file == NULL) {
     irc = -1;
  } else if (istatu == 1) {
     irc = fclose(my_file->fd);
     free(my_file);
  } else if (istatu == 2) {
     irc = fclose(my_file->fd);
	 if (irc != 0 ) {
        perror ("close error 1 in KDICL_C ");
        return irc;
     }
     irc = remove(my_file->nom);
     free(my_file);
  } else {
     irc = -999;
  }
  my_file = NULL;
  if (irc != 0) perror ("close error 2 in KDICL_C ");
  return irc;
}
