
/**************************************/
/* Fortran bindings for the KDI C API */
/*    AUTHOR: A. HEBERT ; 08/04/2005  */
/**************************************/

/*
Copyright (C) 2005 Ecole Polytechnique de Montreal

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
*/

#if defined(absoft) || defined(CRAY) || defined(MSDOS)
#define KDIOP KDIOP
#define KDIPUT KDIPUT
#define KDIGET KDIGET
#define KDICL KDICL
#elif defined(SunOS) || defined(Linux) || defined(DEC) || defined(MIPS)
#define KDIOP kdiop_
#define KDIPUT kdiput_
#define KDIGET kdiget_
#define KDICL kdicl_
#else
#define KDIOP kdiop
#define KDIPUT kdiput
#define KDIGET kdiget
#define KDICL kdicl
#endif

#include <stdlib.h>
#include <string.h>
#include "kdi.h"

static char *sfortoc(char *nom,long lnom)
{
    static char nomstatic[25];
    register long i,imin;
    strncpy(nomstatic,"\0",25);
    imin=lnom;
    if (imin > 24) { imin = 24; }
    for(i=imin-1;i>0;i--)if(nom[i] != ' ')break;
    strncpy(nomstatic,nom,i+1);
    return nomstatic;
}

long KDIOP(char *nom,long *iactio,long lnom)
{
    char *nomC=sfortoc(nom,lnom);
    long my_file = (long)KDIOP_C(nomC,*iactio);
    return my_file;
}

void KDIGET(long *my_file,long *data,long *iofset,long *length,long *irc)
{
    *irc = (long)KDIGET_C((kdi_file *)*my_file,data,*iofset,*length);
}

void KDIPUT(long *my_file,long *data,long *iofset,long *length,long *irc)
{
    *irc = (long)KDIPUT_C((kdi_file *)*my_file,data,*iofset,*length);
}

void KDICL(long *my_file,long *istatu,long *irc)
{
    *irc = (long)KDICL_C((kdi_file *)*my_file,*istatu);
}
