*DECK ADDHST
      SUBROUTINE ADDHST(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
**********************************************************************
*
*     THIS MODULE COMPUTES ADDITION OF HST OBJECTS
*   -  edition level
*     >2 'CELLXXXXXXXX'
*     >5 LCMLIB at the end
*   -  note:
*     HOUT := ADDHST: HOUT Hi :: ... ;
*     HOUT in modification mode only 
*             for creation mode need to add other level 1 data
*               (to be implemented if necessary)
*
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LCM OBJECTS USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LCM OBJECT.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LCM OBJECT IS CREATED.
*               =1 THE LCM OBJECT IS OPEN FOR MODIFICATIONS;
*               =2 THE LCM OBJECT IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LCM OBJECT ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*
*-------------------------------------- AUTHOR: R. CHAMBON  04/07/2005 -
*
      IMPLICIT NONE
* DRVDRV VARIABLES
      INTEGER   NENTRY
      CHARACTER HENTRY(NENTRY)*12
      INTEGER   IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   HSTPRM(NSTATE)
* SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
* REDGET TYPES
      INTEGER ITYP,NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
*
      CHARACTER*12 TEXT12,NAME
      INTEGER  IPOUT,IPIN
      INTEGER I,K,IDEB,IFIN,KFIN
* LOCAL VARIABLES
      INTEGER NCHA,NK,IPRT
*
      LOGICAL LCNL
*
*     INPUT OBJECT CONTROL
*
      IF(NENTRY.LT.2) CALL XABORT('ADDHST: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('ADDHST:'
     + //' LCM OBJECT EXPECTED AT LHS.')
      IF(JENTRY(1).NE.1) CALL XABORT('ADDHST:'
     + //' MODIFICATION MODE EXPECTED.')
      DO 5 I=2,NENTRY
      IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2)) CALL XABORT('ADDHST:'
     + //' LCM OBJECT EXPECTED AT LHS.')
      IF(JENTRY(I).NE.2) CALL XABORT('ADDHST:'
     + //' READ-ONLY MODE EXPECTED.')
 5    CONTINUE
*
      IPOUT=KENTRY(1)
*
      IPRT = 0
      NCHA=0
      NK=0
 10   CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
 11   IF (ITYP.NE.3) THEN
        CALL XABORT('ADDHST: CHARACTER DATA EXPECTED')
      ELSE IF(TEXT12.EQ.'EDIT') THEN
        CALL REDGET(ITYP,IPRT,FLOTT,TEXT12,DFLOTT)
        IF (ITYP.NE.1) THEN
         CALL XABORT('ADDHST: INTEGER DATA EXPECTED')
        ENDIF
      ELSE IF(TEXT12.EQ.'NAME') THEN
* nom du HST
         IPIN=0
         CALL REDGET(ITYP,NITMA,FLOTT,NAME,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('ADDHST: CHARACTER DATA '
     1  //'EXPECTED(20)')
         DO 20 I=1,NENTRY
            IF (NAME.EQ.HENTRY(I)) IPIN=KENTRY(I)
   20       CONTINUE
         IF (IPIN.EQ.0) CALL XABORT('ADDHST: Wrong name '
     1  //'for HST object')
* choix de la zone a copier
   50    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('ADDHST: CHARACTER DATA '
     1  //'EXPECTED(20b)')
         IF (TEXT12.EQ.'CANAL') THEN
            LCNL=.TRUE.
         ELSEIF (TEXT12.EQ.'CELL') THEN
            LCNL= .FALSE.
         ELSE
            GO TO 11 
         ENDIF
         IF (NCHA*NK.EQ.0) THEN
            CALL LCMGET(IPIN,'STATE-VECTOR',HSTPRM)
            NCHA=HSTPRM(4)
            NK=HSTPRM(3)
         ENDIF
         CALL REDGET(ITYP,IDEB,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('ADDHST: INTEGER EXPECTED for IDEB')
         CALL REDGET(ITYP,IFIN,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('ADDHST: INTEGER EXPECTED for IFIN')
         IF (IDEB.GT.IFIN) CALL XABORT('ADDHST: IDEB>IFIN')
C---------------------------
C HST
C---------------------------
         KFIN=1
         IF (LCNL) KFIN=NK
         DO 390 K=0,KFIN-1
            DO 380 I=IDEB,IFIN
               WRITE(TEXT12,'(A4,I8.8)') 'CELL',I+K*NCHA
               IF (IPRT.GT.2) WRITE(6,*) TEXT12
               CALL LCMSIX(IPOUT,TEXT12,1)
               CALL LCMSIX(IPIN,TEXT12,1)
               CALL LCMEQU(IPIN,IPOUT)
               CALL LCMSIX(IPOUT,' ',2)
               CALL LCMSIX(IPIN,' ',2)
 380        CONTINUE
 390     CONTINUE
         GOTO 50
      ELSE IF(TEXT12.EQ.';') THEN
        GOTO 1000
      ELSE
        CALL XABORT('ADDHST: INVALID INPUT OPTION')
      ENDIF
      GOTO 10
C---------------------------
C END
C---------------------------
 1000 CONTINUE 
      IF( IPRT.GT.5 ) CALL LCMLIB(IPOUT)
      RETURN
      END
