*DECK FOBJCT
      SUBROUTINE FOBJCT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* define optimization problem and evaluate the functionnals
* FOBJCT = Function OBJective ConsTraint
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
* NENTRY  number of lcm objects used by the module
* HENTRY  character*12 name of each lcm object
* IENTRY  =1 linked list; =2 xsm file; =3 sequential binary file;
*         =4 sequential ascii file
* JENTRY  =0 the lcm object is created
*         =1 the lcm object is open for modifications;
*         =2 the lcm object is open in read-only mode
* KENTRY  =file unit number; =lcm object address otherwise
*         kentry(nentry)
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   NENTRY
      CHARACTER HENTRY(NENTRY)*12
      INTEGER   IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   IPRINT,NITMA,IDATA,I,J,IPMAP,JPMAP,KPMAP,IPOPT,IPFLU,
     1          ITYP,I2,I3,K,NGRP,MEMADR(20),NUN,ITYP1,IPMCR,IPTRK,
     2          IPIND,LCMGIL,LCMGID
      DOUBLE PRECISION DFLOTT
      REAL      FLOTT
      CHARACTER TEXT12*12,TXT12B*12
      INTEGER   NVARMX,VRLCMX,CSTMX,NLVL1,NLVL2,SIGNA(3)
      PARAMETER (NVARMX=500,VRLCMX=50,CSTMX=500)
      PARAMETER (NLVL1=21,NLVL2=5)
      LOGICAL   LTST
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   OPTPRI(NSTATE),FLUPRM(NSTATE),RESPRM(NSTATE),
     1          TRKPRM(NSTATE),MCRPRM(NSTATE)
      REAL      OPTPRR(NSTATE)
*'Optimization variables' variable
      INTEGER   NVAR,VARTYP(NVARMX),IMAX,IMIN,IVAR
      REAL      VARVAL(NVARMX),BMIN,BMAX,EMIN,EMAX
*'Local arrays' variable
      INTEGER   NVRLC,IVRLC(VRLCMX),LGVRLC(VRLCMX)
      CHARACTER TVRLC(VRLCMX)*12
      LOGICAL   LVRLC(VRLCMX)
*Control zone variables
      INTEGER   NBURNZ,NCHA,IREPZ,IZMAP,IBZMAP,MIX,LENGT,ICHA,
     1          NEZ,NBUND,IIEZ,IEZREP
*Fuesl cost variable
      INTEGER   IEZV,IFCV,IDFCV,IDDATA
      REAL      EPS,EPSW,EPSU,CUNT,CSEP,CFAB,INTR,TOBT,TENR
*Constraint variables
      INTEGER   NCST,CSTTYP(CSTMX),CSTING(CSTMX)
      REAL      CSTOBJ(CSTMX)
*Constraint zone variable
      INTEGER   NZCHF,IZCHF,CBINDX(2)
*Objective and constraint evaluation variable
      REAL      RTFCN(NLVL1,1+2*NLVL2),FVAL
      INTEGER   VTFCN(NLVL1,1+2*NLVL2),STFCN(NLVL1,1+2*NLVL2)
      CHARACTER OTFCN(NLVL1,1+2*NLVL2)*12,TXTPDF*12
      INTEGER   IDTVAL,NVAL,FCTFRM,FCTTO
*Volume considerations
      INTEGER   IELEM,ICHX,IDIM0,IDIM,NMIX,MAXKN,NEL,LL4,VOL,KN,MAT,
     1          IGAR,CDISN,BDISN,IR
      LOGICAL   LDUAL,CYLIND

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
C
C
C---------------------------
C     VALIDITY OF OBJECTS
C---------------------------
*      IF( NENTRY.GT.3) CALL XABORT('FOBJCT: 3 OBJECTS MAX EXPECTED.')
*CHECK IF OBJECTS ARE LCM OBJECTS AND WHICH ONE CORRESPOND
*TO WHICH TYPE
      IPMAP=0
      IPFLU=0
      IPOPT=0
      IPMCR=0
      IPTRK=0
      IPIND=0
*INITIALIZE THE FILE NUMBER UNIT FOR SUBROUTINE OPTEVL.f
      CALL XDISET(MEMADR,20,0)
      DO 2 I=1,NENTRY
         IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2))CALL XABORT('FOBJCT:'
     1      //' LCM OBJECT EXPECTED')
         IF(JENTRY(I).EQ.0) THEN
            TEXT12='L_OPTIMIZE'
            READ(TEXT12,'(3A4)') (SIGNA(J),J=1,3)
            CALL LCMPUT(KENTRY(I),'SIGNATURE',3,3,SIGNA)
         ELSE
            CALL LCMGET(KENTRY(I),'SIGNATURE',SIGNA)
            WRITE(TEXT12,'(3A4)') (SIGNA(J),J=1,3)
         ENDIF
         IF(TEXT12.EQ.'L_MAP') THEN
            IPMAP=KENTRY(I)
            MEMADR(2)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_FLUX') THEN
            IPFLU=KENTRY(I)
            IF(MEMADR(3).EQ.0) THEN
               MEMADR(3)=KENTRY(I)
            ELSE
               MEMADR(13)=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_OPTIMIZE') THEN
            IPOPT=KENTRY(I)
            MEMADR(6)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_GPT') THEN
            MEMADR(5)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_MACROLIB') THEN
            IPMCR=KENTRY(I)
            IF(MEMADR(7).EQ.0) THEN
               MEMADR(7)=KENTRY(I)
            ELSE
               MEMADR(17)=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_TABLE') THEN
            IF(MEMADR(10).EQ.0) THEN
               MEMADR(10)=KENTRY(I)
            ELSE
               MEMADR(20)=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_SYSTEM') THEN
            IF(MEMADR(4).EQ.0) THEN
               MEMADR(4)=KENTRY(I)
            ELSE
               MEMADR(14)=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_MATEX') THEN
            IPIND=KENTRY(I)
            MEMADR(8)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_TRACK') THEN
            IPTRK=KENTRY(I)
            MEMADR(9)=KENTRY(I)
         ELSE
            CALL XABORT('FOBJCT:'//TEXT12 //' NOT GOOD TYPE OF OBJECT')
         ENDIF
    2    CONTINUE
C
C---------------------------
C VARIABLE INITIALISATION	
C---------------------------
      IPRINT=  0
      EPSU=0.007200 ! atomic fraction , 0.007110 = weight fraction
      NVRLC=0
      NVAR=0
      NCST=0
*initialisation des vecteurs locaux
      DO 3 I=1,VRLCMX
         IVRLC(I)=1
         LGVRLC(I)=0
         TVRLC(I)=' '
    3    LVRLC(I)=.FALSE.
* initialiser les parametres de OPTIMIZATION si l'objet est cree.
      IF(JENTRY(1).EQ.0) THEN
         DO 4 I=1,NSTATE
            OPTPRI(I)=0
    4       OPTPRR(I)=0.0
*      minimisation par defaut
         OPTPRI(3)=1
*      reduction du pas par methode parabolique
         OPTPRI(6)=2
*      maximum iterations internes(7) et externes(8)
         OPTPRI(7)=100
         OPTPRI(8)=100
*      resolution du probleme par la methode de lemke par defaut
         OPTPRI(9)=2
*      derivee des XS methode epsilon par default
         OPTPRI(10)=1
         OPTPRR(7)=0.01
*      pas d'avance externe et interne
         OPTPRR(1)=1.0
         OPTPRR(2)=0.1
*      exposant pour une fonction objectif type min sum(Pcj-Pcmoy)^2n
         OPTPRR(8)=8.0
*      convergence externe et interne
         OPTPRR(3)=0.001
         OPTPRR(4)=0.001
*      geometrie
         OPTPRI(17)=NCHA
         OPTPRI(18)=NBUND
         OPTPRI(19)=NUN
         OPTPRI(20)=NGRP
*      methode du Lagrangien augmente et de penalisation
         OPTPRR(9)=2.0
         OPTPRR(10)=0.00001
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
         CALL LCMPUT(IPOPT,'OPT-PARAM-R',NSTATE,2,OPTPRR)
      ELSE
         CALL LCMGET(IPOPT,'STATE-VECTOR',OPTPRI)
         CALL LCMGET(IPOPT,'OPT-PARAM-R',OPTPRR)
         NVAR=OPTPRI(1)
         NCST=OPTPRI(2)
         NGRP=OPTPRI(20)
      ENDIF
*aller chercher dans MAP les info necessaires, si applicable
      IF(IPMAP.GT.0) THEN
         CALL LCMGET(IPMAP,'STATE-VECTOR',RESPRM)
         NBUND  = RESPRM(1)
         NCHA   = RESPRM(2)
         NBURNZ = RESPRM(3)
         NGRP   = RESPRM(4)
         NEZ    = RESPRM(7)
         OPTPRI(17)=NCHA
         OPTPRI(18)=NBUND
         OPTPRI(20)=NGRP
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
         CALL SETARA(RBASE,NBURNZ,IBZMAP)
         CALL SETARA(IBASE,NCHA,IZMAP)
         CALL LCMGET(IPMAP,'B-ZONE',IBASE(IZMAP))
         CALL LCMGET(IPMAP,'BURN-AVG',RBASE(IBZMAP))
      ENDIF
*aller chercher dans FLUX les info necessaires, si applicable
      IF(IPFLU.GT.0) THEN
         CALL LCMGET(IPFLU,'STATE-VECTOR',FLUPRM)
         NGRP   = FLUPRM(1)
         NUN    = FLUPRM(2)
         OPTPRI(19)=NUN
         OPTPRI(20)=NGRP
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
      ENDIF
      IF(IPMCR.GT.0) THEN
         CALL LCMGET(MEMADR(7),'STATE-VECTOR',MCRPRM)
         NMIX = MCRPRM(2)
         OPTPRI(16)=NMIX
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
      ENDIF
C
C---------------------------
C     READ USER INPUT:
C---------------------------
   20 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED (1)')
* Edition level
   30 IF(TEXT12.EQ.'EDIT') THEN
         CALL REDGET(ITYP,IPRINT,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('FOBJCT: *IPRINT* MUST BE INTEGER')
* Control zone definition
      ELSEIF(TEXT12.EQ.'CTRL-ZONE-DF')THEN
         GO TO 100
* Fuel cost definition
      ELSEIF(TEXT12.EQ.'FUEL-COST-DF')THEN
         GO TO 200
* Burnup distribution
      ELSEIF(TEXT12.EQ.'EXIT-B-DIST') THEN
         GO TO 300
!* Average flux distribution
!      ELSEIF(TEXT12.EQ.'FLUX-AVERAGE')THEN
!         GO TO 400
* Constraint zone definition
      ELSEIF(TEXT12.EQ.'CST-ZONE-DF') THEN
         GO TO 500
* Objective and constraint calculation
      ELSEIF(TEXT12.EQ.'EVAL-OBJ-CST') THEN
         GO TO 600
* End of this subroutine
      ELSEIF( TEXT12.EQ.';' )THEN
         GO TO 1000
      ELSE
         CALL XABORT('FOBJCT: '//TEXT12//' IS AN INVALID KEYWORD.')
      ENDIF
      GO TO 20

C---------------------------
C     1      0000     0000
C    11     0    0   0    0
C   1 1    0      0 0      0
C  1  1    0      0 0      0
C 1   1    0      0 0      0
C     1    0      0 0      0
C     1     0    0   0    0
C 11111111   0000     0000
C---------------------------
C VARIABLE DEFINITION AND INFLUENCE ZONE
C---------------------------
*combien de variables existent deja
  100 CALL LCMLEN(IPOPT,'VAR-TYPE',NVAR,ITYP)
      IF(NVAR.GT.NVARMX) CALL XABORT('TOO MUCH VARIABLES ARE STORED')
      IF(NVAR.GT.0) THEN
         CALL LCMGET(IPOPT,'VAR-TYPE',VARTYP)
         CALL LCMGET(IPOPT,'VAR-VALUE',VARVAL)
      ENDIF
      IF(IPMAP.GT.0) CALL SETARA(IBASE,NBURNZ*NCHA,IREPZ)
  101 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
  102 IF(ITYP.NE.3) CALL XABORT('FOBJCT: KEYWORD EXPECTED AFTER'
     1   //'CTRL-ZONE-DF KEYWORD')
C BURNUP ZONE
      IF(TEXT12.EQ.'BURNUP-ZONE') THEN
*minimum et maximum pour les variables de burnup
      CALL REDGET(ITYP,NITMA,BMIN,TEXT12,DFLOTT)
      IF(ITYP.NE.2) CALL XABORT('FOBJCT: "BMIN" REAL EXPECTED')
      CALL REDGET(ITYP,NITMA,BMAX,TEXT12,DFLOTT)
      IF(ITYP.NE.2) CALL XABORT('FOBJCT: "BMAX" REAL EXPECTED')
      DO 110 I=1,NBURNZ
         DO 110 J=0,NCHA-1
            IF(IBASE(IZMAP+J).EQ.I) THEN
               IBASE(IREPZ+J+(I-1)*NCHA)=1
            ELSE
               IBASE(IREPZ+J+(I-1)*NCHA)=0
            ENDIF
  110 CONTINUE
*pour chaque zone: controllee (Y) ou fixee (N)
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED'
     1      //' AFTER BURNUP-ZONE KEYWORD')
      LTST=.FALSE.
      IF(TEXT12.EQ.'ALL') LTST=.TRUE.
      DO 115 I=1,NBURNZ
         IF((.NOT.LTST).AND.(I.GT.1)) THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED'
     1      //' AFTER BURNUP-ZONE KEYWORD')
         ENDIF
         IF((TEXT12.EQ.'Y').OR.(LTST))THEN
*augmenter le nombre de variable, sauver son type et sa valeur
            NVAR=NVAR+1
            VARTYP(NVAR)=1000+I
            VARVAL(NVAR)=RBASE(IBZMAP+I-1)
*sauver la repartition de cette zone dans l'object L_OPTIMIZE
            WRITE(TXT12B,'(A8,I4.4)') 'VAR-ZONE',NVAR
            CALL LCMPUT(IPOPT,TXT12B,NCHA,1,IBASE(IREPZ+(I-1)*NCHA))
         ELSEIF(TEXT12.EQ.'N')THEN
            IF(IPRINT.GE.2) WRITE(6,*) 'ok zone fixee'
         ELSE
            CALL XABORT('FOBJCT: KEYWORD "ALL", "Y" or "N" '
     1      //'EXPECTED AFTER BURNUP-ZONE KEYWORD')
         ENDIF
  115 CONTINUE
C ENRICHISSEMENT ZONE
      ELSEIF(TEXT12.EQ.'ENRICH-ZONE') THEN
*minimum et maximum pour les variables d'enrichissement
      CALL REDGET(ITYP,NITMA,EMIN,TEXT12,DFLOTT)
      IF(ITYP.NE.2) CALL XABORT('FOBJCT: "EMIN" REAL EXPECTED')
      CALL REDGET(ITYP,NITMA,EMAX,TEXT12,DFLOTT)
      IF(ITYP.NE.2) CALL XABORT('FOBJCT: "EMAX" REAL EXPECTED')
*zone a enrichissement variable ou fixe
      CALL SETARA(IBASE,NCHA*NBUND,IEZREP)
      CALL LCMGET(IPMAP,'FLMIX',IBASE(IEZREP))
      IF(NEZ.EQ.0) CALL XABORT('FOBJCT: ENRICHMENT ZONE AND '
     1  //'VALUE NOT DEFINED')
      CALL SETARA(IBASE,NCHA*NBUND,IIEZ)
      JPMAP=LCMGID(IPMAP,'FUEL')
      DO 122 I=1,NEZ
         KPMAP=LCMGIL(JPMAP,I)
         DO 121 J=0,NCHA*NBUND-1
            IF(IBASE(IEZREP+J).EQ.I) THEN
               IBASE(IIEZ+J)=1
            ELSE
               IBASE(IIEZ+J)=0
            ENDIF
  121    CONTINUE
*pour chaque zone : controllee (Y) ou fixee (N)
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED'
     1      //' AFTER ENRICH-ZONE KEYWORD')
         IF(TEXT12.EQ.'Y')THEN
*augmenter le nombre de variable, sauver son type et sa valeur
            NVAR=NVAR+1
            VARTYP(NVAR)=2000+I
            CALL LCMGET(KPMAP,'ENRICH',VARVAL(NVAR))
*sauver la repartition de cette zone dans l'object L_OPTIMIZE
            WRITE(TXT12B,'(A8,I4.4)') 'VAR-ZONE',NVAR
            CALL LCMPUT(IPOPT,TXT12B,NCHA*NBUND,1,IBASE(IIEZ))
         ELSEIF(TEXT12.EQ.'N')THEN
            IF(IPRINT.GE.2) WRITE(6,*) 'ok zone fixee'
         ELSE
            CALL XABORT('FOBJCT: KEYWORD Y or N EXPECTED AFTER'
     1      //'ENRICH-ZONE KEYWORD')
         ENDIF
  122 CONTINUE
      CALL RLSARA(IBASE(IEZREP))
      CALL RLSARA(IBASE(IIEZ))
C ESLE END OF VARIABLE DEFINITION KEYWORD
      ELSE
         IF(IPMAP.GT.0) CALL RLSARA(IBASE(IREPZ))
* sauver les variables (valeur et type)
         IF(NVAR.GT.NVARMX) CALL XABORT('TOO MUCH VARIABLES DEFINED')
         CALL LCMPUT(IPOPT,'VAR-TYPE',NVAR,1,VARTYP)
         CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,VARVAL)
         CALL SETARA(RBASE,NVAR,IMIN)
         CALL SETARA(RBASE,NVAR,IMAX)
         DO 140 IVAR=1,NVAR
            ITYP=VARTYP(IVAR)/1000
            IF(ITYP.EQ.1) THEN
               RBASE(IMIN+IVAR-1)=BMIN
               RBASE(IMAX+IVAR-1)=BMAX
            ELSEIF(ITYP.EQ.2) THEN
               RBASE(IMIN+IVAR-1)=EMIN
               RBASE(IMAX+IVAR-1)=EMAX
            ELSE
               CALL XABORT('FOBJCT: WRONG TYPE OF VARIABLE')
            ENDIF
  140       CONTINUE
         CALL LCMPUT(IPOPT,'VAR-VAL-MIN',NVAR,2,RBASE(IMIN))
         CALL LCMPUT(IPOPT,'VAR-VAL-MAX',NVAR,2,RBASE(IMAX))
         IF(IPRINT.GE.1) THEN
             WRITE(6,*) 'NUMBER OF VARIABLES   = ',NVAR
         ENDIF
         IF(IPRINT.GE.2) THEN
             WRITE(6,*) 'VALUES OF VARIABLES   = ',(VARVAL(I),I=1,NVAR)
         ENDIF
         IF(IPRINT.GE.3) THEN
             WRITE(6,*) 'BORNES OF VARIABLES (MAX)= ',
     1                  (RBASE(IMAX+I-1),I=1,NVAR)
             WRITE(6,*) 'BORNES OF VARIABLES (MIN)= ',
     1                  (RBASE(IMIN+I-1),I=1,NVAR)
         ENDIF
         CALL RLSARA(RBASE(IMIN))
         CALL RLSARA(RBASE(IMAX))
         GOTO 30
      ENDIF
      GOTO 101
C---------------------------
C   2222     0000     0000
C  2    2   0    0   0    0
C 2      2 0      0 0      0
C       2  0      0 0      0
C      2   0      0 0      0
C   22     0      0 0      0
C  2        0    0   0    0
C 22222222   0000     0000
C---------------------------
C FUEL COST  DEFINITION
C---------------------------
*combien il y a de zone d'enrichissement
  200 IF(NEZ.EQ.0) CALL XABORT('FOBJCT: ENRICHISSEMENT HAS TO BE '
     1  //'DEFINIDED BEFORE FUEL COST DEFINITION')
  201 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
  202 IF(ITYP.NE.3) CALL XABORT('FOBJCT: KEYWORD EXPECTED AFTER '
     1   //'FUEL-COST-DF KEYWORD')
      IF(TEXT12.EQ.'FIXED') THEN
         CALL SETARA(RBASE,NEZ,IEZV)
         OPTPRI(11)=2
         DO 210 I=1,NEZ
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.2) CALL XABORT('FOBJCT: A REAL EXPECTED FOR '
     1   //'EACH ENRICHISSEMNET ZONE')
  210       RBASE(IEZV+I-1)=FLOTT
         CALL LCMPUT(IPOPT,'FUEL-COST',NEZ,2,RBASE(IEZV))
         CALL RLSARA(RBASE(IEZV))
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
      ELSEIF(TEXT12.EQ.'DEPENDANT') THEN
         CALL SETARA(RBASE,7,IEZV)
         OPTPRI(11)=1
         DO 220 J=1,7
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.2) CALL XABORT('FOBJCT: A REAL EXPECTED FOR '
     1         //'EACH ENRICHISSEMNET ZONE')
  220       RBASE(IEZV+J-1)=FLOTT
         CALL LCMPUT(IPOPT,'FUEL-COST',7,2,RBASE(IEZV))
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
         CALL RLSARA(RBASE(IEZV))
      ELSEIF(TEXT12.EQ.'MEMORY') THEN
*sauvegarde de la distribution de cout des grappes
*  charger les infos sur le prix du combustible
         CALL LCMLEN(IPOPT,'FUEL-COST',NITMA,ITYP1)
         IF(NITMA.EQ.0) CALL XABORT('FOBJCT: ENRICHISSEMENT COST HAS '
     1      //'TO BE DEFINIDED BEFORE FUEL COST MEMORISATION')
         CALL SETARA(RBASE,NITMA,IDATA)
         CALL SETARA(RBASE,NEZ,IFCV)
         CALL SETARA(RBASE,NEZ,IDFCV)
         CALL LCMGET(IPOPT,'FUEL-COST',RBASE(IDATA))
         IF(OPTPRI(11).EQ.1) THEN
*  calculer le prix du combustible dans chaque zone
             EPSW=RBASE(IDATA)
             CUNT=RBASE(IDATA+1)
             CSEP=RBASE(IDATA+2)
             CFAB=RBASE(IDATA+3)
             INTR=1+RBASE(IDATA+4)
             TOBT=RBASE(IDATA+5)
             TENR=RBASE(IDATA+6)
             JPMAP=LCMGID(IPMAP,'FUEL')
             DO 230 I=0,NEZ-1
                KPMAP=LCMGIL(JPMAP,I+1)
                CALL LCMGET(KPMAP,'ENRICH',RBASE(IFCV+I))
                EPS=RBASE(IFCV+I)
                RBASE(IFCV+I)=CUNT*(EPS-EPSW)/(EPSU-EPSW)*INTR**TENR
     1     +CSEP*INTR**TENR*((2.*EPS-1.)*ALOG(EPS/(1.-EPS))
     2        +(EPS-EPSU)/(EPSU-EPSW)*(2.*EPSW-1.)*ALOG(EPSW/(1.-EPSW))
     3        -(EPS-EPSW)/(EPSU-EPSW)*(2.*EPSU-1.)*ALOG(EPSU/(1.-EPSU)))
     4     +CFAB
                RBASE(IDFCV+I)=CUNT/(EPSU-EPSW)*INTR**TENR
     1     +CSEP*INTR**TENR*(2.*ALOG(EPS/(1.-EPS))
     1          +(2.*EPS-1)/(1.-EPS)/EPS
     2          +1./(EPSU-EPSW)*(2.*EPSW-1.)*ALOG(EPSW/(1.-EPSW))
     3          -1./(EPSU-EPSW)*(2.*EPSU-1.)*ALOG(EPSU/(1.-EPSU)))
     4     +CFAB
  230        CONTINUE
         ELSEIF(OPTPRI(11).EQ.2) THEN
*  ou lire directement le prix du combustible dans chaque zone
             DO 240 I=0,NEZ-1
  240           RBASE(IFCV+I)=RBASE(IDATA+I)
         ELSE
             CALL XABORT('FOBJCT: WRONG NUMBER OF SAVED VALUE IN '
     1          //'FUEL-COST')
         ENDIF
         CALL RLSARA(RBASE(IDATA))
*  Info sur le volume
         IF(IPTRK.EQ.0) CALL XABORT('OPTADF: TRACKING '
     1  //'ADRESS NEEDED')
         CALL LCMGET(IPTRK,'TRACK-TYPE',SIGNA)
         WRITE(TXT12B,'(3A4)') (SIGNA(J),J=1,3)
         IF(TXT12B.NE.'TRIVAC') CALL XABORT('OPTADF: TRIVAC '
     1  //'TRACKING TYPE EXPECTED')
         CALL LCMGET(IPTRK,'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF(IDIM0.LT.4) IDIM=1
         IF((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         IR =TRKPRM(4)
         NEL=TRKPRM(1)
         NUN=TRKPRM(2)
         LL4=TRKPRM(11)
         CYLIND=.FALSE.
         IF((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL)
         CALL XDRSET(RBASE(VOL),NEL,1.0)
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(IPTRK,'MATCOD',IBASE(MAT))
         CALL LCMLEN(IPTRK,'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
         CALL LCMGET(IPTRK,'KN',IBASE(KN))
*  calculer la repartition des couts de combustible
         IF(IPMAP.EQ.0) CALL XABORT('FOBJCT: L_MAP OBJECT NEEDED')
         CALL SETARA(IBASE,NCHA*NBUND,IIEZ)
         CALL LCMGET(IPMAP,'FLMIX',IBASE(IIEZ))
         IF(NUN.EQ.0) CALL XABORT('FOBJCT: NUN NOT DEFINED YET FOR '
     1  //'FUEL COST DISTRIBUTION')
         CALL SETARA(RBASE,IR,IDATA)
         CALL SETARA(RBASE,IR,IDDATA)
         IF(IPIND.EQ.0) CALL XABORT('FOBJCT:L_MATEX OBJECT NEEDED')
         CALL LCMLEN(IPIND,'MAT',LENGT,ITYP1)
         CALL SETARA(IBASE,LENGT,MIX)
         CALL LCMGET(IPIND,'MAT',IBASE(MIX))
         I=0
         DO 245 J=0,NEL-1
            IF(IBASE(MIX+J).NE.0) THEN
               IF(IBASE(MIX+J).GT.0) THEN
                  RBASE(IDATA+I)=0.0
                  RBASE(IDDATA+I)=0.0
               ELSE
                  ICHA=-IBASE(MIX+J)
                  IF(ICHA.LE.0) CALL XABORT('FOBJCT: ENRICHMENT ZONE N'
     1            //'OT DEFINED')
                  IF(ICHA.GT.NCHA*NBUND) CALL XABORT('FOBJCT: ENRICHME'
     1            //'NT ZONE OVERFLOW')
                  RBASE(IDATA+I)=RBASE(IFCV-1+IBASE(IIEZ+ICHA-1))
                  IF(OPTPRI(11).EQ.1) THEN
                     RBASE(IDDATA+I)=RBASE(IDFCV-1+IBASE(IIEZ+ICHA-1))
                  ENDIF
               ENDIF
               I=I+1
            ENDIF
  245       CONTINUE
         IF(I.NE.IR) CALL XABORT('FOBJCT: WRONG NUMBER OF '
     1  //'INDEX IN FUEL-C-DIST DEFINITION')
         CALL RLSARA(IBASE(IIEZ))
         CALL RLSARA(RBASE(IFCV))
         CALL RLSARA(RBASE(IDFCV))
         CALL RLSARA(RBASE(MIX))

         CALL SETARA(RBASE,NUN,CDISN)
         CALL XDRSET(RBASE(CDISN),NUN,0.0)
         CALL SETARA(RBASE,NEL,IGAR)
         CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1        RBASE(IDATA),RBASE(VOL),IBASE(MAT),IBASE(KN),RBASE(CDISN),
     2        RBASE(IGAR))
         CALL LCMPUT(IPOPT,'FUEL-C-DIST',NUN,2,RBASE(CDISN))
         IF(OPTPRI(11).EQ.1) THEN
            CALL XDRSET(RBASE(CDISN),NUN,0.0)
            CALL XDRSET(RBASE(IGAR),NEL,0.0)
            CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1        RBASE(IDDATA),RBASE(VOL),IBASE(MAT),IBASE(KN),
     2        RBASE(CDISN),RBASE(IGAR))
            CALL LCMPUT(IPOPT,'D-FC-DIST',NUN,2,RBASE(CDISN))
         ENDIF
         CALL RLSARA(RBASE(VOL))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(RBASE(IDATA))
         CALL RLSARA(RBASE(IDDATA))
         CALL RLSARA(RBASE(CDISN))
         CALL RLSARA(RBASE(IGAR))
      ELSE
         GO TO 30
      ENDIF
      GO TO 201
C---------------------------
C   3333     0000     0000
C  3    3   0    0   0    0
C 3      3 0      0 0      0
C      33  0      0 0      0
C       3  0      0 0      0
C 3      3 0      0 0      0
C  3    3   0    0   0    0
C   3333     0000     0000
C---------------------------
C EXIT BURNUP DISTRIBUTION
C---------------------------
  300 IF(IPMAP.EQ.0) CALL XABORT('FOBJCT: L_MAP OBJECT NEEDED')
  301 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('FOBJCT: KEYWORD EXPECTED AFTER'
     1   //'EXIT-B-DIST KEYWORD')
  302 IF(TEXT12.EQ.'MEMORY') THEN
*sauvegarde de la distribution de cout des grappes
         IF(IPTRK.EQ.0) CALL XABORT('OPTADF: TRACKING '
     1  //'ADRESS NEEDED')
         CALL LCMGET(IPTRK,'TRACK-TYPE',SIGNA)
         WRITE(TXT12B,'(3A4)') (SIGNA(J),J=1,3)
         IF(TXT12B.NE.'TRIVAC') CALL XABORT('OPTADF: TRIVAC '
     1  //'TRACKING TYPE EXPECTED')
         CALL LCMGET(IPTRK,'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF(IDIM0.LT.4) IDIM=1
         IF((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         IR =TRKPRM(4)
         NEL=TRKPRM(1)
         NUN=TRKPRM(2)
         LL4=TRKPRM(11)
         CYLIND=.FALSE.
         IF((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL)
         CALL XDRSET(RBASE(VOL),NEL,1.0)
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(IPTRK,'MATCOD',IBASE(MAT))
         CALL LCMLEN(IPTRK,'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
         CALL LCMGET(IPTRK,'KN',IBASE(KN))
*calculer la repartition des burnups de sortie du combustible
         IF(IPMAP.EQ.0) CALL XABORT('FOBJCT: L_MAP OBJECT NEEDED')
         CALL SETARA(RBASE,IR,IDATA)
         IF(IPIND.EQ.0) CALL XABORT('FOBJCT:L_MATEX OBJECT NEEDED')
         CALL LCMLEN(IPIND,'MAT',LENGT,ITYP1)
         CALL SETARA(IBASE,LENGT,MIX)
         CALL LCMGET(IPIND,'MAT',IBASE(MIX))
         I=0
         DO 345 J=0,NEL-1
            IF(IBASE(MIX+J).NE.0) THEN
               IF(IBASE(MIX+J).GT.0) THEN
                  RBASE(IDATA+I)=0.0
               ELSE
                  ICHA=-IBASE(MIX+J)+(IBASE(MIX+J)/NCHA)*NCHA
                  IF(ICHA.EQ.0) ICHA=NCHA
                  RBASE(IDATA+I)=
     1              RBASE(IBZMAP-1+IBASE(IZMAP+ICHA-1))
               ENDIF
               I=I+1
            ENDIF
  345       CONTINUE
         IF(I.NE.IR) CALL XABORT('FOBJCT: WRONG NUMBER OF '
     1  //'INDEX IN BURN-E-DIST DEFINITION')
         CALL RLSARA(RBASE(MIX))
         CALL SETARA(RBASE,NUN,BDISN)
         CALL XDRSET(RBASE(BDISN),NUN,0.0)
         CALL SETARA(RBASE,NEL,IGAR)
         CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1        RBASE(IDATA),RBASE(VOL),IBASE(MAT),IBASE(KN),RBASE(BDISN),
     2        RBASE(IGAR))
         CALL LCMPUT(IPOPT,'BURN-E-DIST',NUN,2,RBASE(BDISN))
         CALL RLSARA(RBASE(VOL))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(IBASE(IDATA))
         CALL RLSARA(RBASE(BDISN))
         CALL RLSARA(RBASE(IGAR))
      ELSE
         GO TO 30
      ENDIF
      GO TO 301
C---------------------------
C     4      0000     0000
C    44     0    0   0    0
C   4 4    0      0 0      0
C  4  4    0      0 0      0
C 4   4    0      0 0      0
C  4444444 0      0 0      0
C     4     0    0   0    0
C     4      0000     0000
C---------------------------
!C AVERAGE FLUX DISTRIBUTION
!C---------------------------
!  400 IF(IPMAP.EQ.0) CALL XABORT('FOBJCT: L_MAP OBJECT NEEDED')
!  401 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
!      IF(ITYP.NE.3) CALL XABORT('FOBJCT: KEYWORD EXPECTED AFTER'
!     1   //'EXIT-B-DIST KEYWORD')
!      IF(TEXT12.EQ.'MEMORY') THEN
!*nom de variable valide et quel est son numero
!         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
!         IF(ITYP.NE.3) CALL XABORT('FOBJCT: LOCAL VARIABLE NAME'
!     1      //' EXPECTED')
!         LTST=.TRUE.
!         DO 410 I=1,VRLCMX
!            IF(TVRLC(I).EQ.TEXT12) CALL XABORT('FOBJCT: THIS LOCAL '
!     1      //'VARIABLE ALREADY EXIST')
!            IF((LTST).AND.(.NOT.LVRLC(I))) THEN
!               LTST=.FALSE.
!               NVRLC=I
!               TVRLC(I)=TEXT12
!               LVRLC(I)=.TRUE.
!            ENDIF
!  410    CONTINUE
!         CALL SETARA(RBASE,NCHA*NBUND*NGRP,IVRLC(NVRLC))
!         CALL LCMLEN(IPMAP,'FLUX-AV',NITMA,ITYP)
!         IF(NITMA.EQ.0) CALL XABORT('FOBJCT: AVERAGE FLUX HAS '
!     1      //'TO BE PRECALCULATED')
!         CALL LCMGET(IPMAP,'FLUX-AV',RBASE(IVRLC(NVRLC)))
!      ELSE
!         GO TO 30
!      ENDIF
!      GO TO 401
C---------------------------
C 55555555   0000     0000
C 5         0    0   0    0
C 5  55    0      0 0      0
C 555  55  0      0 0      0
C        5 0      0 0      0
C        5 0      0 0      0
C 55    55  0    0   0    0
C  555555    0000     0000
C---------------------------
C CONSTRAINT ZONE DEFINITION
C---------------------------
*combien de contraintes existent deja
  500 CALL LCMLEN(IPOPT,'CST-TYPE',NCST,ITYP)
      IF(NCST.GT.CSTMX) CALL XABORT('TOO MUCH CONSTRAINTS ARE STORED')
      IF(NCST.GT.0) THEN
         CALL LCMGET(IPOPT,'CST-VOL-TYPE',CSTTYP)
         CALL LCMGET(IPOPT,'CST-TYPE',CSTING)
         CALL LCMGET(IPOPT,'CST-OBJ',CSTOBJ)
      ENDIF
  501 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('FOBJCT: KEYWORD EXPECTED AFTER'
     1   //' CST-ZONE-DF KEYWORD')
C K-EFFECTIF
      IF(TEXT12.EQ.'KEFF') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('FOBJCT:  REAL DATA EXPECTED')
         NCST=NCST+1
         CSTTYP(NCST)=1
         CSTING(NCST)=0
         CSTOBJ(NCST)=FLOTT
         GO TO 501
C FULL CORE VOID REACTIVITY
      ELSEIF(TEXT12.EQ.'VOID-REAC-FC') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('FOBJCT:  REAL DATA EXPECTED')
         NCST=NCST+1
         CSTTYP(NCST)=6
         CSTING(NCST)=1
         CSTOBJ(NCST)=FLOTT/1000.0
         GO TO 501
C FONCTION ANALYTIQUE
      ELSEIF(TEXT12.EQ.'ANALYTIC-FCT') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('FOBJCT:  INTEGER DATA EXPECTED')
         IF((NITMA+1)*NITMA*(NITMA-1).NE.0) CALL XABORT('FOBJCT:  '
     1  //' -1, 0 or 1 expected for constraint type')
         NCST=NCST+1
         CSTING(NCST)=NITMA
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('FOBJCT:  REAL DATA EXPECTED')
         CSTTYP(NCST)=7
         CSTOBJ(NCST)=FLOTT
         GO TO 501
C FLUX DE CHALEUR CRITIQUE
      ELSEIF(TEXT12.EQ.'MAXPOWER') THEN
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
* definition des zones
  502 IF(TEXT12.EQ.'ZONE-DEF') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*     maniere direct
  505    IF(TEXT12.EQ.'SURV-ZONE') THEN
            CALL REDGET(ITYP,NZCHF,FLOTT,TEXT12,DFLOTT)
            IF((ITYP.NE.1).OR.(NITMA.LT.1)) CALL XABORT
     1         ('FOBJCT: POSITIVE INTEGER EXPECTED')
            CALL SETARA(IBASE,NCHA*NBUND,IREPZ)
            CALL XDISET(IBASE(IREPZ),NCHA*NBUND,0)
  510       CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*        definir pour chaque plan chaque bundle le numero de la zone
            IF(TEXT12.EQ.'PLANE') THEN
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
               I2=NITMA-1
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(TEXT12.EQ.'SAME') THEN
                  CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
                  IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
                  I3=NITMA-1
                  DO 515 I=1,NCHA
  515             IBASE(IREPZ+I-1+I2*NCHA)=IBASE(IREPZ+I-1+I3*NCHA)
               ELSEIF(ITYP.EQ.1) THEN
                  IBASE(IREPZ+I2*NCHA)=NITMA
                  DO 520 I=2,NCHA
                     CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
                     IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER DATA'
     1              //'EXPECTED')
  520                IBASE(IREPZ+I-1+I2*NCHA)=NITMA
               ELSE
                  CALL XABORT('FOBJCT: IN DIRECT CHF DEFINITION')
               ENDIF
               GO TO 510
            ELSE
*        sauver ces zones
               CALL SETARA(IBASE,NCHA*NBUND*NZCHF,IZCHF)
               DO 525 I=0,NCHA-1
               DO 525 J=0,NBUND-1
               DO 525 K=1,NZCHF
                  IF(K.EQ.IBASE(IREPZ+I+J*NCHA)) THEN
                     IBASE(IZCHF+I+J*NCHA+(K-1)*NCHA*NBUND)=1
                  ELSE
                     IBASE(IZCHF+I+J*NCHA+(K-1)*NCHA*NBUND)=0
                  ENDIF
  525          CONTINUE
               DO 530 K=1,NZCHF
                  NCST=NCST+1
                  CSTTYP(NCST)=5
                  CSTING(NCST)=1
                  WRITE(TXT12B,'(A8,I4.4)') 'CST-ZONE',NCST
  530             CALL LCMPUT(IPOPT,TXT12B,NCHA*NBUND,1,
     1                        IBASE(IZCHF+(K-1)*NCHA*NBUND))
               CALL RLSARA(IBASE(IREPZ))
               CALL RLSARA(IBASE(IZCHF))
               GO TO 505
            ENDIF
*     par grappe
         ELSEIF(TEXT12.EQ.'BUNDLE') THEN
            LTST=.TRUE.
*          definir quelles grappes sont controllees
            CALL SETARA(IBASE,NCHA*NBUND,IREPZ)
            CALL XDISET(IBASE(IREPZ),NCHA*NBUND,0)
  535       CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED')
            IF(TEXT12.EQ.'ALL') THEN
               LTST=.FALSE.
               DO 540 I=0,NCHA-1
               DO 540 J=0,NBUND-1
  540          IBASE(IREPZ+I+J*NCHA)=1
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            ELSEIF(TEXT12.EQ.'PLANE') THEN
               LTST=.FALSE.
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
               I2=NITMA-1
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(TEXT12.EQ.'SAME') THEN
                  CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
                  IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
                  I3=NITMA-1
                  DO 545 I=1,NCHA
  545             IBASE(IREPZ+I-1+I2*NCHA)=IBASE(IREPZ+I-1+I3*NCHA)
               ELSEIF(ITYP.EQ.1) THEN
                  IF((NITMA.NE.0).AND.(NITMA.NE.1)) CALL XABORT
     1               ('FOBJCT: 0 OR 1 EXPECTED')
                  IBASE(IREPZ+I2*NCHA)=NITMA
                  DO 550 I=2,NCHA
                     CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
                     IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER DATA'
     1              //'EXPECTED')
                     IF((NITMA.NE.0).AND.(NITMA.NE.1)) CALL XABORT
     1               ('FOBJCT: 0 OR 1 EXPECTED')
  550                IBASE(IREPZ+I-1+I2*NCHA)=NITMA
               ENDIF
               GO TO 535
            ENDIF
*          sauvegarder dans l'objet L_OPT les zones des contraintes
            IF(LTST) CALL XABORT('FOBJCT: PLANE OR ALL EXPECTED')
            DO 555 J=0,NBUND-1
            DO 555 I=0,NCHA-1
               IF(IBASE(IREPZ+I+J*NCHA).EQ.1) THEN
                  NCST=NCST+1
                  CSTTYP(NCST)=4
                  CSTING(NCST)=1
                  CBINDX(1)=I+1
                  CBINDX(2)=J+1
                  WRITE(TXT12B,'(A8,I4.4)') 'CST-ZONE',NCST
                  CALL LCMPUT(IPOPT,TXT12B,2,1,CBINDX)
               ENDIF
  555       CONTINUE
            CALL RLSARA(IBASE(IREPZ))
            GO TO 505
*     par canal
         ELSEIF(TEXT12.EQ.'CHANNEL') THEN
            LTST=.TRUE.
*          definir quels canaux sont controlles
            CALL SETARA(IBASE,NCHA,IREPZ)
            CALL XDISET(IBASE(IREPZ),NCHA,0)
  560       CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF((ITYP.EQ.3).AND.(TEXT12.EQ.'ALL')) THEN
               LTST=.FALSE.
               DO 565 I=0,NCHA-1
  565          IBASE(IREPZ+I)=1
            ELSEIF(ITYP.EQ.1) THEN
               IF((NITMA.NE.0).AND.(NITMA.NE.1)) CALL XABORT
     1            ('FOBJCT: 0 OR 1 EXPECTED')
               IBASE(IREPZ)=NITMA
               DO 570 I=1,NCHA-1
                  CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
                  IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER DATA'
     1           //'EXPECTED')
                  IF((NITMA.NE.0).AND.(NITMA.NE.1)) CALL XABORT
     1            ('FOBJCT: 0 OR 1 EXPECTED')
  570             IBASE(IREPZ+I)=NITMA
               LTST=.FALSE.
            ENDIF
*          sauvegarder dans l'objet L_OPT les zones des contraintes
            IF(LTST) CALL XABORT('FOBJCT: ALL OR NCHA 0/1  EXPECTED')
            DO 575 I=0,NCHA-1
               IF(IBASE(IREPZ+I).EQ.1) THEN
                  NCST=NCST+1
                  CSTTYP(NCST)=3
                  CSTING(NCST)=1
                  WRITE(TEXT12,'(A8,I4.4)') 'CST-ZONE',NCST
                  CALL LCMPUT(IPOPT,TEXT12,1,1,I+1)
               ENDIF
  575       CONTINUE
            CALL RLSARA(IBASE(IREPZ))
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            GO TO 505
         ELSE
            GO TO 502
         ENDIF
      ELSEIF(TEXT12.EQ.'VALUE-DEF') THEN
  580    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.EQ.1) THEN
            I2=NITMA
            I3=I2
         ELSEIF((TEXT12.EQ.'RANGE').AND.(ITYP.EQ.3)) THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
            I2=NITMA
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
            I3=NITMA
         ELSE
            GO TO 502
         ENDIF
         IF((I2.GT.NCST).OR.(I3.GT.NCST)) CALL XABORT('FOBJCT: '
     1      //'NUMBER FOR CONSTRAINT EXCEEDED')
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF((ITYP.EQ.3).AND.(TEXT12.EQ.'ALLSAME')) THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.2) CALL XABORT('FOBJCT: REAL EXPECTED')
            DO 585 I=I2,I3
  585          CSTOBJ(I)=FLOTT
            GO TO 580
         ELSEIF(ITYP.EQ.2) THEN
            CSTOBJ(I2)=FLOTT
            IF(I3.GT.I2) THEN
               DO 586 I=I2+1,I3
                  CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
                  IF(ITYP.NE.2) CALL XABORT('FOBJCT: REAL EXPECTED')
  586             CSTOBJ(I)=FLOTT
            ENDIF
            GO TO 580
         ELSE
            CALL XABORT('FOBJCT: WRONG VALUE OF MAXPOWER DEFINITION')
         ENDIF
      ELSEIF(TEXT12.EQ.'END-MAX-POW') THEN
         GO TO 501
      ELSE
         CALL XABORT('FOBJCT: WRONG KEYWORD IN POWER ZONE DEFINITION')
      ENDIF
C REACTIVITE DES CONTROLEURS
      ELSEIF(TEXT12.EQ.'DEVICE-REAC') THEN
      WRITE(6,*) 'FOBJCT: OPTION NOT YET AVAILAIBLE'
C Sauvegarde des contraintes
      ELSE
         CALL LCMPUT(IPOPT,'CST-VOL-TYPE',NCST,1,CSTTYP)
         CALL LCMPUT(IPOPT,'CST-TYPE',NCST,1,CSTING)
         CALL LCMPUT(IPOPT,'CST-OBJ',NCST,2,CSTOBJ)
         OPTPRI(2)=NCST
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
         IF(IPRINT.GE.1) THEN
             WRITE(6,*) 'NUMBER OF CONSTRAINTS  = ',NCST
         ENDIF
         IF(IPRINT.GE.2) THEN
             WRITE(6,*) 'TYPES OF CONSTRAINTS   = ',(CSTTYP(I),I=1,NCST)
         ENDIF
         IF(IPRINT.GE.3) THEN
             WRITE(6,*) '=,<,> TYPE OF CONSTRAINTS = ',
     1                  (CSTTYP(I),I=1,NCST)
             WRITE(6,*) 'BORNES OF VARIABLES (MIN)= ',
     1                  (CSTOBJ(I),I=1,NCST)
         ENDIF
         GO TO 30
      ENDIF
      GO TO 501
C---------------------------
C  666666    0000     0000
C 6      6  0    0   0    0
C 6  66    0      0 0      0
C 666  66  0      0 0      0
C 6      6 0      0 0      0
C 6      6 0      0 0      0
C  6    6   0    0   0    0
C   6666     0000     0000
C---------------------------
C OBJECTIVE AND CONSTRAINT EVALUATION
C---------------------------
*combien de contraintes existent
  600 IF(NCST.EQ.0) CALL XABORT('FOBJCT: EVALUATE CONSTRAINT '
     1  //'ZONE BEFORE EVALUATION')
      CALL SETARA(RBASE,NCST+1,IDTVAL)
      CALL LCMLEN(IPOPT,'FOBJ-CST-VAL',NVAL,ITYP)
      IF(NVAL.EQ.(NCST+1)) THEN
         CALL LCMGET(IPOPT,'FOBJ-CST-VAL',RBASE(IDTVAL))
      ELSEIF(NVAL.EQ.0) THEN
         DO 601 I=0,NCST
  601       RBASE(IDTVAL+I)=0.0
      ENDIF
  610 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED')
      TXTPDF=' '
      IF(TEXT12.EQ.'FOBJ') THEN
         FCTFRM=0
         FCTTO=0
      ELSEIF(TEXT12.EQ.'CONSTRAINT') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
         FCTFRM=NITMA
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED')
         FCTTO=NITMA
         IF(FCTTO.LT.FCTFRM) CALL XABORT('FOBJCT: FROM GREATER '
     1  //'THAN TO')
         IF((FCTFRM.GT.NCST).OR.(FCTTO.GT.NCST)) CALL XABORT
     1  ('FOBJCT: TOTAL NUMBER OF CONSTRAINT IS LESS THAN FCTTO')
      ELSE
*sauvegarder les resultats
         CALL LCMPUT(IPOPT,'FOBJ-CST-VAL',NCST+1,2,
     1               RBASE(IDTVAL))
         CALL RLSARA(RBASE(IDTVAL))
         GO TO 30
      ENDIF
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*definition d'autres variables si applicable - DEBUT
      IF(TEXT12.EQ.'VARDEF') THEN
         IF(IPRINT.GE.5)  WRITE(6,*) 'FUNCTION DEFINED MANUALLY'
         TXTPDF='FUNCTION'
         CALL OPTVDF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXTPDF,TEXT12,
     1            NENTRY,KENTRY,HENTRY)
         IF(TEXT12.NE.'INIT') CALL XABORT('FOBJCT: "INIT" KEYWORD '
     1  //'NEEDED BETWEEN VARIABLES AND SEQUENCE DEFINITIONS')
      ELSEIF(TEXT12.EQ.'FUNCT-PREDEF') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TXTPDF,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('FOBJCT: CHARACTER EXPECTED')
         IF(IPRINT.GE.5)  WRITE(6,*) 'NAME OF THE PREDEFINED FUNCTION',
     1  TXTPDF
         CALL OPTVDF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXTPDF,TEXT12,
     1            NENTRY,KENTRY,HENTRY)
      ENDIF
      IF(TXTPDF.EQ.' ') THEN
         IF(TEXT12.NE.'INIT') CALL XABORT('FOBJCT: "INIT" KEYWORD '
     1  //'NEEDED BEFORE SEQUENCE DEFINITIONS')
         TXTPDF='FUNCTION'
      ENDIF
*definition d'autres variables si applicable - FIN
*debut de la sequence de calcul
      CALL OPTSEQ(MEMADR,STFCN,VTFCN,RTFCN,OTFCN,NLVL1,NLVL2,IVRLC,
     1            TVRLC,VRLCMX,NGRP,TXTPDF)
         IF(IPRINT.GE.6) WRITE(6,*) 'FUNCTION TO BE EVALUATED:',FCTFRM,
     1  ' TO ',FCTTO
  650 DO 670 I=FCTFRM,FCTTO
         VTFCN(1,1)=I
         CALL OPTSUP(MEMADR,STFCN,VTFCN,RTFCN,NLVL1,NLVL2,
     1                  IVRLC,VRLCMX,I)
         CALL OPTEVL(MEMADR,VRLCMX,IVRLC,TVRLC,LVRLC,
     1     NLVL1,NLVL2,STFCN,VTFCN,RTFCN,OTFCN,FVAL,1,TXTPDF)
         IF(IPRINT.GE.7) WRITE(6,'(A5,I3,A2,E13.8)')'IFCT=',I,'->',FVAL
  670    RBASE(IDTVAL+I)=FVAL
      GO TO 610
C---------------------------
C END
C---------------------------
 1000 IF(IPMAP.GT.0) THEN
         CALL RLSARA(RBASE(IBZMAP))
         CALL RLSARA(IBASE(IZMAP))
      ENDIF
      OPTPRI(1)=NVAR
      OPTPRI(2)=NCST
      IF(IPRINT.GE.4) THEN
         WRITE(6,*) 'INTEGER STATE VECTOR',(OPTPRI(I),I=1,NSTATE)
         WRITE(6,*) 'REAL STATE VECTOR',(OPTPRR(I),I=1,NSTATE)
         CALL LCMLIB(IPOPT)
      ENDIF
      CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
*liberer l'espace utilise par les vecteurs locaux
      DO 1010 I=1,VRLCMX
         IF(LVRLC(I)) THEN
            CALL RLSARA(RBASE(IVRLC(I)))
         ENDIF
 1010 CONTINUE
      RETURN
C---------------------------
C FORMAT
C---------------------------
 5000 FORMAT (1X,I5,3H  ',A12,1H',2I8)
      END
