*DECK GPTVRF
      SUBROUTINE GPTVRF(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this module verifies gradients obtained using GPT theory.
* GPTVRF = Generalized Perturbation Theory VeRiFication 
*                   of the calculated gradient
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
* NENTRY  number of lcm objects used by the module
* HENTRY  character*12 name of each lcm object
* IENTRY  =1 linked list; =2 xsm file; =3 sequential binary file;
*         =4 sequential ascii file
* JENTRY  =0 the lcm object is created
*         =1 the lcm object is open for modifications;
*         =2 the lcm object is open in read-only mode
* KENTRY  =file unit number; =lcm object address otherwise
*         kentry(nentry)
* LCM OBJECTS:
* HENTRY(1)  create type (l_macrolib)
* HENTRY(2)  read only type (l_macrolib)
* HENTRY(3)  read only type (l_macrolib)
* or
* HENTRY(1)  create type (l_flux)
* HENTRY(2)  read only type (l_flux)
* HENTRY(3)  read only type (l_flux)
*                          
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   NENTRY
      CHARACTER HENTRY(NENTRY)*12
      INTEGER   IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   IPRINT,NITMA,I,J,IPOPT,IPOPTB,ITYP,NVAR,NCST,SIGNA(3),
     1          LENGT,IEPS,NFCT
      DOUBLE PRECISION DFLOTT
      REAL      FLOTT,ERRREL1,ERRREL2,EPS,DX
      CHARACTER TEXT12*12
      LOGICAL   LREL
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   OPTPRI(NSTATE)

* CALCUL DU GRADIENT
      INTEGER   VARFRM,VARTO,IVAR,FCTFRM,FCTTO,IFCT,VEPS,NEPS
      REAL      GRAD

* Vector offset
      INTEGER   X,Y,YD,WK,ALLFVL,IEPSVL,EPSVAL,GRDEXP,GRDGPT,VARVAL,
     1          VARFCT

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
C
C
C---------------------------
C     VALIDITY OF OBJECTS
C---------------------------
      IF (NENTRY.NE.2) CALL XABORT('GPTSRC: 2 OBJECTS EXPECTED.')
*CHECK IF OBJECTS ARE LCM OBJECTS AND WHICH ONE CORRESPOND 
*TO WHICH TYPE
      IPOPTB=KENTRY(1)
      IPOPT=KENTRY(2)
*INITIALIZE THE FILE NUMBER UNIT FOR SUBROUTINE OPTEVL.f
      DO 1 I=1,NENTRY
    1    IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2))CALL XABORT('GPTVRF:'
     1      //' LCM OBJECT EXPECTED')
      IF (JENTRY(2).NE.2) CALL XABORT('GPTVRF: Second L_OPTIMIZE '
     1  //'object not in READ-ONLY mode')
      CALL LCMGET(IPOPT,'SIGNATURE',SIGNA)
      WRITE(TEXT12,'(3A4)') (SIGNA(J),J=1,3)
      IF (TEXT12.NE.'L_OPTIMIZE') CALL XABORT('GPTVRF: Second object '
     1  //'not L_OPTIMIZE as expected')
      CALL LCMGET(IPOPT,'STATE-VECTOR',OPTPRI)
      IF (JENTRY(1).EQ.0) THEN
         CALL LCMPUT(IPOPTB,'SIGNATURE',3,3,SIGNA)
         CALL LCMPUT(IPOPTB,'STATE-VECTOR',NSTATE,1,OPTPRI)
      ELSE
         CALL LCMGET(IPOPTB,'SIGNATURE',SIGNA)
         WRITE(TEXT12,'(3A4)') (SIGNA(J),J=1,3)
         IF (TEXT12.NE.'L_OPTIMIZE') CALL XABORT('GPTVRF:First  object '
     1  //'not L_OPTIMIZE as expected')
      ENDIF
C
C---------------------------
C VARIABLE INITIALISATION	
C---------------------------
      IPRINT=  0
*aller chercher dans OPT les info necessaires
      CALL LCMGET(IPOPT,'STATE-VECTOR',OPTPRI)
      NVAR   = OPTPRI(1)
      NCST   = OPTPRI(2)
      NFCT   = NCST+1
C
C---------------------------
C     READ USER INPUT:
C---------------------------
   20 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
   30 IF (ITYP.NE.3) CALL XABORT('GPTVRF: CHARACTER EXPECTED')
* Edition level      
      IF (TEXT12.EQ.'EDIT') THEN
         CALL REDGET(ITYP,IPRINT,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('GPTVRF: *IPRINT* MUST BE INTEGER')
* Saving the functionnal values for a given perturbation of one variable
      ELSEIF (TEXT12.EQ.'SAVE-PERT')THEN
         GO TO 100
* Saving the gradients calculated with the GPT
      ELSEIF (TEXT12.EQ.'SAVE-GPT')THEN
         GO TO 200
* Calculation of the gradients with the direct evaluation method
      ELSEIF (TEXT12.EQ.'COMPARE')THEN
         GO TO 300
* End of this subroutine
      ELSEIF( TEXT12.EQ.';' )THEN
         GO TO 1000
      ELSE
         CALL XABORT('SNDMPI: '//TEXT12//' IS AN INVALID KEYWORD.')
      ENDIF
      GO TO 20

C---------------------------
C     1      0000     0000    
C    11     0    0   0    0 
C   1 1    0      0 0      0 
C  1  1    0      0 0      0  
C 1   1    0      0 0      0  
C     1    0      0 0      0  
C     1     0    0   0    0  
C 11111111   0000     0000  
C---------------------------
C Saving the functionnal values for a given perturbation of one variable
C---------------------------
  100 CALL REDGET(ITYP,IVAR,FLOTT,TEXT12,DFLOTT)
      IF (ITYP.NE.1) CALL XABORT('GPTVRF: INTEGER EXPECTED (1)')
      IF ((IVAR.GT.NVAR).OR.(IVAR.LE.0)) CALL XABORT('GPTVRF: INVALID '
     1  //'VARIABLE NUMBER (1)')
      CALL REDGET(ITYP,NITMA,EPS,TEXT12,DFLOTT)
      IF (ITYP.NE.2) CALL XABORT('GPTVRF: REAL EXPECTED (1)')
      CALL SETARA(RBASE,NFCT,VARFCT)
      CALL LCMGET(IPOPT,'FOBJ-CST-VAL',RBASE(VARFCT))
      WRITE(TEXT12,'(A8,I4.4)') 'VAR-PERT',IVAR
      CALL LCMSIX(IPOPTB,TEXT12,1)
* numero pour ce EPS ?
      CALL LCMLEN(IPOPTB,'EPSILON',NEPS,ITYP)
*   la liste est cree
      IF (NEPS.EQ.0) THEN 
         IEPS=1
         CALL LCMPUT(IPOPTB,'EPSILON',1,2,EPS)
         GO TO 150
*   EPS existe-t-il deja dans la liste 
      ELSE
         CALL SETARA(RBASE,NEPS+1,VEPS)
         CALL LCMGET(IPOPTB,'EPSILON',RBASE(VEPS))
         RBASE(VEPS+NEPS)=EPS
         IEPS=NEPS+1
         DO 110 I=0,NEPS-1
            IF (EPS.EQ.RBASE(VEPS+I)) THEN
               IEPS=I+1
              CALL RLSARA(RBASE(VEPS))
               GO TO 150
            ENDIF
  110       CONTINUE
         CALL LCMPUT(IPOPTB,'EPSILON',NEPS+1,2,RBASE(VEPS))
      ENDIF
  150 WRITE(TEXT12,'(A9,I3.3)') 'F-C-VAL-P',IEPS
      CALL LCMPUT(IPOPTB,TEXT12,NFCT,2,RBASE(VARFCT))
      CALL RLSARA(RBASE(VARFCT))
      CALL LCMSIX(IPOPTB,' ',0)
      GO TO 20
C---------------------------
C   2222     0000     0000    
C  2    2   0    0   0    0 
C 2      2 0      0 0      0 
C       2  0      0 0      0  
C      2   0      0 0      0  
C   22     0      0 0      0  
C  2        0    0   0    0  
C 22222222   0000     0000  
C---------------------------
C Saving the gradients calculated with the GPT
C---------------------------
  200 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF (ITYP.NE.3) CALL XABORT('GPTVRF: CHARACTER EXPECTED')
      LREL=.FALSE.
      IF (TEXT12.EQ.'REL') THEN
         CALL REDGET(ITYP,NITMA,EPS,TEXT12,DFLOTT)
         IF (ITYP.NE.2) CALL XABORT('GPTVRF: REAL EXPECTED')
         LREL=.TRUE.
      ELSEIF (TEXT12.NE.'ABS') THEN
         CALL XABORT('GPTVRF: ABS or REL keyword expected')
      ENDIF
      CALL LCMLEN(IPOPT,'GRADIENT',LENGT,ITYP)
      IF (LENGT.NE.NFCT*NVAR) CALL XABORT('GRDVRF: WRONG '
     1  //'NUMBER OF GRADIENTS')
      CALL SETARA(RBASE,NVAR*NFCT,GRDGPT)
      CALL LCMGET(IPOPT,'GRADIENT',RBASE(GRDGPT))
      CALL SETARA(RBASE,NVAR,VARVAL)
      CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVAL))
      IF (IPRINT.GE.2) WRITE(6,*) 'BE SURE YOU PROVIDE UNPERTURBATED '
     1  //'VALUES OF DECISION VARIABLES'
      IF (LREL) THEN
         DO 250 IVAR=0,NVAR-1
            DX=RBASE(VARVAL+IVAR)*EPS
            IF (DX.EQ.0) THEN
               DX=1.0
               WRITE(6,*) 'VARIABLE #',IVAR+1,' WAS NOT PERTURBATED'
            ENDIF
            DO 250 IFCT=0,NFCT-1
 250           RBASE(GRDGPT+IFCT*NVAR+IVAR)=
     1               RBASE(GRDGPT+IFCT*NVAR+IVAR)/DX
      ENDIF
      CALL LCMPUT(IPOPTB,'VAR-VALUE-RF',NVAR,2,RBASE(VARVAL))
      CALL LCMPUT(IPOPTB,'GRADIENT-GPT',NVAR*NFCT,2,RBASE(GRDGPT))
      CALL RLSARA(RBASE(GRDGPT))
      CALL RLSARA(RBASE(VARVAL))
      GO TO 20
C---------------------------
C   3333     0000     0000    
C  3    3   0    0   0    0 
C 3      3 0      0 0      0 
C      33  0      0 0      0  
C       3  0      0 0      0  
C 3      3 0      0 0      0  
C  3    3   0    0   0    0  
C   3333     0000     0000  
C---------------------------
C Calculation of the gradients with the direct evaluation method
C---------------------------
  300 CONTINUE
* variable de decision pour lesquelles la comparaison est faite
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF (ITYP.EQ.1) THEN
         VARFRM=NITMA
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('GPTVRF: INTEGER EXPECTED '
     1  //'FOR VARTO')
         VARTO=NITMA
         IF ((VARFRM.GT.VARTO).OR.(VARFRM.LT.1).OR.(VARTO.GT.NVAR))
     1  CALL XABORT('GPTVRF: VARFRM and VARTO DO NOT FIT')
      ELSEIF (TEXT12.EQ.'ALL') THEN
         VARFRM=1
         VARTO =NVAR
      ELSE
         CALL XABORT('GPTVRF: VARFRM and VARTO DEFINITION IS WRONG')
      ENDIF
* fonctionnelles pour lesquelles la comparaison est faite
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF (ITYP.EQ.1) THEN
         FCTFRM=NITMA
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('GPTVRF: INTEGER EXPECTED '
     1  //'FOR FCTTO')
         FCTTO=NITMA
         IF ((FCTFRM.GT.FCTTO).OR.(FCTFRM.LT.0).OR.(FCTTO.GT.NFCT))
     1  CALL XABORT('GPTVRF: VARFRM and VARTO DO NOT FIT')
      ELSEIF (TEXT12.EQ.'ALL') THEN
         FCTFRM=0
         FCTTO =NFCT
      ELSE
         CALL XABORT('GPTVRF: FCTFRM and FCTTO DEFINITION IS WRONG')
      ENDIF
* initialisation de du gradient experimental
      CALL LCMLEN(IPOPTB,'GRADIENT-EXP',LENGT,ITYP)
      CALL SETARA(RBASE,NVAR*NFCT,GRDEXP)
      IF (LENGT.EQ.0) THEN
         CALL XDRSET(RBASE(GRDEXP),NVAR*NFCT,0.0)
      ELSE
         CALL LCMGET(IPOPTB,'GRADIENT-EXP',RBASE(GRDEXP))
      ENDIF
* charger les valeurs de reference des variables et du gradient
      CALL SETARA(RBASE,NVAR,VARVAL)
      CALL LCMGET(IPOPTB,'VAR-VALUE-RF',RBASE(VARVAL))
      CALL SETARA(RBASE,NVAR*NFCT,GRDGPT)
      CALL LCMGET(IPOPTB,'GRADIENT-GPT',RBASE(GRDGPT))
* calcul du gradient experimental
      DO 390 IVAR=VARFRM,VARTO
         WRITE(TEXT12,'(A8,I4.4)') 'VAR-PERT',IVAR
         CALL LCMSIX(IPOPTB,TEXT12,1)
         CALL LCMLEN(IPOPTB,'EPSILON',NEPS,ITYP)
         IF (NEPS.LE.1) CALL XABORT('GPTVRF: NOT ENOUGTH PERTURBATION')
         CALL SETARA(RBASE,NEPS,EPSVAL)
         CALL SETARA(IBASE,NEPS,IEPSVL)
         CALL LCMGET(IPOPTB,'EPSILON',RBASE(EPSVAL))
         CALL SETARA(RBASE,NEPS,X)
         CALL SETARA(RBASE,NEPS,Y)
         CALL SETARA(RBASE,2*NEPS,YD)
         CALL SETARA(RBASE,2*NEPS,WK)
*   classer les EPS dans l'ordre croissant et calculer X
         TEXT12='UPNOEQ'
         CALL ORDERR(NEPS,RBASE(EPSVAL),IBASE(IEPSVL),TEXT12)
         CALL SETARA(RBASE,NFCT*NEPS,ALLFVL)
         DO 310 IEPS=1,NEPS
*         calcul de X dans le bon ordre
            RBASE(X+IBASE(IEPSVL+IEPS-1)-1)=
     1            RBASE(VARVAL+IVAR-1)*(1+RBASE(EPSVAL+IEPS-1))
            WRITE(TEXT12,'(A9,I3.3)') 'F-C-VAL-P',IEPS
*         mise en place de tous les Y dans le bon ordre
            CALL LCMGET(IPOPTB,TEXT12,
     1             RBASE(ALLFVL+(IBASE(IEPSVL+IEPS-1)-1)*NFCT))
  310       CONTINUE
*        rem: ICFT entre 0 et NCST
         DO 380 IFCT=FCTFRM,FCTTO
*          recuperation du bon Y (rem: deja dans le bon ordre)
            DO 320 IEPS=1,NEPS
  320          RBASE(Y+IEPS-1)=
     1              RBASE(ALLFVL+IFCT+(IEPS-1)*NFCT)
*           calcul du gradient
            CALL OPTCSH(NEPS,RBASE(X),RBASE(Y),RBASE(YD),RBASE(WK),GRAD)
  380       RBASE(GRDEXP-1+IVAR+IFCT*NVAR)=GRAD
         CALL RLSARA(RBASE(ALLFVL))
         CALL RLSARA(RBASE(EPSVAL))
         CALL RLSARA(IBASE(IEPSVL))
         CALL RLSARA(RBASE(X))
         CALL RLSARA(RBASE(Y))
         CALL RLSARA(RBASE(YD))
         CALL RLSARA(RBASE(WK))
         CALL LCMSIX(IPOPTB,' ',0)
 390     CONTINUE
      CALL LCMPUT(IPOPTB,'GRADIENT-EXP',NVAR*NFCT,2,RBASE(GRDEXP))
      IF (IPRINT.GT.0) THEN
         WRITE(6,*) '#FCT | #VAR | GRADIENT-GPT | GRADIENT-EXP | '
     1  //'ERROR (%GPT) | ERROR (%EXP) '
         DO 399 IFCT=FCTFRM,FCTTO
         DO 399 IVAR=VARFRM,VARTO
            ERRREL1=(RBASE(GRDEXP-1+IVAR+IFCT*NVAR)-
     1                 RBASE(GRDGPT-1+IVAR+IFCT*NVAR))
     2              /RBASE(GRDGPT-1+IVAR+IFCT*NVAR)*100
            ERRREL2=(RBASE(GRDGPT-1+IVAR+IFCT*NVAR)-
     1                 RBASE(GRDEXP-1+IVAR+IFCT*NVAR))
     2              /RBASE(GRDEXP-1+IVAR+IFCT*NVAR)*100
            WRITE(6,'(1X,I4,A3,I4,A3,E12.6,A3,E12.6,A3,F12.6,A3,F12.6)') 
     1  IFCT,' | ',IVAR,' | ',RBASE(GRDGPT-1+IVAR+IFCT*NVAR),' | ',
     2  RBASE(GRDEXP-1+IVAR+IFCT*NVAR),' | ',ERRREL1,' | ',ERRREL2
  399    CONTINUE
      ENDIF
      CALL RLSARA(RBASE(VARVAL))
      CALL RLSARA(RBASE(GRDGPT))
      CALL RLSARA(RBASE(GRDEXP))
      GO TO 20
C---------------------------
C END
C---------------------------
 1000  RETURN
C---------------------------
C FORMAT
C---------------------------
      END
