*DECK KOPDRV
      INTEGER FUNCTION KOPDRV(HMODUL,NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* code dependent operator driver for OPTEX.
*
*Copyright:
* Copyright (C) 2009 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input/output
* HMODUL  name of the operator.
* NENTRY  number of LCM objects or files used by the operator.
* HENTRY  name of each LCM object or file.
* IENTRY  type of each LCM object or file:
*         =1 LCM memory object; =2 XSM file; =3 sequential binary file;
*         =4 sequential ascii file.
* JENTRY  access of each LCM object or file:
*         =0 the LCM object or file is created;
*         =1 the LCM object or file is open for modifications;
*         =2 the LCM object or file is open in read-only mode.
* KENTRY  LCM object address or file unit number.
*
*Parameters: output
* KOPDRV  completion flag (=0: operator HMODUL exists; =1: does not
*         exists).
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER HMODUL*(*),HENTRY(NENTRY)*12
      INTEGER IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
      INTEGER DONDRV
*
      KOPDRV=0
      IF(HMODUL.EQ.'FOBJCT:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL FOBJCT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'PERTUR:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL PERTUR(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'GPTSRC:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL GPTSRC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'GPTGRD:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL GPTGRD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'GPTVRF:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL GPTVRF(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'QLPUTL:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL QLPUTL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'QLP:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL QLP(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'ADDOBJ:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL ADDOBJ(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'MATLAB:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL MATLAB(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'TIME77:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL TIME77(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'TABU:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL TABU(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE IF(HMODUL.EQ.'ADDHST:') THEN
         WRITE(6,'(//7H EXEC: ,A,4H BY ,A)') HMODUL,'R.CHAMBON'
         CALL ADDHST(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ELSE
         KOPDRV=DONDRV(HMODUL,NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
      ENDIF
      RETURN
      END
