*DECK MATLAB01
      SUBROUTINE  MATL01(IPASC,IPOPT,NVAR,NFCT,GRAD,FCT,VARVAL,INEPS)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine prepare input file for MATLAB for gradiants 
*  verification
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
* IPASC   file unit number of the ASCII (future MATLAB file)
* IPOPT   adress of the lcm object of L_OPTIMIZE
* NVAR    number of decision variable
* NFCT    number of function (1 objectif function + n constraints)
* 
*Parameters: scratch
* GRAD    REAL(NFCT,NVAR)
* FCT     REAL(NFCT)
* VARVAL  REAL(NVAR)
* INEPS   INTEGER(NVAR)
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER  NVAR,NFCT,IPASC,IPOPT
      REAL     GRAD(NFCT,NVAR),FCT(NFCT),VARVAL(NVAR)
      INTEGER  INEPS(NVAR)
*----
*  LOCAL VARIABLES
*----
      INTEGER  ITYP,IVAR,LENGT,IEPS
      INTEGER  IEPSVL
      CHARACTER TEXT12*12
      INTEGER  NEPS,NEPSMX

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

* Table rase dans MATLAB      
      WRITE(IPASC,*) '% OPTIONS CAN BE CHANGED AT THE END'
      WRITE(IPASC,*) '%  by default - all gradients are ploted'
      WRITE(IPASC,*) '%             - keff is the last function'
      WRITE(IPASC,*) 'clear'


* Calcul de NEPSMX
      NEPSMX=0
      CALL XDISET(INEPS,NVAR,0)
      DO 100 IVAR=1,NVAR
         WRITE(TEXT12,'(A8,I4.4)') 'VAR-PERT',IVAR
         CALL LCMLEN(IPOPT,TEXT12,LENGT,ITYP)
         IF (LENGT.NE.0) THEN
            CALL LCMSIX(IPOPT,TEXT12,1)
            TEXT12='EPSILON'
            CALL LCMLEN(IPOPT,TEXT12,NEPS,ITYP)
            NEPSMX=MAX(NEPS,NEPSMX)
            INEPS(IVAR)=NEPS
            CALL LCMSIX(IPOPT,' ',0)
         ENDIF
  100    CONTINUE

* Copie des valeurs des fonctions
      DO 200 IVAR=1,NVAR
         WRITE(TEXT12,'(A8,I4.4)') 'VAR-PERT',IVAR
         CALL LCMLEN(IPOPT,TEXT12,LENGT,ITYP)
         NEPS=0
         IF (LENGT.NE.0) THEN
            CALL LCMSIX(IPOPT,TEXT12,1)
* EPS[IVAR,:]
            TEXT12='EPSILON'
            NEPS=INEPS(IVAR)
            CALL SETARA(RBASE,NEPS,IEPSVL)
            CALL LCMGET(IPOPT,TEXT12,RBASE(IEPSVL))
            WRITE(IPASC,1010) IVAR
            CALL MATL0R(IPASC,NEPS,NEPSMX,RBASE(IEPSVL))
            WRITE(IPASC,1000) 
            CALL RLSARA(RBASE(IEPSVL))
* FCT[IVAR,IEPS,:]
            DO 150 IEPS=1,NEPS
               WRITE(TEXT12,'(A9,I3.3)') 'F-C-VAL-P',IEPS
               CALL LCMGET(IPOPT,TEXT12,FCT)
               WRITE(IPASC,1020) IVAR,IEPS
               CALL MATL0R(IPASC,NFCT,NFCT,FCT)
               WRITE(IPASC,1000) 
  150          CONTINUE
            CALL LCMSIX(IPOPT,' ',0)
         ENDIF 
         IF (NEPS.EQ.0) THEN
            WRITE(IPASC,1010) IVAR
            CALL MATL0R(IPASC,0,NEPSMX,0.0)
            WRITE(IPASC,1000)
         ENDIF
         IF (NEPS.LT.NEPSMX) THEN
            DO 160 IEPS=NEPS+1,NEPSMX
               WRITE(IPASC,1020) IVAR,IEPS
               CALL MATL0R(IPASC,0,NFCT,0.0)
               WRITE(IPASC,1000)
  160          CONTINUE
         ENDIF
  200    CONTINUE
* Copie des valeurs du gradient
      TEXT12='GRADIENT-GPT'
      CALL LCMGET(IPOPT,TEXT12,GRAD)
      WRITE(IPASC,1030)
      CALL MATL0R(IPASC,NFCT*NVAR,NFCT*NVAR,GRAD)
      WRITE(IPASC,1000)
* Copie des valeurs des variables
      TEXT12='VAR-VALUE-RF'
      CALL LCMGET(IPOPT,TEXT12,VARVAL)
      WRITE(IPASC,1040)
      CALL MATL0R(IPASC,NVAR,NVAR,VARVAL)
      WRITE(IPASC,1000)
* Nombre de EPS par variable
      WRITE(IPASC,1050)
      CALL MATL0I(IPASC,NVAR,NVAR,INEPS)
      WRITE(IPASC,1000)
* Boucle pour creer les figures
      WRITE(IPASC,*) '%%%%%%%%%%%%%%%%%%%%%'
      WRITE(IPASC,*) 'nvar=',NVAR,';'
      WRITE(IPASC,*) 'nfct=',NFCT,';'
      WRITE(IPASC,*) 'deps=0.01;'
      WRITE(IPASC,*) 'for ivar=1:nvar,'
      WRITE(IPASC,*) '    for ifct=1:nfct,'
      WRITE(IPASC,*) '%        tmp=(ifct-1)*(ifct-98)*(ifct-99);'
      WRITE(IPASC,*) '%        if tmp == 0'
      WRITE(IPASC,*) '        x=[-10*deps,10*deps];'
      WRITE(IPASC,*) '        y=FVAL(ivar,1,ifct)*[1 1]+ x*'
     1  //'GRAD(ivar+(ifct-1)*nvar)*VARVAL(ivar);'
      WRITE(IPASC,*) '        for i=1:INEPS(ivar),'
      WRITE(IPASC,*) '            funcval(i)=FVAL(ivar,i,ifct);'
      WRITE(IPASC,*) '            eps(i)=EPS(ivar,i);'
      WRITE(IPASC,*) '        end'
      WRITE(IPASC,*) '        [X,IDX]=sort(eps);'
      WRITE(IPASC,*) '        figure'
      WRITE(IPASC,*) '        h1=axes(''position'',[0.1 0.1 0.85 0.85])'
     1  //';'
      WRITE(IPASC,*) '        plot(X*100,funcval(IDX),''-o'',x*100,y'
     1  //',''r-'')'
      WRITE(IPASC,*) '        text=[''Constraint #'',num2str(ifct-1)];'
      WRITE(IPASC,*) '        if ifct == 1'
      WRITE(IPASC,*) '        text=[''Fobj''];'
      WRITE(IPASC,*) '        end'
      WRITE(IPASC,*) '%        if ifct == nfct'
      WRITE(IPASC,*) '%        text=[''Keff''];'
      WRITE(IPASC,*) '%        end'
      WRITE(IPASC,*) '        ylabel(text)'
      WRITE(IPASC,*) '        text=[''Pertubation (%) in Zone #'','
     1  //'num2str(ivar)];'
      WRITE(IPASC,*) '        xlabel(text)'
      WRITE(IPASC,*) '%        axis tight'
      WRITE(IPASC,*) '        grid on'
      WRITE(IPASC,*) '        if funcval(IDX(size(IDX))) <= '
     1  //'funcval(IDX(1))'
      WRITE(IPASC,*) '           h2=axes(''position'',[0.68 0.68 0.25 '
     1  //'0.25]);'
      WRITE(IPASC,*) '        else'
      WRITE(IPASC,*) '           h2=axes(''position'',[0.68 0.16 0.25 '
     1  //'0.25]);'
      WRITE(IPASC,*) '        end'
      WRITE(IPASC,*) '        plot(X*100,funcval(IDX),''o'',x*100,y'
     1  //',''r-'')'
      WRITE(IPASC,*) '        set(h2,''XLim'',[-1.05,1.05])'
      WRITE(IPASC,*) '        l=axis; '
      WRITE(IPASC,*) '        xl=[l(1) l(1) l(2) l(2) l(1)]; '
      WRITE(IPASC,*) '        yl=[l(3) l(4) l(4) l(3) l(3)]; '
      WRITE(IPASC,*) '        axes(h1) '
      WRITE(IPASC,*) '        line(xl,yl,''LineWidth'',2,''Color'','
     1  //'[.7 .7 .7]); '
      WRITE(IPASC,*) '        axes(h2) '
      WRITE(IPASC,*) '        grid on'
      WRITE(IPASC,*) '        clear funcval eps'
      WRITE(IPASC,*) '%        end'
      WRITE(IPASC,*) '    end'
      WRITE(IPASC,*) 'end'
      WRITE(IPASC,*) ' '
      


 1000 FORMAT(1X,2H];)
 1010 FORMAT(1X,4HEPS(,I4,5H,:)=[)
 1020 FORMAT(1X,5HFVAL(,I4,1H,,I4,5H,:)=[)
 1030 FORMAT(1X,//6HGRAD=[)
 1040 FORMAT(1X,//8HVARVAL=[)
 1050 FORMAT(1X,//7HINEPS=[)

      END
