*DECK MATLAB03
      SUBROUTINE  MATL03(IPASC,IPCPO,NPARAM,NPMAX,NBSTEP,NGRP,
     1                   IPAR,REPERT,XS,XSGP)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine prepare input file for MATLAB for cross sections plots
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
* IPASC   file unit number of the ASCII (future MATLAB file)
* IPCPO   adress of the lcm object of L_COMPO
* NPARAM  number of parameters
* NPMAX   maximum number of parameters
* NBSTEP  number of burnup step
* NGRP    number of energy group
* IPAR    index for each parameter
* REPERT  repertory in the L_COMPO file where the XS are stored
* 
*Parameters: scratch
* XS    cross sections 
*           in order:  TOTAL
*                      STRD
*                      NFTOT
*                      NUSIGF
*                      H_FACTORS
*                      CHI
* XSGP  same as XS but for one burnup step only
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER   IPASC,IPCPO,NPARAM,NPMAX,NBSTEP,NGRP
      INTEGER   IPAR(NPMAX)
      CHARACTER REPERT(2)*12
      REAL      XS(NBSTEP,NGRP,20),XSGP(NGRP,20)

      INTEGER   IBURN,IGR,I,J,LENGT,ITYP,XSSAVE
      CHARACTER TEXT12*12,TXT11*11,TPAR(NPMAX)*4,REPNAM(20)*12
      DATA      REPNAM
     > / 'NTOT0','TRANC','NUSIGF','NFTOT','CHI',
     >   'NU','NG','NHEAT','N2N','N3N',
     >   'N4N','NP','NA','GOLD','ABS',
     >   'NWT0','STRD','STRD X','STRD Y','STRD Z'/

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

* Load XS
      CALL LCMSIX(IPCPO,' ',0)
      CALL LCMSIX(IPCPO,REPERT(1),1)
      DO 20 IBURN=1,NBSTEP
         WRITE(TEXT12,'(A4,I8)') 'BURN',IBURN
         CALL LCMSIX(IPCPO,TEXT12,1)
         CALL LCMSIX(IPCPO,REPERT(2),1)
         CALL LCMLEN(IPCPO,'XS-SAVED',LENGT,ITYP)
         CALL SETARA(IBASE,LENGT,XSSAVE)
         CALL LCMGET(IPCPO,'XS-SAVED',IBASE(XSSAVE))
         DO 5 I=1,20
            IF (IBASE(XSSAVE+I-1).EQ.1) THEN
               CALL LCMGET(IPCPO,REPNAM(I),XSGP(1,I))
            ELSE
               CALL XDRSET(XSGP(1,I),NGRP,0.0)
            ENDIF
    5       CONTINUE
         CALL RLSARA(IBASE(XSSAVE))
         DO 10 IGR=1,NGRP
            DO 10 I=1,20
               XS(IBURN,IGR,I)=XSGP(IGR,I)
   10          CONTINUE
         CALL LCMSIX(IPCPO,' ',2)    
         CALL LCMSIX(IPCPO,' ',2)
   20    CONTINUE
      CALL LCMSIX(IPCPO,' ',0)   
* Write XS
      DO 30 I=2,NPMAX
   30 WRITE(TPAR(I),'(A1,I3)') ',',IPAR(I)
      DO 100 I=1,20
         DO 100 IGR=1,NGRP
            WRITE(TXT11,'(A3,I2,A1,I3,A2)') 'XS(',I,',',IGR,',:'
            WRITE(IPASC,*) TXT11,(TPAR(J),J=2,NPMAX),')=['
            CALL MATL0R(IPASC,NBSTEP,NBSTEP,XS(1,IGR,I))
            WRITE(IPASC,1000)
  100       CONTINUE

 1000 FORMAT(1X,2H];)

      END
