*DECK MATLAB04
      SUBROUTINE  MATL04(IPASC,IPOPT,NVAR,NCHA,VARVAL,PCHA)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine prepare input file for MATLAB optimization iterations
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
* IPASC   file unit number of the ASCII (future MATLAB file)
* IPOPT   adress of the lcm object of L_OPTIMIZE
* NVAR    number of decision variable
* NCHA    number of channels
* 
*Parameters: scratch
* VARVAL  REAL(NVAR)
* PCHA    REAL(NCHA)
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER  NVAR,NCHA,IPASC,IPOPT
      REAL     VARVAL(NVAR),PCHA(NCHA)
*----
*  LOCAL VARIABLES
*----
      INTEGER  ITYP,HIST,LENGT,HISTMX,LENGTMX
      INTEGER  IVAL
      CHARACTER TEXT12*12,TFIRST*12,TEXT9*9

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

* Table rase dans MATLAB 
      WRITE(IPASC,*) '% DECISION VARIABLES DURING OPTIMIZATION'
!      WRITE(IPASC,*) 'clear'

      CALL LCMSIX(IPOPT,'HISTORY',1)
      HISTMX=-1
      LENGTMX=1
      CALL SETARA(RBASE,LENGTMX,IVAL)
      TFIRST=' '
      CALL LCMNXT(IPOPT,TFIRST)
      TEXT12=TFIRST
  100 CALL LCMLEN(IPOPT,TEXT12,LENGT,ITYP)
      IF (LENGT.GT.LENGTMX) THEN
         CALL RLSARA(RBASE(IVAL))
         CALL SETARA(RBASE,LENGT,IVAL)
         LENGTMX=LENGT
      ENDIF 
      CALL LCMGET(IPOPT,TEXT12,RBASE(IVAL))
      READ(TEXT12,'(A9,I3.3)') TEXT9,HIST
      IF (HIST.GT.HISTMX) HISTMX=HIST
      IF (TEXT9.EQ.'FCT-VALUE') THEN 
         WRITE(IPASC,*) 'FOBJ(',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'K-EFF    ') THEN 
         WRITE(IPASC,*) 'KEFF(',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'VAR-VALUE') THEN 
         WRITE(IPASC,*) 'VAR(:,',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'POWER-CHA') THEN 
         WRITE(IPASC,*) 'PCHA(:,',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'POWER-CH2') THEN 
         WRITE(IPASC,*) 'PCHA2(:,',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'POWER-CH3') THEN 
         WRITE(IPASC,*) 'PCHA3(:,',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'S        ') THEN 
         WRITE(IPASC,*) 'S(',HIST+1,')=['
      ELSEIF (TEXT9.EQ.'CST-VAL  ') THEN 
         WRITE(IPASC,*) 'CST(:,',HIST+1,')=['
      ELSE 
         IF (LENGT.EQ.1) THEN
            WRITE(IPASC,*) TEXT9,'(',HIST+1,')=['
         ELSE
            WRITE(IPASC,*) TEXT9,'(:,',HIST+1,')=['
         ENDIF
      ENDIF
      IF (LENGT.EQ.1) THEN
         WRITE(IPASC,*) RBASE(IVAL)
      ELSE
         CALL MATL0R(IPASC,LENGT,LENGT,RBASE(IVAL))
      ENDIF
      WRITE(IPASC,1000) 
      CALL LCMNXT(IPOPT,TEXT12)
      IF (TFIRST.EQ.TEXT12) GOTO 500
      GOTO 100

*FIN
  500 WRITE(IPASC,*) 'ITmax=',HISTMX+1,';'
      WRITE(IPASC,*) 'nvar=',NVAR,';'
      CALL LCMSIX(IPOPT,' ',0)
     
      RETURN

 1000 FORMAT(1X,2H];)

      END
