*DECK MATL0I
      SUBROUTINE  MATL0R(IPASC,N,NTOT,VAL)
*
*-----------------------------------------------------------------------
*
*Purpose:
* Ecrit dans un fichier .m (ASCII) un vecteur a composantes reelles
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): E. Varin, R. Chambon
*
*Parameters: input/ouput
* IPASC numero du fichier
* N     Dimension du vecteur a recopier
* NTOT  Dimension du vecteur dans le tableau MATLAB
* VAL   Valeur du vecteur
*           dimension : N 
*                       1 si N=0, dans ce cas VAL non utilise
* remarque: Si un tableau de donnees est defini ligne par ligne dans
*           MATLAB, chaque ligne doit etre de la meme longueur (NTOT).
*           Si les vecteurs qui definissent cette matrice ne sont pas 
*           tous de la meme taille (N), la longueur du plus grand doit
*           etre fournie (NTOT)

*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER   IPASC,N,NTOT
      REAL      VAL(N)
*----
*  LOCAL VARIABLES
*----
      INTEGER   I,ITOT,J,K,L
      CHARACTER TEXT*4

      TEXT=' ...'

      I=(N-1)/10
      ITOT=(NTOT-1)/10+1
      DO 10 J=1,ITOT
         IF (J.EQ.ITOT) TEXT='    '
         IF (J.LE.I) THEN
            WRITE(IPASC,110) (VAL(K),K=(J-1)*10+1,J*10),TEXT
         ELSEIF ((J.EQ.I+1).OR.((I.LE.0).AND.(J.EQ.1))) THEN
            L=N-(J-1)*10
            IF (L.EQ.0) THEN
               WRITE(IPASC,100) TEXT
            ELSEIF(L.EQ.1) THEN
               WRITE(IPASC,101) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.2) THEN
               WRITE(IPASC,102) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.3) THEN
               WRITE(IPASC,103) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.4) THEN
               WRITE(IPASC,104) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.5) THEN
               WRITE(IPASC,105) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.6) THEN
               WRITE(IPASC,106) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.7) THEN
               WRITE(IPASC,107) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.8) THEN
               WRITE(IPASC,108) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.9) THEN
               WRITE(IPASC,109) (VAL(K),K=(J-1)*10+1,N),TEXT
            ELSEIF (L.EQ.10) THEN
               WRITE(IPASC,110) (VAL(K),K=(J-1)*10+1,N),TEXT
            ENDIF
         ELSE
            WRITE(IPASC,100) TEXT
         ENDIF
   10    CONTINUE

  100 FORMAT(1X,40H NaN NaN NaN NaN NaN NaN NaN NaN NaN NaN,A4)
  101 FORMAT(1X,1E16.8,36H NaN NaN NaN NaN NaN NaN NaN NaN NaN,A4)  
  102 FORMAT(1X,2E16.8,32H NaN NaN NaN NaN NaN NaN NaN NaN,A4)  
  103 FORMAT(1X,3E16.8,28H NaN NaN NaN NaN NaN NaN NaN,A4)  
  104 FORMAT(1X,4E16.8,24H NaN NaN NaN NaN NaN NaN,A4)  
  105 FORMAT(1X,5E16.8,20H NaN NaN NaN NaN NaN,A4)  
  106 FORMAT(1X,6E16.8,16H NaN NaN NaN NaN,A4)  
  107 FORMAT(1X,7E16.8,12H NaN NaN NaN,A4)  
  108 FORMAT(1X,8E16.8,8H NaN NaN,A4)  
  109 FORMAT(1X,9E16.8,4H NaN,A4)  
  110 FORMAT(1X,10E16.8,A4)

      END
