*DECK OPTADF
      SUBROUTINE OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,NAMEV)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine load predifined local array  varaibles
* OPTADF = OPTimization local Automatic variables DeFinition
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
*  MEMADR  adress memory of lcm objects (cf OPTVDF.f)
*  IVRLC   Table of offset of local array variables
*  TVRLC   Table of name of local array variables
*  LVRLC   Table of logical representing  if a local array variable
*           is defined
*  VRLCMX  Number maximum of local array variables
*  NGRP    Number of energy groups
*  NAMEV   Name of the variable
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   MEMADR(20),NGRP,VRLCMX
      INTEGER   IVRLC(VRLCMX)
      CHARACTER TVRLC(VRLCMX)*12,NAMEV*12
      LOGICAL   LVRLC(VRLCMX)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   JPLIST,KPLIST,JPFLU,JPMAP,KPMAP,LCMGIL,LCMGID
      INTEGER   NITMA,I,J,ITYP,IADR
      CHARACTER TEXT12*12,TXT12B*12
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   MCRPRM(NSTATE),OPTPRI(NSTATE),RESPRM(NSTATE),
     1          TRKPRM(NSTATE),SYSPRM(NSTATE)
      REAL      OPTPRR(NSTATE)
* Dimension of tables
      INTEGER   LENGT,NMIX
*A*PHI et B*PHI
      INTEGER   ITY,IFLUX,IWORK,OPTION
*'Local arrays' variable
      INTEGER   NVRLC,NSCAT,ISCAT,NUN
      LOGICAL   LTST
*Burnup et Fuel-cost Distribution variables
      INTEGER   NVAR,NCHA,NBZ,NK,NEZ,ICHA,FCD
      INTEGER   BZV,EZV,IBZ,IEZ,MIX,I1,OLDVAR,BZVOLD,EZVOLD,VARTYP,
     1          IDATA,IFCV,VARBKP
      REAl      EPS,EPSW,CUNT,CSEP,CFAB,INTR,TOBT,TENR,EPSU,EPSP
*Volume considerations
      INTEGER   IELEM,ICHX,IDIM0,IDIM,IR,MAXKN,NEL,LL4,VOL,KN,MAT,IGAR,
     1          SIGNA(3),SIG,BDIST,CDIST
      LOGICAL   LDUAL,CYLIND
*GRADIENT(X)
      INTEGER   NCST

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

      TEXT12=NAMEV
C---------------------------
C VALIDITY OF VARIABLE'S NAME AND ITS NUMBER
C---------------------------
C      IF(ITYP.NE.3) CALL XABORT('OPTADF: CHARACTER EXPECTED')
      LTST=.TRUE.
      DO 5 I=1,VRLCMX
         IF(TVRLC(I).EQ.TEXT12) THEN
            WRITE (6,*) 'OPTADF: ',TEXT12,' LOCAL VARIABLE '
     1      //'ALREADY EXIST'
            LVRLC(I)=.FALSE.
            CALL RLSARA(RBASE(IVRLC(I)))
         ENDIF
         IF((LTST).AND.(.NOT.LVRLC(I))) THEN
            LTST=.FALSE.
            NVRLC=I
            TVRLC(I)=TEXT12
            LVRLC(I)=.TRUE.
         ENDIF
    5 CONTINUE
C---------------------------
C LOAD
C---------------------------
      LTST=.FALSE.
C---------------------------
* charger un vecteur niveau 1 separer par groupe d'energie
      IF(TEXT12.EQ.'FLUX') THEN
         IADR=3
         LTST=.TRUE.
      ELSE IF(TEXT12.EQ.'AFLUX') THEN
         IADR=3
         LTST=.TRUE.
      ELSE IF(TEXT12.EQ.'FLUX2') THEN
         IADR=13
         LTST=.TRUE.
      ELSE IF(TEXT12.EQ.'AFLUX2') THEN
         IADR=13
         LTST=.TRUE.
      ENDIF
      IF(LTST) THEN
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: OBJECT '
     1  //'ADRESS NEEDED')
         JPFLU=LCMGID(MEMADR(IADR),TEXT12)
         CALL LCMLEL(JPFLU,1,NITMA,ITYP)
         CALL SETARA(RBASE,NITMA*NGRP,IVRLC(NVRLC))
         IF((TEXT12.EQ.'FLUX').OR.(TEXT12.EQ.'FLUX2')) THEN
            JPFLU=LCMGID(MEMADR(IADR),'FLUX')
         ELSE
            JPFLU=LCMGID(MEMADR(IADR),'AFLUX')
         ENDIF
         DO 10 I=1,NGRP
            CALL LCMGDL(JPFLU,I,RBASE(IVRLC(NVRLC)+(I-1)*NITMA))
   10    CONTINUE
         RETURN
      ENDIF
C---------------------------
* charger un vecteur niveau 1
      IF(TEXT12.EQ.'FLUX-AV') THEN
         IADR=2
         LTST=.TRUE.
      ELSE IF(TEXT12.EQ.'FLUX-AX') THEN
         IADR=2
         LTST=.TRUE.
      ENDIF
      IF(LTST) THEN
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: L_MAP '
     1  //'OBJECT ADRESS NEEDED')
         CALL LCMLEN(MEMADR(IADR),TEXT12,NITMA,ITYP)
         IF(NITMA.EQ.0) CALL XABORT('OPTAVF: FLUX-AV NOT YET '
     1  //'CALCULATED')
         CALL SETARA(RBASE,NITMA,IVRLC(NVRLC))
         CALL LCMGET(MEMADR(IADR),TEXT12,RBASE(IVRLC(NVRLC)))
         RETURN
      ENDIF
C---------------------------
* charger des XS de la macrolib
      IF((TEXT12.EQ.'DIFFX')    .OR.(TEXT12.EQ.'DIFFY').OR.
     1    (TEXT12.EQ.'DIFFZ')    .OR.(TEXT12.EQ.'NTOT0') .OR.
     2    (TEXT12.EQ.'NFTOT')    .OR.(TEXT12.EQ.'NUSIGF').OR.
     3    (TEXT12.EQ.'H-FACTOR') .OR.(TEXT12.EQ.'CHI')   .OR.
     4    (TEXT12.EQ.'FLUX-INTG')    ) THEN
         LTST=.TRUE.
      ELSE IF(TEXT12.EQ.'NJJ-0') THEN
         LTST=.TRUE.
         TEXT12='NJJ 0'
      ELSE IF(TEXT12.EQ.'IJJ-0') THEN
         LTST=.TRUE.
         TEXT12='IJJ 0'
      ELSE IF(TEXT12.EQ.'IPOS-0') THEN
         LTST=.TRUE.
         TEXT12='IPOS 0'
      ELSE IF(TEXT12.EQ.'SIGW-0') THEN
         LTST=.TRUE.
         TEXT12='SIGW 0'
      ELSE IF(TEXT12.EQ.'NJJ-1') THEN
         LTST=.TRUE.
         TEXT12='NJJ 1'
      ELSE IF(TEXT12.EQ.'IJJ-1') THEN
         LTST=.TRUE.
         TEXT12='IJJ 1'
      ELSE IF(TEXT12.EQ.'IPOS-1') THEN
         LTST=.TRUE.
         TEXT12='IPOS 1'
      ELSE IF(TEXT12.EQ.'SIGW-1') THEN
         LTST=.TRUE.
         TEXT12='SIGW 1'
      ENDIF
      IF(LTST) THEN
         IADR=7
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: MACROLIB '
     1  //'ADRESS NEEDED')
         IF(MEMADR(9).EQ.0) CALL XABORT('OPTADF: TRACKING '
     1  //'ADRESS NEEDED')
         CALL LCMGET(MEMADR(9),'TRACK-TYPE',SIGNA)
         WRITE(TXT12B,'(3A4)') (SIGNA(J),J=1,3)
         IF(TXT12B.NE.'TRIVAC') CALL XABORT('OPTADF: TRIVAC '
     1  //'TRACKING TYPE EXPECTED')
         CALL LCMGET(MEMADR(9),'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF(IDIM0.LT.4) IDIM=1
         IF((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         IR =TRKPRM(4)
         NEL=TRKPRM(1)
         NUN=TRKPRM(2)
         LL4=TRKPRM(11)
         CYLIND=.FALSE.
         IF((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL)
         CALL LCMGET(MEMADR(9),'VOLUME',RBASE(VOL))
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(MEMADR(9),'MATCOD',IBASE(MAT))
         CALL LCMLEN(MEMADR(9),'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
!         CALL SETARA(IBASE,7*NEL,KN)
         CALL LCMGET(MEMADR(9),'KN',IBASE(KN))
         CALL LCMGET(MEMADR(IADR),'STATE-VECTOR',MCRPRM)
!         WRITE (TXT12B,'(A5,I3,1H/,I3)') 'GROUP',1,NGRP
         NMIX = MCRPRM(2)
!         CALL LCMSIX(MEMADR(IADR),TXT12B,1)
!         CALL LCMLEN(MEMADR(IADR),TEXT12,NITMA,ITYP)
!         IF(NITMA.LT.IR) CALL XABORT('NITMA less than IR')
!         IR = NITMA
!         CALL LCMSIX(MEMADR(IADR),TXT12B,2)
         CALL SETARA(RBASE,NMIX,SIG)
         CALL SETARA(RBASE,NUN*NGRP,IVRLC(NVRLC))
         CALL XDRSET(RBASE(IVRLC(NVRLC)),NUN*NGRP,0.0)
         JPLIST=LCMGID(MEMADR(IADR),'GROUP')
         DO 15 I=1,NGRP
            KPLIST=LCMGIL(JPLIST,I)
            CALL LCMGET(KPLIST,TEXT12,RBASE(SIG))
            IF(LDUAL) THEN
               CALL SETARA(RBASE,NEL,IGAR)
               CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,NMIX,NEL,NUN,CYLIND,
     1                     RBASE(SIG),RBASE(VOL),IBASE(MAT),IBASE(KN),
     2                     RBASE(IVRLC(NVRLC)+(I-1)*NUN),RBASE(IGAR))
               CALL RLSARA(RBASE(IGAR))
            ELSE
               CALL XABORT('OPTADF: PRIMAL FINITE ELEMENTS NOT SUPPORT'
     1         //'ED.')
            ENDIF
   15    CONTINUE
         CALL RLSARA(RBASE(VOL))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(RBASE(SIG))
         RETURN
      ENDIF
      IF(TEXT12.EQ.'SCAT-0') THEN
         LTST=.TRUE.
         TEXT12='SCAT 0'
      ELSE IF(TEXT12.EQ.'SCAT-1') THEN
         LTST=.TRUE.
         TEXT12='SCAT 1'
      ENDIF
      IF(LTST) THEN
         IADR=7
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: OBJECT '
     1  //'ADRESS NEEDED')
         JPLIST=LCMGID(MEMADR(IADR),'GROUP')
         KPLIST=LCMGIL(JPLIST,1)
         CALL LCMLEN(KPLIST,'NTOT0',NITMA,ITYP)
         CALL SETARA(RBASE,NITMA*NGRP*NGRP,ISCAT)
         NSCAT=0
         DO 20 I=1,NGRP
            KPLIST=LCMGIL(JPLIST,I)
            CALL LCMLEN(KPLIST,TEXT12,NITMA,ITYP)
            CALL LCMGET(KPLIST,TEXT12,RBASE(ISCAT+NSCAT))
            NSCAT=NSCAT+NITMA
   20    CONTINUE
         CALL SETARA(RBASE,NSCAT,IVRLC(NVRLC))
         DO 25 I=0,NSCAT-1
   25    RBASE(IVRLC(NVRLC)+I)=RBASE(ISCAT+I)
         CALL RLSARA(RBASE(ISCAT))
         RETURN
      ENDIF
C---------------------------
* A*PHI ou B*PHI
      IF((TEXT12.EQ.'A*PHI').OR.(TEXT12.EQ.'B*PHI')) THEN
C         LTST=.TRUE.
C     L_FLUX, L_TRACK et L_SYSTEM sont fournis donc A*PHI et B*PHI
C       peuvent etre calcule directement
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN   =OPTPRI(19)
         CALL SETARA(RBASE,NGRP*NUN,IVRLC(NVRLC))
         IF(MEMADR(3)*MEMADR(4)*MEMADR(9).NE.0) THEN
            CALL LCMGET(MEMADR(4),'STATE-VECTOR',SYSPRM)
            LL4=SYSPRM(2)
            ITY=SYSPRM(4)
            CALL MTOPEN(0,MEMADR(9),LL4)
            CALL SETARA(RBASE,NUN,IFLUX)
            CALL SETARA(RBASE,NUN,IWORK)
            IF(TEXT12.EQ.'A*PHI') THEN
               OPTION=1
            ELSE
               OPTION=2
            ENDIF
            CALL OPTAFI(MEMADR(3),MEMADR(9),MEMADR(4),NUN,NGRP,LL4,ITY,
     1         OPTION,RBASE(IVRLC(NVRLC)),RBASE(IFLUX),RBASE(IWORK))
            CALL RLSARA(RBASE(IFLUX))
            CALL RLSARA(RBASE(IWORK))
            RETURN
         ENDIF
C      A*PHI ou B*PHI doivent etre precalcules
         CALL LCMSIX(MEMADR(6),'STEP       0',1)
         CALL LCMLEN(MEMADR(6),TEXT12,LENGT,ITYP)
         IF(LENGT.EQ.0) CALL XABORT('OPTADF: MAT*FLUX DO NOT EXIST')
         CALL LCMGET(MEMADR(6),TEXT12,RBASE(IVRLC(NVRLC)))
         CALL LCMSIX(MEMADR(6),' ',0)
         RETURN
      ENDIF
C---------------------------
* delta XS
      IF((TEXT12.EQ.'D-TOTAL')  .OR.(TEXT12.EQ.'D-CHI')    .OR.
     1    (TEXT12.EQ.'D-DIFFX')  .OR.(TEXT12.EQ.'D-DIFFY')  .OR.
     2    (TEXT12.EQ.'D-DIFFZ')  .OR.(TEXT12.EQ.'D-NUSIGF') .OR.
     3    (TEXT12.EQ.'D-NFTOT')  .OR.(TEXT12.EQ.'D-HFACT')  .OR.
     4    (TEXT12.EQ.'D-OVER')   .OR.(TEXT12.EQ.'D-SIGW0')  .OR.
     5    (TEXT12.EQ.'D-SIGW1')) THEN
C         LTST=.TRUE.
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN=OPTPRI(19)
         CALL SETARA(RBASE,NGRP*NUN,IVRLC(NVRLC))
         RETURN
      ENDIF
      IF((TEXT12.EQ.'D-SCAT0').OR.(TEXT12.EQ.'D-SCAT1')) THEN
         LTST=.TRUE.
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN=OPTPRI(19)
         CALL SETARA(RBASE,NGRP*NGRP*NUN,IVRLC(NVRLC))
         RETURN
      ENDIF
C---------------------------
* AP*PHI ou BP*PHI
      IF((TEXT12.EQ.'AP*PHI').OR.(TEXT12.EQ.'BP*PHI')) THEN
C         LTST=.TRUE.
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN=OPTPRI(19)
         CALL SETARA(RBASE,NGRP*NUN,IVRLC(NVRLC))
         RETURN
      ENDIF
C---------------------------
* Distribution du (burnup de sortie) ou (cout) des grappes
      IF((TEXT12.EQ.'BURN-E-DIST').OR.(TEXT12.EQ.'FUEL-C-DIST')) THEN
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN=OPTPRI(19)
         CALL SETARA(RBASE,NUN,IVRLC(NVRLC))
         CALL LCMGET(MEMADR(6),TEXT12,RBASE(IVRLC(NVRLC)))
         RETURN
      ENDIF
C---------------------------
* Derivee de la distribution du burnup de sortie des grappes
  180 IF(TEXT12.EQ.'D-BEDIST') THEN
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED')
         IF(MEMADR(2).EQ.0) CALL XABORT('OPTADF: L_MAP NEEDED (2)')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         CALL LCMGET (MEMADR(2),'STATE-VECTOR',RESPRM)
         NVAR=OPTPRI(1)
         NCHA=OPTPRI(17)
         NK =RESPRM(1)
         NBZ =RESPRM(3)
*volume consideration
         IF(MEMADR(9).EQ.0) CALL XABORT('OPTADF: TRACKING '
     1  //'ADRESS NEEDED')
         CALL LCMGET(MEMADR(9),'TRACK-TYPE',SIGNA)
         WRITE(TXT12B,'(3A4)') (SIGNA(J),J=1,3)
         IF(TXT12B.NE.'TRIVAC') CALL XABORT('OPTADF: TRIVAC '
     1  //'TRACKING TYPE EXPECTED')
         CALL LCMGET(MEMADR(9),'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF(IDIM0.LT.4) IDIM=1
         IF((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         IR =TRKPRM(4)
         NEL=TRKPRM(1)
         NUN=TRKPRM(2)
         LL4=TRKPRM(11)
         CYLIND=.FALSE.
         IF((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL)
         CALL XDRSET(RBASE(VOL),NEL,1.0)
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(MEMADR(9),'MATCOD',IBASE(MAT))
         CALL LCMLEN(MEMADR(9),'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
         CALL LCMGET(MEMADR(9),'KN',IBASE(KN))
*        allouer l'espace pour le vecteur
         CALL SETARA(RBASE,NUN,IVRLC(NVRLC))
         CALL XDRSET(RBASE(IVRLC(NVRLC)),NUN,0.0)
         CALL SETARA(RBASE,IR,BDIST)
*        aller chercher les valeurs de burnup moyen de sortie
         CALL SETARA(IBASE,NVAR,VARTYP)
         CALL LCMGET(MEMADR(6),'VAR-TYPE',IBASE(VARTYP))
         CALL SETARA(RBASE,NBZ,BZV)
         CALL LCMGET(MEMADR(2),'BURN-AVG',RBASE(BZV))
*        corriger si le repertoire L_OPTIMIZE/BKP-VALUE est non vide
*         au quel cas une des valeurs de burnup moyen de sortie peut
*         avoir ete modifiee
         CALL LCMLEN(MEMADR(6),'BKP-VALUE',LENGT,ITYP)
         IF(LENGT.EQ.-1) THEN
            CALL LCMSIX(MEMADR(6),'BKP-VALUE',1)
            CALL LCMLEN(MEMADR(6),'VAR-VALUE',LENGT,ITYP)
            IF(LENGT.NE.0) THEN
               CALL SETARA(RBASE,NVAR,VARBKP)
               CALL LCMGET(MEMADR(6),'VAR-VALUE',RBASE(VARBKP))
               DO 185 I=0,NVAR-1
                  IF((IBASE(VARTYP+I)/1000).EQ.1)
     1               RBASE(BZV-1+IBASE(VARTYP+I)-1000)=RBASE(VARBKP+I)
  185          CONTINUE
               CALL RLSARA(RBASE(VARBKP))
            ENDIF
            CALL LCMSIX(MEMADR(6),' ',2)
         ENDIF
         CALL SETARA(IBASE,NCHA,IBZ)
         CALL LCMGET(MEMADR(2),'B-ZONE',IBASE(IBZ))
         CALL LCMLEN(MEMADR(8),'MAT',LENGT,ITYP)
         CALL SETARA(IBASE,LENGT,MIX)
         CALL LCMGET(MEMADR(8),'MAT',IBASE(MIX))
*    calcul de la distribution de DB (Nr)
*     DB=B*EPS
  181    IF(OPTPRI(10).EQ.1) THEN
            CALL LCMGET(MEMADR(6),'OPT-PARAM-R',OPTPRR)
            EPS=OPTPRR(7)
            I1=0
            DO 190 J=0,NEL-1
               IF(IBASE(MIX+J).NE.0) THEN
                  IF(IBASE(MIX+J).GT.0) THEN
                     RBASE(BDIST+I1)=0.0
                  ELSE
                     ICHA=-IBASE(MIX+J)+(IBASE(MIX+J)/NCHA)*NCHA
                     IF(ICHA.EQ.0) ICHA=NCHA
                     RBASE(BDIST+I1)=
     1                 RBASE(BZV-1+IBASE(IBZ+ICHA-1))*EPS
                  ENDIF
                  I1=I1+1
               ENDIF
  190       CONTINUE
*      DB= Bk-Bk-1
         ELSE IF(OPTPRI(10).EQ.2) THEN
            CALL LCMLEN(MEMADR(6),'OLD-VALUE',LENGT,ITYP)
            IF(LENGT.EQ.0) THEN
               OPTPRI(10)=1
               GOTO 181
            ENDIF
            CALL LCMSIX(MEMADR(6),'OLD-VALUE',1)
            CALL SETARA(RBASE,NVAR,OLDVAR)
            CALL LCMGET(MEMADR(6),'VAR-VALUE',RBASE(OLDVAR))
            CALL LCMSIX(MEMADR(6),' ',0)
            CALL SETARA(RBASE,NBZ,BZVOLD)
*           initilisation de Bk-1
            DO 192 I=0,NBZ-1
  192       RBASE(BZVOLD+I)=RBASE(BZV+I)
*           mise a jour de Bk-1
            DO 195 I=0,NVAR-1
               IF((IBASE(VARTYP+I)/1000).EQ.1)
     1         RBASE(BZVOLD-1+IBASE(VARTYP+I)-1000)=RBASE(OLDVAR+I)
  195       CONTINUE
*           calcul de la distribution
            I1=0
            DO 200 J=0,NEL-1
               IF(IBASE(MIX+J).NE.0) THEN
                  IF(IBASE(MIX+J).GT.0) THEN
                     RBASE(BDIST+I1)=0.0
                  ELSE
                     ICHA=-IBASE(MIX+J)+(IBASE(MIX+J)/NCHA)*NCHA
                     IF(ICHA.EQ.0) ICHA=NCHA
                     RBASE(BDIST+I1)=
     1                 RBASE(BZV-1+IBASE(IBZ+ICHA-1))
     2                -RBASE(BZVOLD-1+IBASE(IBZ+ICHA-1))
                  ENDIF
                  I1=I1+1
               ENDIF
  200          CONTINUE
            CALL RLSARA(RBASE(BZVOLD))
            CALL RLSARA(RBASE(OLDVAR))
         ENDIF
* DB(Nr) -> DB(NUN)
         IF(LDUAL) THEN
            CALL SETARA(RBASE,NEL,IGAR)
            CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1                  RBASE(BDIST),RBASE(VOL),IBASE(MAT),IBASE(KN),
     2                  RBASE(IVRLC(NVRLC)),RBASE(IGAR))
            CALL RLSARA(RBASE(IGAR))
         ELSE
            CALL XABORT('OPTADF: PRIMAL FINITE ELEMENTS NOT SUPPORTED')
         ENDIF
         IF(I1.NE.IR) CALL XABORT('OPTADF: WRONG'
     1  //' NUMBER OF INDEX IN D-BEDIST DEFINITION(2)')
         CALL RLSARA(RBASE(VOL))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(RBASE(BDIST))
         CALL RLSARA(IBASE(MIX))
         CALL RLSARA(IBASE(VARTYP))
         CALL RLSARA(RBASE(BZV))
         CALL RLSARA(IBASE(IBZ))
         RETURN
      ENDIF
C---------------------------
* Derivee de la distribution du cout des grappes
      IF(TEXT12.EQ.'D-FCDIST') THEN
         IF(MEMADR(6).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE NEEDED(3)')
         IF(MEMADR(2).EQ.0) CALL XABORT('OPTADF: L_MAP NEEDED (3)')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         CALL LCMGET (MEMADR(2),'STATE-VECTOR',RESPRM)
         NVAR=OPTPRI(1)
         NUN =OPTPRI(19)
         NCHA=OPTPRI(17)
         NEZ =RESPRM(7)
         FCD =OPTPRI(11)
*        allouer l'espace pour le vecteur
         CALL SETARA(RBASE,NUN,IVRLC(NVRLC))
         CALL XDRSET(RBASE(IVRLC(NVRLC)),NUN,0.0)
         CALL LCMLEN(MEMADR(6),'FUEL-COST',LENGT,ITYP)
         IF(LENGT.EQ.0) CALL XABORT('OPTADF: NO FUEL-COST DEFINED')
         CALL SETARA(RBASE,LENGT,IDATA)
         CALL LCMGET(MEMADR(6),'FUEL-COST',RBASE(IDATA))
*        enrichissement fixe
  201    IF(FCD.EQ.2) THEN
            CALL RLSARA(RBASE(IDATA))
            RETURN
         ENDIF
*        sinon enrichissement variable: 3 etapes
*        ETAPE 1: initialisation
         EPSU=0.007200 ! atomic fraction , 0.007110 = weight fraction
         EPSW=RBASE(IDATA)
         CUNT=RBASE(IDATA+1)
         CSEP=RBASE(IDATA+2)
         CFAB=RBASE(IDATA+3)
         INTR=1+RBASE(IDATA+4)
         TOBT=RBASE(IDATA+5)
         TENR=RBASE(IDATA+6)
         CALL RLSARA(RBASE(IDATA))
         IF(MEMADR(2).EQ.0) CALL XABORT('OPTADF: L_MAP NEEDED (2)')
         CALL SETARA(RBASE,NEZ,EZV)
         JPMAP=LCMGID(MEMADR(2),'FUEL')
         DO I=1,NEZ
            KPMAP=LCMGIL(JPMAP,I)
            CALL LCMGET(KPMAP,'ENRICH',RBASE(EZV+I-1))
         ENDDO
         CALL SETARA(RBASE,NEZ,IFCV)
*        ETAPE 2:
*          DCu =Cu(enr_perturbe)-Cu(enr)
*          etape 2a : (enr_perturbe)1..NEZ
*          etape 2b : Cu(enr_perturbe)1..NEZ
*     Ep=E(1+EPS)
         IF(OPTPRI(10).EQ.1) THEN
            CALL LCMGET(MEMADR(6),'OPT-PARAM-R',OPTPRR)
            EPSP=OPTPRR(7)
            DO 230 I=0,NEZ-1
*              E
               EPS=RBASE(EZV+I)
*              Cu(E)
               RBASE(IFCV+I)=CUNT*(EPS-EPSW)/(EPSU-EPSW)*INTR**TENR
     1     +CSEP*INTR**TENR*((2*EPS-1)*ALOG(EPS/(1-EPS))
     2          +(EPS-EPSU)/(EPSU-EPSW)*(2*EPSW-1)*ALOG(EPSW/(1-EPSW))
     3          -(EPS-EPSW)/(EPSU-EPSW)*(2*EPSU-1)*ALOG(EPSU/(1-EPSU)))
     4     +CFAB
*              Ep
               EPS=RBASE(EZV+I)*(1+EPSP)
*              Cu(Ep)-Cu(E)
  230           RBASE(IFCV+I)=CUNT*(EPS-EPSW)/(EPSU-EPSW)*INTR**TENR
     1     +CSEP*INTR**TENR*((2*EPS-1)*ALOG(EPS/(1-EPS))
     2          +(EPS-EPSU)/(EPSU-EPSW)*(2*EPSW-1)*ALOG(EPSW/(1-EPSW))
     3          -(EPS-EPSW)/(EPSU-EPSW)*(2*EPSU-1)*ALOG(EPSU/(1-EPSU)))
     4     +CFAB - RBASE(IFCV+I)
*      DCu= Cu(Ek)-Cu(Ek-1), Ep=Ek-1
         ELSE IF(OPTPRI(10).EQ.2) THEN
            CALL LCMLEN(MEMADR(6),'OLD-VALUE',LENGT,ITYP)
            IF(LENGT.EQ.0) THEN
               OPTPRI(10)=1
               GOTO 201
            ENDIF
            CALL LCMSIX(MEMADR(6),'OLD-VALUE',1)
            CALL SETARA(RBASE,NVAR,OLDVAR)
            CALL LCMGET(MEMADR(6),'VAR-VALUE',RBASE(OLDVAR))
            CALL LCMSIX(MEMADR(6),' ',0)
            CALL SETARA(IBASE,NVAR,VARTYP)
            CALL LCMGET(MEMADR(6),'VAR-TYPE',IBASE(VARTYP))
*           initilisation de Ek-1
            CALL SETARA(RBASE,NEZ,EZVOLD)
            DO 242 I=0,NEZ-1
  242       RBASE(EZVOLD+I)=RBASE(EZV+I)
*           mise a jour de Ek-1
            DO 245 I=0,NVAR-1
               IF((IBASE(VARTYP+I)/1000).EQ.2)
     1       RBASE(EZVOLD-1+IBASE(VARTYP+I)-2000)=RBASE(OLDVAR+I)
  245          CONTINUE
            DO 250 I=0,NEZ-1
               EPS=RBASE(EZV+I)
               RBASE(IFCV+I)=CUNT*(EPS-EPSW)/(EPSU-EPSW)*INTR**TENR
     1     +CSEP*INTR**TENR*((2*EPS-1)*ALOG(EPS/(1-EPS))
     2          +(EPS-EPSU)/(EPSU-EPSW)*(2*EPSW-1)*ALOG(EPSW/(1-EPSW))
     3          -(EPS-EPSW)/(EPSU-EPSW)*(2*EPSU-1)*ALOG(EPSU/(1-EPSU)))
     4     +CFAB
               EPS=RBASE(EZVOLD+I)
  250          RBASE(IFCV+I)=CUNT*(EPS-EPSW)/(EPSU-EPSW)*INTR**TENR
     1     +CSEP*INTR**TENR*((2*EPS-1)*ALOG(EPS/(1-EPS))
     2          +(EPS-EPSU)/(EPSU-EPSW)*(2*EPSW-1)*ALOG(EPSW/(1-EPSW))
     3          -(EPS-EPSW)/(EPSU-EPSW)*(2*EPSU-1)*ALOG(EPSU/(1-EPSU)))
     4     +CFAB - RBASE(IFCV+I)
            CALL RLSARA(IBASE(VARTYP))
            CALL RLSARA(RBASE(EZVOLD))
            CALL RLSARA(RBASE(OLDVAR))
         ENDIF
         CALL RLSARA(RBASE(EZV))
*        ETAPE 3: calcul de la distribution
* volume consideration
         IF(MEMADR(9).EQ.0) CALL XABORT('OPTADF: TRACKING '
     1  //'ADRESS NEEDED')
         CALL LCMGET(MEMADR(9),'TRACK-TYPE',SIGNA)
         WRITE(TXT12B,'(3A4)') (SIGNA(J),J=1,3)
         IF(TXT12B.NE.'TRIVAC') CALL XABORT('OPTADF: TRIVAC '
     1  //'TRACKING TYPE EXPECTED')
         CALL LCMGET(MEMADR(9),'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF(IDIM0.LT.4) IDIM=1
         IF((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         IR =TRKPRM(4)
         NEL=TRKPRM(1)
         NUN=TRKPRM(2)
         LL4=TRKPRM(11)
         CYLIND=.FALSE.
         IF((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL)
         CALL XDRSET(RBASE(VOL),NEL,1.0)
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(MEMADR(9),'MATCOD',IBASE(MAT))
         CALL LCMLEN(MEMADR(9),'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
         CALL LCMGET(MEMADR(9),'KN',IBASE(KN))
*        allouer l'espace pour le vecteur
         CALL SETARA(RBASE,IR,CDIST)
         CALL LCMLEN(MEMADR(8),'MAT',LENGT,ITYP)
         CALL SETARA(IBASE,LENGT,MIX)
         CALL LCMGET(MEMADR(8),'MAT',IBASE(MIX))
         CALL SETARA(IBASE,NCHA*NK,IEZ)
         CALL LCMGET(MEMADR(2),'FLMIX',IBASE(IEZ))
*         etape3a : DCu(NEL)
            I1=0
            DO 270 J=0,NEL-1
               IF(IBASE(MIX+J).NE.0) THEN
                  IF(IBASE(MIX+J).GT.0) THEN
                     RBASE(CDIST+I1)=0.0
                  ELSE
                     ICHA=-IBASE(MIX+J)+(IBASE(MIX+J)/NCHA)*NCHA
                     IF(ICHA.EQ.0) ICHA=NCHA
                     RBASE(CDIST+I1)=
     1                 RBASE(IFCV-1+IBASE(IEZ+ICHA-1))
                  ENDIF
                  I1=I1+1
               ENDIF
  270          CONTINUE
         IF(I1.NE.IR) CALL XABORT('OPTADF: WRONG'
     1  //' NUMBER OF INDEX IN D-BEDIST DEFINITION(2)')
C         CALL RLSARA(IBASE(IFCVP))
         CALL RLSARA(IBASE(IFCV))
         CALL RLSARA(IBASE(MIX))
         CALL RLSARA(IBASE(IEZ))
*         etape3b : DCu(Nr) -> DCu(NUN)
         IF(LDUAL) THEN
           CALL SETARA(RBASE,NEL,IGAR)
           CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1                 RBASE(CDIST),RBASE(VOL),IBASE(MAT),IBASE(KN),
     2                 RBASE(IVRLC(NVRLC)),RBASE(IGAR))
           CALL RLSARA(RBASE(IGAR))
         ELSE
           CALL XABORT('OPTADF: PRIMAL FINITE ELEMENTS NOT IMPLEMENTED')
         ENDIF
         IF(I1.NE.IR) CALL XABORT('OPTADF: WRONG'
     1  //' NUMBER OF INDEX IN D-BEDIST DEFINITION(2)')
         CALL RLSARA(RBASE(VOL))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(RBASE(CDIST))
         RETURN
      ENDIF
C---------------------------
* charger un vecteur niveau 1 cas special de FUNCVALUE et FUNCZVOL
*               et GRADVALUE
      IF(TEXT12.EQ.'FUNCVALUE') THEN
         IADR=6
         LTST=.TRUE.
         TEXT12='FOBJ-CST-VAL'
      ELSE IF(TEXT12.EQ.'FUNCZVOL') THEN
         IADR=6
         LTST=.TRUE.
         TEXT12='FUNC-ZON-VOL'
      ELSE IF(TEXT12.EQ.'GRADVALUE') THEN
         IADR=6
         LTST=.TRUE.
         TEXT12='GRADIENT'
      ENDIF
      IF(LTST) THEN
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE '
     1  //'OBJECT ADRESS NEEDED')
         CALL LCMLEN(MEMADR(IADR),TEXT12,NITMA,ITYP)
         IF(NITMA.EQ.0) CALL XABORT('OPTAVF: FUNCTION VALUE or  '
     1  //'VOLUME or GRADIENT NOT CALCULATED')
         CALL SETARA(RBASE,NITMA,IVRLC(NVRLC))
         CALL LCMGET(MEMADR(IADR),TEXT12,RBASE(IVRLC(NVRLC)))
         RETURN
      ENDIF
C---------------------------
* charger un vecteur niveau 1 cas special de FUNCVALUE et FUNCZVOL
*               et GRADVALUE
      IF(TEXT12.EQ.'GRADVALUE(X)') THEN
         IADR=6
         LTST=.TRUE.
         TEXT12='GRADIENT'
         CALL LCMGET(MEMADR(IADR),'STATE-VECTOR',OPTPRI)
         NVAR=OPTPRI(1)
         NCST=OPTPRI(2)
      ENDIF
      IF(LTST) THEN
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE '
     1  //'OBJECT ADRESS NEEDED')
         CALL LCMLEN(MEMADR(IADR),TEXT12,NITMA,ITYP)
         IF(NITMA.EQ.0) CALL XABORT('OPTAVF: GRADIENT NOT CALCULATED')
         CALL SETARA(RBASE,NCST+1,IVRLC(NVRLC))
         RETURN
      ENDIF
C---------------------------
* charger la valeur de keff ou keff,v
      IF(TEXT12.EQ.'KEFF') THEN
         IADR=3
         LTST=.TRUE.
      ELSE IF(TEXT12.EQ.'KEFF-VOID') THEN
         IADR=13
         LTST=.TRUE.
      ENDIF
      IF(LTST) THEN
         TEXT12='K-EFFECTIVE'
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: L_FLUX '
     1  //'OBJECT ADRESS NEEDED')
         CALL SETARA(RBASE,1,IVRLC(NVRLC))
         CALL LCMGET(MEMADR(IADR),TEXT12,RBASE(IVRLC(NVRLC)))
         RETURN
      ENDIF
C---------------------------
* charger un vecteur niveau 1 cas special de D-LAMBDA ou D-LAMBDA-V
      IF((TEXT12.EQ.'D-LAMBDA').OR.(TEXT12.EQ.'D-LAMBDA-V')) THEN
         IADR=6
         LTST=.TRUE.
      ENDIF
      IF(LTST) THEN
         IF(MEMADR(IADR).EQ.0) CALL XABORT('OPTADF: L_OPTIMIZE '
     1  //'OBJECT ADRESS NEEDED')
         CALL LCMLEN(MEMADR(IADR),TEXT12,NITMA,ITYP)
         IF(NITMA.EQ.0) CALL XABORT('OPTAVF: GRADIENT OF EIGENVALUE'
     1  //' NOT CALCULATED')
         CALL SETARA(RBASE,1,IVRLC(NVRLC))
         RETURN
      ENDIF
C---------------------------
* mauvais nom de variable predefinie
      WRITE(6,*) 'NAME=',TEXT12
      CALL XABORT('OPTADF: WRONG NAME FOR PREDENINED LOCAL ARRAY')
C---------------------------
C END
C---------------------------
      END
