*DECK OPTCSH                                                                    
      SUBROUTINE OPTCSH(N,X,Y,YD,WK,GRAD)                                               
*                                                                      *        
*----------------------------------------------------------------------*        
*                                                                      *        
*Purpose:
* this subroutine computes the numerical derivate of a table of 
*   ordinates using the Ceschino method (order 4).
* OPTCSH = OPTimization CeScHino
*        *******************************************************       *        
*        *  DERIVATION NUMERIQUE D'UNE TABLE D'ORDONNEES PAR   *       *        
*        *         LA METHODE DE CESCHINO ( ORDRE 4 )          *       *        
*        *******************************************************       *        
*                                                                      *        
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): OPTEX
*  Modified : R. Chambon
*
*Parameters: input/ouput
*  N
*  X
*  Y
*  YD
*  WK
*  GRAD
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
	  INTEGER N
      REAL Y(*),GRAD                                                   
      DIMENSION  X(*),WK(2,*)                                                   
      DOUBLE PRECISION YD(*)                                                     
*----
*  LOCAL VARIABLES
*----
*
      DO 1 I=1,N
    1    YD(I)=DBLE(Y(I))
*
      IF (N.EQ.2) GOTO 40                                                       
      HP   = 1.0/(X(2)-X(1))                                                    
      WK(1,1) = HP                                                              
      WK(2,1) = HP                                                              
      YDLAST = YD(1)                                                              
      YD(1)  = 2.0*HP*HP*(YD(2)-YD(1))                                             
      NM1   = N-1                                                               
*                                                                               
      DO 10 I=2,NM1                                                             
         HM  = HP                                                               
         HP  = 1.0/(X(I+1)-X(I))                                                
         WK(1,I) = 2.0*(HM+HP)                                                  
         WK(2,I) = HP                                                           
         PMX  = 3.0*(HM*HM*(YD(I)-YDLAST)+HP*HP*(YD(I+1)-YD(I)))                    
         YDLAST= YD(I)                                                            
         YD(I) = PMX                                                             
   10 CONTINUE                                                                  
*                                                                               
      HM   = HP                                                                 
      WK(1,N)= HM                                                               
      WK(2,N)= HM                                                               
      YD(N) = 2.0*HM*HM*(YD(N)-YDLAST)                                             
*                                                                               
*---- RESOLUTION DU SYSTEME MATRICIEL                                           
*                                                                               
      PMX  = WK(1,1)                                                            
      YD(1) = YD(1)/PMX                                                           
*                                                                               
      DO 20 I=2,N                                                               
         GAR = WK(2,I-1)                                                        
         WK(2,I-1) = WK(2,I-1)/PMX                                              
         PMX = WK(1,I)-GAR*WK(2,I-1)                                            
         YD(I)= (YD(I)-GAR*YD(I-1))/PMX                                            
   20 CONTINUE                                                                  
*                                                                               
*---- SUBSTITUTION ARRIERE                                                      
*                                                                               
      DO 30 I1=2,N                                                              
         I = N-I1+1                                                             
         YD(I) = YD(I)-WK(2,I)*YD(I+1)                                             
   30 CONTINUE                                                                  
      GOTO  50                                                                  
*                                                                               
   40 CONTINUE
      YD(1) = (YD(2)-YD(1))/(X(2)-X(1))                                            
      YD(2) = YD(1)      
*                                                                               
   50 CONTINUE
      GRAD = REAL(YD(1))
      RETURN                                                                    
      END                                                                       
