*DECK OPTEVL
      SUBROUTINE OPTEVL(MEMADR,VRLCMX,IVRLC,TVRLC,LVRLC,NLVL1,NLVL2,
     1 STFCN,VTFCN,RTFCN,OTFCN,FVALUE,LGDATA,TXTPDF)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine computes functions (integral and numerical)
* OPTEVL : OPTimization - EVaLuation of the functions
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
*  MEMADR : adress memory of lcm objects (cf OPTVDF.f)
*  VRLCMX : number of local module variables 
*            (cf. FOBJCT.f & SGAGRD.f)
*  IVRLC  : offset pour les variables locales
*  TVRLC  : noms des variables locales
*  LVRLC  : existance des variables locales
*  STFCN  : sequence des tableaux a lire
*           1 pour VTFCN
*           2 pour RTFCN
*           3 pour OTFCN
*           4 pour VTFCN (to update)
*  VTFCN  : numero des variables locales utilisees
*  RTFCN  : reels utilises
*  OTFCN  : noms des operateurs (numeriques et integraux)
*  NLVL1  : number maximum of operation in one sequence level 1
*  NLVL2  : number maximum of integral in one function
*
*Parameters: ouput
*  FVALUE : valeur du vecteur a calculer
*  LGDATA : longueur du vecteur a calculer
*                          
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER   VRLCMX,NLVL1,NLVL2,LGDATA,MEMADR(20)
      INTEGER   IVRLC(VRLCMX),STFCN(NLVL1,2*NLVL2+1),
     1          VTFCN(NLVL1,2*NLVL2+1)
      REAL      RTFCN(NLVL1,2*NLVL2+1),FVALUE(LGDATA)
      LOGICAL   LVRLC(VRLCMX)
      CHARACTER TVRLC(VRLCMX)*12,OTFCN(NLVL1,2*NLVL2+1)*12,TXTPDF*12
*----
*  LOCAL VARIABLES
*----
      CHARACTER TEXT12*12,TYPVOL*12
      REAL      STACK(NLVL1,3)
      DOUBLE PRECISION INTVAL,ENEVAL
      INTEGER   I,J,K,ISTACK(3),LVL,COL,LINE,LINE1,LINE2,ITFVOL,LVLINT,
     1          GRPTO,GRPFRM
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   OPTPRI(NSTATE),TRKPRM(NSTATE)
      REAL      OPTPRR(NSTATE)
* for volume definition
      INTEGER NINT,ITYP,ICHA,CSTTYP,ITFVL1,VARTYP,NVAR,TYPEC,
     1        POS(2),NCST,LENGT,I1,CSTVOL,CSTCOR,MIX,NGRP,IGR,NUN,
     2        IOFSET,ITFVL2,ITFVL3,CHACST,CHACOR,CHAREA,CORVOL,
     3        REAVOL,VARVOL,CHADIS,CHAVAR,NCHA,NBUN,FCD
      LOGICAL LTST,LTST1,LTST2,LTST3
*Volume considerations
      INTEGER   IELEM,ICHX,IDIM0,IDIM,IR,MAXKN,NEL,LL4,VOL1,KN,MAT,IGAR,
     1          NMIX,EXNMIX
      LOGICAL   LDUAL,CYLIND
      CHARACTER TXTINT*12

* Predefined functions
      INTEGER   IVAR1,IVAR2,IVAR3,IVAR4,IVAR5,IVAR6,IVAR7,IFCT1,IFCT2,N,
     1          TYPVAR
      REAL      IHFLU,FVAL,FVOL,CVOL
      DOUBLE PRECISION FACT1,FACT2,FACT3,FACT4

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

      CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
      NVAR=OPTPRI(1)
      NCST=OPTPRI(2)
      FCD =OPTPRI(11)
      NMIX=OPTPRI(16)
      NCHA=OPTPRI(17)
      NBUN=OPTPRI(18)
      NINT=OPTPRI(17)*OPTPRI(18)
      NUN =MAX(OPTPRI(19),1)
      NGRP=OPTPRI(20)
* first object of the stack is not used for calculations, but need to 
*   be defined because the subroutine that do the calcultion needs 
*   ISTACK and ISTACK-1
      STACK(1,1)=0.0
      STACK(2,1)=0.0
      STACK(3,1)=0.0
C if LDATA > 1, then the calculation correspond to the adjoint source
C   then we need to define the volume where the constraint is applied
C   #CST = VTFCN(1,1)
      IF ((LGDATA.GT.1).OR.(TXTPDF.NE.'FUNCTION')) THEN
         LTST1=.FALSE.
         LTST2=.FALSE.
         LTST3=.FALSE.
*   PRECALCULER LES VOLUMES CORRESPONDANT A CHAQUE INCONNUE (NUN) 
*       POUR CHAQUE REGION DU reacteur, coeur et zone
*   allouer l'espace memoire
*    REAVOL: chaque region du reacteur
*    CORVOL: chaque region du coeur
*    CSTVOL: chaque region de la zone de controle
         CALL SETARA(RBASE,NUN,REAVOL)
         CALL SETARA(RBASE,NUN,CORVOL)
         CALL SETARA(RBASE,NUN,CSTVOL)
         CALL SETARA(RBASE,NUN,VARVOL)
         IF ((TXTPDF.EQ.'D-LAMBDA') .OR.
     1       (TXTPDF.EQ.'KEFF')     .OR.
     1       (TXTPDF.EQ.'D-KEFF')   .OR.
     1       (TXTPDF.EQ.'KEFF=KREF').OR.
     1       (TXTPDF.EQ.'D-KEFF=KREF')  .OR.
     1       (TXTPDF.EQ.'MINPCMAX')     .OR.
     1       (TXTPDF.EQ.'D-MINPCMAX')   .OR.
     1       (TXTPDF.EQ.'VOID-REAC-FC') .OR.
     1       (TXTPDF.EQ.'D-VOID-R-FC')) GO TO 2000
         CALL XDRSET(RBASE(REAVOL),NUN,0.0)
         CALL XDRSET(RBASE(CORVOL),NUN,0.0)
         CALL XDRSET(RBASE(CSTVOL),NUN,0.0)
         CALL XDRSET(RBASE(VARVOL),NUN,0.0)
*   charger les vecteurs necessaires a la transformation
*      NCHA*NGRP -> NMIX -> NUN
*                   CHAREA  REAVOL
*                   CHACOR  CORVOL
*       CSTCOR      CHACST  CSTVOL
*       IBASE()     RBASE() RBASE()
********************
         CALL SETARA(RBASE,NMIX,CHAREA)
         CALL SETARA(RBASE,NMIX,CHACOR)
         CALL SETARA(RBASE,NMIX,CHACST)
         CALL SETARA(RBASE,NMIX,CHAVAR)
         CALL XDRSET(RBASE(CHAREA),NMIX,0.0)
         CALL XDRSET(RBASE(CHACOR),NMIX,0.0)
         CALL XDRSET(RBASE(CHACST),NMIX,0.0)
         CALL XDRSET(RBASE(CHAVAR),NMIX,0.0)
*        INDEX
         CALL LCMLEN(MEMADR(8),'MAT',EXNMIX,ITYP)
         CALL SETARA(IBASE,EXNMIX,MIX)
         CALL LCMGET(MEMADR(8),'MAT',IBASE(MIX))
*   NMIX fois 0.0 ou 1.0 (pour le volume)
*        TRACKING
         CALL LCMGET(MEMADR(9),'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF (IDIM0.LT.4) IDIM=1
         IF ((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF ((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         NEL  =TRKPRM(1)
         LL4  =TRKPRM(11)
         CYLIND=.FALSE.
         IF ((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL1)
         CALL XDRSET(RBASE(VOL1),NEL,1.0)
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(MEMADR(9),'MATCOD',IBASE(MAT))
         CALL LCMLEN(MEMADR(9),'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
         CALL LCMGET(MEMADR(9),'KN',IBASE(KN))
*     pour le reacteur entier (option: DISCRETE-ALL)
         CALL XDRSET(RBASE(CHAREA),NMIX,1.0)
*     pour tous les canaux    (option: DISCRETE-COR)
*        NCH*NBUND-> NMIX
         I=0
         DO 9 J=0,EXNMIX-1
            IF (IBASE(MIX+J).NE.0) THEN
               IF (IBASE(MIX+J).GT.0) THEN
                  RBASE(CHACOR+I)=0.0
               ELSE
                  RBASE(CHACOR+I)=1.0
               ENDIF
               I=I+1
            ENDIF
    9          CONTINUE
         IF (I.NE.NMIX) CALL XABORT('OPTEVL: WRONG NUMBER '
     1  //'OF INDEX IN CSTVOL DEFINITION(1)')
*    rem: pour les contraintes : 1 vecteur indice en plus ZONE
*         pour la fonction objectif (IFCN=0): 
*           2 vecteurs indices possibles ALL ou CORE seulement
         IF (VTFCN(1,1).EQ.0)  GO TO 91
*    pour les contraintes     (option: DISCRETE-CST)
         LTST1=.TRUE.
         WRITE(TEXT12,'(A8,I4.4)') 'CST-ZONE',VTFCN(1,1)
         CALL LCMLEN(MEMADR(6),TEXT12,LENGT,ITYP)
         LTST=(LENGT.EQ.0)
         IF (LTST) THEN
            WRITE(6,*) ('OPTEVL: NO ZONE VOLUME DEFINED '
     1      //'FOR THIS CONSTRAINT')
            GO TO 91
         ENDIF
         CALL SETARA(IBASE,NINT,CSTCOR)
         CALL SETARA(IBASE,NCST,CSTTYP)
         CALL LCMGET(MEMADR(6),'CST-VOL-TYPE',IBASE(CSTTYP))
         TYPEC=IBASE(CSTTYP+VTFCN(1,1)-1)
         IF (TYPEC.EQ.1) THEN
            CALL XDRSET(RBASE(CHACST),NMIX,1.0)
         ELSEIF (TYPEC.EQ.2) THEN
            DO 31 I=0,NMIX-1
   31          RBASE(CHACST+I)=RBASE(CHACOR+I)
         ELSEIF (TYPEC.EQ.3) THEN
            CALL LCMGET(MEMADR(6),TEXT12,ICHA)
            CALL XDISET(IBASE(CSTCOR),NINT,0)
            DO 32 J=0,NBUN-1
   32          IBASE(CSTCOR+ICHA-1+J*NCHA)=1
         ELSEIF (TYPEC.EQ.4) THEN
            CALL LCMGET(MEMADR(6),TEXT12,POS)
            CALL XDISET(IBASE(CSTCOR),NINT,0)
            IBASE(CSTCOR+POS(1)-1+(POS(2)-1)*NCHA)=1
         ELSEIF (TYPEC.EQ.5) THEN
            CALL LCMGET(MEMADR(6),TEXT12,IBASE(CSTCOR))
         ENDIF
*        NCH*NBUND->NMIXT
         IF (TYPEC.GT.2) THEN
            I=0
            DO 90 J=0,EXNMIX-1
               IF (IBASE(MIX+J).NE.0) THEN
                  IF (IBASE(MIX+J).GT.0) THEN
                     RBASE(CHACST+I)=0.0
                  ELSE
                     RBASE(CHACST+I)=
     1                    REAL(IBASE(CSTCOR-IBASE(MIX+J)-1))
                  ENDIF
                  I=I+1
               ENDIF
   90          CONTINUE
            IF (I.NE.NMIX) CALL XABORT('OPTEVL: WRONG NUMBER '
     1  //'OF INDEX IN CSTVOL DEFINITION (2)')
         ENDIF
         CALL RLSARA(IBASE(CSTTYP))
         CALL RLSARA(IBASE(CSTCOR))
*   pour les variables
   91    IF (STFCN(1,1).NE.0) THEN
            LTST2=.TRUE.
            CALL SETARA(IBASE,NINT,ITFVL1)
            CALL SETARA(IBASE,NVAR,VARTYP)
            WRITE(TEXT12,'(A8,I4.4)') 'VAR-ZONE',STFCN(1,1)
            CALL LCMLEN(MEMADR(6),TEXT12,LENGT,ITYP)
            IF (LENGT.EQ.0) CALL XABORT('OPTEVL: NO ZONE DEFINED '
     1  //'FOR THIS VARIABLE')
            CALL LCMGET(MEMADR(6),'VAR-TYPE',IBASE(VARTYP))
*     NCHA 0/1 dans le record
            IF ((IBASE(VARTYP+STFCN(1,1)-1)/1000).LE.3) THEN
               CALL SETARA(IBASE,NCHA,ICHA)
               CALL LCMGET(MEMADR(6),TEXT12,IBASE(ICHA))
               DO 92 K=0,NCHA-1
                  DO 92 J=0,NBUN-1
   92             IBASE(ITFVL1+K+J*NCHA)=IBASE(ICHA+K)
               CALL RLSARA(IBASE(ICHA))
            ELSE
*     NCHA*NBUND 0/1 dans le record
               CALL LCMGET(MEMADR(6),TEXT12,IBASE(ITFVL1))
            ENDIF
            TYPVAR=IBASE(VARTYP+STFCN(1,1)-1)/1000
*        NCH*NBUND->NMIXT
            I=0
            DO 93 J=0,EXNMIX-1
               IF (IBASE(MIX+J).NE.0) THEN
                  IF (IBASE(MIX+J).GT.0) THEN
                     RBASE(CHAVAR+I)=0.0
                  ELSE
                     RBASE(CHAVAR+I)=
     1                    REAL(IBASE(ITFVL1-IBASE(MIX+J)-1))
                  ENDIF
                  I=I+1
               ENDIF
   93          CONTINUE
            IF (I.NE.NMIX) CALL XABORT('OPTEVL: WRONG NUMBER '
     1  //'OF INDEX IN CSTVOL DEFINITION (3)')
            CALL RLSARA(IBASE(VARTYP))
            CALL RLSARA(IBASE(ITFVL1))
         ENDIF
********************
*        NMIX -> NUN
         IF (LDUAL) THEN
            CALL SETARA(RBASE,NEL,IGAR)
            CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1                  RBASE(CHAREA),RBASE(VOL1),IBASE(MAT),IBASE(KN),
     2                  RBASE(REAVOL),RBASE(IGAR))
            CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1                  RBASE(CHACOR),RBASE(VOL1),IBASE(MAT),IBASE(KN),
     2                  RBASE(CORVOL),RBASE(IGAR))
            IF (LTST1)  CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,
     1                  CYLIND,RBASE(CHACST),RBASE(VOL1),IBASE(MAT),
     2                  IBASE(KN),RBASE(CSTVOL),RBASE(IGAR))
            IF (LTST2)  CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,
     1                  CYLIND,RBASE(CHAVAR),RBASE(VOL1),IBASE(MAT),
     2                  IBASE(KN),RBASE(VARVOL),RBASE(IGAR))
            CALL RLSARA(RBASE(IGAR))
         ELSE 
            WRITE(6,*) 'cas primal: non supporte'
C            CALL TRIASP(IELEM,IR,NEL,LL4,CYLIND,SGD,XX,DD,VOL,MAT,
C     1                     KN,LC,T,TS,VEC)
         ENDIF
         CALL RLSARA(RBASE(CHAREA))
         CALL RLSARA(RBASE(CHACOR))
         CALL RLSARA(RBASE(CHACST))
         CALL RLSARA(RBASE(CHAVAR))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(RBASE(VOL1))
         CALL RLSARA(IBASE(MIX))
      ENDIF

      IF (TXTPDF.NE.'FUNCTION') GO TO 2000

C---------------------------
C FUNCTION DEFINED MANUALY
C---------------------------
C FOR ALL THE COMPONENT OF THE ARRAY TO BE CALCULATED
 99   LTST3=.TRUE.
      IGR=0
      DO 1000 I=1,LGDATA
* initialisation des sequences de calculs
      ISTACK(1)=1
      LVL=1
      LVLINT=0
      COL=1
      LINE=2
      IGR=(I-1)/NUN+1
C rajouter un reel a la pile 1
  100 IF ((STFCN(LINE,COL).EQ.2).OR.(STFCN(LINE,COL).EQ.4)) THEN
         ISTACK(LVL)=ISTACK(LVL)+1
         STACK(ISTACK(LVL),LVL)=RTFCN(LINE,COL)
         LINE=LINE+1
         GO TO 100
C utiliser une variable locale niveau 1
      ELSEIF(STFCN(LINE,COL).EQ.1) THEN
         ISTACK(LVL)=ISTACK(LVL)+1
         STACK(ISTACK(LVL),LVL)=RBASE(IVRLC(VTFCN(LINE,COL)))
         LINE=LINE+1
         GO TO 100
C effectuer une operation niveau 1 
      ELSEIF(STFCN(LINE,COL).EQ.3) THEN
* integration
         IF (OTFCN(LINE,COL).EQ.'INTEGRAL') THEN
*    definir le nombre de point de la zone sur laquelle on integre 
            LTST =.FALSE.
            LTST2=.FALSE.
            LVL=2
            LVLINT=LVLINT+1
            COL=1+LVLINT
            TYPVOL=OTFCN(1,COL)
            LINE1=LINE
            TXTINT=OTFCN(1,COL)
            IF (OTFCN(1,COL).EQ.'DBL-ZONE') TXTINT='CST-ZONE'
  150       IF (TXTINT.EQ.'REACTOR') THEN
               CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
               NUN=OPTPRI(19)
               CALL SETARA(RBASE,NUN,ITFVOL)
               CALL XDRSET(RBASE(ITFVOL),NUN,1.0)
               NINT=NUN
            ELSEIF (TXTINT.EQ.'CORE') THEN
               LTST=.TRUE.
               CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
               NINT=NBUN*NCHA
               CALL SETARA(IBASE,NINT,ITFVL1)
               CALL XDISET(IBASE(ITFVL1),NINT,1)
            ELSEIF (TXTINT.EQ.'CST-ZONE') THEN
               LTST=.TRUE.
               CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
               NCST=OPTPRI(2)
               NINT=NBUN*NCHA
               CALL SETARA(IBASE,NINT,ITFVL1)
               WRITE(TEXT12,'(A8,I4.4)') 'CST-ZONE',VTFCN(1,1)
               CALL LCMLEN(MEMADR(6),TEXT12,LENGT,ITYP)
               IF (LENGT.EQ.0) CALL XABORT('OPTEVL: NO ZONE DEFINED '
     1         //'FOR THIS CONSTRAINT(2)')
               CALL SETARA(IBASE,NCST,CSTTYP)
               CALL LCMGET(MEMADR(6),'CST-VOL-TYPE',IBASE(CSTTYP))
*     numero de canal dans le record
               IF (IBASE(CSTTYP+VTFCN(1,1)-1).EQ.3) THEN
                  CALL LCMGET(MEMADR(6),TEXT12,ICHA)
                  DO 161 J=0,NINT-1
  161                IBASE(ITFVL1+J)=0                     
                  DO 162 J=0,NBUN-1
  162                IBASE(ITFVL1+ICHA-1+J*NCHA)=1
*     numero de canal et de bundle dans le record
               ELSEIF (IBASE(CSTTYP+VTFCN(1,1)-1).EQ.4) THEN
                  CALL LCMGET(MEMADR(6),TEXT12,POS)
                  DO 163 J=0,NINT-1
  163                IBASE(ITFVL1+J)=0         
                  IBASE(ITFVL1+POS(1)-1+(POS(2)-1)*NCHA)=1
*     NCHA*NBUND 0/1 dans le record
               ELSEIF (IBASE(CSTTYP+VTFCN(1,1)-1).EQ.5) THEN
                  CALL LCMGET(MEMADR(6),TEXT12,IBASE(ITFVL1))
               ENDIF
               CALL RLSARA(IBASE(CSTTYP))
               IF (OTFCN(1,COL).EQ.'DBL-ZONE') THEN 
                  CALL SETARA(IBASE,NINT,ITFVL2)
                  DO 172 I1=0,NINT-1
  172             IBASE(ITFVL2+I1)=IBASE(ITFVL1+I1)
                  CALL RLSARA(IBASE(ITFVL1))
                  TXTINT='VAR-ZONE'
                  GOTO 150
               ENDIF
            ELSEIF (TXTINT.EQ.'VAR-ZONE') THEN
               LTST=.TRUE.
 170           CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
               NVAR=OPTPRI(1)
               NINT=NBUN*NCHA
               CALL SETARA(IBASE,NINT,ITFVL1)
               WRITE(TEXT12,'(A8,I4.4)') 'VAR-ZONE',STFCN(1,1)
               CALL LCMLEN(MEMADR(6),TEXT12,LENGT,ITYP)
               IF (LENGT.EQ.0) CALL XABORT('OPTEVL: NO ZONE DEFINED '
     1  //'FOR THIS VARIABLE')
               CALL SETARA(IBASE,NVAR,VARTYP)
               CALL LCMGET(MEMADR(6),'VAR-TYPE',IBASE(VARTYP))
*     NCHA 0/1 dans le record
               IF ((IBASE(VARTYP+VTFCN(1,1)-1)/1000).LE.3) THEN
                  CALL SETARA(IBASE,NCHA,ICHA)
                  CALL LCMGET(MEMADR(6),TEXT12,IBASE(ICHA))
                  DO 181 K=0,NCHA-1
                     DO 181 J=0,NBUN-1
  181                IBASE(ITFVL1+K+J*NCHA)=IBASE(ICHA+K)
                  CALL RLSARA(IBASE(ICHA))
               ELSE
*     NCHA*NBUND 0/1 dans le record
                  CALL LCMGET(MEMADR(6),TEXT12,IBASE(ITFVL1))
               ENDIF
               CALL RLSARA(IBASE(VARTYP))
               IF (OTFCN(1,COL).EQ.'DBL-ZONE') THEN
                  CALL SETARA(IBASE,NINT,ITFVL3)
                  DO 173 I1=0,NINT-1
  173             IBASE(ITFVL3+I1)=IBASE(ITFVL1+I1)
                  CALL RLSARA(IBASE(ITFVL1))
                  TXTINT='DBL-ZONE'
                  GOTO 150
               ENDIF
*     Cas LDATA=1  <Gj>Vi double zone(variable et contrainte)
            ELSEIF (TXTINT.EQ.'DBL-ZONE') THEN
               LTST=.TRUE.
               CALL SETARA(IBASE,NINT,ITFVL1)
               DO 175 I1=0,NINT-1
  175             IBASE(ITFVL1+I1)=IBASE(ITFVL2+I1)*IBASE(ITFVL3+I1)
               CALL RLSARA(IBASE(ITFVL2))
               CALL RLSARA(IBASE(ITFVL3))
*     Cas LDATA>1  <REACTEUR>
            ELSEIF (TXTINT.EQ.'DISCRETE-ALL') THEN
               NINT=1
               CALL SETARA(RBASE,NINT,ITFVOL)
               RBASE(ITFVOL)=1.0
               VTFCN(1,COL+NLVL2)=IGR
               STFCN(1,COL+NLVL2)=IGR
*     Cas LDATA>1  <TOUS LES CANAUX>
            ELSEIF (TXTINT.EQ.'DISCRETE-COR') THEN
               NINT=1
               CALL SETARA(RBASE,NINT,ITFVOL)
               IOFSET=I-1-(IGR-1)*NUN
               RBASE(ITFVOL)=RBASE(CORVOL+IOFSET)
               VTFCN(1,COL+NLVL2)=IGR
               STFCN(1,COL+NLVL2)=IGR
*     Cas LDATA>1  <ZONE DE LA CONTRAINTE>
            ELSEIF (TXTINT.EQ.'DISCRETE-CST') THEN
               NINT=1
               CALL SETARA(IBASE,NINT,ITFVOL)
               IOFSET=I-1-(IGR-1)*NUN
               RBASE(ITFVOL)=RBASE(CSTVOL+IOFSET)
               VTFCN(1,COL+NLVL2)=IGR
               STFCN(1,COL+NLVL2)=IGR
            ELSE 
               CALL XABORT('OPTEVL: WRONG VOLUME KEYWORD')
            ENDIF
*       transformer un tableau NCHA*NBUND de 0/1 en NEL 0/1
            IF (LTST) THEN
               CALL LCMGET(MEMADR(9),'STATE-VECTOR',TRKPRM)
               IELEM=TRKPRM(9)
               ICHX =TRKPRM(12)
               IDIM0=TRKPRM(6)
               IF (IDIM0.LT.4) IDIM=1
               IF ((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
               IF ((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
               IR   =TRKPRM(4)
               NEL  =TRKPRM(1)
               LL4  =TRKPRM(11)
               CYLIND=.FALSE.
               IF ((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
               LDUAL=(TRKPRM(9).GT.0)
               CALL SETARA(RBASE,NEL,VOL1)
               CALL XDRSET(RBASE(VOL1),NEL,1.0)
               CALL SETARA(IBASE,NEL,MAT)
               CALL LCMGET(MEMADR(9),'MATCOD',IBASE(MAT))
               CALL LCMLEN(MEMADR(9),'KN',MAXKN,ITYP)
               CALL SETARA(IBASE,MAXKN,KN)
               CALL LCMGET(MEMADR(9),'KN',IBASE(KN))
               NUN=OPTPRI(19)
               CALL SETARA(IBASE,NUN,ITFVOL)
               CALL XDRSET(RBASE(ITFVOL),NUN,0.0)
               CALL LCMLEN(MEMADR(8),'MAT',LENGT,ITYP)
               CALL SETARA(IBASE,LENGT,MIX)
               CALL LCMGET(MEMADR(8),'MAT',IBASE(MIX))
               CALL SETARA(RBASE,IR,CHADIS)
               I1=0
               DO 190 J=0,NEL-1
               IF (IBASE(MIX+J).NE.0) THEN
                  IF (IBASE(MIX+J).GT.0) THEN
                     RBASE(CHADIS+I1)=0.0
                  ELSE
                     RBASE(CHADIS+I1)=
     1                    IBASE(ITFVL1-IBASE(MIX+J)-1)
                  ENDIF
                  I1=I1+1
               ENDIF
  190          CONTINUE
               CALL RLSARA(IBASE(ITFVL1))
               CALL RLSARA(IBASE(MIX))
               IF (LDUAL) THEN
                  CALL SETARA(RBASE,NEL,IGAR)
                  CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,IR,NEL,NUN,CYLIND,
     1                     RBASE(CHADIS),RBASE(VOL1),IBASE(MAT),
     2                     IBASE(KN),RBASE(ITFVOL),RBASE(IGAR))
                  CALL RLSARA(RBASE(IGAR))
               ELSE 
               WRITE(6,*) 'cas primal: non supporte'
C               CALL TRIASP(IELEM,IR,NEL,LL4,CYLIND,SGD,XX,DD,VOL,MAT,
C     1                     KN,LC,T,TS,VEC)
               ENDIF
               CALL RLSARA(RBASE(CHADIS))
               CALL RLSARA(IBASE(KN))
               CALL RLSARA(IBASE(MAT))
               CALL RLSARA(RBASE(VOL1))
               NINT=NUN
            ENDIF
*    calculer l'integrale
            INTVAL=0.0D0
            DO 900 J=1,NINT
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C indentation decalee pour niveau 2     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C        rajouter un reel a la pile 2
      LINE=2
      ISTACK(LVL)=1
  200 IF (RBASE(ITFVOL+J-1).EQ.0.0) THEN
         STACK(2,2)=0.0
         GO TO 890
      ENDIF
      IF ((STFCN(LINE,COL).EQ.2).OR.(STFCN(LINE,COL).EQ.4)) THEN
         ISTACK(LVL)=ISTACK(LVL)+1
         STACK(ISTACK(LVL),LVL)=RTFCN(LINE,COL)
         LINE=LINE+1
         GO TO 200
C        utiliser une variable locale niveau 2
      ELSEIF(STFCN(LINE,COL).EQ.1) THEN
         ISTACK(LVL)=ISTACK(LVL)+1
         IF (LGDATA.EQ.1) THEN
            IOFSET=J-1
         ELSE
            IOFSET=I-1-(IGR-1)*NUN
         ENDIF
         STACK(ISTACK(LVL),LVL)=
     1      RBASE(IVRLC(VTFCN(LINE,COL))+IOFSET)
         LINE=LINE+1
         GO TO 200
C        effectuer une operation niveau 2 
      ELSEIF(STFCN(LINE,COL).EQ.3) THEN
* energie
         IF (OTFCN(LINE,COL).EQ.'ENERGY') THEN
*    definir intervale de groupes
            COL=1+LVLINT+NLVL2
            GRPFRM=VTFCN(1,COL)
            GRPTO =STFCN(1,COL)
            LINE2=LINE
            LVL=3
            ISTACK(LVL)=1
*    calculer l'integrale en energie en ce point
            ENEVAL=0.0D0
            DO 800 K=GRPFRM,GRPTO
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C indentation decalee pour niveau 3     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C        rajouter un reel a la pile 3
      LINE=2
      ISTACK(LVL)=1
  300 IF ((STFCN(LINE,COL).EQ.2).OR.(STFCN(LINE,COL).EQ.4)) THEN
         ISTACK(LVL)=ISTACK(LVL)+1
         STACK(ISTACK(LVL),LVL)=RTFCN(LINE,COL)
         LINE=LINE+1
         GO TO 300
C        utiliser une variable locale niveau 3
      ELSEIF(STFCN(LINE,COL).EQ.1) THEN
         ISTACK(LVL)=ISTACK(LVL)+1
         IF (LGDATA.EQ.1) THEN
            IOFSET=J-1+(K-1)*NINT
         ELSE
            IOFSET=I-1
         ENDIF
         STACK(ISTACK(LVL),LVL)=
     1      RBASE(IVRLC(VTFCN(LINE,COL))+IOFSET)
         LINE=LINE+1
         GO TO 300
C        effectuer une operation niveau 3
      ELSEIF(STFCN(LINE,COL).EQ.3) THEN
C fin du calcul de l'integrale
         IF (OTFCN(LINE,COL).EQ.'END-ENERGY') THEN
            IF (ISTACK(3).NE.2) CALL XABORT('OPTEVL: ERROR IN '
     1  //'FUNCTION DEFINITION IN LEVEL 2')
            GO TO 790
         ELSE
            CALL OPTNOP(STACK(ISTACK(LVL)-1,LVL),STACK(ISTACK(LVL),LVL),
     1               OTFCN(LINE,COL),ISTACK(LVL))
         ENDIF
         LINE=LINE+1
         GO TO 300
* probleme dans la sequence => arret
      ELSE
         CALL XABORT('OPTEVL: WRONG CODE NUMBER IN SEQUENCE 3')
      ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C fin indentation decalee pour niveau 3 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 790           ENEVAL=ENEVAL+STACK(2,3)
 800           CONTINUE
*    recharger les compteurs du niveau 2
            LINE=LINE2
            COL=1+LVLINT
            LVL=2
            ISTACK(LVL)=ISTACK(LVL)+1
*    mettre la valeur en energie dans la pile niveau 2
            STACK(ISTACK(LVL),2)=ENEVAL
C fin du calcul de l'integrale
         ELSEIF (OTFCN(LINE,COL).EQ.'END-INTEGRAL') THEN
            IF (ISTACK(2).NE.2) CALL XABORT('OPTEVL: ERROR IN '
     1  //'FUNCTION DEFINITION IN LEVEL 2')
            GO TO 890
C operateur numerique (+ * - / ...) niveau 2
         ELSE
            CALL OPTNOP(STACK(ISTACK(LVL)-1,LVL),STACK(ISTACK(LVL),LVL),
     1               OTFCN(LINE,COL),ISTACK(LVL))
         ENDIF
         LINE=LINE+1
         GO TO 200
* probleme dans la sequence => arret
      ELSE
         CALL XABORT('OPTEVL: WRONG CODE NUMBER IN SEQUENCE 2')
      ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C fin indentation decalee pour niveau 2 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 890           INTVAL=INTVAL+STACK(2,2)
 900           CONTINUE
            CALL RLSARA(RBASE(ITFVOL))
*    recharger les compteurs du niveau 1
            LINE=LINE1
            COL=1
            LVL=1
            ISTACK(LVL)=ISTACK(LVL)+1
*    mettre la valeur de l'integrale dans la pile niveau 1
            STACK(ISTACK(LVL),1)=INTVAL
C fin du calcul pour cette composante du vecteur
         ELSEIF (OTFCN(LINE,COL).EQ.'END') THEN
            IF (ISTACK(1).NE.2) CALL XABORT('OPTEVL: ERROR IN '
     1  //'FUNCTION DEFINITION IN LEVEL 1')
            GO TO 990
C operateur numerique (+ * - / ...) niveau 1
         ELSE
            CALL OPTNOP(STACK(ISTACK(LVL)-1,LVL),STACK(ISTACK(LVL),LVL),
     1               OTFCN(LINE,COL),ISTACK(LVL))
         ENDIF
         LINE=LINE+1
         GO TO 100
* probleme dans la sequence => arret
      ELSE
         CALL XABORT('OPTEVL: WRONG CODE NUMBER IN SEQUENCE 1')
      ENDIF
  990 FVALUE(I)=STACK(2,1)
 1000 CONTINUE
      GO TO 5000
C---------------------------
C FUNCTION PREDEFINED 
C---------------------------
 2000 CONTINUE
C D-LAMBDA (D-LAMBDA,D-LAMBDA/DX,D-LAMBDA-V,D-LAMBDA-V/DX)
      IF (TXTPDF.EQ.'D-LAMBDA') THEN
         IVAR1=IVRLC(VTFCN(2,1+1+NLVL2))
         IVAR2=IVRLC(VTFCN(3,1+1+NLVL2))
         IVAR3=IVRLC(VTFCN(3,1+2+NLVL2))
         IVAR4=IVRLC(VTFCN(3,1+3+NLVL2))
         IVAR5=IVRLC(VTFCN(3,1+4+NLVL2))
         FACT1=0.0D0
         FACT2=0.0D0
         FACT3=0.0D0
         FACT4=0.0D0
         DO 2010 I=0,NUN-1
         DO 2010 IGR=0,NGRP-1
            FACT1=RBASE(IVAR1+I+IGR*NUN)*RBASE(IVAR2+I+IGR*NUN)+FACT1
            FACT2=RBASE(IVAR1+I+IGR*NUN)*RBASE(IVAR3+I+IGR*NUN)+FACT2
            FACT3=RBASE(IVAR1+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)+FACT3
            FACT4=RBASE(IVAR1+I+IGR*NUN)*RBASE(IVAR5+I+IGR*NUN)+FACT4
 2010       CONTINUE
         FVALUE(1)=RTFCN(2,1)*(FACT1/FACT2-FACT3/FACT4)
C UCOST
      ELSEIF (TXTPDF.EQ.'UCOST') THEN
         IVAR1=IVRLC(VTFCN(2,1+1))
         IVAR2=IVRLC(VTFCN(3,1+1))
         IVAR3=IVRLC(VTFCN(2,1+1+NLVL2))
         IVAR4=IVRLC(VTFCN(3,1+1+NLVL2))
         FACT1=0.0D0
         IHFLU=RTFCN(3,1)
         DO 2111 I=0,NUN-1
            IF (RBASE(IVAR2+I).NE.0.0) THEN
               DO 2110 IGR=0,NGRP-1
                  FACT1=FACT1+RBASE(IVAR1+I)/RBASE(IVAR2+I)
     1                    *RBASE(IVAR3+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)
     2                    *RBASE(CORVOL+I)
 2110          CONTINUE
            ENDIF
 2111    CONTINUE
         FVALUE(1)=FACT1/IHFLU
C DX-UCOST
      ELSEIF (TXTPDF.EQ.'DX-UCOST') THEN
         IVAR1=IVRLC(VTFCN(2,1+2))
         IVAR2=IVRLC(VTFCN(3,1+2))
         IVAR3=IVRLC(VTFCN(2,1+3+NLVL2))
         IVAR4=IVRLC(VTFCN(3,1+3+NLVL2))
         IVAR5=IVRLC(VTFCN(2,1+2+NLVL2))
         IF (FCD.EQ.1) THEN
            IVAR6=IVRLC(VTFCN(2,1+1))
         ENDIF
         IVAR7=IVRLC(VTFCN(7,1+3))
         FACT1=0.0D0
         FACT2=0.0D0
         FACT3=0.0D0
         FACT4=0.0D0
         FVAL=RTFCN(8,1)
         IHFLU=RTFCN(11,1)
         DO 2212 I=0,NUN-1
            IF (RBASE(IVAR2+I).NE.0.0) THEN
               DO 2210 IGR=0,NGRP-1
                  IF ((FCD.EQ.1).AND.(TYPVAR.EQ.2)) THEN
                  FACT1=FACT1+RBASE(IVAR6+I)/RBASE(IVAR2+I)
     1                    *RBASE(IVAR3+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)
     2                    *RBASE(VARVOL+I)
                  ENDIF
                  FACT2=FACT2+RBASE(IVAR1+I)/RBASE(IVAR2+I)
     1                    *RBASE(IVAR5+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)
     2                    *RBASE(VARVOL+I)
                  IF (TYPVAR.EQ.1) THEN
                  FACT3=FACT3+RBASE(IVAR1+I)/(RBASE(IVAR2+I)**2)
     1                    *RBASE(IVAR7+I)*RBASE(IVAR3+I+IGR*NUN)
     2                    *RBASE(IVAR4+I+IGR*NUN)*RBASE(VARVOL+I)
                  ENDIF
 2210          CONTINUE
            ENDIF
            DO 2211 IGR=0,NGRP-1
               FACT4=FACT4+RBASE(IVAR5+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)
     1                    *RBASE(REAVOL+I)
 2211       CONTINUE
 2212    CONTINUE
         FVALUE(1)=(FACT1+FACT2-FACT3-FACT4*FVAL)/IHFLU
C DPHI-UCOST
      ELSEIF (TXTPDF.EQ.'DPHI-UCOST') THEN
         IVAR1=IVRLC(VTFCN(2,1+1))
         IVAR2=IVRLC(VTFCN(3,1+1))
         IVAR3=IVRLC(VTFCN(2,1+1+NLVL2))
         FVAL=RTFCN(4,1)
         IHFLU=RTFCN(7,1)
         DO 2312 I=0,NUN-1
            IF (RBASE(IVAR2+I).NE.0.0) THEN
               FACT1=RBASE(IVAR1+I)/RBASE(IVAR2+I)
            ELSE
               FACT1=0.0D0
            ENDIF
            DO 2310 IGR=0,NGRP-1
               FVALUE(I+1+IGR*NUN)=(FACT1*RBASE(IVAR3+I+IGR*NUN)
     1                            -FVAL*RBASE(IVAR3+I+IGR*NUN))
     2                           /IHFLU
 2310       CONTINUE
 2312    CONTINUE
C POWERLIMIT
      ELSEIF (TXTPDF.EQ.'POWERLIMIT') THEN
         IVAR2=IVRLC(VTFCN(2,1+1+NLVL2))
         IVAR3=IVRLC(VTFCN(3,1+1+NLVL2))
         FACT1=0.0D0
         IHFLU=1.0/RTFCN(3,1)
         FVOL =RTFCN(5,1)
         DO 2410 I=0,NUN-1
         DO 2410 IGR=0,NGRP-1
            FACT1=FACT1+RBASE(IVAR2+I+IGR*NUN)*RBASE(IVAR3+I+IGR*NUN)
     1                 *RBASE(CSTVOL+I)
 2410    CONTINUE
         FVALUE(1)=FACT1/FVOL/IHFLU
C DX-POWER
      ELSEIF (TXTPDF.EQ.'DX-POWER') THEN
         IVAR4=IVRLC(VTFCN(2,1+1+NLVL2))
         IVAR5=IVRLC(VTFCN(3,1+1+NLVL2))
         FACT1=0.0D0
         FACT2=0.0D0
         FVAL =RTFCN(7,1)
         IHFLU=RTFCN(11,1)
         FVOL =RTFCN(5,1)
         CVOL =RTFCN(3,1)
         DO 2510 I=0,NUN-1
         DO 2510 IGR=0,NGRP-1
            FACT1=FACT1+RBASE(IVAR5+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)
     1                 *RBASE(CSTVOL+I)*RBASE(VARVOL+I)
            FACT2=FACT2+RBASE(IVAR5+I+IGR*NUN)*RBASE(IVAR4+I+IGR*NUN)
 2510    CONTINUE
         FVALUE(1)=(CVOL/FVOL*FACT1-FVAL*FACT2)/IHFLU
C DPHI-POWER
      ELSEIF (TXTPDF.EQ.'DPHI-POWER') THEN
         IVAR3=IVRLC(VTFCN(2,1+1+NLVL2))
         FVAL =RTFCN(7,1)
         IHFLU=RTFCN(11,1)
         FVOL =RTFCN(5,1)
         CVOL =RTFCN(3,1)
         DO 2610 I=0,NUN-1
         DO 2610 IGR=0,NGRP-1
            FVALUE(I+1+IGR*NUN)=(CVOL/FVOL*RBASE(IVAR3+I+IGR*NUN)
     1        *RBASE(CSTVOL+I)-FVAL*RBASE(IVAR3+I+IGR*NUN)
     2        )/IHFLU
 2610    CONTINUE
C KEFF
      ELSEIF (TXTPDF.EQ.'KEFF') THEN
         IVAR1=IVRLC(VTFCN(2,1))
         FVALUE(1)=RBASE(IVAR1)
C DX-KEFF
      ELSEIF (TXTPDF.EQ.'D-KEFF') THEN
         IVAR1=IVRLC(VTFCN(3,1))
         IVAR2=IVRLC(VTFCN(6,1))
         FVALUE(1)=-(RBASE(IVAR1)**2)*RBASE(IVAR2)
C VOID-REAC-FC
      ELSEIF (TXTPDF.EQ.'VOID-REAC-FC') THEN
         IVAR1=IVRLC(VTFCN(3,1))
         IVAR2=IVRLC(VTFCN(6,1))
         FVALUE(1)=1.0/RBASE(IVAR1)-1.0/RBASE(IVAR2)
C D-VOID-R-FC
      ELSEIF (TXTPDF.EQ.'D-VOID-R-FC') THEN
         IVAR1=IVRLC(VTFCN(2,1))
         IVAR2=IVRLC(VTFCN(3,1))
         FVALUE(1)=RBASE(IVAR1)-RBASE(IVAR2)
C KEFF=KREF
      ELSEIF (TXTPDF.EQ.'KEFF=KREF') THEN
         IVAR1=IVRLC(VTFCN(2,1))
         IVAR2=IVRLC(VTFCN(3,1))
         FVALUE(1)=(RBASE(IVAR1)-RBASE(IVAR2))**2
C D-KEFF=KREF
      ELSEIF (TXTPDF.EQ.'D-KEFF=KREF') THEN
         IVAR1=IVRLC(VTFCN(2,1))
         IVAR2=IVRLC(VTFCN(3,1))
         IVAR3=IVRLC(VTFCN(4,1))
         FVALUE(1)=-(RBASE(IVAR1)-RBASE(IVAR2))
     1               *(RBASE(IVAR1)**2)*RBASE(IVAR3)
C MINPCMAX
      ELSEIF (TXTPDF.EQ.'MINPCMAX') THEN
         IVAR1=IVRLC(VTFCN(2,1))
         IVAR2=IVRLC(VTFCN(3,1))
         CALL LCMGET(MEMADR(6),'OPT-PARAM-R',OPTPRR)
         N=OPTPRR(8)
         IFCT1=RBASE(IVRLC(VTFCN(4,1)))
         IFCT2=RBASE(IVRLC(VTFCN(5,1)))
         FVALUE(1)=0.0
         DO 3310 I=IFCT1,IFCT2
            IF (RBASE(IVAR1+I).GT.RBASE(IVAR2)) THEN
            FVALUE(1)=FVALUE(1)+(RBASE(IVAR1+I)-RBASE(IVAR2))**(2*N)
            ENDIF
 3310    CONTINUE
C D-MINPCMAX
      ELSEIF (TXTPDF.EQ.'D-MINPCMAX') THEN
         IVAR1=IVRLC(VTFCN(2,1))
         IVAR2=IVRLC(VTFCN(3,1))
         CALL LCMGET(MEMADR(6),'OPT-PARAM-R',OPTPRR)
         N=OPTPRR(8)
         IFCT1=RBASE(IVRLC(VTFCN(4,1)))
         IFCT2=RBASE(IVRLC(VTFCN(5,1)))
         IVAR5=IVRLC(VTFCN(6,1))
         FVALUE(1)=0.0
         DO 3410 I=IFCT1,IFCT2
            IF (RBASE(IVAR1+I).GT.RBASE(IVAR2)) THEN
            FVALUE(1)=FVALUE(1)
     1       +2*N*(RBASE(IVAR1+I)-RBASE(IVAR2))**(2*N-1)
     2           *RBASE(IVAR5+I)
            ENDIF
 3410       CONTINUE
C ERREUR
      ELSE
         CALL XABORT('OPTSEQ:'//TXTPDF//' WRONG FUNCTION NAME')
      ENDIF

 5000 CONTINUE
      IF ((LGDATA.GT.1).OR.(TXTPDF.NE.'FUNCTION')) THEN
         CALL RLSARA(RBASE(REAVOL))
         CALL RLSARA(RBASE(CORVOL))
         CALL RLSARA(RBASE(CSTVOL))
         CALL RLSARA(RBASE(VARVOL))
      ENDIF
      RETURN
C END OF SUBROUTINE
      END
