*DECK OPTIHF
      SUBROUTINE OPTIHF(MEMADR,IVRLC,VRLCMX,IVARH,IVARF,IHFLU)
*
*-----------------------------------------------------------------------
*Purpose:
* this subroutine computes the integral <Hfactor,Flux>reactor .
* OPTIHF = OPTimization : Integral H * F over the reactor
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
*  MEMADR : adress memory of lcm objects (cf OPTVDF.f)
*  IVRLC  : Table of offset of local array variables
*  VRLCMX : Number maximum of local array variables
*  IVARH  : Number of the local array for H Factors
*  IVARF  : Number of the local array for the integrated flux
*
*Parameters: ouput
*  IHFLU  : Value of <H,F>
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   VRLCMX,MEMADR(20),IVARH,IVARF
      INTEGER   IVRLC(VRLCMX)
      REAL      IHFLU
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   I,J,OPTPRI(NSTATE),NUN,NGRP
      DOUBLE PRECISION TEMP

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

      CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
      NUN   =OPTPRI(19)
      NGRP  =OPTPRI(20)
      TEMP  =0.0D0
      DO 10 I=0,NUN-1
         DO 10 J=0,NGRP-1
   10       TEMP=TEMP+RBASE(IVRLC(IVARH)+I+J*NUN)
     1                *RBASE(IVRLC(IVARF)+I+J*NUN)
      IHFLU=REAL(TEMP)
      RETURN
      END
