*DECK OPTNOP
      SUBROUTINE OPTNOP(REAL1,REAL2,OPERAT,ISTACK)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine does basic numerical operations
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
*  REAL1  : real in the stack in rank ISTACK-1
*  REAL2  : real in the stack in rank ISTACK
*  OPERAT : operation (character) between real2 and possibly real1
*  ISTACK : rank ISTACK
*
*Parameters: ouput
*  REAL1  : new real in the stack in rank ISTACK-1
*  REAL2  : new real in the stack in rank ISTACK
*  ISTACK : new rank ISTACK
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER    ISTACK
      REAL       REAL1,REAL2
      CHARACTER  OPERAT*12
*----
*  LOCAL VARIABLES
*----
      REAL       REALRF
      PARAMETER  (REALRF=0.0)

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

      IF ((OPERAT.EQ.'+').OR.(OPERAT.EQ.'PLUS')) THEN
         REAL1=REAL1+REAL2
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF ((OPERAT.EQ.'-').OR.(OPERAT.EQ.'MINUS')) THEN
         REAL1=REAL1-REAL2
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF ((OPERAT.EQ.'*').OR.(OPERAT.EQ.'TIMES')) THEN
         REAL1=REAL1*REAL2
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF ((OPERAT.EQ.'/').OR.(OPERAT.EQ.'DIVISION')) THEN
         REAL1=REAL1/REAL2
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF ((OPERAT.EQ.'**').OR.(OPERAT.EQ.'POWER')) THEN
         REAL1=REAL1**REAL2
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF (OPERAT.EQ.'MAX') THEN
         REAL1=MAX(REAL1,REAL2)
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF (OPERAT.EQ.'MIN') THEN
         REAL1=MIN(REAL1,REAL2)
         REAL2=REALRF
         ISTACK=ISTACK-1
      ELSEIF (OPERAT.EQ.'LOG') THEN
         REAL2=ALOG10(REAL2)
      ELSEIF (OPERAT.EQ.'LN') THEN
         REAL2=ALOG(REAL2)
      ELSEIF (OPERAT.EQ.'EXP') THEN
         REAL2=EXP(REAL2)
      ELSEIF (OPERAT.EQ.'SIN') THEN
         REAL2=SIN(REAL2)
      ELSEIF (OPERAT.EQ.'COS') THEN
         REAL2=COS(REAL2)
      ELSEIF (OPERAT.EQ.'TAN') THEN
         REAL2=TAN(REAL2)
      ELSEIF (OPERAT.EQ.'ABS') THEN
         REAL2=ABS(REAL2)
      ELSEIF (OPERAT.EQ.'SQRT') THEN
         REAL2=SQRT(REAL2)
      ELSE
         WRITE(6,*) 'OPERATION SELECTED: ',OPERAT
         CALL XABORT('OPTNOP: WRONG KEYWORD FOR OPERATION')
      ENDIF
C END OF SUBROUTINE
      END
