*DECK OPTSEQ
      SUBROUTINE OPTSEQ(MEMADR,STFCN,VTFCN,RTFCN,OTFCN,NLVL1,NLVL2,
     1                  IVRLC,TVRLC,VRLCMX,NGRP,TXTPDF)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine defines the sequence of calculation for function 
*  evaluation.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
*  MEMADR : adress memory of lcm objects (cf OPTVDF.f)
*  STFCN  : Sequence of the tables to get the information
*  VTFCN  : Table of number of local array variables
*  RTFCN  : Table of real
*  OTFCN  : Table of operator
*  NLVL1  : Number of maximum operation and real in one level
*  NLVL2  : Number of integration maximum in one evaluation
*  IVRLC  : Table of offset of local array variables
*  TVRLC  : Table of name of local array variables
*  LVRLC  : Table of logical representing  if a local array variable 
*           is defined
*  VRLCMX : Number maximum of local array variables
*  NGRP   : Number of energy groups
*  TXTPDF : Nom de fonction predefinie
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   MEMADR(20),NLVL1,NLVL2,VRLCMX,NGRP
      INTEGER   STFCN(NLVL1,1+2*NLVL2),VTFCN(NLVL1,1+2*NLVL2),
     1          IVRLC(VRLCMX)
      REAL      RTFCN(NLVL1,1+2*NLVL2)
      CHARACTER OTFCN(NLVL1,1+2*NLVL2)*12,TVRLC(VRLCMX)*12,TXTPDF*12
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   NITMA,I,J,ITYP
      DOUBLE PRECISION DFLOTT
      REAL      FLOTT
      CHARACTER TEXT12*12
      REAL      ALMST0,LAMBDA
      PARAMETER (ALMST0=0.0001E-32)
*'Local arrays' variable
      INTEGER   NVRLC
*Objective and constraint evaluation variable
      INTEGER   ISTACK(3)
      INTEGER   GRPFRM,GRPTO,LVLGRL,LVLINT,ICOL,IVAR,IVAR1,IDATA,
     1          LENGT,IOPTPR
      REAL      VCORE
*Numero et nom de variable local
      CHARACTER NAMVAR(10)*12
      INTEGER   NUMVAR(10)
*<H,F>
      REAL      IHFLU,FVAL
*L_OPTIMIZE state vector
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   OPTPRI(NSTATE),FCD

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

      IF(MEMADR(6).EQ.0) CALL XABORT('OPTSEQ: L_OPTIMIZE NEEDED')
      CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
      FCD =OPTPRI(11)

      IF (TXTPDF.EQ.'FUNCTION') THEN
         GO TO 100
      ELSEIF (TXTPDF.EQ.'D-LAMBDA') THEN
         GO TO 200
      ELSEIF (TXTPDF.EQ.'UCOST') THEN
         GO TO 300
      ELSEIF (TXTPDF.EQ.'DX-UCOST') THEN
         GO TO 400
      ELSEIF (TXTPDF.EQ.'DPHI-UCOST') THEN
         GO TO 500
      ELSEIF (TXTPDF.EQ.'POWERLIMIT') THEN
         GO TO 600
      ELSEIF (TXTPDF.EQ.'DX-POWER') THEN
         GO TO 700
      ELSEIF (TXTPDF.EQ.'DPHI-POWER') THEN
         GO TO 800
      ELSEIF (TXTPDF.EQ.'KEFF') THEN
         GO TO 900
      ELSEIF (TXTPDF.EQ.'D-KEFF') THEN
         GO TO 1000
      ELSEIF (TXTPDF.EQ.'VOID-REAC-FC') THEN
         GO TO 1100
      ELSEIF (TXTPDF.EQ.'D-VOID-R-FC') THEN
         GO TO 1200
      ELSEIF (TXTPDF.EQ.'GPT-D-SOUR') THEN
         GO TO 1300
      ELSEIF (TXTPDF.EQ.'KEFF=KREF') THEN
         GO TO 1400
      ELSEIF (TXTPDF.EQ.'D-KEFF=KREF') THEN
         GO TO 1500
      ELSEIF (TXTPDF.EQ.'MINPCMAX') THEN
         GO TO 1600
      ELSEIF (TXTPDF.EQ.'D-MINPCMAX') THEN
         GO TO 1700
      ELSE
         CALL XABORT('OPTSEQ: '//TXTPDF//'WRONG FUNCTION NAME')
      ENDIF
      

C---------------------------
C     1      0000     0000    
C    11     0    0   0    0 
C   1 1    0      0 0      0 
C  1  1    0      0 0      0  
C 1   1    0      0 0      0  
C     1    0      0 0      0  
C     1     0    0   0    0  
C 11111111   0000     0000  
C---------------------------
C FUNCTION DEFINED MANUALY
C---------------------------
  100 WRITE (6,*) 'FUNCTION DEFINED MANUALY'
*    lire la sequence jusqu'a rencontrer 'END'
*        initialisation des compteurs
      ISTACK(1)=1
      LVLGRL=1
      LVLINT=0
      ICOL=1
*        initialisation des tableaux de fonctions
      DO 110 I=1,NLVL1
         DO 110 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  110       OTFCN(I,J)=' ' 
  120 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*        valeur numerique
      IF (ITYP.EQ.2) THEN
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=2
         RTFCN(ISTACK(LVLGRL),ICOL)=FLOTT
         GO TO 120
      ELSEIF (ITYP.EQ.3) THEN
*        variable
         IF (TEXT12.EQ.'VAR') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*             numero (et verification du nom)
         IF (ITYP.NE.3) CALL XABORT('OPTSEQ: LOCAL VARIABLE NAME'
     1  //' EXPECTED')
         NVRLC=0
         DO 125 I=1,VRLCMX
            IF (TVRLC(I).EQ.TEXT12) THEN
               NVRLC=I
            ENDIF
  125       CONTINUE
         IF (NVRLC.EQ.0) CALL XABORT('OPTSEQ: WRONG LOCAL VARIABLE '
     1  //'NAME')
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=1
         VTFCN(ISTACK(LVLGRL),ICOL)=NVRLC
         GO TO 120
*        valeur reelle dependante de la fonctionnelle 
         ELSEIF (TEXT12.EQ.'VARF') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*             numero (et verification du nom)
         IF (ITYP.NE.3) CALL XABORT('OPTSEQ: LOCAL VARIABLE NAME'
     1  //' EXPECTED')
         NVRLC=0
         DO 135 I=1,VRLCMX
            IF (TVRLC(I).EQ.TEXT12) THEN
               NVRLC=I
            ENDIF
  135       CONTINUE
         IF (NVRLC.EQ.0) CALL XABORT('OPTSEQ: WRONG LOCAL VARIABLE '
     1  //'NAME')
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=4
         VTFCN(ISTACK(LVLGRL),ICOL)=NVRLC
         GO TO 120
*        operateur integral
         ELSEIF (TEXT12.EQ.'INTEGRAL') THEN
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=3
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12         
         LVLGRL=2
         ISTACK(LVLGRL)=1
         LVLINT=LVLINT+1
         ICOL=LVLINT+1
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('FOBJCT: VOLUME TYPE NAME'
     1  //' EXPECTED')
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12
         GO TO 120
*        operateur fin-integral
         ELSEIF (TEXT12.EQ.'END-INTEGRAL') THEN
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12         
         STFCN(ISTACK(LVLGRL),ICOL)=3         
         LVLGRL=1
         ICOL=1
         GO TO 120
*        operateur energy
         ELSEIF (TEXT12.EQ.'ENERGY') THEN
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=3
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12         
         LVLGRL=3
         ISTACK(LVLGRL)=1
         ICOL=ICOL+NLVL2
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (TEXT12.EQ.'ALL') THEN
            GRPFRM=1
            GRPTO =NGRP
         ELSE         
            IF (ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED') 
            GRPFRM=NITMA
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF (ITYP.NE.1) CALL XABORT('FOBJCT: INTEGER EXPECTED') 
            GRPTO=NITMA
            IF (GRPTO.LT.GRPFRM) CALL XABORT('FOBJCT: FROM GREATER '
     1  //'THAN TO')
            IF ((GRPFRM.GT.NGRP).OR.(GRPTO.GT.NGRP)) CALL XABORT
     1  ('FOBJCT: TOTAL NUMBER OF GROUP IS LESS THAN GRPTO')
         ENDIF
         STFCN(ISTACK(LVLGRL),ICOL)=GRPTO
         VTFCN(ISTACK(LVLGRL),ICOL)=GRPFRM         
         GO TO 120
*        operateur fin-energy
         ELSEIF (TEXT12.EQ.'END-ENERGY') THEN
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12         
         STFCN(ISTACK(LVLGRL),ICOL)=3         
         LVLGRL=2
         ICOL=ICOL-NLVL2
         GO TO 120
*        operateur fin-calcul
         ELSEIF (TEXT12.EQ.'END') THEN
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=3         
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12         
         RETURN
*        operateur numerique (conventionnel)
         ELSE
         ISTACK(LVLGRL)=ISTACK(LVLGRL)+1
         STFCN(ISTACK(LVLGRL),ICOL)=3
         OTFCN(ISTACK(LVLGRL),ICOL)=TEXT12
         GO TO 120
         ENDIF
      ELSE
         CALL XABORT('OPTSEQ:REAL, LOCAL VARIABLE OR OPERATOR EXPECTED')
      ENDIF
C---------------------------
C   2222     0000     0000    
C  2    2   0    0   0    0 
C 2      2 0      0 0      0 
C       2  0      0 0      0  
C      2   0      0 0      0  
C   22     0      0 0      0  
C  2        0    0   0    0  
C 22222222   0000     0000  
C---------------------------
C VARIABLES FOR D-LAMBDA
C
C       <F*,(Ap-A)F>   <F*,(Bp-B)F>
C DL=L*(------------ - ------------) 
C         <F*,A.F>       <F*,B.F>
C---------------------------
  200 CALL LCMGET(MEMADR(3),'K-EFFECTIVE',LAMBDA)
      LAMBDA=1/LAMBDA
      DO 220 I=1,NLVL1
         DO 220 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  220       OTFCN(I,J)=' ' 
      STFCN(2,1)=2
      RTFCN(2,1)=LAMBDA
      DO 221 I=3,11
  221    STFCN(I,1)=3
      OTFCN(3,1) ='INTEGRAL'
      OTFCN(4,1) ='INTEGRAL'
      OTFCN(5,1) ='/'
      OTFCN(6,1) ='INTEGRAL'
      OTFCN(7,1) ='INTEGRAL'
      OTFCN(8,1) ='/'
      OTFCN(9,1) ='-'
      OTFCN(10,1)='*'
      OTFCN(11,1)='END'
* numero de la variable de AFLUX (flux adjoint)
      TEXT12='AFLUX'
      IVAR=0
      DO 222 I=1,VRLCMX
         IF (TVRLC(I).EQ.TEXT12) THEN
            IVAR=I
         ENDIF
  222    CONTINUE
      IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: AFLUX NOT DEFINED YET') 
      DO 224 I=1,4
         OTFCN(1,1+I)='REACTOR'
         STFCN(2,1+I)=3
         OTFCN(2,1+I)='ENERGY'
         STFCN(3,1+I)=3
         OTFCN(3,1+I)='END-INTEGRAL'
         VTFCN(1,1+I+NLVL2)=1
         STFCN(1,1+I+NLVL2)=NGRP
         STFCN(2,1+I+NLVL2)=1
         VTFCN(2,1+I+NLVL2)=IVAR
         STFCN(3,1+I+NLVL2)=1
* numero de la variable de MATRICE*FLUX
         IF (I.EQ.1) TEXT12='AP*PHI'
         IF (I.EQ.2) TEXT12='A*PHI'
         IF (I.EQ.3) TEXT12='BP*PHI'
         IF (I.EQ.4) TEXT12='B*PHI'
         IVAR1=0
         DO 223 J=1,VRLCMX
            IF (TVRLC(J).EQ.TEXT12) THEN
               IVAR1=J
            ENDIF
  223       CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//TEXT12//' NOT '
     1  //'DEFINED YET') 
         VTFCN(3,1+I+NLVL2)=IVAR1
         STFCN(4,1+I+NLVL2)=3
         OTFCN(4,1+I+NLVL2)='*'
         STFCN(5,1+I+NLVL2)=3
  224    OTFCN(5,1+I+NLVL2)='END-ENERGY'
      RETURN
C---------------------------
C   3333     0000     0000    
C  3    3   0    0   0    0 
C 3      3 0      0 0      0 
C      33  0      0 0      0  
C       3  0      0 0      0  
C 3      3 0      0 0      0  
C  3    3   0    0   0    0  
C   3333     0000     0000  
C---------------------------
C VARIABLES FOR UCOST
C
C        <Cu/B.H,F>
C UCOST= ----------
C          <H,F>
C---------------------------
  300 DO 320 I=1,NLVL1
         DO 320 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  320       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='FUEL-C-DIST'
      NAMVAR(2)='BURN-E-DIST'
      NAMVAR(3)='H-FACTOR'
      NAMVAR(4)='FLUX'
      DO 330 I=1,4
         IVAR=0
         DO 325 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  325    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//TEXT12//' NOT '
     1  //'DEFINED YET') 
  330    NUMVAR(I)=IVAR
* Calcul de <H,F>
      CALL OPTIHF(MEMADR,IVRLC,VRLCMX,NUMVAR(3),NUMVAR(4),IHFLU)
*definition de la sequence
* numerateur
      STFCN(2,1)=3
      OTFCN(2,1)='INTEGRAL'
      OTFCN(1,2)='CORE'
      STFCN(2,2)=1
      VTFCN(2,2)=NUMVAR(1)
      STFCN(3,2)=1
      VTFCN(3,2)=NUMVAR(2)
      STFCN(4,2)=3
      OTFCN(4,2)='/'
      STFCN(5,2)=3
      OTFCN(5,2)='ENERGY'
      VTFCN(1,2+NLVL2)=1
      STFCN(1,2+NLVL2)=NGRP
      STFCN(2,2+NLVL2)=1
      VTFCN(2,2+NLVL2)=NUMVAR(3)
      STFCN(3,2+NLVL2)=1
      VTFCN(3,2+NLVL2)=NUMVAR(4)
      STFCN(4,2+NLVL2)=3
      OTFCN(4,2+NLVL2)='*'
      STFCN(5,2+NLVL2)=3
      OTFCN(5,2+NLVL2)='END-ENERGY'
      STFCN(6,2)=3
      OTFCN(6,2)='*'
      STFCN(7,2)=3
      OTFCN(7,2)='END-INTEGRAL'
* UCOST=numerateur/IHFLU
      STFCN(3,1)=2
      RTFCN(3,1)=IHFLU
      STFCN(4,1)=3
      OTFCN(4,1)='/'
      STFCN(5,1)=3
      OTFCN(5,1)='END'
      RETURN

C---------------------------
C     4      0000     0000    
C    44     0    0   0    0 
C   4 4    0      0 0      0 
C  4  4    0      0 0      0  
C 4   4    0      0 0      0  
C  4444444 0      0 0      0  
C     4     0    0   0    0  
C     4      0000     0000    
C---------------------------
C VARIABLES FOR DX-UCOST
C           1             2             3                     4
C           <DCu/B.H,F>vi+<Cu/B.DH,F>vi-<Cu/B2.DB.H,F>vi-UCOST<DH,F>reac
C DX-UCOST= ---------------------------------------------------------
C                               <H,F>reac
C---------------------------
  400 DO 420 I=1,NLVL1
         DO 420 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  420       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='FUEL-C-DIST'
      NAMVAR(2)='BURN-E-DIST'
      NAMVAR(3)='H-FACTOR'
      NAMVAR(4)='FLUX'
      NAMVAR(5)='D-HFACT'
      NAMVAR(6)='D-FCDIST'
      NAMVAR(7)='D-BEDIST'
      DO 430 I=1,7
         IVAR=0
         DO 425 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  425    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//TEXT12//' NOT '
     1  //'DEFINED YET') 
  430    NUMVAR(I)=IVAR
* Calcul de <H,F>
      CALL OPTIHF(MEMADR,IVRLC,VRLCMX,NUMVAR(3),NUMVAR(4),IHFLU)
* Charger UCOST
      CALL LCMLEN(MEMADR(6),'FOBJ-CST-VAL',LENGT,ITYP)
      CALL SETARA(RBASE,LENGT,IDATA)
      CALL LCMGET(MEMADR(6),'FOBJ-CST-VAL',RBASE(IDATA))
      FVAL=RBASE(IDATA)
      CALL RLSARA(RBASE(IDATA))
*definition de la sequence
* partie 1 du numerateur
      IF (FCD.EQ.2) THEN
         STFCN(2,1)=3
         OTFCN(2,1)='INTEGRAL'
         OTFCN(2,2)='REACTOR'
         STFCN(2,2)=2
         RTFCN(2,2)=0.0
         STFCN(3,2)=3
         OTFCN(3,2)='END-INTEGRAL'
      ELSEIF (FCD.EQ.1) THEN
         STFCN(2,1)=3
         OTFCN(2,1)='INTEGRAL'
         OTFCN(1,2)='VAR-ZONE'
         STFCN(2,2)=1
         VTFCN(2,2)=NUMVAR(6)
         STFCN(3,2)=1
         VTFCN(3,2)=NUMVAR(2)
         STFCN(4,2)=3
         OTFCN(4,2)='/'
         STFCN(5,2)=3
         OTFCN(5,2)='ENERGY'
         VTFCN(1,2+NLVL2)=1
         STFCN(1,2+NLVL2)=NGRP
         STFCN(2,2+NLVL2)=1
         VTFCN(2,2+NLVL2)=NUMVAR(3)
         STFCN(3,2+NLVL2)=1
         VTFCN(3,2+NLVL2)=NUMVAR(4)
         STFCN(4,2+NLVL2)=3
         OTFCN(4,2+NLVL2)='*'
         STFCN(5,2+NLVL2)=3
         OTFCN(5,2+NLVL2)='END-ENERGY'
         STFCN(6,2)=3
         OTFCN(6,2)='*'
         STFCN(7,2)=3
         OTFCN(7,2)='END-INTEGRAL'
      ELSE
         CALL XABORT('OPTSEQ: FUEL COST DEPENDENCY NOT DEFINED')
      ENDIF
* partie 2 du numerateur
      STFCN(3,1)=3
      OTFCN(3,1)='INTEGRAL'
      OTFCN(1,3)='VAR-ZONE'
      STFCN(2,3)=1
      VTFCN(2,3)=NUMVAR(1)
      STFCN(3,3)=1
      VTFCN(3,3)=NUMVAR(2)
      STFCN(4,3)=3
      OTFCN(4,3)='/'
      STFCN(5,3)=3
      OTFCN(5,3)='ENERGY'
      VTFCN(1,3+NLVL2)=1
      STFCN(1,3+NLVL2)=NGRP
      STFCN(2,3+NLVL2)=1
      VTFCN(2,3+NLVL2)=NUMVAR(5)
      STFCN(3,3+NLVL2)=1
      VTFCN(3,3+NLVL2)=NUMVAR(4)
      STFCN(4,3+NLVL2)=3
      OTFCN(4,3+NLVL2)='*'
      STFCN(5,3+NLVL2)=3
      OTFCN(5,3+NLVL2)='END-ENERGY'
      STFCN(6,3)=3
      OTFCN(6,3)='*'
      STFCN(7,3)=3
      OTFCN(7,3)='END-INTEGRAL'
* partie 1 + partie 2 =ANS
      STFCN(4,1)=3
      OTFCN(4,1)='+'
* partie 3 du numerateur
      STFCN(5,1)=3
      OTFCN(5,1)='INTEGRAL'
      OTFCN(1,4)='VAR-ZONE'
      STFCN(2,4)=1
      VTFCN(2,4)=NUMVAR(1)
      STFCN(3,4)=1
      VTFCN(3,4)=NUMVAR(2)
      STFCN(4,4)=2
      RTFCN(4,4)=2.0
      STFCN(5,4)=3
      OTFCN(5,4)='**'
      STFCN(6,4)=3
      OTFCN(6,4)='/'
      STFCN(7,4)=1
      VTFCN(7,4)=NUMVAR(7)
      STFCN(8,4)=3
      OTFCN(8,4)='*'
      STFCN(9,4)=3
      OTFCN(9,4)='ENERGY'
      VTFCN(1,4+NLVL2)=1
      STFCN(1,4+NLVL2)=NGRP
      STFCN(2,4+NLVL2)=1
      VTFCN(2,4+NLVL2)=NUMVAR(3)
      STFCN(3,4+NLVL2)=1
      VTFCN(3,4+NLVL2)=NUMVAR(4)
      STFCN(4,4+NLVL2)=3
      OTFCN(4,4+NLVL2)='*'
      STFCN(5,4+NLVL2)=3
      OTFCN(5,4+NLVL2)='END-ENERGY'
      STFCN(10,4)=3
      OTFCN(10,4)='*'
      STFCN(11,4)=3
      OTFCN(11,4)='END-INTEGRAL'
* ANS - partie 3 =ANS
      STFCN(6,1)=3
      OTFCN(6,1)='-'
* partie 4 du numerateur
      STFCN(7,1)=3
      OTFCN(7,1)='INTEGRAL'
      OTFCN(1,5)='REACTOR'
      STFCN(2,5)=3
      OTFCN(2,5)='ENERGY'
      VTFCN(1,5+NLVL2)=1
      STFCN(1,5+NLVL2)=NGRP
      STFCN(2,5+NLVL2)=1
      VTFCN(2,5+NLVL2)=NUMVAR(5)
      STFCN(3,5+NLVL2)=1
      VTFCN(3,5+NLVL2)=NUMVAR(4)
      STFCN(4,5+NLVL2)=3
      OTFCN(4,5+NLVL2)='*'
      STFCN(5,5+NLVL2)=3
      OTFCN(5,5+NLVL2)='END-ENERGY'
      STFCN(3,5)=3
      OTFCN(3,5)='END-INTEGRAL'
* ANS - Fc*partie 4 =numerateur
      STFCN(8,1)=2
      RTFCN(8,1)=FVAL
      STFCN(9,1)=3
      OTFCN(9,1)='*'
      STFCN(10,1)=3
      OTFCN(10,1)='-'
* DX-UCOST = numerateur/IHFLU
      STFCN(11,1)=2
      RTFCN(11,1)=IHFLU
      STFCN(12,1)=3
      OTFCN(12,1)='/'
      STFCN(13,1)=3
      OTFCN(13,1)='END'
      RETURN

C---------------------------
C 55555555   0000     0000    
C 5         0    0   0    0 
C 5  55    0      0 0      0 
C 555  55  0      0 0      0  
C        5 0      0 0      0  
C        5 0      0 0      0  
C 55    55  0    0   0    0  
C  555555    0000     0000  
C---------------------------
C VARIABLES FOR DPHI-UCOST
C             1               2
C             Cu/B.H(r)-UCOST.H(r)
C DPHI-UCOST= --------------------
C                  <H,F>reac
C---------------------------
  500 DO 520 I=1,NLVL1
         DO 520 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  520       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='FUEL-C-DIST'
      NAMVAR(2)='BURN-E-DIST'
      NAMVAR(3)='H-FACTOR'
      NAMVAR(4)='FLUX'
      DO 530 I=1,4
         IVAR=0
         DO 525 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  525    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//TEXT12//' NOT '
     1  //'DEFINED YET') 
  530    NUMVAR(I)=IVAR
* Calcul de <H,F>
      CALL OPTIHF(MEMADR,IVRLC,VRLCMX,NUMVAR(3),NUMVAR(4),IHFLU)
* Charger UCOST
      CALL LCMLEN(MEMADR(6),'FOBJ-CST-VAL',LENGT,ITYP)
      CALL SETARA(RBASE,LENGT,IDATA)
      CALL LCMGET(MEMADR(6),'FOBJ-CST-VAL',RBASE(IDATA))
      FVAL=RBASE(IDATA)
      CALL RLSARA(RBASE(IDATA))
*definition de la sequence
* partie 1 du numerateur
      STFCN(2,1)=3
      OTFCN(2,1)='INTEGRAL'
      OTFCN(1,2)='DISCRETE-COR'
      STFCN(2,2)=1
      VTFCN(2,2)=NUMVAR(1)
      STFCN(3,2)=1
      VTFCN(3,2)=NUMVAR(2)
      STFCN(4,2)=3
      OTFCN(4,2)='/'
      STFCN(5,2)=3
      OTFCN(5,2)='ENERGY'
      VTFCN(1,2+NLVL2)=1
      STFCN(1,2+NLVL2)=NGRP
      STFCN(2,2+NLVL2)=1
      VTFCN(2,2+NLVL2)=NUMVAR(3)
      STFCN(3,2+NLVL2)=3
      OTFCN(3,2+NLVL2)='END-ENERGY'
      STFCN(6,2)=3
      OTFCN(6,2)='*'
      STFCN(7,2)=3
      OTFCN(7,2)='END-INTEGRAL'
* partie 2 du numerateur
      STFCN(3,1)=3
      OTFCN(3,1)='INTEGRAL'
      OTFCN(1,3)='DISCRETE-COR'
      STFCN(2,3)=3
      OTFCN(2,3)='ENERGY'
      VTFCN(1,3+NLVL2)=1
      STFCN(1,3+NLVL2)=NGRP
      STFCN(2,3+NLVL2)=1
      VTFCN(2,3+NLVL2)=NUMVAR(3)
      STFCN(3,3+NLVL2)=3
      OTFCN(3,3+NLVL2)='END-ENERGY'
      STFCN(3,3)=3
      OTFCN(3,3)='END-INTEGRAL'
* partie 1 - Fc*partie 2 =numerateur
      STFCN(4,1)=2
      RTFCN(4,1)=FVAL
      STFCN(5,1)=3
      OTFCN(5,1)='*'
      STFCN(6,1)=3
      OTFCN(6,1)='-'
* DPHI-UCOST = numerateur/IHFLU
      STFCN(7,1)=2
      RTFCN(7,1)=IHFLU
      STFCN(8,1)=3
      OTFCN(8,1)='/'
      STFCN(9,1)=3
      OTFCN(9,1)='END'
      RETURN
      
C---------------------------
C  666666    0000     0000    
C 6      6  0    0   0    0 
C 6  66    0      0 0      0 
C 666  66  0      0 0      0  
C 6      6 0      0 0      0  
C 6      6 0      0 0      0  
C  6    6   0    0   0    0  
C   6666     0000     0000  
C---------------------------
C VARIABLES FOR POWERLIMIT
C              Vrea  <H,F>Vj
C POWERLIMIT = ----*---------
C               Vj  <H,F>reac
C---------------------------
  600 DO 620 I=1,NLVL1
         DO 620 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  620       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='FUNCZVOL'
      NAMVAR(2)='H-FACTOR'
      NAMVAR(3)='FLUX'
      DO 630 I=1,3
         IVAR=0
         DO 625 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  625    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
  630    NUMVAR(I)=IVAR
* Calcul de <H,F>reac
      CALL OPTIHF(MEMADR,IVRLC,VRLCMX,NUMVAR(2),NUMVAR(3),IHFLU)
* Charger le volume du coeur
      CALL LCMLEN(MEMADR(6),'OPT-PARAM-R',LENGT,ITYP)
      CALL SETARA(RBASE,LENGT,IOPTPR)
      CALL LCMGET(MEMADR(6),'OPT-PARAM-R',RBASE(IOPTPR))
      VCORE=RBASE(IOPTPR+10)
!* Definir CPPF
!      CPPF=1.0
* partie 1 du numerateur <H,F>Vj
      STFCN(2,1)=3
      OTFCN(2,1)='INTEGRAL'
      OTFCN(1,2)='CST-ZONE'
      STFCN(2,2)=3
      OTFCN(2,2)='ENERGY'
      VTFCN(1,2+NLVL2)=1
      STFCN(1,2+NLVL2)=NGRP
      STFCN(2,2+NLVL2)=1
      VTFCN(2,2+NLVL2)=NUMVAR(2)
      STFCN(3,2+NLVL2)=1
      VTFCN(3,2+NLVL2)=NUMVAR(3)
      STFCN(4,2+NLVL2)=3
      OTFCN(4,2+NLVL2)='*'
      STFCN(5,2+NLVL2)=3
      OTFCN(5,2+NLVL2)='END-ENERGY'
      STFCN(3,2)=3
      OTFCN(3,2)='END-INTEGRAL'
* Ans * Vrea/<H,F>reac / Vj
      STFCN(3,1)=2
      RTFCN(3,1)=VCORE/IHFLU
      STFCN(4,1)=3
      OTFCN(4,1)='*'
      STFCN(5,1)=4
      VTFCN(5,1)=NUMVAR(1)
      STFCN(6,1)=3
      OTFCN(6,1)='/'
      STFCN(7,1)=3
      OTFCN(7,1)='END'
      CALL RLSARA(RBASE(IOPTPR))
      RETURN
C---------------------------
C 77777777   0000     0000    
C       7   0    0   0    0 
C      7   0      0 0      0 
C     7    0      0 0      0  
C  77777   0      0 0      0  
C   7      0      0 0      0  
C  7        0    0   0    0  
C 7          0000     0000  
C---------------------------
C VARIABLES FOR DX-POWER
C              1                  2
C           Vrea       
C           ----*<DH,F>Vj,Vi - qj*<DH,F>reac
C            Vj    
C DX-POWER =--------------------------------
C                       <H,F>reac      
C---------------------------
  700 DO 720 I=1,NLVL1
         DO 720 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  720       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='FUNCZVOL'
      NAMVAR(2)='FUNCVALUE'
      NAMVAR(3)='H-FACTOR'
      NAMVAR(4)='FLUX'
      NAMVAR(5)='D-HFACT'
      DO 730 I=1,5
         IVAR=0
         DO 725 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  725    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//TEXT12//' NOT '
     1  //'DEFINED YET') 
  730    NUMVAR(I)=IVAR
* Calcul de <H,F>reac
      CALL OPTIHF(MEMADR,IVRLC,VRLCMX,NUMVAR(3),NUMVAR(4),IHFLU)
* Charger le volume du coeur
      CALL LCMLEN(MEMADR(6),'OPT-PARAM-R',LENGT,ITYP)
      CALL SETARA(RBASE,LENGT,IOPTPR)
      CALL LCMGET(MEMADR(6),'OPT-PARAM-R',RBASE(IOPTPR))
      VCORE=RBASE(IOPTPR+10)
* partie 1 du numerateur <DH,F>Vj,Vi
      STFCN(2,1)=3
      OTFCN(2,1)='INTEGRAL'
      OTFCN(1,2)='DBL-ZONE'
      STFCN(2,2)=3
      OTFCN(2,2)='ENERGY'
      VTFCN(1,2+NLVL2)=1
      STFCN(1,2+NLVL2)=NGRP
      STFCN(2,2+NLVL2)=1
      VTFCN(2,2+NLVL2)=NUMVAR(4)
      STFCN(3,2+NLVL2)=1
      VTFCN(3,2+NLVL2)=NUMVAR(5)
      STFCN(4,2+NLVL2)=3
      OTFCN(4,2+NLVL2)='*'
      STFCN(5,2+NLVL2)=3
      OTFCN(5,2+NLVL2)='END-ENERGY'
      STFCN(3,2)=3
      OTFCN(3,2)='END-INTEGRAL'
* partie1 = Ans * V / Vj
      STFCN(3,1)=2
      RTFCN(3,1)=VCORE
      STFCN(4,1)=3
      OTFCN(4,1)='*'
      STFCN(5,1)=4
      VTFCN(5,1)=NUMVAR(1)
      STFCN(6,1)=3
      OTFCN(6,1)='/'
* partie2 = qj*<DH,F>reac
      STFCN(7,1)=4
      VTFCN(7,1)=NUMVAR(2)
      STFCN(8,1)=3
      OTFCN(8,1)='INTEGRAL'
      OTFCN(1,3)='REACTOR'
      STFCN(2,3)=3
      OTFCN(2,3)='ENERGY'
      VTFCN(1,3+NLVL2)=1
      STFCN(1,3+NLVL2)=NGRP
      STFCN(2,3+NLVL2)=1
      VTFCN(2,3+NLVL2)=NUMVAR(4)
      STFCN(3,3+NLVL2)=1
      VTFCN(3,3+NLVL2)=NUMVAR(5)
      STFCN(4,3+NLVL2)=3
      OTFCN(4,3+NLVL2)='*'
      STFCN(5,3+NLVL2)=3
      OTFCN(5,3+NLVL2)='END-ENERGY'
      STFCN(3,3)=3
      OTFCN(3,3)='END-INTEGRAL'
      STFCN(9,1)=3
      OTFCN(9,1)='*'
*DX-POWER = (partie1 - partie2)/<H,F>reac
      STFCN(10,1)=3
      OTFCN(10,1)='-'
      STFCN(11,1)=2
      RTFCN(11,1)=IHFLU
      STFCN(12,1)=3
      OTFCN(12,1)='/'
      STFCN(13,1)=3
      OTFCN(13,1)='END'
      CALL RLSARA(RBASE(IOPTPR))
      RETURN
C---------------------------
C   8888     0000     0000    
C  8    8   0    0   0    0 
C 8      8 0      0 0      0 
C  888888  0      0 0      0  
C  8    8  0      0 0      0  
C 8      8 0      0 0      0  
C  8    8   0    0   0    0  
C   8888     0000     0000  
C---------------------------
C VARIABLES FOR DPHI-POWER
C                1            2
C              Vrea       
C              ----*H(rj) - qj*H(r)
C               Vj    
C DPHI-POWER = --------------------------------
C                       <H,F>reac      
C---------------------------
  800 DO 820 I=1,NLVL1
         DO 820 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  820       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='FUNCZVOL'
      NAMVAR(2)='FUNCVALUE'
      NAMVAR(3)='H-FACTOR'
      NAMVAR(4)='FLUX'
      DO 830 I=1,4
         IVAR=0
         DO 825 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  825    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
  830    NUMVAR(I)=IVAR
* Calcul de <H,F>reac
      CALL OPTIHF(MEMADR,IVRLC,VRLCMX,NUMVAR(3),NUMVAR(4),IHFLU)
* Charger le volume du coeur
      CALL LCMLEN(MEMADR(6),'OPT-PARAM-R',LENGT,ITYP)
      CALL SETARA(RBASE,LENGT,IOPTPR)
      CALL LCMGET(MEMADR(6),'OPT-PARAM-R',RBASE(IOPTPR))
      VCORE=RBASE(IOPTPR+10)
* partie 1 du numerateur H(rj)
      STFCN(2,1)=3
      OTFCN(2,1)='INTEGRAL'
      OTFCN(1,2)='DISCRETE-CST'
      STFCN(2,2)=3
      OTFCN(2,2)='ENERGY'
      VTFCN(1,2+NLVL2)=1
      STFCN(1,2+NLVL2)=NGRP
      STFCN(2,2+NLVL2)=1
      VTFCN(2,2+NLVL2)=NUMVAR(3)
      STFCN(3,2+NLVL2)=3
      OTFCN(3,2+NLVL2)='END-ENERGY'
      STFCN(3,2)=3
      OTFCN(3,2)='END-INTEGRAL'
* partie1 = Ans * V / Vj
      STFCN(3,1)=2
      RTFCN(3,1)=VCORE
      STFCN(4,1)=3
      OTFCN(4,1)='*'
      STFCN(5,1)=4
      VTFCN(5,1)=NUMVAR(1)
      STFCN(6,1)=3
      OTFCN(6,1)='/'
* partie2 = qj*H(r)
      STFCN(7,1)=4
      VTFCN(7,1)=NUMVAR(2)
      STFCN(8,1)=3
      OTFCN(8,1)='INTEGRAL'
      OTFCN(1,3)='DISCRETE-ALL'
      STFCN(2,3)=3
      OTFCN(2,3)='ENERGY'
      VTFCN(1,3+NLVL2)=1
      STFCN(1,3+NLVL2)=NGRP
      STFCN(2,3+NLVL2)=1
      VTFCN(2,3+NLVL2)=NUMVAR(3)
      STFCN(3,3+NLVL2)=3
      OTFCN(3,3+NLVL2)='END-ENERGY'
      STFCN(3,3)=3
      OTFCN(3,3)='END-INTEGRAL'
      STFCN(9,1)=3
      OTFCN(9,1)='*'
*DX-POWER = (partie1 - partie2)/<H,F>reac
      STFCN(10,1)=3
      OTFCN(10,1)='-'
      STFCN(11,1)=2
      RTFCN(11,1)=IHFLU
      STFCN(12,1)=3
      OTFCN(12,1)='/'
      STFCN(13,1)=3
      OTFCN(13,1)='END'
      CALL RLSARA(RBASE(IOPTPR))
      RETURN
C---------------------------
C   9999     0000     0000
C  9    9   0    0   0    0
C 9      9 0      0 0      0
C 9      9 0      0 0      0
C  99  999 0      0 0      0
C    99  9 0      0 0      0
C 9      9  0    0   0    0
C  999999    0000     0000
C---------------------------
C KEFF
C---------------------------
  900 DO 920 I=1,NLVL1
         DO 920 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
  920       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='KEFF'
      DO 930 I=1,1
         IVAR=0
         DO 925 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
  925    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
  930    NUMVAR(I)=IVAR
      STFCN(2,1)=1
      VTFCN(2,1)=NUMVAR(1)
      STFCN(3,1)=3
      OTFCN(3,1)='END'
      RETURN
C------------------------------------
C     1      0000     0000     0000     
C    11     0    0   0    0   0    0 
C   1 1    0      0 0      0 0      0 
C  1  1    0      0 0      0 0      0  
C 1   1    0      0 0      0 0      0  
C     1    0      0 0      0 0      0  
C     1     0    0   0    0   0    0 
C 11111111   0000     0000     0000
C------------------------------------
C D-KEFF=-KEFF^2*DLAMBDA
C---------------------------
 1000 DO 1020 I=1,NLVL1
         DO 1020 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1020       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='KEFF'
      NAMVAR(2)='D-LAMBDA'
      DO 1030 I=1,2
         IVAR=0
         DO 1025 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1025    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
 1030    NUMVAR(I)=IVAR
      STFCN(2,1)=2
      RTFCN(2,1)=-1.0
      STFCN(3,1)=1
      VTFCN(3,1)=NUMVAR(1)
      STFCN(4,1)=2
      RTFCN(4,1)=2.0
      STFCN(5,1)=3
      OTFCN(5,1)='POWER'
      STFCN(6,1)=1
      VTFCN(6,1)=NUMVAR(2)
      STFCN(7,1)=3
      OTFCN(7,1)='*'
      STFCN(8,1)=3
      OTFCN(8,1)='*'
      STFCN(9,1)=3
      OTFCN(9,1)='*'
      STFCN(10,1)=3
      OTFCN(10,1)='END'
      RETURN
C------------------------------------
C     1         1     0000     0000    
C    11        11    0    0   0    0 
C   1 1       1 1   0      0 0      0 
C  1  1      1  1   0      0 0      0  
C 1   1     1   1   0      0 0      0  
C     1         1   0      0 0      0  
C     1         1    0    0   0    0  
C 11111111 11111111   0000     0000  
C------------------------------------
C                1      1
C VOID-REAC-FC=---- - ------
C              Keff   Keff,v
C---------------------------
 1100 DO 1120 I=1,NLVL1
         DO 1120 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1120       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='KEFF'
      NAMVAR(2)='KEFF-VOID'
      DO 1130 I=1,2
         IVAR=0
         DO 1125 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1125    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
 1130    NUMVAR(I)=IVAR
      STFCN(2,1)=2
      RTFCN(2,1)=1.0
      STFCN(3,1)=1
      VTFCN(3,1)=NUMVAR(1)
      STFCN(4,1)=3
      OTFCN(4,1)='/'
      STFCN(5,1)=2
      RTFCN(5,1)=1.0
      STFCN(6,1)=1
      VTFCN(6,1)=NUMVAR(2)
      STFCN(7,1)=3
      OTFCN(7,1)='/'
      STFCN(8,1)=3
      OTFCN(8,1)='-'
      STFCN(9,1)=3
      OTFCN(9,1)='END'
      RETURN
C------------------------------------
C     1      2222     0000     0000    
C    11     2    2   0    0   0    0 
C   1 1    2      2 0      0 0      0 
C  1  1          2  0      0 0      0  
C 1   1         2   0      0 0      0  
C     1      22     0      0 0      0  
C     1     2        0    0   0    0  
C 11111111 22222222   0000     0000  
C------------------------------------
C D-VOID-R-FC = D-LAMBDA - D-LAMBDA-V
C------------------------------------
 1200 DO 1220 I=1,NLVL1
         DO 1220 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1220       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='D-LAMBDA'
      NAMVAR(2)='D-LAMBDA-V'
      DO 1230 I=1,2
         IVAR=0
         DO 1225 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1225    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
 1230    NUMVAR(I)=IVAR
      STFCN(2,1)=1
      VTFCN(2,1)=NUMVAR(1)
      STFCN(3,1)=1
      VTFCN(3,1)=NUMVAR(2)
      STFCN(4,1)=3
      OTFCN(4,1)='-'
      STFCN(5,1)=3
      OTFCN(5,1)='END'
      RETURN
C------------------------------------
C     1      3333     0000     0000    
C    11     3    3   0    0   0    0 
C   1 1    3      3 0      0 0      0 
C  1  1         33  0      0 0      0  
C 1   1          3  0      0 0      0  
C     1    3      3 0      0 0      0  
C     1     3    3   0    0   0    0  
C 11111111   3333     0000     0000  
C------------------------------------
C GPT-D-SOUR ( DIRECT SOURCE )
C NOTE: cela mets juste les variables MAT*PHI dans VTFCN
C         et ne correspond a aucune formule
 1300 DO 1320 I=1,NLVL1
         DO 1320 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1320       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='A*PHI'
      NAMVAR(2)='AP*PHI'
      NAMVAR(3)='B*PHI'
      NAMVAR(4)='BP*PHI'
      DO 1330 I=1,4
         IVAR=0
         DO 1325 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1325    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
 1330    VTFCN(1+I,1)=IVAR
      RETURN
C---------------------------
C     1        4      0000     0000    
C    11       44     0    0   0    0 
C   1 1      4 4    0      0 0      0 
C  1  1     4  4    0      0 0      0  
C 1   1    4   4    0      0 0      0  
C     1     4444444 0      0 0      0  
C     1        4     0    0   0    0  
C 11111111     4      0000     0000    
C---------------------------
C KEFF=KREF = (KEFF - KREF)**2
C NOTE: cela mets juste les variables KEFF et KREF dans VTFCN
C         et ne correspond a aucune formule dans la definition
C         de la sequence mais le calcul sera fait dans OPTEVL
C---------------------------
 1400 DO 1420 I=1,NLVL1
         DO 1420 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1420       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='KEFF'
      NAMVAR(2)='KREF'
      DO 1430 I=1,2
         IVAR=0
         DO 1425 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1425    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET') 
 1430    VTFCN(1+I,1)=IVAR

      RETURN
C---------------------------
C     1    55555555   0000     0000    
C    11    5         0    0   0    0 
C   1 1    5  55    0      0 0      0 
C  1  1    555  55  0      0 0      0  
C 1   1           5 0      0 0      0  
C     1           5 0      0 0      0  
C     1    55    55  0    0   0    0  
C 11111111 555555    0000     0000  
C---------------------------
C D-KEFF=KREF = 2 * (KEFF - KREF) * (KEFF**2) * D-LAMBDA
C NOTE: cela mets juste les variables KEFF et KREF dans VTFCN
C         et ne correspond a aucune formule dans la definition
C         de la sequence mais le calcul sera fait dans OPTEVL
C---------------------------
 1500 DO 1520 I=1,NLVL1
         DO 1520 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1520       OTFCN(I,J)=' ' 
*numero des variables
      NAMVAR(1)='KEFF'
      NAMVAR(2)='KREF'
      NAMVAR(3)='D-LAMBDA'
      DO 1530 I=1,3
         IVAR=0
         DO 1525 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1525    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET')
 1530    VTFCN(1+I,1)=IVAR
      RETURN

C---------------------------
C     1     666666    0000     0000
C    11    6      6  0    0   0    0
C   1 1    6  66    0      0 0      0
C  1  1    666  66  0      0 0      0
C 1   1    6      6 0      0 0      0
C     1    6      6 0      0 0      0
C     1     6    6   0    0   0    0
C 11111111   6666     0000     0000
C---------------------------
C MINPCMAX
C---------------------------
 1600 DO 1620 I=1,NLVL1
         DO 1620 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1620       OTFCN(I,J)=' '
*numero des variables
      NAMVAR(1)='FUNCVALUE'
      NAMVAR(2)='QMOY'
      NAMVAR(3)='IFCT1'
      NAMVAR(4)='IFCT2'
      DO 1630 I=1,4
         IVAR=0
         DO 1625 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1625    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET')
 1630    VTFCN(1+I,1)=IVAR
      RETURN

C---------------------------
C     1    77777777   0000     0000
C    11          7   0    0   0    0
C   1 1         7   0      0 0      0
C  1  1        7    0      0 0      0
C 1   1     77777   0      0 0      0
C     1      7      0      0 0      0
C     1     7        0    0   0    0
C 11111111 7          0000     0000
C---------------------------
C D-MINPCMAX
C---------------------------
 1700 DO 1720 I=1,NLVL1
         DO 1720 J=1,1+2*NLVL2
            STFCN(I,J)=0
            VTFCN(I,J)=0
            RTFCN(I,J)=ALMST0
 1720       OTFCN(I,J)=' '
*numero des variables
      NAMVAR(1)='FUNCVALUE'
      NAMVAR(2)='QMOY'
      NAMVAR(3)='IFCT1'
      NAMVAR(4)='IFCT2'
      NAMVAR(5)='GRADVALUE(X)'
      DO 1730 I=1,5
         IVAR=0
         DO 1725 J=1,VRLCMX
            IF (TVRLC(J).EQ.NAMVAR(I)) THEN
               IVAR=J
            ENDIF
 1725    CONTINUE
         IF (IVAR.EQ.0) CALL XABORT('OPTSEQ: '//NAMVAR(I)
     1  //' NOT DEFINED YET')
 1730    VTFCN(1+I,1)=IVAR
      RETURN

C---------------------------
C END
C---------------------------
      END
