*DECK OPTSUP
      SUBROUTINE OPTSUP(MEMADR,STFCN,VTFCN,RTFCN,NLVL1,NLVL2,IVRLC,
     1                  VRLCMX,IFCT)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine updates the sequence of calculation for function 
*  evaluation.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
*  MEMADR : adress memory of lcm objects (cf OPTVDF.f)
*  STFCN  : Sequence of the tables to get the information
*  VTFCN  : Table of number of local array variables
*  RTFCN  : Table of real
*  NLVL1  : Number of maximum operation and real in one level
*  NLVL2  : Number of integration maximum in one evaluation
*  IVRLC  : Table of offset of local array variables
*  VRLCMX : Number maximum of local array variables
*  IFCT   : Number of the function to update 
*            0=f obj, 1 and more for constraint number
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   MEMADR(20),NLVL1,NLVL2,VRLCMX,IFCT
      INTEGER   STFCN(NLVL1,1+2*NLVL2),VTFCN(NLVL1,1+2*NLVL2),
     1          IVRLC(VRLCMX)
      REAL      RTFCN(NLVL1,1+2*NLVL2)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   I,J

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
*    chercher les operations de type 4 dans la sequence
*       pour remplacer la valeur reelle correspondante
      DO 110 I=2,NLVL1
      DO 110 J=1,1+2*NLVL2
        IF (STFCN(I,J).EQ.4) THEN
           RTFCN(I,J)=RBASE(IVRLC(VTFCN(I,J))+IFCT)
        ENDIF
  110 CONTINUE
      RETURN
      END
