*DECK OPTVDF
      SUBROUTINE OPTVDF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXTPDF,
     1                  TEXT12,NENTRY,KENTRY,HENTRY)
*
*-----------------------------------------------------------------------
* 
*Purpose:
* this subroutine loads local array variable.
* OPTVDF = OPTimization local Variables DeFinition
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
*  MEMADR : Adress memory of lcm objects
*  1 L_GEOM           11 L_SYSTEM #2        (in GPTGRD)
*  2 L_MAP            12
*  3 L_FLUX           13 L_FLUX #2 ou GenAd (in FOBJCT or in GPTGRD)
*  4 L_SYSTEM         14 L_SYSTEM #2 ou P   (in FOBJCT or in GPTGRD)
*  5 L_GPT            15
*  6 L_OPTIMIZE       16
*  7 L_MACROLIB       17 L_MACROLIB P
*  8 L_MATEX          18
*  9 L_TRACK          19 L_SYSTEM #2P       (in GPTGRD)
* 10 L_TABLE          20
*  IVRLC  : Table of offset of local array variables
*  TVRLC  : Table of name of local array variables
*  LVRLC  : Table of logical representing  if a local array variable 
*           is defined
*  VRLCMX : Number maximum of local array variables
*  NGRP   : Number of energy groups
*  TXTPDF : Nom de fonction predefinie
*  TEXT12 : Character variable for the REDGET of the calling module
*  NENTRY : number of lcm objects or files used by the module
*  HENTRY : Character*12 name of each lcm object or file
*  KENTRY : File unit number; =lcm object address otherwise
*           kentry(nentry)
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   MEMADR(20),VRLCMX,NGRP,NENTRY
      INTEGER   IVRLC(VRLCMX),KENTRY(NENTRY)
      CHARACTER TEXT12*12,TXTPDF*12,TVRLC(VRLCMX)*12,HENTRY(NENTRY)*12
      LOGICAL   LVRLC(VRLCMX)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   NITMA,I,J,ITYP,SIGNA(3),IPTRK,IPFLU,IPSYS,IPLIST
      DOUBLE PRECISION DFLOTT
      REAL      FLOTT,QMOY
      CHARACTER TXT12B*12,TXT12C*12
*'Local arrays' variable
      INTEGER   NVRLC,NUN,NDATA,I1,IFCT1,IFCT2,LL4,OPTION,ITY,IFLUX,
     1          IWORK
      LOGICAL   LTST

      INTEGER  OPTPRI(40),SYSPRM(40)

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

      IF (TXTPDF.EQ.' ') THEN
         RETURN
      ELSEIF (TXTPDF.EQ.'FUNCTION') THEN
         GO TO 100
      ELSEIF (TXTPDF.EQ.'D-LAMBDA') THEN
         GO TO 200
      ELSEIF (TXTPDF.EQ.'UCOST') THEN
         GO TO 300
      ELSEIF (TXTPDF.EQ.'DX-UCOST') THEN
         GO TO 400
      ELSEIF (TXTPDF.EQ.'DPHI-UCOST') THEN
         GO TO 500
      ELSEIF (TXTPDF.EQ.'POWERLIMIT') THEN
         GO TO 600
      ELSEIF (TXTPDF.EQ.'DX-POWER') THEN
         GO TO 700
      ELSEIF (TXTPDF.EQ.'DPHI-POWER') THEN
         GO TO 800
      ELSEIF (TXTPDF.EQ.'KEFF') THEN
         GO TO 900
      ELSEIF (TXTPDF.EQ.'D-KEFF') THEN
         GO TO 1000
      ELSEIF (TXTPDF.EQ.'VOID-REAC-FC') THEN
         GO TO 1100
      ELSEIF (TXTPDF.EQ.'D-VOID-R-FC') THEN
         GO TO 1200
      ELSEIF (TXTPDF.EQ.'GPT-D-SOUR') THEN
         GO TO 1300
      ELSEIF (TXTPDF.EQ.'KEFF=KREF') THEN
         GO TO 1400
      ELSEIF (TXTPDF.EQ.'D-KEFF=KREF') THEN
         GO TO 1500
      ELSEIF (TXTPDF.EQ.'MINPCMAX') THEN
         GO TO 1600
      ELSEIF (TXTPDF.EQ.'D-MINPCMAX') THEN
         GO TO 1700
      ELSE
         CALL XABORT('OPTVDF:'//TXTPDF//' WRONG FUNCTION NAME')
      ENDIF
      

C---------------------------
C     1      0000     0000
C    11     0    0   0    0
C   1 1    0      0 0      0
C  1  1    0      0 0      0
C 1   1    0      0 0      0
C     1    0      0 0      0
C     1     0    0   0    0
C 11111111   0000     0000
C---------------------------
C VARIABLE DEFINED MANUALY
C---------------------------
  100 CONTINUE
  104 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*     charger une variable contenue dans un repertoire d<un objet
      IF (TEXT12.EQ.'LOAD') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED') 
         I1=0
         DO 105 I=1,NENTRY
            IF (TEXT12.EQ.HENTRY(I)) THEN
               I1=I
            ENDIF
  105       CONTINUE
         IF (I1.EQ.0) CALL XABORT('OPTVDF: WRONG NAME OF OBJECT')
  110    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*          changer de repertoire
         IF (TEXT12.EQ.'DOWN') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
            CALL LCMLEN(KENTRY(I1),TEXT12,NITMA,ITYP)
            IF (NITMA.EQ.0) CALL XABORT('OPTVDF: THIS SUBDIRECTORY '
     1  //'DOES NOT EXIST') 
            CALL LCMSIX(KENTRY(I1),TEXT12,1)
            GO TO 110
*          identifier les donnees a charger
         ELSEIF (TEXT12.EQ.'GREP') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
            IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
            CALL LCMLEN(KENTRY(I1),TXT12B,NDATA,ITYP)
            IF (NDATA.LE.0) CALL XABORT('OPTVDF: THESE DATAS  '
     1  //'DO NOT EXIST IN THIS DIRECTORY')
            GO TO 110
*          les charger dans la variable locale
         ELSEIF (TEXT12.EQ.'IN') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*              nom de variable valide et quel est son numero
            IF (ITYP.NE.3) CALL XABORT('OPTVDF: LOCAL VARIABLE NAME'
     1   //' EXPECTED')
            LTST=.TRUE.
            DO 115 I=1,VRLCMX
               IF (TVRLC(I).EQ.TEXT12) WRITE(6,*) 'OPTVDF: THIS '
     1   //'LOCAL VARIABLE ALREADY EXIST'
               IF ((LTST).AND.(.NOT.LVRLC(I))) THEN
                  LTST=.FALSE.
                  NVRLC=I
                  TVRLC(I)=TEXT12
                  LVRLC(I)=.TRUE.
               ENDIF
  115          CONTINUE
            CALL SETARA(RBASE,NDATA,IVRLC(NVRLC))
            CALL LCMGET(KENTRY(I1),TXT12B,RBASE(IVRLC(NVRLC)))
            GO TO 104
         ELSE
            CALL XABORT('OPTVDF: KEYWORD DOWN, GREP or IN EXPECTED')
         ENDIF
*     charger une variable contenue dans un repertoire d'un objet
      ELSEIF (TEXT12.EQ.'PREDEF') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
         CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
         GO TO 104
*     precalcul d'une variable type MSYS*PHI
      ELSEIF (TEXT12.EQ.'MSYS*FLUX') THEN 
         CALL LCMGET(MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN  =OPTPRI(19)
         IPTRK=MEMADR(9)
*        objet SYSTEM
         CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
         IPLIST=0
         DO 120 I=1,NENTRY
         IF (TXT12B.EQ.HENTRY(I)) IPLIST=KENTRY(I)
  120       CONTINUE
         IF (IPLIST.EQ.0) CALL XABORT('OPTVDF: '//TXT12B//' NOT A '
     1  //'VALID OBJECT NAME')
         CALL LCMGET(IPLIST,'SIGNATURE',SIGNA)
         WRITE(TXT12C,'(3A4)') (SIGNA(J),J=1,3)
         IF (TXT12C.NE.'L_SYSTEM') CALL XABORT('OPTVDF: '//TXT12B
     1  //'NOT A L_SYSTEM OBJECT')
*        option A ou B
         CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
         IF ((TXT12B.NE.'A').AND.(TXT12B.NE.'B')) CALL XABORT('OPTVDF: '
     1  //' "A" OR "B" KEYWORD EXPECTED')
         IF (TXT12B.EQ.'A') THEN
            OPTION=1
         ELSE
            OPTION=2
         ENDIF
         IPSYS=IPLIST
*        objet FLUX
         CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
         IPLIST=0
         DO 121 I=1,NENTRY
            IF (TXT12B.EQ.HENTRY(I)) IPLIST=KENTRY(I)
  121    CONTINUE
         IF (IPLIST.EQ.0) CALL XABORT('OPTVDF: '//TXT12B//' NOT A '
     1  //'VALID OBJECT NAME')
         CALL LCMGET(IPLIST,'SIGNATURE',SIGNA)
         WRITE(TXT12C,'(3A4)') (SIGNA(J),J=1,3)
         IF (TXT12C.NE.'L_FLUX') CALL XABORT('OPTVDF: '//TXT12B//' NOT'
     1  //' A L_FLUX OBJECT')
         IPFLU=IPLIST
*        option ADJOINT
         CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
         IF (TXT12B.EQ.'ADJOINT') THEN
            OPTION=OPTION+2
         ELSEIF (TXT12B.EQ.'IN') THEN
            GO TO 122
         ENDIF
*        sauvegarde de la variable
         CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: CHARACTER EXPECTED')
         IF (TXT12B.NE.'IN') CALL XABORT('OPTVDF: "IN" EXPECTED')
  122    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*              nom de variable valide et quel est son numero
         IF (ITYP.NE.3) CALL XABORT('OPTVDF: LOCAL VARIABLE NAME'
     1   //' EXPECTED')
          LTST=.TRUE.
         DO 125 I=1,VRLCMX
            IF (TVRLC(I).EQ.TEXT12) WRITE(6,*) 'OPTVDF: THIS '
     1   //'LOCAL VARIABLE ALREADY EXIST'
            IF ((LTST).AND.(.NOT.LVRLC(I))) THEN
               LTST=.FALSE.
               NVRLC=I
               TVRLC(I)=TEXT12
               LVRLC(I)=.TRUE.
            ENDIF
  125       CONTINUE
         CALL SETARA(RBASE,NUN*NGRP,IVRLC(NVRLC))
*        calcul de la variable
         CALL SETARA(RBASE,NUN,IFLUX)
         CALL SETARA(RBASE,NUN,IWORK)
         CALL LCMGET(IPSYS,'STATE-VECTOR',SYSPRM)
         LL4=SYSPRM(2)
         ITY=SYSPRM(4)
         CALL MTOPEN(0,IPTRK,LL4)
         CALL OPTAFI(IPFLU,IPTRK,IPSYS,NUN,NGRP,LL4,ITY,OPTION,
     1              RBASE(IVRLC(NVRLC)),RBASE(IFLUX),RBASE(IWORK))
         CALL RLSARA(RBASE(IFLUX))
         CALL RLSARA(RBASE(IWORK))
         GO TO 104
      ENDIF
      RETURN
C---------------------------
C   2222     0000     0000    
C  2    2   0    0   0    0 
C 2      2 0      0 0      0 
C       2  0      0 0      0  
C      2   0      0 0      0  
C   22     0      0 0      0  
C  2        0    0   0    0  
C 22222222   0000     0000  
C---------------------------
C VARIABLES FOR D-LAMBDA
C---------------------------
  200 TXT12B='AFLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='A*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='B*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='AP*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='BP*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C   3333     0000     0000    
C  3    3   0    0   0    0 
C 3      3 0      0 0      0 
C      33  0      0 0      0  
C       3  0      0 0      0  
C 3      3 0      0 0      0  
C  3    3   0    0   0    0  
C   3333     0000     0000  
C---------------------------
C VARIABLES FOR UCOST
C---------------------------
  300 TXT12B='FUEL-C-DIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='BURN-E-DIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='H-FACTOR'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C     4      0000     0000    
C    44     0    0   0    0 
C   4 4    0      0 0      0 
C  4  4    0      0 0      0  
C 4   4    0      0 0      0  
C  4444444 0      0 0      0  
C     4     0    0   0    0  
C     4      0000     0000    
C---------------------------
C VARIABLES FOR DX-UCOST
C---------------------------
  400 TXT12B='FUEL-C-DIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='BURN-E-DIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='H-FACTOR'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='D-HFACT'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='D-FCDIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='D-BEDIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C 55555555   0000     0000    
C 5         0    0   0    0 
C 5  55    0      0 0      0 
C 555  55  0      0 0      0  
C        5 0      0 0      0  
C        5 0      0 0      0  
C 55    55  0    0   0    0  
C  555555    0000     0000  
C---------------------------
C VARIABLES FOR DPHI-UCOST
C---------------------------
  500 TXT12B='FUEL-C-DIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='BURN-E-DIST'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='H-FACTOR'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C  666666    0000     0000
C 6      6  0    0   0    0 
C 6  66    0      0 0      0 
C 666  66  0      0 0      0  
C 6      6 0      0 0      0  
C 6      6 0      0 0      0  
C  6    6   0    0   0    0  
C   6666     0000     0000  
C---------------------------
C VARIABLES FOR POWERLIMIT
C---------------------------
  600 TXT12B='FUNCZVOL'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='H-FACTOR'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
!      TXT12B='CPPF'
!      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C 77777777   0000     0000    
C       7   0    0   0    0 
C      7   0      0 0      0 
C     7    0      0 0      0  
C  77777   0      0 0      0  
C   7      0      0 0      0  
C  7        0    0   0    0  
C 7          0000     0000  
C---------------------------
C VARIABLES FOR DX-POWER
C---------------------------
  700 TXT12B='FUNCZVOL'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FUNCVALUE'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='H-FACTOR'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='D-HFACT'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
!      TXT12B='CPPF'
!      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C   8888     0000     0000    
C  8    8   0    0   0    0 
C 8      8 0      0 0      0 
C  888888  0      0 0      0  
C  8    8  0      0 0      0  
C 8      8 0      0 0      0  
C  8    8   0    0   0    0  
C   8888     0000     0000  
C---------------------------
C VARIABLES FOR DPHI-POWER
C---------------------------
  800 TXT12B='FUNCZVOL'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FUNCVALUE'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='H-FACTOR'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='FLUX'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
!      TXT12B='CPPF'
!      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C---------------------------
C   9999     0000     0000
C  9    9   0    0   0    0
C 9      9 0      0 0      0
C 9      9 0      0 0      0
C  99  999 0      0 0      0
C    99  9 0      0 0      0
C 9      9  0    0   0    0
C  999999    0000     0000
C---------------------------
C VARIABLES FOR KEFF
C---------------------------
  900 TXT12B='KEFF'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C------------------------------------
C     1      0000     0000     0000     
C    11     0    0   0    0   0    0 
C   1 1    0      0 0      0 0      0 
C  1  1    0      0 0      0 0      0  
C 1   1    0      0 0      0 0      0  
C     1    0      0 0      0 0      0  
C     1     0    0   0    0   0    0 
C 11111111   0000     0000     0000
C------------------------------------
C VARIABLES FOR D-KEFF
C---------------------------
 1000 TXT12B='KEFF'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='D-LAMBDA'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C------------------------------------
C     1         1     0000     0000    
C    11        11    0    0   0    0 
C   1 1       1 1   0      0 0      0 
C  1  1      1  1   0      0 0      0  
C 1   1     1   1   0      0 0      0  
C     1         1   0      0 0      0  
C     1         1    0    0   0    0  
C 11111111 11111111   0000     0000  
C------------------------------------
C VARIABLES FOR VOID-REAC-FC
C---------------------------
 1100 TXT12B='KEFF'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='KEFF-VOID'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C------------------------------------
C     1      2222     0000     0000    
C    11     2    2   0    0   0    0 
C   1 1    2      2 0      0 0      0 
C  1  1          2  0      0 0      0  
C 1   1         2   0      0 0      0  
C     1      22     0      0 0      0  
C     1     2        0    0   0    0  
C 11111111 22222222   0000     0000  
C------------------------------------
C VARIABLES FOR DX-VOID-R-FC
C---------------------------
 1200 TXT12B='D-LAMBDA'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='D-LAMBDA-V'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN
C------------------------------------
C     1      3333     0000     0000    
C    11     3    3   0    0   0    0 
C   1 1    3      3 0      0 0      0 
C  1  1         33  0      0 0      0  
C 1   1          3  0      0 0      0  
C     1    3      3 0      0 0      0  
C     1     3    3   0    0   0    0  
C 11111111   3333     0000     0000  
C------------------------------------
C GPT-D-SOUR ( DIRECT SOURCE )
C---------------------------
 1300 TXT12B='A*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='B*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='AP*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='BP*PHI'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      RETURN

C---------------------------
C     1        4      0000     0000    
C    11       44     0    0   0    0 
C   1 1      4 4    0      0 0      0 
C  1  1     4  4    0      0 0      0  
C 1   1    4   4    0      0 0      0  
C     1     4444444 0      0 0      0  
C     1        4     0    0   0    0  
C 11111111     4      0000     0000
C---------------------------
C KEFF=KREF
C---------------------------
 1400 TXT12B='KEFF'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
*     KREF
      TXT12B='KREF'
      CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
      IF (ITYP.NE.2) CALL XABORT('OPTVDF: real value for Kref'
     1  //'expected')
      LTST=.TRUE.
      DO 1415 I=1,VRLCMX
         IF (TVRLC(I).EQ.TXT12B) WRITE(6,*) 'OPTVDF: THIS '
     1   //'LOCAL VARIABLE ALREADY EXIST'
         IF ((LTST).AND.(.NOT.LVRLC(I))) THEN
            LTST=.FALSE.
            NVRLC=I
            TVRLC(I)='KREF'
            LVRLC(I)=.TRUE.
         ENDIF
 1415    CONTINUE
      CALL SETARA(RBASE,1,IVRLC(NVRLC))
      RBASE(IVRLC(NVRLC))=FLOTT
      RETURN

C---------------------------
C     1    55555555   0000     0000
C    11    5         0    0   0    0
C   1 1    5  55    0      0 0      0
C  1  1    555  55  0      0 0      0
C 1   1           5 0      0 0      0
C     1           5 0      0 0      0
C     1    55    55  0    0   0    0
C 11111111 555555    0000     0000
C---------------------------
C D-KEFF=KREF
C---------------------------
 1500 TXT12B='D-LAMBDA'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      TXT12B='KEFF'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
*     KREF
      TXT12B='KREF'
      CALL REDGET(ITYP,NITMA,FLOTT,TXT12B,DFLOTT)
      IF (ITYP.NE.2) CALL XABORT('OPTVDF: real value for Kref'
     1  //'expected')
      LTST=.TRUE.
      DO 1515 I=1,VRLCMX
         IF (TVRLC(I).EQ.TXT12B) WRITE(6,*) 'OPTVDF: THIS '
     1   //'LOCAL VARIABLE ALREADY EXIST'
         IF ((LTST).AND.(.NOT.LVRLC(I))) THEN
            LTST=.FALSE.
            NVRLC=I
            TVRLC(I)='KREF'
            LVRLC(I)=.TRUE.
         ENDIF
 1515    CONTINUE
      CALL SETARA(RBASE,1,IVRLC(NVRLC))
      RBASE(IVRLC(NVRLC))=FLOTT
      RETURN

C---------------------------
C     1     666666    0000     0000
C    11    6      6  0    0   0    0
C   1 1    6  66    0      0 0      0
C  1  1    666  66  0      0 0      0
C 1   1    6      6 0      0 0      0
C     1    6      6 0      0 0      0
C     1     6    6   0    0   0    0
C 11111111   6666     0000     0000
C---------------------------
C MINPCMAX
C---------------------------
 1600 TXT12B='FUNCVALUE'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
*     QMOY
      CALL REDGET(ITYP,NITMA,QMOY,TXT12B,DFLOTT)
      IF (ITYP.NE.2) CALL XABORT('OPTVDF: real value for Qmoy'
     1  //'expected')
      CALL REDGET(ITYP,IFCT1,FLOTT,TXT12B,DFLOTT)
      IF (ITYP.NE.1) CALL XABORT('OPTVDF: integer value for'
     1  //' for IFCT1 expected')
      CALL REDGET(ITYP,IFCT2,FLOTT,TXT12B,DFLOTT)
      IF (ITYP.NE.1) CALL XABORT('OPTVDF: integer value for'
     1  //' for IFCT2 expected')
      DO 1615 J=1,3
      IF (J.EQ.1) TXT12B='QMOY'
      IF (J.EQ.2) TXT12B='IFCT1'
      IF (J.EQ.3) TXT12B='IFCT2'
      LTST=.TRUE.
      DO 1610 I=1,VRLCMX
         IF (TVRLC(I).EQ.TXT12B) WRITE(6,*) 'OPTVDF: THIS '
     1   //'LOCAL VARIABLE ALREADY EXIST'
         IF ((LTST).AND.(.NOT.LVRLC(I))) THEN
            LTST=.FALSE.
            NVRLC=I
            TVRLC(I)=TXT12B
            LVRLC(I)=.TRUE.
         ENDIF
 1610    CONTINUE
      CALL SETARA(RBASE,1,IVRLC(NVRLC))
      IF (J.EQ.1) RBASE(IVRLC(NVRLC))=QMOY
      IF (J.EQ.2) RBASE(IVRLC(NVRLC))=REAL(IFCT1)
      IF (J.EQ.3) RBASE(IVRLC(NVRLC))=REAL(IFCT2)
 1615 CONTINUE
      RETURN

C---------------------------
C     1    77777777   0000     0000
C    11          7   0    0   0    0
C   1 1         7   0      0 0      0
C  1  1        7    0      0 0      0
C 1   1     77777   0      0 0      0
C     1      7      0      0 0      0
C     1     7        0    0   0    0
C 11111111 7          0000     0000
C---------------------------
C D-MINPCMAX
C---------------------------
 1700 TXT12B='GRADVALUE(X)'
      CALL OPTADF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXT12B)
      GOTO 1600
C---------------------------
C END
C---------------------------
      END
