* DECK OPTVUP
      SUBROUTINE OPTVUP(IVRLC,TVRLC,LVRLC,MEMADR,IVAR,VTFCN,VRLCMX,
     1    NLVL1,NLVL2,NVDXS,NGRP,INDIC)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine updates predefined local array variables.
* OPTVUP = OPTimization local Variables UPdate
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
*  MEMADR : adress memory of lcm objects (cf OPTVDF.f)
*  IVRLC  : Table of offset of local array variables
*  TVRLC  : Table of name of local array variables
*  IVAR   : Number of the optimization variable to update XS
*           (not used if INDIC=1)
*  VTFCN  : Number of local array variables in the sequences
*  NLVL1  : number maximum of operation in one sequence level 1
*  NLVL2  : number maximum of integral in one function
*  NGRP   : Number of energy groups
*  NVDXS  : Table of number of local array variables which 
*           has to be updated (if = 0 the corresponding perturbated 
*           XS does not to be updated)
*           #1 - TOTAL
*  INDIC  : =1 NVDXS is created
*           =2 NVDXS is used, and XS updated
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   MEMADR(20),IVAR,VRLCMX,NLVL1,NLVL2,INDIC,NBTDXS,NGRP
      PARAMETER (NBTDXS=18)
      INTEGER   IVRLC(VRLCMX),VTFCN(NLVL1,1+2*NLVL2),NVDXS(NBTDXS)
      CHARACTER TVRLC(VRLCMX)*12
      LOGICAL   LVRLC(VRLCMX)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   NITMA,I,J,ITYP,IXS,NSTATE
      INTEGER JPLIST,KPLIST,LCMGID,LCMGIL
      PARAMETER (NSTATE=40)
      CHARACTER TEXT12*12,TXT12B*12
* STATE-VECTOR VARIABLES
      INTEGER   OPTPRI(NSTATE),TRKPRM(NSTATE),SYSPRM(NSTATE)
* Dimension of tables
      INTEGER   NUN
*'Local arrays' variable
      INTEGER   IPLIST,NSCAT,ISCAT,IVARL
*Volume considerations
      INTEGER   IELEM,ICHX,IDIM0,IDIM,IR,MAXKN,NEL,LL4,VOL,KN,MAT,IGAR,
     1          SIGNA(3),SIG
*AP*PHI
      INTEGER   ITY,OPTION,IFLUX,IWORK
*D-LAMBDA
      INTEGER   IDATA
*GRADIENT(X)
      INTEGER   NVAR,NCST,IGRAD

      LOGICAL   LDUAL,CYLIND

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
C---------------------------
C WHICH ARE THE NUMBER LOCAL ARRAY VARIABLES
C  AND WHAT DO THEY CORRESPOND TO
C---------------------------
      IF(INDIC.EQ.1) THEN
      DO 10 IXS=1,NBTDXS
   10    NVDXS(IXS)=0
      DO 100 I=1,1+2*NLVL2
         DO 100 J=2,NLVL1
            IF(VTFCN(J,I).NE.0) THEN
               IF(.NOT.LVRLC(VTFCN(J,I))) CALL XABORT('OPTVUP: '
     1  //'SOMETHING WRONG WITH LOCAL VARIABLE')
               TEXT12=TVRLC(VTFCN(J,I))
               IF(TEXT12.EQ.'D-TOTAL')  NVDXS(1) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-CHI')    NVDXS(2) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-DIFFX')  NVDXS(3) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-DIFFY')  NVDXS(4) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-DIFFZ')  NVDXS(5) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-NUSIGF') NVDXS(6) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-NFTOT')  NVDXS(7) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-HFACT')  NVDXS(8) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-OVER')   NVDXS(13)=VTFCN(J,I)
               IF(TEXT12.EQ.'D-SIGW0')  NVDXS(10)=VTFCN(J,I)
               IF(TEXT12.EQ.'D-SIGW1')  NVDXS(12)=VTFCN(J,I)
               IF(TEXT12.EQ.'D-SCAT0')  NVDXS(9) =VTFCN(J,I)
               IF(TEXT12.EQ.'D-SCAT1')  NVDXS(11)=VTFCN(J,I)
               IF(TEXT12.EQ.'AP*PHI')   NVDXS(14)=VTFCN(J,I)
               IF(TEXT12.EQ.'BP*PHI')   NVDXS(15)=VTFCN(J,I)
               IF(TEXT12.EQ.'D-LAMBDA')   NVDXS(16)=VTFCN(J,I)
               IF(TEXT12.EQ.'D-LAMBDA-V') NVDXS(17)=VTFCN(J,I)
               IF(TEXT12.EQ.'GRADVALUE(X)') NVDXS(18)=VTFCN(J,I)
            ENDIF
 100     CONTINUE
      RETURN
      ENDIF
C---------------------------
C UPDATE PERTURBATED XS IF APPLICABLE
C---------------------------
      IF(INDIC.EQ.2) THEN
      DO 300 IXS=1,NBTDXS
      IVARL=NVDXS(IXS)
      IF(IVARL.NE.0) THEN
!!!!!!!!!!!!!!!!
!debut indentation
      IF(IXS.EQ.1)  TEXT12='NTOT0'
      IF(IXS.EQ.2)  TEXT12='CHI'
      IF(IXS.EQ.3)  TEXT12='DIFFX'
      IF(IXS.EQ.4)  TEXT12='DIFFY'
      IF(IXS.EQ.5)  TEXT12='DIFFZ'
      IF(IXS.EQ.6)  TEXT12='NUSIGF'
      IF(IXS.EQ.7)  TEXT12='NFTOT'
      IF(IXS.EQ.8)  TEXT12='H-FACTOR'
      IF(IXS.EQ.9)  TEXT12='OVER'
      IF(IXS.EQ.10) TEXT12='SIGW00'
      IF(IXS.EQ.11) TEXT12='SIGW01'
      IF(IXS.EQ.12) TEXT12='SCAT00'
      IF(IXS.EQ.13) TEXT12='SCAT01'
      IF(IXS.EQ.14) TEXT12='A*PHI'
      IF(IXS.EQ.15) TEXT12='B*PHI'
      IF(IXS.EQ.16) TEXT12='D-LAMBDA'
      IF(IXS.EQ.17) TEXT12='D-LAMBDA-V'
      IF(IXS.EQ.18) TEXT12='GRADVALUE(X)'
* charger des XS de la macrolib
      IF(IXS.LE.11) THEN
         IPLIST=MEMADR(6)
         CALL LCMGET(IPLIST,'STATE-VECTOR',OPTPRI)
         NUN=OPTPRI(19)
         IF(IPLIST.EQ.0) CALL XABORT('OPTVDF: L_OPTIMIZE NEEDED')
         IF(MEMADR(17).EQ.0) THEN
*   les derivees des XS ont ete precalculees et stockees            
            WRITE (TXT12B,'(A4,I8)') 'STEP',IVAR
            CALL LCMLEN(IPLIST,TXT12B,NITMA,ITYP)
            IF(NITMA.EQ.0) CALL XABORT('OPTVUP: THE DERIVATED XS DO '
     1  //'NOT EXIT FOR THIS GLOBAL VARIABLE')
            CALL LCMSIX(IPLIST,TXT12B,1)
         ELSE
*   les derivees des XS sont directement pris dans la macro perturbee
*         IPLIST change d'object momentanement
            IPLIST=MEMADR(17)
         ENDIF
         IF(MEMADR(9).EQ.0) CALL XABORT('OPTADF: TRACKING '
     1  //'ADRESS NEEDED')
         CALL LCMGET(MEMADR(9),'TRACK-TYPE',SIGNA)
         WRITE(TXT12B,'(3A4)') (SIGNA(J),J=1,3)
         IF(TXT12B.NE.'TRIVAC') CALL XABORT('OPTADF: TRIVAC '
     1  //'TRACKING TYPE EXPECTED')
         CALL LCMGET(MEMADR(9),'STATE-VECTOR',TRKPRM)
         IELEM=TRKPRM(9)
         ICHX =TRKPRM(12)
         IDIM0=TRKPRM(6)
         IF(IDIM0.LT.4) IDIM=1
         IF((IDIM0.EQ.5).OR.(IDIM0.EQ.6).OR.(IDIM0.EQ.8)) IDIM=2
         IF((IDIM0.EQ.7).OR.(IDIM0.EQ.9)) IDIM=3
         IR =TRKPRM(4)
         NEL=TRKPRM(1)
         NUN=TRKPRM(2)
         LL4=TRKPRM(11)
         CYLIND=.FALSE.
         IF((IDIM0.EQ.3).OR.(IDIM0.EQ.6)) CYLIND=.TRUE.
         LDUAL=(TRKPRM(9).GT.0)
         CALL SETARA(RBASE,NEL,VOL)
         CALL LCMGET(MEMADR(9),'VOLUME',RBASE(VOL))
         CALL SETARA(IBASE,NEL,MAT)
         CALL LCMGET(MEMADR(9),'MATCOD',IBASE(MAT))
         CALL LCMLEN(MEMADR(9),'KN',MAXKN,ITYP)
         CALL SETARA(IBASE,MAXKN,KN)
         CALL LCMGET(MEMADR(9),'KN',IBASE(KN))
         CALL SETARA(RBASE,NEL,SIG)
         CALL XDRSET(RBASE(IVRLC(IVARL)),NUN*NGRP,0.0)
         JPLIST=LCMGID(IPLIST,'GROUP')
         DO 215 I=1,NGRP
            KPLIST=LCMGIL(JPLIST,I)
            CALL LCMLEN(KPLIST,TEXT12,NITMA,ITYP)
            IF(NITMA.EQ.0) CALL XABORT('OPTVUP: THE '//TEXT12 
     1  //' DERIVATED XS DO NOT EXIT FOR THIS GLOBAL VARIABLE')
            CALL LCMGET(KPLIST,TEXT12,RBASE(SIG))
            IF(LDUAL) THEN
               CALL SETARA(RBASE,NEL,IGAR)
               CALL TRIASD(MAXKN,IELEM,ICHX,IDIM,NITMA,NEL,NUN,CYLIND,
     1                     RBASE(SIG),RBASE(VOL),IBASE(MAT),IBASE(KN),
     2                     RBASE(IVRLC(IVARL)+(I-1)*NUN),RBASE(IGAR))
               CALL RLSARA(RBASE(IGAR))
            ELSE
               CALL XABORT('OPTVUP: PRIMAL FINITE-ELEMENTS NOT IMPLEME'
     1         //'NTED')
            ENDIF
  215       CONTINUE
         CALL RLSARA(RBASE(VOL))
         CALL RLSARA(IBASE(MAT))
         CALL RLSARA(IBASE(KN))
         CALL RLSARA(RBASE(SIG))
         IF(MEMADR(17).NE.0) THEN
            IPLIST=MEMADR(6)
         ENDIF
         IF(MEMADR(17).EQ.0) THEN
            CALL LCMSIX(IPLIST,' ',0)
         ENDIF
* charger des XS de la macrolib, cas particulier de SCAT
      ELSEIF((IXS.GE.12).AND.(IXS.LE.13)) THEN
         IPLIST=MEMADR(6)
         IF(IPLIST.EQ.0) CALL XABORT('OPTVDF: L_OPTIMIZE NEEDED')
         WRITE (TXT12B,'(A4,I8)') 'STEP',IVAR
         CALL LCMLEN(IPLIST,TXT12B,NITMA,ITYP)
         IF(NITMA.EQ.0) CALL XABORT('OPTVUP: THE DERIVATED XS DO '
     1  //'NOT EXIT FOR THIS GLOBAL VARIABLE')
         CALL LCMSIX(IPLIST,TXT12B,1)
         CALL LCMLEN(IPLIST,'NTOT0',NITMA,ITYP)
         CALL LCMSIX(IPLIST,TXT12B,2)
         CALL SETARA(RBASE,NITMA*NGRP*NGRP,ISCAT)
         NSCAT=0
         JPLIST=LCMGID(IPLIST,'GROUP')
         DO 220 I=1,NGRP
            KPLIST=LCMGIL(JPLIST,I)
            CALL LCMLEN(KPLIST,TEXT12,NITMA,ITYP)
            CALL LCMGET(KPLIST,TEXT12,RBASE(ISCAT+NSCAT))
            NSCAT=NSCAT+NITMA
  220    CONTINUE
         DO 225 I=0,NSCAT-1
  225       RBASE(IVRLC(IVARL)+I)=RBASE(ISCAT+I)
         CALL RLSARA(RBASE(ISCAT))
         CALL LCMSIX(IPLIST,' ',0)
* charger les vecteurs A*PHI et B*PHI
      ELSEIF((IXS.GE.14).AND.(IXS.LE.15)) THEN
         IPLIST=MEMADR(6)
         IF(IPLIST.EQ.0) CALL XABORT('OPTVDF: L_OPTIMIZE NEEDED')
         CALL LCMGET (MEMADR(6),'STATE-VECTOR',OPTPRI)
         NUN   =OPTPRI(19)
         IF(MEMADR(3)*MEMADR(14)*MEMADR(9).NE.0) THEN
            CALL LCMGET(MEMADR(14),'STATE-VECTOR',SYSPRM)
            LL4=SYSPRM(2)
            ITY=SYSPRM(4)
            CALL MTOPEN(0,MEMADR(9),LL4)
            CALL SETARA(RBASE,NUN,IFLUX)
            CALL SETARA(RBASE,NUN,IWORK)
            IF(TEXT12.EQ.'A*PHI') THEN
               OPTION=1
            ELSE
               OPTION=2
            ENDIF
            CALL OPTAFI(MEMADR(3),MEMADR(9),MEMADR(14),NUN,NGRP,LL4,ITY,
     1         OPTION,RBASE(IVRLC(IVARL)),RBASE(IFLUX),RBASE(IWORK))
            CALL RLSARA(RBASE(IFLUX))
            CALL RLSARA(RBASE(IWORK))
            GO TO 300
         ENDIF
C      AP*PHI ou BP*PHI doivent etre precalcules
         WRITE (TXT12B,'(A4,I8)') 'STEP',IVAR
         CALL LCMLEN(IPLIST,TXT12B,NITMA,ITYP)
         IF(NITMA.EQ.0) CALL XABORT('OPTVUP: THE DERIVATED XS DO '
     1  //'NOT EXIT FOR THIS GLOBAL VARIABLE')
         CALL LCMSIX(IPLIST,TXT12B,1)
         CALL LCMGET(IPLIST,TEXT12,RBASE(IVRLC(IVARL)))
         CALL LCMLEN(IPLIST,TEXT12,NITMA,ITYP)
         CALL LCMSIX(IPLIST,' ',0)
* charger les vecteurs D-LAMBDA ou D-LAMBDA-V
      ELSEIF((IXS.GE.16).AND.(IXS.LE.17)) THEN
         IPLIST=MEMADR(6)
         IF(IPLIST.EQ.0) CALL XABORT('OPTVDF: L_OPTIMIZE NEEDED')
         CALL LCMLEN(IPLIST,TEXT12,NITMA,ITYP)
         CALL SETARA(RBASE,NITMA,IDATA)
         CALL LCMGET(IPLIST,TEXT12,RBASE(IDATA))
         RBASE(IVRLC(IVARL))=RBASE(IDATA+IVAR-1)
         CALL RLSARA(RBASE(IDATA))
* charger la valeur des gradients deja calcules
      ELSEIF(IXS.EQ.18) THEN
         IPLIST=MEMADR(6)
         CALL LCMGET(IPLIST,'STATE-VECTOR',OPTPRI)
         NVAR=OPTPRI(1)
         NCST=OPTPRI(2)
         CALL SETARA(RBASE,NVAR*(NCST+1),IGRAD)
         CALL LCMGET(IPLIST,'GRADIENT',RBASE(IGRAD))
         DO 230 I=0,NCST
            RBASE(IVRLC(IVARL)+I)=RBASE(IGRAD+I*NVAR+IVAR-1)
  230       CONTINUE
         CALL RLSARA(RBASE(IGRAD))
      ENDIF
!fin indentation
!!!!!!!!!!!!!!!!
      ENDIF
  300 CONTINUE
      RETURN
      ENDIF
C---------------------------
C END
C---------------------------
      END
