*DECK ORDERR
      SUBROUTINE ORDERR(N,VECT,RANK,TEXT12)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine gives the rank of a serie of numbers.
* ORDERR = put in ORDER a serie of Real numbers.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
*     N      number of elements to class
*     VECT   real elements to class
*     TEXT12 type of classification
*      cas1      ="UP"       croissant
*      cas2      ="UPNOEQ"   croissant pas d'egalite permise
*      cas3      ="DOWN"     decroissant
*      cas4      ="DOWNNOEQ" decroissant pas d'egalite permise
*
*Parameters: ouput
*     RANK   rank ok elements
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER    N
      INTEGER    RANK(N)
      REAL       VECT(N)
      CHARACTER  TEXT12*12
*----
*  LOCAL VARIABLES
*----
      INTEGER    I,J
      

* initialisation du rank
      CALL XDISET(RANK,N,1)
      IF (N.LE.0) CALL XABORT('ORDER: WRONG N')
      IF (N.EQ.1) THEN
         RETURN
      ENDIF
* cas 1
      IF(TEXT12.EQ.'UP') THEN
         DO 100 I=2,N
         DO 100 J=1,I-1
            IF(VECT(J)<VECT(I)) RANK(I)=RANK(I)+1
            IF(VECT(J)>VECT(I)) RANK(J)=RANK(J)+1
            RANK(I)=RANK(J)
  100       CONTINUE
* cas 2
      ELSEIF(TEXT12.EQ.'UPNOEQ') THEN
         DO 200 I=2,N
         DO 200 J=1,I-1
            IF(VECT(J)<VECT(I)) THEN 
               RANK(I)=RANK(I)+1
            ELSEIF(VECT(J)>VECT(I)) THEN 
               RANK(J)=RANK(J)+1
            ELSE
               CALL XABORT('ORDERR: 2 VALUES ARE EQUAL (UP)')
            ENDIF
  200       CONTINUE
* cas 3
      ELSEIF(TEXT12.EQ.'DOWN') THEN
         DO 300 I=2,N
         DO 300 J=1,I-1
            IF(VECT(J)>VECT(I)) RANK(I)=RANK(I)+1
            IF(VECT(J)<VECT(I)) RANK(J)=RANK(J)+1
            RANK(I)=RANK(J)
  300       CONTINUE
* cas 4
      ELSEIF(TEXT12.EQ.'DOWNNOEQ') THEN
         DO 400 I=2,N
         DO 400 J=1,I-1
            IF(VECT(J)>VECT(I)) THEN
               RANK(I)=RANK(I)+1
            ELSEIF(VECT(J)<VECT(I)) THEN
               RANK(J)=RANK(J)+1
            ELSE
               CALL XABORT('ORDERR: 2 VALUES ARE EQUAL (DOWN)')
            ENDIF
  400       CONTINUE
      ELSE
         CALL XABORT('ORDERR:WRONG TYPE OF CLASSIFICATION')
      ENDIF
      RETURN
      END
