*DECK PERTUR
      SUBROUTINE PERTUR(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this module computes gradients of function using the first order of 
*  perturbation theory.
* PERTUR = PERTURbation theory
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
* NENTRY  number of lcm objects used by the module
* HENTRY  character*12 name of each lcm object
* IENTRY  =1 linked list; =2 xsm file; =3 sequential binary file;
*         =4 sequential ascii file
* JENTRY  =0 the lcm object is created
*         =1 the lcm object is open for modifications;
*         =2 the lcm object is open in read-only mode
* KENTRY  =file unit number; =lcm object address otherwise
*         kentry(nentry)
*                          
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   NENTRY
      CHARACTER HENTRY(NENTRY)*12
      INTEGER   IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   IPRINT,NITMA,LENGT,I,J,VARFRM,VARTO,FCTFRM,FCTTO,
     1          ITYP,NGRP,MEMADR(20),NUN,IPMAP,IPOPT,IPFLU,IPGPT,
     2          IPMCR,SIGNA(3),ILAMBD,IGRAD,DXMETH
      DOUBLE PRECISION DFLOTT
      REAL      FLOTT,FVAL,DX,EPS
      CHARACTER TEXT12*12,HSIGN*12,TXTPDF*12
      INTEGER   NVARMX,VRLCMX,CSTMX,NLVL1,NLVL2
      PARAMETER (NVARMX=100,VRLCMX=50,CSTMX=500)
      PARAMETER (NLVL1=21,NLVL2=5)
      LOGICAL   LLAMBD,LDXM,LGRAD,LVOID
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   OPTPRI(NSTATE),FLUPRM(NSTATE)
      REAL      OPTPRR(NSTATE)
*'Optimization variables' variable
      INTEGER   NVAR,IVAR,VARVAL,VARVL0,NVDXS(18)
*'Local arrays' variable
      INTEGER   NVRLC,IVRLC(VRLCMX)
      CHARACTER TVRLC(VRLCMX)*12
      LOGICAL   LVRLC(VRLCMX)
*'Constraint' variables
      INTEGER   NCST
*Objective and constraint evaluation variable
      REAL      RTFCN(NLVL1,1+2*NLVL2)
      INTEGER   VTFCN(NLVL1,1+2*NLVL2),STFCN(NLVL1,1+2*NLVL2)
      CHARACTER OTFCN(NLVL1,1+2*NLVL2)*12

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

        PRINT *,'PERTUT: a'
      IF (NENTRY.LT.2) CALL XABORT('PERTUR: 2 OBJECTS MIN EXPECTED.')
      CALL LCMGET(KENTRY(1),'SIGNATURE',SIGNA)
      WRITE(HSIGN,'(3A4)') (SIGNA(I),I=1,3)
      IF (HSIGN.NE.'L_OPTIMIZE') CALL XABORT('PERTUR: L_OPTIMIZE '
     1  //' OBJECT ONLY EXPECTED ON LHS')
*CHECK IF OBJECTS ARE LCM OBJECTS AND WHICH ONE CORRESPOND 
*TO WHICH TYPE
      IPMAP=0
      IPFLU=0
      IPOPT=0
      IPGPT=0
      IPMCR=0
*INITIALIZE THE FILE NUMBER UNIT FOR SUBROUTINE OPTEVL.f
      DO 201 I=1,20
  201    MEMADR(I)=0
      IPOPT=KENTRY(1)
      MEMADR(6)=KENTRY(1)
      IF (JENTRY(1).NE.1) CALL XABORT('L_OPTIMIZIDE MODIFICATION ONLY')
      DO 202 I=2,NENTRY
         IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2))CALL XABORT('PERTUR:'
     1      //' LCM OBJECT EXPECTED')
         CALL LCMGET(KENTRY(I),'SIGNATURE',SIGNA)
         WRITE(TEXT12,'(3A4)') (SIGNA(J),J=1,3)
         IF (TEXT12.EQ.'L_MAP') THEN 
             IPMAP=KENTRY(I)
             MEMADR(2)=KENTRY(I)
         ELSEIF (TEXT12.EQ.'L_FLUX') THEN 
             IPFLU=KENTRY(I)
             MEMADR(3)=KENTRY(I)
         ELSEIF (TEXT12.EQ.'L_MACROLIB') THEN 
            IPMCR=KENTRY(I)
            IF (MEMADR(7).EQ.0) THEN
               MEMADR(7)=KENTRY(I)
            ELSE
               MEMADR(17)=KENTRY(I)
            ENDIF
         ELSEIF (TEXT12.EQ.'L_SYSTEM') THEN 
            IF (MEMADR(4).EQ.0) THEN
               MEMADR(4)=KENTRY(I)
            ELSE
               MEMADR(14)=KENTRY(I)
            ENDIF
         ELSEIF (TEXT12.EQ.'L_MATEX') THEN 
             MEMADR(8)=KENTRY(I)
         ELSEIF (TEXT12.EQ.'L_TRACK') THEN 
             MEMADR(9)=KENTRY(I)
         ELSE 
             CALL XABORT('PERTUR: NOT GOOD TYPE OF OBJECT')
         ENDIF
         IF (JENTRY(I).NE.2) CALL XABORT(TEXT12//' READ ONLY')
  202    CONTINUE
      IF (IPFLU.EQ.0) CALL XABORT('L_FLUX NEEDED')
C
C---------------------------
C VARIABLE INITIALISATION	
C---------------------------
      IPRINT=  0
      NVRLC =  0
      LLAMBD=.FALSE.
      LDXM=.FALSE.
      LGRAD=.TRUE.
      LVOID=.FALSE.
        PRINT *,'PERTUR: b'
*initialisation des vecteurs locaux
      DO 203 I=1,VRLCMX
         IVRLC(I)=1
         TVRLC(I)=' '
  203    LVRLC(I)=.FALSE.
*aller chercher dans FLU les info necessaires
      CALL LCMGET(IPFLU,'STATE-VECTOR',FLUPRM)
      NGRP   = FLUPRM(1)
      NUN    = FLUPRM(2)
*aller chercher dans OPT les info necessaires
      CALL LCMGET(IPOPT,'STATE-VECTOR',OPTPRI)
      NVAR   = OPTPRI(1)
      NCST   = OPTPRI(2)
      DXMETH = OPTPRI(10)
      CALL LCMGET(IPOPT,'OPT-PARAM-R',OPTPRR)
      EPS    = OPTPRR(7)
      CALL SETARA(RBASE,NVAR,VARVAL)
      CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVAL))
      IF (DXMETH.EQ.2) THEN
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
         CALL LCMLEN(IPOPT,'VAR-VALUE',LENGT,ITYP)
         IF (LENGT.NE.0) THEN
            CALL SETARA(RBASE,NVAR,VARVL0)
            CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVL0))
            LDXM=.TRUE.
         ENDIF
         CALL LCMSIX(IPOPT,' ',2)
      ENDIF
*fin initialisation variable
  300 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
  301 IF (TEXT12.EQ.';') GO TO 1000
      IF (TEXT12.EQ.'EDIT') THEN
         CALL REDGET(ITYP,IPRINT,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('PERTUR: INTEGER FOR IPRINT '
     1  //'EXPECTED')
         GO TO 300
      ENDIF
      IF (TEXT12.NE.'VARNUM') CALL XABORT('PERTUR: "VARNUM" EXPECTED')
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF (ITYP.EQ.1) THEN
         VARFRM=NITMA
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('PERTUR: INTEGER EXPECTED '
     1  //'FOR VARTO')
         VARTO=NITMA
         IF ((VARFRM.GT.VARTO).OR.(VARFRM.LT.1).OR.(VARTO.GT.NVAR))
     1  CALL XABORT('PERTUR: VARFRM and VARTO DO NOT FIT')
      ELSEIF (TEXT12.EQ.'ALL') THEN
         VARFRM=1
         VARTO =NVAR
      ELSE
         CALL XABORT('PERTUR: VARFRM and VARTO DEFINITION IS WRONG')
      ENDIF
      TXTPDF=' '
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF (ITYP.NE.3) CALL XABORT('PERTUR: CHARACTER EXPECTED') 
      IF (TEXT12.EQ.'FOBJ') THEN
         FCTFRM=0
         FCTTO=0
      ELSEIF (TEXT12.EQ.'CONSTRAINT') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('PERTUR: INTEGER EXPECTED') 
         FCTFRM=NITMA
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('PERTUR: INTEGER EXPECTED') 
         FCTTO=NITMA
         IF (FCTTO.LT.FCTFRM) CALL XABORT('PERTUR: FROM GREATER '
     1  //'THAN TO')
         IF ((FCTFRM.GT.NCST).OR.(FCTTO.GT.NCST)) CALL XABORT
     1  ('PERTUR: TOTAL NUMBER OF CONSTRAINT IS LESS THAN FCTTO')
      ELSEIF ((TEXT12.EQ.'D-LAMBDA').OR.(TEXT12.EQ.'D-LAMBDA/DX')) THEN
         FCTFRM=0
         FCTTO=0
         TXTPDF='D-LAMBDA'
         LLAMBD=.TRUE.
         IF (TEXT12.EQ.'D-LAMBDA/DX') THEN
            LGRAD=.TRUE.
         ELSE
            LGRAD=.FALSE.
         ENDIF
      ELSEIF ((TEXT12.EQ.'D-LAMBDA-V').OR.
     1        (TEXT12.EQ.'D-LAMBDA-V/DX')) THEN
         LVOID=.TRUE.
         FCTFRM=0
         FCTTO=0
         TXTPDF='D-LAMBDA'
         LLAMBD=.TRUE.
         IF (TEXT12.EQ.'D-LAMBDA-V/DX') THEN
            LGRAD=.TRUE.
         ELSE
            LGRAD=.FALSE.
         ENDIF
C         GO TO 400
      ELSE
         CALL XABORT('PERTUR: WRONG TYPE OF FUNCTION SPECIFIED')
      ENDIF
*recuperer les gradiants deja calcules
      IF (LLAMBD) THEN
         CALL SETARA(RBASE,NVAR,ILAMBD)
         IF (LVOID) THEN
            CALL LCMLEN(IPOPT,'D-LAMBDA-V',LENGT,ITYP)
         ELSE
            CALL LCMLEN(IPOPT,'D-LAMBDA',LENGT,ITYP)
         ENDIF
         IF (LENGT.EQ.0) THEN
            CALL XDISET(RBASE(ILAMBD),NVAR,0.0)
         ELSEIF (NVAR.NE.LENGT) THEN
            CALL XABORT('PERTUR: NUMBERS OF VARIABLE DO NOT MATCH')
         ELSE
            IF (LVOID) THEN
               CALL LCMGET(IPOPT,'D-LAMBDA-V',RBASE(ILAMBD))
            ELSE
               CALL LCMGET(IPOPT,'D-LAMBDA',RBASE(ILAMBD))
            ENDIF
         ENDIF
      ELSE
         CALL SETARA(RBASE,NVAR*(NCST+1),IGRAD)
         CALL LCMLEN(IPOPT,'GRADIENT',LENGT,ITYP)
         IF (LENGT.EQ.0) THEN
            CALL XDISET(RBASE(IGRAD),NVAR*(NCST+1),0.0)
         ELSEIF (NVAR*(NCST+1).NE.LENGT) THEN
            CALL XABORT('PERTUR: NUMBERS OF VARIABLE DO NOT MATCH')
         ELSE
            CALL LCMGET(IPOPT,'GRADIENT',RBASE(IGRAD))
         ENDIF
      ENDIF
         PRINT *,'PERTUR: c'
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
*definition d'autres variables si applicable
      IF (TEXT12.EQ.'VARDEF') THEN
         TXTPDF='FUNCTION'
      ELSEIF (TEXT12.EQ.'FUNCT-PREDEF') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TXTPDF,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('PERTUR: CHARACTER EXPECTED')
      ENDIF
      CALL OPTVDF(MEMADR,IVRLC,TVRLC,LVRLC,VRLCMX,NGRP,TXTPDF,TEXT12,
     1                  TEXT12,NENTRY,KENTRY,HENTRY)
      IF (TXTPDF.EQ.' ') TXTPDF='FUNCTION'
*definition de la sequence de calcul
      CALL OPTSEQ(MEMADR,STFCN,VTFCN,RTFCN,OTFCN,NLVL1,NLVL2,IVRLC,
     1            TVRLC,VRLCMX,NGRP,TXTPDF)
*note: dans le cas d'une evaluation de fontionnelle LGDATA=1 obligatoirement
C      CALL SETARA(RBASE,LGDATA,IDATA) -> FVAL
*mettre a jour les vecteurs predefinis qui dependent des variables
*    PART 1:  quels sont les numeros de variables a mettre a jour
      CALL OPTVUP(IVRLC,TVRLC,LVRLC,MEMADR,0,VTFCN,VRLCMX,NLVL1,NLVL2,
     1            NVDXS,NGRP,1)
      DO 390 IVAR=VARFRM,VARTO
*    PART 2:  mettre a jour les variables avec numeros valides
         CALL OPTVUP(IVRLC,TVRLC,LVRLC,MEMADR,IVAR,VTFCN,VRLCMX,NLVL1,
     1               NLVL2,NVDXS,NGRP,2)
         IF (LDXM) THEN
            DX=RBASE(VARVAL+IVAR-1)-RBASE(VARVL0+IVAR-1)
         ELSE
            DX=RBASE(VARVAL+IVAR-1)*EPS
         ENDIF
         DO 390 I=FCTFRM,FCTTO
            VTFCN(1,1)=I+1
            CALL OPTEVL(MEMADR,VRLCMX,IVRLC,TVRLC,LVRLC,NLVL1,NLVL2,
     1               STFCN,VTFCN,RTFCN,OTFCN,FVAL,1,TXTPDF)
            IF (LGRAD) THEN
               IF (LLAMBD) THEN
                  RBASE(ILAMBD+IVAR-1)=FVAL/DX
               ELSE
                  RBASE(IGRAD+IVAR-1+I*NVAR)=FVAL/DX
               ENDIF
            ELSE
               IF (LLAMBD) THEN
                  RBASE(ILAMBD+IVAR-1)=FVAL
               ELSE
                  RBASE(IGRAD+IVAR-1+I*NVAR)=FVAL
               ENDIF
            ENDIF
  390       CONTINUE
  400 IF (LLAMBD) THEN
C         CALL SETARA(RBASE,NUN*NGRP,AFLU)
C         CALL SETARA(RBASE,NUN*NGRP,APHI)
C         CALL SETARA(RBASE,NUN*NGRP,BPHI)
C         CALL SETARA(RBASE,NUN*NGRP,APPHI)
C         CALL SETARA(RBASE,NUN*NGRP,BPPHI)
C         DO 410 IGR=1,NGRP
C            WRITE(TEXT12,'(A5,I3.3)') 'AFLUX',IGR
C 410        CALL LCMGET(IPFLU,TEXT12,RBASE(AFLU+NUN*(IGR-1)))
C         CALL LCMSIX(IPOPT,'STEP       0',1)
C         CALL LCMGET(IPOPT,'A*PHI',RBASE(APHI))
C         CALL LCMGET(IPOPT,'B*PHI',RBASE(BPHI))
C         CALL LCMSIX(IPOPT,' ',0)
C         CALL LCMGET(IPFLU,'K-EFFECTIVE',KEFF)
C         DO 420 IVAR=VARFRM,VARTO
C            WRITE(TEXT12,'(A4,I8)') 'STEP',IVAR
C            CALL LCMSIX(IPOPT,TEXT12,1)
C            CALL LCMGET(IPOPT,'A*PHI',RBASE(APPHI))
C            CALL LCMGET(IPOPT,'B*PHI',RBASE(BPPHI))
C            CALL LCMSIX(IPOPT,' ',0)
C            FACT1=0.0D0
C            FACT2=0.0D0
C            FACT3=0.0D0
C            FACT4=0.0D0
C            DO 430 I=0,NUN*NGRP-1
C               FACT1=FACT1+RBASE(AFLU+I)*RBASE(APHI+I)
C               FACT2=FACT2+RBASE(AFLU+I)*RBASE(BPHI+I)
C               FACT3=FACT3+RBASE(AFLU+I)*RBASE(APPHI+I)
C 430           FACT4=FACT4+RBASE(AFLU+I)*RBASE(BPPHI+I)
C            RBASE(ILAMBD+IVAR-1)=(FACT3/FACT1-FACT4/FACT2)/KEFF
C 420        WRITE(6,*) 'VAR#',IVAR,'->DL=',RBASE(ILAMBD+IVAR-1)
C         CALL RLSARA(RBASE(AFLU))
C         CALL RLSARA(RBASE(APHI))
C         CALL RLSARA(RBASE(BPHI))
C         CALL RLSARA(RBASE(APPHI))
C         CALL RLSARA(RBASE(BPPHI))
C         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
C         IF (LGRAD) THEN
C            IF (LDXM) THEN
C               DO 491 IVAR=VARFRM,VARTO
C  491             RBASE(ILAMBD+IVAR-1)=RBASE(ILAMBD+IVAR-1)
C     1                /(RBASE(VARVL0+IVAR-1)-RBASE(VARVAL+IVAR-1))
C            ELSE
C               DO 492 IVAR=VARFRM,VARTO
C  492             RBASE(ILAMBD+IVAR-1)=RBASE(ILAMBD+IVAR-1)
C     1                /(RBASE(VARVAL+IVAR-1)*EPS)
C            ENDIF
C         ENDIF
         IF (LVOID) THEN
            CALL LCMPUT(IPOPT,'D-LAMBDA-V',NVAR,2,RBASE(ILAMBD))
         ELSE
            CALL LCMPUT(IPOPT,'D-LAMBDA',NVAR,2,RBASE(ILAMBD))
         ENDIF
         CALL RLSARA(RBASE(ILAMBD))
         GO TO 301
      ELSE
         CALL LCMPUT(IPOPT,'GRADIENT',NVAR*(NCST+1),2,
     1               RBASE(IGRAD))
         CALL RLSARA(RBASE(IGRAD))
      ENDIF
      GO TO 300
C---------------------------
C END
C---------------------------
*liberer l'espace utilise par les vecteurs locaux
 1000 DO 1010 I=1,VRLCMX
         IF (LVRLC(I)) THEN
            CALL RLSARA(RBASE(IVRLC(I)))
         ENDIF
 1010 CONTINUE
      CALL RLSARA(RBASE(VARVAL))
      IF (LDXM) CALL RLSARA(RBASE(VARVL0))
      RETURN
C---------------------------
C FORMAT
C---------------------------
      END
