*DECK PRNTAB
      SUBROUTINE PRNTAB(GF,APLUS,INPLUS,BPLUS,XITK,XINF,XSUP,NDEC,M0,
     >                  SRCNAM)
*----------------------------------------------------------------------*
*                                                                      *
*Purpose:
* this subroutine print the arrays of thelinear optimization problem. 
* PRNTAB = PRiNt TABles of the linear optimization problem.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): OPTEX
*  Modified : R. Chambon
*
*Parameters: input/ouput
*    GF     : GFS DES VARIABLES DE CONTROLE. DIMENSION GF(N0)      
*    APLUS : MATRICE DES COEFFICIENTS DES CONTRAINTES LINEAIRES.       *
*            DIMENSION APLUS(M0+1,N0)                                  *
*    INPLUS: RELATIONS DES CONTRAINTES : =-1 SI PLUS GRAND OU EGAL;    *
*                                        = 0 SI EGAL;                  *
*                                        = 1 SI PLUS PETIT OU EGAL.    *
*            DIMENSION INPLUS(M0+1)                                    *
*    BPLUS : TERMES DE DROITE DES CONTRAINTES LINEAIRES.               *
*            DIMENSION B(M0+1)                                         *
*    XITK
*    DINF  : BORNES INFERIEURES SUR LES VARIABLES DE DECISION.       
*    DSUP  : BORNES SUPERIEURES SUR LES VARIABLES DE DECISION.       
*              DIMENSION DINF(N0),DSUP(N0)                         
*    NDEC  
*    M0    : NOMBRE DE CONTRAINTES LINEAIRES PLUS LE NOMBRE DE BORNES
*              (INFERIEURES OU SUPERIEURES) INTERCEPTANT LA CONTRAINTE 
*              QUADRATIQUE.                                            
*    SRCNAM:
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
	  INTEGER       M0
      REAL          BPLUS(*),XITK(*),XINF(*),XSUP(*)
      DOUBLE PRECISION  GF(*),APLUS(M0+1,*)
      INTEGER       INPLUS(*)
      CHARACTER*(*) SRCNAM
*----
*  LOCAL VARIABLES
*----
      CHARACTER*2   CTYPES(-1:1)
      CHARACTER*6   CLNAME
      CHARACTER*80  FMT
*
      DATA CTYPES / '>=',' =','<=' /
      DATA CLNAME / 'PRNTAB' /
*
      WRITE(6,1000) SRCNAM
*
      IF (NDEC.GT.8) THEN
CX       FMT  = '(1P,8E13.5,/,XXE13.5,5X,A3,5X,1P,E13.5)'
CX       NVAL = NDEC - 10
         RETURN
      ELSE
         FMT = '(1P,XXE13.5,5X,A3,5X,1P,E13.5)'
         NVAL = NDEC
      ENDIF
*
      IDX = INDEX(FMT,'X')
      WRITE(FMT(IDX:IDX+1),'(I2.2)') NVAL
*
*---- IMPRESSION DES COUTS
*
      WRITE(6,2000) (I,I=1,NDEC)
      WRITE(6,3000) (GF(I),I=1,NDEC)
*
      WRITE(6,4000)
      DO 10 J=1,M0+1
         WRITE(6,FMT) (APLUS(J,I),I=1,NDEC),CTYPES(INPLUS(J)),BPLUS(J)
  10  CONTINUE
*
      WRITE(6,5000) (XINF(I),I=1,NDEC)
      WRITE(6,6000) (XITK(I),I=1,NDEC)
      WRITE(6,7000) (XSUP(I),I=1,NDEC)
*
      RETURN
*
1000  FORMAT(//,5X,'IMPRESSION DU PROBLEME LINEARISE AU NIVEAU DE ',A,/)
2000  FORMAT( /,5X,'COUT(NDEC)',//,(10(5X,I3,5X)),//)
3000  FORMAT((1P,10E13.5))
4000  FORMAT( /,5X,'APLUS(M0,NDEC)',35X,'INPLUS(M0)',35X,'BPLUS(M0)',/)
5000  FORMAT( /,5X,'XINF(NDEC)  ',//,(1P,10E13.5))
6000  FORMAT( /,5X,'XITK(NDEC)  ',//,(1P,10E13.5))
7000  FORMAT( /,5X,'XSUP(NDEC)  ',//,(1P,10E13.5))
      END











