*DECK QLPUTL
      SUBROUTINE QLPUTL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this module defines optimization tools.
* QLPUTL = Quasi Linear Programmation UTiLities
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input/ouput
* NENTRY  number of lcm objects used by the module
* HENTRY  character*12 name of each lcm object or file
* IENTRY  =1 linked list; =2 xsm file; =3 sequential binary file;
*         =4 sequential ascii file
* JENTRY  =0 the lcm object is created
*         =1 the lcm object is open for modifications;
*         =2 the lcm object is open in read-only mode
* KENTRY  =file unit number; =lcm object address otherwise
*         kentry(nentry)
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   NENTRY
      CHARACTER HENTRY(NENTRY)*12
      INTEGER   IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*----
*  LOCAL VARIABLES
*----
* General variable
      INTEGER   NITMA,ITYP
      DOUBLE PRECISION DFLOTT
      REAL      FLOTT,TEMP
      CHARACTER TEXT12*12

      INTEGER   NTXTXS,NBTYPV
      PARAMETER (NTXTXS=13,NBTYPV=4)
* STATE-VECTOR VARIABLES
      INTEGER   NSTATE
      PARAMETER (NSTATE=40)
      INTEGER   FLUPRM(NSTATE),OPTPRI(NSTATE),RESPRM(NSTATE),
     1          SYSPRM(NSTATE),TRKPRM(NSTATE)
      REAL      OPTPRR(NSTATE)

      INTEGER   IPMAP,JPMAP,KPMAP,IPFLU,IPOPT,IPGPT,IPMCR,IPTRK,IPSYS,
     1          IPMCRP,IPSYSP,IPPOW,LCMGIL,LCMGID,LCMDIL,LCMLID,NBFUEL,
     2          JPOPT,JPMCR,KPOPT,KPMCR,MEMADR(21),I,J,IGR,NVAR,NCST,
     3          LENGT,IPRINT,IMETH,VRTYP,VTYP,REDSTP,MINMAX,NBZONE,
     4          NZONE,TSTBKP(NTXTXS),LL4,ITY,VARFRM,VARTO,NUN,NGRP,IVAR,
     5          SIGNA(3),IPIDX,NEL,VOL,MIX,ZVOL,ZVOLD,CSTFRM,CSTTO,ICST,
     6          NINT,ICST01,CSTTYP,ICHA,POS(2),OPTION,IPSYST,I2,I3,
     7          CSTOBJ,ICST1,ICST2
      INTEGER   IDATA,INEGAL,CONTR,BZV,VARTYP,MATPHI,IFLUX,IWORK,GRADF,
     1          CSTWGT,LAFAC,DIRVAL
      REAL      DELTA,VCORE,VREAC,COSTF,LA0E,CRIT,FLAPNT,ALPHA,EPSALP,
     1          EPS,BEST,ALMOST,ECART,REFE
      CHARACTER TXT12B*12,TEXTXS(NTXTXS)*12,TEXT4*4
      LOGICAL   FLAG(4),LMCRP,LSYSP,LTST,LLA,LCSTVL,LCST
*
      INTEGER   VARVAL,VARWGT,FCSTV,VARVL0,VLDTST,FCSTV0,GRAD0,CVTST
      REAL      DERR,ERR,DXMIN,COST,COST0,TESTC,EPS3,WEIGHT,DMINI,
     1          ERRX,NORX,DIFFX
      REAL      VALCST,VALCSF
      PARAMETER (VALCST=1.0E-6,VALCSF=1.0)
* 1000
      INTEGER HIST,IPCHA,NCHA
      REAL KEFF

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
C
C---------------------------
C     VALIDITY OF OBJECTS
C---------------------------
      IF(NENTRY.GT.8) CALL XABORT('QLPUTL: 8 OBJECTS MAX EXPECTED.')
*CHECK IF OBJECTS ARE LCM OBJECTS AND WHICH ONE CORRESPOND
*TO WHICH TYPE
      IPMAP=0
      IPFLU=0
      IPOPT=0
      IPGPT=0
      IPMCR=0
      IPTRK=0
      IPSYS=0
      IPPOW=0
      IPIDX=0
      IPMCRP=0
      IPSYSP=0
*INITIALIZE THE FILE NUMBER UNIT FOR SUBROUTINE OPTEVL.f
      CALL XDISET(MEMADR,21,0)
*     pour le cas ou 2 L_MACOLB ou 2 _SYSTEM serait fournie la deuxieme
*               est la perturbee
      LMCRP=.FALSE.
      LSYSP=.FALSE.
      DO 2 I=1,NENTRY
         IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2))CALL XABORT('QLPUTL:'
     1      //' LCM OBJECT EXPECTED')
         IF(JENTRY(I).LT.1) CALL XABORT('QLPUTL: OBJECT IN '
     1  //'MODIFICATION MODE or READ ONLY')
         CALL LCMGET(KENTRY(I),'SIGNATURE',SIGNA)
         WRITE(TEXT12,'(3A4)') (SIGNA(J),J=1,3)

         IF(TEXT12.EQ.'L_MAP') THEN
            IPMAP=KENTRY(I)
            MEMADR(2)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_FLUX') THEN
            IPFLU=KENTRY(I)
            IF(MEMADR(3).EQ.0) THEN
               MEMADR(3)=KENTRY(I)
            ELSE
               MEMADR(13)=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_OPTIMIZE') THEN
            IPOPT=KENTRY(I)
            MEMADR(6)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_GPT') THEN
            IPGPT=KENTRY(I)
            MEMADR(5)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_MACROLIB') THEN
            IF(MEMADR(7).EQ.0) THEN
               MEMADR(7)=KENTRY(I)
               IPMCR=KENTRY(I)
            ELSE
               MEMADR(17)=KENTRY(I)
               IPMCRP=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_SYSTEM') THEN
            IF(MEMADR(4).EQ.0) THEN
               MEMADR(4)=KENTRY(I)
               IPSYS=KENTRY(I)
            ELSE
               MEMADR(14)=KENTRY(I)
               IPSYSP=KENTRY(I)
            ENDIF
         ELSEIF(TEXT12.EQ.'L_MATEX') THEN
            IPIDX=KENTRY(I)
            MEMADR(8)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_TRACK') THEN
            IPTRK=KENTRY(I)
            MEMADR(9)=KENTRY(I)
         ELSEIF(TEXT12.EQ.'L_POWER') THEN
            IPPOW=KENTRY(I)
            MEMADR(21)=KENTRY(I)
         ELSE
             WRITE(6,*) 'SIGNATURE=',TEXT12
             CALL XABORT('QLPUTL: NOT GOOD TYPE OF OBJECT')
         ENDIF
    2    CONTINUE
C
C---------------------------
C VARIABLE INITIALISATION	
C---------------------------
* variables generales
      CALL LCMGET(IPOPT,'STATE-VECTOR',OPTPRI)
      CALL LCMGET(IPOPT,'OPT-PARAM-R',OPTPRR)
      NVAR=OPTPRI(1)
      NCST=OPTPRI(2)
      MINMAX=OPTPRI(3)
* variables de decision
      CALL SETARA(RBASE,NVAR,VARVAL)
      CALL SETARA(IBASE,NVAR,VARTYP)
      CALL LCMLEN(IPOPT,'VAR-VALUE',LENGT,ITYP)
      IF(LENGT.NE.NVAR) CALL XABORT('QLPUTL: WRONG NUMBER OF VARIABLE')
      CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVAL))
      CALL LCMGET(IPOPT,'VAR-TYPE',IBASE(VARTYP))
* poids des variables de decision
      CALL SETARA(RBASE,NVAR,VARWGT)
      CALL LCMLEN(IPOPT,'VAR-WEIGHT',LENGT,ITYP)
      IF(LENGT.EQ.0) THEN
         DO 3 I=1,NVAR
    3       RBASE(VARWGT+I-1)=1.0
         CALL LCMPUT(IPOPT,'VAR-WEIGHT',NVAR,2,RBASE(VARWGT))
      ELSEIF(LENGT.EQ.NVAR) THEN
         CALL LCMGET(IPOPT,'VAR-WEIGHT',RBASE(VARWGT))
      ELSE
         CALL XABORT('QLPUTL: NVAR - LENGT ARE NOT THE SAME')
      ENDIF
* valeurs des fonctionnelles (fonction objectif = premiere valeur)
      CALL SETARA(RBASE,NCST+1,FCSTV)
      CALL LCMLEN(IPOPT,'FOBJ-CST-VAL',LENGT,ITYP)
      IF(LENGT.EQ.0) THEN
         WRITE(6,*) 'WARNING : QLPUTL: OBJECTIVE FUNCTION AND '
     1  //'CONSTRAINTS NOT YET EVALUATED'
      ELSE
         CALL LCMGET(IPOPT,'FOBJ-CST-VAL',RBASE(FCSTV))
         COST=RBASE(FCSTV)
      ENDIF
* pas de changement de S pour reduction parabolique si newS>(1-EPS3)oldS
      EPS3=0.2
* Nombre de type de variable (1=burnup, 2=enrichissement, ...) = NBTYPV
* Nombre maximum de XS a faire un backup (liste cf boucle 700) = NTXTXS
*     initialisation si necessaire
      CALL LCMLEN(IPOPT,'BKP-PERT-XS',LENGT,ITYP)
      IF(LENGT.EQ.0) THEN
         CALL XDISET(TSTBKP,NTXTXS,0)
         CALL LCMPUT(IPOPT,'BKP-PERT-XS',NTXTXS,1,TSTBKP)
      ENDIF
C
C---------------------------
C     READ USER INPUT:
C---------------------------
      IPRINT=1
   20 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
* Edition level
   30 IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
      IF(TEXT12.EQ.'EDIT') THEN
         CALL REDGET(ITYP,IPRINT,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('FOBJCT: *IPRINT* MUST BE INTEGER')
* Definition of parameters
      ELSEIF(TEXT12.EQ.'DEFINITION')THEN
         GO TO 100
* New step validation
      ELSEIF(TEXT12.EQ.'STEP-VALID')THEN
         GO TO 200
* Interpolation between two step
      ELSEIF(TEXT12.EQ.'STEP-INTERP') THEN
         GO TO 300
* XS derivation methode
      ELSEIF(TEXT12.EQ.'DX-METHOD') THEN
         GO TO 400
* Update the new value in the different object
      ELSEIF(TEXT12.EQ.'NEW-VAL-UPDT') THEN
         LTST=.FALSE.
         GO TO 500
* Get the new value of the different object in the OPTIM object
      ELSEIF(TEXT12.EQ.'GET-VALUE') THEN
         LTST=.TRUE.
         GO TO 500
* Perturbation of one variable
      ELSEIF(TEXT12.EQ.'PERTURB-VAR') THEN
         GO TO 600
* Backup of perturbated L_MACROLIB
      ELSEIF(TEXT12.EQ.'BKP-MACRO-P') THEN
         GO TO 700
* System matrice * flux
      ELSEIF(TEXT12.EQ.'MAT*FLUX') THEN
         GO TO 800
* Augmented Lagrangien & penalty method
      ELSEIF(TEXT12.EQ.'LA-PNLT') THEN
         GO TO 900
* Histoty
      ELSEIF(TEXT12.EQ.'HISTORY') THEN
         GO TO 1000
* End of this subroutine
      ELSEIF( TEXT12.EQ.';' ) THEN
         GO TO 2000
      ELSE
         CALL XABORT('QLPUTL: '//TEXT12//' IS AN INVALID KEYWORD.')
      ENDIF
      GO TO 20
C---------------------------
C     1      0000     0000
C    11     0    0   0    0
C   1 1    0      0 0      0
C  1  1    0      0 0      0
C 1   1    0      0 0      0
C     1    0      0 0      0
C     1     0    0   0    0
C 11111111   0000     0000
C---------------------------
C Definition of parameters
C---------------------------
  100 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
  101 IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
      IF(TEXT12.EQ.'METHOD') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(TEXT12.EQ.'SIMPLEX') THEN
            IMETH=1
         ELSEIF(TEXT12.EQ.'LEMKE') THEN
            IMETH=2
         ELSEIF(TEXT12.EQ.'MAP') THEN
            IMETH=3
         ELSEIF(TEXT12.EQ.'AUG-LAGRANG') THEN
            IMETH=4
         ELSEIF(TEXT12.EQ.'PENAL-METH') THEN
            IMETH=5
         ELSE
            CALL XABORT('QLPUTL: WRONG METHOD KEYWORD')
         ENDIF
         OPTPRI(9)=IMETH
      ELSEIF(TEXT12.EQ.'MAXIMIZE') THEN
         OPTPRI(3)=-1
      ELSEIF(TEXT12.EQ.'MINIMIZE') THEN
         OPTPRI(3)=1
      ELSEIF(TEXT12.EQ.'MIN(PCMX)^2N') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED')
         OPTPRR(8)=REAL(NITMA)
      ELSEIF(TEXT12.EQ.'VAR-WEIGHT') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
         IF(TEXT12.EQ.'TYP-BURNUP') THEN
            VRTYP=1
         ELSEIF(TEXT12.EQ.'TYP-ENRICH') THEN
            VRTYP=2
         ELSE
            CALL XABORT('QLPUTL: TYP-BURNUP or TYP-ENRICH EXPECTED')
         ENDIF
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         WEIGHT=FLOTT
         DO 110 I=1,NVAR
            VTYP=IBASE(VARTYP+I-1)/1000
            IF(VTYP.EQ.VRTYP) RBASE(VARWGT+I-1)=WEIGHT
  110       CONTINUE
      ELSEIF(TEXT12.EQ.'CST-WEIGHT') THEN
         CALL SETARA(RBASE,NCST,CSTWGT)
         CALL LCMLEN(IPOPT,'CST-WEIGHT',LENGT,ITYP)
         IF(LENGT.EQ.0) THEN
            CALL XDRSET(RBASE(CSTWGT),NCST,1.0)
         ELSEIF(LENGT.EQ.NCST) THEN
            CALL LCMGET(IPOPT,'CST-WEIGHT',RBASE(CSTWGT))
         ELSE
            CALL XABORT('QLPUTL: LENGT.NE.NCST (l112)')
         ENDIF
  112    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.EQ.1) THEN
            I2=NITMA
            I3=I2
         ELSEIF((TEXT12.EQ.'RANGE').AND.(ITYP.EQ.3)) THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED(112)')
            I2=NITMA
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED(112)')
            I3=NITMA
         ELSE
            CALL RLSARA(RBASE(CSTWGT))
            GO TO 101
         ENDIF
         IF((I2.GT.NCST).OR.(I3.GT.NCST)) CALL XABORT('QLPUTL: '
     1      //'NUMBER FOR CONSTRAINT EXCEEDED')
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF((ITYP.EQ.3).AND.(TEXT12.EQ.'ALLSAME')) THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED(115)')
            DO 115 I=I2,I3
  115       RBASE(CSTWGT+I-1)=FLOTT
         ELSEIF(ITYP.EQ.2) THEN
            RBASE(CSTWGT+I2-1)=FLOTT
            IF(I3.GT.I2) THEN
               DO 116 I=I2+1,I3
               CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED116')
  116          RBASE(CSTWGT+I-1)=FLOTT
            ENDIF
         ELSE
            CALL XABORT('FOBJCT: WRONG VALUE OF MAXPOWER DEFINITION')
         ENDIF
         CALL LCMPUT(IPOPT,'CST-WEIGHT',NCST,2,RBASE(CSTWGT))
         GO TO 112
      ELSEIF(TEXT12.EQ.'CST-WGT-MFAC') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(9)=FLOTT
      ELSEIF(TEXT12.EQ.'CST-VIOL-EPS') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(10)=FLOTT
      ELSEIF(TEXT12.EQ.'INN-STEP-NMX') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED')
         OPTPRI(7)=NITMA
      ELSEIF(TEXT12.EQ.'OUT-STEP-NMX') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED')
         OPTPRI(8)=NITMA
      ELSEIF(TEXT12.EQ.'OUT-STEP-LIM') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(1)=FLOTT
      ELSEIF(TEXT12.EQ.'INN-STEP-LIM') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(2)=FLOTT
      ELSEIF(TEXT12.EQ.'OUT-STEP-EPS') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(3)=FLOTT
      ELSEIF(TEXT12.EQ.'INN-STEP-EPS') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(4)=FLOTT
      ELSEIF(TEXT12.EQ.'CST-QUAD-LIM') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED')
         OPTPRR(5)=FLOTT
      ELSEIF(TEXT12.EQ.'STEP-REDUCT') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
         IF(TEXT12.EQ.'HALF') THEN
            OPTPRI(6)=1
         ELSEIF(TEXT12.EQ.'PARABOLIC') THEN
            OPTPRI(6)=2
         ELSE
            CALL XABORT('QLPUTL: WRONG STEP REDUCTION KEYWORD')
         ENDIF
      ELSEIF(TEXT12.EQ.'BKP-MCR-P-XS') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(TEXT12.EQ.'ADD') THEN
            CALL LCMGET(IPOPT,'BKP-PERT-XS',TSTBKP)
         ELSEIF(TEXT12.EQ.'NEW') THEN
            CALL XDISET(TSTBKP,NTXTXS,0)
         ELSE
            CALL XABORT('QLPUTL: WRONG BCK-PERT-XS KEYWORD')
         ENDIF
  121    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
         I=0
         IF(TEXT12.EQ.'DIFFX') I=1
         IF(TEXT12.EQ.'DIFFY') I=2
         IF(TEXT12.EQ.'DIFFZ') I=3
         IF(TEXT12.EQ.'NTOT0') I=4
         IF(TEXT12.EQ.'SCAT0') I=5
         IF(TEXT12.EQ.'SIGW0') I=6
         IF(TEXT12.EQ.'SCAT1') I=7
         IF(TEXT12.EQ.'SIGW1') I=8
         IF(TEXT12.EQ.'NFTOT') I=9
         IF(TEXT12.EQ.'NUSIGF') I=10
         IF(TEXT12.EQ.'H-FACTOR') I=11
         IF(TEXT12.EQ.'CHI') I=12
         IF(TEXT12.EQ.'FIXE') I=13
         IF(I.EQ.0) THEN
            CALL LCMPUT(IPOPT,'BKP-PERT-XS',NTXTXS,1,TSTBKP)
            GO TO 101
         ELSE
            TSTBKP(I)=1
         ENDIF
         GO TO 121
      ELSEIF(TEXT12.EQ.'F-C-VOLUME') THEN
*        initialisation des volumes de coeur et reacteur
         IF(IPTRK.EQ.0) CALL XABORT('QLPUTL: L_TRACK NEEDED(1)')
         IF(IPIDX.EQ.0) CALL XABORT('QLPUTL: L_MATEX NEEDED(1)')
         CALL LCMGET(IPTRK,'STATE-VECTOR',TRKPRM)
         NEL=TRKPRM(1)
         CALL SETARA(RBASE,NEL,VOL)
         CALL LCMGET(IPTRK,'VOLUME',RBASE(VOL))
         CALL LCMLEN(IPIDX,'MAT',LENGT,ITYP)
         CALL SETARA(IBASE,LENGT,MIX)
         CALL LCMGET(IPIDX,'MAT',IBASE(MIX))
         IF(OPTPRR(12).EQ.0.0) THEN
            VCORE=0.0
            VREAC=0.0
            DO 140 I=0,NEL-1
               VREAC=VREAC+RBASE(VOL+I)
               IF(IBASE(MIX+I).LT.0) VCORE=VCORE+RBASE(VOL+I)
  140       CONTINUE
            OPTPRR(12)=VREAC
            OPTPRR(11)=VCORE
         ELSE
            VREAC=OPTPRR(12)
            VCORE=OPTPRR(11)
         ENDIF
*        initialisation des volumes de zones
*        recuperer les volumes deja calculer ou initialiser a 0
         CALL SETARA(RBASE,NCST+1,ZVOL)
         CALL XDRSET(RBASE(ZVOL),NCST+1,0.0)
         CALL LCMLEN(IPOPT,'FUNC-ZON-VOL',LENGT,ITYP)
         IF((LENGT.NE.0).AND.(LENGT.LE.NCST+1)) THEN
            CALL SETARA(RBASE,LENGT,ZVOLD)
            CALL LCMGET(IPOPT,'FUNC-ZON-VOL',RBASE(ZVOLD))
            DO 141 I=0,LENGT-1
  141       RBASE(ZVOL+I)=RBASE(ZVOLD+I)
            CALL RLSARA(RBASE(ZVOLD))
         ELSEIF(LENGT.GT.NCST+1) THEN
            CALL XABORT('QLPUTL: More volumes than constraints')
         ENDIF
* lire le volume a definir
  142    CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
         IF(TEXT12.EQ.'FOBJ') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
            IF(TEXT12.EQ.'REACTOR') THEN
               RBASE(ZVOL)=VREAC
            ELSEIF(TEXT12.EQ.'CORE') THEN
               RBASE(ZVOL)=VCORE
            ELSE
               CALL XABORT('QLPUTL: Wrong Volume keyword for F-OBJ')
            ENDIF
            GO TO 142
         ELSEIF(TEXT12.EQ.'CONSTRAINT') THEN
            CALL REDGET(ITYP,CSTFRM,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT('QLPUTL: Integer Expected for '
     1  //'Constraint number')
            CALL REDGET(ITYP,CSTTO,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT('QLPUTL: Integer Expected for '
     1  //'Constraint number')
            IF((CSTFRM.GT.CSTTO).OR.(CSTFRM.LT.1).OR.(CSTTO.GT.
     1 NCST)) CALL XABORT('QLPUTL:CSTFRM and CSTTO DO NOT FIT')
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
            DO 148 ICST=CSTFRM,CSTTO
               RBASE(ZVOL+ICST)=0.0
               IF(TEXT12.EQ.'REACTOR') THEN
                  RBASE(ZVOL+ICST)=VREAC
               ELSEIF(TEXT12.EQ.'CORE') THEN
                  RBASE(ZVOL+ICST)=VCORE
               ELSEIF(TEXT12.EQ.'ZONE') THEN
                  WRITE (TXT12B,'(A8,I4.4)') 'CST-ZONE',ICST
                  CALL LCMLEN(IPOPT,TXT12B,LENGT,ITYP)
                  IF(LENGT.EQ.0) CALL XABORT('OPTEVL: NO ZONE DEFINED '
     1  //'FOR THIS CONSTRAINT(2)')
                  NINT=OPTPRI(18)*OPTPRI(17)
                  CALL SETARA(IBASE,NINT,ICST01)
                  CALL XDISET(IBASE(ICST01),NINT,0)
                  CALL SETARA(IBASE,NCST,CSTTYP)
                  CALL LCMGET(MEMADR(6),'CST-VOL-TYPE',IBASE(CSTTYP))
*                 numero de canal dans le record
                  IF(IBASE(CSTTYP+ICST-1).EQ.3) THEN
                     CALL LCMGET(MEMADR(6),TXT12B,ICHA)
                     DO 145 J=0,OPTPRI(18)-1
  145                IBASE(ICST01+ICHA-1+J*OPTPRI(17))=1
*     numero de canal et de bundle dans le record
                  ELSEIF(IBASE(CSTTYP+ICST-1).EQ.4) THEN
                     CALL LCMGET(MEMADR(6),TXT12B,POS)
                     IBASE(ICST01+POS(1)-1+(POS(2)-1)*OPTPRI(17))=1
*     NCHA*NBUND 0/1 dans le record
                  ELSEIF(IBASE(CSTTYP+ICST-1).EQ.5) THEN
                     CALL LCMGET(MEMADR(6),TXT12B,IBASE(ICST01))
                  ENDIF
                  DO 146 J=0,NEL-1
                     IF(IBASE(MIX+J).LT.0) THEN
                        IF(IBASE(ICST01-IBASE(MIX+J)-1).EQ.1)
     1                   RBASE(ZVOL+ICST)=RBASE(ZVOL+ICST)+RBASE(VOL+J)
                     ENDIF
  146             CONTINUE

                  CALL RLSARA(IBASE(CSTTYP))
                  CALL RLSARA(IBASE(ICST01))
               ELSE
                  CALL XABORT('QLPUTL: Wrong Volume keyword for CST')
               ENDIF
  148          CONTINUE
            GO TO 142
         ELSE
            CALL LCMPUT(IPOPT,'FUNC-ZON-VOL',NCST+1,2,RBASE(ZVOL))
            CALL RLSARA(RBASE(ZVOL))
            CALL RLSARA(RBASE(VOL))
            CALL RLSARA(IBASE(MIX))
         ENDIF
         GO TO 101
      ELSE
         CALL LCMPUT(IPOPT,'VAR-WEIGHT',NVAR,2,RBASE(VARWGT))
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
         CALL LCMPUT(IPOPT,'OPT-PARAM-R',NSTATE,2,OPTPRR)
         GO TO 30
      ENDIF
  150 GO TO 100
C---------------------------
C   2222     0000     0000
C  2    2   0    0   0    0
C 2      2 0      0 0      0
C       2  0      0 0      0
C      2   0      0 0      0
C   22     0      0 0      0
C  2        0    0   0    0
C 22222222   0000     0000
C---------------------------
C New step validation
C---------------------------
  200 CALL REDGET(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
      LCSTVL=.FALSE.
      LCST=.TRUE.
      IF(TEXT12.EQ.'TEST-CST-VLD') THEN
         LCSTVL=.TRUE.
         CALL REDGET(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
      ENDIF
      IF(ITYP.NE.-5) CALL XABORT('QLPUTL: OUTPUT LOGICAL EXPECTED')
      CALL LCMLEN(IPOPT,'OLD-VALUE',LENGT,ITYP)
      IF(LENGT.EQ.0) CALL XABORT('QLPUTL: NO OLD VALUES DEFINED')
      CALL LCMSIX(IPOPT,'OLD-VALUE',1)
      CALL SETARA(RBASE,NCST+1,FCSTV0)
      CALL LCMLEN(IPOPT,'FOBJ-CST-VAL',LENGT,ITYP)
      IF(LENGT.EQ.0) CALL XABORT('QLPUTL: NO OLD FUNCTION VALUE '
     1  //'DEFINED')
      CALL LCMGET(IPOPT,'FOBJ-CST-VAL',RBASE(FCSTV0))
      CALL SETARA(RBASE,NVAR,VARVL0)
      CALL LCMLEN(IPOPT,'VAR-VALUE',LENGT,ITYP)
      IF(LENGT.NE.NVAR) CALL XABORT('QLPUTL: WRONG NUMBER OF '
     1  //'VARIABLE')
      CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVL0))
      IMETH=OPTPRI(9)
* flag pour echec dans QLP
      IF(OPTPRI(13).NE.0) THEN
         LTST=.TRUE.
         IF(IPRINT.GE.1) WRITE(6,*) 'UNSUCCESSFUL RESOLUTION IN '
     1  //'"QLP" FOR ',OPTPRI(13),' TIMES IN A ROW'
*     dans le cas TABU SEARCH/PROMISING AREA
!         IF(IMETH.EQ.4) CALL SETARA(RBASE,NCST,CSTWGT)
         GO TO 215
      ENDIF
      IF((IMETH.GE.1).AND.(IMETH.LE.3)) THEN
         COST0=RBASE(FCSTV0)
      ELSEIF(IMETH.EQ.4) THEN
         CALL LCMGET(IPOPT,'F-LA-EVAL',LA0E)
         COST0=LA0E
         CALL LCMSIX(IPOPT,' ',0)
         COSTF=COST
         CALL SETARA(RBASE,NCST,CSTWGT)
         CALL LCMGET(IPOPT,'CST-WEIGHT',RBASE(CSTWGT))
         CALL SETARA(RBASE,NCST,LAFAC)
         CALL LCMGET(IPOPT,'F-LA-MULT',RBASE(LAFAC))
         CALL SETARA(IBASE,NCST,INEGAL)
         CALL LCMLEN(IPOPT,'CST-TYPE',LENGT,ITYP)
         IF(LENGT.NE.NCST) CALL XABORT('QLP: NCST - LENGT NOT EQUAL')
         CALL LCMGET(IPOPT,'CST-TYPE',IBASE(INEGAL))
         CALL SETARA(RBASE,NCST,CONTR)
         CALL LCMLEN(IPOPT,'CST-OBJ',LENGT,ITYP)
         IF(LENGT.NE.NCST) CALL XABORT('QLP: NCST - LENGT NOT EQUAL')
         CALL LCMGET(IPOPT,'CST-OBJ',RBASE(CONTR))
         DO 201 J=0,NCST-1
            RBASE(CONTR+J)  = -RBASE(CONTR+J)+RBASE(FCSTV+J+1)
            IF(IBASE(INEGAL+J).EQ.0) THEN
               COST=COST+RBASE(LAFAC+J)*RBASE(CONTR+J)
     1                  +RBASE(CSTWGT+J)*RBASE(CONTR+J)**2/2.0
            ELSE
               CRIT=IBASE(INEGAL+J)*RBASE(CONTR+J)*RBASE(CSTWGT+J)
     1              +RBASE(LAFAC+J)
               IF(CRIT.LE.0.0) THEN
                  COST=COST-3*RBASE(LAFAC+J)**2/RBASE(CSTWGT+J)/2.0
               ELSE
                  COST=COST
     1          +2.0*RBASE(LAFAC+J)*RBASE(CONTR+J)*IBASE(INEGAL+J)
     2          +RBASE(CSTWGT+J)*RBASE(CONTR+J)**2/2.0
               ENDIF
            ENDIF
  201    CONTINUE
         CALL RLSARA(IBASE(INEGAL))
         CALL RLSARA(RBASE(CONTR))
         CALL LCMPUT(IPOPT,'F-LA-EVAL',1,2,COST)
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
      ELSEIF(IMETH.EQ.5) THEN
         CALL LCMGET(IPOPT,'F-PENAL-EVAL',LA0E)
         COST0=LA0E
         COSTF=COST
         CALL LCMSIX(IPOPT,' ',0)
         CALL SETARA(RBASE,NCST,CSTWGT)
         CALL LCMGET(IPOPT,'CST-WEIGHT',RBASE(CSTWGT))
         CALL SETARA(IBASE,NCST,INEGAL)
         CALL LCMLEN(IPOPT,'CST-OBJ',LENGT,ITYP)
         IF(LENGT.NE.NCST) CALL XABORT('QLP: NCST - LENGT NOT EQUAL')
         CALL LCMGET(IPOPT,'CST-TYPE',IBASE(INEGAL))
         CALL SETARA(RBASE,NCST,CONTR)
         CALL LCMLEN(IPOPT,'CST-OBJ',LENGT,ITYP)
         IF(LENGT.NE.NCST) CALL XABORT('QLP: NCST - LENGT NOT EQUAL')
         CALL LCMGET(IPOPT,'CST-OBJ',RBASE(CONTR))
         DO 202 J=0,NCST-1
            RBASE(CONTR+J)  = -RBASE(CONTR+J)+RBASE(FCSTV+J+1)
            IF(IBASE(INEGAL+J).EQ.0) THEN
               COST=COST+RBASE(CSTWGT+J)*RBASE(CONTR+J)**2/2.0
            ELSE
               CRIT=IBASE(INEGAL+J)*RBASE(CONTR+J)
               IF(CRIT.GT.0.0) THEN
                  COST=COST+RBASE(CSTWGT+J)*RBASE(CONTR+J)**2/2.0
               ENDIF
            ENDIF
  202    CONTINUE
         CALL RLSARA(IBASE(INEGAL))
         CALL RLSARA(RBASE(CONTR))
         CALL LCMPUT(IPOPT,'F-PENAL-EVAL',1,2,COST)
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
      ENDIF
* la fonction objectif diminue
      IF(COST0.GT.COST) THEN
         IF(OPTPRI(3).EQ.1) THEN
            LTST=.TRUE.
         ELSE
            LTST=.FALSE.
         ENDIF
* la fonction objectif augmente
      ELSE
         IF(OPTPRI(3).EQ.-1) THEN
            LTST=.TRUE.
         ELSE
            LTST=.FALSE.
         ENDIF
      ENDIF
* contraintes encore respectees?
      IF((IMETH.GE.1).AND.(IMETH.LE.3).AND.(LTST).AND.(LCSTVL)) THEN
         CALL LCMSIX(IPOPT,' ',0)
         CALL SETARA(IBASE,NCST,INEGAL)
         CALL LCMGET(IPOPT,'CST-TYPE',IBASE(INEGAL))
         CALL SETARA(RBASE,NCST,CONTR)
         CALL LCMGET(IPOPT,'CST-OBJ',RBASE(CONTR))
         EPS=OPTPRR(3)
         DO 203 J=1,NCST
            IF(.NOT.LCST) GO TO 203
            IF(IBASE(INEGAL+J-1).EQ.0) THEN
               DELTA=ABS(RBASE(FCSTV+J)-RBASE(CONTR+J-1))
            ELSE
               DELTA=REAL(IBASE(INEGAL+J-1))
     1                *(RBASE(FCSTV+J)-RBASE(CONTR+J-1))
               DELTA=MAX(0.0,DELTA)
            ENDIF
            DMINI=MAX(ABS(EPS/VALCSF*RBASE(CONTR+J-1)),VALCST)
            IF(DELTA.GT.DMINI) LCST=.FALSE.
  203    CONTINUE
         LTST=LCST
         CALL RLSARA(IBASE(INEGAL))
         CALL RLSARA(RBASE(CONTR))
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
      ENDIF
* la fonction objectif s'ameliore
  215 IF(LTST) THEN
         ITYP=5
         VLDTST=+1
         CALL REDPUT(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
*    mise a jour de l'avant dernier point valid sans echec dans QLP
         CALL LCMPUT(IPOPT,'VAR-VALUE2',NVAR,2,RBASE(VARVL0))
*    sauvegarde si meilleure solution jamais trouvee
         BEST=REAL(MINMAX)*1.0E30
         CALL LCMLEN(IPOPT,'BEST-FCT',LENGT,ITYP)
         IF(LENGT.GT.0) CALL LCMGET(IPOPT,'BEST-FCT',BEST)
         IF(IPRINT.GE.1) WRITE(6,*) 'current:',COST,' best:',BEST
         IF(REAL(MINMAX)*(BEST-COST).GT.0.0) THEN
            CALL LCMPUT(IPOPT,'BEST-FCT',1,2,COST)
            CALL LCMPUT(IPOPT,'BEST-VAR',NVAR,2,RBASE(VARVAL))
         ENDIF
         CALL LCMSIX(IPOPT,' ',0)
         GO TO 220
* la fonction objectif empire
      ELSE
         IF((OPTPRI(6).EQ.0).OR.(OPTPRI(6).GE.3)) THEN
            WRITE(6,20001)
            REDSTP=2
         ELSE
            REDSTP=OPTPRI(6)
         ENDIF
*     anciennes variables de decision
         CALL SETARA(RBASE,NVAR*(NCST+1),GRAD0)
         CALL LCMLEN(IPOPT,'GRADIENT',LENGT,ITYP)
         CALL LCMGET(IPOPT,'GRADIENT',RBASE(GRAD0))
         CALL SETARA(RBASE,NVAR,GRADF)
         IF(IMETH.LE.3) THEN
            DO 204 I=0,NVAR-1
 204        RBASE(GRADF+I)=RBASE(GRAD0+I)
         ELSEIF(IMETH.LE.5) THEN
            CALL LCMLEN(IPOPT,'DF-LA-PENAL',LENGT,ITYP)
            CALL LCMGET(IPOPT,'DF-LA-PENAL',RBASE(GRADF))
         ENDIF
         CALL LCMSIX(IPOPT,' ',0)
* si les contraintes sont violees alors S=S/2 meme si methode paraboliqu
         IF((REDSTP.EQ.1).OR.(.NOT.LCST)) THEN
            OPTPRR(1)=OPTPRR(1)*0.5
*           convergence?
            IF(OPTPRR(1).LE.OPTPRR(3)) THEN
               WRITE(6,20002)
               OPTPRI(4)=1
            ENDIF
         ELSE
            DERR=0.0
            NORX=0.0
            DO 205 I=0,NVAR-1
               NORX=NORX+(RBASE(VARVAL+I)-RBASE(VARVL0+I))**2
  205          DERR=DERR
     1              +(RBASE(VARVAL+I)-RBASE(VARVL0+I))*RBASE(GRADF+I)
            NORX=NORX**0.5
            DERR=DERR/NORX
            ERR=OPTPRR(1)
!            ERRX=(0.5*DERR*ERR*ERR)/(DERR*ERR-(COST-COST0))
            ERRX=(0.5*DERR*NORX*NORX)/(DERR*NORX-(COST-COST0))
            DXMIN=MIN(ERR,ERRX)
            DXMIN=MAX(DXMIN,ERR/10.0)
*           convergence?
            IF(DXMIN.LE.OPTPRR(3)) THEN
               WRITE(6,20002)
               OPTPRI(4)=1
            ENDIF
            TESTC=ABS(DXMIN-ERR)/ERR
*              le changement de pas est suffisant
            IF(TESTC.GT.EPS3) THEN
               OPTPRR(1)=OPTPRR(1)*(DXMIN/ERR)
*              le changement de pas n'est pas suffisant
            ELSE
               IF(IPRINT.GE.1) WRITE(6,*) 'Step forced to valid'
               ITYP=5
               VLDTST=+1
               CALL REDPUT(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
               GO TO 210
            ENDIF
         ENDIF
         CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVL0))
         CALL LCMPUT(IPOPT,'FOBJ-CST-VAL',NCST+1,2,RBASE(FCSTV0))
         CALL LCMPUT(IPOPT,'OPT-PARAM-R',NSTATE,2,OPTPRR)
         CALL LCMPUT(IPOPT,'GRADIENT',NVAR*(NCST+1),2,RBASE(GRAD0))
         IF(IMETH.GE.4) THEN
            IF(IMETH.EQ.4) CALL LCMPUT(IPOPT,'F-LA-EVAL',1,2,COST0)
            IF(IMETH.EQ.5) CALL LCMPUT(IPOPT,'F-PENAL-EVAL',1,2,COST0)
         ENDIF
         ITYP=5
         VLDTST=-1
         CALL REDPUT(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
      ENDIF
  210 CALL RLSARA(RBASE(GRAD0))
      CALL RLSARA(RBASE(GRADF))
  220 CALL RLSARA(RBASE(VARVL0))
      CALL RLSARA(RBASE(FCSTV0))
      IF(OPTPRI(13).EQ.0) THEN
         IF(IMETH.GE.4) CALL RLSARA(RBASE(CSTWGT))
         IF(IMETH.EQ.4) CALL RLSARA(RBASE(LAFAC))
         IF(IMETH.GE.4) COST=COSTF
      ENDIF
      GO TO 20
C---------------------------
C   3333     0000     0000
C  3    3   0    0   0    0
C 3      3 0      0 0      0
C      33  0      0 0      0
C       3  0      0 0      0
C 3      3 0      0 0      0
C  3    3   0    0   0    0
C   3333     0000     0000
C---------------------------
C Interpolation between two step
C---------------------------
 300  CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
* faire un backup des valeurs actuelles, et calculer les valeurs milieux
      IF(TEXT12.EQ.'PUT') THEN
*    backup des variables et de la valeur des fonctions
         CALL LCMSIX(IPOPT,'BKP-VALUE',1)
         CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
         CALL LCMPUT(IPOPT,'FOBJ-CST-VAL',NCST+1,2,RBASE(FCSTV))
         CALL LCMSIX(IPOPT,' ',0)
*    calcul des valeurs des variables point milieu
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
         CALL SETARA(RBASE,NVAR,VARVL0)
         CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVL0))
         CALL LCMSIX(IPOPT,' ',0)
         DO 305 I=0,NVAR-1
  305    RBASE(VARVAL+I)=(RBASE(VARVAL+I)+RBASE(VARVL0+I))*0.5
         CALL RLSARA(RBASE(VARVL0))
         CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
         GO TO 20
* f1/2 > f1 ?
      ELSEIF(TEXT12.EQ.'RECOVER') THEN
         CALL REDGET(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.-5) CALL XABORT('QLPUTL: OUTPUT LOGICAL EXPECTED')
         CALL LCMLEN(IPOPT,'BKP-VALUE',LENGT,ITYP)
         IF(LENGT.EQ.0) CALL XABORT('QLPUTL: NO BKP VALUES DEFINED')
         CALL LCMSIX(IPOPT,'BKP-VALUE',1)
         CALL SETARA(RBASE,NCST+1,FCSTV0)
         CALL LCMLEN(IPOPT,'FOBJ-CST-VAL',LENGT,ITYP)
         IF(LENGT.EQ.0) CALL XABORT('QLPUTL: NO BACKUP FUNCTION VALUE '
     1  //'DEFINED')
         CALL LCMGET(IPOPT,'FOBJ-CST-VAL',RBASE(FCSTV0))
         COST0=RBASE(FCSTV0)
         CALL RLSARA(RBASE(FCSTV0))
*     OUI - remettre les valeurs stockees dans backup a leur place
         IF(COST.GT.COST0) THEN
            ITYP=5
            VLDTST=1
            CALL REDPUT(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
*           les variables de decision
            CALL SETARA(RBASE,NVAR,VARVL0)
            CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVL0))
            CALL LCMDEL(IPOPT,'VAR-VALUE')
            CALL LCMSIX(IPOPT,' ',0)
            CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVL0))
            CALL RLSARA(RBASE(VARVL0))
*     NON - garder ces valeurs pour Xk+1 et diminuer le pas d'avance par
*       NOTE: le flux de reference devra etre recalcule pour ce point
         ELSE
            ITYP=5
            VLDTST=-1
            CALL REDPUT(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
            OPTPRR(1)=OPTPRR(1)*0.5
            CALL LCMDEL(IPOPT,'VAR-VALUE')
            CALL LCMSIX(IPOPT,' ',0)
            CALL LCMPUT(IPOPT,'OPT-PARAM-R',NSTATE,2,OPTPRR)
         ENDIF
         GO TO 20
      ELSE
         CALL XABORT('QLPUTL: WRONG STEP-INTERPOLATION KEYWORD')
      ENDIF
C---------------------------
C     4      0000     0000
C    44     0    0   0    0
C   4 4    0      0 0      0
C  4  4    0      0 0      0
C 4   4    0      0 0      0
C  4444444 0      0 0      0
C     4     0    0   0    0
C     4      0000     0000
C---------------------------
C PERTURBATION OF PROPERTIES METHOD
C---------------------------
  400 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED '
     1  //'AFTER DX-METHOD')
      IF(TEXT12.EQ.'EPS') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED FOR EPS')
         OPTPRR(7)=FLOTT
         OPTPRI(10)=1
      ELSEIF(TEXT12.EQ.'PREVIOUS') THEN
         OPTPRR(7)=0.0
         OPTPRI(10)=2
      ELSE
         CALL XABORT('QLPUTL: WRONG CHARACTER AFTER DX-METHOD')
      ENDIF
      CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
      CALL LCMPUT(IPOPT,'OPT-PARAM-R',NSTATE,2,OPTPRR)
      GO TO 20
C---------------------------
C 55555555   0000     0000
C 5         0    0   0    0
C 5  55    0      0 0      0
C 555  55  0      0 0      0
C        5 0      0 0      0
C        5 0      0 0      0
C 55    55  0    0   0    0
C  555555    0000     0000
C---------------------------
C (FALSE) Update the new value in the different object
C (TRUE)  Get the new value of the different object in the OPTIM object
C---------------------------
C FALSE   OPTIM  -> object
C TRUE    object -> OPTIM
  500 CONTINUE
      CALL XDLSET(FLAG,NBTYPV,.FALSE.)
      DO 502 I=0,NVAR-1
         VTYP=IBASE(VARTYP+I)/1000
         FLAG(VTYP)=.TRUE.
  502 CONTINUE
C variables type burnup a updater
      IF(FLAG(1)) THEN
         IF(IPMAP.EQ.0) CALL XABORT('QLPUTL: L_MAP NEEDED')
         CALL LCMGET(IPMAP,'STATE-VECTOR',RESPRM)
         NBZONE=RESPRM(3)
         NBFUEL=RESPRM(7)
         CALL SETARA(RBASE,NBZONE,BZV)
         CALL LCMGET(IPMAP,'BURN-AVG',RBASE(BZV))
         DO 510 I=0,NVAR-1
            VTYP=IBASE(VARTYP+I)/1000
            IF(VTYP.EQ.1) THEN
               NZONE=IBASE(VARTYP+I)-(IBASE(VARTYP+I)/1000)*1000
               IF(LTST) THEN
                  RBASE(VARVAL+I)=RBASE(BZV+NZONE-1)
               ELSE
                  RBASE(BZV+NZONE-1)=RBASE(VARVAL+I)
               ENDIF
            ENDIF
  510    CONTINUE
         IF(LTST) THEN
            CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
         ELSE
            CALL LCMPUT(IPMAP,'BURN-AVG',NBZONE,2,RBASE(BZV))
         ENDIF
         CALL RLSARA(RBASE(BZV))
      ENDIF
C variables type enrichissement a updater
      IF(FLAG(2)) THEN
         IF(IPMAP.EQ.0) CALL XABORT('QLPUTL: L_MAP NEEDED')
         IF(NBFUEL.EQ.0) CALL XABORT('QLPUTL: NO ENRICHMENT '
     1   //'ZONE IN L_MAP')
         CALL SETARA(RBASE,NBFUEL,BZV)
         JPMAP=LCMGID(IPMAP,'FUEL')
         DO 519 I=0,NBFUEL-1
            KPMAP=LCMGIL(JPMAP,I+1)
            CALL LCMGET(KPMAP,'ENRICH',RBASE(BZV+I))
  519    CONTINUE
         DO 520 I=0,NVAR-1
            VTYP=IBASE(VARTYP+I)/1000
            IF(VTYP.EQ.2) THEN
               NZONE=IBASE(VARTYP+I)-(IBASE(VARTYP+I)/1000)*1000
               IF(LTST) THEN
                  RBASE(VARVAL+I)=RBASE(BZV+NZONE-1)
               ELSE
                  RBASE(BZV+NZONE-1)=RBASE(VARVAL+I)
               ENDIF
            ENDIF
  520    CONTINUE
         IF(LTST) THEN
            CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
         ELSE
            DO 521 I=0,NBFUEL-1
               KPMAP=LCMGIL(JPMAP,I+1)
               CALL LCMPUT(KPMAP,'ENRICH',1,2,RBASE(BZV+I))
  521       CONTINUE
         ENDIF
         CALL RLSARA(RBASE(BZV))
      ENDIF
      GO TO 20
C---------------------------
C  666666    0000     0000
C 6      6  0    0   0    0
C 6  66    0      0 0      0
C 666  66  0      0 0      0
C 6      6 0      0 0      0
C 6      6 0      0 0      0
C  6    6   0    0   0    0
C   6666     0000     0000
C---------------------------
C Perturbation of one variable
C---------------------------
  600 CALL REDGET(ITYP,IVAR,FLOTT,TEXT12,DFLOTT)
      CALL SETARA(RBASE,NVAR,VARVL0)
* changer la valeur d'une variable
      IF(ITYP.EQ.1) THEN
         CALL LCMSIX(IPOPT,'BKP-VALUE',1)
         CALL LCMLEN(IPOPT,'VAR-VALUE',LENGT,ITYP)
         IF(LENGT.EQ.0) THEN
            CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
            CALL LCMSIX(IPOPT,' ',0)
         ELSE
            CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVAL))
            CALL LCMSIX(IPOPT,' ',0)
C            CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVL0))
         ENDIF
C         CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVAL))
  601    IF(OPTPRI(10).EQ.1) THEN
            RBASE(VARVAL+IVAR-1)=RBASE(VARVAL+IVAR-1)*(1.0+OPTPRR(7))
         ELSEIF(OPTPRI(10).EQ.2) THEN
*    utilisation de l'ancien point
            CALL LCMSIX(IPOPT,'OLD-VALUE',1)
            CALL LCMLEN(IPOPT,'VAR-VALUE',LENGT,ITYP)
*        c'est la premiere iteration externe ou probleme de sauvegarde
*           cette methode n'est pas possible donc methode par defaut EPS
            IF(LENGT.EQ.0) THEN
               OPTPRI(10)=1
               GO TO 601
            ENDIF
            CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVL0))
            CALL LCMSIX(IPOPT,' ',0)
            RBASE(VARVAL+IVAR-1)=RBASE(VARVL0+IVAR-1)
         ELSE
            WRITE(6,*) 'WRONG DX-METHOD NUMBER, EPSILON CHOSEN INSTEAD'
            OPTPRI(10)=1
            GO TO 601
         ENDIF
         CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
* remettre les bonnes variables
      ELSEIF(TEXT12.EQ.'RESTORE') THEN
         CALL LCMSIX(IPOPT,'BKP-VALUE',1)
         CALL LCMLEN(IPOPT,'VAR-VALUE',LENGT,ITYP)
         IF(LENGT.EQ.0) WRITE(6,*) 'NO BACKUPED VARIABLE'
         CALL LCMGET(IPOPT,'VAR-VALUE',RBASE(VARVAL))
         CALL LCMDEL(IPOPT,'VAR-VALUE')
         CALL LCMSIX(IPOPT,' ',0)
         CALL LCMPUT(IPOPT,'VAR-VALUE',NVAR,2,RBASE(VARVAL))
      ELSE
         CALL XABORT('QLPUTL: INTEGER or "RESTORE" EXPECTED '
     1  //'AFTER PERTURB-VAR')
      ENDIF
      CALL RLSARA(RBASE(VARVL0))
      GO TO 20
C---------------------------
C 77777777   0000     0000
C       7   0    0   0    0
C      7   0      0 0      0
C     7    0      0 0      0
C  77777   0      0 0      0
C   7      0      0 0      0
C  7        0    0   0    0
C 7          0000     0000
C---------------------------
C Backup of perturbated L_MACROLIB
C---------------------------
  700 IF(IPRINT.GE.1) WRITE(6,*) 'WARNING: BE SURE THAT YOU '
     1  //'PROVIDED DELTA PROPERTIES (ex: DH=Hp-H) CALCULATED '
     2  //'WITH ADDOBJ MODULE'
      CALL REDGET(ITYP,IVAR,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED '
     1  //'AFTER PERTURB-VAR')
      IF((IVAR.LE.0).OR.(IVAR.GT.NVAR)) CALL XABORT('QLPUTL: WRONG '
     1  //'IVAR NUMBER PROVIDED')
      IF(IPMCR.EQ.0) CALL XABORT('QLPUTL: L_MACROLIB NEEDED')
      CALL LCMSIX(IPOPT,' ',0)
      CALL LCMSIX(IPMCR,' ',0)
      CALL LCMGET(IPOPT,'BKP-PERT-XS',TSTBKP)
      TEXTXS(1) ='DIFFX'
      TEXTXS(2) ='DIFFY'
      TEXTXS(3) ='DIFFZ'
      TEXTXS(4) ='NTOT0'
      TEXTXS(5) ='SCAT00'
      TEXTXS(6) ='SIGW00'
      TEXTXS(7) ='SCAT01'
      TEXTXS(8) ='SIGW01'
      TEXTXS(9) ='NFTOT'
      TEXTXS(10)='NUSIGF'
      TEXTXS(11)='H-FACTOR'
      TEXTXS(12)='CHI'
      TEXTXS(13)='FIXE'
      WRITE (TEXT12,'(A4,I8.8)') 'STEP',IVAR
      CALL LCMSIX(IPOPT,TEXT12,1)
      NGRP      =OPTPRI(20)
      JPOPT=LCMLID(IPOPT,'GROUP',NGRP)
      JPMCR=LCMGID(IPMCR,'GROUP')
      DO 750 IGR=1,NGRP
         KPOPT=LCMDIL(JPOPT,IGR)
         KPMCR=LCMGIL(JPMCR,IGR)
         DO 730 I=1,NTXTXS
            IF(TSTBKP(I).NE.1) GO TO 730
            CALL LCMLEN(IPMCR,TEXTXS(I),LENGT,ITYP)
            IF(LENGT.EQ.0) THEN
               WRITE (6,*) 'Delta',TEXTXS(I),' can not be saved'
               GO TO 730
            ENDIF
            CALL SETARA(RBASE,LENGT,IDATA)
            CALL LCMGET(KPMCR,TEXTXS(I),RBASE(IDATA))
            CALL LCMPUT(KPOPT,TEXTXS(I),LENGT,2,RBASE(IDATA))
            CALL RLSARA(RBASE(IDATA))
  730    CONTINUE
  750 CONTINUE
      CALL LCMSIX(IPOPT,' ',0)
      GO TO 20
C---------------------------
C   8888     0000     0000
C  8    8   0    0   0    0
C 8      8 0      0 0      0
C  888888  0      0 0      0
C  8    8  0      0 0      0
C 8      8 0      0 0      0
C  8    8   0    0   0    0
C   8888     0000     0000
C---------------------------
C System matrice * flux
C---------------------------
  800 IF(IPFLU.EQ.0) CALL XABORT('QLPUTL: L_FLUX NEEDED')
      IF(IPTRK.EQ.0) CALL XABORT('QLPUTL: L_TRACK NEEDED')
      IF(IPSYS.EQ.0) CALL XABORT('QLPUTL: L_SYSTEM NEEDED')
      NGRP  =OPTPRI(20)
      NUN   =OPTPRI(19)
      CALL LCMGET(IPSYS,'STATE-VECTOR',SYSPRM)
      LL4=SYSPRM(2)
      ITY=SYSPRM(4)
      CALL MTOPEN(0,IPTRK,LL4)
*aller chercher dans FLUX les info necessaires, si necessaire
      IF(NUN.EQ.0) THEN
         CALL LCMGET(IPFLU,'STATE-VECTOR',FLUPRM)
         NGRP   = FLUPRM(1)
         NUN    = FLUPRM(2)
         OPTPRI(19)=NUN
         OPTPRI(20)=NGRP
         CALL LCMPUT(IPOPT,'STATE-VECTOR',NSTATE,1,OPTPRI)
      ENDIF
      CALL SETARA(RBASE,NUN*NGRP,MATPHI)
      CALL SETARA(RBASE,NUN,IFLUX)
      CALL SETARA(RBASE,NUN,IWORK)
  801 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED')
* not pertubated XS
      IF((TEXT12.EQ.'A*PHI').OR.(TEXT12.EQ.'B*PHI')) THEN
         IPSYST=MEMADR(4)
         IF(TEXT12.EQ.'A*PHI') THEN
            TEXT4='A'
            OPTION=1
         ELSE
            TEXT4='B'
            OPTION=2
         ENDIF
            VARFRM=0
            VARTO=0
* pertubated XS
      ELSEIF((TEXT12.EQ.'AP*PHI').OR.(TEXT12.EQ.'BP*PHI')) THEN
         IPSYST=MEMADR(14)
         IF(IPSYST.EQ.0) CALL XABORT('QLPUTL: L_SYSTEM PERTURBATED '
     1  //'NEEDED')
         IF(TEXT12.EQ.'AP*PHI') THEN
            TEXT4='A'
            OPTION=1
         ELSE
            TEXT4='B'
            OPTION=2
         ENDIF
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('QLPUTL: WRONG NUMBER OF DECISION '
     1  //'VARIABLE')
            VARFRM=NITMA
C            CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
C            IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED '
C     1  //'FOR VARTO')
            VARTO=NITMA
C            IF((VARFRM.GT.VARTO).OR.(VARFRM.LT.1).OR.(VARTO.GT.
C     1 NVAR)) CALL XABORT('QLPUTL: VARFRM and VARTO DO NOT FIT')
C         ELSEIF(TEXT12.EQ.'ALL') THEN
C            VARFRM=1
C            VARTO =NVAR
C         ELSE
C            CALL XABORT('QLPUTL: VARFRM and VARTO DEFINITION IS '
C     1  //'WRONG')
C         ENDIF
      ELSE
         CALL RLSARA(RBASE(MATPHI))
         CALL RLSARA(RBASE(IFLUX))
         CALL RLSARA(RBASE(IWORK))
         GO TO 30
      ENDIF
      DO 890 IVAR=VARFRM,VARTO
         WRITE(TXT12B,'(A4,I8.8)') 'STEP',IVAR
         CALL LCMSIX(IPOPT,TXT12B,1)
         CALL OPTAFI(IPFLU,IPTRK,IPSYST,NUN,NGRP,LL4,ITY,OPTION,
     1     RBASE(MATPHI),RBASE(IFLUX),RBASE(IWORK))
         WRITE(TXT12B,'(A1,A4)') TEXT4,'*PHI'
         CALL LCMPUT(IPOPT,TXT12B,NUN*NGRP,2,RBASE(MATPHI))
         CALL LCMSIX(IPOPT,' ',0)
         CALL LCMSIX(IPSYS,' ',0)
  890 CONTINUE
      GO TO 801
C---------------------------
C   9999     0000     0000
C  9    9   0    0   0    0
C 9      9 0      0 0      0
C 9      9 0      0 0      0
C  99  999 0      0 0      0
C    99  9 0      0 0      0
C 9      9  0    0   0    0
C  999999    0000     0000
C---------------------------
C LA-PNLT
C---------------------------
  900 IMETH=OPTPRI(9)
      IF(IMETH.EQ.4) THEN
         LLA=.TRUE.
      ELSEIF(IMETH.EQ.5) THEN
         LLA=.FALSE.
      ELSE
         CALL XABORT('QLPUTL: wrong resolution method for this '
     1  //'option (900)')
      ENDIF
  902 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED (900)')
C Initialisation of the coefficient
      IF(TEXT12.EQ.'INITIAL') THEN
         CALL LCMLEN(IPOPT,'CST-WEIGHT',LENGT,ITYP)
         IF(LENGT.EQ.0) THEN
            CALL SETARA(RBASE,NCST,CSTWGT)
            CALL XDRSET(RBASE(CSTWGT),NCST,1.0)
            CALL LCMPUT(IPOPT,'CST-WEIGHT',NCST,2,RBASE(CSTWGT))
            CALL RLSARA(RBASE(CSTWGT))
         ENDIF
         IF(LLA) THEN
            CALL SETARA(RBASE,NCST,LAFAC)
            CALL XDRSET(RBASE(LAFAC),NCST,0.0)
            CALL LCMPUT(IPOPT,'F-LA-MULT',NCST,2,RBASE(LAFAC))
            CALL RLSARA(RBASE(LAFAC))
         ENDIF
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
         CALL LCMPUT(IPOPT,'VAR-LAPNLT',NVAR,2,RBASE(VARVAL))
         CALL LCMSIX(IPOPT,' ',0)
C LA or PNLT function evaluation
      ELSEIF(TEXT12.EQ.'F-EVAL') THEN
         CALL SETARA(RBASE,NCST,CSTWGT)
         CALL SETARA(IBASE,NCST,INEGAL)
         CALL SETARA(RBASE,NCST,CSTOBJ)
         CALL LCMGET(IPOPT,'CST-WEIGHT',RBASE(CSTWGT))
         CALL LCMGET(IPOPT,'CST-TYPE',IBASE(INEGAL))
         CALL LCMGET(IPOPT,'CST-OBJ',RBASE(CSTOBJ))
         FLAPNT=RBASE(FCSTV)
         IF(LLA) THEN
            CALL SETARA(RBASE,NCST,LAFAC)
            CALL LCMGET(IPOPT,'F-LA-MULT',RBASE(LAFAC))
            DO 904 J=1,NCST
               TEMP=RBASE(FCSTV+J)-RBASE(CSTOBJ+J-1)
               IF(IBASE(INEGAL+J-1).EQ.0) THEN
                  FLAPNT=FLAPNT
     1              +TEMP*(RBASE(CSTWGT+J-1)*TEMP/2.0+RBASE(LAFAC+J-1))
               ELSE
                  CRIT=IBASE(INEGAL+J-1)*TEMP*RBASE(CSTWGT+J-1)
     1                 +RBASE(LAFAC+J-1)
                  IF(CRIT.LE.0.0) THEN
                     FLAPNT=FLAPNT-3*RBASE(LAFAC+J-1)**2.0
     1                             /RBASE(CSTWGT+J-1)/2.0
                  ELSE
                     FLAPNT=FLAPNT
     1                 +2.0*RBASE(LAFAC+J-1)*TEMP*IBASE(INEGAL+J-1)
     2                 +RBASE(CSTWGT+J-1)*TEMP**2.0/2.0
                  ENDIF
               ENDIF
  904       CONTINUE
            CALL RLSARA(RBASE(LAFAC))
         ELSE
            DO 905 J=1,NCST
               TEMP=RBASE(FCSTV+J)-RBASE(CSTOBJ+J-1)
               IF(IBASE(INEGAL+J-1).EQ.0) THEN
                  FLAPNT=FLAPNT+RBASE(CSTWGT+J-1)*TEMP**2.0/2.0
               ELSE
                  CRIT=IBASE(INEGAL+J-1)*TEMP
                  IF(CRIT.GT.0.0) THEN
                     FLAPNT=FLAPNT+RBASE(CSTWGT+J-1)*TEMP**2.0/2.0
                  ENDIF
               ENDIF
  905       CONTINUE
         ENDIF
         CALL LCMPUT(IPOPT,'F-LA-PNLT',1,2,FLAPNT)
         CALL RLSARA(RBASE(CSTWGT))
         CALL RLSARA(IBASE(INEGAL))
         CALL RLSARA(RBASE(CSTOBJ))
C Update of the coefficient
      ELSEIF(TEXT12.EQ.'COEF-UPDATE') THEN
         CALL SETARA(RBASE,NCST,CSTWGT)
         CALL LCMGET(IPOPT,'CST-WEIGHT',RBASE(CSTWGT))
         IF(IPRINT.GE.3) WRITE(6,*) 'CONSTRAINTS WEIGHT '
     1  //'BEFORE UPDATE :',(RBASE(CSTWGT+J),J=0,NCST-1)
         CALL LCMLEN(IPOPT,'F-LA-PNLT',LENGT,ITYP)
         IF(LENGT.EQ.0) THEN
            FLAPNT=1.0E8
         ELSE
            CALL LCMGET(IPOPT,'F-LA-PNLT',FLAPNT)
         ENDIF
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
         CALL LCMPUT(IPOPT,'CST-WEIGHT',NCST,2,RBASE(CSTWGT))
         CALL LCMPUT(IPOPT,'F-LA-PNLT',1,2,FLAPNT)
         CALL LCMSIX(IPOPT,' ',0)
         IF(IMETH.EQ.4) THEN
            CALL LCMGET(IPOPT,'F-LA-EVAL',LA0E)
         ELSE
            CALL LCMGET(IPOPT,'F-PENAL-EVAL',LA0E)
         ENDIF
         CALL LCMPUT(IPOPT,'F-LA-PNLT',1,2,LA0E)
         CALL SETARA(IBASE,NCST,INEGAL)
         CALL LCMGET(IPOPT,'CST-TYPE',IBASE(INEGAL))
         CALL SETARA(RBASE,NCST,CSTOBJ)
         CALL LCMGET(IPOPT,'CST-OBJ',RBASE(CSTOBJ))
         ALPHA=OPTPRR(9)
         EPSALP=OPTPRR(10)
         IF(LLA) THEN
*           sauvegarde des anciens
            CALL SETARA(RBASE,NCST,LAFAC)
            CALL LCMGET(IPOPT,'F-LA-MULT',RBASE(LAFAC))
            IF(IPRINT.GE.3) WRITE(6,*) 'LAGRANGIAN COEFFICIENT '
     1  //'BEFORE UPDATE :',(RBASE(LAFAC+J),J=0,NCST-1)
            CALL LCMSIX(IPOPT,'OLD-VALUE',1)
            CALL LCMPUT(IPOPT,'F-LA-MULT',NCST,2,RBASE(LAFAC))
            CALL LCMSIX(IPOPT,' ',0)
*           calcul des nouveaux
            DO 910 J=0,NCST-1
               IF(IBASE(INEGAL+J).EQ.0) THEN
                  RBASE(LAFAC+J)=RBASE(LAFAC+J)
     1          +RBASE(CSTWGT+J)*(RBASE(FCSTV+J+1)-RBASE(CSTOBJ+J))
               ELSE
                  RBASE(LAFAC+J)=MAX(0.0,RBASE(LAFAC+J)+RBASE(CSTWGT+J)
     1      *(RBASE(FCSTV+J+1)-RBASE(CSTOBJ+J))*IBASE(INEGAL+J))
               ENDIF
  910       CONTINUE
            CALL LCMPUT(IPOPT,'F-LA-MULT',NCST,2,RBASE(LAFAC))
            IF(IPRINT.GE.2) WRITE(6,*) 'LAGRANGIAN COEFFICIENT '
     1  //'AFTER UPDATE :',(RBASE(LAFAC+J),J=0,NCST-1)
            CALL RLSARA(RBASE(LAFAC))
         ENDIF
         DO 920 J=0,NCST-1
            IF(IBASE(INEGAL+J).EQ.0) THEN
               IF(ABS(RBASE(FCSTV+J+1)-RBASE(CSTOBJ+J)).GT.EPSALP) THEN
                  RBASE(CSTWGT+J)=ALPHA*RBASE(CSTWGT+J)
               ELSE
                  RBASE(CSTWGT+J)=RBASE(CSTWGT+J)/((ALPHA+1.0)/2)
               ENDIF
            ELSE
               CRIT=(RBASE(FCSTV+J+1)-RBASE(CSTOBJ+J))*IBASE(INEGAL+J)
               IF(CRIT.GT.EPSALP) THEN
                  RBASE(CSTWGT+J)=ALPHA*RBASE(CSTWGT+J)
               ELSE
                  RBASE(CSTWGT+J)=RBASE(CSTWGT+J)/((ALPHA+1.0)/2)
               ENDIF
            ENDIF
  920    CONTINUE
         CALL LCMPUT(IPOPT,'CST-WEIGHT',NCST,2,RBASE(CSTWGT))
         IF(IPRINT.GE.2) WRITE(6,*) 'CONSTRAINTS WEIGHT '
     1  //'AFTER UPDATE :',(RBASE(CSTWGT+J),J=0,NCST-1)
         CALL RLSARA(RBASE(CSTWGT))
         CALL RLSARA(IBASE(INEGAL))
         CALL RLSARA(RBASE(CSTOBJ))
C Test of the external convergence
      ELSEIF(TEXT12.EQ.'CONV-TEST') THEN
         CALL SETARA(RBASE,NVAR,VARVL0)
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
         CALL LCMGET(IPOPT,'VAR-LAPNLT',RBASE(VARVL0))
         CALL LCMSIX(IPOPT,' ',0)
         EPS=OPTPRR(3)
         DIFFX=0.0
         NORX=0.0
         IF(IPRINT.GE.2) THEN
            WRITE(6,*) 'NEW VARIABLES',(RBASE(VARVAL+I-1),I=1,NVAR)
            WRITE(6,*) 'OLD VARIABLES',(RBASE(VARVL0+I-1),I=1,NVAR)
         ENDIF
         DO 930 I=0,NVAR-1
            DIFFX=DIFFX+RBASE(VARWGT+I)
     1                *(RBASE(VARVAL+I)-RBASE(VARVL0+I))**2
            NORX=NORX+RBASE(VARWGT+I)*RBASE(VARVAL+I)**2
  930    CONTINUE
         CRIT=(DIFFX/NORX)**0.5
         IF(CRIT.GT.EPS) THEN
            CVTST=-1
         ELSE
            CVTST=+1
         ENDIF
C         IF(LLA) THEN
C            CALL SETARA(RBASE,NCST,LAFAC)
C            CALL LCMGET(IPOPT,'F-LA-MULT',RBASE(LAFAC))
C            CALL SETARA(RBASE,NCST,LAFAC2)
C            CALL LCMSIX(IPOPT,'OLD-VALUE',1)
C            CALL LCMLEN(IPOPT,'F-LA-MULT',LENGT,ITYP)
C            IF(LENGT.EQ.0) CALL XABORT('QLPUTL: UPDATE OF THE '
C     1  //'LAGRANGIAN HAVE NOT BEEN DONE')
C            CALL LCMGET(IPOPT,'F-LA-MULT',RBASE(LAFAC2))
C            CALL LCMSIX(IPOPT,' ',0)
C            DIFFX=0.0
C            NORX=0.0
C            DO 940 J=0,NCST-1
C               DIFFX=DIFFX
C     1                +(RBASE(LAFAC+J)-RBASE(LAFAC2+J))**2
C               NORX=NORX+RBASE(LAFAC+J)**2
C  940          CONTINUE
C            IF(NORX.EQ.0.0) NORX=1.0
C            CRIT=(DIFFX/NORX)**0.5
C            IF(CRIT.GT.EPS) CVTST=-1
C            CALL RLSARA(RBASE(LAFAC))
C            CALL RLSARA(RBASE(LAFAC2))
C         ENDIF
         CALL REDGET(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.-5) CALL XABORT('QLPUTL: OUTPUT LOGICAL'
     1  //'EXPECTED (930)')
         ITYP=-ITYP
         CALL REDPUT(ITYP,CVTST,FLOTT,TEXT12,DFLOTT)
         CALL RLSARA(RBASE(VARVL0))
         CALL LCMSIX(IPOPT,'OLD-VALUE',1)
         CALL LCMPUT(IPOPT,'VAR-LAPNLT',NVAR,2,RBASE(VARVAL))
         CALL LCMSIX(IPOPT,' ',0)
C Test of almost feasible point
      ELSEIF(TEXT12.EQ.'ALMOST-FSBLE') THEN
         CALL REDGET(ITYP,VLDTST,ALMOST,TEXT12,DFLOTT)
         IF(ITYP.EQ.2) THEN
            CALL REDGET(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
         ELSE
            ALMOST=OPTPRR(3)
         ENDIF
         IF(ITYP.NE.-5) CALL XABORT('QLPUTL: OUTPUT LOGICAL'
     1  //'EXPECTED (950)')
         CALL SETARA(IBASE,NCST,INEGAL)
         CALL LCMLEN(IPOPT,'CST-TYPE',LENGT,ITYP)
         IF(LENGT.NE.NCST) CALL XABORT('QLP: NCST - LENGT NOT EQUAL')
         CALL LCMGET(IPOPT,'CST-TYPE',IBASE(INEGAL))
         CALL SETARA(RBASE,NCST,CONTR)
         CALL LCMLEN(IPOPT,'CST-OBJ',LENGT,ITYP)
         IF(LENGT.NE.NCST) CALL XABORT('QLP: NCST - LENGT NOT EQUAL')
         CALL LCMGET(IPOPT,'CST-OBJ',RBASE(CONTR))
         VLDTST=+1
         DO 940 I=0,NCST-1
            ECART=RBASE(FCSTV+I+1)-RBASE(CONTR+I)
            IF(RBASE(CONTR+I).NE.0) THEN
               REFE=ALMOST*RBASE(CONTR+I)
            ELSE
               REFE=ALMOST
            ENDIF
            IF(IBASE(INEGAL+I).EQ.0) THEN
               IF(ABS(ECART).GT.ABS(REFE)) VLDTST=-1
            ELSE
               IF(IBASE(INEGAL+I)*ECART.GT.ABS(REFE)) VLDTST=-1
            ENDIF
  940    CONTINUE
         ITYP=5
         CALL REDPUT(ITYP,VLDTST,FLOTT,TEXT12,DFLOTT)
         CALL RLSARA(IBASE(INEGAL))
         CALL RLSARA(RBASE(CONTR))
      ELSE
         GO TO 30
      ENDIF
      GO TO 902
C------------------------------------
C     1      0000     0000     0000
C    11     0    0   0    0   0    0
C   1 1    0      0 0      0 0      0
C  1  1    0      0 0      0 0      0
C 1   1    0      0 0      0 0      0
C     1    0      0 0      0 0      0
C     1     0    0   0    0   0    0
C 11111111   0000     0000     0000
C------------------------------------
C HISTORY
C---------------------------
 1000 CALL REDGET(ITYP,HIST,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED (1000)')
      CALL LCMSIX(IPOPT,'HISTORY',1)
      WRITE(TXT12B,'(A9,I3.3)') 'VAR-VALUE',HIST
      CALL LCMPUT(IPOPT,TXT12B,NVAR,2,RBASE(VARVAL))
      WRITE(TXT12B,'(A9,I3.3)') 'FCT-VALUE',HIST
      CALL LCMPUT(IPOPT,TXT12B,1,2,COST)
 1010 CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED (1010)')
      IF((TEXT12.EQ.'POWER-CHA').OR.(TEXT12.EQ.'POWER-CHA2').OR.
     1    (TEXT12.EQ.'POWER-CHA3')) THEN
         NCHA=OPTPRI(17)
         IF(IPPOW.EQ.0) CALL XABORT('QLPUTL: L_POWER NEEDED (1010)')
         CALL LCMLEN(IPPOW,'POWER-CHAN',LENGT,ITYP)
         IF(LENGT.EQ.0) CALL XABORT('QLPUTL: POWER CHANNEL NEEDED')
         CALL SETARA(RBASE,NCHA,IPCHA)
         CALL LCMGET(IPPOW,'POWER-CHAN',RBASE(IPCHA))
         IF(TEXT12.EQ.'POWER-CHA') THEN
            WRITE(TXT12B,'(A9,I3.3)') 'POWER-CHA',HIST
         ELSEIF(TEXT12.EQ.'POWER-CHA2') THEN
            WRITE(TXT12B,'(A9,I3.3)') 'POWER-CH2',HIST
         ELSEIF(TEXT12.EQ.'POWER-CHA3') THEN
            WRITE(TXT12B,'(A9,I3.3)') 'POWER-CH3',HIST
         ENDIF
         CALL LCMPUT(IPOPT,TXT12B,NCHA,2,RBASE(IPCHA))
         CALL RLSARA(RBASE(IPCHA))
      ELSEIF(TEXT12.EQ.'K-EFFECTIVE') THEN
         IF(IPFLU.EQ.0) CALL XABORT('QLPUTL: L_FLUX NEEDED (1010)')
         CALL LCMGET(IPFLU,'K-EFFECTIVE',KEFF)
         WRITE(TXT12B,'(A9,I3.3)') 'K-EFF    ',HIST
         CALL LCMPUT(IPOPT,TXT12B,1,2,KEFF)
      ELSEIF(TEXT12.EQ.'QUAD-CST') THEN
         WRITE(TXT12B,'(A9,I3.3)') 'S        ',HIST
         CALL LCMPUT(IPOPT,TXT12B,1,2,OPTPRR(1))
      ELSEIF(TEXT12.EQ.'CONSTRAINT') THEN
         WRITE(TXT12B,'(A9,I3.3)') 'CST-VAL  ',HIST
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(TEXT12.EQ.'ALL') THEN
            ICST1=1
            ICST2=NCST
         ELSEIF(TEXT12.EQ.'RANGE') THEN
            CALL REDGET(ITYP,ICST1,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT
     1              ('QLPUTL: INTEGER EXPECTED (1010a)')
            CALL REDGET(ITYP,ICST2,FLOTT,TEXT12,DFLOTT)
            IF(ITYP.NE.1) CALL XABORT
     1              ('QLPUTL: INTEGER EXPECTED (1010a)')
         ELSEIF(ITYP.EQ.1) THEN
            ICST1=NITMA
            ICST2=NITMA
         ELSE
            CALL XABORT('QLPUTL: INTEGER or "ALL" or "RANGE"  EXPECTED')
         ENDIF
         CALL LCMPUT(IPOPT,TXT12B,ICST2-ICST1+1,2,RBASE(FCSTV+ICST1))
      ELSEIF(TEXT12.EQ.'DIRECT') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.3) CALL XABORT('QLPUTL: CHARACTER EXPECTED (1010d)')
         WRITE(TXT12B,'(A9,I3.3)') TEXT12,HIST
         CALL REDGET(ITYP,ICST1,FLOTT,TEXT12,DFLOTT)
         IF(ITYP.NE.1) CALL XABORT('QLPUTL: INTEGER EXPECTED (1010d)')
         CALL SETARA(RBASE,ICST1,DIRVAL)
         DO 1020 I=0,ICST1-1
            CALL REDGET(ITYP,NITMA,RBASE(DIRVAL+I),TEXT12,DFLOTT)
            IF(ITYP.NE.2) CALL XABORT('QLPUTL: REAL EXPECTED (1010d)')
 1020    CONTINUE
         CALL LCMPUT(IPOPT,TXT12B,ICST1,2,RBASE(DIRVAL))
         CALL RLSARA(RBASE(DIRVAL))
      ELSE
         CALL LCMSIX(IPOPT,' ',0)
         GO TO 30
      ENDIF
      GO TO 1010
C---------------------------
C END
C---------------------------
 2000 CONTINUE
      CALL RLSARA(RBASE(VARWGT))
      CALL RLSARA(RBASE(FCSTV))
      CALL RLSARA(IBASE(VARTYP))
      CALL RLSARA(RBASE(VARVAL))
      RETURN

20001 FORMAT(/'NO STEP REDUCTION SPECIFIED YET, PARABOLIC AS DEFAULT')
20002 FORMAT(//,5X,'LE PAS D''AVANCE NE PEUT PLUS ETRE REDUIT',//)
40001 FORMAT(//,5X,'S**2 (XDROIT) = ',1P,E13.5,
     >        /,5X,'FPOIDS  = ',/,(11X,1P,8E13.5))
40002 FORMAT(   5X,'*** LA CONTRAINTE #NO: ',I3,' DU TYPE INEGAL = ',I2,
     >             ' EST VIOLEES DE ',1PE12.5)
      END
