*DECK TABNMC
      SUBROUTINE TABNMC(CURVAL,OLDVAL,VARWGT,EPS,NVAR,LTST)
*
*-----------------------------------------------------------------------
*
*Purpose:
* this subroutine tests the convergence of the Nelder-Mead method.
* TABu Nelder-Mead Convergence test
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
* CURVAL current value
* MINVAL minimum value
* VARWGT maximum value
* EPS    precision for convergence test
* NVAR   number of variables
*Parameters: output
* LTST   logical for the result of the test of convergence
*                          
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT NONE
      INTEGER  NVAR
      REAL     CURVAL(NVAR),OLDVAL(NVAR),VARWGT(NVAR),EPS
      LOGICAL  LTST
*----
*  LOCAL VARIABLES
*----
      INTEGER I
      REAL    TEMP

      LTST=.FALSE.
      TEMP=0.0

      DO 100 I=1,NVAR
         TEMP=TEMP+VARWGT(I)*(CURVAL(I)-OLDVAL(I))**2.0
 100     CONTINUE
      TEMP=TEMP/REAL(NVAR)
      IF (TEMP.LT.EPS) LTST=.TRUE.

      RETURN
      END
