      SUBROUTINE TABUPD(IPTABU,LSTMAX,LSTCUR,LIST,VFTVAL,NVAR,
     1                  NCST,FIFO,MINMAX,TRSHLD)
*
*-----------------------------------------------------------------------
* 
*Purpose:
* this subroutine updates a tabu or promising area list 
* TABUUPD = TABu UPDate list
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): R. Chambon
*
*Parameters: input
* IPTABU   adress of the lcm object of L_TABU
* LSTMAX   maximum size of the list
* LSTCUR   actual size/indent for the list
* LIST     lists to be updated
*            =1         TABU-LIST
*            =2         PROMISE-LIST
* VFTVAL   value of the decision variables, the functionnals 
*          (objective & constraints), the tabu function
* NVAR     number of decision variable of the optimisation problem
* NCST     number of constraints of the optimisation problem
* FIFO     type of update
*            =1          FIFO
*            =2          Worst out
* MINMAX   minimize/maximize =1/-1
*Parameters: output
* LSTCUR    * number of the item to be stored (FIFO)
*                          
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      IMPLICIT  NONE
      INTEGER   IPTABU,JPTABU,LSTMAX,LSTCUR,LIST,NVAR,NCST,FIFO,MINMAX
      REAL      VFTVAL(NVAR+NCST+2),TRSHLD
*----
*  LOCAL VARIABLES
*----
      INTEGER   LENGT,ITYP,ITEMNB,I,IFVAL,IMAX,LCMGID,LCMLID
      REAL      MINI,MEAN
      CHARACTER TEXT12*12
      LOGICAL   LTST

      REAL      RBASE
      INTEGER   IBASE(1)
      COMMON    RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))

* type of list
      IF (LIST.EQ.1) THEN
         TEXT12='TABU-LIST'
      ELSEIF (LIST.EQ.2) THEN
         TEXT12='PROMISE-LIST'
      ELSE
         CALL XABORT('TABUPD: WRONG TYPE OF LIST')
      ENDIF
      CALL LCMSIX(IPTABU,TEXT12,1)
      CALL LCMLEN(IPTABU,'TABU-F-VAL',LENGT,ITYP)
      LTST=(LENGT.EQ.LSTMAX)
      CALL SETARA(RBASE,LENGT+1,IFVAL)
      IF (LENGT.NE.0) CALL LCMGET(IPTABU,'TABU-F-VAL',RBASE(IFVAL))
* number of the item to be stored (FIFO)
      IF (FIFO.EQ.1) THEN
         LSTCUR=LSTCUR+1
         IF (LSTCUR.GT.LSTMAX) LSTCUR=1
         ITEMNB=LSTCUR
         RBASE(IFVAL+LSTCUR-1)=VFTVAL(NVAR+NCST+2)
* number of the item to be stored (Worst out)
      ELSE
         IF (.NOT.LTST) THEN
            LSTCUR=LSTCUR+1
            ITEMNB=LSTCUR
            RBASE(IFVAL+LSTCUR-1)=VFTVAL(NVAR+NCST+2)
         ELSE
            IF (MINMAX.EQ.1) THEN
               MINI=-1.0E30
               DO 10 I=0,LENGT-1
                  MINI=MAX(MINI,RBASE(IFVAL+I))
   10             IF (MINI.EQ.RBASE(IFVAL+I)) ITEMNB=I
            ELSE
               MINI=1.0E30
               DO 20 I=0,LENGT-1
                  MINI=MIN(MINI,RBASE(IFVAL+I))
   20             IF (MINI.EQ.RBASE(IFVAL+I)) ITEMNB=I
            ENDIF
         ENDIF
         RBASE(IFVAL+LSTCUR-1)=VFTVAL(NVAR+NCST+2)
      ENDIF
      write(6,*) 'update len avant'
      CALL LCMLEN(IPTABU,'ITEM',LENGT,ITYP)
      write(6,*) 'update len apres'
      IF (LENGT.EQ.0) THEN
         JPTABU=LCMLID(IPTABU,'ITEM',LSTMAX)
      ELSE   
         JPTABU=LCMGID(IPTABU,'ITEM')
      ENDIF
      write(6,*) 'update LSTMAX, ITEMNB',LSTMAX, ITEMNB
* 	  WRITE(TEXT12,'(A4,I8)') 'ITEM',ITEMNB
*      CALL LCMPUT(IPTABU,TEXT12,NVAR+NCST+2,2,VFTVAL)
      CALL LCMPDL(JPTABU,ITEMNB,NVAR+NCST+2,2,VFTVAL)
      IF (LTST) THEN
         CALL LCMPUT(IPTABU,'TABU-F-VAL',LSTMAX,2,RBASE(IFVAL))
      ELSE
         CALL LCMPUT(IPTABU,'TABU-F-VAL',LSTCUR,2,RBASE(IFVAL))
      ENDIF
      IF (LIST.EQ.2) THEN
         IF (LTST) THEN 
            IMAX=LSTMAX
         ELSE
            IMAX=LSTCUR
         ENDIF
         MEAN=0.0
         DO 100 I=0,IMAX-1
  100       MEAN=MEAN+RBASE(IFVAL+I)
         MEAN=MEAN/REAL(IMAX)
         TRSHLD=MEAN
      ENDIF
      CALL RLSARA(RBASE(IFVAL))
      CALL LCMSIX(IPTABU,' ',2)

      RETURN
      END
