*DECK ERROR
      SUBROUTINE ERROR(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* Reaction rate comparison operator.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input/output
* NENTRY  number of LCM objects or files used by the operator.
* HENTRY  name of each LCM object or file:
*         HENTRY(1): read-only reference macrolib type(L_MACROLIB);
*         HENTRY(2): read-only macrolib type(L_MACROLIB);
* IENTRY  type of each LCM object or file:
*         =1 LCM memory object; =2 XSM file; =3 sequential binary file;
*         =4 sequential ascii file.
* JENTRY  access of each LCM object or file:
*         =0 the LCM object or file is created;
*         =1 the LCM object or file is open for modifications;
*         =2 the LCM object or file is open in read-only mode.
* KENTRY  LCM object address or file unit number.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER NENTRY                  	
      CHARACTER HENTRY(NENTRY)*12
      INTEGER IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NSTATE=40)
      CHARACTER TITLE*72,TEXT12*12,HSIGN*12
      INTEGER KCHAR(18),IDATA(NSTATE)
      COMMON BASE(1)
*----
*  PARAMETER VALIDATION.
*----
      IF(NENTRY.LE.1) CALL XABORT('ERROR: TWO PARAMETERS EXPECTED.')
      IF((JENTRY(1).NE.2).OR.(IENTRY(1).LT.1).OR.(IENTRY(1).GT.4))
     1 CALL XABORT('ERROR: LINKED LIST OR FILE IN READ-ONLY MODE EXPE'
     2 //'CTED AT FIRST RHS.')
      IF((JENTRY(2).NE.2).OR.(IENTRY(2).LT.1).OR.(IENTRY(2).GT.4))
     1 CALL XABORT('ERROR: LINKED LIST OR FILE IN READ-ONLY MODE EXPE'
     2 //'CTED AT SECOND RHS.')
*----
*  PROCESS FIRST AND SECOND RHS.
*----
      IF(IENTRY(1).GE.3) THEN
         CALL LCMOP(IPMAC1,'COPY1',0,1,0)
         CALL LCMEXP(IPMAC1,0,KENTRY(1),IENTRY(1)-2,2)
      ELSE
         IPMAC1=KENTRY(1)
      ENDIF
      CALL LCMGET(IPMAC1,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(1)
         CALL XABORT('ERROR: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      IF(IENTRY(2).GE.3) THEN
         CALL LCMOP(IPMAC2,'COPY2',0,1,0)
         CALL LCMEXP(IPMAC2,0,KENTRY(2),IENTRY(2)-2,2)
      ELSE
         IPMAC2=KENTRY(2)
      ENDIF
      CALL LCMGET(IPMAC2,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('ERROR: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL LCMLEN(IPMAC2,'TITLE',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         CALL LCMGET(IPMAC2,'TITLE',KCHAR)
         WRITE(TITLE,'(18A4)') (KCHAR(I),I=1,18)
      ELSE
         TITLE='*** NO TITLE PROVIDED ***'
      ENDIF
      WRITE(6,'(/1X,A72)') TITLE
*
      CALL LCMGET(IPMAC1,'STATE-VECTOR',IDATA)
      NGRP=IDATA(1)
      NREG=IDATA(2)
      CALL LCMGET(IPMAC2,'STATE-VECTOR',IDATA)
      IF((NREG.NE.IDATA(2)).OR.(NGRP.NE.IDATA(1))) THEN
         WRITE (6,'(/16H REFERENCE NREG=,I7,6H NGRP=,I7)') NREG,NGRP
         WRITE (6,'(/16H   APPROX. NREG=,I7,6H NGRP=,I7)') IDATA(2),
     1   IDATA(1)
         CALL XABORT('ERROR: REFERENCE AND APPROX. DATA ARE NOT COMPA'
     1   //'TIBLE.')
      ENDIF
      CALL SETARA(BASE,NREG*NGRP,ITRA1)
      CALL SETARA(BASE,NREG*NGRP,ITRA2)
      CALL SETARA(BASE,NREG,IVOL1)
      CALL SETARA(BASE,NREG,IVOL2)
      CALL SETARA(BASE,NREG,ITOTAL)
      CALL SETARA(BASE,NREG,IGAR)
      CALL SETARA(BASE,NREG,IFLUX)
      CALL SETARA(BASE,NREG,IQUAN1)
      CALL SETARA(BASE,NREG,IQUAN2)
      CALL ERRDRV(IPMAC1,IPMAC2,NREG,NGRP,BASE(ITRA1),BASE(ITRA2),
     1 BASE(IVOL1),BASE(IVOL2),BASE(ITOTAL),BASE(IGAR),BASE(IFLUX),
     2 BASE(IQUAN1),BASE(IQUAN2))
      CALL RLSARA(BASE(IQUAN2))
      CALL RLSARA(BASE(IQUAN1))
      CALL RLSARA(BASE(IFLUX))
      CALL RLSARA(BASE(IGAR))
      CALL RLSARA(BASE(ITOTAL))
      CALL RLSARA(BASE(IVOL2))
      CALL RLSARA(BASE(IVOL1))
      CALL RLSARA(BASE(ITRA2))
      CALL RLSARA(BASE(ITRA1))
      IF(IENTRY(1).GE.3) CALL LCMCL(IPMAC1,2)
      IF(IENTRY(2).GE.3) CALL LCMCL(IPMAC2,2)
      RETURN
      END
