*DECK MTBLD
      SUBROUTINE MTBLD(HNAME,IPTRK,IPSYS,ITY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* LCM driver for VECBLD.
*
*Copyright:
* Copyright (C) 2002 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* HNAME   name of the matrix. HNAME(:1) is 'W ', 'X ', 'Y', or 'Z'.
*         In case of a Thomas-Raviart basis, can also be equal to 'WA',
*        'XA', 'YA' or 'ZA'.
* IPTRK   L_TRACK pointer to the tracking information.
* IPSYS   L_SYSTEM pointer to system matrices.
* ITY     type of processing:
*         =1 gather back; =2 scatter forth;
*         =3 scatter forth and store the diagonal elements.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER HNAME*(*)
      INTEGER IPTRK,IPSYS,ITY
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NSTATE=40)
      CHARACTER TEXT12*12,HSMG*131,HCHAR*1
      INTEGER IBASE(1),ITP(NSTATE)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*----
*  RECOVER TRACKING INFORMATION FROM LCM
*----
      CALL KDRCPU(TK1)
      HCHAR=HNAME(:1)
      CALL LCMGET(IPTRK,'STATE-VECTOR',ITP)
      ISEG=ITP(17)
      IMPV=ITP(18)
      CALL LCMLEN(IPTRK,'MU'//HCHAR,LL4,ITYLCM)
      CALL LCMLEN(IPTRK,'NBL'//HCHAR,LON,ITYLCM)
      CALL SETARA(IBASE,LL4,IMU)
      CALL SETARA(IBASE,LON,INBL)
      CALL SETARA(IBASE,LON,ILBL)
      CALL SETARA(IBASE,LL4,IMUV)
      CALL SETARA(IBASE,LL4,IIPV)
      CALL LCMGET(IPTRK,'MU'//HCHAR,IBASE(IMU))
      CALL LCMGET(IPTRK,'NBL'//HCHAR,IBASE(INBL))
      CALL LCMGET(IPTRK,'LBL'//HCHAR,IBASE(ILBL))
      CALL LCMGET(IPTRK,'MUV'//HCHAR,IBASE(IMUV))
      CALL LCMGET(IPTRK,'IPV'//HCHAR,IBASE(IIPV))
*
      TEXT12=HNAME
      IIMAX=IBASE(IMU+LL4-1)
      LBL0=0
      DO 10 I=1,LON
   10 LBL0=LBL0+IBASE(ILBL+I-1)
      IIMAXV=IBASE(IMUV+LBL0-1)*ISEG
      IF(ITY.EQ.1) THEN
*        SUPERVECTORIAL TO SCALAR REBUILD.
         CALL SETARA(BASE,IIMAX,IASS)
         CALL LCMLEN(IPSYS,TEXT12,ILEN,ITYLCM)
         IF(ILEN.NE.IIMAXV) THEN
            WRITE(HSMG,'(38HMTBLD: REBUILD FAILURE 1 IN PROCESSING,
     1      9H MATRIX '',A12,2H''.)') TEXT12
            CALL XABORT(HSMG)
         ENDIF
         CALL LCMIOF(IPSYS,TEXT12,IASSV)
         CALL VECBLD(ISEG,LL4,IBASE(IMU),LON,IBASE(INBL),IBASE(ILBL),
     1   IBASE(IMUV),IBASE(IIPV),1,BASE(IASS),BASE(IASSV),DUMMY)
         CALL LCMPOF(IPSYS,TEXT12,IIMAX,2,IASS)
      ELSE IF(ITY.GE.2) THEN
*        SCALAR TO SUPERVECTORIAL REBUILD.
         CALL SETARA(BASE,LBL0*ISEG,IDGV)
         CALL SETARA(BASE,IIMAXV,IASSV)
         CALL LCMLEN(IPSYS,TEXT12,ILEN,ITYLCM)
         IF(ILEN.NE.IIMAX) THEN
            WRITE(HSMG,'(38HMTBLD: REBUILD FAILURE 2 IN PROCESSING,
     1      9H MATRIX '',A12,2H''.)') TEXT12
            CALL XABORT(HSMG)
         ENDIF
         CALL LCMIOF(IPSYS,TEXT12,IASS)
         CALL VECBLD(ISEG,LL4,IBASE(IMU),LON,IBASE(INBL),IBASE(ILBL),
     1   IBASE(IMUV),IBASE(IIPV),2,BASE(IASS),BASE(IASSV),BASE(IDGV))
         IF(ITY.EQ.3) THEN
            CALL LCMPOF(IPSYS,HCHAR//'D'//TEXT12(3:),LBL0*ISEG,2,IDGV)
         ELSE
            CALL RLSARA(BASE(IDGV))
         ENDIF
         CALL LCMPOF(IPSYS,TEXT12,IIMAXV,2,IASSV)
      ENDIF
      CALL RLSARA(IBASE(IIPV))
      CALL RLSARA(IBASE(IMUV))
      CALL RLSARA(IBASE(ILBL))
      CALL RLSARA(IBASE(INBL))
      CALL RLSARA(IBASE(IMU))
      CALL KDRCPU(TK2)
      IF(IMPV.GE.3) WRITE (6,'(/18H MTBLD: CPU TIME =,F7.2,3H S.)')
     1 TK2-TK1
      RETURN
      END
