rem *********************************************************************************
rem   Script to compile and link Version4 components on MS-DOS
rem   compile with intel Fortran and intel C++
rem   run the script in Dos windows from Visual studio command prompt
rem   execute script from Version4 directory as .\script\instver4
rem   base on a script created by E. Varin for Dragon 3.06
rem *********************************************************************************
rem ----compile utilib----
cd Utilib
md lib\ms-dos
copy src\*.* lib\ms-dos\
cd lib\ms-dos\
ifort /c /assume:byterecl /warn:nofileopt *.f
rem make utilib library
lib /nologo /out:utilib.lib *.obj
del *.obj *.f
cd ..\..\..
rem ----------------------
rem ----compile ganlib----
cd Ganlib
md lib\ms-dos
copy src\*.* lib\ms-dos\
cd lib\ms-dos\
ren KDRCPU.F KDRCPU.fpp
ren KDROPN.F KDROPN.fpp
ren KDRSTD.F KDRSTD.fpp
ren DRVMPI.F DRVMPI.fpp
ren SNDMPI.F SNDMPI.fpp
ifort /c /DMSDOS /assume:byterecl /warn:nofileopt *.f *.fpp
cl /c /DMSDOS *.c
rem make ganlib library
move ganlib.obj ..
lib /nologo /out:ganlib.lib *.obj
del *.obj *.f *.fpp *.c *.h
move ..\ganlib.obj .
cd ..\..
rem make ganlib executable
md bin\ms-dos
cd bin\ms-dos\
ifort -o ganlib.exe ..\..\lib\ms-dos\ganlib.obj ..\..\lib\ms-dos\ganlib.lib ^
   ..\..\..\Utilib\lib\ms-dos\utilib.lib
cd ..\..\..
rem ----------------------
rem ----compile trivac----
cd Trivac
md lib\ms-dos
copy src\*.* lib\ms-dos\
cd lib\ms-dos\
ifort /c /assume:byterecl /warn:nofileopt *.f
rem make trivac library
move trivac.obj ..
lib /nologo /out:trivac.lib *.obj
del *.obj *.f
move ..\trivac.obj .
cd ..\..
rem make trivac executable
md bin\ms-dos
cd bin\ms-dos\
ifort -o trivac.exe ..\..\lib\ms-dos\trivac.obj ..\..\lib\ms-dos\trivac.lib ^
   ..\..\..\Ganlib\lib\ms-dos\ganlib.lib ..\..\..\Utilib\lib\ms-dos\utilib.lib
cd ..\..\..
rem ----------------------
rem ----compile dragon----
cd Dragon
md lib\ms-dos
copy src\*.* lib\ms-dos\
cd lib\ms-dos\
ren DRAGON.F DRAGON.fpp
ifort /c /assume:byterecl /warn:nofileopt *.f *.fpp
cl /c /DMSDOS *.c
rem make dragon library
move dragon.obj ..
lib /nologo /out:dragon.lib *.obj
del *.obj *.f *.c *.h
move ..\dragon.obj .
cd ..\..
rem make dragon executable
md bin\ms-dos
cd bin\ms-dos\
ifort -o dragon.exe ..\..\lib\ms-dos\dragon.obj ..\..\lib\ms-dos\dragon.lib ^
   ..\..\..\Trivac\lib\ms-dos\trivac.lib ..\..\..\Ganlib\lib\ms-dos\ganlib.lib ^
   ..\..\..\Utilib\lib\ms-dos\utilib.lib
cd ..\..\..
rem ----------------------
rem ----compile donjon----
cd Donjon
md lib\ms-dos
copy src\*.* lib\ms-dos\
cd lib\ms-dos\
ren DONJON.F DONJON.fpp
ifort /c /assume:byterecl /warn:nofileopt *.f *.fpp
rem make donjon library
move donjon.obj ..
lib /nologo /out:donjon.lib *.obj
del *.obj *.f
move ..\donjon.obj .
cd ..\..
rem make donjon executable
md bin\ms-dos
cd bin\ms-dos\
ifort -o donjon.exe ..\..\lib\ms-dos\donjon.obj ..\..\lib\ms-dos\donjon.lib ^
   ..\..\..\Dragon\lib\ms-dos\dragon.lib ..\..\..\Trivac\lib\ms-dos\trivac.lib ^
   ..\..\..\Ganlib\lib\ms-dos\ganlib.lib ..\..\..\Utilib\lib\ms-dos\utilib.lib
cd ..\..\..
rem ---------------------
rem ----compile optex----
cd Optex
md lib\ms-dos
copy src\*.* lib\ms-dos\
cd lib\ms-dos\
ifort /c /assume:byterecl /warn:nofileopt *.f
rem make optex library
move optex.obj ..
lib /nologo /out:optex.lib *.obj
del *.obj *.f
move ..\optex.obj .
cd ..\..
rem make optex executable
md bin\ms-dos
cd bin\ms-dos\
ifort -o optex.exe ..\..\lib\ms-dos\optex.obj ..\..\lib\ms-dos\optex.lib ^
   ..\..\..\Donjon\lib\ms-dos\donjon.lib  ..\..\..\Dragon\lib\ms-dos\dragon.lib ^
   ..\..\..\Trivac\lib\ms-dos\trivac.lib ..\..\..\Ganlib\lib\ms-dos\ganlib.lib ^
   ..\..\..\Utilib\lib\ms-dos\utilib.lib
cd ..\..\..
rem *********************************************************************************
